$MODULE_FACTORY_REGISTRY = typeof $MODULE_FACTORY_REGISTRY != 'undefined' ? $MODULE_FACTORY_REGISTRY : {};
$MODULE_REGISTRY = typeof $MODULE_REGISTRY != 'undefined' ? $MODULE_REGISTRY : {};
if(typeof require == 'undefined')
function require(path){if(!$MODULE_REGISTRY[path]) $MODULE_REGISTRY[path] = $MODULE_FACTORY_REGISTRY[path](); return $MODULE_REGISTRY[path]};$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/NGJSEnvironmentSupport'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/NGJSEnvironmentSupport'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/NGJSEnvironmentSupport'] = exports; /**

 # NGJSEnvironmentSupport.js
 # webgame
 #
 # Created by Frederic Barthelemy on 10/01/10.
 # Copyright 2010 ngmoco:). All rights reserved.

 */

/**
 * Provides Environmental support for features missing on certain platforms.
 */


/**
 * setTimeout and setInterval implementation for platforms that don't have it.
 *	It fires timers at the beginning of the first frame past the requested millisecond,
 *	before it processes messages for a particular frame.
 *
 * Platform Consumers:
 *	- Android
 *
 * Note:
 *	- Only accurate to within the frame.
 *	- Does behaves like webkit in that it lets clearInterval and clearTimeout
 *		clear timers created by each other's constructor style.
 *
 */
var NGSetTimeoutCustom = false;
var NGSetTimeoutCallbacks = {};
var NGSetTimeoutUIDGenerator = 0;

exports.NGSetTimeoutRunTimers = function() {
	if(NGSetTimeoutCustom) {
		var timersToExecute = [];
		var curTime = new Date().getTime();
		for (var tk in NGSetTimeoutCallbacks) {
			if (NGSetTimeoutCallbacks.hasOwnProperty(tk) && NGSetTimeoutCallbacks[tk].shouldExecute(curTime)) {
				timersToExecute.push(NGSetTimeoutCallbacks[tk]);
			}
		}

		for (var i in timersToExecute) {
			if (timersToExecute.hasOwnProperty(i)) {
				timersToExecute[i].execute();
			}
		}
	}
};

if(typeof(setTimeout) != "function") {
	NGSetTimeoutCustom = true;

	var NGSingleTimeoutInstance = function(fptr, timeMs) {
		this.uid = NGSetTimeoutUIDGenerator++;
		if (NGSetTimeoutUIDGenerator == Infinity)
		{
			NGSetTimeoutUIDGenerator = 0;
		}
		this.fptr = fptr;
		this.interval = timeMs;
		this.requestedTime = new Date().getTime() + timeMs;
	};

	NGSingleTimeoutInstance.prototype.shouldExecute = function(curTime) {
		if(curTime < this.requestedTime) {
			return false;
		}
		return true;
	};

	NGSingleTimeoutInstance.prototype.execute = function() {
		delete NGSetTimeoutCallbacks[this.uid];
		this.fptr();
	};
	/**
	*
	*/
	setTimeout = function(fptr,requestedTime) {
		if(requestedTime < 0 || typeof(requestedTime) != "number") {
			requestedTime = 0;
		}

		var inst = new NGSingleTimeoutInstance(fptr,requestedTime);
		NGSetTimeoutCallbacks[inst.uid] = inst;
		return inst.uid;
	};
	/**
	*
	*/
	clearTimeout = function(uid) {
		if(NGSetTimeoutCallbacks.hasOwnProperty(uid)) {
			delete NGSetTimeoutCallbacks[uid];
		}
	};
	/**
	*
	*/
	setInterval = function(fptr,requestedTime) {
		if(requestedTime < 0 || typeof(requestedTime) != "number") {
			requestedTime = 0;
		}

		var inst = new NGSingleTimeoutInstance(fptr,requestedTime);
		/*Special setIntervalMagic */
		inst.execute = function() {
			this.requestedTime = new Date().getTime() + this.interval;
			this.fptr();
		};
		/*End setIntervalMagic */
		NGSetTimeoutCallbacks[inst.uid] = inst;
		return inst.uid;
	};
	clearInterval = clearTimeout;
	
}
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/SystemBinding'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/SystemBinding'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/SystemBinding'] = exports; var ClassReq = require('NGCore/Client/Core/Class');
var Base64 = require('NGCore/Client/Core/Base64').Base64;
var ResultSetReq = require('NGCore/Client/Plus/ResultSet');

var NGSystemBindingCommands = {
    HandleAction: 0
};

var SystemBinding = ClassReq.Class.subclass({
    classname: "SystemBinding",
    callbacks: {},
    callbacksUidGenerator: 0,
    _contResultSets: {},
    _contResultSetIdxs: {}
});

var ResultSet = ClassReq.Class.subclass({
    classname: "ResultSet",
    initialize: function(continueId) {
        this.items = [];
        this._continueId = continueId;
        this.totalLength = Number.MAX_VALUE;
    },
    /*
	 * Call to getMore adds more items to items list.
	 * Please note that in the callback, it is possible that addedCount == 0
	 * in some cases.  In that case access to items[newIdx] does not yield
	 * any result
	 */
    getMore: function(cb) {
        return SystemBinding._getMoreContacts(this, cb);
    },
    /*
	 * Releases resource used by current ResultSet.
	 *
	 * To avoid resource leakage, please call closeResultSet if getMore
	 * is not called all the way to the end.
	 */
    closeResultSet: function() {
        SystemBinding._closeContactsResultSet(this);
    }
});

SystemBinding._pushContactsCmd = function(cmdname, callbackFunc, continueId) {
    // Generate unused callbackEntry
    var callbackId = SystemBinding.callbacksUidGenerator++;
    if ( !! !callbackFunc) {
        callbackFunc = function() {};
    }
    SystemBinding.callbacks[callbackId] = callbackFunc;
    var message = {
        name: cmdname,
        callbackId: callbackId
    };
    if (typeof continueId != 'undefined') {
        message.continueId = continueId;
    }
    message = JSON.stringify(message);
    NgPushCommand3(NgEntityTypes.NgSystemBinding, NGSystemBindingCommands.HandleAction,
    Base64.encode(message));
};

SystemBinding._closeContactsResultSetfunction = function(rSet) {
    // Passing empty callback as caller does not need to know when the close
    // is complete
    var cb = function() {};
    SystemBinding._pushContactsCmd('closecontacts', cb, rSet._continueId);
};

SystemBinding._getMoreContacts = function(rSet, callbackFunc) {
    if ((typeof rSet._continueId != 'undefined') &&
    (rSet.items.length < rSet.totalLength)) {
        SystemBinding._pushContactsCmd('morecontacts', callbackFunc, rSet._continueId);
        return true;
    }
    return false;
};

SystemBinding.getContacts = function(callbackFunc) {
    SystemBinding._pushContactsCmd('contacts', callbackFunc, undefined);
};

SystemBinding.getDeviceToken = function(callbackFunc) {
    // Generate unused callbackEntry
    var callbackId = SystemBinding.callbacksUidGenerator++;
    if ( !! !callbackFunc) {
        callbackFunc = function() {};
    }
    SystemBinding.callbacks[callbackId] = callbackFunc;
    var message = {
        name: 'devicetoken',
        callbackId: callbackId
    };
    message = JSON.stringify(message);
    NgPushCommand3(NgEntityTypes.NgSystemBinding, NGSystemBindingCommands.HandleAction,
    Base64.encode(message));
};

SystemBinding.handleCommand = function(command) {
    var fields = NgParseCommand2(command, NgParseInt, NgParseBase64);
    var cmd = JSON.parse(fields[1]);
    if (cmd.name == 'callback') {
    	var cb = SystemBinding.callbacks[cmd.callbackId];
		if (typeof cb == "function") {
            if (cmd.callbackname == 'contacts') {
                var obj = SystemBinding._contResultSets[cmd.continueId];
                if (typeof obj == 'undefined') {
                    // First time for this callback
                    obj = new ResultSetReq.ResultSet(cmd.continueId);
                    SystemBinding._contResultSets[cmd.continueId] = obj;
                    SystemBinding._contResultSetIdxs[cmd.continueId] = 0;
                }

                var addedCount = cmd.list.length;
                while (cmd.list.length > 0) {
                    var item = cmd.list.shift();
                    obj.items.push(item);
                }

                var newIdx = SystemBinding._contResultSetIdxs[cmd.continueId];
				if ((typeof newIdx) != 'undefined') {
                	SystemBinding._contResultSetIdxs[cmd.continueId] = newIdx + addedCount;
				}

                // Invalidate the continueId if done - when total is return (no
                // more result) or when result set is explicitly closed (cmd.closed)
                if ((typeof cmd.total != 'undefined') ||
                (typeof cmd.rsclosed != 'undefined')) {
                    if (typeof cmd.total != 'undefined') {
                        obj.totalLength = cmd.total;
                    }
                    delete obj._continueId;
                    delete SystemBinding._contResultSets[cmd.continueId];
                    delete SystemBinding._contResultSetIdxs[cmd.continueId];
                }

                delete SystemBinding.callbacks[cmd.callbackId];
				if (cmd.success) {
                	cb(undefined, obj, newIdx, addedCount);
				} else {
                	cb(cmd.error, obj, newIdx, addedCount);
				}
            } else {
                // other callbacks
                delete SystemBinding.callbacks[cmd.callbackId];
                cb(cmd);
            }
        }
    }
};

exports.SystemBinding = SystemBinding;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI'] || {}; $MODULE_REGISTRY['NGCore/Client/UI'] = exports; var Commands = require('NGCore/Client/UI/Commands').Commands;
var ViewGeometry = require('NGCore/Client/UI/ViewGeometry');

/**
 * <p>Classes and objects contained by the UI module.</p>
 * @name UI
 * @namespace
 * @description <p>The UI module is a collection of classes that control user interface components of a device.
 * Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 * <ul>
 * <li><code>{@link UI.AbstractView}</code>A base class object for constructing other UI objects.</li>
 * <li><code>{@link UI.CellView}</code>: Construct <code>CellView</code> objects.</li>
 * <li><code>{@link UI.CheckBox}</code>: Construct objects that are used as checkboxes in an application.</li>
 * <li><code>{@link UI.CheckoutView}</code>: Construct objects that handle and manage information associated with <code>POST</code> methods in an application.</li>
 * <li><code>{@link UI.DateField}</code>: Construct objects used for handling data returned by date functions.</li>
 * <li><code>{@link UI.DocumentView}</code>: Constructs objects that control the location of application documents.</li>
 * <li><code>{@link UI.EditText}</code>: Constructs objects for handling editable text in an application.</li>
 * <li><code>{@link UI.EditTextArea}</code>: Constructs objects for handling multiline editable text in an application.</li>
 * <li><code>{@link UI.Element}</code>: A base class object for constructing other UI objects.</li>
 * <li><code>{@link UI.GLView}</code>: Construct objects that provide applications with access to OpenGL.</li>
 * <li><code>{@link UI.Image}</code>: Constructs objects that control the location and size of images used in the user interface.</li>
 * <li><code>{@link UI.Label}</code>: Constructs objects that control the look and feel of application labels.</li>
 * <li><code>{@link UI.ListView}</code>: Construct <code>ListView</code> objects.</li>
 * <li><code>{@link UI.ListViewItem}</code>: Construct <code>ListViewItem</code> objects.</li>
 * <li><code>{@link UI.ListViewSection}</code>: Construct <code>ListViewSection</code> objects.</li>
 * <li><code>{@link UI.NavController}</code>: Construct objects that control the flow of applcation navigation.</li>
 * <li><code>{@link UI.ProgressDialog}</code>: Construct objects that control application progress messaging.</li>
 * <li><code>{@link UI.ScrollView}</code>: Construct <code>ScrollView</code> objects.</li>
 * <li><code>{@link UI.Spinner}</code>: Construct objects that handle application menu spinners.
 * <li><code>{@link UI.Toast}</code>: Construct <code>Toast</code> objects.
 * <li><code>{@link UI.View}</code>: Construct objects that control the look and feel of the application view state.</li>
 * <li><code>{@link UI.ViewGeometry.Rect}</code>: Construct rectangle objects for use as positionable elements in the user interface.</li>
 * <li><code>{@link UI.ViewGeometry.Scale}</code>: Construct objects that handle view geometry for different scales of measurement.</li>
 * <li><code>{@link UI.WebView}</code>: Construct objects that pass event callback functions when web page events occur.</li>
 * <li><code>{@link UI.Window}</code>: Construct application window objects.</li>
 * </ul>
 */

var UI = exports.UI = {
	Commands: Commands,

	FontStyle: Commands.FontStyle,
	State: Commands.State,
	FitMode: Commands.FitMode,

	ViewGeometry: ViewGeometry,
	Scale: ViewGeometry.Scale,

    /**
	 *	@function
	 * 	@name UI#animate
	 * 	Animate changes to the properties of one or more UI objects.
	 * 	Currently animates changes to frame and alpha, and animates the addition / removal of subviews.
	 * 	@param {Function} action A closure that sets the property or properties to be animated.
	 * 		This function may manipulate several objects.
	 * 	@param {Number} duration The time over which to execute the animation, in milliseconds.
	 * 	@param {Function} onCompletion A closure to be executed after the animation has completed.
	 */
    animate: Commands.animate,

    /**
		@name UI#compositeImages
		Creates a composition of images to an offscreen bitmap, writing the resulting picture to disk.
		
		The filename returned in the callback may not be the same as originally requested!
		
		@example
		UI.compositeImages( 200, 200, "basic.png", [
			{
				image:'./Content/background.png',
				rect:[ 0,0, 200, 200 ]
			},
			{
				image:'./Content/CanYouSeeThisImage.png',
				rect:[ 50, 50, 100, 100 ]
			},
		], function( data ) { 
			if ( data.error == undefined ) { 
				NgLogD("yay, picture! at:"+data.filename);
			}
		} );
	 */
    compositeImages: function(w, h, filename, infoArray, callback) {
        var cb = Commands.registerTemporaryCallback(callback);
        if (cb) {
			Commands.doCompositeImages(w, h, filename, infoArray, cb);
		}
    },

    /**
		@name UI#choosePhoto
		Show fullscreen user interface for taking a picture with the camera or choosing an existing
		photo.
		
		Currently there are no 'options' keys defined.  
		In the future, we're considering "forAvatar" key to use a custom cropping UI.
		
		The filename returned in the callback may not be the same as originally requested!
		If the user cancels or an error occurs, the callback will be passed an error string.
		
		Passing 0 for targetWide or High will return the original unscaled image.
		
		@example
		UI.choosePhoto( 0, 0, "basic.png", undefined, function( data ) { 
			if ( data.error == undefined ) { 
				NgLogD("yay, picture! at:"+data.filename);
			}
		} );
	*/
    choosePhoto: function(width, height, filename, options, callback, invokingView) {
       if (!invokingView || !invokingView.__objectRegistryId) {
            new exports.UI.Toast({
                'text': "Photo picker requires an invoking view.",
                'onDisappear': function() {
                    this.destroy();
                }
            }).show();
            return;
        }

        var cb = Commands.registerTemporaryCallback(callback);
		if (cb) {
        	Commands.doChoosePhoto(width, height, filename, options || {}, cb, invokingView.__objectRegistryId);
		}
    },

    /**
		@name UI#choosePhotoCamera
		Show fullscreen user interface for taking a picture with the camera or choosing an existing
		photo.
		
		Currently there are no 'options' keys defined.  
		In the future, we're considering "forAvatar" key to use a custom cropping UI.
		
		The filename returned in the callback may not be the same as originally requested!
		If the user cancels or an error occurs, the callback will be passed an error string.
		
		Passing 0 for targetWide or High will return the original unscaled image.
		
		@example
		UI.choosePhoto( 0, 0, "basic.png", undefined, function( data ) { 
			if ( data.error == undefined ) { 
				NgLogD("yay, picture! at:"+data.filename);
			}
		} );
	*/
    choosePhotoCamera: function(width, height, filename, options, callback) {
        var cb = Commands.registerTemporaryCallback(callback);
		if (cb) {
        	Commands.doChooseCamera(width, height, filename, options || {}, cb);
		}
    },

	measureText: function( text, w, h, font, size, callback) {
		var cb = Commands.registerTemporaryCallback(callback);
		if (cb != '') {
			Commands.measureText(text, w || -1, h || -1, font, size, cb);
		}
	}
};

exports.UI.__defineGetter__("Window",
function() {
    delete UI.Window;
    return UI.Window = require('NGCore/Client/UI/Window').Window;
});
exports.UI.__defineGetter__("Element",
function() {
    delete UI.Element;
    return UI.Element = require('NGCore/Client/UI/Element').Element;
});
exports.UI.__defineGetter__("View",
function() {
    delete UI.View;
    return UI.View = require('NGCore/Client/UI/View').View;
});
exports.UI.__defineGetter__("Label",
function() {
    delete UI.Label;
    return UI.Label = require('NGCore/Client/UI/Label').Label;
});
exports.UI.__defineGetter__("Image",
function() {
    delete UI.Image;
    return UI.Image = require('NGCore/Client/UI/Image').Image;
});
exports.UI.__defineGetter__("Button",
function() {
    delete UI.Button;
    return UI.Button = require('NGCore/Client/UI/Button').Button;
});
exports.UI.__defineGetter__("GLView",
function() {
    delete UI.GLView;
    return UI.GLView = require('NGCore/Client/UI/GLView').GLView;
});
exports.UI.__defineGetter__("NavController",
function() {
    delete UI.NavController;
    return UI.NavController = require('NGCore/Client/UI/NavController').NavController;
});
exports.UI.__defineGetter__("WebView",
function() {
    delete UI.WebView;
    return UI.WebView = require('NGCore/Client/UI/WebView').WebView;
});
exports.UI.__defineGetter__("ScrollView",
function() {
    delete UI.ScrollView;
    return UI.ScrollView = require('NGCore/Client/UI/ScrollView').ScrollView;
});
exports.UI.__defineGetter__("ListView",
function() {
    delete UI.ListView;
    return UI.ListView = require('NGCore/Client/UI/ListView').ListView;
});
exports.UI.__defineGetter__("ListViewSection",
function() {
    delete UI.ListViewSection;
    return UI.ListViewSection = require('NGCore/Client/UI/ListViewSection').ListViewSection;
});
exports.UI.__defineGetter__("ListViewItem",
function() {
    delete UI.ListViewItem;
    return UI.ListViewItem = require('NGCore/Client/UI/ListViewItem').ListViewItem;
});
exports.UI.__defineGetter__("CellView",
function() {
    delete UI.CellView;
    return UI.CellView = require('NGCore/Client/UI/CellView').CellView;
});
exports.UI.__defineGetter__("CheckBox",
function() {
    delete UI.CheckBox;
    return UI.CheckBox = require('NGCore/Client/UI/CheckBox').CheckBox;
});
exports.UI.__defineGetter__("EditText",
function() {
    delete UI.EditText;
    return UI.EditText = require('NGCore/Client/UI/EditText').EditText;
});
exports.UI.__defineGetter__("EditTextArea",
function() {
    delete UI.EditTextArea;
    return UI.EditTextArea = require('NGCore/Client/UI/EditTextArea').EditTextArea;
});
exports.UI.__defineGetter__("DateField",
function() {
    delete UI.DateField;
    return UI.DateField = require('NGCore/Client/UI/DateField').DateField;
});
exports.UI.__defineGetter__("AlertDialog",
function() {
    delete UI.AlertDialog;
    return UI.AlertDialog = require('NGCore/Client/UI/AlertDialog').AlertDialog;
});
exports.UI.__defineGetter__("ProgressDialog",
function() {
    delete UI.ProgressDialog;
    return UI.ProgressDialog = require('NGCore/Client/UI/ProgressDialog').ProgressDialog;
});
exports.UI.__defineGetter__("Toast",
function() {
    delete UI.Toast;
    return UI.Toast = require('NGCore/Client/UI/Toast').Toast;
});
/** @private */
exports.UI.__defineGetter__("AdView",
function() {
    delete UI.AdView;
    return UI.AdView = require('NGCore/Client/UI/AdView').AdView;
});
exports.UI.__defineGetter__("DocumentView",
function() {
    delete UI.DocumentView;
    return UI.DocumentView = require('NGCore/Client/UI/DocumentView').DocumentView;
});
exports.UI.__defineGetter__("CheckoutView",
function() {
    delete UI.CheckoutView;
    return UI.CheckoutView = require('NGCore/Client/UI/CheckoutView').CheckoutView;
});
exports.UI.__defineGetter__("Spinner",
function() {
    delete UI.Spinner;
    return UI.Spinner = require('NGCore/Client/UI/Spinner').Spinner;
});
exports.UI.__defineGetter__("ProgressBar",
function() {
    delete UI.ProgressBar;
    return UI.ProgressBar = require('NGCore/Client/UI/ProgressBar').ProgressBar;
});
exports.UI.__defineGetter__("MapView",
function() {
    delete UI.MapView;
    return UI.MapView = require('NGCore/Client/UI/MapView').MapView;
});
exports.UI.__defineGetter__("MapAnnotation",
function() {
    delete UI.MapAnnotation;
    return UI.MapAnnotation = require('NGCore/Client/UI/MapAnnotation').MapAnnotation;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/DownloadManifest'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/DownloadManifest'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/DownloadManifest'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class XHR
// XMLHttpRequest implementation
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Class = require('NGCore/Client/Core/Class').Class;
var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
var XHR = require('NGCore/Client/Network/XHR').XHR;
var Util = require('NGCore/Client/Network/Util').Util;
var DownloadFile = require('NGCore/Client/Network/DownloadFile').DownloadFile;
var FileSystem = require('NGCore/Client/Storage/FileSystem').FileSystem;
var LocalGameList = require('NGCore/Client/Core/LocalGameList').LocalGameList;

// JMarr temporary hack to supress archive downloads on flash.
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;

////////////////////////////////////////////////////////////////////////////////

var Manifest = Class.subclass(
{
	classname: 'Manifest',

	initialize: function()
	{
	},

	reset: function ()
	{
		this.mJson = null;
		this.mArchives = null;
	},

	initWithJsonText: function ( text, emptyOnFail)
	{
		try
		{
			this.mJson = JSON.parse ( text );
			if (!this.mJson)
			{
				this.mJson = {};
			}
		}
		catch (e)
		{
			this.mJson = {};
		}

		if('__archives' in this.mJson)
		{
			this.mArchives = this.mJson['__archives'].files;
			delete this.mJson['__archives'];
		}
		else
		{
			this.mArchives = [];
		}
	},

	//cb: function ( itemKey, dstList, srcList ), which is compareItems
	//cb returns ! null, then dst[ item ] = cb return value.
	//cb returns null, then delete dst[ item ].
	foreach: function ( other, cb )
	{
		var dst = this.mJson;
		var src = other.mJson;
		// Handle all things in src.
		for ( var key in src )
		{
			this.handleItem ( key, dst, src, cb );
		}
		// Build up list of all things not in src.
		for ( var key in dst )
		{
			// Handle all things not in src.
			if ( ! (key in src) )
			{
				this.handleItem ( key, dst, src, cb );
			}
		}
	},

	handleItem: function ( key, dst, src, cb )
	{
		var ret = cb ( key, dst, src );
		if ( !ret )
		{
			delete dst[ key ];
		}
	},

	write: function ( fname )
	{
		var cb = function (err)
		{
			if (err)
			{
				console.log('Error writing manifest! ' + err);
			}
			// DO stuff?
		};

		if (this.mJson)
		{
			var out = JSON.stringify(this.mJson);
			FileSystem.writeFile(fname, out, cb);
		}
	}
});

////////////////////////////////////////////////////////////////////////////////

exports.DownloadManifest = MessageListener.subclass(
/** @lends Network.DownloadManifest.prototype */
{
	classname: 'DownloadManifest',

	/**
	 * @class The <code>DownloadManifest</code> class constructs objects that initiate the handling of a manifest file. 
	 * This ensures a set of files are kept up-to-date in the specified directory from the specified URL.
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 */
	initialize: function()
	{
		this.reset();
	},

	_clearConnections: function()
	{
		for (var i in this.mConnections)
		{
			if(!this.mConnections.hasOwnProperty(i)) continue;
			
			this.mConnections[i].abort();
		}
		this.mConnections = [];
	},

	reset: function ()
	{
		this.mConcurrentRequests = 6;

		this.mManifest = null;

		this.mRemoteUrl = null;
		this.mLocalPath = null;
		this.mLocalRoot = null;

		this.mLocalText = null;
		this.mRemoteText = null;
		/** @private */
		this.mProgressCb = function() {};
		/** @private */
		this.mDoneCb = function() {};

		this.mPaused = false;
		this.mValid = false;

		this._clearConnections();
		this.mPendingItems = [];
		this.mCompleteBytes = 0;
		this.mTotalBytes = 0;
		
		this.mSpaceNeeded = 0;
		
		this.mNumRemoteManifestFiles = 0;
		this.mNumRemoteManifestBytes = 0;
		
		this.mDownloadArchives = true;
		this.mActiveRequests = [];

		this.mLocalGameList = LocalGameList;

		this.mNewJS = false;
		this.mAppObserver = null;

		this.mRetrySchedule = Util.RetrySchedule(50, 2000);
		this.mManifestRetrySchedule = this.mRetrySchedule.slice(0);

		if(this._statusListener)
		{
			this._statusListener.destroy();
			this._statusListener = null;
		}
		this.mCheckUpdateOnly = false;
		this.mCheckUpdateCallback = null;
	},

	_ensureTrailingSlashes: function(remoteUrl, localPath, secureContentUrl)
	{
		// Check for trailing slashes
		this.mRemoteUrl = remoteUrl.match(/.*\/$/) ? remoteUrl : remoteUrl + '/';
		// If the local path is nothing, do not alter the filename. Otherwise, ensure trailing slash
		this.mLocalRoot = (localPath.match(/.*\/$/) || (!localPath)) ? localPath : localPath + '/';
		this._secureContentUrl = ((!secureContentUrl) || secureContentUrl.match(/.*\/$/)) ? secureContentUrl : secureContentUrl + '/';
	},

	_readLocalManifest: function()
	{
		FileSystem.readFile ( this.mLocalPath, this._onReadLocalManifest.bind(this) );
	},

	_setRemotePath: function(manifestName)
	{
		if (this._secureContentUrl)
		{
			this.mRemotePath = this._secureContentUrl + manifestName;
		}
		else
		{
			this.mRemotePath = this.mRemoteUrl + manifestName;
		}
	},

	_parseManNames: function (man)
	{
		if (typeof man === 'string')
		{
			var obj = {};
			obj[man] = man;
			man = obj;
		}
		return man;
	},

	isUpdated: function(remoteUrl, localPath, manifest, doneCB, errorCB)
	{
		this.mCheckUpdateOnly = true;
		this.mCheckUpdateCallback = doneCB;

		this.mDoneCb = (typeof errorCB == 'function') ? errorCB : function() {};
		this.mProgressCb = function(done, left) {};
		var httpStatusCode = 0;
		var fullUrl = remoteUrl + "/configuration.json" + Util.getCacheBustingString();
		Util.OperationWithRetries(
			(function(failCall, abortCall)
			{
				// Start remote manifest download.
				var req = new XHR();
				req.onreadystatechange = (function()
				{
					if( req.readyState == 4 && this.mValid )	// done && not cancelled
					{
						this.mManifest = new Manifest ();
						var manifestUrl = null;
						// Only parse if we got a good response back
						if (req.status == 200 && req.responseText)
						{
							var config = JSON.parse(req.responseText);
							manifestUrl = config.contentUrl;
							if (!manifest)
							{
								manifest =
								{
									"webgame.ngmanifest":
									require('NGCore/Client/Core/_int_LGL')._int_LGL.getManifestName(config)
								};
							}

							// If config didn't have contentUrl or we never parsed(local testing), use the base URL
							if (!manifestUrl)
								manifestUrl = remoteUrl;

							manifest = this._parseManNames(manifest);
							var manifestSourceName;
							var manifestName;
							for (var key in manifest)
							{
								manifestSourceName = manifest[key];
								manifestName = key;
								break;
							}

							this._ensureTrailingSlashes(manifestUrl, localPath);
							this.mLocalPath = this.mLocalRoot + manifestName;
							this._setRemotePath(manifestSourceName);
							this._readLocalManifest();
						}
						else if (req.status == 404)
						{
							this._processError('404! Failed to download configuration at '+ fullUrl, false);
						}
						else
						{
							httpStatusCode = req.status;
							failCall();
						}
					}
				}).bind(this);

				req.open ( 'GET', fullUrl, true );
				req.send ();
			}).bind(this),
			(function()
			{
				console.log('Exceeded maximum number of manifest download retires, failing');
				this._processError('Failed to download manifest (' + httpStatusCode + ') at ' + fullUrl, false);
			}).bind(this),
			this.mFailEarly
		);

		this.mValid = true;
	},

	// progressCb: function ( completedRequests, totalRequests )
	// doneCb: function ( err, manifest )
	// throws if url/path arguments are null or empty.
	// TODO: Allow headers argument.  Currently null.
	// TODO: Allow HTTP method argument.  Currently GET.
	/**
	* @name Network.DownloadManifest#start
	* @description Start a download of a remote manifest file at <code>[remoteUrl + manifestName]</code> 
	* and read a local manifest at <code>[localPath + manifestName]</code>.<br><br>
	* <ul>
	* <li>If the local manifest does not exist, all files specified by the remote manifest are downloaded.</li>
	* <li>If the local manifest does exist, this method will update the file system at 
	* <code>[localPath]</code> to match the files specified in the remote manifest.</li>
	* </ul>
	* Each file download will trigger a <code>progress</code> callback function that returns the 
	* number of items downloaded and the total number of items to download.
	* <pre class="code">progressCb: function ( completedRequests, totalRequests )</pre>
	* When all downloads are complete, a <code>done</code> callback function is triggered that returns an error (if any) 
	* and the contents of <code>[localPath + manifestName]</code>. 
	* <pre class="code">doneCb: function ( err, manifest )</pre>
	* If an error does not occur, this function returns <code>undefined</code>.<br><br>
	* <b>Note:</b> The contents of <code>[localPath + manifestName]</code> are saved whether an error occurs or not.
	* @param {String} remoteUrl The URL to a manifest file.
	* @param {String} localPath The directory path to a manifest file.
	* @param {String} manifestName The manifest filename. 
	* @param {Function} progressCb The callback function to call for download progress.
	* @param {Function} doneCb The callback function to call when the download is complete.
	* @throws {invalid arguments} If the URL or directory path returns as empty or <code>null</code>.
	* @example Network.DownloadManifest.start(this._URL, './', this._manifestName, progressCb, doneCallback);
	* @function
    * @status iOS, Android
	*/
	/** @ignore */
	start: function ( remoteUrl, localPath, manifest, progressCb, doneCb, disableArchives, failEarly )
	{
		this.mCheckUpdateOnly = false;
		
		// Allow manifestName to be a hash with {manifestDestName: manifestSourceName}
		manifest = this._parseManNames(manifest);
		var manifestSourceName;
		var manifestName;
		for (var key in manifest)
		{
			manifestSourceName = manifest[key];
			manifestName = key;
			break;
		}

		console.log('DownloadManifest.start(', remoteUrl, localPath, manifestSourceName, ')');
		if ( ! remoteUrl || ! localPath || remoteUrl == '' || localPath == '' )
		{
			throw new Error ( 'invalid arguments: ' + JSON.stringify ( arguments ) );
		}

		// Set up instance state for this request.
		this.mManifest = new Manifest ();
		if(disableArchives)
			this.mDownloadArchives = false;
		
		// JMarr temporary hack to disable archive downloads on flash.
		if(Capabilities.getPlatformOS() == 'flash')
		{
			console.log('Flash does not yet support archive downloads');
			this.mDownloadArchives = false;
		}

		this._ensureTrailingSlashes(remoteUrl, localPath, this._secureContentUrl);
		this._setRemotePath(manifestSourceName);
		this.mLocalPath = this.mLocalRoot + manifestName;
		this.mFailEarly = failEarly;

		// try these to prevent a failed update due to bad code
		/** @private */
		this.mProgressCb = function (done, left)
		{
			try
			{
				progressCb(done, left);
			}
			catch (ex)
			{
				NgLogException(ex);
			}
		};

		var that = this;
		/** @private */
		this.mDoneCb = function (err, man, hadCache)
		{
			try
			{
				// touch the .nomedia file (MOB-1355)
				FileSystem.writeFile(that.mLocalRoot + '/.nomedia', '');

				/** @private */
				this.mProgressCb = function() {};
				/** @private */
				this.mDoneCb = function() {};
				this._setLifecycleListening(false);
				doneCb(err, man, hadCache);
			}
			catch (ex)
			{
				NgLogException(ex);
			}
		};

		this._readLocalManifest();
		this._setLifecycleListening(true);
		this.mValid = true;
	},

	abort: function()
	{
		this.reset();
	},

	pause: function()
	{
		// Cancel downloads
		this._clearConnections();

		// move active requests back to pending
		this.mPendingItems = this.mPendingItems.concat(this.mActiveRequests);
		this.mActiveRequests = [];

		this.mPaused = true;
	},

	resume: function()
	{
		if (this.mPaused)
		{
			this.mPaused = false;
			this._downloadPendingItems();
		}
	},

	_setLifecycleListening: function(toListen)
	{
		if (toListen && !this.lifeListening)
		{
			Device.LifecycleEmitter.addListener(this,
				function (event)
				{
					switch (event)
					{
						case Device.LifecycleEmitter.Event.Suspend:
						case Device.LifecycleEmitter.Event.Terminate:
							this._writeManifest();
						break;
					}
				}
			);
			this.lifeListening = true;
		}
		else if (this.lifeListening)
		{
			Device.LifecycleEmitter.removeListener(this);
			this.lifeListening = false;
		}
	},

	_theQuestion: function (toBe)
	{
		return toBe | !toBe;
	},

	_setConfig: function (cfg)
	{
		// For saving after completion
		this._Config = cfg;
		// for skipping JS download
		this._noJS = cfg.omitJsUpdate;
		// For using separate content URL
		this._secureContentUrl = cfg.secureContentUrl;
	},

	// Callback for read of local manifest file in start method.

	_onReadLocalManifest: function ( err, data )
	{
		if (this.mValid)
		{
			try	// always start try block in async callbacks
			{
				if ( ! err )
				{
					this.mLocalText = data;
				}
				else
				{
					this.mLocalText = '{}';	// Empty string is ! null.  It's ok for the read to fail.
				}
				this._downloadManifest();
			}
			catch ( ex )
			{
				NgLogException ( ex );
				this._processError ( 'Error reading local manifest err: ' + err , false );
			}
		}
	},

	// Called to start the manifest download.
	_downloadManifest: function()
	{
		var httpStatusCode = 0;
		Util.OperationWithRetries(
			(function(failCall, abortCall)
			{
				// Start remote manifest download.
				var req = new XHR();
				var id = this.mConnections.push(req) - 1;
				req.onreadystatechange = (function()
				{
					if( req.readyState == 4 && this.mValid )	// done && not cancelled
					{
						delete this.mConnections[id];
						httpStatusCode = req.status;
						if ( httpStatusCode == 200 )
						{
							this.mRemoteText = req.responseText;
							this._checkItems();

							if (this.mCheckUpdateOnly)
								this._checkUpdate();
							else
								this._evalManifests ();
						}
						else
						{
							console.log( 'Download of manifest at ' + this.mRemotePath
								+Util.getCacheBustingString() + ' failed: ' + httpStatusCode + ' '
								+ req.responseText);
							if (httpStatusCode == 404)
							{
								abortCall();
							}
							else
							{
								failCall();
							}
						}
					}
				}).bind(this);

				req.open ( 'GET', this.mRemotePath + Util.getCacheBustingString(), true );
				req.send ();
			}).bind(this),
			(function()
			{
				this._processError('Failed to download manifest (' + httpStatusCode + ')', false);
			}).bind(this),
			this.mFailEarly
		);
	},

	// Can be called at any time.

	_processError: function ( message , writeManifest)
	{
		if (writeManifest && this.mManifest)
		{
			this._writeManifest();
		}

		// Don't call the doneCB without checking local text
		if (this.mValid)
		{
			this.mDoneCb ( message, null,  this.mLocalText ? this.mLocalText.length > 2 : false );
			this.reset ();
		}
	},

	_checkItems: function()
	{
		// Init source and destination manifests.
		this.mManifest.initWithJsonText ( this.mLocalText , true );
		var other = new Manifest ();
		other.initWithJsonText ( this.mRemoteText );

		// Build list of pending local items.
		this.mManifest.foreach ( other, this._compareItems.bind(this));
	},

	_checkUpdate: function()
	{
		this.mPendingItems = [];
		this.mCheckUpdateCallback(this.mTotalBytes > 0, this.mTotalBytes);
	},

	_evalManifests: function ()
	{
		try
		{
			// JMarr always download with zips if they are available.
			// If we only need to download less than 33% of files and less than 33% of bytes, then don't use an archive.
			// Additinoally, we must be on wifi, or else carriers might tamper with our files.
			/*var NetworkEmitter = require('../Device/NetworkEmitter').NetworkEmitter;
			if(this.mPendingItems.length < this.mNumRemoteManifestFiles * 0.33
				&& this.mTotalBytes < this.mNumRemoteManifestBytes * 0.33
				&& NetworkEmitter.getLastStatus() == NetworkEmitter.Status.Wifi)
			{
				this.mDownloadArchives = false;
			}*/
			
			// Cache total bytes into separate variable. Archive download might increase
			// space needed, but not total bytes.
			this.mSpaceNeeded = this.mTotalBytes;

			var other = new Manifest ();
			other.initWithJsonText ( this.mRemoteText );
			// If there is no archive in the manifest, don't download an archive.
			if(!other.mArchives)
				this.mDownloadArchives = false;

			// Prepare for archive downloads. If mDownloadArchives is true,
			// then all files will be downloaded through an archive. Otherwise,
			// only files that are makred as force archive will be downloaded
			// through archive.
			this._prepareForArchiveDownload(other.mArchives, !this.mDownloadArchives);
			
			// Trigger progress callback.
			this.mProgressCb ( this.mCompleteBytes, this.mTotalBytes );

			this.mLocalGameList.freeSpace(this.mSpaceNeeded, (function (err)
			{
				if (err)
				{
					this._processError(err, false);
					return;
				}
				var num = this.mPendingItems.length;
				if (num)
				{
					console.log("Going to download %d items.", num);
					if (num < 10)
					{
						console.log("Items: " + JSON.stringify(this.mPendingItems));
					}
				}
				// Download anything that got into pending list
				this._downloadPendingItems ();
			}).bind(this));
		}
		catch (e)
		{
			NgLogException ( e );
			this.mDoneCb ( 'Failed processing manifests!', null );
		}
	},
	
	// Decides which archives need to be downloaded to ensure that all of the pending files are downloaded.
	_prepareForArchiveDownload: function(archives, onlyForcedFiles)
	{
		console.log('DownloadManfiest._prepareForArchiveDownload onlyForcedFiles:', onlyForcedFiles);
		// Iterate over files that need to be covered and make sure they are included.
		var neededFiles = [];
		var includedArcns = {};
		var includedExpSize = 0;
		var includedArcSize = 0;
		var filesToCover = this.mPendingItems;
		var nonForcedFiles = [];
		for(var i=0; i < filesToCover.length; ++i)
		{
			// If this file isn't an archive, just download the file.
			var f = filesToCover[i];
			if(!f.arcn)
			{
				//console.log('NonForced: including arnc-less %s', f.name);
				neededFiles.push(f);
				includedExpSize += f.size;
				continue;
			}
			
			// Record that this archive provides this file.
			var arcn = f.arcn;
			var a = archives[arcn];
			if(!a.files)
				a.files = [f];
			else
				a.files.push(f);
			
			// Is this archive already incldued?
			if(includedArcns[arcn])
				continue;
			
			// If we are only including forced files, remember that this
			// is a non forced file that we need to download. If after evaluating
			// all of the forced files and these files are not included, they will
			// be explicitly included.
			if(onlyForcedFiles && !f.arcForce)
			{
				nonForcedFiles.push(f);
				//console.log('NonForced: delaying decision about %s in arcn %d', f.name, f.arcn);
				continue;
			}
			
			//console.log('Forced: including %s from arcn %d', f.name, f.arcn);
			
			// Include the archive associated with this arcn.
			neededFiles.push(a);
			includedArcns[arcn] = true;
			includedExpSize += a.expSize;
			includedArcSize += a.arcSize;
		}
		
		// If only downloading forced archives, examine all of the queued
		// files that are not forced. If their archive is not included, then 
		// directly include the file.
		for(i=0; i < nonForcedFiles.length; ++i)
		{
			// Is the archive for this file already incldued?
			// This will happen if a forced file (like a .js) 
			// forced the archive to be included.
			var f = nonForcedFiles[i];
			if(includedArcns[f.arcn])
			{
				//console.log('NonForced: skipping %s because it is already in arcn %d', f.name, f.arcn);
				continue;
			}
			
			//console.log('NonForced: including %s from arch %d', f.name, f.arcn);
			
			// Otherwise, include this file.
			neededFiles.push(f);
			includedExpSize += f.size;
		}
		
		// Tell the rest of the world about our choices.
		this.mPendingItems = neededFiles;
		this.mTotalBytes = includedExpSize;
		this.mSpaceNeeded = includedExpSize + includedArcSize;
	},

	// Callback from Manifest.foreach.

	_compareItems: function ( key, dst, src )
	{
		var ditem = dst[key];
		var sitem = src[key];

		// Early out for removed file.  Always delete.
		if ( ! sitem )
		{
			var fname = this.mLocalRoot + key;
			var cb = function(err)
			{
				if (err)
				{
					console.log('Error deleting ' + fname + ' error: ' + err);
				}
			};
			FileSystem.deleteFile(fname, cb);

			// If the item was pending, delete the temporary file it was downloading
			if ('pending' in ditem )
			{
				fname = fname + '.tmp';
				FileSystem.deleteFile(fname, cb);
			}
			return false;
		}

		var isJS = this._extensionMatch ( key, 'js' );

		// Don't download the html or the js with noJS.
		if (this._noJS && (isJS || key == "index.html"))
		{
			// Don't download JS!! keep it in the local manifest, but don't push it to download
			return true;
		}

		sitem.name = key;
		this.mNumRemoteManifestFiles += 1;
		this.mNumRemoteManifestBytes += sitem.size;

		// No local version or version mismatch, must download.
		if ( ! ditem || ditem.hash != sitem.hash)
		{
			if ( isJS )
			{
				this.mNewJS = true;
			}

			// Tally the space we need for downloading new items
			this.mTotalBytes += sitem.size;

			// Add to the pending queue.
			this.mPendingItems.push ( sitem );
		}
		
		return true;
	},

	// Utility method to check for case-insensitive match for file extension.
	
	_extensionMatch: function ( fname, ext )
	{
		var pattern = new RegExp ( '^.*\.(' + ext + ')$', 'i' );
		var ret = fname.match ( pattern );
		return ret;
	},

	// Once in download state, this method is called to start downloading 
	// assets from manifest.  When each asset successfully completes, this method
	// will also be called to start the next download.  This method institutes
	// the logic for having a limited number of concurrent downloads from
	// the mCurrentRequests and mConcurrentRequests members.

	_downloadPendingItems: function ()
	{
		if (this.mValid && !this.mPaused)
		{
			// Are we done?
			if ( this.mPendingItems.length == 0 && this.mActiveRequests.length == 0)
			{
				if (this.mTotalBytes > 0)
				{
					this._writeManifest ();
				}
				this._writeConfig();

				// Trigger done callback and reset.
				this.mDoneCb ( null, this.mManifest );
				this.reset ();
				return;
			}

			// Not done, pop more pending items and start their downloads.
			while ( this.mPendingItems.length && this.mActiveRequests.length < this.mConcurrentRequests )
			{
				// Download the next pending file.
				var item = this.mPendingItems.pop ();
				item.retrySchedule = this.mRetrySchedule.slice(0);
				this._downloadItem(item);
			}
		}
	},
	
	_downloadItem: function(item)
	{
		this.mActiveRequests.push(item);
		var remoteUrl = this.mRemoteUrl + item.name;
		if(item.mangled)
		{
			var i = remoteUrl.lastIndexOf('.');
			remoteUrl = remoteUrl.substr(0, i) + '-' + remoteUrl.substr(i+1) + '.bin';
		}

		Util.OperationWithRetries((function(failCb)
		{
			// Start the download.
			var dlFile = new DownloadFile();
			var id = this.mConnections.push(dlFile) - 1;
			dlFile.start(this.mLocalRoot + item.name,
				'GET',
				remoteUrl + Util.getCacheBustingString(),
				[],
				this._onDownloadItemComplete.bind(this, item, failCb, id));
		}).bind(this), (function()
		{
			console.log('Manifest download failed. Too many failed download attempts for ' + item.name );
			this._processError ( 'Could not download file ' + item.name , true);
		}).bind(this), this.mFailEarly);
	},

	_removeActiveRequest: function (item)
	{
		for (var i in this.mActiveRequests)
		{
			if (item == this.mActiveRequests[i])
			{
				this.mActiveRequests.splice(i, 1);
			}
		}
	},

	// Callback for completion of download started in downloadItem method.
	// Will throw if item does not have pending member set.

	_onDownloadItemComplete: function ( item, failCb, id, status, hash )
	{
		try
		{
			delete this.mConnections[id];
			// Was there an error or bad download?
			if(status != 200 || item.hash != hash)
			{
				// Try to download the item again.
				console.log('Download failed.  Retrying ' + item.name );
				console.log('Status: ' + status + ' manifest hash: ' + item.hash + ' actual hash: ' + hash);
				failCb();
				return;
			}
			
			// Is this an archive?
			if(item.files)
			{
				// Temporarially increase the max number of connections while we decompress the archive.
				++this.mConcurrentRequests;
				
				FileSystem.decompressFile(this.mLocalRoot + item.name, this.mLocalRoot, false, (function(err, files)
				{
					// Restore max connections to original value.
					--this.mConcurrentRequests;
					
					// Delete the zip file.
					FileSystem.deleteFile(this.mLocalRoot + '/' + item.name);
					
					if(err)
					{
						// Try to download the item again.
						console.log('Decompress failed.  Retrying ' + item.name );
						failCb();
					}
					
					for(var i=0; i < item.files.length; ++i)
					{
						var f = item.files[i];
						this.mManifest.mJson[f.name] = {size: f.size, hash: f.hash};
					    if (typeof f.encryption != "undefined")
						this.mManifest.mJson[f.name].encryption = f.encryption;
					}

					this._removeActiveRequest(item);
					this.mCompleteBytes += Number(item.expSize);
					this.mProgressCb ( this.mCompleteBytes, this.mTotalBytes );
					this._downloadPendingItems ();
				}).bind(this));
			}
			else
			{
				// Update our working manifest.
				this.mManifest.mJson[item.name] = {size: item.size, hash: item.hash};
			    if (typeof item.encryption != "undefined")
				this.mManifest.mJson[item.name].encryption = item.encryption;
				
				// Make callbacks (like a boss).
				this._removeActiveRequest(item);
				this.mCompleteBytes += Number(item.size);
				this.mProgressCb ( this.mCompleteBytes, this.mTotalBytes );
				this._downloadPendingItems ();
			}
		}
		catch ( ex )
		{
			// Unlikely, but safety
			NgLogException ( ex );
			this._processError ( 'Error after finishing the download of item ' + item 
				+ '. status is ' + status , true );
		}
	},

	// Flush changes to locally cached manifest file.

	_writeManifest: function ()
	{
		console.log("DM Complete!");
		try
		{
			if (this.mManifest)
				this.mManifest.write ( this.mLocalPath );
		}
		catch (ex)
		{
			NgLogException(ex);
		}
	},

	_writeConfig: function ()
	{
		try
		{
			if (this._Config)
			{
				// console.log("writing |%s| to %s", JSON.stringify(this._Config), this.mLocalRoot + Capabilities._getConfigFile());
				FileSystem.writeFile(this.mLocalRoot + Capabilities._getConfigFile(),
					JSON.stringify(this._Config), function(err) {console.log(err); } );
			}
		}
		catch (ex)
		{
			NgLogException(ex);
		}
	}
});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/LocalGameList'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/LocalGameList'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/LocalGameList'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class LocalGameList
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Proc = require('NGCore/Client/Core/Proc').Proc;
var Class = require('NGCore/Client/Core/Class').Class;
var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var Base64 = require('NGCore/Client/Core/Base64').Base64;
var toMD5 = require('NGCore/Client/Core/toMD5').toMD5;
var Util = require('NGCore/Client/Network/Util').Util;
var LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;

////////////////////////////////////////////////////////////////////////////////

var LifeListener = MessageListener.subclass(
{
	initialize: function(listen)
	{
		LifecycleEmitter.addListener(this, this.onLifecycleUpdate);
		this._listener = listen;
	},

	destroy: function()
	{
		LifecycleEmitter.removeListener(this);
	},

	onLifecycleUpdate: function(event)
	{
		switch (event)
		{
			case Device.LifecycleEmitter.Event.Resume:
				this._listener.onResume();
				break;
		}
	}
});

exports.LocalGameList = Class.singleton (
/** @lends Core.LocalGameList.prototype */
{
	classname: 'LocalGameList',

	/**
	 * @class The <code>LocalGameList</code> class constructs objects that handle the loading and updating of a user's game list.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 */
	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		new LifeListener(this);
		this.mRefCount = 0;
		this.mRefTable = [];
		this.mSpaceAvailable = 0;
		this.mRequiredAvailableSpace = 0;
		
		this.mSpaceCB = [];

		this._getRepoSpaceSendGen();

		var self = this;
		var KeyValueCache = require('NGCore/Client/Storage/KeyValue').KeyValueCache;
		this.mGameStore = KeyValueCache.global("Core.GameList");
		this.mActiveGameKey = "activeGames";
		this.onResume();
	},


	/** @private */
	onResume: function()
	{
		this._reloadGameList();
	},

	_reloadGameList: function()
	{
		this.mGameStore.getItem(this.mActiveGameKey,
			(function(error, value)
			{
				var list;
				if (value)
					list = JSON.parse(value);
				else
					list = [];

				this.mGameList = list;
				if (typeof this.mListListen == 'function')
					this.mListListen();
			}).bind(this),
			true
		);
	},

	/** @private */
	setListListener: function(funk)
	{
		this.mListListen = funk;
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 302
	// Method create = -1
	// Method updateGame = 2
	// Method updateDone = 3
	// Method getRepoSpace = 4
	// Method repoSpace = 5
	// Method deleteGame = 6
	// Method _setUpdateProgressVisible = 7
	// Method _setUpdateProgressBounds = 8
	// Method pauseUpdate = 9
	// Method resumeUpdate = 10
	// Method cancelUpdate = 11
	// Method updateProgress = 12
	// Method runGame = 13
	// Method finishGame = 14
	// Method _forwardException = 15
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 3:
					instance._updateDoneRecv( cmd );
					break;
				case 5:
					instance._repoSpaceRecv( cmd );
					break;
				case 12:
					instance._updateProgressRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in LocalGameList._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in LocalGameList._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[302] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_updateDoneRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in LocalGameList.updateDone from command: " + cmd );
			return false;
		}
		
		obj[ "id" ] = Proc.parseInt( cmd[ 0 ] );
		if( obj[ "id" ] === undefined )
		{
			NgLogE("Could not parse id in LocalGameList.updateDone from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Proc.parseString( cmd[ 1 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in LocalGameList.updateDone from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_repoSpaceRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in LocalGameList.repoSpace from command: " + cmd );
			return false;
		}
		
		obj[ "space" ] = Proc.parseInt( cmd[ 0 ] );
		if( obj[ "space" ] === undefined )
		{
			NgLogE("Could not parse space in LocalGameList.repoSpace from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_updateProgressRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 4 )
		{
			NgLogE("Could not parse due to wrong argument count in LocalGameList.updateProgress from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in LocalGameList.updateProgress from command: " + cmd );
			return false;
		}
		
		obj[ "cur" ] = Proc.parseInt( cmd[ 1 ] );
		if( obj[ "cur" ] === undefined )
		{
			NgLogE("Could not parse cur in LocalGameList.updateProgress from command: " + cmd );
			return false;
		}
		
		obj[ "total" ] = Proc.parseInt( cmd[ 2 ] );
		if( obj[ "total" ] === undefined )
		{
			NgLogE("Could not parse total in LocalGameList.updateProgress from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Proc.parseBool( cmd[ 3 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in LocalGameList.updateProgress from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Proc.appendToCommandString( ":302,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_updateGameSendGen: function( url, id )
	{
		Proc.appendToCommandString( ":302,2," + this.__objectRegistryId + "," + Base64.encode( url ) + "," + id  );
	},
	
	/** @private */
	_getRepoSpaceSendGen: function(  )
	{
		Proc.appendToCommandString( ":302,4," + this.__objectRegistryId );
	},
	
	/** @private */
	_deleteGameSendGen: function( mdFive )
	{
		Proc.appendToCommandString( ":302,6," + this.__objectRegistryId + "," + Base64.encode( mdFive )  );
	},
	
	/** @private */
	__setUpdateProgressVisibleSendGen: function( visible )
	{
		Proc.appendToCommandString( ":302,7," + this.__objectRegistryId + "," + ( visible ? 1 : 0 )  );
	},
	
	/** @private */
	__setUpdateProgressBoundsSendGen: function( x, y, w, h )
	{
		Proc.appendToCommandString( ":302,8," + this.__objectRegistryId + "," + x + "," + y + "," + w + "," + h  );
	},
	
	/** @private */
	_pauseUpdateSendGen: function( url )
	{
		Proc.appendToCommandString( ":302,9," + this.__objectRegistryId + "," + Base64.encode( url )  );
	},
	
	/** @private */
	_resumeUpdateSendGen: function( url )
	{
		Proc.appendToCommandString( ":302,10," + this.__objectRegistryId + "," + Base64.encode( url )  );
	},
	
	/** @private */
	_cancelUpdateSendGen: function( url )
	{
		Proc.appendToCommandString( ":302,11," + this.__objectRegistryId + "," + Base64.encode( url )  );
	},
	
	/** @private */
	_runGameSendGen: function( url )
	{
		Proc.appendToCommandString( ":302,13," + this.__objectRegistryId + "," + Base64.encode( url )  );
	},
	
	/** @private */
	_finishGameSendGen: function(  )
	{
		Proc.appendToCommandString( ":302,14," + this.__objectRegistryId );
	},
	
	/** @private */
	__forwardExceptionSendGen: function( exceptionString )
	{
		Proc.appendToCommandString( ":302,15," + this.__objectRegistryId + "," + Base64.encode( exceptionString )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// updateGame: function( url, id ) {}
	
	// _updateDoneRecv: function( cmd ) {}
	// getRepoSpace: function(  ) {}
	
	// _repoSpaceRecv: function( cmd ) {}
	// deleteGame: function( mdFive ) {}
	
	// _setUpdateProgressVisible: function( visible ) {}
	
	// _setUpdateProgressBounds: function( x, y, w, h ) {}
	
	// pauseUpdate: function( url ) {}
	
	// resumeUpdate: function( url ) {}
	
	// cancelUpdate: function( url ) {}
	
	// _updateProgressRecv: function( cmd ) {}
	// runGame: function( url ) {}
	
	// finishGame: function(  ) {}
	
	// _forwardException: function( exceptionString ) {}
	

// {{/Wg Generated Code}}
	
	_setProgressVisible: function (progressVisible) {
		this.progressVisible = progressVisible;
		this.__setUpdateProgressVisibleSendGen(progressVisible);
	},
	
	_setProgressBounds: function(bounds) {
		this.__setUpdateProgressBoundsSendGen(bounds[0],bounds[1],bounds[2],bounds[3]);
	},
	
	_createProcSwitchDialog: function(title)
	{
		var UI = require('NGCore/Client/UI').UI;
		var Device = require('NGCore/Client/Device').Device;
		var w = NGWindow.outerWidth;
		var h = NGWindow.outerHeight;
		
		if(Device.OrientationEmitter.getInterfaceOrientation() == Device.OrientationEmitter.Orientation.Landscape
			|| Device.OrientationEmitter.getInterfaceOrientation() == Device.OrientationEmitter.Orientation.LandscapeLeft)
		{
			w = NGWindow.outerHeight;
			h = NGWindow.outerWidth;
		}
		
		var r = new UI.ViewGeometry.Rect(0, 0, w, h);
		
		var background = new UI.View({
			'frame': r.array(),
			'title': title,
			'backgroundColor': "8000"
		});
		
		r.inset(Math.round( (h - 238) / 2.0 ), 10);
		
		var dialog = new UI.View({
			'frame': r.array(),
			'gradient': {
				gradient: ["FF102031 0.0", "FF102031 0.394", "FF101820 0.394", "FF101820 1.0"],
				outerLine: "FF9c 1.0"
			}
		});
		background.addChild(dialog);

		r.x = r.y = 0;
		
		var header = new UI.Label({
			'frame': r.sliceVertical(94).array(),
			'text': (title || "Please Wait…"),
			'textColor': "FFFF",
			'textShadow': "8000 1.0 {0,-1}",
			'textSize': 24.0,
			'textGravity': [0.0, 0.5],
			'textInsets': [10, 30, 10, 30]
		});
		dialog.addChild(header);
		
		r.inset(36, 36 + Math.floor( (r.w - r.h) / 2));
		r.h = r.w;
		
		var spinner = new UI.Spinner({
			'frame': r.array()
		});
		dialog.addChild(spinner);
		
		UI.Window.document.addChild(background);
		
		return background;
	},

	/**
	* Restart the current game
	*/
	restartGame: function()
	{
		this.runGame(Capabilities.getServer() + "/" + Capabilities.getGame());
	},

	/**
	* Launch a game from the specified URL.
	* @param {String} url The specified URL of a game. Null to return to mobage.
	*/
	
	runGame: function( url )
	{
		console.log("Calling runGame with " + url);
		if (!url)
		{
			console.log("Finishing");
			this._finishGame();
		}
		else
		{
			this._runGameSendGen(Util.NormalizeUrl(url));
		}
	},

/** private */
	_finishGame: function()
	{
		this._finishGameSendGen();
	},

	// Next 5 functions are for mobage, not developers.

	// callback = function(gameUrl, dl'd, total, error)
	// mobage responsibility to intercept when dl'd == total, update is finished
	//	or know if there was an error by checking that param

	listenUpdates: function(callback)
	{
		this.mUpdateListener = callback;
	},

	stopUpdateListening: function()
	{
		delete this.mUpdateListener;
	},

	pauseUpdate: function(url)
	{
		this._pauseUpdateSendGen(Util.NormalizeUrl(url));
	},

	resumeUpdate: function(url)
	{
		this._resumeUpdateSendGen(Util.NormalizeUrl(url));
	},

	cancelUpdate: function(url)
	{
		this._cancelUpdateSendGen(Util.NormalizeUrl(url));
	},

	/**
	* Update an application at the specified URL.
	* @example Core.LocalGameList.updateGame(url, (function(err)
	*	{
	*		if (err)
	*		{
	*			NgLogE("GameHub error updating game! " + err);
	*			Network.Util.showSimpleNetworkError();
	*			this._loadingGame = false;
	*		}
	*		else
	*		{
	*			Core.LocalGameList.runGame(url);
	*		}
	*	});
	* @param {String} url The specified URL.
	* @param {Function} cb The callback function to pass in.
	*/
	
	updateGame: function( url , cb )
	{
		var reqId = this.mRefCount;
		this.mRefTable[this.mRefCount++] = cb;

		this._updateGameSendGen( Util.NormalizeUrl(url), reqId );
		return reqId;
	},
	
	/**
	* Launch an updated application from the specified URL.
	* @example Core.LocalGameList.runUpdatedGame('/games/MyGames');
	* @param {String} url The specified URL of an updated application.
	*/
	
	runUpdatedGame: function (url)
	{
		if (!url)
		{
			this._finishGame();
			return;
		}

		this.updateGame(url,
			(function(err)
			{
				if (err)
				{
					NgLogE("LGL Error updating game! " + err);
					Util.showFatalErrorDialog();
				}
				else
				{
					this.runGame(url);
				}
			}).bind(this)
		);
	},

	_updateProgressRecv: function( cmd )
	{
		var obj = {};
		this._updateProgressRecvGen(cmd, obj);
		if (this.mUpdateListener)
			this.mUpdateListener(obj.url, obj.cur, obj.total, obj.error);
	},

	_updateDoneRecv: function( cmd )
	{
		var obj = {};
		this._updateDoneRecvGen(cmd, obj);

		this._reloadGameList();

		var cb = this.mRefTable[obj.id];
		if (cb)
		{
			cb(obj.error);
		}

		delete this.mRefTable[obj.id];
		this._getRepoSpaceSendGen();
	},

	_repoSpaceRecv: function( cmd )
	{
		var obj = {};
		this._repoSpaceRecvGen(cmd, obj);
		this.mSpaceAvailable = obj.space - 7340032; // KJ report 7mb less
		console.log('LocalGameList.got response:', this.mSpaceAvailable, 'and need:', this.mRequiredAvailableSpace);
		
		if(this.mRequiredAvailableSpace > this.mSpaceAvailable)
		{
			var errorAlert = new UI.AlertDialog();
			errorAlert.setText(Core.Localization.getString("SD card is full"));
			errorAlert.setChoices([Core.Localization.getString("Exit")]);
			errorAlert.game = this.game;
			errorAlert.onchoice = function(ret)
			{
				errorAlert.hide();
				LifecycleEmitter.exitProcess();
			};
			errorAlert.show();
		}
		else
		{
			for(var i=0; i < this.mSpaceCB.length; ++i)
			{
				this.mSpaceCB[i]();
			}
			this.mSpaceCB = [];
			this.mRequiredAvailableSpace = 0;
		}
	},

	/**
	 * @private
	 */
	getGameList: function()
	{
		// Caveat! This will return an empty list if it is the first call. Must initialize beforehand.-KJ
		return this.mGameList;
	},

	/**
	 * @private
	 */
	updateGameList: function(list)
	{
		this.mGameList = list;
	},

	/**
	 * @private
	 */
	freeSpace: function(space, cb)
	{
		this.mRequiredAvailableSpace += space;
		
		this.mSpaceCB.push(cb);
		console.log('LocalGameList.freeSpace space=', this.mRequiredAvailableSpace);
		if(this.mSpaceCB.length == 1)
		{
			console.log('LocalGameList.sending request to native');
			// Send request to native if this is the first requester.
			this._getRepoSpaceSendGen();
		}
	},

	/**
	 * @private
	 */
	deleteGame: function(url)
	{
		url = Util.NormalizeUrl(url);
		var hash = toMD5(url);
		this._deleteGameSendGen(hash);

		var self = this;
		var doneCB = function ()
		{
			NgLogD("LocalGameList finished deleting game from " + self.mActiveGameKey + " for " + hash );
		};

		// Update cached game list to match what's going to happen in high-priv.
		// Matches logic in _LocalGameList._deleteGameFromStorage, but doesn't
		// write to Storage key.
		if( this.mGameList )
		{
			var list = this.mGameList;
			var good = false;
			var ind;
			var out = [];
			for(ind = 0; ind < list.length; ++ind)
			{
				if(list[ind].name == hash)
					good = true;
				else
					out.push(list[ind]);
			}

			if( good )
			{
				NgLogD("LocalGameList found and removed " + hash);
				this.mGameList = out;
			}
			else
				NgLogD("LocalGameList failed to find and remove " + hash);
		}
		else
			NgLogD("LocalGameList cache not warm, can't remove " + hash);
	},

	/**
	 * Check if an update is available for the specified application.<br><br>
	 * The following code illustrates how to retrieve an application name to pass in for this call.
	 * @param {String} game The specified game. Use <code>{@link Core.Capabilities.getGame}</code> to return the game name.
	 * @param {Function} callback The function to call once the check is complete.
	 * @example
	 *
	 * updateButton.onclick = function() {
	 *     LocalGameList.updateAvailable(Core.Capabilities.getUrl(), function(updated, spaceNeeded) {
	 *         if (updated)
	 *             LGL.runUpdatedGame(Core.Capabilities.getUrl());
	 *     });
	 * };
	 * @status
	 */
	updateAvailable: function(game, doneCB, errorCB)
	{
		var _int_LGL = require('NGCore/Client/Core/_int_LGL')._int_LGL;
		_int_LGL.updateAvailable(game, doneCB, errorCB);
	},

	_forwardException: function( exceptionString )
	{
		this.__forwardExceptionSendGen({exceptionString:exceptionString});
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device'] || {}; $MODULE_REGISTRY['NGCore/Client/Device'] = exports; /**
 * <p>Classes and objects contained by the Device module.</p>
 * @name Device
 * @namespace
 * @description <p>The Device module is a collection of classes that support the effect of physical movement on a device.
 * Each class instantiates a device singleton that emits when specific device conditions are met:</p>
 *<ul>
 *<li><code>{@link Device.KeyEmitter}</code>: A singleton object for emitting when the user presses or releases a device hardware key.</li>
 *<li><code>{@link Device.LifecycleEmitter}</code>: A singleton object for emitting when device lifecycle events occur.</li>
 *<li><code>{@link Device.LocationEmitter}</code>: A singleton object for emitting the geographic location of a device.</li>
 *<li><code>{@link Device.MemoryEmitter}</code>: A singleton object for emitting when low-memory states occur on a device.</li>
 *<li><code>{@link Device.MotionEmitter}</code>: A singleton object for emitting objects that collect spatial data from a device.</li>
 *<li><code>{@link Device.NetworkEmitter}</code>: A singleton object for emitting when a change in network status occurs for a device.</li>
 *<li><code>{@link Device.OrientationEmitter}</code>: A singleton object for emitting when a change to the physical orientation of the device occurs.</li>
 *<li><code>{@link Device.ShakeEmitter}</code>: A singleton object for emitting when the device detects a shake gesture.</li>
 *</ul>
 */
exports.Device = {};

exports.Device.__defineGetter__("LifecycleEmitter", function() {
	delete this.LifecycleEmitter;
	return this.LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;
});
exports.Device.__defineGetter__("LocationEmitter", function() {
	delete this.LocationEmitter;
	return this.LocationEmitter = require('NGCore/Client/Device/LocationEmitter').LocationEmitter;
});
exports.Device.__defineGetter__("MemoryEmitter", function() {
	delete this.MemoryEmitter;
	return this.MemoryEmitter = require('NGCore/Client/Device/MemoryEmitter').MemoryEmitter;
});
exports.Device.__defineGetter__("MotionEmitter", function() {
	delete this.MotionEmitter;
	return this.MotionEmitter = require('NGCore/Client/Device/MotionEmitter').MotionEmitter;
});
exports.Device.__defineGetter__("NetworkEmitter", function() {
	delete this.NetworkEmitter;
	return this.NetworkEmitter = require('NGCore/Client/Device/NetworkEmitter').NetworkEmitter;
});
exports.Device.__defineGetter__("OrientationEmitter", function() {
	delete this.OrientationEmitter;
	return this.OrientationEmitter = require('NGCore/Client/Device/OrientationEmitter').OrientationEmitter;
});
exports.Device.__defineGetter__("ShakeEmitter", function() {
	delete this.ShakeEmitter;
	return this.ShakeEmitter = require('NGCore/Client/Device/ShakeEmitter').ShakeEmitter;
});
exports.Device.__defineGetter__("KeyEmitter", function() {
	delete this.KeyEmitter;
	return this.KeyEmitter = require('NGCore/Client/Device/KeyEmitter').KeyEmitter;
});
exports.Device.__defineGetter__("PushNotificationEmitter", function() {
	delete this.PushNotificationEmitter;
	return this.PushNotificationEmitter = require('NGCore/Client/Device/_PushNotificationEmitter').PushNotificationEmitter;
});
exports.Device.__defineGetter__("InAppPurchaseEmitter", function() {
	delete this.InAppPurchaseEmitter;
	return this.InAppPurchaseEmitter = require('NGCore/Client/Device/_InAppPurchaseEmitter').InAppPurchaseEmitter;
});
exports.Device.__defineGetter__("InAppPurchase", function() {
	delete this.InAppPurchase;
	return this.InAppPurchase = require('NGCore/Client/Device/_InAppPurchase').InAppPurchase;
});
exports.Device.__defineGetter__("IPCEmitter", function() {
	delete this.IPCEmitter;
	return this.IPCEmitter = require('NGCore/Client/Device/IPCEmitter').IPCEmitter;
});
exports.Device.__defineGetter__("LayoutEmitter", function() {
	delete this.LayoutEmitter;
	return this.LayoutEmitter = require('NGCore/Client/Device/LayoutEmitter').LayoutEmitter;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core'] || {}; $MODULE_REGISTRY['NGCore/Client/Core'] = exports; /**
 * <p>Classes and objects contained by the Core module.</p>
 * @name Core
 * @namespace
 * @description <p>The Core module is a collection of classes that provide applications with access to:</p>
 * <ul>
 * <li>Core components of a device.</li>
 * <li>APIs that define a class-based structure for development.</li>
 * <li>Objects that support application updates.</li>
 * </ul>
 * <p>Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 * <ul>
 * <li><code>{@link Core.Analytics}</code>: Construct objects that keep track of game-specific items that require analysis and counting.</li>
 * <li><code>{@link Core.Capabilities}</code>: A singleton object that contains data about device hardware components.</li>
 * <li><code>{@link Core.Class}</code>: Supports construction of objects and classes for use in OOP environments.</li>
 * <li><code>{@link Core.Color}</code>: Control the RGB color components of a device.</li>
 * <li><code>{@link Core.LocalGameList}</code>: Construct objects that manage a user's game list.</li>
 * <li><code>{@link Core.MessageEmitter}</code>: A base class object for constructing objects that emit application notifications.</li>
 * <li><code>{@link Core.MessageListener}</code>: A base class object for constructing objects that handle application notifications.</li>
 * <li><code>{@link Core.NativeAppLaunch}</code>: Construct objects for storing <code>intent</code> strings.</li>
 * <li><code>{@link Core.Point}</code>: Control the point values for <i>x</i> and <i>y</i> coordinates.</li>
 * <li><code>{@link Core.Rect}</code>: Construct rectangle objects.</li>
 * <li><code>{@link Core.Size}</code>: Control the values for <i>height</i> and <i>width</i> components.</li>
 * <li><code>{@link Core.Time}</code>: A singleton that contains data about device timing values.
 * <li><code>{@link Core.UpdateEmitter}</code>: Control the application update time rate.</li>
 * <li><code>{@link Core.Vector}</code>: Control the vector values for <i>x</i> and <i>y</i> coordinates.</li>
 * </ul>
 */
exports.Core = {};

exports.Core.__defineGetter__("Analytics", function() {
	delete this.Analytics;
	return this.Analytics = require('NGCore/Client/Core/Analytics').Analytics;
});
exports.Core.__defineGetter__("Base64", function() {
	delete this.Base64;
	return this.Base64 = require('NGCore/Client/Core/Base64').Base64;
});
exports.Core.__defineGetter__("Capabilities", function() {
	delete this.Capabilities;
	return this.Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
});
exports.Core.__defineGetter__("Class", function() {
	delete this.Class;
	return this.Class = require('NGCore/Client/Core/Class').Class;
});
exports.Core.__defineGetter__("Color", function() {
	delete this.Color;
	return this.Color = require('NGCore/Client/Core/Color').Color;
});
exports.Core.__defineGetter__("Vector", function() {
	delete this.Vector;
	return this.Vector = require('NGCore/Client/Core/Vector').Vector;
});
exports.Core.__defineGetter__("Point", function() {
	delete this.Point;
	return this.Point = require('NGCore/Client/Core/Point').Point;
});
exports.Core.__defineGetter__("Size", function() {
	delete this.Size;
	return this.Size = require('NGCore/Client/Core/Size').Size;
});
exports.Core.__defineGetter__("Rect", function() {
	delete this.Rect;
	return this.Rect = require('NGCore/Client/Core/Rect').Rect;
});
exports.Core.__defineGetter__("MessageEmitter", function() {
	delete this.MessageEmitter;
	return this.MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
});
exports.Core.__defineGetter__("MessageListener", function() {
	delete this.MessageListener;
	return this.MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
});
exports.Core.__defineGetter__("ObjectRegistry", function() {
	delete this.ObjectRegistry;
	return this.ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
});
exports.Core.__defineGetter__("Time", function() {
	delete this.Time;
	return this.Time = require('NGCore/Client/Core/Time').Time;
});
exports.Core.__defineGetter__("toMD5", function() {
	delete this.toMD5;
	return this.toMD5 = require('NGCore/Client/Core/toMD5').toMD5;
});
exports.Core.__defineGetter__("SHA1", function() {
	delete this.SHA1;
	return this.SHA1 = require('NGCore/Client/Core/SHA1').SHA1;
});
exports.Core.__defineGetter__("UpdateEmitter", function() {
	delete this.UpdateEmitter;
	return this.UpdateEmitter = require('NGCore/Client/Core/UpdateEmitter').UpdateEmitter;
});
exports.Core.__defineGetter__("Proc", function() {
	delete this.Proc;
	return this.Proc = require('NGCore/Client/Core/Proc').Proc;
});
exports.Core.__defineGetter__("Logger", function() {
	delete this.Logger;
	return this.Logger = require('NGCore/Client/Core/Logger').Logger;
});
exports.Core.__defineGetter__("LocalGameList", function() {
	delete this.LocalGameList;
	return this.LocalGameList = require('NGCore/Client/Core/LocalGameList').LocalGameList;
});
exports.Core.__defineGetter__("Localization", function() {
	delete this.Localization;
	return this.Localization = require('NGCore/Client/Core/Localization').Localization;
});
exports.Core.__defineGetter__("_LocalGameList", function() {
	delete this._LocalGameList;
	return this._LocalGameList = require('NGCore/Client/Core/_LocalGameList')._LocalGameList;
});
exports.Core.__defineGetter__("NativeAppLaunch", function() {
	delete this.NativeAppLaunch;
	return this.NativeAppLaunch = require('NGCore/Client/Core/NativeAppLaunch').NativeAppLaunch;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Capabilities'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Capabilities'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Capabilities'] = exports; 	////////////////////////////////////////////////////////////////////////////////
// Class Capabilities
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Client/Core/Class').Class;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Proc = require('NGCore/Client/Core/Proc').Proc;

////////////////////////////////////////////////////////////////////////////////

exports.Capabilities = Class.singleton(
/** @lends Core.Capabilities.prototype */
{
	classname: 'Capabilities',
	_configFile: 'configuration.json',

	/**
	 * @class The <code>Capabilities</code> class constructs a singleton object that contains device properties. These objects represent the device and provide access to device information. 
	 * This class also provides information about how a device and game servers communicate.
	 * <br><br>
	 * <b>Note:</b> An application should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

        // Please keep this on one line, sed won't update otherwise
		this._fields = {version: 'sdks_1.3-20110826-1.3', buildDate: '20110901', buildHash: 'g5ff56d6'};
	},

	_getConfigFile:			function() {return this._configFile;},
	_isGameLoaded:			function() {return this._fields._gamePreLoaded;},
	_getAccts:				function() {return this._fields._accts;},

	meetsBinaryVersion: function(desiredVersion)
	{
		var binary = this.getBinaryVersion().split('-').pop().split('.');
		var desired = desiredVersion.split('.');

		// A shorter length means a lower version (if all other items match)
		var meets = binary.length >= desired.length;
		var len = Math.min(desired.length, binary.length);
		for (var i = 0; i < len; ++i)
		{
			var bin = Number(binary[i]);
			var des = Number(desired[i]);
			if (bin != des)
			{
				meets = bin > des;
				break;
			}
		}
		return meets;
	},

	/**
	 * Return the object stored in configuration.json for your game.
	 * @returns {Object} The JSON.parsed object represented in your configuration.json file.
	 * @type Object
	 * @status
	 */
	getConfigs:			function() {return this._configuration;},

	/**
	 * Return the SDK version number from the <code>Capabilities</code> of this device.
	 * @returns {String} The version of the SDK on the device.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSDKVersion:           function() { return this._fields.version; },

	/**
	 * Return the build date for the currently installed SDK. The build date is in the format <i>YYYYMMDD</i>.
	 * @returns {String} The build date for the SDK on the device.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSDKBuildDate:           function() { return this._fields.buildDate; },
	
	/**
	 * Return the build hash of the currently installed SDK.
	 * @returns {String} The build hash for the SDK on the device.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSDKBuildHash:           function() { return this._fields.buildHash; },

	/**
	 * Return the version of the currently running ngCore binary
	 * @returns {String} The version of ngCore running
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getBinaryVersion:           function() { return this._fields.binaryVersion; },

	/**
	 * Return the build date for the currently running ngCore binary. The build date is in the format <i>YYYYMMDD</i>.
	 * @returns {String} The build date for the ngCore binary
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getBinaryBuildDate:           function() { return this._fields.binaryBuildDate; },

	/**
	 * Return the build hash of the currently running ngCore binary
	 * @returns {String} The build hash for the ngCore binary
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getBinaryBuildHash:           function() { return this._fields.binaryBuildHash; },
	
	/**
	 * Return the device ID. 
	 * @returns {String} The device ID for the device running the application.
	 * @type String
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getUniqueId:           function() { return this._fields.uniqueId; },

	/**
	 * Return the lifetime constant value of the device.<br><br>
	 * <b>Note:</b> Currently only available on Android.
	 * @returns {String} <code>Settings.Secure.ANDROID_ID</code>: A 64-bit number as a hex string randomly generated on first boot of the device. 
	 * <b>Note:</b> This value only changes when the device is reset.
	 * @status Android
	 */
	getLifetimeName: function() { return this._fields.lifetimeName; },
	
	/**
	 * Return the device name.
	 * @returns {String} The device name for the device running the application.
	 * @type String
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getDeviceName:         function() { return this._fields.deviceName; },
	
	/**
	 * Return the operating system.
	 * @returns {String} The operating system of the device running the application.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getPlatformOS:         function() { return this._fields.platformOs; },
	
	/**
	 * Return the operating system version number.
	 * @returns {String} The version number of the operating system running on the device.
	 * @type String
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getPlatformOSVersion:  function() { return this._fields.platformOsVersion; },
	
	/**
	 * Return the device hardware type.
	 * @returns {String} The type of device hardware running the application.
	 * @type String
	 * @status iOS, Flash, Test, iOSTested, AndroidTested
	 */
	getPlatformHW:         function() { return this._fields.platformHw; },
	
	/**
	 * Return the total amount of installed memory.
	 * @returns {Number} The amount of installed memory on the device running the application.
	 * @type Number
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getPhysicalMem:        function() { return this._fields.physicalMem; },
	
	/**
	 * Return the total number of installed CPUs.
	 * @returns {Number} The number of CPUs installed on the device running the application.
	 * @type Number
	 * @status iOS, Test, iOSTested, AndroidTested
	 */
	getPhysicalCpus:       function() { return this._fields.physicalCpus; },
	
	/**
	 * Return the number of active CPUs.
	 * @returns {Number} The number of active CPUs on the device running the application.
	 * @type Number
	 * @status iOS, Test, iOSTested, AndroidTested
	 */
	getActiveCpus:         function() { return this._fields.activeCpus; },
	
	/**
	 * Return the installed user language. 
	 * @returns {String} The installed user language on the device running the application.
	 * Expressed as a canonicalized IETF BCP 47 language identifier.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLanguage:         function() { return this._fields.language; },

	_getBoot:         function() { return this._fields.boot; },
	_getBootServer:         function() { return this._fields.bootServer; },

	/**
	 * Return the URL for the content of this application.
	 * @returns {String} The URL to content for this application.
	 * @status
	 */
	getContentUrl:			function() {return this._fields.contentUrl;},

	/**
	 * Return the name of the root application. Root application refers to the application that launches when the user taps the application icon.
	 * @returns {String} The directory name for the root application.
	 * @status
	 */
	getBootGame:         function() { return this._fields.bootgame; },

	/**
	 * Return the starting server for an application.
	 * @returns {String} The start server.
	 * @type String
	 * @status
	 */
	getStartingServer:         function() { return this._fields.startingServer; },

	/**
	 * Return the name of the application bundled with the binary of this build.
	 * @returns {String} The name of the bundled game.
	 * @type String
	 * @status
	 */
	getBundleGame:         function() { return this._fields.bundleGame; },

	/**
	 * Return the server bundled with the binary of this build.
	 * @returns {String} The bundle server.
	 * @type String
	 * @status
	 */
	getBundleServer:         function() { return this._fields.bundleServer; },

	/**
	 * Return the bundle identifier for the binary of this build.
	 * @returns {String} The bundle identifier.
	 * @type String
	 * @status
	 */
	getBundleIdentifier:         function() { return this._fields.bundleIdentifier; },
	
	/**
	 * Return the directory name of the currently running application.
	 * @returns {String} The current folder name for the application.
	 * @type String
	 * @status iOS, Android, Flash
	 */
	getGame:         function() { return this._fields.game; },

	/**
	 * Return the server from which an application was downloaded.
	 * @returns {String} The download server.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getServer:         function() { return this._fields.server; },

	/**
	 * Return the full URL for the current application.
	 * @returns {String} The URL from which a application is downloaded.
	 * @type String
	 * @status
	 */
	getUrl:         function() { return this._fields.url; },

	/**
	 * Return the logical screen width for this device.
	 * @returns {Number} The current screen width of the device.
	 * @type Number
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getScreenWidth:        function() { return this._fields.screenWidth; },
	
	/**
	 * Return the logical screen height for this device.
	 * @returns {Number} The current screen height of the device.
	 * @type Number
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getScreenHeight:       function() { return this._fields.screenHeight; },
	
	/**
	 * Return a reasonable factor for scaling logical coordinates to the current display.
	 * @returns {Number} Logically scaled screen units for the device.
	 * @type Number
	 * @status
	 */
	getScreenUnits:        function() { return this._fields.screenUnits; },
	
	/**
	 * Return the number of physical pixels associated with one unit of logical space.
	 * @returns {Number} The total number of pixels that equal one screen unit.
	 * @type Number
	 * @status
	 */
	getScreenPixelUnits:       function() { return this._fields.screenPixelUnits; },
	
	/**
	 * Return the maximum number of supported textures.
	 * @returns {Number} The maximum number of supported textures per coordinate (<i>x</i>,<i>y</i>).
	 * @type Number
	 * @status Test, iOSTested, AndroidTested
	 */
	getMaxTextureSize:     function() { return this._fields.maxTextureSize; },
	
	/**
	 * Return the maximum number of supported texture units.
	 * @returns {Number} The maximum number of supported texture units per coordinate (<i>x</i>,<i>y</i>).
	 * @type Number
	 * @status Test, iOSTested, AndroidTested
	 */
	getMaxTextureUnits:    function() { return this._fields.maxTextureUnits; },
	
	/**
	 * @deprecated Replaced by {@link UI.GLView#getGLExtensions}.
	 */
	getOglExtensions:      function()
	{
		if (this._fields.oglExtensions)
			return this._fields.oglExtensions;

		// This table should stay in sync with:
		// https://spreadsheets.google.com/a/ngmoco.com/spreadsheet/ccc?key=0AinqDSqLOjJtdDMwNGk0eDgtRFdvQ2N0eWRUcGlsc0E&hl=en_US&authkey=CMWLyoAC
		switch (this._fields.deviceName)
		{
			case "Droid":                // Motorola Droid
			case "DROID2":               // Motorola Droid 2
			case "DROIDX":               // Motorola Droid X
			case "SGH-T959":             // Samsung Galaxy S 19000 8GB
			case "SGH-T959V":            // Samsung Galaxy S 4G
			case "SAMSUNG-SGH-I997":     // Samsung Galaxy S2
			case "SAMSUNG-SGH-I897":     // Samsung Captivate
			case "Nexus S":              // Google Nexus S
				return ["GL_IMG_texture_compression_pvrtc"];
			case "HTC Desire":           // HTC Desire GSM
			case "PC36100":              // HTC Evo 4G
			case "ADR6300":              // HTC Droid Incredible
			case "001HT":                // HTC Desire HD
			case "Nexus One":            // Google Nexus One
			case "HTC Glacier":          // HTC myTouch 4G
				return ["GL_AMD_compressed_ATC_texture"];
			default:
				return [];
		}
	},

	/**
	 * Return the directory path to the temp directory for this device.
	 * @returns {String} The directory path to the temp directory on the device.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTmpDir:           function() { return this._fields.tmpDir; },

	/**
	 * Check the <code>Capabilities</code> of this device for an accelerometer.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains an accelerometer.
	 * @type Boolean
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getHasAccel:           function() { return this._fields.hasAccel; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for a gyroscope.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains an gyroscope.
	 * @type Boolean
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getHasGyro:            function() { return this._fields.hasGyro; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for touchscreen input support.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application supports touchscreen input.
	 * @type Boolean
	 * @status iOS, Test, iOSTested, AndroidTested
	 */
	getHasTouch:           function() { return this._fields.hasTouch; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for multi-touch input support.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application supports multi-touch input.
	 * @type Boolean
	 * @status iOS, Test, iOSTested, AndroidTested
	 */
	getHasMultiTouch:      function() { return this._fields.hasMultiTouch; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for a GPS unit.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains a GPS unit.
	 * @type Boolean
	 * @status Android, Test, iOSTested, AndroidTested
	 */
	getHasGps:             function() { return this._fields.hasGps; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for a magnetic compass.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains a magnetic compass.
	 * @type Boolean
	 * @status Android, Test, iOSTested, AndroidTested
	 */
	getHasCompass:         function() { return this._fields.hasCompass; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for a hardware keyboard.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains a hardware keyboard.
	 * @type Boolean
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getHasHwKeyboard:      function() { return this._fields.hasHwKeyboard; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for a <b>Back</b> button.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains a <b>Back</b> button.
	 * @status
	 */
	getHasBackButton:      function() { return this._fields.hasBackButton; },

	/**
	 * Check the <code>Capabilities</code> of this device for a camera.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains a camera.
	 * @type Boolean
	 * @status Test, iOSTested, AndroidTested
	 */
	getHasCamera:          function() { return this._fields.hasCamera; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for access to a wide area network (WAN).
	 * @returns {Boolean} Returns <code>true</code> when the device running the application has access to a WAN.
	 * @type Boolean
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getHasWwan:            function() { return this._fields.hasWwan; },

	/**
	 * Check the <code>Capabilities</code> of this device for access to a Wi-Fi network.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application has access to Wi-Fi.
	 * @type Boolean
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getHasWifi:            function() { return this._fields.hasWifi; },

	/**
	 * Check the <code>Capabilities</code> of this device for access to a Wi-Fi network.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application has access to Wi-Fi.
	 * @status
	 */
	getCarrier:            function() { return this._fields.carrier; },

	/**
	 * Return the URL used to launch this application.
	 * @returns {String} The URL for launching this application. If the application is not launched from a URL, returns an empty string.
	 * @type String
	 * @status
	 */
	getIntentUrl:            function() { return this._fields.intentUrl; },
	
	/**
	 * Return the height of the system status bar.
	 * @returns {Number} The status bar height rounded to the nearest integer (in pixels).
	 * @type Number
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 * @status Android
	*/
     getStatusBarHeight:            function() { return this._fields.statusBarHeight; },
	
	/**
	 * Return the device locale.
	 * @returns {String} The regional location of a device.
	 * The <code>locale</code> string is a combination of ISO 639-1 and ISO 3166-1. For example, <code>en_US</code>, <code>ja_JP</code>.
	 * @type String
	 * @status
	 */
	getLocale: function() { return this._fields.locale; },

	/**
	 * Return a list of installed fonts on this device.
	 * @returns {Array (Strings)} An array of font names installed on the system or addressable by name.
	 * @type Array
	 * @status iOS, Android
	 */
	getAvailableFonts: function()
	{
		return this._deserializedFonts || (this._deserializedFonts = JSON.parse(this._fields.availableFonts));
	},
	
	/** @private */
	getAutorotateDisabled: function()
	{
		return this._fields.autorotateDisabled || false;
	},
	

	/**
	 * Return the social server used for this application.
	 * @returns {String} The social server URL. For example, partner.plusplus.com.
	 * @status
	 */	
	getSocialServer: function()
	{
		return this.socialServer;
	},

	/*
	 * Returns the name of the Mobage distribution first installed on the device.
	 * @returns {String} The name of the distribution.
	 */
	getDistributionName: function() 
	{
		return this._fields.distributionName;
	},

	/*
	 * @status
	 */	
	getSourceAppID: function()
	{
		return this._fields.sourceAppID;
	},

	/*
	 * @status Android
	 */	
	getAppSignatures: function()
	{
		return this._fields.appSignatures;
	},
	
	/*
	 * Return the release version of this application.  The value comes directly from the 
	 * configuration.json value for releaseVersion.
	 * @returns {String} The version identifier. For example, 1.1:20110607183748_blf7gety.
	 * @status
	 */
	getAppReleaseVersion: function()
	{
		return this._releaseVersion;
	},
	
	
	/** @private */
	_init: function(dict)
	{
		// parse the dict
		var ifields = [];
		NgParseCommandDictionary(dict, 2, this._fields, ifields);

		try {
			// Change server based on URL passed in
			var items = /(https?:\/\/.+?)\/(.*)/.exec(this._fields.url);
			this._fields.server = items[1];
			this._fields.game  = items[2];
		}
		catch (e)
		{
			NgLogException(e);
		}

		// KJ this is necessary because an empty string passed becomes undefined
		if (!this._fields.intentUrl)
			this._fields.intentUrl = "";

		if (this._fields.oglExtensions)
		try
		{
			this._fields.oglExtensions = JSON.parse(this._fields.oglExtensions);
		}
		catch (e)
		{
			NgLogE("Unable to parse OGL Extensions! " + this._fields.oglExtensions);
			NgLogException(e);
		}

		if (this._fields._accts)
		try
		{
			this._fields._accts = JSON.parse(this._fields._accts);
		}
		catch (e)
		{
			NgLogE("Unable to parse Accounts! " + this._fields._accts);
			NgLogException(e);
		}

		try
		{
			this._configuration = JSON.parse(this._fields.configJSON);
			this._fields.contentUrl = this._configuration.contentUrl;
			this.socialServer = this._configuration.socialServer;
			this._releaseVersion = this._configuration.releaseVersion;
		}
		catch (e)
		{
			NgLogE("Unable to parse config!! (" + this._fields.configJSON + ")");
			NgLogException(e);
		}

		console.log( "dict : JS version : " + this.getSDKVersion() );
		console.log( "dict : JS build date : " + this.getSDKBuildDate() );
		console.log( "dict : JS build hash : " + this.getSDKBuildHash() );

		console.log("dict : contentUrl : " + this._fields.contentUrl);
		console.log("dict : socialServer : " + this.socialServer);
		console.log("dict : releaseVersion : " + this._releaseVersion);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 301
	// Method create = -1
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Capabilities._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Capabilities._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[301] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Proc.appendToCommandString( ":301,-1," + __objectRegistryId  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	

// {{/Wg Generated Code}}
	// This kills the JSLint error for trailing comma (since we can't change the generated code)
	t: 0
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Localization'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Localization'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Localization'] = exports; var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
var FileSystem = require('NGCore/Client/Storage/FileSystem').FileSystem;

var LocalizationEngine = exports.LocalizationEngine = MessageEmitter.subclass(
/** @lends Core.Localization.prototype */
{
	classname: 'Localization',
    
    /**
     * Specifies the directory path to language files this object will load.
     */
    directoryPath:null,
    
    /**
     * Specifies the directory path to a language file for a specific language.
     */
	languageFilePath:null,
    
	/**
	 * @class The <code>Localization</code> class provides applications with access to localized strings.
	 * Applications supply a language code corresponding to a file in <code>Content/Localization/</code> or a JSON object.<br><br> 
     * Loading of dictionary files is an anynchronous process. Applications need to listen for emitted notifications from <code>Localization</code> objects that signal when the language dictionary
     * is modified. When a <code>Localization</code> object emits a notification, localized strings are available to the application (see <code>{@link Core.MessageEmitter#emit}</code>).
	 * @constructs The default constructor.
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Flash
	 */
	initialize: function(directoryPath)
	{
		if(!directoryPath){directoryPath = "./Content/Localization/";}
	    NgLogD("Localization : init ("+directoryPath+")");
	    this.directoryPath = directoryPath;
	    
        this.setLanguage(Capabilities.getLanguage());
	},
    
	/**
	 * Aynchronously load the localization dictionary for the specified language.
     * <br><br>
	 * <b>Notes:</b> 
	 * <ul>
	 * <li>This function looks for the corresponding JSON dictionary file in the <code>Content/Localization</code> directory.
     * For example, <code>Content/Localization/fr.json</code>. If the application cannot load a dictionary, this call has no effect.</li>
     * <li><code>Localization</code> objects emit a notification with the new language string if this call succeeds.</li>
     *</ul>
	 *
	 * @example
	 * Core.Localization.addListener(listener, function()
     * {
     *     listener.label.setText(Core.Localization.getString("Hello World"));
     * });
	 * Core.Localization.setLanguage('es');
	 *
	 * @param {String} language The base name of a JSON dictionary file in <code>./Content/Language</code>.
	 * @see Core.Localization#setDictionary, 
	 * @see Core.MessageListener
	 * @status
	 */    
    setLanguage: function(language)
    {
        var dictionaryPath = this.languageFilePath = this.directoryPath + language + '.json';
        var self = this;
        NgLogD("Localization : reading json file "+ dictionaryPath);
        
		FileSystem.readFile(dictionaryPath, function(error, data)
        {
            if(error === '')
            {
                NgLogD("Localization : successfully read json file "+ dictionaryPath);  
                self.setDictionary(language, JSON.parse(data));
            }
            else
            {
                NgLogD("Localization: unable to read json file "+ dictionaryPath + ", use default english setting instead");                
            }
        });
    },

	/**
	 * Directly set the language code and localization dictionary.
     * <code>Localization</code> objects emit a message with the new language string during this call.
	 * 
	 * @example
     * var chDictionary =    
     * {
     *     "Hello World": "你好世界"
     * };
	 * Core.Localization.setDictionary('ch', chDictionary);
	 * label.setText(Core.Localization.getString("Hello World"));
	 *
	 * @param {String} language A string identifying the specified language or localization.
	 * @param {Object} dictionary An object containing key/value pairs for the specified language.
	 * @see Core.Localization#setLanguage,
	 * @see Core.MessageEmitter#emit
	 * @status
	 */    
    setDictionary: function(lang, dictionary)
    {
        this._lang = lang;
        this._dictionary = dictionary;
        this.emit(this._lang);
    },    
    
    /**
	 * Retrieve a localized string.
     * @param {String} str A localization key.
	 * @returns {String} The localized string or the provided key if the application is unable to lcoate the specified string.
	 * @status
	 */
	getString: function(str)
	{        
        if(this._dictionary && typeof this._dictionary === 'object')
        {
            var value = this._dictionary[str];
            if(value && typeof value !== 'undefined')
            {
                return value;
            }
        }
        
        return this.unknownString(str);
	},
	
	/** @protected */
	unknownString:function(str){
		NgLogD("Localization: ... No localization for "+str+" in "+this._lang);
		return str;
	}
});

/**
 * Global Localization Singleton, gets initialized when the device locale is known.
 */
exports.Localization = LocalizationEngine.singleton({});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Storage'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Storage'] || {}; $MODULE_REGISTRY['NGCore/Client/Storage'] = exports; /**
 * <p>Classes and objects contained by the Storage module.</p>
 * @name Storage
 * @namespace
 * @description <p>The Storage module is a collection of classes that support file manipulation operations.
 * Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 * <ul>
 *  <li><code>{@link Storage.FileSystem}</code>: Construct objects for reading a file, writing to a file, deleting a file, or decompressing a file.</li>
 *  <li><code>{@link Storage.KeyValue}</code>: Construct objects that store key/value pairs.</li>
 * </ul>
 * <b>Note:</b> The static method <code>KeyValueCache.global()</code> creates a <code>KeyValueCache</code> object that multiple applications can use. 
 * @param {String} globalKey The module name for the <code>KeyValueCache</code> object. The <code>global()</code> method creates a new <code>KeyValueCache</code> 
 * when the module with that name doesn't already exist.
 */
var Storage = exports.Storage = {};

Storage.__defineGetter__("KeyValue", function() {
	delete this.KeyValue;
	return this.KeyValue = require('NGCore/Client/Storage/KeyValue').KeyValue;
});
Storage.__defineGetter__("KeyValueCache", function() {
	delete this.KeyValueCache;
	return this.KeyValueCache = require('NGCore/Client/Storage/KeyValue').KeyValueCache;
});
Storage.__defineGetter__("FileSystem", function() {
	delete this.FileSystem;
	return this.FileSystem = require('NGCore/Client/Storage/FileSystem').FileSystem;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Logger'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Logger'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Logger'] = exports; var Class = require('NGCore/Client/Core/Class').Class;
var Proc = require('NGCore/Client/Core/Proc').Proc;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var sprintf = require('NGCore/Shared/Lib/sprintf').sprintf;
var Base64 = require('NGCore/Client/Core/Base64').Base64;

var Logger = Class.singleton(
/** @lends Core.Logger.prototype */
{
	classname: 'Logger',

	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},

	/** @private */
	_disable: function()
	{
		console.log("Logger : javascript logging disabled");
		console.log = Logger.log = function(message, argv) {};
	},

	_enable: function()
	{
		console.log = Logger.log = function(message, argv)
		{
			if (arguments.length > 1) {
				try {
					var params = new Array();
					for (var i = 0; i < arguments.length; ++i) {
						params[i] = arguments[i];
					}
					var result = sprintf(params);
					params.unshift(result);
					message = params.join(" ");
				} catch (err) {
					var concat = new Array();
					for (var i = 0; i < arguments.length; ++i) {
						concat[i] = arguments[i];
					}
					message = concat.join(" ");
				}
			}
			__underscore_SysLog(message);
		};

		console.log("Logger : javascript logging enabled");
	},

	/**
	 * Log a message to the development console.
	 * @param {string} message
	 * @param {Array} argv Additional arguments to log.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	log: function(message, argv)
	{
		
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 305
	// Method create = -1
	// Method log = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Logger._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Logger._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[305] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Proc.appendToCommandString( ":305,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_logSendGen: function( msg )
	{
		Proc.appendToCommandString( ":305,2," + this.__objectRegistryId + "," + Base64.encode( msg )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// log: function( msg ) {}
	

// {{/Wg Generated Code}}
	
});

Logger.instantiate();

__underscore_SysLog = function(_massage)
{
	Logger._logSendGen( _massage );
};

// JMarr Don't override console.log when on flash.
if(typeof(_NG_TARGET_FLASH) == 'undefined')
	console.log = Logger.log;

exports.Logger = Logger;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Class'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Class'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Class'] = exports; exports.Class = require('NGCore/Shared/Class').Class;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Base64'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Base64'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Base64'] = exports; exports.Base64 = require('NGCore/Shared/Lib/base64').Base64;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Plus/ResultSet'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Plus/ResultSet'] || {}; $MODULE_REGISTRY['NGCore/Client/Plus/ResultSet'] = exports; var ClassReq = require('NGCore/Client/Core/Class');
var SystemBindingReq = require('NGCore/Client/UI/SystemBinding');

var ResultSet = ClassReq.Class.subclass({
    classname: "ResultSet",
    initialize: function(continueId) {
        this.items = [];
        this._continueId = continueId;
        this.totalLength = Number.MAX_VALUE;
    },
    /*
	 * Call to getMore adds more items to items list.
	 * Please note that in the callback, it is possible that addedCount == 0
	 * in some cases.  In that case access to items[newIdx] does not yield
	 * any result
	 */
    getMore: function(cb) {
        return SystemBindingReq.SystemBinding._getMoreContacts(this, cb);
    },
    /*
	 * Releases resource used by current ResultSet.
	 *
	 * To avoid resource leakage, please call closeResultSet if getMore
	 * is not called all the way to the end.
	 */
    closeResultSet: function() {
        SystemBindingReq.SystemBinding._closeContactsResultSet(this);
    }
});

exports.ResultSet = ResultSet;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Class'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Class'] || {}; $MODULE_REGISTRY['NGCore/Shared/Class'] = exports; /**
 * The default constructor.
 * @constructor 
 * @class The <code>Class</code> object provides an environment for Object Oriented Programming (OOP) development in Javascript, such as Java or C++.
 * @name Core.Class
 */
var Class = function() {}
exports.Class = Class;

/**
 * Create a new class by extending another class.
 * @example
 * var MyClass = Class.subclass(
 * {
 *    initialize: function()
 *    {
 *        console.log('constructor');
 *    },
 *    foo: function(v)
 *    {
 *        console.log('MyClass.foo(' + v + ')');
 *    },
 * });
 * var myClass = new MyClass();
 * myClass.foo('param');
 * @param {Object} extensions Object literal containing new functions for the derived class.
 * @function
 * @name Core.Class.subclass
 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
 */
Class.subclass = (function()
{
/**#@+ @ignore */
	// Parse a function body and extract the parameter names.
	function argumentNames(body)
	{
		var names = body.toString().match(/^[\s\(]*function[^(]*\(([^)]*)\)/)[1]
			.replace(/\/\/.*?[\r\n]|\/\*(?:.|[\r\n])*?\*\//g, '')
			.replace(/\s+/g, '').split(',');
		return names.length == 1 && !names[0] ? [] : names;
	}
	
	// Create a function that calls overrideBody with a closure to ancestorBody.
	function overrideMethod(overrideBody, ancestorBody)
	{
		if(ancestorBody !== undefined)
		{
			// Create a function that calls overrideBody with a closure to ancestorBody as the first param.
			var override = function()
			{
				var localThis = this;
				var $super = function() { return ancestorBody.apply(localThis, arguments) };
				Array.prototype.unshift.call(arguments, $super);
				return overrideBody.apply(this, arguments);
			}
		}
		else
		{
			// Create a function that calls overrideBody with undefined as the first param, because ancestorBody is undefined.
			var override = function()
			{
				Array.prototype.unshift.call(arguments, undefined);
				return overrideBody.apply(this, arguments);
			}
		}

		// Hide our dirty tricks from the rest of the world.
		override.valueOf = function() { return overrideBody.valueOf() };
		override.toString = function() { return overrideBody.toString() };
		return override;
	}
	
	// Define some empty functions used later. This is a speed optimization.
	function TempClass() {}
	function emptyFunction() {}
	
	return function()
	{
		// Constructor for new class to be created.
		var properties = arguments[0];
		var classname = properties.classname || "AnonymousClass";
		var NewClass = eval('(function ' + classname + '(){this.initialize.apply(this, arguments)})');
		
		// Copy statics from this.
		for(var property in this)
		{
			if(!this.hasOwnProperty(property)) continue;
			NewClass[property] = this[property];
		}
		
		// Copy prototype from this.
		var ancestorPrototype = this.prototype;
		TempClass.prototype = ancestorPrototype;
		NewClass.prototype = new TempClass();
		NewClass.prototype.superclass = ancestorPrototype;
		NewClass.prototype.constructor = NewClass;
		
		// Copy properties into NewClass prototype.
		for(var property in properties)
		{
			if(!properties.hasOwnProperty(property)) continue;

			// getters / setters behave differently than normal properties.
			var getter = properties.__lookupGetter__(property)
			var setter = properties.__lookupSetter__(property)
			if(getter || setter)
			{
				if(getter)
				{
					// Copy getter into klass.
					var value = getter;
					if(argumentNames(value)[0] == "$super")
						value = overrideMethod(value, ancestorPrototype.__lookupGetter__(property));
					NewClass.prototype.__defineGetter__(property, value);
				}

				if(setter)
				{
					// Copy setter into klass.
					var value = setter;
					if(argumentNames(value)[0] == "$super")
						value = overrideMethod(value, ancestorPrototype.__lookupSetter__(property));
					NewClass.prototype.__defineSetter__(property, value);
				}
			}
			else
			{
				var value = properties[property];
				if(typeof value === "function" && property[0] != '$')
				{
					if(argumentNames(value)[0] == "$super")
					{
						// Create override method if first param is $super.
						value = overrideMethod(value, ancestorPrototype[property]);
					}
					else if(property == 'initialize')
					{
						var ancestorInitialize = ancestorPrototype.initialize
						if(ancestorInitialize)
						{
							// Automatically call inherited constructor.
							var derivedInitialize = value;
							value = function()
							{
								ancestorInitialize.apply(this, arguments);
								derivedInitialize.apply(this, arguments);
							};
						}
					}
					else if(property == 'destroy')
					{
						var ancestorDestroy = ancestorPrototype.destroy
						if(ancestorDestroy)
						{
							// Automatically call inherited destructor.
							var derivedDestroy = value;
							value = function()
							{
								derivedDestroy.apply(this, arguments);
								ancestorDestroy.apply(this, arguments);
							};
						}
					}

					// Copy function into new class prototype.
					NewClass.prototype[property] = value;
				}
				else
				{
					if(property[0] == '$')
						property = property.slice(1);

					// Copy enum into new class and the prototype.
					NewClass[property] = value;
					NewClass.prototype[property] = value;
				}
			}
		}
		
		// Make sure the is an initialize function.
		if(!NewClass.prototype.initialize)
			NewClass.prototype.initialize = emptyFunction;

		return NewClass;
	}
/**#@-*/
})();

/**
 * Create a singleton by extending a class.
 * @example
 * var MySingleton = Class.singleton(
 * {
 *    initialize: function()
 *    {
 *        console.log('constructor');
 *    },
 *    foo: function(v)
 *    {
 *        console.log('MyClass.foo(' + v + ')');
 *    },
 * });
 * MySingleton.foo('param');
 * @param {Object} extensions Object literal containing new functions for the singleton.
 * @function
 * @name Core.Class.singleton
 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
 */
Class.singleton = function()
{
	// Create sublcass as normal.
	var tempClass = this.subclass.apply(this, arguments);
	
	// Hide the initialize.
	var initialize = tempClass.prototype.initialize;
	tempClass.prototype.initialize = function() {};
	
	// Now instantiate.
	var instance = new tempClass();
	
	// Hide every prototype function with an instance function that calls initialize.
	var functions = [];
	/** 
	 * Ensure that the singleton has been created and fully initialized.
	 * @status iOS, Android, Flash
	*/
	var instantiate = function(real)
	{
		// Delete all of the instance functions we added.
		for(var i in functions)
		{
			var func = functions[i];
			delete instance[func];
		}
		
		// Restore the initialize function and call it.
		instance.initialize = initialize;
		instance.initialize();
		
		// Replace instantiate method with an empty function.
		instance.instantiate = function() {};
		
		// Call the function that caused this instantiation.
		var args = Array.prototype.slice.call(arguments, 1);
		return real.apply(instance, args);
	}
	
	// Iterate over all prototype functions.
	for(var i in instance)
	{
		// Don't do anything for setters or getters.
		if(instance.__lookupGetter__(i)
			|| instance.__lookupSetter__(i))
		{
			//TODO Should put proxies here too.
			continue;
		}
			
		var value = instance[i];
		if(typeof(value) == 'function')
		{
			// Remember the function names that we added so that instantiate() can remove them.
			functions.push(i);
			
			// Add an instance function to hide the prototype function, which will call instantiate.
			instance[i] = instantiate.bind(this, value);
		}
	}
	
	// Add instantiate method.
	instance.instantiate = instantiate.bind(this, function() {});
	
	// Return the isntance.
	return instance;
}

/**
 * @ignore
 */
Class.prototype.bind = function(func)
{
	var context = this;
	if(arguments.length < 2)
	{
		// Fast path if only the 'this' pointer is being bound.
		return function()
		{
			return func.apply(context, arguments);
		}
	}
	else
	{
		// Slower path if additional parameters are being bound.
		var args = Array.prototype.slice.call(arguments, 1);
		return function()
		{
			var finalArgs = args.concat(Array.prototype.slice.call(arguments, 0));
			return func.apply(context, finalArgs);
		}
	}
}

/**
 * @ignore
 */
Class.prototype.toString = function()
{
	return this.constructor.name;
}

// Debug implementation that will replace every method in destroyed objects with a grenade.
/*Class.prototype.destroy = function()
{
	function suicide()
	{
		throw new Error('Function called on destroyed object');
	}
	
	for(var i in this)
	{
		var value = this[i];
		if(typeof(value) == 'function')
		{
			this[i] = suicide;
		}
	}
}*/
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Lib/base64'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Lib/base64'] || {}; $MODULE_REGISTRY['NGCore/Shared/Lib/base64'] = exports; /**
* @description
* Takes a string and encodes or decodes base-64.
* @class Base64
* @see http://coderepos.org/share/browser/lang/javascript/Base64/trunk/base64.js
*
**/

/*
 * $Id: base64.js,v 1.1 2009/03/01 22:38:45 dankogai Exp dankogai $
 *
 * History:
 *   dankogai's original: character-based
 *   drry's fix: split string to array then join
 *   new version: regexp-based
 */

var Base64 = (function() {
    var b64chars
        = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
    var b64tab = function(bin){
        var t = {};
        for (var i = 0, l = bin.length; i < l; i++) {
            t[bin.charAt(i)] = i;
        }
        return t;
    }(b64chars);

    var fromCharCode = String.fromCharCode;

    var sub_toBase64 = function(m){
        var n = (m.charCodeAt(0) << 16)
              | (m.charCodeAt(1) <<  8)
              | (m.charCodeAt(2)      );
        return b64chars.charAt( n >>> 18)
             + b64chars.charAt((n >>> 12) & 63)
             + b64chars.charAt((n >>>  6) & 63)
             + b64chars.charAt( n         & 63);
    };

    var toBase64 = function(bin){
        if (bin.match(/[^\x00-\xFF]/)) {
            throw 'unsupported character found';
        }
        var padlen = 0;
        while(bin.length % 3) {
            bin += '\x00';
            padlen++;
        }
        var b64 = bin.replace(/[\x00-\xFF]{3}/g, sub_toBase64);
        if (!padlen) return b64;
        b64 = b64.substr(0, b64.length - padlen);
        while(padlen--) b64 += '=';
        return b64;
    };

    // use native btoa() if it exists
    var _btoa = typeof(btoa) !== "undefined" ? btoa : toBase64;

    var sub_fromBase64 = function(m){
            var n = (b64tab[ m.charAt(0) ] << 18)
                |   (b64tab[ m.charAt(1) ] << 12)
                |   (b64tab[ m.charAt(2) ] <<  6)
                |   (b64tab[ m.charAt(3) ]);
        return fromCharCode(  n >> 16 )
            +  fromCharCode( (n >>  8) & 0xff )
            +  fromCharCode(  n        & 0xff );
    };

    var fromBase64 = function(b64){
        b64 = b64.replace(/[^A-Za-z0-9\+\/]/g, '');
        var padlen = 0;
        while(b64.length % 4){
            b64 += 'A';
            padlen++;
        }
        var bin = b64.replace(/[A-Za-z0-9\+\/]{4}/g, sub_fromBase64);
        bin.length -= [0,0,2,1][padlen];
        return bin;
    };

    // use native atob() if it exists
    var _atob = typeof(atob) !== "undefined" ? atob : fromBase64;

    var re_char_nonascii = /[^\x00-\xFF]/g;

    var sub_char_nonascii = function(m){
        var n = m.charCodeAt(0);
        return n < 0x800 ? fromCharCode(0xc0 | (n >>>  6))
                         + fromCharCode(0x80 | (n & 0x3f))
            :              fromCharCode(0xe0 | ((n >>> 12) & 0x0f))
                         + fromCharCode(0x80 | ((n >>>  6) & 0x3f))
                         + fromCharCode(0x80 |  (n         & 0x3f))
            ;
    };

    var utob = function(uni){
        return uni.replace(re_char_nonascii, sub_char_nonascii);
    };

    var re_bytes_nonascii
        = /[\xC0-\xDF][\x80-\xBF]|[\xE0-\xEF][\x80-\xBF]{2}|[\xF0-\xF7][\x80-\xBF]{3}/g;

    var sub_bytes_nonascii = function(m){
        var c0 = m.charCodeAt(0);
        var c1 = m.charCodeAt(1);
        if(c0 < 0xe0){
            return fromCharCode(((c0 & 0x1f) << 6) | (c1 & 0x3f));
        }else{
            var c2 = m.charCodeAt(2);
            return fromCharCode(
                ((c0 & 0x0f) << 12) | ((c1 & 0x3f) <<  6) | (c2 & 0x3f)
            );
        }
    };

    var btou = function(bin){
        return bin.replace(re_bytes_nonascii, sub_bytes_nonascii);
    };
    return {
        fromBase64:fromBase64,
        toBase64:toBase64,
        atob:_atob,
        btoa:_btoa,
        utob:utob,
        btou:btou,
        /**
        * @description
        * Takes an input value and returns a base-64 encoded string.
        * @name Base64.encode
        * @function
        * @param String input The input to return as a base-64 encoded string.
        * @return String A base-64 encoded string of the input parameter.
        */
        encode:function(u){
            if(!u) {
                return "";
            }
            return _btoa(utob(new String(u)));
        },
        decode:function(a){
            if(!a) {
                return "";
            }
            return btou(_atob(a.replace(/[\-_]/g, function(m0){
                return m0 == '-' ? '+' : '/';
            })));
        }
    };
})();

exports.Base64 = Base64;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Commands'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Commands'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Commands'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class Commands
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

function UIAnimationOptions() {
	this.animationCurve = "EaseInOut";
	return this;
}

var Commands = exports.Commands = Core.Class.singleton(
/** @lends UI.Commands.prototype */
{
	/**
	 * @name UI.Commands
	 * @class 
	 * @augments Core.Class
	 */
	/** 
	 * @field
	 */
	classname: 'Commands',
	
	/**
	 * @constructs
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this.initializeNative(this.__objectRegistryId);
		this._tempCBs = {};
		this._tempCBCount = 0;
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
			* Enumeration for image fit modes.
			* Image Fit is always applied relative to view bounds *after* content insets are applied.
			* @namespace
			 */
	FitMode:
	{ 
		/** The image content is not scaled at all. */
		None: 0,
		/** The image will be aspect-scaled to fit completely within the view. */
		Inside: 1,
		/** The image will be aspect-scaled to cover the entire view bounds. Clipping may occur. */
		Fill: 2,
		/** The image will be distorted to cover the exact view bounds. */
		Stretch: 3,
		/** The image will be aspect-scaled so its width matches the view bounds. Clipping may occur. */
		AspectWidth: 5,
		/** The image will be aspect-scaled so its height matches the view bounds. Clipping may occur. */
		AspectHeight: 6,
		/** The image will be scaled down to fit completely within the view, but not upscaled. */
		InsideNoUpscaling: 7,
	},
	
	/** 
			* Enumeration for supported units for dimensions.
			* Math.round() is your friend. Sending decimal pixel coordinates can result in unpredictable behavior on various platforms, but half- and quarter-pixels can be useful tools on iOS.
			* @namespace
			 */
	Scaling:
	{ 
		/** The native format, and the default for view bounds. No conversion will be performed. */
		Pixels: 0,
		/** Adjusted to roughly one typesetting point, downscaled from 72 to 160 dpi. */
		Points: 1,
		/** 1.0 represents 100% of the provided or implied size (usually a view width or height). */
		Unit: 2,
		/** A percentage of the provided or implied size (typically from 0 to 100). */
		Percent: 3,
		/** At this scale, the device's screen is always 320 units wide. */
		iPhone: 4,
	},
	
	/** 
			* Enumeration for text font styles.
			* @namespace
			 */
	FontStyle:
	{ 
		/** * */
		Normal: 0,
		/** * */
		Bold: 1,
		/** * */
		Italic: 2,
		/** * */
		BoldItalic: 3,
	},
	
	/** 
			* Flags for control / view states. Used in View and its subclasses.
			* When setting content and properties for states, the value with the highest id when AND'ed with the current state, but no additional bits, will be used.
			* @namespace
			 */
	State:
	{ 
		/** The view is in an unexceptional state. */
		Normal: 0x00,
		/** * */
		Focused: 0x01,
		/** * */
		Selected: 0x02,
		/** * */
		Pressed: 0x04,
		/** * */
		Checked: 0x08,
		/** * */
		Custom: 0x00FF0000,
		/** * */
		Disabled: 0x40000000,
	},
	
	/** 
			* Enumeration for Enter Key Behavior in editable text fields.
			* @namespace
			 */
	EnterKeyType:
	{ 
		/** * */
		Return: 0,
		/** * */
		Done: 1,
		/** * */
		Next: 2,
		/** * */
		Submit: 3,
		/** * */
		Go: 4,
		/** * */
		Search: 5,
		/** * */
		Send: 6,
	},
	
	/** 
			* Enumeration for Input Types for editable text fields.
			* @namespace
			 */
	InputType:
	{ 
		/** * */
		None: 0,
		/** * */
		TextWithCorrection: 1,
		/** * */
		Password: 2,
		/** * */
		Numeric: 4,
		/** * */
		Email: 5,
		/** * */
		URL: 6,
		/** * */
		Date: 7,
		/** * */
		ANDROID_LANDSCAPE_FULLSCREEN: 8,
	},
	
	/** 
			* Arrangement of combinations of text and images for buttons. When stacked, the button rect will be divided proportionally into two rects that completely cover the button. Gravity will apply to the image and text within their rects.
			* @namespace
			 */
	ButtonLayout:
	{ 
		/** The view is in an unexceptional state. */
		CenterTextOver: 0,
		/** * */
		StackImageLeft: 1,
		/** * */
		StackImageTop: 2,
		/** * */
		StackImageRight: 3,
		/** * */
		StackImageBottom: 4,
		/** * */
		CenterImageOver: 5,
	},
	
	/** 
			* Describes what direction a user swiped during a swipe callback.
			* @see UI.AbstractView#setOnSwipe
			* @namespace
			 */
	SwipeDirection:
	{ 
		/** * */
		Left: 1,
		/** * */
		Right: 2,
		/** * */
		Up: 3,
		/** * */
		Down: 4,
	},
	
	///////
	// Class Summary and Generated Constants (for internal use only):
	// Class ID = 337
	// Method -1: _initializeNative ( int reservedId )
	// Method -2: _create ( int newObjectId, str className )
	// Method 3: _destroy (  )
	// Method 4: _setActive ( bool active )
	// Method 5: _setTouchable ( bool touchable )
	// Method 6: _enableEvent ( str eventName )
	// Method 7: _disableEvent ( str eventName )
	// Method -8: _eventOccurred ( json eventObject )
	// Method 9: _setIsVisible ( bool visible )
	// Method 10: _setEnabled ( bool enable )
	// Method 11: _setState ( int state )
	// Method 12: _addSubview ( int __objectRegistryId, int index )
	// Method 13: _removeFromSuperview (  )
	// Method -14: _startAnimation ( int durationMs, str callbackId )
	// Method -15: _executeAnimation ( json options )
	// Method 16: _setFrame ( float x, float y, float w, float h )
	// Method 17: _setOrigin ( float x, float y )
	// Method 18: _setAnchor ( float x, float y )
	// Method 19: _setSize ( float w, float h )
	// Method 20: _setTransform ( float a, float b, float c, float d, float tx, float ty )
	// Method 21: _setBackgroundColor ( str color )
	// Method 22: _setImage ( int state, str imageURL )
	// Method 23: _setImageBorder ( int state, json gradientJSON )
	// Method 24: _setImageFitMode ( int fitMode )
	// Method 25: _setImageGravity ( float x, float y )
	// Method 26: _setImageOrigin ( float x, float y )
	// Method 27: _setImageAnchor ( float x, float y )
	// Method 28: _setImageSize ( float w, float h )
	// Method 29: _setImageInsets ( float t, float r, float b, float l )
	// Method 30: _setImageTransform ( float a, float b, float c, float d, float tx, float ty )
	// Method 31: _setText ( int state, str text )
	// Method 32: _setTextColor ( int state, str text )
	// Method 33: _setTextFont ( int state, str fontName )
	// Method 34: _setTextShadow ( int state, str shadow )
	// Method 35: _setTextSize ( float textFontSize )
	// Method 36: _setTextGravity ( float x, float y )
	// Method 37: _setTextInsets ( float t, float r, float b, float l )
	// Method 38: _setTextOverflow ( int overflowMode )
	// Method 39: _setTextMaxLines ( int maxLines )
	// Method 40: _setTextMinSize ( float minSize )
	// Method 41: _setTitle ( int state, str title )
	// Method 42: _setTitleColor ( int state, str title )
	// Method 43: _setTitleFont ( int state, str fontName )
	// Method 44: _setTitleShadow ( int state, str shadow )
	// Method 45: _setTitleSize ( float titleFontSize )
	// Method 46: _setTitleGravity ( float x, float y )
	// Method 47: _setTitleInsets ( float t, float r, float b, float l )
	// Method 48: _setTitleOverflow ( int overflowMode )
	// Method 49: _setTitleMaxLines ( int maxLines )
	// Method 50: _setTitleMinSize ( float minSize )
	// Method 51: _setGradient ( int state, json gradientJSON )
	// Method 52: _setStringValue ( str value )
	// Method 53: _setFloatValue ( float value )
	// Method 54: _setIntValue ( int value )
	// Method 55: _setBoolValue ( bool value )
	// Method 56: _setButtonLayout ( int layoutType )
	// Method 57: _setContentInsets ( float t, float r, float b, float l )
	// Method 58: _setBarGradient ( int state, json gradientJSON )
	// Method 59: _setPlaceholderText ( str placeholder )
	// Method 60: _setPlaceholderTextColor ( str color )
	// Method 61: _setPlaceholderTextShadow ( str shadow )
	// Method 62: _setEnterKeyType ( int enterKeyType )
	// Method 63: _setInputType ( int inputType )
	// Method 64: _setChecked ( bool checked )
	// Method 65: _setScrollPosition ( float x, float y )
	// Method 66: _setScrollableSize ( float w, float h )
	// Method 67: _setSections ( json idArray )
	// Method 68: _setTitleView ( int titleObjectID )
	// Method 69: _setSourceDocument ( str documentURL )
	// Method 70: _setChoices ( json stringArray, int defaultChoiceIndex, int cancelChoiceIndex )
	// Method 71: _show (  )
	// Method 72: _hide (  )
	// Method 73: _setPostData ( str data )
	// Method 74: _loadPostURL ( str url )
	// Method 75: _loadGetURL ( str url )
	// Method 76: _loadURL ( str url, json headers, float timeout )
	// Method 77: _stopLoading (  )
	// Method 78: _reload (  )
	// Method 79: _invoke ( str script )
	// Method 80: _goBack (  )
	// Method 81: _goForward (  )
	// Method 82: _setBasicAuthCredentials ( json credentials )
	// Method 83: _setRightImage ( int state, str rightImageURL )
	// Method 84: _setRightImageBorder ( int state, json gradientJSON )
	// Method 85: _setRightImageFitMode ( int fitMode )
	// Method 86: _setRightImageGravity ( float x, float y )
	// Method 87: _setRightImageOrigin ( float x, float y )
	// Method 88: _setRightImageAnchor ( float x, float y )
	// Method 89: _setRightImageSize ( float w, float h )
	// Method 90: _setRightImageInsets ( float t, float r, float b, float l )
	// Method 91: _setRightImageTransform ( float a, float b, float c, float d, float tx, float ty )
	// Method -92: _setStatusBarHidden ( bool statusBarStatus )
	// Method 93: _pauseAds (  )
	// Method 94: _resumeAds (  )
	// Method 95: _setAdRefreshRate ( int refreshRate )
	// Method 96: _setAdAllowAutoplay ( bool autoplay )
	// Method 97: _setAlpha ( float alpha )
	// Method 98: _postURL ( str url, str data )
	// Method 99: _setProgressGradient ( int state, json gradientJSON )
	// Method 100: _setSecondaryGradient ( int state, json gradientJSON )
	// Method 101: _setProgress ( float progress, float secondaryProgress )
	// Method 102: _useForUpdateProgress ( bool use )
	// Method 103: _setDarkStyle ( bool use )
	// Method -104: _doCompositeImages ( int w, int h, str filename, json infoArray, str callbackId )
	// Method -105: _REMOVED_doChoosePhoto ( int w, int h, str filename, json options, str callbackId )
	// Method -106: _doChooseCamera ( int w, int h, str filename, json options, str callbackId )
	// Method 107: _setScrollable ( bool enabled )
	// Method 108: _setZoomable ( bool enabled )
	// Method 109: _addAnnotation ( int __objectRegistryId )
	// Method 110: _removeAnnotation ( int __objectRegistryId )
	// Method 111: _selectAnnotation ( int __objectRegistryId )
	// Method 112: _setRegion ( float latitude, float longitude, float latitudeDelta, float longitudeDelta, bool animated )
	// Method 113: _setView ( int __objectRegistryId )
	// Method 114: _setCoordinate ( float latitude, float longitude )
	// Method 115: _setCalloutTitle ( str title )
	// Method 116: _setCalloutSubtitle ( str subTitle )
	// Method 117: _setCalloutEnabled ( bool enabled )
	// Method 118: _setCalloutLeftView ( int __objectRegistryId )
	// Method 119: _setCalloutRightView ( int __objectRegistryId )
	// Method 120: _setCenterOffset ( float xOffset, float yOffset )
	// Method -121: _doChoosePhoto ( int w, int h, str filename, json options, str callbackId, int invokingView )
	// Method 122: _setScrollIndicatorsVisible ( bool enabled )
	// Method -123: _measureText ( str string, int w, int h, str font, float fontSize, str callbackId )
	// Method 124: _setFocus ( bool enabled )
	// Method 125: _setViewportEnabled ( bool enabled )
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Commands._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				case -8:
					Commands._eventOccurredRecv( cmd );
					break;
				default:
					NgLogE("Unknown static method id " + cmdId + " in Commands._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[337] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	$_eventOccurredRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Commands.eventOccurred from command: " + cmd );
			return false;
		}
		
		obj[ "eventObject" ] = Core.Proc.parseJSONString( cmd[ 0 ] );
		if( obj[ "eventObject" ] === undefined )
		{
			NgLogE("Could not parse eventObject in Commands.eventOccurred from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$initializeNative: function( reservedId )
	{
		Core.Proc.appendToCommandString( ":337,-1," + reservedId  );
	},
	
	/** @private */
	$create: function( newObjectId, className )
	{
		Core.Proc.appendToCommandString( ":337,-2," + newObjectId + "," + Core.Base64.encode( className )  );
	},
	
	/** @private */
	destroy: function(  )
	{
		Core.Proc.appendToCommandString( ":337,3," + this.__objectRegistryId );
	},
	
	/** @private */
	setActive: function( active )
	{
		Core.Proc.appendToCommandString( ":337,4," + this.__objectRegistryId + "," + ( active ? 1 : 0 )  );
	},
	
	/** @private */
	setTouchable: function( touchable )
	{
		Core.Proc.appendToCommandString( ":337,5," + this.__objectRegistryId + "," + ( touchable ? 1 : 0 )  );
	},
	
	/** @private */
	enableEvent: function( eventName )
	{
		Core.Proc.appendToCommandString( ":337,6," + this.__objectRegistryId + "," + Core.Base64.encode( eventName )  );
	},
	
	/** @private */
	disableEvent: function( eventName )
	{
		Core.Proc.appendToCommandString( ":337,7," + this.__objectRegistryId + "," + Core.Base64.encode( eventName )  );
	},
	
	/** @private */
	setIsVisible: function( visible )
	{
		Core.Proc.appendToCommandString( ":337,9," + this.__objectRegistryId + "," + ( visible ? 1 : 0 )  );
	},
	
	/** @private */
	setEnabled: function( enable )
	{
		Core.Proc.appendToCommandString( ":337,10," + this.__objectRegistryId + "," + ( enable ? 1 : 0 )  );
	},
	
	/** @private */
	setState: function( state )
	{
		Core.Proc.appendToCommandString( ":337,11," + this.__objectRegistryId + "," + state  );
	},
	
	/** @private */
	addSubview: function( __objectRegistryId, index )
	{
		Core.Proc.appendToCommandString( ":337,12," + this.__objectRegistryId + "," + __objectRegistryId + "," + index  );
	},
	
	/** @private */
	removeFromSuperview: function(  )
	{
		Core.Proc.appendToCommandString( ":337,13," + this.__objectRegistryId );
	},
	
	/** @private */
	$startAnimation: function( durationMs, callbackId )
	{
		Core.Proc.appendToCommandString( ":337,-14," + durationMs + "," + Core.Base64.encode( callbackId )  );
	},
	
	/** @private */
	$executeAnimation: function( options )
	{
		Core.Proc.appendToCommandString( ":337,-15," + Core.Base64.encode( JSON.stringify( options ) )  );
	},
	
	/** @private */
	setFrame: function( x, y, w, h )
	{
		Core.Proc.appendToCommandString( ":337,16," + this.__objectRegistryId + "," + x + "," + y + "," + w + "," + h  );
	},
	
	/** @private */
	setOrigin: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,17," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setAnchor: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,18," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setSize: function( w, h )
	{
		Core.Proc.appendToCommandString( ":337,19," + this.__objectRegistryId + "," + w + "," + h  );
	},
	
	/** @private */
	setTransform: function( a, b, c, d, tx, ty )
	{
		Core.Proc.appendToCommandString( ":337,20," + this.__objectRegistryId + "," + a + "," + b + "," + c + "," + d + "," + tx + "," + ty  );
	},
	
	/** @private */
	setBackgroundColor: function( color )
	{
		Core.Proc.appendToCommandString( ":337,21," + this.__objectRegistryId + "," + Core.Base64.encode( color )  );
	},
	
	/** @private */
	setImage: function( state, imageURL )
	{
		Core.Proc.appendToCommandString( ":337,22," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( imageURL )  );
	},
	
	/** @private */
	setImageBorder: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( ":337,23," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( JSON.stringify( gradientJSON ) )  );
	},
	
	/** @private */
	setImageFitMode: function( fitMode )
	{
		Core.Proc.appendToCommandString( ":337,24," + this.__objectRegistryId + "," + fitMode  );
	},
	
	/** @private */
	setImageGravity: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,25," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setImageOrigin: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,26," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setImageAnchor: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,27," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setImageSize: function( w, h )
	{
		Core.Proc.appendToCommandString( ":337,28," + this.__objectRegistryId + "," + w + "," + h  );
	},
	
	/** @private */
	setImageInsets: function( t, r, b, l )
	{
		Core.Proc.appendToCommandString( ":337,29," + this.__objectRegistryId + "," + t + "," + r + "," + b + "," + l  );
	},
	
	/** @private */
	setImageTransform: function( a, b, c, d, tx, ty )
	{
		Core.Proc.appendToCommandString( ":337,30," + this.__objectRegistryId + "," + a + "," + b + "," + c + "," + d + "," + tx + "," + ty  );
	},
	
	/** @private */
	setText: function( state, text )
	{
		Core.Proc.appendToCommandString( ":337,31," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( text )  );
	},
	
	/** @private */
	setTextColor: function( state, text )
	{
		Core.Proc.appendToCommandString( ":337,32," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( text )  );
	},
	
	/** @private */
	setTextFont: function( state, fontName )
	{
		Core.Proc.appendToCommandString( ":337,33," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( fontName )  );
	},
	
	/** @private */
	setTextShadow: function( state, shadow )
	{
		Core.Proc.appendToCommandString( ":337,34," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( shadow )  );
	},
	
	/** @private */
	setTextSize: function( textFontSize )
	{
		Core.Proc.appendToCommandString( ":337,35," + this.__objectRegistryId + "," + textFontSize  );
	},
	
	/** @private */
	setTextGravity: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,36," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setTextInsets: function( t, r, b, l )
	{
		Core.Proc.appendToCommandString( ":337,37," + this.__objectRegistryId + "," + t + "," + r + "," + b + "," + l  );
	},
	
	/** @private */
	setTextOverflow: function( overflowMode )
	{
		Core.Proc.appendToCommandString( ":337,38," + this.__objectRegistryId + "," + overflowMode  );
	},
	
	/** @private */
	setTextMaxLines: function( maxLines )
	{
		Core.Proc.appendToCommandString( ":337,39," + this.__objectRegistryId + "," + maxLines  );
	},
	
	/** @private */
	setTextMinSize: function( minSize )
	{
		Core.Proc.appendToCommandString( ":337,40," + this.__objectRegistryId + "," + minSize  );
	},
	
	/** @private */
	setTitle: function( state, title )
	{
		Core.Proc.appendToCommandString( ":337,41," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( title )  );
	},
	
	/** @private */
	setTitleColor: function( state, title )
	{
		Core.Proc.appendToCommandString( ":337,42," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( title )  );
	},
	
	/** @private */
	setTitleFont: function( state, fontName )
	{
		Core.Proc.appendToCommandString( ":337,43," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( fontName )  );
	},
	
	/** @private */
	setTitleShadow: function( state, shadow )
	{
		Core.Proc.appendToCommandString( ":337,44," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( shadow )  );
	},
	
	/** @private */
	setTitleSize: function( titleFontSize )
	{
		Core.Proc.appendToCommandString( ":337,45," + this.__objectRegistryId + "," + titleFontSize  );
	},
	
	/** @private */
	setTitleGravity: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,46," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setTitleInsets: function( t, r, b, l )
	{
		Core.Proc.appendToCommandString( ":337,47," + this.__objectRegistryId + "," + t + "," + r + "," + b + "," + l  );
	},
	
	/** @private */
	setTitleOverflow: function( overflowMode )
	{
		Core.Proc.appendToCommandString( ":337,48," + this.__objectRegistryId + "," + overflowMode  );
	},
	
	/** @private */
	setTitleMaxLines: function( maxLines )
	{
		Core.Proc.appendToCommandString( ":337,49," + this.__objectRegistryId + "," + maxLines  );
	},
	
	/** @private */
	setTitleMinSize: function( minSize )
	{
		Core.Proc.appendToCommandString( ":337,50," + this.__objectRegistryId + "," + minSize  );
	},
	
	/** @private */
	setGradient: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( ":337,51," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( JSON.stringify( gradientJSON ) )  );
	},
	
	/** @private */
	setStringValue: function( value )
	{
		Core.Proc.appendToCommandString( ":337,52," + this.__objectRegistryId + "," + Core.Base64.encode( value )  );
	},
	
	/** @private */
	setFloatValue: function( value )
	{
		Core.Proc.appendToCommandString( ":337,53," + this.__objectRegistryId + "," + value  );
	},
	
	/** @private */
	setIntValue: function( value )
	{
		Core.Proc.appendToCommandString( ":337,54," + this.__objectRegistryId + "," + value  );
	},
	
	/** @private */
	setBoolValue: function( value )
	{
		Core.Proc.appendToCommandString( ":337,55," + this.__objectRegistryId + "," + ( value ? 1 : 0 )  );
	},
	
	/** @private */
	setButtonLayout: function( layoutType )
	{
		Core.Proc.appendToCommandString( ":337,56," + this.__objectRegistryId + "," + layoutType  );
	},
	
	/** @private */
	setContentInsets: function( t, r, b, l )
	{
		Core.Proc.appendToCommandString( ":337,57," + this.__objectRegistryId + "," + t + "," + r + "," + b + "," + l  );
	},
	
	/** @private */
	setBarGradient: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( ":337,58," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( JSON.stringify( gradientJSON ) )  );
	},
	
	/** @private */
	setPlaceholderText: function( placeholder )
	{
		Core.Proc.appendToCommandString( ":337,59," + this.__objectRegistryId + "," + Core.Base64.encode( placeholder )  );
	},
	
	/** @private */
	setPlaceholderTextColor: function( color )
	{
		Core.Proc.appendToCommandString( ":337,60," + this.__objectRegistryId + "," + Core.Base64.encode( color )  );
	},
	
	/** @private */
	setPlaceholderTextShadow: function( shadow )
	{
		Core.Proc.appendToCommandString( ":337,61," + this.__objectRegistryId + "," + Core.Base64.encode( shadow )  );
	},
	
	/** @private */
	setEnterKeyType: function( enterKeyType )
	{
		Core.Proc.appendToCommandString( ":337,62," + this.__objectRegistryId + "," + enterKeyType  );
	},
	
	/** @private */
	setInputType: function( inputType )
	{
		Core.Proc.appendToCommandString( ":337,63," + this.__objectRegistryId + "," + inputType  );
	},
	
	/** @private */
	setChecked: function( checked )
	{
		Core.Proc.appendToCommandString( ":337,64," + this.__objectRegistryId + "," + ( checked ? 1 : 0 )  );
	},
	
	/** @private */
	setScrollPosition: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,65," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setScrollableSize: function( w, h )
	{
		Core.Proc.appendToCommandString( ":337,66," + this.__objectRegistryId + "," + w + "," + h  );
	},
	
	/** @private */
	setSections: function( idArray )
	{
		Core.Proc.appendToCommandString( ":337,67," + this.__objectRegistryId + "," + Core.Base64.encode( JSON.stringify( idArray ) )  );
	},
	
	/** @private */
	setTitleView: function( titleObjectID )
	{
		Core.Proc.appendToCommandString( ":337,68," + this.__objectRegistryId + "," + titleObjectID  );
	},
	
	/** @private */
	setSourceDocument: function( documentURL )
	{
		Core.Proc.appendToCommandString( ":337,69," + this.__objectRegistryId + "," + Core.Base64.encode( documentURL )  );
	},
	
	/** @private */
	setChoices: function( stringArray, defaultChoiceIndex, cancelChoiceIndex )
	{
		Core.Proc.appendToCommandString( ":337,70," + this.__objectRegistryId + "," + Core.Base64.encode( JSON.stringify( stringArray ) ) + "," + defaultChoiceIndex + "," + cancelChoiceIndex  );
	},
	
	/** @private */
	show: function(  )
	{
		Core.Proc.appendToCommandString( ":337,71," + this.__objectRegistryId );
	},
	
	/** @private */
	hide: function(  )
	{
		Core.Proc.appendToCommandString( ":337,72," + this.__objectRegistryId );
	},
	
	/** @private */
	setPostData: function( data )
	{
		Core.Proc.appendToCommandString( ":337,73," + this.__objectRegistryId + "," + Core.Base64.encode( data )  );
	},
	
	/** @private */
	loadPostURL: function( url )
	{
		Core.Proc.appendToCommandString( ":337,74," + this.__objectRegistryId + "," + Core.Base64.encode( url )  );
	},
	
	/** @private */
	loadGetURL: function( url )
	{
		Core.Proc.appendToCommandString( ":337,75," + this.__objectRegistryId + "," + Core.Base64.encode( url )  );
	},
	
	/** @private */
	loadURL: function( url, headers, timeout )
	{
		Core.Proc.appendToCommandString( ":337,76," + this.__objectRegistryId + "," + Core.Base64.encode( url ) + "," + Core.Base64.encode( JSON.stringify( headers ) ) + "," + timeout  );
	},
	
	/** @private */
	stopLoading: function(  )
	{
		Core.Proc.appendToCommandString( ":337,77," + this.__objectRegistryId );
	},
	
	/** @private */
	reload: function(  )
	{
		Core.Proc.appendToCommandString( ":337,78," + this.__objectRegistryId );
	},
	
	/** @private */
	invoke: function( script )
	{
		Core.Proc.appendToCommandString( ":337,79," + this.__objectRegistryId + "," + Core.Base64.encode( script )  );
	},
	
	/** @private */
	goBack: function(  )
	{
		Core.Proc.appendToCommandString( ":337,80," + this.__objectRegistryId );
	},
	
	/** @private */
	goForward: function(  )
	{
		Core.Proc.appendToCommandString( ":337,81," + this.__objectRegistryId );
	},
	
	/** @private */
	setBasicAuthCredentials: function( credentials )
	{
		Core.Proc.appendToCommandString( ":337,82," + this.__objectRegistryId + "," + Core.Base64.encode( JSON.stringify( credentials ) )  );
	},
	
	/** @private */
	setRightImage: function( state, rightImageURL )
	{
		Core.Proc.appendToCommandString( ":337,83," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( rightImageURL )  );
	},
	
	/** @private */
	setRightImageBorder: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( ":337,84," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( JSON.stringify( gradientJSON ) )  );
	},
	
	/** @private */
	setRightImageFitMode: function( fitMode )
	{
		Core.Proc.appendToCommandString( ":337,85," + this.__objectRegistryId + "," + fitMode  );
	},
	
	/** @private */
	setRightImageGravity: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,86," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setRightImageOrigin: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,87," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setRightImageAnchor: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,88," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setRightImageSize: function( w, h )
	{
		Core.Proc.appendToCommandString( ":337,89," + this.__objectRegistryId + "," + w + "," + h  );
	},
	
	/** @private */
	setRightImageInsets: function( t, r, b, l )
	{
		Core.Proc.appendToCommandString( ":337,90," + this.__objectRegistryId + "," + t + "," + r + "," + b + "," + l  );
	},
	
	/** @private */
	setRightImageTransform: function( a, b, c, d, tx, ty )
	{
		Core.Proc.appendToCommandString( ":337,91," + this.__objectRegistryId + "," + a + "," + b + "," + c + "," + d + "," + tx + "," + ty  );
	},
	
	/** @private */
	$setStatusBarHidden: function( statusBarStatus )
	{
		Core.Proc.appendToCommandString( ":337,-92," + ( statusBarStatus ? 1 : 0 )  );
	},
	
	/** @private */
	pauseAds: function(  )
	{
		Core.Proc.appendToCommandString( ":337,93," + this.__objectRegistryId );
	},
	
	/** @private */
	resumeAds: function(  )
	{
		Core.Proc.appendToCommandString( ":337,94," + this.__objectRegistryId );
	},
	
	/** @private */
	setAdRefreshRate: function( refreshRate )
	{
		Core.Proc.appendToCommandString( ":337,95," + this.__objectRegistryId + "," + refreshRate  );
	},
	
	/** @private */
	setAdAllowAutoplay: function( autoplay )
	{
		Core.Proc.appendToCommandString( ":337,96," + this.__objectRegistryId + "," + ( autoplay ? 1 : 0 )  );
	},
	
	/** @private */
	setAlpha: function( alpha )
	{
		Core.Proc.appendToCommandString( ":337,97," + this.__objectRegistryId + "," + alpha  );
	},
	
	/** @private */
	postURL: function( url, data )
	{
		Core.Proc.appendToCommandString( ":337,98," + this.__objectRegistryId + "," + Core.Base64.encode( url ) + "," + Core.Base64.encode( data )  );
	},
	
	/** @private */
	setProgressGradient: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( ":337,99," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( JSON.stringify( gradientJSON ) )  );
	},
	
	/** @private */
	setSecondaryGradient: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( ":337,100," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( JSON.stringify( gradientJSON ) )  );
	},
	
	/** @private */
	setProgress: function( progress, secondaryProgress )
	{
		Core.Proc.appendToCommandString( ":337,101," + this.__objectRegistryId + "," + progress + "," + secondaryProgress  );
	},
	
	/** @private */
	useForUpdateProgress: function( use )
	{
		Core.Proc.appendToCommandString( ":337,102," + this.__objectRegistryId + "," + ( use ? 1 : 0 )  );
	},
	
	/** @private */
	setDarkStyle: function( use )
	{
		Core.Proc.appendToCommandString( ":337,103," + this.__objectRegistryId + "," + ( use ? 1 : 0 )  );
	},
	
	/** @private */
	$doCompositeImages: function( w, h, filename, infoArray, callbackId )
	{
		Core.Proc.appendToCommandString( ":337,-104," + w + "," + h + "," + Core.Base64.encode( filename ) + "," + Core.Base64.encode( JSON.stringify( infoArray ) ) + "," + Core.Base64.encode( callbackId )  );
	},
	
	/** @private */
	$doChooseCamera: function( w, h, filename, options, callbackId )
	{
		Core.Proc.appendToCommandString( ":337,-106," + w + "," + h + "," + Core.Base64.encode( filename ) + "," + Core.Base64.encode( JSON.stringify( options ) ) + "," + Core.Base64.encode( callbackId )  );
	},
	
	/** @private */
	setScrollable: function( enabled )
	{
		Core.Proc.appendToCommandString( ":337,107," + this.__objectRegistryId + "," + ( enabled ? 1 : 0 )  );
	},
	
	/** @private */
	setZoomable: function( enabled )
	{
		Core.Proc.appendToCommandString( ":337,108," + this.__objectRegistryId + "," + ( enabled ? 1 : 0 )  );
	},
	
	/** @private */
	addAnnotation: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":337,109," + this.__objectRegistryId + "," + __objectRegistryId  );
	},
	
	/** @private */
	removeAnnotation: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":337,110," + this.__objectRegistryId + "," + __objectRegistryId  );
	},
	
	/** @private */
	selectAnnotation: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":337,111," + this.__objectRegistryId + "," + __objectRegistryId  );
	},
	
	/** @private */
	setRegion: function( latitude, longitude, latitudeDelta, longitudeDelta, animated )
	{
		Core.Proc.appendToCommandString( ":337,112," + this.__objectRegistryId + "," + latitude + "," + longitude + "," + latitudeDelta + "," + longitudeDelta + "," + ( animated ? 1 : 0 )  );
	},
	
	/** @private */
	setView: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":337,113," + this.__objectRegistryId + "," + __objectRegistryId  );
	},
	
	/** @private */
	setCoordinate: function( latitude, longitude )
	{
		Core.Proc.appendToCommandString( ":337,114," + this.__objectRegistryId + "," + latitude + "," + longitude  );
	},
	
	/** @private */
	setCalloutTitle: function( title )
	{
		Core.Proc.appendToCommandString( ":337,115," + this.__objectRegistryId + "," + Core.Base64.encode( title )  );
	},
	
	/** @private */
	setCalloutSubtitle: function( subTitle )
	{
		Core.Proc.appendToCommandString( ":337,116," + this.__objectRegistryId + "," + Core.Base64.encode( subTitle )  );
	},
	
	/** @private */
	setCalloutEnabled: function( enabled )
	{
		Core.Proc.appendToCommandString( ":337,117," + this.__objectRegistryId + "," + ( enabled ? 1 : 0 )  );
	},
	
	/** @private */
	setCalloutLeftView: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":337,118," + this.__objectRegistryId + "," + __objectRegistryId  );
	},
	
	/** @private */
	setCalloutRightView: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":337,119," + this.__objectRegistryId + "," + __objectRegistryId  );
	},
	
	/** @private */
	setCenterOffset: function( xOffset, yOffset )
	{
		Core.Proc.appendToCommandString( ":337,120," + this.__objectRegistryId + "," + xOffset + "," + yOffset  );
	},
	
	/** @private */
	$doChoosePhoto: function( w, h, filename, options, callbackId, invokingView )
	{
		Core.Proc.appendToCommandString( ":337,-121," + w + "," + h + "," + Core.Base64.encode( filename ) + "," + Core.Base64.encode( JSON.stringify( options ) ) + "," + Core.Base64.encode( callbackId ) + "," + invokingView  );
	},
	
	/** @private */
	setScrollIndicatorsVisible: function( enabled )
	{
		Core.Proc.appendToCommandString( ":337,122," + this.__objectRegistryId + "," + ( enabled ? 1 : 0 )  );
	},
	
	/** @private */
	$measureText: function( string, w, h, font, fontSize, callbackId )
	{
		Core.Proc.appendToCommandString( ":337,-123," + Core.Base64.encode( string ) + "," + w + "," + h + "," + Core.Base64.encode( font ) + "," + fontSize + "," + Core.Base64.encode( callbackId )  );
	},
	
	/** @private */
	setFocus: function( enabled )
	{
		Core.Proc.appendToCommandString( ":337,124," + this.__objectRegistryId + "," + ( enabled ? 1 : 0 )  );
	},
	
	/** @private */
	setViewportEnabled: function( enabled )
	{
		Core.Proc.appendToCommandString( ":337,125," + this.__objectRegistryId + "," + ( enabled ? 1 : 0 )  );
	},
	

// {{/Wg Generated Code}}

	_eventOccurredRecv: function( cmd ) {
		var str = Core.Proc.parseString( cmd[ 0 ] );
		Commands.Window.doCommand(str);
	},
	
	registerTemporaryCallback: function( callback ) {
		if (typeof callback != 'function') return null;
		var regId = (++this._tempCBCount).toString(36);
		Commands._tempCBs[regId] = callback;
		return regId;
	},
	
	takeTemporaryCallback: function( regId ) {
		var cb = Commands._tempCBs[regId];
		delete Commands._tempCBs[regId];
		return cb;
	},

	/**
	 *	@function UI#animate
	 * 	Animate changes to the properties of one or more UI objects.
	 * 	Currently animates changes to frame and alpha, and animates the addition / removal of subviews.
	 * 	@param {Function} action A closure that sets the property or properties to be animated.
	 * 		This function may manipulate several objects.
	 * 	@param {Number} duration The time over which to execute the animation, in milliseconds.
	 * 	@param {Function} onCompletion A closure to be executed after the animation has completed.
	 */
	animate: function(action, duration, callback) {
		if (typeof action == 'function') {
			var cbFn = (typeof callback == 'function') ? callback : duration;
			var duration = (typeof duration == 'number') ? duration : callback;
			if (typeof duration != 'number') duration = 400;

			Commands.startAnimation( duration, Commands.registerTemporaryCallback(callback));
			var options = new UIAnimationOptions();
			action(options);
			Commands.executeAnimation(options);
		}
	},
});

exports.Commands.instantiate();
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ViewGeometry'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ViewGeometry'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ViewGeometry'] = exports; var Class = require('NGCore/Client/Core/Class').Class;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;

/**
 * <p>Classes and objects contained by the <code>ViewGeometry</code> class.</p>
 * @name UI.ViewGeometry
 * @namespace
 * @description <p>The <code>ViewGeometry</code> class is a collection of classes and objects that control spatial components for UI views. 
 * Derived classes from <code>ViewGeometry</code> include:</p>
 * <ul>
 * <li><code>{@link UI.ViewGeometry.Rect}</code></li>
 * <li><code>{@link UI.ViewGeometry.Scale}</code></li>
 * </ul>
 * <p><code>ViewGeometry</code> utilizes the following enumerated constants:</p>
 * <ul>
 * <li><code>{@link UI.ViewGeometry.FitMode}</code></li>
 * <li><code>{@link UI.ViewGeometry.Gravity}</code></li>
 * </ul>
 */

var Scale = exports.Scale = Class.singleton(
/** @lends UI.ViewGeometry.Scale.prototype */
{
	/**
	 * @name UI.ViewGeometry.Scale
	 * @class The <code>Scale</code> class constructs objects that handle view geometry for different scales of measurement.
         * @constructs The default constructor.
	 * @augments Core.Class
	 */
   
	initialize: function() {
		var screenUnits = Capabilities.getScreenUnits();
		this.iOSConversion = screenUnits;
		this.pointConversion = this.iOSConversion * 160 / 72; 
	},

	// Use the values of generated constants... Mostly for if we need to send these to native in the future.
	Pixels: Commands.Scaling.Pixels,
	Points: Commands.Scaling.Points,
	Unit: Commands.Scaling.Unit,
	Percent: Commands.Scaling.Percent,
	iPhone: Commands.Scaling.iPhone,
	
	// Internals.
    
	pointConversion: 1.0,
    
	iOSConversion: 1.0,

    /** 
     * Retrieve the supported measurement scale from the device.
     * @param {Number} units The unit of measure.
     * @param {Number} size The screen size of the device.
     * @returns The current screen dimension supported by the device.
     */
	getScale: function(units, size) {
		switch (+units) {
			case this.Points:
				return this.pointConversion;
			case this.Unit:
				return size;
			case this.Percent:
				return size / 100;
			case this.iPhone:
				return this.iOSConversion;
		}
		return 1.0;
	}
});

var Gravity = exports.Gravity = 
{
		
	/** 
	 * @name UI.ViewGeometry.Gravity
	 * @class Enumeration for image gravity in a view.
	 */
	/** 
	* Center of gravity is the top-left corner of the image.
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	TopLeft: [0.0,0.0],
	/** 
	* Center of gravity is the top-center portion of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	TopCenter: [0.5,0.0],
	/** 
	* Center of gravity is the top-right corner of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	TopRight: [1.0, 0.0],
	/** 
	* Center of gravity is the left side of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	Left: [0.0,0.5],
	/** 
	* Center of gravity is the center of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	Center: [0.5,0.5],
	/** 
	* Center of gravity is the right side of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	Right: [1.0,0.5],
	/** 
	* Center of gravity is the bottom-left corner of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	BottomLeft: [0.0,1.0],
	/** 
	* Center of gravity is the bottom-center portion of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	BottomCenter: [0.5,1.0],
	/** 
	* Center of gravity is the bottom-right corner of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	BottomRight: [1.0,1.0]
};

 
exports.FitModes = Commands.FitMode;
/** 
* @name UI.ViewGeometry.FitMode
* @class Enumeration for image fit modes in a view.
* @see UI.Commands#FitMode
*/

	
var Rect = exports.Rect = Class.subclass(
/** @lends UI.ViewGeometry.Rect.prototype */
{
	/**
	 * @name UI.ViewGeometry.Rect
	 * @class <code>Rect</code> constructs rectangle objects for use as positionable elements in the user interface. 
	 * @constructs The default constructor.
	 * @augments Core.Class
	 */

    initialize: function(arg0)
    {
    	if (arg0 instanceof this.constructor){
    		// Another Rect
    		this.x = arg0.x;
    		this.y = arg0.y;
    		this.w = arg0.w;
    		this.h = arg0.h;
    	} else if (arg0 instanceof Array) {
    		if (arguments.length == 2 
    			&& arguments[0].length >= 2 
    			&& arguments[1] instanceof Array 
    			&& arguments[1].length >= 2) {
				
				// Arguments can be two arrays, one of which is a point and one of which is a size,
				this.x = arguments[0][0];
				this.y = arguments[0][1];
				this.w = arguments[1][0];
				this.h = arguments[1][1];
			}
			else if (arguments.length == 1 && arg0.length >= 4) {
				// Single Array
				this.x = arg0[0];
				this.y = arg0[1];
				this.w = arg0[2];
				this.h = arg0[3];
			}
			else {
				NgLogD("UI.ViewGeometry.Rect initialized with unparseable Array(s)");
			}
		} else if (arguments.length == 4) {
			// Four numbers
			this.x = arguments[0];
			this.y = arguments[1];
			this.w = arguments[2];
			this.h = arguments[3];
		}
		return this;
    },
	/**
	 * @returns {Boolean} Returns <code>true</code> if any component value is undefined, NaN, or the value indicates this rect has an area of 0 (<i>width</i> * <i>height</i>).
	 */
	isEmpty: function(){
		return !(this.w * this.h > 0) || isNaN(this.x) || isNaN(this.y) || isNaN(this.w) || isNaN(this.h);
	},
	/**
	 * Copy the component values of this <code>Rect</code>
	 * @returns {UI.ViewGeometry.Rect} A new <code>Rect</code> with identical component values.
	 */	
	copy: function() {
		return new (this).constructor(this);
	},
    /**
	 * Retrieve the component values of this <code>Rect</code>.
	 * @returns {Array (Number)} An array of component values for the specified <code>Rect</code> (<i>x</i>, <i>y</i>, <i>height</i>, <i>width</i>).
	 */	
	array: function() {
		return [this.x, this.y, this.w, this.h];
	},
    /**
	 * Set the dimensions of this <code>Rect</code> as an inset.
	 * @example var imageRect = null;
	 * var remainingRect = rect.copy();
	 * ...
	 * imageRect = remainingRect.sliceHorizontal(110).inset(8,15,8,15);
	 * @param {Number} t The size for the top of the rectangle.
	 * @param {Number} r The size for the right side of the rectangle.
	 * @param {Number} b The size for the bottom of the rectangle.
	 * @param {Number} l The size for the left side of the rectangle.
	 * @param {UI.ViewGeometry.Scale} units The unit of measure for the rectangle.
	 * @returns {UI.ViewGeometry.Rect} This function returns <code>this</code> to support method invocation chaining.
	 */	
	inset: function(t, r, b, l, units) {
		if (arguments.length > 4) {
			var xScale = Scale.getScale(units, this.w);
			var yScale = Scale.getScale(units, this.h);
			t = Math.floor(t * yScale);
			r = Math.floor(r * xScale);
			b = Math.floor(b * yScale);
			l = Math.floor(l * xScale);
		}
		
		if (arguments.length < 2) {
			r = t;
		}
		if (arguments.length < 4) {
			b = t;
			l = r;
		}
		this.y += t;
		this.h -= t + b;
		this.x += l;
		this.w -= l + r;
		return this;
	},
    /**
	 *	Create and return a new <code>Rect</code> representing the top (if positive) or bottom (if negative).
	 *	Destructively modifies this Rect, removing the new rect area from the receiver.
	 * @example var topPart = rect.inset(10).sliceVertical(50, UI.Scale.Percent);
	 * @param {Number} height The new rect height.
	 * @param {UI.ViewGeometry.Scale} [units] The scale of measurement.
	 * @returns {UI.ViewGeometry.Rect} A new <code>Rect</code> object.<br>
	 * @see UI.ViewGeometry.Rect#sliceHorizontal
	 */	
	sliceVertical: function(height, units) {
		if (arguments.length > 1) height = Math.floor(height * Scale.getScale(units, this.h));
		
		var newRect = this.copy();
		if (height < 0) {
			// Return the bottom area...
			newRect.h = -height;
			this.h += height;
			newRect.y += this.h;
		} else {
			newRect.h = height;
			this.y += height;
			this.h -= height;
		}
		return newRect;
	},
    /**
	 *	Create and return a new <code>Rect</code> representing the left (if positive) or right (if negative).
	 *	Destructively modifies this Rect, removing the new rect area from the receiver.
	 * @example var imageRect = null;
	 * var remainingRect = rect.copy();
	 * ...
	 * imageRect = remainingRect.sliceHorizontal(110).inset(8,15,8,15);
	 * @param {Number} width The new rect width.
	 * @param {UI.ViewGeometry.Scale} [units] The scale of measurement.
	 * @returns {UI.ViewGeometry.Rect} A new <code>Rect</code> object.<br>
	 * @see UI.ViewGeometry.Rect#sliceVertical
	 */	
	sliceHorizontal: function(width, units) {
		if (arguments.length > 1) width = Math.floor(width * Scale.getScale(units, this.w));

		var newRect = this.copy();
		if (width < 0) {
			newRect.w = -width;
			this.w += width;
			newRect.x += this.w;
		} else {
			newRect.w = width;
			this.x += width;
			this.w -= width;
		}
		return newRect;
	},

	toString: function() {
		return "Rect: {" + this.array().join(',') + "}";
	},

	/**
	 * Retrieve an array of component values for this <code>Rect</code> with rows and columns redistributed evenly.
	 * @returns {Array (Number)}
	 * @param {Number} rows The rect rows.
	 * @param {Number} columns The rect columns.
	 * @param {String} flat A one-dimensional array (left to right, top to bottom).
	 */
	getGrid: function(rows, columns, flat) {
		// Return an array of this rect divided equally into columns and rows.
		flat = (flat == true);
		var cellW = Math.floor(this.w / columns);
		var cellH = Math.floor(this.h / rows);
		
		var rowSet = new Array();
		for (var i = 0; i < rows; i++) {
			var colSet = new Array();
			for (var j = 0; j < columns; j++) {
				var r = new this.constructor(this.x + j * cellW, this.y + i * cellH, cellW, cellH);
				(flat ? rowSet : colSet).push(r);
			}
			if (!flat) rowSet.push(colSet);
		}
		return rowSet;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Window'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Window'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Window'] = exports; var Class = require('NGCore/Client/Core/Class').Class;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Element = require('NGCore/Client/UI/Element').Element;
var Rect = require('NGCore/Client/UI/ViewGeometry').Rect;

var WindowLayer = require('NGCore/Client/UI/WindowLayer').WindowLayer;

// Singleton
// Methods beginning with an underscore are considered private and should
// not be called from outside of the class.

Commands.Window = exports.Window = Class.singleton({

	/**
	 * @deprecated Replaced by {@link UI.Window#getWidth}.
	 */
	_outerWidth: 0,

	/**
	 * @deprecated Replaced by {@link UI.Window#getHeight}.
	 */
	_outerHeight: 0,

	/**
	 * @private
	 */
	_width: 0,
	/**
	 * @private
	 */
	_height: 0,

	 /**
	 * @class The <code>Window</code> class constructs a singleton object that manages application access to native UI.<br><br>
	 * <b>Note:</b> An application should never directly allocate a singleton.
	 * @name UI.Window
	 * @augments Core.Class	
	 * @see UI.Window#document
	 * @constructs The default constructor.
	 */
	initialize: function() {
		if (!this._outerWidth || !this._outerHeight) this.setWidthAndHeight(Capabilities.getScreenWidth(), Capabilities.getScreenHeight());
		if (!this._width || !this._height) this._setWidthAndHeight(Capabilities.getScreenWidth(), Capabilities.getScreenHeight());
		
		Commands.instantiate();
		var LayoutListener = Core.MessageListener.subclass(
		{
			initialize: function()
			{
				Device.LayoutEmitter.addListener(this, this.onUpdate);
			},
			
			onUpdate: function(layout)
			{
				UI.Window._setWidthAndHeight(layout['width'], layout['height']);
			}
		});
		var layout = new LayoutListener();
		NgLogD("window: outer = " + this._outerWidth + " × " + this._outerHeight + " frame = " + this._width + " × " + this._height);
	},
	
	document: WindowLayer.singleton({
		'type': 'document',
		register: function() {
			// This is not a registered object.
			this.__objectRegistryId = 0;
		}
	}),
	
	_layers: {},
	_getLayer: function(level) {
		return this._layers[level] || (this._layers[level] = new WindowLayer({'level':level || 0}));
	},
	
	/**
	 * @private
	 */
	destroyObject: function(obj) {
		obj.removeFromParent();
		Commands.destroy.call(obj);
		ObjectRegistry.unregister(obj);
	},
	
	/**
	 * @private
	 */
	handleCommand: function(command) {
		// this.log(["Raw Command", command]);
		var fields = NgParseCommand2(command, NgParseInt, NgParseBase64);
	//	this.log(["handleCommand:", fields[1]]);
		this.doCommand(fields[1]);
	},
	/**
	* @private
	*/
	setStatusBarHidden: function(value) {
		Commands.setStatusBarHidden(value);
		this._outerHeight = Capabilities.getScreenHeight() - (value ? 0 : (Capabilities.getStatusBarHeight() || 0));
	},
	
	/**
	 * @private
	 */
	doCommand: function(jsonString) {
		//NgLogD(jsonString);
		var command = JSON.parse(jsonString);
		if(command.name == 'callback'){
			var cb = Commands.takeTemporaryCallback(command.callback_id);
			if (typeof cb == 'function') {
				cb(command);
			}
		} else {
			var object = ObjectRegistry.idToObject(command.objId);
			if (object instanceof Element) {
				switch (command.name) {
					case 'event':
						object.performEventCallback(command);
						break;
					case 'update':
						var properties = command.properties || {};
						for (var property in properties) {
							try {
								var setter = object['update' + property.charAt(0).toUpperCase() + property.substr(1)];
								if (typeof setter == 'function') {
									setter.apply(object, [properties[property]]);
								} else {
									// Set read-only properties!
									object['_'+property] = properties[property];
								}
							} catch (e) {};
						}
						break;
					default:
						object.handleCommand(command);
				}
			} else {
				console.log("Message received for non-element object with id " + command.objId);
				return;
			}
		}
		// log(["Got message back", command]);
	},
    
	/**
	 * @private
	 */    
	log: function(object) {
		NgLogD(object.toString());
		// this.postMessage({name: 'log', message: object});
	},
	/**
	 * Return the available screen width, with respect to orientation and system status bars.
	 * @returns {Number} The currently available width in pixels that can be drawn to.
	 * @type Number
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getWidth: function()
	{
		return this._width;
	},

	/**
	 * Return the available screen height, with respect to orientation and system status bars.
	 * @returns {Number} The currently available height in pixels that can be drawn to.
	 * @type Number
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getHeight: function()
	{
		return this._height;
	},

	getOuterWidth: function() {
		return this._outerWidth;
	},
	
	getOuterHeight: function() {
		return this._outerHeight;
	},

	getFrame: function() {
		return new Rect(0, 0, this._width, this._height);
	}
});

// Cause property access to initialize the singleton. Needed for backward compatibility.
Commands.Window.__defineGetter__("outerWidth", function() {return this.getOuterWidth()});
Commands.Window.__defineGetter__("outerHeight", function() {return this.getOuterHeight()});

/**
 * @private
 */
Commands.Window._setWidthAndHeight = function(width, height)
{
	console.log("window: set layout size to: " + width + ' × ' + height);
	this._width = width;
	this._height = height;
};

/**
 * @private
 */
Commands.Window.setWidthAndHeight = function(width, height)
{
	console.log("window: set outer size to: " + width + ' × ' + height);
	this._outerWidth = width;
	this._outerHeight = height;
};

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Element'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Element'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Element'] = exports; var Class = require('NGCore/Client/Core/Class').Class;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;

var Element = exports.Element = Class.subclass(
/** @lends UI.Element.prototype */
{
	$subclass: function() {
		if (typeof this._init == 'function') this._init();
		return Class.subclass.apply(this, arguments);
	},
	
	classname: "UI_Element",

	/**
	 * @class The <code>Element</code> class is a base class for derived classes that manage object properties and handle user interface events.<br><br>
	 * <b>Caution!:</b> This base class is not exported in the UI module. Do not access it or subclass it at runtime.
	 * Derived classes from <code>Element</code> include:
	* <div class="ul">
	 * <li>{@link UI.AbstractView}</li>
	 * <li>{@link UI.AlertDialog}</li>
	 * <li>{@link UI.ListViewSection}</li>
	 * <li>{@link UI.ProgressDialog}</li>	 
	 * </div>
	 * @constructs The default constructor. 
	 * @param {String} properties
	 * @augments Core.Class
	*/
	initialize: function(properties) {
		if (Element._init) Element._init();
		
		this.register();
		
		// Enable events that are being handled at the class level...
		var events = this._eventNames;
		if (events) for (var e in events) {
			if (this[events[e]]) Commands.enableEvent.call(this, e);
		}
		
		//	Reimplement setAttributes here for speed
		var setters = this._setters;
		if (setters) for (var k in properties) {
			if (typeof setters[k] == 'function') try {
				setters[k].call(this, properties[k]);
			} catch (e) {
				NgLogD("Unable to set " + this.type + '.' + k);
			}
		}
		
	/*	This is awesome. Maybe use it in production code, but we want to keep
	//	our stylistic constraints for core development.
	
		for (var propName in this._setters) {
			this.__defineSetter__(propName, this._setters[propName]);
		}
		for (propName in this._getters) {
			this.__defineGetter__(propName, this._getters[propName]);
		}
	*/
	
		return this;
	},
	
	register: function() {
		try {
			ObjectRegistry.register(this);
			Commands.create(this.__objectRegistryId, this.type || this.classname);
		} catch (e) {
			// Nothing yet
		} finally {
			return this.__objectRegistryId;
		}
	},
	
	retain: function() {
		(this.__retainCount) ? ++this.__retainCount : (this.__retainCount = 1);
		return this;
	},
	
	release: function() {
		if (--this.__retainCount === 0) {
			this.destroy();
		}
	},
		
	/**
	 * Retrieve the property value of the given key. 
	 * @param {String} key The property keyword.
	 * @returns {String} The current property value.
	 * @see UI.Element#getAttributes,
	 * @see UI.Element#setAttribute,
	 * @see UI.Element#setAttributes
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	getAttribute: function(key) {
		var getter = this._getters[key];
		return (typeof getter == 'function') ? getter.call(this) : undefined;
	},
	
	/**
	 * Set the property value for the given key.
	 * @example var glView = new UI.GLView
	 * ...
	 * glView.setAttribute('active', true);
	 * @param {String} key The property keyword.
	 * @param {String} value The new property value.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see UI.Element#getAttribute,
	 * @see UI.Element#getAttributes,
	 * @see UI.Element#setAttributes
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	setAttribute: function(key, value){
		var setter = this._setters[key];
		if (typeof setter == 'function') {
			return setter.call(this, value);
		} else {
			NgLogD("Unable to set " + this.type + '.' + key);
		}
		return this;
	},
	
	/**
	 * Set the property value for each specified key. Property values are passed in as key/value pairs.
	 * @param {Object} dict A dictionary of property key/value pairs.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see UI.Element#getAttribute,
	 * @see UI.Element#getAttributes,
	 * @see UI.Element#setAttribute
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	setAttributes: function(dict) {
		var setters = this._setters;
		if (setters) for (var k in dict) {
			if (typeof setters[k] == 'function') try {
				setters[k].call(this, dict[k]);
			} catch (e) {
				NgLogD("Unable to set " + this.type + '.' + k);
			}
		}
		return this;
	},
	
	/**
	 * Retrieve property values for each specified key. 
	 * @param {String} list A list of property keywords.
	 * @returns {Object} A list of key/value pairs.
	 * @see UI.Element#getAttribute,
	 * @see UI.Element#setAttribute,
	 * @see UI.Element#setAttributes
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	getAttributes: function(list) {
		var output = {};
		if (list instanceof Array) {
			var key;
			for (var i = 0; i < list.length; i++) {
				key = list[i];
				output[key] = this._getters[key].call(this);
			}
		} else {
			for (var key in this._getters) {
				output[key] = this._getters[key].call(this);
			}
		}
		return output;
	},

	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	enableEvent: Commands.enableEvent,
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	toString: function() {
		return this.type + '(' + this.__objectRegistryId + ')';
	},

	/**
	 * @function
	 * @description Destroy this instance and release resources on the backend.
	 * @status Javascript, iOS, Android, Flash, Test
	*/
	destroy: function() {
		Commands.destroy.call(this);
		ObjectRegistry.unregister(this);
		delete this.prototype;
		for (var i in this) {
			if (this.hasOwnProperty(i)) {
				delete this[i];
			}
		}
		this._destroyed = true;
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	*/
	registerCallback: function(func, oneTime) {
		var callbackId = ++this.callbackCounter;
		var obj = this;
		this.callbacks[callbackId] = function(obj, args) {
			try {
				func(obj, args);
				if(oneTime) {
					delete obj.callbacks[callbackId];
				}
			}
			catch(e) {
				NgHandleException(e);
			}
		};
		return callbackId;
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	performCallback: function(event) {
		var cb = this.callbacks[event.callbackId];
		if(cb) {
			cb(this, event.arguments);
		}
	},
	
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	performEventCallback: function(event) {
		try {
			// Look up the event by its 'onXXX' name...
			var eName = this._eventNames[event.eventType];
			var fn = this['_'+eName] || this[eName];
			if (typeof fn == 'function') {
				fn.call(this, event);
			}
		}
		catch(e) {
			NgHandleException(e);
		}
	},	
	
	// STATICS: Setter and Getter Registration
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	$registerAccessors: function(propName, getterFn, setterFn, deprecationMessage) {
		// Put the new setter / getter functions into the prototype.
		var caseAdjusted = propName.charAt(0).toUpperCase() + propName.substr(1);
		var byKeyOnly = Boolean(deprecationMessage || false);
	//	NgLogD("Synthesizing set" + caseAdjusted + (shouldSetClosure ? " (custom)" : " (standard)") +
	//		" and get" + caseAdjusted + (onGetClosure ? " (custom)" : " (standard)") + " for member variable " + localVar);
	
		// If this is an instance, use the instance. Otherwise, if we are a class constructor, modify the prototype.
		var pType = (this instanceof Element) ? this : this.prototype;
		if (typeof getterFn == 'function') {
			if (!pType.hasOwnProperty('_getters')) {
				try {
					var heritableMap = function() {return this;};
					var superGetters = pType.superclass._getters;
					if (superGetters) heritableMap.prototype = superGetters;
					pType._getters = new heritableMap();
				} catch (e) {};
			}
			if (byKeyOnly) {
				pType['get'+caseAdjusted] = function() {
					NgLogD("WARNING: Use of get" + caseAdjusted + "() is deprecated. " + deprecationMessage);
					getterFn.apply(this, arguments);
				};
			} else {
				pType['get'+caseAdjusted] = getterFn;
			}
			pType._getters[propName] = getterFn;
		}
		if (typeof setterFn == 'function') {
			if (!pType.hasOwnProperty('_setters')) {
				try {
					var heritableMap = function() {return this;};
					var superSetters = pType.superclass._setters;
					if (superSetters) heritableMap.prototype = superSetters;
					pType._setters = new heritableMap();
				} catch (e) {};
			}
			if (byKeyOnly) {
				pType['set'+caseAdjusted] = function() {
					NgLogD("WARNING: Calling set" + caseAdjusted + "() is deprecated. " + deprecationMessage);
					setterFn.apply(this, arguments);
				}
			} else {
				pType['set'+caseAdjusted] = setterFn;
			}
			pType._setters[propName] = setterFn;
		}
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	$registerEventType: function(eventName) {
		var onEventName = 'on' + eventName.charAt(0).toUpperCase() + eventName.substr(1);
		var localVar = '_' + onEventName;
		var pType = this.prototype;
		
		var getterFn = function() {
			return this[localVar] || this[onEventName];
		};
		var setterFn = function(callback) {
			var isFn = (typeof callback == 'function');
			if (isFn) {
				this[localVar] = callback;
			} else {
				delete this[localVar];
			}
			this.enableEvent(eventName, isFn);
		};
		if (!pType.hasOwnProperty('_eventNames')) {
			try {
				var heritableMap = function() {return this;};
				var superEvents = pType.superclass._eventNames;
				if (superEvents) heritableMap.prototype = superEvents;
				pType._eventNames = new heritableMap();
			} catch (e) {};
		}
		pType._eventNames[eventName] = onEventName;
		
		this.registerAccessors(onEventName, getterFn, setterFn);
		
		// Legacy support. Let's concentrate on removing this soon or at least fixing the casing.
		pType.__defineGetter__(onEventName.toLowerCase(), getterFn);
		pType.__defineSetter__(onEventName.toLowerCase(), setterFn);
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	$synthesizePropertyWithState: function(propName, CommandsFn) {
		var lVarName = '_' + propName + 'Map';
		var setterFn;
		if (propName) {
			setterFn = function(value, optState) {
				optState |= 0;
			//	NgLogD("Set " + this.type + "." + propName + "[" + optState + "] = " + value);
				(this[lVarName] || (this[lVarName] = {}))[optState] = value;
				CommandsFn.call(this, optState, value);
				return this;
			};
		} else {
			setterFn = function(value, optState) {
				CommandsFn.call(this, (optState | 0), value);
				return this;
			};
		}
		
		var getterFn = function(state) {
			return (this[lVarName] || 0)[(state | 0)];
		};
		
		this.registerAccessors(propName, getterFn, setterFn);
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	$synthesizeCompoundProperty: function(propName, CommandsFn) {
		var lVarName = '_' + propName;
		var setterFn;
		if (CommandsFn) {
			// Synthesized setters accept EITHER an array of reasonable length OR individual args.
			setterFn = function(args) {
				this[lVarName] = (args instanceof Array)
					? args
					: Array.prototype.slice.call(arguments);
				CommandsFn.apply(this, this[lVarName]);
				return this;
			}
		} else {
			setterFn = function(args) {
				this[lVarName] = (args instanceof Array) ? args : Array.prototype.slice.call(arguments);
				return this;
			}
		}
		
		this.registerAccessors(propName, function() {return this[lVarName];} , setterFn);
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	$synthesizeProperty: function(propName, CommandsFn) {
		var lVarName = '_' + propName;
		var setterFn;
		if (CommandsFn) {
			// Optional args are still passed through, even though only the first arg is assigned.
			setterFn = function(arg) {
				this[lVarName] = arg;
				CommandsFn.apply(this, arguments);
				return this;
			}
		} else {
			setterFn = function(arg) {
				this[lVarName] = arg;
				return this;
			}
		}
		
		this.registerAccessors(propName, function() {return this[lVarName];} , setterFn);
	}
});


// Event Handlers
Element._init = function() {
	delete Element._init;
	
	/**
	 * @name UI.Element#setOnLoad
	 * @description Set a function to call when the <code>load</code> event occurs.
	 * @param {Function} loadCallback The new functoin to call.<br><br><b>Note:</b> The <code>load</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example function() { 
	 *	onLoad.loaded = true; 
	 * };
	 * @see UI.Element#event:getOnLoad
	 * @event
	 */
	/**
	 * @name UI.Element#getOnLoad
	 * @description Retrieve the function to call when the <code>load</code> event occurs.
	 * @returns {Function} The current function to call.
	 * @see UI.Element#event:setOnLoad
	 * @event
	 */
	Element.registerEventType('load');
	/**
	 * @name UI.Element#setOnUnload
	 * @description Set a function to call when the <code>unload</code> event occurs.
	 * @param {Function} unloadCallback The new functoin to call.<br><br><b>Note:</b> The <code>unload</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example function() { 
	 *	onUnload.unloaded = true; 
	 * };
	 * @see UI.Element#event:getOnUnload	
	 * @event
	 */
	/**
	 * @name UI.Element#getOnUnload
	 * @description Retrieve the function to call when the <code>unload</code> event occurs.
	 * @returns {Function} The current function to call.
	 * @see UI.Element#event:setOnUnload	 
	 * @event
	 */
	Element.registerEventType('unload');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/View'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/View'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/View'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var Window = require('NGCore/Client/UI/Window').Window;

var ViewParent = require('NGCore/Client/UI/ViewParent').ViewParent;

var View = exports.View = AbstractView.subclass(
/** @lends UI.View.prototype */
{
	'type':'view',

	/**	 
	 * @class The <code>View</code> class is a base class for derived classes that handle application views. Derived classes from <code>View</code> include:
	 * <div class="ul">
	 * <li>{@link UI.ScrollView}</li>
	 * <li>{@link UI.Toast}</li>
	 * </div>
	 * @constructs The default constructor. 
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {String} properties Object properties.
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (View._init) View._init();
		ViewParent.initialize.call(this);
		return $super(properties);
	},
	/**
	* Add a child node to this <code>View</code> at the specified index.
	* @example var mainView = new UI.View();
	* ...
	* var errorView = new UI.View();
	* ...
	* mainView.addChild(errorView);
	* @param {GL2.Node} childNode The child node to add.
	* @param {Number} index The specified index.
	* @throws {this.type + ".addChild: " + childNode + " is not a view!"} Specified node is not attached to a view.
	* @returns This function returns <code>this</code> to support method invocation chaining.
	* @see UI.View#removeChild
    * @status iOS, Android, Test
	*/
	addChild: ViewParent.addChild,
	
	/**
	* Remove a child node from this <code>View</code> at the specified index.
	* @example mainView.removeChild(errorView);
	* @param {GL2.Node} childNode The child node to remove.
	* @throws {this.type + ".removeChild: " + childNode + " is not a view!} Specified node is not attached to a view.
	* @returns The child node that was removed.
	* @see UI.View#addChild
    * @status iOS, Android, Test
	*/    
	removeChild: ViewParent.removeChild,


	/**
	 * Retrieve a count of the child nodes attached to this <code>View</code>.
	 * @return {Number} The current number of child nodes.
	 * @status Javascript, iOS, Android, Flash
	 */
	getChildCount: ViewParent.getChildCount,

	/**
	 * Retrieve the child nodes attached to this <code>View</code>.
	 * @return {Object} All attached children nodes.
	 * @status Javascript, iOS, Android, Flash
	 */
	getChildren: ViewParent.getChildren,

	/**
	 * @function
	 * @description Override this for custom view subclass layout code.
	 */
	layoutSubviews: function() {
		//Override this for custom view subclass layout code
	},
	/** @protected */
	_style:null,
	/**
	 * Retrieve the style for this <code>View</code>.
	 * @returns {UI.Style} The current <code>View</code> style.
	 * @see UI.View#setStyle
	 * @status Javascript, iOS, Android, Flash
	 */
	getStyle:function(){
		return this._style;
	},
	/**
	 * Set the style for this <code>View</code>. This call allows custom view objects to process and update their styles more easily.
	 * @param {UI.Style} style The new <code>View</code> style.
	 * @see UI.View#getStyle
	 * @status Javascript, iOS, Android, Flash
	 */
	setStyle: function(/*UI.Style*/style) {
		//Override this for custom view subclass styling code
		this._style = style;
	},
	
	/**
	 * @protected
	 * @function
	 * @status Javascript, iOS, Android, Flash
	 */
	_setVisible: function($super, makeVisible) {
		var wasVisible = this._visible;
		$super(makeVisible);
		if (this._visible != wasVisible) {
			var l = this._children.length;
			for (var i = 0; i < l; i++) {
				this._children[i]._setVisible(makeVisible);
			}
		}
	},
});

// Properties
View._init = function() {
	delete View._init;
	if (AbstractView._init) AbstractView._init();

	/**
	 * @name UI.View#setImage
	 * @description Set an image URL for a view state. This property defines a remote image resource to use in arbitrary contexts.
	 * @example var someSprite = new UI.View();        
	 * someSprite.setImage('./Content/mySprite.png', [w, h], [0, 0]);
	 * @see UI.View#getImage
	 * @param {String} imageURL The new image URL.
	 * @param {UI.State} [flags=UI.State.Normal] A set of flags describing the view state(s) for using this URL.
 	 * @status iOS, Android, Test
	 * @function 
	 */
	/**
	 * @name UI.View#getImage
	 * @description Retrieve the <code>image</code> URL for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current image URL for the specified view state.
	 * @see UI.View#setImage
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	View.synthesizePropertyWithState('image', Commands.setImage);
	/**
	 * @name UI.View#setImageBorder
	 * @description Set the value of the <code>imageBorder</code> property for a view state. This property defines a border for images used in the specified view state.
	 * @param {Object} imageBorder The new value for <code>imageBorder</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.View#getImageBorder
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.View#getImageBorder
	 * @description Retrieve the value of the <code>imageBorder</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current value of <code>imageBorder</code>.
	 * @see UI.View#setImageBorder
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	View.synthesizePropertyWithState('imageBorder', Commands.setImageBorder);
	/**
	 * @name UI.View#setImageGravity
	 * @description Set the value of the <code>imageGravity</code> property. This property defines how an image is positioned within a viewable area.
	 * @example var someSprite = new UI.View();
	 * ...
	 * someSprite.setImageGravity([0.5, 0.0]);
	 * @param {Number} imageGravity The new value for <code>imageGravity</code> (expressed as two floats).
	 * @see UI.View#getImageGravity
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.View#getImageGravity
	 * @description Retrieve the value of the <code>imageGravity</code> property.
	 * @returns {Number} The current value of <code>imageGravity</code> (expressed as two floats).
	 * @see UI.View#setImageGravity
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	View.synthesizeCompoundProperty('imageGravity', Commands.setImageGravity);
	/**
	 * @name UI.View#setImageFit
	 * @description Set the value of the <code>imageFit</code> property. This property defines the scaling of bitmap images to fit within the bounds of a control 
	 * (subtracting the value for <code>imageInsets</code>).
	 * @example var someSprite = new UI.View();
	 * ...
	 * someSprite.setImageFit(UI.FitMode.None);
	 * @param {Number} imageFit The new value for <code>imageFit</code>.
	 * @see UI.View#getImageFit
	 * @function
	 */
	/**
	 * @name UI.View#getImageFit
	 * @description Retrieve the value of the <code>imageFit</code> property.
	 * @returns {Number} The current value of <code>imageFit</code>.
	 * @see UI.View#setImageFit
	 * @function
 	 * @status 
	 */
	View.synthesizeProperty('imageFit', Commands.setImageFitMode);
	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'disabled': Commands.State.Disabled,
		//** extra-deprecated */
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing View." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			View.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('image');
	bindStateProperties('imageBorder');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Label'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Label'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Label'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var Label = exports.Label = AbstractView.subclass(
/** @lends UI.Label.prototype */
{
	'type':'label',
	/**
	 * @name UI.Label
	 * @class The <code>Label</code> class constructs objects for managing strings that are used as application labels. 
	 * These objects include access to a wide range of attributes for manipulating the look and feel of application labels.
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (Label._init) Label._init();
		$super(properties);
	}
});

Label._init = function() {
	delete Label._init;
	if (AbstractView._init) AbstractView._init();
	
	/**
	 * @name UI.Label#setText
	 * @description Set the value of the <code>text</code> property for a view state. This property defines a text string to use as a label in the specified view state.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setText("Friends List");
	 * @param {String} text The new value for <code>text</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Label#getText
	 * @status iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getText
	 * @description Retrieve the value of the <code>text</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value for <code>text</code>.
	 * @see UI.Label#setText
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizePropertyWithState('text', Commands.setText);	
	/**
	 * @name UI.Label#setTextFont
	 * @description Set the value of the <code>textFont</code> property. This property defines the font face used with labels in the specified view state.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setTextFont(myFont);
	 * @param {String} textFont The new value for <code>textFont</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Label#getTextFont
	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getTextFont
	 * @description Retrieve the value of the <code>textFont</code> property.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value for <code>textFont</code>.
	 * @see UI.Label#setTextFont
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizePropertyWithState('textFont', Commands.setTextFont);
	/**
	 * @name UI.Label#setTextColor
	 * @description Set the value of the <code>textColor</code> property for a view state. This property defines the color of a text string for a label in the specified view state.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setTextColor('FFFF');
	 * @param {String} textColor The new value for <code>textColor</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Label#getTextColor
	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getTextColor
	 * @description Retrieve the value of the <code>textColor</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textColor</code>.
	 * @see UI.Label#setTextColor
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * @name UI.Label#setTextShadow
	 * @description Set the value of the <code>textShadow</code> property for a view state. This property defines the amount of text shadowing used on labels in the specified view state.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setTextShadow("FF00 2.0 {0,-1}");
	 * @param {String} textShadow The new value for <code>textShadow</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Label#getTextShadow
	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getTextShadow
	 * @description Retrieve the value of the <code>textShadow</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textShadow</code>.
	 * @see UI.Label#setTextShadow
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	
	/**
	 * @name UI.Label#setTextGravity
	 * @description Set the value of the <code>textGravity</code> property for this <code>Label</code>. This property defines how a text string is positioned within a viewable area.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setTextGravity([0.1, 0.5]);
	 * @param {Number, Array (Number)} textGravity The new value for <code>textGravity</code>. Set as individual components or a single array of components.
	 * @see UI.Label#getTextGravity
	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getTextGravity
	 * @description Retrieve the value of the <code>textGravity</code> property for this <code>Label</code>.
	 * @returns {Number, Array (Number)} The current value of <code>textGravity</code>.
	 * @see UI.Label#setTextGravity
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);
	/**
	 * @name UI.Label#setTextSize
	 * @description Set the value of the <code>textSize</code> property for this <code>Label</code>. This property defines the size of text strings for a label.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setTextGravity(24);
	 * @param {Number} textSize The new value for <code>textSize</code>.
	 * @see UI.Label#getTextSize
	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getTextSize
	 * @description Retrieve the value of the <code>textSize</code> property for this <code>Label</code>.
	 * @returns {Number} The current value of <code>textSize</code>.
	 * @see UI.Label#setTextSize
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizeProperty('textSize', Commands.setTextSize);

	/**
	 * @name UI.Label#setTextInsets
	 * @description Set the value of the <code>textInsets</code> property for this <code>Label</code>. This property defines the viewable area of a text string when applying gravity.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setTextInsets(0, 0, 0, 64);
	 * @param {Number, Array (Number)} textInsets The new value for <code>textInsets</code>. Set as individual components or a single array of components.
	 * @see UI.Label#getTextInsets
	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getTextInsets
	 * @description Retrieve the value of the <code>textInsets</code> property for this <code>Label</code>.
	 * @returns {Number, Array (Number)} The current value of <code>textInsets</code>.
	 * @see UI.Label#setTextInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizeCompoundProperty('textInsets', Commands.setTextInsets);
	
			// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed,
		'disabled': Commands.State.Disabled
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Label." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			Label.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('text');
	bindStateProperties('textColor');
	bindStateProperties('textShadow');
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Image'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Image'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Image'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var Image = exports.Image = AbstractView.subclass(
/** @lends UI.Image.prototype */
{
	/**
	 * @name UI.Image
	 * @class The <code>Image</code> class constructs objects that control the location and size of images used in the user interface.
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (Image._init) Image._init();
		$super(properties);
	},
	
	'type':'image'
});


// Properties
Image._init = function() {
	delete Image._init;
	if (AbstractView._init) AbstractView._init();

	/**
	 * @name UI.Image#setImage
	 * @description Set an image URL for a view state. This property defines how an image appears for specific conditions. For example,
	 * set one image for the default view state and another image for a view state with focus.
	 * @example var splashGraphic = new UI.Image();
	 * ...
	 * splashGraphic.setImage('./Content/splash.png');
	 * @see UI.Image#getImage
	 * @param {String} imageURL The new image URL.
	 * @param {UI.State} [flags=UI.State.Normal] A set of flags describing the view state(s) for using this URL.
	 * @status iOS, Android, Test
	 * @function 
	 */
	/**
	 * @name UI.Image#getImage
	 * @description Retrieve the <code>image</code> URL for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current image URL for the specified view state..
	 * @see UI.Image#setImage
	 * @status iOS, Android, Test
	 * @function
	 */
	Image.synthesizePropertyWithState('image', Commands.setImage);
	/**
	 * @name UI.Image#setImageBorder
	 * @description Set the value of the <code>imageBorder</code> property for a view state. This property defines a border for images used in the specified view state.
	 * @param {Object} imageBorder The new value for <code>imageBorder</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Image#getImageBorder
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.Image#getImageBorder
	 * @description Retrieve the value of the <code>imageBorder</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current value of <code>imageBorder</code>.
	 * @see UI.Image#setImageBorder
	 * @function
	 * @status iOS, Android, Test
	 */
	Image.synthesizePropertyWithState('imageBorder', Commands.setImageBorder);
	/**
	 * @name UI.Image#setImageGravity
	 * @description Set the value of the <code>imageGravity</code> property. This property defines how an image is positioned within a viewable area.
	 * @example var splashGraphic = new UI.Image();
	 * ...
	 * splashGraphic.setImageGravity([0.5, 0.0]);
	 * @param {Number} imageGravity The new value for <code>imageGravity</code> expressed as two floats.
	 * @see UI.Image#getImageGravity
	 * @function
	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.Image#getImageGravity
	 * @description Retrieve the value of the <code>imageGravity</code> property.
	 * @returns {Number} The current value of <code>imageGravity</code> expressed as two floats.
	 * @see UI.Image#setImageGravity
	 * @function
	 * @status iOS, Android, Test
	 */
	Image.synthesizeCompoundProperty('imageGravity', Commands.setImageGravity);
	 /**
	 * @name UI.Image#setImageTransform
	 * @description Set the value of the <code>imageTransform</code> property. This property defines data compression for images.
	 * @example var splashGraphic = new UI.Image();
	 * ...
	 * splashGraphic.setImageTransform([Math.cos(angle), Math.sin(angle), Math.sin(angle), Math.cos(angle), 0, 0]);
	 * @param {Array (Number)} imageTransform The new value for <code>imageTransform</code>. 
	 * Set as an array of floats (<i>a</i>, <i>b</i>, <i>c</i>, <i>d</i>, <i>tx</i>, <i>ty</i>).
	 * @see UI.Image#getImageTransform
	 * @function
	 */
	/**
	 * @name UI.Image#getImageTransform
	 * @description Retrieve the value of the <code>imageTransform</code> property.
	 * @returns {Array (Number)} The current value of <code>imageTransform</code>.
	 * @see UI.Image#setImageTransform
	 * @function
	 */
	 Image.synthesizeCompoundProperty('imageTransform', Commands.setImageTransform);
	/**
	 * @name UI.Image#setImageFit
	 * @description Set the value of the <code>imageFit</code> property. This property defines the scaling of bitmap images to fit within the bounds of a control 
	 * (subtracting the value for <code>imageInsets</code>).
	 * @example var splashGraphic = new UI.Image();
	 * ...
	 * splashGraphic.setImageFit(UI.FitMode.None);
	 * @param {Number} imageFit The new value for <code>imageFit</code>.
	 * @see UI.Image#getImageFit
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.Image#getImageFit
	 * @description Retrieve the value of the <code>imageFit</code> property.
	 * @returns {Number} The current value of <code>imageFit</code>.
	 * @see UI.Image#setImageFit
	 * @function
 	 * @status iOS, Android, Test
	 */
	Image.synthesizeProperty('imageFit', Commands.setImageFitMode);
	
		// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed,
		'disabled': Commands.State.Disabled
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Image." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			Image.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('image');
    bindStateProperties('imageBorder');
	bindStateProperties('gradient');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Button'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Button'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Button'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var Button = exports.Button = AbstractView.subclass(
/** @lends UI.Button.prototype */
{
	/**
	 * @name UI.Button
	 * @class The <code>Button</code> class constructs objects that are used as application buttons.
	 * @augments UI.AbstractView
	 */
	'type':'button',

	'Layout':Commands.ButtonLayout,
	
	initialize: function($super, properties) {
		if (Button._init) Button._init();
		$super(properties);
	}
});

// Properties
Button._init = function() {
	delete Button._init;
	if (AbstractView._init) AbstractView._init();
	
	/**
	 * @name UI.Button#setImage
	 * @description Set an image URL for a view state. This defines how buttons appear for specific conditions. For example, 
	 * set different images for a button in the default view state and a button when it is pressed.
	 * @example var backButton = new UI.Button();        
	 * backButton.setImage('./Content/backButton.png', [w, h], [0, 0]);
	 * @see UI.Button#getImage
	 * @param {String} imageURL The new image URL.
	 * @param {UI.State} [flags=UI.State.Normal] A set of flags describing the view state(s) for using this URL.
 	 * @status iOS, Android, Test
	 * @function 
	 */
	/**
	 * @name UI.Button#getImage
	 * @description Retrieve the <code>image</code> URL for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current image URL for the specified view state..
	 * @see UI.Button#setImage
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizePropertyWithState('image', Commands.setImage);
	/**
	 * @name UI.Button#setImageInsets
	 * @description Set the value of the <code>imageInsets</code> property. This property defines the viewable area of an image when applying gravity.
	 * @example var backButton = new UI.Button();
	 * ...
	 * backButton.setImageInset([10,10,10,10]);
	 * @param {Number, Array (Number)} imageInsets The new value for <code>imageInsets</code>. Set as insets or an array of insets (expressed as floats).
	 * @see UI.Button#getImageInsets
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getImageInsets
	 * @description Retrieve the value of the <code>imageInsets</code> property.
	 * @returns {Number, Array (Number)} The current value of <code>imageInsets</code>.
	 * @see UI.Button#setImageInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizeCompoundProperty('imageInsets', Commands.setImageInsets);
	/**
	 * @name UI.Button#setImageFit
	 * @description Set the value of the <code>imageFit</code> property. This property defines the scaling of bitmap images to fit within the bounds of a control 
	 * (subtracting the value for <code>imageInsets</code>).
	 * @example var backButton = new UI.Button();
	 * ...
	 * backButton.setImageFit(UI.FitMode.None);
	 * @param {Number} imageFit The new value for <code>imageFit</code>.
	 * @see UI.Button#getImageFit
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.Button#getImageFit
	 * @description Retrieve the value of the <code>imageFit</code> property.
	 * @returns {Number} The current value of <code>imageFit</code>.
	 * @see UI.Button#setImageFit
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	Button.synthesizeProperty('imageFit', Commands.setImageFitMode);
	/**
	 * @name UI.Button#setImageGravity
	 * @description Set the value of the <code>imageGravity</code> property. This property defines how a image for a button is positioned within a viewable area.
	 * @example var backButton = new UI.Button();
	 * ...
	 * backButton.setImageGravity([0.5, 0.0]);
	 * @param {Number} imageGravity The new value for <code>imageGravity</code> (expressed as two floats).
	 * @see UI.Button#getImageGravity
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.Button#getImageGravity
	 * @description Retrieve the value of the <code>imageGravity</code> property.
	 * @returns {Number} The current value of <code>imageGravity</code> (expressed as two floats).
	 * @see UI.Button#setImageGravity
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	Button.synthesizeCompoundProperty('imageGravity', Commands.setImageGravity);
	/**
	 * @name UI.Button#setImageTransform
	 * @description Set the value of the <code>imageTransform</code> property. This property defines data compression for an image used as a button.
	 * @example var button = new UI.Button()
	 * ...
	 * button.setImageTransform([Math.cos(angle), Math.sin(angle), Math.sin(angle), Math.cos(angle), 0, 0]);
	 * @param {Array (Number)} imageTransform The new value for <code>imageTransform</code>. 
	 * Set as an array of floats (<i>a</i>, <i>b</i>, <i>c</i>, <i>d</i>, <i>tx</i>, <i>ty</i>).
	 * @see UI.Button#getImageTransform
 	 * @status iOS, Android
	 * @function
	 */
	/**
	 * @name UI.Button#getImageTransform
	 * @description Retrieve the value of the <code>imageTransform</code> property.
	 * @returns {Array (Number)} The current value of <code>imageTransform</code>.
	 * @see UI.Button#setImageTransform
 	 * @status Javascript, iOS, Android, Flash
	 * @function
	 */
	Button.synthesizeCompoundProperty('imageTransform', Commands.setImageTransform);
	/**
	 * @name UI.Button#setImageBorder
	 * @description Set the value of the <code>imageBorder</code> property for a view state. This property defines a border for images used in the specified view state.
	 * @param {Object} imageBorder The new value for <code>imageBorder</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Button#getImageBorder
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getImageBorder
	 * @description Retrieve the value of the <code>imageBorder</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current value of <code>imageBorder</code>.
	 * @see UI.Button#setImageBorder
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizePropertyWithState('imageBorder', Commands.setImageBorder);
	
	/**
	 * @name UI.Button#setText
	 * @description Set the value of the <code>text</code> property for a view state. This property defines a text string to use as a label for a button in different view states.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setText("More information");
	 * @see UI.Button#getText
	 * @param {String} text The new value for <code>text</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getText
	 * @description Retrieve the value of the <code>text</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>text</code> in the specified view state..
	 * @see UI.Button#setText
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizePropertyWithState('text', Commands.setText);
	/**
	 * @name UI.Button#setTextColor
	 * @description Set the value of the <code>textColor</code> property for a view state. This property defines the color of a text string used as a label on a 
	 * button in different view states.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setTextColor('FFFFFF');
	 * @see UI.Button#getTextColor
	 * @param {String} textColor The new value for <code>textColor</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @function 
	 */
	/**
	 * @name UI.Button#getTextColor
	 * @description Retrieve the value of the <code>textColor</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textColor</code> in the specified view state..
	 * @see UI.Button#setTextColor
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * @name UI.Button#setTextFont
	 * @description Set the value of the <code>textFont</code> property. This property defines the font face used with labels for a button in different view states.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setTextFont(myFont);
	 * @param {String} textFont The new value for <code>textFont</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Button#getTextFont
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getTextFont
	 * @description Retrieve the value of the <code>textFont</code> property.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value for <code>textFont</code> in the specified view state.
	 * @see UI.Button#setTextFont
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizePropertyWithState('textFont', Commands.setTextFont);
	/**
	 * @name UI.Button#setTextShadow
	 * @description Set the value of the <code>textShadow</code> property for a view state. This property defines the amount of text shadowing used on text strings for a button in different view states.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setTextShadow("FF00 2.0 {0,-1}");
	 * @see UI.Button#getTextShadow
	 * @param {String} textShadow The new value for <code>textShadow</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getTextShadow
	 * @description Retrieve the value of the <code>textShadow</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textShadow</code> in the specified view state..
	 * @see UI.Button#setTextShadow	
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	/**
	 * @name UI.Button#setTextGravity
	 * @description Set the value of the <code>textGravity</code> property. This property defines how a text string for a button is positioned within a viewable area.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setTextGravity([0.1, 0.5]);
	 * @param {Number, Array (Number)} textGravity The new value for <code>textGravity</code>. Set as individual components or a single array of components.
	 * @see UI.Button#getTextGravity
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getTextGravity
	 * @description Retrieve the value of the <code>textGravity</code> property.
	 * @returns {Number, Array (Number)} The current value of <code>textGravity</code>.
	 * @see UI.Button#setTextGravity
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);

	/**
	 * @name UI.Button#setTextSize
	 * @description Set the value of the <code>textSize</code> property. This property defines the text size of labels for a button.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setTextSize(24);
	 * @param {Number} textSize The new value for <code>textSize</code>.
	 * @see UI.Button#getTextSize
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getTextSize
	 * @description Retrieve the value of the <code>textSize</code> property.
	 * @returns {Number} The current value for <code>textSize</code>.
	 * @see UI.Button#setTextSize
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizeProperty('textSize', Commands.setTextSize);
	/**
	 * @name UI.Button#setTextInsets
	 * @description Set the value of the <code>textInsets</code> property. This property defines the viewable area of a text string when applying gravity.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setTextInsets(0, 0, 0, 64);
	 * @param {Array (Number)} textInsets The new value for <code>textInsets</code>.
	 * @see UI.Button#getTextInsets
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getTextInsets
	 * @description Retrieve the value of the <code>textInsets</code> property.
	 * @returns {Array (Number)} The curent value for <code>textInsets</code>.
	 * @see UI.Button#setTextInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizeCompoundProperty('textInsets', Commands.setTextInsets);
	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'disabled': Commands.State.Disabled,
		//** extra-deprecated */
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Button." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			Button.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('text');
	bindStateProperties('textColor');
    bindStateProperties('textFont');
	bindStateProperties('textShadow');
	bindStateProperties('gradient');
	bindStateProperties('image');
    bindStateProperties('imageBorder');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/GLView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/GLView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/GLView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var GLView = exports.GLView = AbstractView.subclass(
/** @lends UI.GLView.prototype */
{
	'type':'glview',
	/**
	* @class The <code>GLView</code> class constructs objects that provide applications with access to OpenGL. Games must instantiate a <code>GLView</code> object, 
	* set the active state to <code>true</code> and wait for the callback before instantiating any objects in the {@link GL2} module.
	* @name UI.GLView
	* @augments UI.AbstractView	
	*/
	initialize: function($super, properties) {
		if (GLView._init) GLView._init();
		$super(properties);
	}
});

GLView._init = function() {
	delete GLView._init;
	if (AbstractView._init) AbstractView._init();

	/**
	 * @name UI.GLView#setActive
	 * @description Set the value of the <code>active</code> property.
	 * @example var glView = new UI.GLView()
	 * ...
	 * glView.setActive(true);
	 * @param {Boolean} active Set as <code>true</code> if the <code>GLView</code> object is active.
	 * @see UI.GLView#getActive
	 * @status iOS, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.GLView#getActive
	 * @description Retrieve the value of the <code>active</code> property.
	 * @returns {Boolean} Returns <code>true</code> if the <code>GLView</code> object is active.
	 * @see UI.GLView#setActive
	 * @status iOS, Android, Flash, Test
	 * @function
	 */
	GLView.synthesizeProperty('active', Commands.setActive);
	
	/**
	 * @name UI.GLView#getOGLExtensions
	 * @description Return an array containing all of the OpenGL extensions that are supported within the context of this view.
	 * The return value of this method is only valid when the view is active.
	 * @status Android
	 * @function
	 */
	GLView.registerAccessors('OGLExtensions', function() {return this['_OGLExtensions'];}, function() {} );
	
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/NavController'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/NavController'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/NavController'] = exports; var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
var KeyEmitter = require('NGCore/Client/Device/KeyEmitter').KeyEmitter;
var Window = require('NGCore/Client/UI/Window').Window;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var Device = require('NGCore/Client/Device').Device;
var Element = require('NGCore/Client/UI/Element').Element;
var View = require('NGCore/Client/UI/View').View;

function getAnalyticsName(item){
	if(item && item.hasOwnProperty("analyticsName")){
		return item["analyticsName"] || undefined;	// If NULL, return undefined.
	}
	return undefined;
}

var NavKeyListener = MessageListener.subclass({
	classname: "UI_NavController_KeyListener",
});

var NavController = exports.NavController = View.subclass(
/** @lends UI.NavController.prototype */
{
	/**
	 * @class The <code>NavController</code> class constructs objects that define application navigation components.
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {String} properties Object properties.
	 */
	initialize: function($super, properties) {
		if (NavController._init) NavController._init();
		
	    this.navStack = [];
		var onAndroid = Capabilities.getPlatformOS() == 'Android';
	    this._useBackButton = !onAndroid;
	
		this.keyListener = new NavKeyListener();
		KeyEmitter.addListener(this.keyListener, this.onKeyPressed.bind(this));
		$super(properties);
	},
	
	/**
	 * Turn on the onscreen <b>Back</b> button. Applications designed for iOS should always provide the <b>Back</b> button 
	 * and integrate it into the application UI (calling <code>{@link UI.NavController#back}</code> when pressed).<br><br>
	 * <b>Note:</b> This is turned off by default for applcations designed for Android because Android devices contain a hardware <b>Back</b> button.
	 * @param {Boolean} toUse Set as <code>true</code> to enable the onscreen <b>Back</b> button.
	 * @function
	 * @status Javascript, iOS, Android, Flash
	 */
	setUseBackButton: function(toUse) {
		this._useBackButton = toUse;
		if (toUse) {
			this._createBackButton();
		} else if (this.backButton) {
			this.backButton.removeFromParent();
		}
	},
    
	/**
	 * Reset the stack for this <code>NavController</code>.
	 * @param {String} fromButton The button to reset.
	 * @status Javascript, iOS, Android, Flash
	 */    
	clear: function(fromButton) {
		return this.backToView(undefined);
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	logNavEvent: function (from, to, via) {
		var toName = getAnalyticsName(to);
		var fromName = getAnalyticsName(from);
		var viaName = getAnalyticsName(via);
		if (fromName || toName) {
			Core.Analytics._getPipe().navigationEvent(fromName, toName, viaName);
		}
	},
	
	/**
	 * Retrieve the top view from the nav stack of this <code>NavController</code>.
	 * @returns {Object} The top view in the nav stack
	 * @status Javascript, iOS, Android, Flash
	 * @function
	 */
	getTopView: function() {
		return (this.navStack.length > 0) ? this.navStack[ (this.navStack.length - 1) ] : undefined;
	},
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	*/
	navStackDepth: function() {
		return this.navStack.length;
	},
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	*/
	depthOfView: function(targetView) {
		var targetIndex = this.navStack.indexOf(targetView);
		if(targetIndex == -1){return -1;}
		
		return this.navStack.length - targetIndex - 1;
	},
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	*/
	viewAtDepth: function(targetDepth) {
		if(targetDepth >= this.navStack.length){
			return null;
		}
		return this.navStack[this.navStack.length - targetDepth - 1];
	},
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	*/
	removeDeepView:function(targetView) {
		var targetIndex = this.navStack.indexOf(targetView);
		if(targetIndex == -1){
			NgLogE("NavController: trying to remove a nonexistent view from the nav stack!");
			return;
		}
		this.navStack.splice(targetIndex,1);
	},
    
	/**
	 * @protected
	 * @status Javascript, iOS, Android, Flash
	 * @function
	 */
	_viewTransition: function(fromView, toView, back, buttonRef) {
		//The views transition within the container (which is 'this')
		var myFrame = this.getFrame();
		var w = myFrame[2];
		var h = myFrame[3];
		
		//TODO: animate this (below) transition.
		if (toView) {
			toView.setFrame( (back ? -w : w), 0, w, h);
			this.addChild(toView);
		}
		
		UI.animate(function() {
			if (fromView) fromView.setFrame( (back ? w : -w), 0, w, h);
			if (toView) toView.setFrame(0, 0, w, h);
		}, 400, function() {
			if (fromView) fromView.removeFromParent();
		});
		
		this.logNavEvent(fromView, toView, buttonRef);
		this._createBackButton();
	},

	/**
	 * Retrieve removed views in the reverse order they were removed.
	 * @example var page = new NavPage({...});
	 *
	 * var controller = new UI.NavController({...});
	 *
	 * NavPage.navController = controller;
	 * controller.forwardToView(page);
	 * @param {String} destView The destination view for this navigation component.
	 * @param {String} fromButton The button that triggers this navigation component.
	 * @status Javascript, iOS, Android, Flash
	 * @see UI.NavController#backToView
	 */    
	forwardToView: function(destView, fromButton) {
		var currentView = this.getTopView();
		if (destView && 
			(!this._delegate 
				|| (this._delegate 
					&& typeof this._delegate.navControllerShouldPush == "function" 
					&& this._delegate.navControllerShouldPush(this,destView))
			)) {
			
			destView.performEventCallback({eventType:"push",navController:this})
			
			this.navStack.push(destView);
			this._viewTransition(currentView, destView, false, fromButton);
		}
	},
    
	/**
	 * Set back navigation for this <code>NavController</code>.
	 * @param {String} fromButton The button that triggers this navigation component.
	 * @status Javascript, iOS, Android, Flash
	 * @see UI.NavController#forward	
	 */
	back: function(fromButton) {
		var removed = this.navStack.pop();
		
		if (removed && 
			(!this._delegate 
				|| (this._delegate 
					&& typeof this._delegate.navControllerShouldPop == "function" 
					&& this._delegate.navControllerShouldPop(this,removed))
			)) {
			removed.performEventCallback({eventType:"pop",navController:this});
		} else {
			return null;
		}
		this._viewTransition(removed, this.getTopView(), true, fromButton);
		return removed;
	},

	/**
	 * Retrieve removed views in the order they were removed.
	 * @example var page = new NavPage({...});
	 *
	 * var controller = new UI.NavController({...});
	 *
	 * NavPage.navController = controller;
	 * controller.backToView(page);
	 * @param {String} destView The destination view for this navigation component.
	 * @param {String} fromButton The button that triggers this navigation component.
	 * @status Javascript, iOS, Android, Flash
	 * @see UI.NavController#forwardToView
	 */    
	backToView: function(destView, fromButton) {
		var removedSet = [];
		var removed = this.navStack.pop();
		var originalView = removed;
		if (removed) {
			do {
				if (removed && 
					(!this._delegate 
						|| (this._delegate 
							&& typeof this._delegate.navControllerShouldPop == "function" 
							&& this._delegate.navControllerShouldPop(this,removed))
					)) {
					removedSet.push(removed);
					removed.performEventCallback({eventType:"pop",navController:this});
				}
				else {
					//There was nothing to remove, or the this._delegate said "don't remove".
					break;
				}
				
				if (this.getTopView() == destView){break;}
			} while ((removed = this.navStack.pop()));
		}
		if(removedSet.length > 0) {
			this._viewTransition(originalView, this.getTopView(), true, fromButton);
		}
		return removedSet;
	},

	/**
	 * Set this <code>NavController</code> to launch the application when activated.
	 * @status Javascript, iOS, Android, Flash
	 */    
	loadApp: function() {		
	},
    
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */    
	onBackPressed: function() {
		if (this.navStack.length > 1) {
		//	NgLogD("Handle back on nav stack. Number of views on stack=" + this.navStack.length);
			
			var analyticsName = "bcksbtn"; // Back System Button
			
			// if the topmost view has an analytics name, prefix the button
			var topView = this.getTopView();
			if(topView.analyticsName){
				analyticsName = topView.analyticsName + "." + analyticsName;
			}

			this.back({
				analyticsName: analyticsName
			});
			return true;
		}
		return false;
	},
	
	onKeyPressed: function(event) {
		if ((event.code === Device.KeyEmitter.Keycode.back) && (this.navStack.length > 1)) {
			this.back();
			return true;
		}
		return false;
	},
	
	/**
	 * @protected
	 * @status Javascript, iOS, Android, Flash
	 */
	_delegate:null,
	/**
	 * @description Set subscribers to the <code>NavController</code> behavior. Subscribers can modify what happens. 
	 * NavControllerDelegateProtocol:
	 *	@optional - (BOOL)navControllerShouldPop(NavController,View)
	 *	@optional - (BOOL)navControllerShouldPush(NavController,View)
	 * @param {String} navDelegate A <code>NavController</code> subscriber.
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	setDelegate:function( /*NavControllerDelegate*/ navDelegate){
		this._delegate = navDelegate;
	},
	
	delegate:function(){return this._delegate;},
	
	/**
	 * @protected
	 * @status Javascript, iOS, Android, Flash
	 * @function
	 */
	_createBackButton: function() {
		// Do nothing if this device does not require an onscreen button.
		if (!this._useBackButton) return;
		
		if (!this.backButton) {
			this.backButton = new UI.Button({
				normalText: 'Back',
				textSize: 13.0,
				normalTextColor: "FF",
				normalTextShadow: "00 1.5 {0,-1}",
				frame: [-2, 20, Window.outerWidth / 5, Window.outerHeight / 12],
				normalGradient: {
					corners: "0 8 8 0",
					outerLine: "00 1.5",
					innerShadow: "99FF 2.0 {0,-1}",
					gradient: [
						"FFCC 0.0",
						"FF80 1.0"
					]
				},
				highlightedGradient: {
					corners: "0 8 8 0",
					outerLine: "00 1.5",
					innerLine: "FF00 15 {0,-1}",
					gradient: [
						"FF50 0.0",
						"FF80 1.0"
					]
				}
			});
			this.backButton.onclick = this.bind(this.onBackPressed);
		}
		
		if (this.navStack.length > 1) {
			if (!this.backButton.getParent()) Window.document.addChild(this.backButton);
		} else if ( this.backButton.getParent() ) {
			this.backButton.removeFromParent();
		}
	}
});

NavController._init = function() {
	delete NavController._init;
	if (View._init) View._init();
}; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/WebView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/WebView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/WebView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var WebView = exports.WebView = AbstractView.subclass(
/** @lends UI.WebView.prototype */
{
	'type':'webview',

	/**
	 * @class The <code>WebView</code> class constructs objects for loading and navigating documents. 
	 * <code>WebView</code> objects also trigger event callback functions when web page events occur.
	 * @constructs The default constructor. 
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {String} properties Object properties.
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (WebView._init) WebView._init();
		this._canGoBack = false;
		this._canGoForward = false;
		return $super(properties);
	},
	
	/** @private */
	_onShouldLoad: function(event) {
		NgLogD("Should Load " + event.url + " ???????");
		var fn = this.getOnShouldload();
		if (typeof fn == 'function') {
			// If we SHOULDN'T load the url, bail.
			if (!Boolean(fn.call(this, event))) return;
		}
		// The default (if the function was missing or not a function) is to load the url.
		this.loadUrl(event.url);
	},
	
	/** @private */
	performEventCallback: function($super, event) {
		try {
			if (event.eventType == 'shouldload') {
				// We need to call the onShouldLoad function in a way that captures the return value.
				this._onShouldLoad(event);
				return;
			}
			if (event.eventType == 'pageload') {
				// Do not touch this parsing code. Everything else is wrong, extensive testing was done.
				this._canGoBack = event.canGoBack = Boolean(JSON.parse(event.canGoBack));
				this._canGoForward = event.canGoForward = Boolean(JSON.parse(event.canGoForward));
			}
			$super(event);
		} catch(e) {
			NgHandleException(e);
		}
	},
	// invoke doesn't return a value. to get response, use onpageevent
	/**
	* Run a string of Javascript code in this <code>WebView</code>. Any code requiring a result from <code>invoke()</code> must explicitly 
	* return a value by attempting to load an ngcore:// URL. The attempted load is caught by <code>pageEvent</code>. 
	* @see UI.WebView#event:setOnPageevent
	* @function
    * @status iOS, Android
	*/
	invoke: Commands.invoke,
	/**
	* Set a document to load from the specified URL.
	* @example myWebView = new UI.WebView();
	* ...
	* myWebView.loadUrl('http://www.webdoc.com/");
	* @param {String} url The URL from which to load a document.
	* @param {String} [headers] The document headers.
	* @param {Number} [timeout] The timeout duration.
	* @see UI.WebView#loadDocument
    * @status iOS, Android
	*/
	loadUrl: function(url, headers, timeout) {
		Commands.loadURL.call(this, url, headers || null, +(timeout || 0));
	},
	/**
	* Set a document to load from the specified local path.
	* @example myWebView = new UI.WebView();
	* ...
	* myWebView.loadUrl('./path/to/document/");
	* @param {String} relativePath The local path from which to load a document.
	* @see UI.WebView#loadUrl
    * @status iOS, Android
	*/
	loadDocument: function(relativePath){
		Commands.setSourceDocument.call(this, relativePath);
	},
	/**
	* Load a URL using the HTTP <code>POST</code> method.
	* @param {String} url The URL to load using <code>POST</code>.
	* @param {String / Object} data A string containing the raw <code>POST</code> body, or an object to post with <code>www/form-data</code> encoding containing key/value pairs.
	* @see UI.WebView#loadUrl,
	* @see UI.WebView#loadDocument
    * @status iOS, Android
	*/
	postUrl: function(url, data){
		var dataStr;
		if(typeof data == "object"){
			var params = [];
			for(var key in data){
				params.push(encodeURIComponent(key) + '=' + encodeURIComponent(data[key]));
			}
			dataStr = params.join('&');
		}else{
			dataStr = data;
		}
		Commands.postURL.call(this, url, dataStr);
	},
	/**
	* Stop loading a document. 
	* @function
    * @status iOS, Android
	*/
	stopLoading: Commands.stopLoading,
	/**
	* Reload a document called with <code>loadDocument()</code> or <code>loadUrl()</code>.
	* @see UI.WebView#loadDocument,
	* @see UI.WebView#loadUrl
	* @function
    * @status iOS, Android
	*/
	reload: Commands.reload,
	/**
	* Navigate to the previous page in a document view.
	* @see UI.WebView#goForward
	* @function
    * @status iOS, Android
	*/
	goBack: Commands.goBack,
	/**
	* Navigate to the next page in a document view.
	* @see UI.WebView#goBack
	* @function
    * @status iOS, Android
	*/
	goForward: Commands.goForward,
	/**
	* Set back navigation as supported in this <code>WebView</code>.
	* @returns {Boolean} Returns <code>true</code> if this <code>WebView</code> supports back navigation.
	* @see UI.WebView#canGoForward
    * @status iOS
	*/
	canGoBack: function(){
		return this._canGoBack;
	},
	/**
	* Set that forward navigation is supported in this <code>WebView</code>.
	* @returns {Boolean} Returns <code>true</code> if this <code>WebView</code> supports forward navigation.
	* @see UI.WebView#canGoBack
    * @status iOS
	*/
	canGoForward: function(){
		return this._canGoForward;
	},
	/**
	* Set the authentication credentials for this <code>WebView</code> session.
	* @param {String} host The authentication host.
	* @param {String} realm The security realm.
	* @param {String} username The username to use for authenticating the session.
	* @param {String} password The password to use for authenticating the session.
    * @status iOS, Android
	*/
	setBasicAuthCredential: function(host, realm, username, password){
		Commands.setBasicAuthCredentials.call(this, {'host':host, 'realm':realm, 'username':username, 'password':password});
	},

	setViewportEnabled: function(enabled) {
		Commands.setViewportEnabled.call(this, enabled);
	}
});

WebView._init = function() {
	delete WebView._init;
	if (AbstractView._init) AbstractView._init();
	
	WebView.synthesizeProperty('scrollable', Commands.setScrollable);
	
	/**
	 * @name UI.WebView#setOnStartload
	 * @description Set a function to call when the <code>startload</code> event occurs.
	 * @param {Function} startloadCallback The function to call.<br><br>
	 * <b>Note:</b> The <code>startload</code> event is disabled if the value of this parameter is not a function.
	 * @see UI.WebView#event:getOnStartload
	 * @event
	 * @status iOS, Android
	 */
	/**
	 * @name UI.WebView#getOnStartload
	 * @description Retrieve the function to call when the <code>startload</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.WebView#event:setOnStartload
	 * @event
	 * @status iOS, Android
	 */
	WebView.registerEventType('startload');
	/**
	 * @name UI.WebView#setOnPageload
	 * @description Set a function to call when the <code>pageload</code> event occurs.
	 * @param {Function} pageloadCallback The function to call.<br><br>
	 * <b>Note:</b> The <code>pageload</code> event is disabled if the value of this parameter is not a function.
	 * @see UI.WebView#event:getOnPageload
	 * @event
	 * @status iOS, Android
	 */
	/**
	 * @name UI.WebView#getOnPageload
	 * @description Retrieve the function to call when the <code>pageload</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.WebView#event:setOnPageload
	 * @event
	 * @status iOS, Android
	 */
	WebView.registerEventType('pageload');
	/**
	 * @name UI.WebView#setOnError
	 * @description Set a function to call when the <code>error</code> event occurs.
	 * @param {Function} [errorCallback] The function to call.<br><br>
	 * <b>Note:</b> The <code>error</code> event is disabled if the value of this parameter is not a function.
	 * @see UI.WebView#event:getOnError
	 * @event
	 * @status iOS, Android
	 */
	/**
	 * @name UI.WebView#getOnError
	 * @description Retrieve the function to call when the <code>error</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.WebView#event:setOnError
	 * @event
	 * @status iOS, Android
	 */
	WebView.registerEventType('error');
	/**
	 * @name UI.WebView#setOnPageevent
	 * @description Set a function to call when the <code>pageevent</code> event occurs.
	 * @param {Function} pageeventCallback The new callback function.<br><br>
	 * <b>Note:</b> The <code>pageevent</code> event is disabled if the value of this parameter is not a function.
	 * @see UI.WebView#event:getOnPageevent
	 * @event
	 * @status iOS, Android
	 */
	/**
	 * @name UI.WebView#getOnPageevent
	 * @description Retrieve the function to call when the <code>pageevent</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.WebView#event:setOnPageevent
	 * @event
	 * @status iOS, Android
	 */
	WebView.registerEventType('pageevent');	
	/** 
	* @name UI.WebView#setOnShouldLoad
	* @description Set a function to call when the <code>shouldload</code> event occurs. The callback for the event returns 
	* <code>true</code> if the page should be loaded. Otherwise, the callback returns <code>false</code>.
	* @param {function} shouldloadCallback The new callback function.<br><br>
	* <b>Note:</b> The <code>shouldload</code> event is disabled if the value of this parameter is not a function.
	* @example  myWebView.setOnShouldload( function(event) {
	NgLogD("URL is " + event.url);
	NgLogD("Nav Type is " + event.navigation);
  } );
	* @see UI.WebView#event:getOnShouldLoad
	* @event
	*/
	/**
	* @name UI.WebView#getOnShouldLoad
	* @description Retrieve the function to call when the <code>shouldload</code> event occurs.
	* @returns {function} The current callback function.
	* @see UI.WebView#event:setOnShouldLoad
	* @event
	*/
	WebView.registerEventType('shouldload');
	
	/** 
	* @name UI.WebView#setOnExternalLink
	* @description Set a function to call when a link will be opened in an external application.
	* @param {function} ExternalLinkCallback The new callback function.<br><br>
	* @see UI.WebView#event:getOnExternalLink
	* @event
	*/
	/**
	* @name UI.WebView#getOnExternalLink
	* @description Retrieve the function to call when the <code>ExternalLink</code> event occurs.
	* @returns {function} The current callback function.
	* @see UI.WebView#event:setOnExternalLink
	* @event
	*/
	WebView.registerEventType('externalLink');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ScrollView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ScrollView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ScrollView'] = exports; var View = require('NGCore/Client/UI/View').View;
var ViewGeometry = require('NGCore/Client/UI/ViewGeometry');
var Commands = require('NGCore/Client/UI/Commands').Commands;

var ScrollView = exports.ScrollView = View.subclass(
/** @lends UI.ScrollView.prototype */
{
	'type':'scrollview',
	/**
	* @class The <code>ScrollView</code> class constructs objects that handle views in a scrolling list (see <code>{@link UI.ListView}</code>). 
	* You can define these views as scrolling vertically, horizontially, or both directions.<br><br>
	* <b>Note:</b> Android devices can only scroll in one direction at a time.
	* @name UI.ScrollView
	* @augments UI.View
	*/
	initialize: function($super, properties) {
		if (ScrollView._init) ScrollView._init();
		this._scrollPosition = [0, 0];
		return $super(properties);
	},
	
	/**
	 * @private
	 */    
	updateScrollPosition: function(newVal) {
		this._scrollPosition = newVal;
	},
	
	/**
	 * @private
	 */    
	performEventCallback: function($super, e) {
		if (e.eventType == 'scroll') this.updateScrollPosition(e.scrollPosition);
		$super(e);
	}
});

// Properties
ScrollView._init = function() {
	delete ScrollView._init;
	if (View._init) View._init();

	/**
	 * @name UI.ScrollView#setContentSize
	 * @description Set the value for the <code>contentSize</code> property. This property defines the size of a scroll area.
	 * @example var dialog = {
	 * 	width: screen.width * sizeRate.width / 100,
	 *	height: screen.height * sizeRate.height / 100
	 * };
	 * ...
	 * this.scrollView.setContentSize([dialog.width, 600]);
	 * @params {Number, Array (Number, String)} Individual components or a component array.
	 * @see UI.ScrollView#getContentSize
	 * @function
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.ScrollView#getContentSize
	 * @description Retrieve the value of the <code>contentSize</code> property.
	 * @returns {Number, Array (Number, String)} The current value of <code>contentSize</code>.
	 * @see UI.ScrollView#setContentSize
	 * @function
     * @status iOS, Android, Test
	 */
	ScrollView.synthesizeCompoundProperty('contentSize', Commands.setScrollableSize);
	/**
	 * @name UI.ScrollView#setScrollPosition
	 * @description Set the value for the <code>scrollPosition</code> property.
	 * @example var hscroller = new UI.ScrollView();
	 * ...
	 * hscroller.setScrollPosition([0.5,0]);
	 * @params {Number, Array (Number)} Individual components or a component array.
	 * @see UI.ScrollView#getScrollPosition
	 * @function
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.ScrollView#getScrollPosition
	 * @description Retrieve the value of the <code>scrollPosition</code> property.
	 * @returns {Number, Array (Number)} The current value of <code>scrollPosition</code>.
	 * @see UI.ScrollView#setScrollPosition
	 * @function
     * @status iOS, Android, Test
	 */
	ScrollView.synthesizeCompoundProperty('scrollPosition', Commands.setScrollPosition);
	
	/**
	 * @name UI.ScrollView#setScrollIndicatorsVisible
	 * @description Set the value for the <code>scrollIndicatorsVisible</code> property.
	 * @example var hscroller = new UI.ScrollView();
	 * ...
	 * hscroller.setScrollIndicatorsVisible(false);
	 * @params {Boolean} Whether scroll indicators should be visible.
	 * @see UI.ScrollView#getScrollIndicatorsVisible
	 * @function
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.ScrollView#getScrollIndicatorsVisible
	 * @description Retrieve the value of the <code>scrollIndicatorsVisible</code> property.
	 * @returns {Boolean} Whether scroll indicators will be visible during scrolling.
	 * @see UI.ScrollView#setScrollIndicatorsVisible
	 * @function
     * @status iOS, Android, Test
	 */
	ScrollView.synthesizeCompoundProperty('scrollIndicatorsVisible', Commands.setScrollIndicatorsVisible);

	/**
	 * @name UI.ScrollView#setOnScroll
	 * @description Set a function to call when the <code>scroll</code> event occurs.
	 * @param {Function} scrollCallback The new callback function.<br><br>
	 * <b>Note:</b> The <code>scroll</code> event is disabled if the value of this parameter is not a function.
	 * @see UI.ScrollView#event:getOnScroll
	 * @event
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.ScrollView#getOnScroll
	 * @description Retrieve the function to call when the <code>scroll</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.ScrollView#event:setOnScroll
	 * @event
     * @status iOS, Android, Test
	 */
	ScrollView.registerEventType('scroll');
	
	ScrollView.registerEventType('scrollEnded');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ListView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ListView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ListView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var ScrollView = require('NGCore/Client/UI/ScrollView').ScrollView;
var ViewGeometry = require('NGCore/Client/UI/ViewGeometry');

var ListView = exports.ListView = ScrollView.subclass(
/** @lends UI.ListView.prototype */
{
	'type':'listview',
	/**
	* @class The <code>ListView</code> class constructs objects that contain <code>{@link UI.ListViewItem}</code> and <code>{@link UI.ListViewSection}</code> objects. 
	* These objects handle and render scrolling lists in an application.
	* A <code>ListView</code> object can contain potentially thousands of items, 
	* in sections, that use a pool of reusable views to display content.
	* @name UI.ListView
	* @augments UI.ScrollView
	*/
	initialize:function($super, properties) {
		if (ListView._init) ListView._init();
		$super(properties);
		
		this._sections = [];
		this._scrollPosition = [0,0];
		this.enableEvent('scroll', true);
		
		this._ownedViews = [];
		this._queuedViews = {};
		
		this._cellDivider = 0;
		
		return this;
	},
	
	destroy: function($super) {
		var l = this._ownedViews.length;
		for (var i = 0; i < l; i++) {
			this._ownedViews[i].release();
		}
		this._ownedViews = null;
		$super();
	},
	
	addChild: function($super, child, index) {
		if (index == "cell") {
			index = this._cellDivider++;
		} else if ((index || -1) >= 0) {
			index += this._cellDivider;
		}
		$super(child, index);
	},
	
	_viewForItem: function(lvItem) {
		if (lvItem._currentView instanceof AbstractView) return lvItem._currentView;
		
		var rID = lvItem._reuseId;
		var queue = this._queuedViews[rID];
		
		var view = null;
		while (queue && queue.length > 0) {
			if ((view = queue.pop()) instanceof AbstractView) break;
		}
		
		if (!(view instanceof AbstractView)) {
			view = lvItem._onCreateView(lvItem);
			if (view instanceof AbstractView) {
				this._ownedViews.push(view.retain());
				this.addChild(view, "cell");
			} else {
				console.log("Error creating view for list item with reuse id " + rID);
			}
		}
	//	console.log("_viewForItem: " + lvItem + " = " + view);
		return view;
	},
	
	_queueViewForItem: function(lvItem) {
		var viewToQueue = lvItem._currentView;
		if (viewToQueue instanceof AbstractView) {
			var rId = lvItem._reuseId;
			var queue = this._queuedViews[rId] || (this._queuedViews[rId] = []);
			queue.push(viewToQueue);
		}
		lvItem._setCurrentView();
	},
	
	_removeQueuedViews: function() {
		for (var q in this._queuedViews) {
			if (!this._queuedViews.hasOwnProperty(q)) continue;
			
			q = this._queuedViews[q];
			for (var i = 0, l = q.length; i < l; i++) {
				q[i].removeFromParent();
			}
		}
		this._cellDivider = 0;
	},
	
	/**
	 * @private
 	 * @status Javascript, iOS, Android, Flash
	 */
	flushSections: function() {
		for (var i in this._sections) {
			if(!this._sections.hasOwnProperty(i)) { continue; }
				
			var section = this._sections[i];
			// Cause every section to completely queue out its item views.
			section.flush();
			section.calculateItemPositions();
		}
		this._removeQueuedViews();
	},
	
	/**
	 * Clear this <code>ListView</code> and reload all list data.
	 * @see UI.ListViewItem,
	 * @see UI.ListViewSection
 	 * @status Javascript, iOS, Android, Flash
	 */
	reloadData: function() {
		this.flushSections();
		this.calculateSectionPositions();
		this.updateScrollPosition(this._scrollPosition);
	},
	
	/**
	 * Retrieve all contained sections by this <code>ListView</code>.
	 * @returns {Object} The current section list as an array of section IDs.
	 * @see UI.ListView#setSections
 	 * @status Javascript, iOS, Android, Flash
	 */
	getSections: function() {
		return this._sections;
	},
	
	/**
	 * Set the list of sections that this <code>ListView</code> contains.
	 * @example var sections = [];
	 * var section = new UI.ListViewSection;
	 * ...
	 * var items = [];
	 * for(news in News)
	 * {
	 *	var item = new ListItem.ListItem();
	 *	item.game = News[news];
	 *	items.push(item);
	 * }
	 *
	 * section.setItems(items);
	 * sections.push(section);
	 *
	 * gameNews.setSections(sections);
	 * @param {Object} newSections A new aray of section IDs.
	 * @see UI.ListView#getSections
 	 * @status Javascript, iOS, Android, Flash
	 */
	setSections: function(newSections) {
		this.flushSections();
		for (var i in this._sections) {
			if(this._sections.hasOwnProperty(i)) {
				this._sections[i].setListView(null);
			}
		}
		this._sections = newSections;
		var idArray = new Array();
		for (var i in newSections) {
			if(newSections.hasOwnProperty(i)) {
				idArray.push(0+(newSections[i].__objectRegistryId || 0));
			}
		}
		UI.Commands.setSections.call(this, idArray);
		this.reloadData();
	},
	
	/**
	 * @private
 	 * @status Javascript, iOS, Android, Flash
	 */
	calculateSectionPositions: function() {
		this._stackedSections = {};
		topY = 0;
		// Should account for header here.
		var l = this._sections.length;
		for (var i = 0; i < l; i++) {
		//	NgLogD("Calculating height for Section " + i + " / " + l + " from yPos " + topY);
			var section = this._sections[i];
			this._stackedSections[topY] = section;
			section.setListView(this);
			section.setYPosition(topY);
			var relTopY = this._scrollPosition[1/*y*/] - topY;
			section.updateVisibleRange(relTopY, relTopY + this._frame[3/*h*/]);
			var h = section._measureHeight();
			// Set the section's frame...
			section._setFrame(0, topY, this._frame[2], h);
			topY += h;
		}
		// Should account for footer here.
		this.setContentSize([this._frame[2], topY]);
	},
	
	/**
	 * @private
 	 * @status Javascript, iOS, Android, Flash
	 */
	updateScrollPosition:function(newVal) {
		if (this._scrollPosition[1] === newVal[1]) return;
		this._scrollPosition = newVal;
		
		var myHeight = this._frame[3];
		for (var yPos in this._stackedSections) {
			if(this._stackedSections.hasOwnProperty(yPos)) {
				var section = this._stackedSections[yPos];
				relTopY = newVal[1] - yPos;
				section.updateVisibleRange(relTopY, relTopY + myHeight);
			}
		}
	},
	
	/**
	 * @protected
 	 * @status Javascript, iOS, Android, Flash
	 */
	'_onScroll': function() {},
	
	/**
	 * @private
 	 * @status Javascript, iOS, Android, Flash
	 */
	enableEvent: function($super, eventName, enable) {
		// Don't allow scrolling events to be turned off!
		if ( (eventName == 'scroll') && !enable ) return;
		$super(eventName, enable);
	}
});

ListView._init = function() {
	delete ListView._init;
	if (ScrollView._init) ScrollView._init();

	/**
	 * @name UI.ListView#setHeader
	 * @description Set the value for the <code>header</code> property. This string is used as a header for the <code>ListView</code>.
	 * @example var friendHeader = mew UI.ListView();
	 * ...
	 * friendHeader.setHeader('Friends List');
	 * @param {String} header The new header.
	 * @see UI.ListView#getHeader
	 * @function
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.ListView#getHeader
	 * @description Retrieve the value of the <code>header</code> property.
	 * @returns {String} The current header.
	 * @see UI.ListView#setHeader
	 * @function
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	ListView.synthesizeProperty('header');
	/**
	 * @name UI.ListView#setFooter
	 * @description Set the value for the <code>footer</code> property. This string is used as a footer for the <code>ListView</code>.
	 * @example var friendFooter = mew UI.ListView();
	 * ...
	 * friendHeader.setHeader('This is a footer');
	 * @param {String} footer The new footer.
	 * @see UI.ListView#getFooter
	 * @function
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.ListView#getFooter
	 * @description Retrieve the value of the <code>footer</code> property.
	 * @returns {String} The current footer.
	 * @see UI.ListView#setFooter
	 * @function
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	ListView.synthesizeProperty('footer');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ListViewSection'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ListViewSection'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ListViewSection'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var ViewGeometry = require('NGCore/Client/UI/ViewGeometry');
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var ListViewItem = require('NGCore/Client/UI/ListViewItem').ListViewItem;

/* This class does not have a physical view representation.
	We still fully map and register it so that sections can be persisted independently of tables. */

var ListViewSection = exports.ListViewSection = Element.subclass(
/** @lends UI.ListViewSection.prototype */
{
	'type':'listview-section',
	/**
	* @class The <code>ListViewSection</code> class constructs objects that contain <code>ListViewItem</code> objects. 
	* These objects are rendered as individual sections of a scrolling list (see <code>{@link UI.ListView}</code>).
	* @name UI.ListViewSection
	* @augments UI.Element
	*/
	initialize:function($super, properties) {
		if (ListViewSection._init) ListViewSection._init();
		
		this._visibleRange = [0,0];
		this._headerHeight = 0;
		this._titleHeight = 0;
		
		delete this._measuredHeight;
		this._needsLayout = false;
		
		$super(properties);
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	addItemToVisible: function(lvItem, index) {
		if (!(lvItem instanceof ListViewItem)) return;
		if (lvItem._currentView instanceof Element) return;
		
		var useView = this._listView._viewForItem(lvItem);
		var w = this._listView.getFrame()[2];
		
		if (this._rowHeight > 0) {
			useView.setFrame(0, this._yPosition + this._titleHeight + index * this._rowHeight, w, this._rowHeight);
		} else {
			useView.setFrame(0, this._yPosition + this._cellPositions[index], w, lvItem._height);
		}
		
		lvItem._setCurrentView(useView);
		if (!useView.getParent()) this._listView.addChild(useView, "cell");
	},
	
	_setFrame: function(l, t, w, h) {
		UI.Commands.setFrame.call(this, l, t, w, h);
		if (this._titleView) {
			var f = this._titleView.getFrame();
			this._titleView.setFrame(l, t, w, f[3]);
		}
	},
	
	/**
	 * Reset the visible range for this <code>ListViewSection</code>.
	 * @function
	 * @status Javascript, iOS, Android, Flash
	 */
	flush: function() {
		for (var i = this._visibleRange[0], l = this._visibleRange[1]; i < l; i++) {
			this._listView._queueViewForItem(this._items[i]);
		}
		this._visibleRange = [0,0];
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	updateVisibleRange: function(topY, bottomY) {
		var totalH = this._getMeasuredHeight();
		
		// Expand the view window. This is really only necessary for Android...
		var l = this._items.length;
		var rowH = this._rowHeight > 0 ? this._rowHeight : totalH / l;
		topY -= rowH * 5;
		bottomY += rowH * 5;
		
		var oldStartIndex = this._visibleRange[0];
		var oldEndIndex = this._visibleRange[1];
		var startIndex = l > 0 ? Math.max(0, Math.floor(topY / rowH)) : 0;
		var endIndex = l > 0 ? Math.min(l, startIndex + Math.floor((bottomY - topY) / rowH)) : 0;
		
		if (this._cellPositions) {
			// We should have a good guess into the array from the above code,
			// so now it just needs to be adjusted until accurate.
			while (startIndex < l && this._cellPositions[startIndex] < topY) startIndex++;
			while (startIndex > 0 && this._cellPositions[startIndex] > topY) startIndex--;
			if (startIndex >= l) startIndex = Math.max(0, l - 1);
			
			while (endIndex < l && this._cellPositions[endIndex] < bottomY) endIndex++;
			while (endIndex > startIndex && this._cellPositions[endIndex] > bottomY) endIndex--;
		
			topY = this._cellPositions[startIndex];
			// EndIndex is one past the last element...
			bottomY = endIndex == 0 ? topY : (this._cellPositions[endIndex-1] + this._items[endIndex-1]._height );
		}
		if (bottomY < 0 || topY > totalH) {
			for (var i = this._visibleRange[0]; i < this._visibleRange[1]; i++) {
				this._listView._queueViewForItem(this._items[i]);
			}
			this._visibleRange = [0,0];
			return;
		}
		
		if (oldStartIndex == startIndex && oldEndIndex == endIndex) return;
		
//		NgLogD("(" + oldStartIndex + "," + oldEndIndex + ") -> (" + startIndex + "," + endIndex + ")");
		
		if (oldStartIndex == oldEndIndex) {
			for (var i = startIndex; i < endIndex; i++) {
				this.addItemToVisible(this._items[i], i);
			}
		} else {
			// Dequeue and requeue from both ends.
			if (oldStartIndex < startIndex) {
				do {
					this._listView._queueViewForItem(this._items[oldStartIndex]);
				} while (++oldStartIndex < startIndex);
			}
			if (oldEndIndex > endIndex) {
				while (oldEndIndex-- > endIndex) {
					this._listView._queueViewForItem(this._items[oldEndIndex]);
				}
				oldEndIndex = endIndex;	// Keep later codepath from triggering
			}
		
			if (oldStartIndex > startIndex) {
				while (oldStartIndex-- > startIndex) {
					this.addItemToVisible(this._items[oldStartIndex], oldStartIndex);
				}
				oldStartIndex = startIndex;
			} 
			if (oldEndIndex < endIndex) {
				do {
					this.addItemToVisible(this._items[oldEndIndex], oldEndIndex);
				} while (++oldEndIndex < endIndex)
			}
		
		}
		this._visibleRange = [startIndex, endIndex];
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	setListView : function(listView) {
		this._listView = listView;
		delete this._measuredHeight;
		return this;
	},
	
	_getMeasuredHeight : function() {
		return this._measuredHeight || this._measureHeight();
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	_measureHeight : function() {
		// Sum the heights of the rows.  No variable-heights yet!!!
		if (this._rowHeight < 0) {
			// Variable Height Trigger
			var totalHeight = this._titleHeight + this._headerHeight;
			var runningHeights = [];
			var l = this._items.length;
			for (var i = 0; i < l; i++) {
				runningHeights.push(totalHeight);
				totalHeight += this._items[i]._height;
			}
			this._cellPositions = runningHeights;
			return this._measuredHeight = totalHeight;
		}
		
		delete this._cellPositions;
		return this._measuredHeight = this._titleHeight + this._headerHeight + this._rowHeight * this._items.length;
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	calculateItemPositions: function() {
		// Not used?.
	},
});

ListViewSection._init = function() {
	delete ListViewSection._init;
	if (Element._init) Element._init();

	// We don't have a set pattern for sending the id of a view we want to assign by reference...
	/**
	 * @name UI.ListViewSection#setTitleView
	 * @description 
	 * @function
	 * @see UI.ListViewSection#getTitleView
 	 * @status Javascript, iOS, Android, Flash
	 */
	var boundTitleFunction = function() {
		if (this.listViewMonitor) this.listViewMonitor.setTitleView(this);
		boundTitleFunction._superfunc.apply(this, Array.prototype.slice.call(arguments));
	};
	var setTitleView = function(titleView) {
		if (this._titleView && this._titleView.listViewMonitor == this) {
			delete this._titleView.listViewMonitor;
		}
		this._titleView = titleView;
		
		if (!(titleView.listViewMonitor == this)) {
			titleView.listViewMonitor = this;
			if (!boundTitleFunction._superfunc) {
				boundTitleFunction._superfunc = titleView.setFrame;
			}
			if (titleView.setFrame != boundTitleFunction) {
				titleView.registerAccessors('frame', null, boundTitleFunction);
			}
		}
		
		this._titleHeight = titleView.getFrame()[3];
		delete this._measuredHeight;
		Commands.setTitleView.call(this, ObjectRegistry.objectToId(titleView));
		return this;
	}
	/**
	 * @name UI.ListViewSection#getTitleView
	 * @description 
	 * @function
	 * @see UI.ListViewSection#setTitleView
 	 * @status Javascript, iOS, Android, Flash
	 */
	var getTitleView = function() {
		return this._titleView;
	}
	/**
	 * @name UI.ListViewSection#setTitle
	 * @description Set the value for the <code>title</code> property.
	 * @param {String} title The new section title.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.ListViewSection#getTitle
	 * @function
	 */
	/**
	 * @name UI.ListViewSection#getTitle
	 * @description Retrieve the value of the <code>title</code> property.
	 * @returns {String} The current section title.
	 * @see UI.ListViewSection#setTitle
	 * @function
	 */
	ListViewSection.registerAccessors('titleView', getTitleView, setTitleView);
	
	// Other properties
	/**
	 * @name UI.ListViewSection#setRowHeight
	 * @description Set the value for the <code>rowHeight</code> property.
	 * @param {Number} rowHeight The new row height.
	 * @see UI.ListViewSection#getRowHeight
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.ListViewSection#getRowHeight
	 * @description Retrieve the value of the <code>rowHeight</code> property.
	 * @returns {Number} The current row height.
	 * @see UI.ListViewSection#setRowHeight
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	ListViewSection.synthesizeProperty('rowHeight');
	/**
	 * @name UI.ListViewSection#setItems
	 * @description Set the value for the <code>items</code> property.
	 * Setting this updates the visual state of the <code>listView</code> if the section is in a <code>listView</code> that is visible.
	 * @param {UI.ListViewItem} items The new <code>ListView</code> items.
	 * @see UI.ListViewSection#getItems
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	var setItems = function(newItems) {
		newItems = (newItems instanceof Array) ? newItems : Array.prototype.slice.call(arguments);
		
		this.flush();
		this._items = newItems;
		
		if (!this._listView) return;
		this._listView.reloadData();
		delete this._measuredHeight;
	}
	/**
	 * @name UI.ListViewSection#getItems
	 * @description Retrieve the value of the <code>items</code> property.
	 * @returns {UI.ListViewItem} The current <code>ListView</code> items.
	 * @see UI.ListViewSection#setItems
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	var getItems = function() {
		return this._items;
	}
	ListViewSection.registerAccessors('items', getItems, setItems);
	/**
	 * @name UI.ListViewSection#setYPosition
	 * @description Set the value for the <code>yPosition</code> property.
	 * @param {Number} yPosition The new position for <i>y</i>.
	 * @see UI.ListViewSection#getYPosition
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.ListViewSection#getYPosition
	 * @description Retrieve the value of the <code>yPosition</code> property.
	 * @returns {Number} The current position of <i>y</i>.
	 * @see UI.ListViewSection#setYPosition
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	ListViewSection.synthesizeProperty('yPosition');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ListViewItem'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ListViewItem'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ListViewItem'] = exports; /* This class does not have a physical view representation, and is just a holder for closures / a bag for data...
	We still fully map and register it so that sections can be persisted independently of tables. */
var Class = require('NGCore/Client/Core/Class').Class;

var ListViewItem = exports.ListViewItem = Class.subclass(
/** @lends UI.ListViewItem.prototype */
{	/**
	* @class The <code>ListViewItem</code> class constructs objects that contain data for individual items in a scrolling list (see <code>{@link UI.ListView}</code>).
	* @name UI.ListViewItem
	* @constructs The default constructor.
	* @augments Core.Class
	*/
	
	'type':'listview-item',
	
	_reuseId: "__default__",
	/** @protected */
	_currentView: null,
	
	/**
	 * @function
	 * @protected
 	 * @status Javascript, iOS, Android, Flash
	 */
	_onCreateView: function() {},
	/**
	 * @function
	 * @protected
 	 * @status Javascript, iOS, Android, Flash
	 */
	_onReleaseView: function(oldView) {},
	/**
	 * @function
	 * @protected
 	 * @status Javascript, iOS, Android, Flash
	 */
	_onSetView: function(newView) {},
	
	/**
	 * Set the callback for the <code>onCreateView</code> event. 
	 * This event must return a newly created view that displays the data type represented by the item.
	 * @param {Function} newFn The new function to call.
	 * @event
	 */
	setOnCreateView: function(newFn)	{this._onCreateView = newFn},
	/**
	 * Set the callback for the <code>onReleaseView</code> event. This event occurs when the view is set to <code>null</code>. 
	 * Use this to remove uncommon view states or clean up the view when necessary.
	 * @param {Function} newFn The new function to call.
	 * @event
	 */
	setOnReleaseView: function(newFn)	{this._onReleaseView = newFn},
	/**
	 * Set the callback for the <code>onSetView</code> event. When this event occurs, the item puts any relevant visual state / data into <code>newView</code>.
	 * This transfer should occur before the item is visible to the user:
	 * <pre class="code">onSetView(newView)</pre>
	 * @param {Function} newFn The new function to call.
	 * @event
	 */
	setOnSetView: function(newFn)		{this._onSetView = newFn},
	
	/**
	 * Set the height of the current ListViewItem in pixels.
	 * <pre class="code">setHeight(Number)</pre>
	 * This should occur before the item is visible to the user.
	 * This setting is only used when the item's ListViewSection has height = -1
	 * @param {Function} newFn The new function to call.
	 */
	setHeight: function(h) {
		this._height = h;
	},
	
	/**
	 * Get the current height of the ListViewItem.
	 * <pre class="code">getHeight()</pre>
	 * This should occur before the item is visible to the user.
	 * @returns {Number} The height of this ListViewItem.
	 */
	getHeight: function() {
		return this._height;
	},
	
	/**
	 * @function
	 * @protected
 	 * @status Javascript, iOS, Android, Flash
	 */
	_setCurrentView: function(newView) {
		if (newView instanceof Class) {
			this._onSetView(newView);
		} else {
			this._onReleaseView(this._currentView);
		}
		this._currentView = newView;
		return this;
	},
	
	/**
 	 * Retrieve the current view attached to this <code>ListViewItem</code>.
	 * @returns {UI.View} The current <code>ListViewItem</code> view.
	 * @status Javascript, iOS, Android, Flash
	 */
	getCurrentView: function(){
		return this._currentView;
	},
		
	initialize: function(reuseId) {
		if (reuseId) this._reuseId = reuseId;
		return this;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/CellView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/CellView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/CellView'] = exports; var View = require('NGCore/Client/UI/View').View;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var CellView = exports.CellView = View.subclass(
/** @lends UI.CellView.prototype */
{
	'type':'cell',
	/**
	* @class The <code>CellView</code> class constructs objects that handle cell views in an application. For example, a cell in a scrolling list.
	* These objects are rendered with images on the left and right, and two text areas (title and text) stacked vertically in the middle.
	* @name UI.CellView
	* @augments UI.AbstractView
	*/
	initialize: function($super, properties) {
		if (CellView._init) CellView._init();
		$super(properties);
	}
});

// Properties
CellView._init = function() {
	delete CellView._init;
	if (View._init) View._init();
	
	/**
	 * @name UI.CellView#setImage
	 * @description Set the value of the <code>image</code> property for a view state. This defines how a cell view appears for specific conditions. For example,
	 * set different images for a cell view in the default state and when the cell view has focus.
	 * @example background.setImage('./Content/blank.png', [w, h], [0, 0]);
	 * @param {String} image The new <code>image</code> URL.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.CellView#getImage
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.CellView#getImage
	 * @description Retrieve the value of the <code>image</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current <code>image</code> URL.
	 * @see UI.CellView#setImage
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	CellView.synthesizePropertyWithState('image', Commands.setImage);
	/**
	 * @name UI.CellView#setImageBorder
	 * @description Set the value of the <code>imageBorder</code> property for a view state. This property defines a border for images used in the specified view state.
	 * @param {Object} imageBorder The new value for <code>imageBorder</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.CellView#getImageBorder
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.CellView#getImageBorder
	 * @description Retrieve the value of the <code>imageBorder</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current value of <code>imageBorder</code>.
	 * @see UI.CellView#setImageBorder
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	CellView.synthesizePropertyWithState('imageBorder', Commands.setImageBorder);
	/**
	 * @name UI.CellView#setImageInsets
	 * @description Set the value of the <code>imageInsets</code> property. This property defines the viewable area of an image when applying gravity.
	 * @example background.setImageInsets([10,10,10,10]);
	 * @param {Number, Array (Number)} imageInsets The new value for <code>imageInsets</code>. Set as insets or an array of insets (float).
	 * @see UI.CellView#getImageInsets
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#getImageInsets
	 * @description Retrieve the value of the <code>imageInsets</code> property.
	 * @returns {Number, Array (Number)} The current value of <code>imageInsets</code>.
	 * @see UI.CellView#setImageInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	CellView.synthesizeCompoundProperty('imageInsets', Commands.setImageInsets);
	/**
	 * @name UI.CellView#setImageFit
	 * @description Set the value of the <code>imageFit</code> property. This property defines the scaling of bitmap images to fit within the bounds of a control 
	 * (subtracting the value for <code>imageInsets</code>).
	 * @example background.setImageFit(UI.FitMode.None);
	 * @param {Number} imageFit The new value for <code>imageFit</code>.
	 * @see UI.CellView#getImageFit
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#getImageFit
	 * @description Retrieve the value of the <code>imageFit</code> property.
	 * @returns {Number} The current value of <code>imageFit</code>.
	 * @see UI.CellView#setImageFit
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	CellView.synthesizeProperty('imageFit', Commands.setImageFitMode);
	/**
	 * @name UI.CellView#setImageGravity
	 * @description Set the value of the <code>imageGravity</code> property. This property defines how an image is positioned within a viewable area.
	 * @example background.setImageGravity([0.5, 0.0]);
	 * @param {Number} imageGravity The new value for <code>imageGravity</code> (expressed as two floats).
	 * @see UI.CellView#getImageGravity
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.CellView#getImageGravity
	 * @description Retrieve the value of the <code>imageGravity</code> property.
	 * @returns {Number} The current value of <code>imageGravity</code> (expressed as two floats).
	 * @see UI.CellView#setImageGravity
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	CellView.synthesizeProperty('imageGravity', Commands.setImageGravity);
	 /**
	 * @name UI.CellView#setImageTransform
	 * @description Set the value of the <code>imageTransform</code> property. This property defines data compression for images used with a cell view.
	 * @example background.setImageTransform([Math.cos(angle), Math.sin(angle), Math.sin(angle), Math.cos(angle), 0, 0]);
	 * @param {Array (Number)} imageTransform The new value for <code>imageTransform</code>. Set as an array of floats (<i>a</i>, <i>b</i>, <i>c</i>, <i>d</i>, <i>tx</i>, <i>ty</i>).
	 * @see UI.CellView#getImageTransform
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#getImageTransform
	 * @description Retrieve the value of the <code>imageTransform</code> property.
	 * @returns {Array (Number)} The current value of <code>imageTransform</code>.
	 * @see UI.CellView#setImageTransform
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	 CellView.synthesizeCompoundProperty('imageTransform', Commands.setImageTransform);
	/**
	 * @name UI.CellView#getRightImage
	 * @description Retrieve the value of the <code>rightImage</code> property in the specified view state.
	 * @returns {String} The current value of <code>rightImage</code>.
	 * @function
	 * @see UI.CellView#setRightImage
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setRightImage
	 * @description Set the value of the <code>rightImage</code> property in the specified view state. This defines how images used for UI controls appear for specific conditions. For example, 
	 * use seperate images for a closure arrow in the default state and a closure arrow when expanded.
	 * @example var cellClosure = new UI.CellView()
	 * ...
	 * cellClosure.setRightImage('./Content/closure.png', [w, h], [0, 0]);
	 * @param {String} rightImage The new value for <code>rightImage</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI State.
	 * @function
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getRightImage
	 */
	CellView.synthesizePropertyWithState('rightImage', Commands.setRightImage);
	/**
	 * @name UI.CellView#getRightImageBorder
	 * @description Retrieve the value of the <code>rightImageBorder</code> property in the specified view state. 
	 * @returns {Object} The current value of <code>rightImageBorder</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 * @see UI.CellView#setRightImageBorder
	 */
	/**
	 * @name UI.CellView#setRightImageBorder
	 * @description Set the value of the <code>rightImageBorder</code> property in the specified view state. This property defines a border for images used in the specified view state.
	 * @param {Object} rightImageBorder The new value for <code>rightImageBorder</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI View state.
 	 * @status iOS, Android, Test
	 * @function
	 * @see UI.CellView#getRightImageBorder
	 */
	CellView.synthesizePropertyWithState('rightImageBorder', Commands.setRightImageBorder);
	/**
	 * @name UI.CellView#getRightImageInsets
	 * @description Retrieve the value of the <code>rightImageInsets</code> property.
	 * @returns {Array (Number)} The current value of <code>rightImageInsets</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @see UI.CellView#setRightImageInsets
	 */
	/**
	 * @name UI.CellView#setRightImageInsets
	 * @description Set the value of the <code>rightImageInsets</code> property. This property defines the viewable area of an image when applying gravity.
	 * @example closureIcon.setRightImageInsets([10,10,10,10]);
	 * @param {Array (Number)} rightImageInsets The new value for <code>rightImageInsets</code>. Set as floats (<i>t</i>, <i>r</i>, <i>b</i>, <i>l</i>).
	 * @function
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getRightImageInsets
	 */
	CellView.synthesizeProperty('rightImageInsets', Commands.setRightImageInsets);
	/**
	 * @name UI.CellView#getRightImageFit
	 * @description Retrieve the value of the <code>rightImageFit</code> property. 
	 * @returns {Number} The current value of <code>rightImageFit</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @see UI.CellView#setRightImageFit
	 */
	/**
	 * @name UI.CellView#setRightImageFit
	 * @description Set the value of the <code>rightImageFit</code> property. This property defines the scaling of bitmap images to fit within the bounds of a control 
	 * (subtracting the value for <code>imageInsets</code>).
	 * @example closureIcon = new UI.CellView();
	 * ...
	 * closureIcon.setRightImageFit(UI.FitMode.None);
	 * @param {Number} rightImageFit The new value for <code>rightImageFit</code>.
	 * @function
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getRightImageFit
	 */
	CellView.synthesizeProperty('rightImageFit', Commands.setRightImageFitMode);
	/**
	 * @name UI.CellView#getRightImageGravity
	 * @description Retrieve the value of the <code>rightImageGravity</code> property. 
	 * @returns {Number} The current value of <code>rightImageGravity</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @see UI.CellView#setRightImageGravity
	 */
	/**
	 * @name UI.CellView#setRightImageGravity
	 * @description Set the value of the <code>rightImageGravity</code> property. This property defines how a image for a control is positioned within a viewable area.
	 * @example var closureIcon = new UI.CellView();
	 * ...
	 * closureIcon.setRightImageGravity([0.5, 0.0]);
	 * @param {Number} rightImageGravity The new value for <code>rightImageGravity</code>. Set as two floats (<i>x</i>, <i>y</i>).
	 * @function
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getRightImageGravity
	 */
	CellView.synthesizeProperty('rightImageGravity', Commands.setRightImageGravity);
	/**
	 * @name UI.CellView#getRightImageTransform
	 * @description Retrieve the value of the <code>rightImageTransform</code> property.
	 * @returns {Array (Number)} The current value of <code>rightImageTransform</code>.
	 * @see UI.CellView#setRightImageTransform
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	 /**
	 * @name UI.CellView#setRightImageTransform
	 * @description Set the value of the <code>rightImageTransform</code> property. This property defines data compression for images used with right image objects.
	 * @example var closureIcon = new UI.CellView();
	 * ...
	 * closureIcon.setRightImageTransform([Math.cos(angle), Math.sin(angle), Math.sin(angle), Math.cos(angle), 0, 0]);
	 * @param {Array (Number)} rightImageTransform The new value for <code>rightImageTransform</code>. 
	 * Set as six floats (<i>a</i>, <i>b</i>, <i>c</i>, <i>d</i>, <i>tx</i>, <i>ty</i>).
	 * @see UI.CellView#getRightImageTransform
 	 * @status iOS, Android, Test
	 * @function
	 */
	 CellView.synthesizeCompoundProperty('rightImageTransform', Commands.setRightImageTransform);
	 
	/**
	 * @name UI.CellView#getTitle
	 * @description Retrieve the value of the <code>title</code> property in a view state.
	 * @returns {String} The current value of <code>title</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 * @see UI.CellView#setTitle
	 */
	/**
	 * @name UI.CellView#setTitle
	 * @description Set the value of the <code>title</code> property for a view state. This property defines the title string for a view in the specified view state.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitle('Game of Foo');
	 * @param {String} title The new value for <code>title</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getTitle
	 * @function
	 */
	CellView.synthesizePropertyWithState('title', Commands.setTitle);
	/**
	 * @name UI.CellView#getTitleColor
	 * @description Retrieve the value of the <code>titleColor</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>titleColor</code>.
	 * @see UI.CellView#setTitleColor
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#setTitleColor
	 * @description Set the value of the <code>titleColor</code> property for a view state. This property defines the title string color for the <code>CellView</code> object in the specified view state.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitleColor(0,0,1);
	 * @param {String} titleColor The new value for <code>titleColor</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.CellView#getTitleColor
	 * @function 
 	 * @status iOS, Android, Test
	 */
	CellView.synthesizePropertyWithState('titleColor', Commands.setTitleColor);
	/**
	 * @name UI.CellView#getTitleFont	 
	 * @description Retrieve the value of the <code>titleFont</code> property in a view state. 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>titleFont</code>.
	 * @function
	 * @see UI.CellView#setTitleFont
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTitleFont
	 * @description Set the value of the <code>titleFont</code> property in a view state. This property defines the title string font for cell view labels in the specified view state.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitleFont('Content/Cacophony.ttf');
	 * @param {String} titleFont The new value for <code>titleFont</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @function
	 * @see UI.CellView#getTitleFont
 	 * @status iOS, Android, Test
	 */
	CellView.synthesizePropertyWithState('titleFont', Commands.setTitleFont);
	/**
	 * @name UI.CellView#getTitleShadow
	 * @description Retrieve the value of the <code>titleShadow</code> property in a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>titleShadow</code>.
	 * @see UI.CellView#setTitleShadow
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTitleShadow
	 * @description Set the value of the <code>titleShadow</code> property in a view state. This property defines the amount of text shadowing used for title strings in a cell view.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitleShadow('FFCCCCFF 2.0 {0,0}');
	 * @param {String} titleShadow The new value for <code>titleShadow</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getTitleShadow
	 * @function
	 */
	CellView.synthesizePropertyWithState('titleShadow', Commands.setTitleShadow);

	/**
	 * @name UI.CellView#getTitleGravity
	 * @description Retrieve the value of the <code>titleGravity</code> property. 
	 * @returns {Array (Number)} The current value of <code>titleGravity</code>.
	 * @see UI.CellView#setTitleGravity
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTitleGravity
	 * @description Set the value of the <code>titleGravity</code> property. This property defines how a title string is positioned within a viewable area.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitleGravity([0.5, 0.0]);	 
	 * @param {Array (Number)} titleGravity The new value for <code>titleGravity</code>. Set as two floats (<i>x</i>, <i>y</i>).
	 * @see UI.CellView#getTitleGravity
 	 * @status iOS, Android, Test
	 * @function
	 */
	CellView.synthesizeCompoundProperty('titleGravity', Commands.setTitleGravity);

	/**
	 * @name UI.CellView#getTitleSize
	 * @description Retrieve the value of the <code>titleSize</code> property.
	 * @returns {Number} The current value of <code>titleSize</code>.
	 * @see UI.CellView#setTitleSize
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTitleSize
	 * @description Set the value of the <code>titleSize</code> property. This property defines the text size of title strings in the specified view state.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitleSize(32);
	 * @param {Number} titleSize The new value for <code>titleSize</code>. Set as two floats (<i>x</i>, <i>y</i>).	
	 * @function
	 * @see UI.CellView#getTitleSize
 	 * @status iOS, Android, Test
	 */
	CellView.synthesizeProperty('titleSize', Commands.setTitleSize);
	/**
	 * @name UI.CellView#getTitleInsets
	 * @description Retrieve the value of the <code>titleInsets</code> property.	 
	 * @returns {Array (Number)} The current value of <code>titleInsets</code>.
	 * @function
	 * @see UI.CellView#setTitleInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTitleInsets
	 * @description Set the value of the <code>titleInsets</code> property. This property defines the viewable area of a title string when applying gravity.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitleInsets([10,10,10,10]);	 
	 * @param {Array (Number)} titleInsets The new value for <code>titleInsets</code>. Set as four floats (<i>t</i>, <i>r</i>, <i>b</i>, <i>l</i>).
	 * @function
	 * @see UI.CellView#getTitleInsets
 	 * @status iOS, Android, Test
	 */
	CellView.synthesizeCompoundProperty('titleInsets', Commands.setTitleInsets);
	
	/**
	 * @name UI.CellView#getText
	 * @description Retrieve the value of the <code>text</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>text</code>..
	 * @see UI.CellView#setText
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#setText
	 * @description Set the value of the <code>text</code> property for a view state. This property defines a text string to use in the specified view state.
	 * @example var cellView = new UI.CellView();
	 * ...
	 * cellView.setText(this.game.description);
	 * @see UI.CellView#getText
	 * @param {String} text The new value for <code>text</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @function
	 */
	CellView.synthesizePropertyWithState('text', Commands.setText);
	/**
	 * @name UI.CellView#getTextColor
	 * @description Retrieve the value of the <code>textColor</code> property for a view state. 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textColor</code>.
	 * @see UI.CellView#setTextColor
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTextColor
	 * @description Set the value of the <code>textColor</code> property for a view state. This property defines the color of a text string in the specified view state.
	 * @example var cellText = new UI.CellView();
	 * ...
	 * cellText.setTextColor('FFFF');
	 * @see UI.CellView#getTextColor
	 * @param {String} textColor The new value for <code>textColor</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @function 
	 */
	CellView.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * @name UI.CellView#getTextShadow
	 * @description Retrieve the value of the <code>textShadow</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textShadow</code>.
	 * @see UI.CellView#setTextShadow	
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTextShadow
	 * @description Set the value of the <code>textShadow</code> property for a view state. This property defines the amount of text shadowing used on text strings in this view.
	 * @example var cellText = new UI.CellView();
	 * ...
	 * cellText.setTextShadow('FFCCCCFF 2.0 {0,0}');
	 * @see UI.CellView#getTextShadow
	 * @param {String} textShadow The new value for <code>textShadow</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @function
	 */
	CellView.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	/**
	 * @name UI.CellView#getTextFont
	 * @description Retrieve the value of the <code>textFont</code> property. 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value for <code>textFont</code> in the specified view state.
	 * @see UI.CellView#setTextFont
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTextFont
	 * @description Set the value of the <code>textFont</code> property. This property defines the font face used with labels for a cell view.
	 * @example var cellText = new UI.CellView()
	 * ...
	 * cellText.setTextFont('Content/Cacophony.ttf');
	 * @param {String} textFont The new value for <code>textFont</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.CellView#getTextFont
 	 * @status iOS, Android, Test
	 * @function
	 */
	CellView.synthesizePropertyWithState('textFont', Commands.setTextFont);
	
	/**
	 * @name UI.CellView#getTextGravity
	 * @description Retrieve the value of the <code>textGravity</code> property.
	 * @returns {Number, Array (Number)} The current value of <code>textGravity</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @see UI.CellView#setTextGravity
	 */
	/**
	 * @name UI.CellView#setTextGravity	 
	 * @description Set the value of the <code>textGravity</code> property. This property defines how a text string is positioned within a viewable area.
	 * @example var cellText = new UI.CellView()
	 * ...
	 * cellText.setTextGravity([0.5, 0.0]);
	 * @param {Number, Array (Number)} textGravity The new value for <code>textGravity</code>. Set as individual components or a component array (<i>x</i>, <i>y</i>).
	 * @function
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getTextGravity
	 */
	CellView.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);

	/**
	 * @name UI.CellView#getTextSize
	 * @description Retrieve the value of the <code>textSize</code> property.
	 * @returns {Number} The current value for <code>textSize</code>.
	 * @see UI.CellView#setTextSize
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#setTextSize
	 * @description Set the value of the <code>textSize</code> property. This property defines the size of text strings for a view.
	 * @example var cellText = new UI.CellView()
	 * ...
	 * cellText.setTextSize(18);
	 * @param {Number} textSize The new value for <code>textSize</code>.
	 * @see UI.CellView#getTextSize
 	 * @status iOS, Android, Test
	 * @function
	 */
	CellView.synthesizeProperty('textSize', Commands.setTextSize);
	/**
	 * @name UI.CellView#getTextInsets
	 * @description Retrieve the value of the <code>textInsets</code> property.
	 * @returns {Array (Number)} The curent value for <code>textInsets</code>.
	 * @see UI.CellView#setTextInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#setTextInsets
	 * @description Set the value of the <code>textInsets</code> property. This property defines the viewable area of a text string when applying gravity.
	 * @example var cellText = new UI.CellView()
	 * ...
	 * cellText.setTextInsets([10,10,10,10]);
	 * @param {Array (Number)} textInsets The new value for <code>textInsets</code>.
	 * @see UI.CellView#getTextInsets
 	 * @status iOS, Android, Test
	 * @function
	 */
	CellView.synthesizeCompoundProperty('textInsets', Commands.setTextInsets);
	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'disabled': Commands.State.Disabled,
		//** extra-deprecated */
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing CellView." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			CellView.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('text');
	bindStateProperties('textColor');
	bindStateProperties('textShadow');
	bindStateProperties('textFont');
	bindStateProperties('title');
	bindStateProperties('titleColor');
	bindStateProperties('titleFont');
	bindStateProperties('titleShadow');
	bindStateProperties('gradient');
	bindStateProperties('image');
	bindStateProperties('imageBorder');
	bindStateProperties('rightImage');
	bindStateProperties('rightImageBorder');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/CheckBox'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/CheckBox'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/CheckBox'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var WindowR = require('NGCore/Client/UI/Window');

var gradients = {
	'normal': {
		"gradient": ["FFED 0.000", "FFA4 1.000"],
		"insets": "{4.0,4.0,4.0,4.0}",
		"outerLine": "FF51 2.0",
		"outerShadow": "0000 0.0 {0.0,0.0}",
		"corners": "3.0 3.0 3.0 3.0"
	},
	'pressed': {
		"innerShadow": "FF00 6.0 {0.0,-1.0}",
		"gradient": ["FF80 0.000", "FF80 1.000"],
		"insets": "{4.0,4.0,4.0,4.0}",
		"outerLine": "FF51 2.0",
		"outerShadow": "0000 0.0 {0.0,0.0}",
		"corners": "3.0 3.0 3.0 3.0"
	},
	'checked': {"innerLine":"FF27A227 2.0","corners":"3.0 3.0 3.0 3.0","insets":"{4.0,4.0,4.0,4.0}","gradient":["FF2CFF2B 0.000","FF179117 1.000"],"outerShadow":"0000 0.0 {0.0,0.0}","outerLine":"FF51 3.0","innerShadow":"FF97FE97 1.0 {0.0,0.0}"},
	'checkedpressed': {"innerShadow":"FF0F610F 5.0 {0.0,-1.0}","gradient":["FF179117 0.000","FF179117 1.000"],"insets":"{4.0,4.0,4.0,4.0}","outerLine":"FF2B512B 3.0","outerShadow":"0000 0.0 {0.0,0.0}","corners":"3.0 3.0 3.0 3.0"},
	'disabled': {
		"innerShadow": "0000 0.0 {0.0,0.0}",
		"gradient": ["66B6 0.000", "66CA 1.000"],
		"insets": "{4.0,4.0,4.0,4.0}",
		"outerLine": "7FE0 3.0",
		"outerShadow": "0000 0.0 {0.0,0.0}",
		"corners": "3.0 3.0 3.0 3.0"
	},
};

var CheckBox = exports.CheckBox = AbstractView.subclass(
/** @lends UI.CheckBox.prototype */
{
	'type':'checkbox',

    /**
     * @class The <code>CheckBox</code> class constructs objects that handle the state of application checkboxes.
     * @constructs The default constructor. 
     * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
     * @param {String} properties Object properties.
     * @augments UI.AbstractView
     */
    initialize: function($super, properties) {
		if (CheckBox._init) CheckBox._init();
        this._checked = false;
        $super();
		this.setGradient(gradients['normal'], Commands.State.Normal);
		this.setGradient(gradients['pressed'], Commands.State.Pressed);
		this.setGradient(gradients['checked'], Commands.State.Checked);
		this.setGradient(gradients['checkedpressed'], Commands.State.Checked | Commands.State.Pressed);
		this.setGradient(gradients['disabled'], Commands.State.Disabled);
		this.setImageInsets([4,4,4,4]);
		this.setAttributes(properties);
    },
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
    performEventCallback: function($super, event) {
		if (event.eventType == 'click') {
        	this._checked = event.checked;
			if (this._checked) {
				this._state = this._state | Commands.State.Checked;
			} else {
				this._state = this._state & ~Commands.State.Checked;
			}
		}
		$super(event);
    }
});

CheckBox._init = function() {
	delete CheckBox._init;
	if (AbstractView._init) AbstractView._init();
	
	/**
	 * @name UI.CheckBox#getImage
	 * @description Retrieve the <code>image</code> URL for a view state. 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current image URL for the specified view state.
	 * @see UI.CheckBox#setImage
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setImage
	 * @description Set an image URL for a view state. This defines how a checkbox appears for specific conditions. For example,
	 * set different images for a checkbox in the default state and when the checkbox is checked.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setImage('./Content/checkbox.png', [w, h], [0, 0]);
	 * @see UI.CheckBox#getImage
	 * @param {String} imageURL The new image URL.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @status iOS, Android, Test
	 * @function 
	 */
	CheckBox.synthesizePropertyWithState('image', Commands.setImage);
	/**
	 * @name UI.CheckBox#getImageInsets
	 * @description Retrieve the value of the <code>imageInsets</code> property (expressed as floats).
	 * @returns {Number, Array (Number)} The current value of <code>imageInsets</code>.
	 * @see UI.CheckBox#setImageInsets
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setImageInsets
	 * @description Set the value of the <code>imageInsets</code> property. This property defines the viewable area of an image when applying gravity.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setImageInset([10,10,10,10]);
	 * @param {Number, Array (Number)} imageInsets The new value for <code>imageInsets</code>. Set as insets or an array of insets (expressed as floats).
	 * @see UI.CheckBox#getImageInsets
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizeCompoundProperty('imageInsets', Commands.setImageInsets);
	
	/**
	 * @name UI.CheckBox#getText
	 * @description Retrieve the value of the <code>text</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>text</code> in the specified view state.
	 * @see UI.CheckBox#setText
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setText
	 * @description Set the value of the <code>text</code> property for a view state. This property defines a text string to use as a label for a 
	 * checkbox in the specified view state.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setText("Yes");
	 * @see UI.CheckBox#getText
	 * @param {String} text The new value for <code>text</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizePropertyWithState('text', Commands.setText);
	/**
	 * @name UI.CheckBox#getTextColor
	 * @description Retrieve the value of the <code>textColor</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textColor</code> in the specified view state.
	 * @see UI.CheckBox#setTextColor
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setTextColor
	 * @description Set the value of the <code>textColor</code> property for a view state. This property defines the color of a text string used as a label for a 
	 * checkbox in different view states.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setTextColor('FFFFFF');
	 * @see UI.CheckBox#getTextColor
	 * @param {String} textColor The new value for <code>textColor</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @status iOS, Android, Test
	 * @function 
	 */
	CheckBox.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * @name UI.CheckBox#getTextShadow
	 * @description Retrieve the value of the <code>textShadow</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textShadow</code> in the specified view state.
	 * @see UI.CheckBox#setTextShadow	
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setTextShadow
	 * @description Set the value of the <code>textShadow</code> property for a view state. This property defines the amount of shadowing used on text strings for a checkbox in different view states.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setTextShadow("FF00 2.0 {0,-1}");
	 * @see UI.CheckBox#getTextShadow
	 * @param {String} textShadow The new value for <code>textShadow</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	/**
	 * @name UI.CheckBox#getTextGravity
	 * @description Retrieve the value of the <code>textGravity</code> property (expressed as floats).
	 * @returns {Number, Array (Number)} The current value of <code>textGravity</code>.
	 * @see UI.CheckBox#setTextGravity
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setTextGravity
	 * @description Set the value of the <code>textGravity</code> property. This property defines how a text string is positioned within a viewable area.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setTextGravity([0.1, 0.5]);
	 * @param {Number, Array (Number)} textGravity The new value for <code>textGravity</code>. Set as individual components or a single array of components (expressed as floats).
	 * @see UI.CheckBox#getTextGravity
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);

	/**
	 * @name UI.CheckBox#getTextSize
	 * @description Retrieve the value of the <code>textSize</code> property.
	 * @returns {Number} The current value for <code>textSize</code>.
	 * @see UI.CheckBox#setTextSize
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setTextSize
	 * @description Set the value of the <code>textSize</code> property. This property defines the text size of labels for a checkbox.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setTextSize(18);
	 * @param {Number} textSize The new value for <code>textSize</code>.
	 * @see UI.CheckBox#getTextSize
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizeProperty('textSize', Commands.setTextSize);
	/**
	 * @name UI.CheckBox#getTextFont
	 * @description Retrieve the value of the <code>textFont</code> property.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value for <code>textFont</code> in the specified view state.
	 * @see UI.CheckBox#setTextFont
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setTextFont
	 * @description Set the value of the <code>textFont</code> property. This property defines the font face used with labels for a checkbox in different view states.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setTextFont(myFont);
	 * @param {String} textFont The new value for <code>textFont</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.CheckBox#getTextFont
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizePropertyWithState('textFont', Commands.setTextFont);
	/**
	 * @name UI.CheckBox#getTextInsets
	 * @description Retrieve the value of the <code>textInsets</code> property.
	 * @returns {Array (Number)} The curent value for <code>textInsets</code>.
	 * @see UI.CheckBox#setTextInsets
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setTextInsets
	 * @description Set the value of the <code>textInsets</code> property. This property defines the viewable area of a text string when applying gravity.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setTextInsets(0, 0, 0, 64);
	 * @param {Array (Number)} textInsets The new value for <code>textInsets</code>.
	 * @see UI.CheckBox#getTextInsets
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizeCompoundProperty('textInsets', Commands.setTextInsets);
	
	// Corresponding event is onClick
	/**
	 * @name UI.CheckBox#getChecked
	 * @description Retrieve whether this <code>CheckBox</code> is currently "checked".
	 * @returns {Boolean} Returns <code>true</code> if this <code>CheckBox</code> is currently "checked".
	 * @see UI.CheckBox#setChecked
	 * @status Javascript, iOS, Android, Flash
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setChecked
	 * @description Set whether this <code>CheckBox</code> is "checked".
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setChecked(true);
	 * @param {Boolean} checked Set as <code>true</code> if this <code>CheckBox</code> is "checked".
	 * @see UI.CheckBox#getChecked
	 * @status iOS, Android
	 * @function 
	 */
	CheckBox.synthesizeProperty('checked', Commands.setChecked);
	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed,
		'disabled': Commands.State.Disabled,
		'checked': Commands.State.Checked,
	};

	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Button." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			CheckBox.registerAccessors(thisStatePropName, getterFn, setterFn, 
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};

	bindStateProperties('text');
	bindStateProperties('textColor');
    bindStateProperties('textFont');
	bindStateProperties('textShadow');
	bindStateProperties('gradient');
	bindStateProperties('image');
    bindStateProperties('imageBorder');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/EditText'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/EditText'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/EditText'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var EditText = exports.EditText = AbstractView.subclass(
/** @lends UI.EditText.prototype */
{
	'type':'edittext',
	/**
	* @class The <code>EditText</code> class is a base class for derived classes that handle text-editing functions.
	* Derived classes from <code>EditText</code> include:
	* <div class="ul">
	 * <li>{@link UI.DateField}</li>
	 * </div>
	* @name UI.EditText
	* @augments UI.AbstractView
	*/
	initialize: function($super, properties) {
		if (EditText._init) EditText._init();
		$super(properties);
	},
	
	
	'InputTypes': Commands.InputType,
	'EnterKeyTypes': Commands.EnterKeyType,
	
	
	performEventCallback: function($super, event) {
		try {
			switch (event.eventType) {
				case 'change':
					this._text = event.text;
					// Fallthrough
				default: $super(event);
			}
		} catch(e) {
			NgHandleException(e);
		}
	},
	
	// Adapt API to the single-state model for "text" on editable text.
	/**
	 * Retrieve the value of the <code>text</code> property.
	 * @returns {String} The current value of <code>text</code>.
	 * @see UI.EditText#setText
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */	
	getText: function() {
		return this._text || "";
	},
	
	/**
	 * Set the value of the <code>text</code> property. This property defines a text string to use in arbitrary fashion.
	 * @example var someText = new UI.EditText();
	 * ...
	 * someText.setText("Pow!");
	 * @param {String} text The new value for <code>text</code>.
	 * @see UI.EditText#getText
	 * @status Javascript, iOS, Android, Test
	 * @function
	 */
	setText: function(text) {
		this._text = text;
		Commands.setText.call(this, 0, text);
	},

	setFocus: function(focus) {
		Commands.setFocus.call(this, focus);
	}
});

EditText._init = function() {
	delete EditText._init;
	if (AbstractView._init) AbstractView._init();
	
	// ==== Content
	// API defines state for the text property, but we ONLY support one state for this control.
	
	EditText.registerAccessors('text', EditText.prototype.getText, EditText.prototype.setText);
	
	/**
	 * @name UI.EditText#getPlaceholder
	 * @description Retrieve the value of the <code>placeholderText</code> property.
	 * @returns {String} The current value of <code>placeholder</code>.
	 * @see UI.EditText#setPlaceholder
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setPlaceholder
	 * @description Set the value of the <code>placeholderText</code> property. This property defines a text string to use as a placeholder for fields that require text input.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setPlaceholder("This is a placeholder");
	 * @param {String} placeholder The new value for <code>placeholder</code>.
	 * @see UI.EditText#getPlaceholder
	 * @function
	 */
	EditText.synthesizeProperty('placeholder', Commands.setPlaceholderText);
	/**
	 * @name UI.EditText#getPlaceholderColor
	 * @description Retrieve the value of the <code>placeholderTestColor</code> property. 
	 * @see UI.EditText#setPlaceholderColor
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */	
	/**
	 * @name UI.EditText#setPlaceholderColor
	 * @description Set the value of the <code>placeholderTestColor</code> property. This property defines the color of the placeholder text string.
	 * @returns {String} The current value of <code>placeholderTextColor</code>.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setPlaceholderColor('FFFFFF');
	 * @param {String} placeholderColor The new value for <code>placeholderTestColor</code>.
	 * @see UI.EditText#getPlaceholderColor
	 * @function
	 */
	EditText.synthesizeProperty('placeholderColor', Commands.setPlaceholderTextColor);
	/**
	 * @name UI.EditText#getPlaceholderShadow
	 * @description Retrieve the value of the <code>placeholderTestShadow</code> property.
	 * @returns {String} The current value of <code>placeholderTestShadow</code>.
	 * @see UI.EditText#setPlaceholderShadow
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setPlaceholderShadow
	 * @description Set the value of the <code>placeholderTestShadow</code> property.  This property defines the amount of shawdow applied to the placeholder text string.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setPlaceholderShadow("FF00 2.0 {0,-1}");
	 * @param {String} placeholderShadow The new value for <code>placeholderTestShadow</code>.
	 * @see UI.EditText#getPlaceholderShadow
	 * @function
	 */
	 EditText.synthesizeProperty('placeholderShadow', Commands.setPlaceholderTextShadow);
	
	// ==== Behavior
	/**
	 * @name UI.EditText#getInputType
	 * @description Retrieve the value of the <code>inputType</code> property.
	 * @returns {Number} The current value of <code>inputType</code>.
	 * @see UI.EditText#setInputType
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setInputType
	 * @description Set the value of the <code>inputType</code> property.
	 * @param {Number} inputType The new value for <code>inputType</code>.
	 * @see UI.EditText#getInputType
	 * @function
	 */	
	 EditText.synthesizeProperty('inputType', Commands.setInputType);
	/**
	 * @name UI.EditText#getEnterKeyType
	 * @description Retrieve the value of the <code>enterKeyType</code> property.
	 * @returns {Number} The current value of <code>enterKeyType</code>.
	 * @see UI.EditText#setEnterKeyType
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setEnterKeyType
	 * @description Set the value of the <code>enterKeyType</code> property.
	 * @param {Number} enterKeyType The new value for <code>enterKeyType</code>.
	 * @see UI.EditText#getEnterKeyType
	 * @function
	 */
	EditText.synthesizeProperty('enterKeyType', Commands.setEnterKeyType);
	
	// ==== Appearance
	/**
	 * @name UI.EditText#getTextColor
	 * @description Retrieve the value of the <code>textColor</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} textColor The current value of <code>textColor</code>.
	 * @see UI.EditText#setTextColor
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setTextColor
	 * @description Set the value of the <code>textColor</code> property for a view state. This property defines the color of a text string in the specified view state.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setTextColor('FFFFFF');
	 * @param {String} textColor The new value for <code>textColor</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.EditText#getTextColor
	 * @status iOS, Test
	 * @function
	 */
	EditText.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * @name UI.EditText#getTextShadow
	 * @description Retrieve the value of the <code>textShadow</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textShadow</code>.
	 * @see UI.EditText#setTextShadow
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setTextShadow
	 * @description Set the value of the <code>textShadow</code> property for a view state. This property defines the amount of text shadowing used on text strings in this view.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setTextShadow("FF00 2.0 {0,-1}");
	 * @param {String} textShadow The new value for <code>textShadow</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.EditText#getTextShadow
	 * @status iOS, Test
	 * @function
	 */
	EditText.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	
	/**
	 * @name UI.EditText#getTextGravity
	 * @description Retrieve the value of the <code>textGravity</code> property for this <code>EditText</code>.
	 * @returns {Number, Array (Number)} The current value of <code>textGravity</code>.
	 * @see UI.EditText#setTextGravity
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setTextGravity
	 * @description Set the value of the <code>textGravity</code> property for this <code>EditText</code>. This property defines how a text string is positioned within a viewable area.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setTextGravity([0.1, 0.5]);
	 * @param {Number, Array (Number)} textGravity The new value for <code>textGravity</code>. Set as a float or an array.
	 * @see UI.EditText#getTextGravity
	 * @function
	 */
	EditText.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);
	/**
	 * @name UI.EditText#getTextSize
	 * @description Retrieve the value of the <code>teztSize</code> property for this <code>EditText</code>.
	 * @returns {Number} The current value of <code>textSize</code>.
	 * @see UI.EditText#setTextSize
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setTextSize
	 * @description Set the value of the <code>textSize</code> property for this <code>EditText</code>. This property defines the size of text strings for a view.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setTextSize(18);
	 * @param {Number} textSize The new value for <code>textSize</code>.
	 * @see UI.EditText#getTextSize
	 * @status iOS, Test
	 * @function
	 */
	EditText.synthesizeProperty('textSize', Commands.setTextSize);
	/**
	 * @name UI.EditText#getTextFont
	 * @description Retrieve the value of the <code>textFont</code> property for this <code>EditText</code>.
	 * @returns {String} The current value of <code>textFont</code>.
	 * @see UI.EditText#setTextFont
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setTextFont
	 * @description Set the value of the <code>textFont</code> property. This property defines the font face used with text strings in a view.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setTextFont(myFont);
	 * @param {String} textFont The new value for <code>textFont</code>.
	 * @see UI.EditText#getTextFont
	 * @status iOS, Test
	 * @function
	 */
	EditText.synthesizePropertyWithState('textFont', Commands.setTextFont);
	
	// ==== Events
	/**
	 * @name UI.EditText#getOnChange
	 * @description Retrieve the function to call when the <code>change</code> event occurs.
	 * @returns {Function} The current <code>change</code> callback function.
	 * @see UI.EditText#event:setOnChange
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event
	 */
	/**
	 * @name UI.EditText#setOnChange
	 * @description Set a function to call when the <code>change</code> event occurs.
	 * @param {Function} changeCallback The new <code>change</code> callback function. <br><br><b>Note:</b> The <code>change</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example EditText.setOnChange( function(event) { 
	 * 	console.log(event.text) 
	 *	} 
	 * );
	 * @see UI.EditText#event:getOnChange
	 * @status iOS
	 * @event
	 */
	EditText.registerEventType('change');
	/**
	 * @name UI.EditText#getOnFocus 
	 * @description Retrieve the function to call when the <code>focus</code> event occurs.
	 * @returns {Function} The current <code>focus</code> callback function.
	 * @see UI.EditText#event:setOnFocus
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event	 
	 */
	/**
	 * @name UI.EditText#setOnFocus
	 * @description Set a function to call when the <code>focus</code> event occurs.
	 * @param {Function} focusCallback The new <code>focus</code> callback function. <br><br><b>Note:</b> The <code>focus</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example EditText.setOnFocus( function(event) { 
	 * 	console.log(event.text) 
	 *	} 
	 * );
	 * @see UI.EditText#event:getOnFocus
	 * @event
	 */
	EditText.registerEventType('focus');
	/**
	 * @name UI.EditText#getOnBlur
	 * @description Retrieve the function to call when the <code>blur</code> event occurs.
	 * @returns {Function} The current <code>blur</code> callback function.
	 * @see UI.EditText#event:setOnBlur
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event
	 */
	/**
	 * @name UI.EditText#setOnBlur
	 * @description Set a function to call when the <code>blur</code> event occurs.
	 * @note WARNING! This event is not guaranteed to occur on Android devices. Developers must not rely on this event occurring.
	 * @param {Function} blurCallback The new <code>blur</code> callback function.<br><br><b>Note:</b> The <code>blur</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example EditText.setOnBlur( function(event) { 
	 * 	console.log(event.text) 
	 *	} 
	 * );
	 * @see UI.EditText#event:getOnBlur
	 * @event
	 */
	EditText.registerEventType('blur');

	/**
	 * @name UI.EditText#getOnAction
	 * @description Retrieve the function to call when the <code>action</code> event occurs.
	 * @returns {Function} The current <code>action</code> callback function.
	 * @see UI.EditText#event:setOnAction
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event
	 */
	/**
	 * @name UI.EditText#setOnAction
	 * @description Set a function to call when a keyboard key corresponding to executing an action is pressed.
	 * Available since 1.1.6
	 * @note WARNING! Soft keyboards on Android devices are not required to offer actions. Developers must not rely on this event occurring.
	 * @param {Function} actionCallback The new <code>action</code> callback function.<br><br><b>Note:</b> The <code>action</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @see UI.EditText#event:getOnAction
	 * @event
	 */
	EditText.registerEventType('action');

	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed,
		'disabled': Commands.State.Disabled
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			};
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			};
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Button." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			EditText.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		};
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('textColor');
	bindStateProperties('textShadow');
	bindStateProperties('gradient');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/EditTextArea'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/EditTextArea'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/EditTextArea'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var EditTextArea = exports.EditTextArea = AbstractView.subclass(
/** @lends UI.EditTextArea.prototype */
{
	'type':'edittextarea',
	/**
	* @class The <code>EditTextArea</code> class is multiline text-editing area.
	* @name UI.EditTextArea
	* @augments UI.AbstractView
	*/
	initialize: function($super, properties) {
		if (EditTextArea._init) EditTextArea._init();
		$super(properties);
	},
	
	
	performEventCallback: function($super, event) {
		try {
			switch (event.eventType) {
				case 'change':
					this._text = event.text;
					$super(event);
					break;
				case 'focus':
				case 'blur':
					$super(event);
					break;
			}
		} catch(e) {
			NgHandleException(e);
		}
	},
	
	// Adapt API to the single-state model for "text" on editable text.
	/**
	 * Retrieve the value of the <code>text</code> property.
	 * @returns {String} The current value of <code>text</code>.
	 * @see UI.EditTextArea#setText
	 * @status Javascript, iOS
	 * @function
	 */	
	getText: function() {
		return this._text || "";
	},
	
	/**
	 * Set the value of the <code>text</code> property.
	 * @param {String} text The new value for <code>text</code>.
	 * @see UI.EditTextArea#getText
	 * @status Javascript, iOS
	 * @function
	 */
	setText: function(text) {
		this._text = text;
		Commands.setText.call(this, 0, text);
	},

	setFocus: function(focus) {
		Commands.setFocus.call(this, focus);
	}
});

EditTextArea._init = function() {
	delete EditTextArea._init;
	if (AbstractView._init) AbstractView._init();
	
	// ==== Content
	// API defines state for the text property, but we ONLY support one state for this control.
	
	EditTextArea.registerAccessors('text', EditTextArea.prototype.getText, EditTextArea.prototype.setText);
	
	/**
	 * @name UI.EditTextArea#getPlaceholder
	 * @description Retrieve the value of the <code>placeholder</code> property.
	 * @returns {String} The current value of <code>placeholder</code>.<br>
	 * @see UI.EditTextArea#setPlaceholder
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setPlaceholder
	 * @description Set the value of the <code>placeholder</code> property.
	 * @param {String} placeholder The new value for <code>placeholder</code>.
	 * @see UI.EditTextArea#getPlaceholder
	 * @function
	 */
	EditTextArea.synthesizeProperty('placeholder', Commands.setPlaceholderText);
	/**
	 * @name UI.EditTextArea#getPlaceholderColor
	 * @description Retrieve the value of the <code>placeholder color</code> property.
	 * @returns {String} The current value of <code>placeholder color</code>.<br>
	 * @see UI.EditTextArea#setPlaceholderColor
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */	
	/**
	 * @name UI.EditTextArea#setPlaceholderColor
	 * @description Set the value of the <code>placeholder color</code> property.
	 * @param {String} placeholderColor The new value for <code>placeholder color</code>.
	 * @see UI.EditTextArea#getPlaceholderColor
	 * @function
	 */
	EditTextArea.synthesizeProperty('placeholderColor', Commands.setPlaceholderTextColor);
	/**
	 * @name UI.EditTextArea#getPlaceholderShadow
	 * @description Retrieve the value of the <code>placeholder shadow</code> property.
	 * @returns {String} The current value of <code>placeholder shadow</code>.<br>
	 * @see UI.EditTextArea#setPlaceholderShadow
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setPlaceholderShadow
	 * @description Set the value of the <code>placeholder shadow</code> property.
	 * @param {String} placeholderShadow The new value for <code>placeholder shadow</code>.
	 * @see UI.EditTextArea#getPlaceholderShadow
	 * @function
	 */
	 EditTextArea.synthesizeProperty('placeholderShadow', Commands.setPlaceholderTextShadow);
	
	
	// ==== Appearance
	/**
	 * @name UI.EditTextArea#getTextColor
	 * @description Retrieve the value of the <code>textColor</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} textColor The current value of <code>textColor</code>.<br>
	 * @see UI.EditTextArea#setTextColor
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setTextColor
	 * @description Set the value of the <code>textColor</code> property for a view state.
	 * @param {String} textColor The new value for <code>textColor</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.EditTextArea#getTextColor
	 * @status iOS, Test
	 * @function
	 */
	EditTextArea.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * @name UI.EditTextArea#getTextShadow
	 * @description Retrieve the value of the <code>textShadow</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textShadow</code>.<br>
	 * @see UI.EditTextArea#setTextShadow
	 * @private not working on iOS
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setTextShadow
	 * @description Set the value of the <code>textShadow</code> property for a view state.
	 * @param {String} textShadow The new value for <code>textShadow</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.EditTextArea#getTextShadow
	 * @private not working on iOS
	 * @status iOS, Test
	 * @function
	 */
	EditTextArea.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	
	/**
	 * @name UI.EditTextArea#getTextGravity
	 * @description Retrieve the value of the <code>textGravity</code> property for this <code>EditTextArea</code>.
	 * @returns {Number, Array (Number)} The current value of <code>textGravity</code>.<br>
	 * @see UI.EditTextArea#setTextGravity
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setTextGravity
	 * @description Set the value of the <code>textGravity</code> property for this <code>EditTextArea</code>.
	 * @param {Number, Array (Number)} textGravity The new value for <code>textGravity</code>. Set as a float or an array.
	 * @see UI.EditTextArea#getTextGravity
	 * @function
	 */
	EditTextArea.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);
	/**
	 * @name UI.EditTextArea#getTextSize
	 * @description Retrieve the value of the <code>teztSize</code> property for this <code>EditTextArea</code>.
	 * @returns {Number} The current value of <code>textSize</code>.<br>
	 * @see UI.EditTextArea#setTextSize
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setTextSize
	 * @description Set the value of the <code>textSize</code> property for this <code>EditTextArea</code>.
	 * @param {Number} textSize The new value for <code>textSize</code>.
	 * @see UI.EditTextArea#getTextSize
	 * @status iOS, Test
	 * @function
	 */
	EditTextArea.synthesizeProperty('textSize', Commands.setTextSize);
	/**
	 * @name UI.EditTextArea#getTextFont
	 * @description Retrieve the value of the <code>textFont</code> property for this <code>EditTextArea</code>.
	 * @returns {String} The current value of <code>textFont</code>.<br>
	 * @see UI.EditTextArea#setTextFont
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setTextFont
	 * @description Set the value of the <code>textFont</code> property for this <code>EditTextArea</code>.
	 * @param {String} textFont The new value for <code>textFont</code>.
	 * @see UI.EditTextArea#getTextFont
	 * @status iOS, Test
	 * @function
	 */
	EditTextArea.synthesizePropertyWithState('textFont', Commands.setTextFont);
	
	// ==== Events
	/**
	 * @name UI.EditTextArea#getOnChange
	 * @description Retrieve the function to call when the <code>change</code> event occurs.
	 * @returns {Function} The current <code>change</code> callback function.
	 * @see UI.EditTextArea#event:setOnChange
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event
	 */
	/**
	 * @name UI.EditTextArea#setOnChange
	 * @description Set a function to call when the <code>change</code> event occurs.
	 * @param {Function} changeCallback The new <code>change</code> callback function. <br><br><b>Note:</b> The <code>change</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @see UI.EditTextArea#event:getOnChange
	 * @status iOS
	 * @event
	 */
	EditTextArea.registerEventType('change');
	/**
	 * @name UI.EditTextArea#getOnFocus 
	 * @description Retrieve the function to call when the <code>focus</code> event occurs.
	 * @returns {Function} The current <code>focus</code> callback function.
	 * @see UI.EditTextArea#event:setOnFocus
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event	 
	 */
	/**
	 * @name UI.EditTextArea#setOnFocus
	 * @description Set a function to call when the <code>focus</code> event occurs.
	 * @param {Function} focusCallback The new <code>focus</code> callback function. <br><br><b>Note:</b> The <code>focus</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @see UI.EditTextArea#event:getOnFocus
	 * @event
	 */
	EditTextArea.registerEventType('focus');
	/**
	 * @name UI.EditTextArea#getOnBlur
	 * @description Retrieve the function to call when the <code>blur</code> event occurs.
	 * @returns {Function} The current <code>blur</code> callback function.
	 * @see UI.EditTextArea#event:setOnBlur
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event
	 */
	/**
	 * @name UI.EditTextArea#setOnBlur
	 * @description Set a function to call when the <code>blur</code> event occurs.
	 * @param {Function} blurCallback The new <code>blur</code> callback function.<br><br><b>Note:</b> The <code>blur</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @see UI.EditTextArea#event:getOnBlur
	 * @event
	 */
	EditTextArea.registerEventType('blur');
	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed,
		'disabled': Commands.State.Disabled
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			};
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			};
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Button." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			EditTextArea.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		};
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('textColor');
	bindStateProperties('textShadow');
	bindStateProperties('gradient');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/DateField'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/DateField'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/DateField'] = exports; var EditText = require('NGCore/Client/UI/EditText').EditText;

function isValidDate(d) {
	if ( !d.getTime )
		return false; 
		
	return !isNaN(d.getTime());
}

/*
 Date Parser code to handle WebKit's lack of following the implementation.
 http://stackoverflow.com/questions/3085937/safari-js-cannot-parse-yyyy-mm-dd-date-format/3085993#3085993
 */
function parseDate(input, format) {
  format = format || 'yyyy-mm-dd'; // default format
  var parts = input.match(/(\d+)/g), 
      i = 0, fmt = {};
  // extract date-part indexes from the format
  format.replace(/(yyyy|dd|mm)/g, function(part) { fmt[part] = i++; });

  return new Date(parts[fmt['yyyy']], parts[fmt['mm']]-1, parts[fmt['dd']]);
}
/*
 * Our Code is not actually passing its format to parseDate (already had all the code to rejigger the date pieces to yyyy-mm-dd before I realized the problems with webkit's date constructor / date string parser). -fbartho 2010-11-30
 */

exports.DateField = EditText.subclass(
/** @lends UI.DateField.prototype */
{
	/**
	 * @class The <code>DateField</code> class constructs objects that handle data returned by date functions.
	 * @constructs The default constructor. 
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {String} properties
	 * @augments UI.EditText
	 */
	initialize: function($super, properties) {
		var constructorRVal = $super(properties);
		this.setDateFormat("yyyy-mm-dd");
		this.ondatechange = function(newDate){};
		
		this.setInputType(EditText.InputTypes.Date);
		return constructorRVal;
	},
    
	/**
	 * Trigger an event callback for this <code>DateField</code>.
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {String} event The event that triggers a callback function.
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	performEventCallback: function($super, event) {
		try {
			if (event.eventType == 'change') {
				// Make Sure the Text is changed (call $super), before we call our listeners!
				var oldText = this.getText();
				$super(event);
				this.ondatechange(this.getDate());
			}
		} catch(e) {
			NgHandleException(e);
		}
	},
	_filterAndInsertDashes:function(oldText,newText) {
		var t = newText;
		if((oldText.length == t.length + 1) && oldText[oldText.length-1] == "-") {
			//This lets the user backspace through - marks as if they weren't there.
			// fbartho: Currently not in use! 2010-12-10
			//this.setText(t.substring(0,t.length-1));
			return t.substring(0,t.length-1);
		}
		
		var nt = "";
		var j = 0;
		for(var i = 0; i < t.length && nt.length < this.formatStr.length; i++,j++) {
			if(j < this.formatStr.length && this.formatStr[j] == "-" && i < t.length){
				if(t[i] == "-"|| t[i] == "/"){
					nt+="-";
					continue;
				}
				else {
					nt+="-";
					nt+=t[i];
					continue;
				}
			}
			if ( i < t.length && (t[i] == "-" || t[i] == "/") ) {
				--j; 
				continue;
			}
			nt+=t[i];
		}
		
		if(this.formatStr.length > j && (this.formatStr[j] == "-" || this.formatStr[j] == "/") ) {
			nt+="-";
		}
		
		return nt;
	},
	/**
	 * Format a date parsed from this <code>DateField</code> into a human-readable string.
	 * @status Javascript, iOS, Android, Flash, Test
	 */    
	normalizeDateLayout:function() {
		var ot = this.getText();
		var nt = this._filterAndInsertDashes(this.getText(),this.getText());
		if(ot!=nt)this.setText(nt);
	},
	/**
	 * Retrieve the date format of date strings parsed from this <code>DateField</code>
	 * @returns {String} The current date format.
	 * @see UI.DateField#setDateFormat
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	getDateFormat:function() {
		return this.formatStr;
	},
	/**
	 * Set the date format for date strings parsed from this <code>DateField</code>.
	 * @param {String} dateFormat The new date format.
	 * @see UI.DateField#getDateFormat
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	setDateFormat:function(fStr) 
	{
		if (   fStr != "yyyy-mm-dd"
			&& fStr != "mm-yyyy"
			&& fStr != "yyyy-mm"
			&& fStr != "mm-dd-yyyy"
			&& fStr != "dd-mm-yyyy" ) {
			// Invalid Format String Error Case
			NgLogD("Error: Invalid Format String set for Birthdate Field!!\n");
			
			return;
		}
		
		this.formatStr = fStr;
		this.setPlaceholder(this.formatStr);
		return;
	},
	/**
	 * Retrieve a date string parsed from this <code>DateField</code>.
	 * @returns {String} The current date.
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	getDate:function() {
		return this._dateFromText(this._filterAndInsertDashes(this.getText(),this.getText()));
	}, 
	_dateFromText:function(text) 
	{
		var tmp = null;
		var t = text;
		var bits = null;
		var b2 = null;
		if ( this.formatStr == "dd-mm-yyyy" ) {
			bits = t.split("-");
			if(bits.length != 3 || bits[2].length != 4)
				return null;
			
			b2 = [];
			b2.push(bits.pop());
			b2.push(bits.pop());
			b2.push(bits.pop());
			tmp = parseDate(b2.join("-"));
		} else if ( this.formatStr == "mm-yyyy" ) {
			bits = t.split("-");
			if(bits.length != 2 || bits[1].length != 4)
				return null;
			
			b2 = [];
			b2.push(bits.pop());
			b2.push(bits.pop());
			b2.push("01");
			var tStr = b2.join("-");
			
			tmp = parseDate(tStr);
		} else if ( this.formatStr == "yyyy-mm" ) {
			bits = t.split("-");
			if(bits.length != 2 || bits[0].length != 4)
				return null;
			
			tmp = parseDate(t+"-01");
		} else if ( this.formatStr == "mm-dd-yyyy" ) {
			bits = t.split("-");
			if(bits.length != 3 || bits[2].length != 4)
				return null;
			
			b2 = [];
			b2.push(bits.pop());
			b2.push(bits.shift());
			b2.push(bits.shift());
			tmp = parseDate(b2.join("-"));
		} else {
			tmp = parseDate(t);
		}
		
		if(!isValidDate(tmp)) {
			NgLogD("Failed to parse date: "+tmp+"   -  "+tmp.toString()+"\n");
			return null;
		}
		return tmp;
	}
});

//TODO: make a proper DatePicker?
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/AlertDialog'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/AlertDialog'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/AlertDialog'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var AlertDialog = exports.AlertDialog = Element.subclass(
/** @lends UI.AlertDialog.prototype */
{
	'type':'alertdialog',
	/**
	 * @name UI.AlertDialog
	 * @class The <code>AlertDialog</code> class constructs objects that handle alert dialogs in an application.
	 * @augments UI.Element
	 */
	initialize: function($super, properties) {
		if (AlertDialog._init) AlertDialog._init();
		$super(properties);
	},
	
	/** 
	 * Show this dialog.
	 * @function
	 */
	show: Commands.show,
	/** 
	 * Hide this dialog.
	 * @function
	 */
	hide: Commands.hide
});

// Properties
AlertDialog._init = function() {
	delete AlertDialog._init;
	if (Element._init) Element._init();

	/**
	 * @name UI.AlertDialog#setTitle
	 * @description Set the value of the <code>title</code> property for a view state. This property defines the title string for an alert dialog window.
	 * @example var alertDialog = new UI.AlertDialog();
	 * alertDialog.setTitle("Exiting Game..");
	 * @see UI.AlertDialog#getTitle
	 * @param {String} title The new value for <code>title</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android
	 * @function
	 */
	/**
	 * @name UI.AlertDialog#getTitle
	 * @description Retrieve the value of the <code>title</code> property for a view state.
	 * @see UI.AlertDialog#setTitle
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>title</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	AlertDialog.synthesizePropertyWithState('title', Commands.setTitle);
	/**
	 * @name UI.AlertDialog#setText
	 * @description Set the value of the <code>text</code> property for a view state. This property defines a text string that is on display within an alert dialog window.
	 * @example var alertDialog = new UI.AlertDialog();
	 * ...
	 * alertDialog.setText("Returning to launcher..");
	 * @see UI.AlertDialog#getText
	 * @param {String} text The new value for <code>text</code>
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android
	 * @function
	 */
	/**
	 * @name UI.AlertDialog#getText
	 * @description Retrieve the value of the <code>text</code> property for a view state.
	 * @see UI.AlertDialog#setText
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>text</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	AlertDialog.synthesizePropertyWithState('text', Commands.setText);
	// Not a compound property; AlertDialog.getChoices() should return the array of strings.
	/**
	 * @name UI.AlertDialog#setChoices
	 * @description Set the value of the <code>choices</code> property. This property defines any available interface options for the user.
	 * @example var errorAlert = new UI.AlertDialog();
	 * ...
	 * errorAlert.setChoices(["Yes", "No"]);
	 * @see UI.AlertDialog#getChoices
	 * @param {String} choices The new value for <code>choices</code>.
	 * @param {Number} defaultChoice The index of the default choice.
	 * @param {Number} cancelChoice The index of the <code>cancel</code> choice.
 	 * @status iOS, Android
	 * @function
	 */
	/**
	 * @name UI.AlertDialog#getChoices
	 * @description Retrieve the value of the <code>choices</code> property.
	 * @see UI.AlertDialog#setChoices
	 * @returns {Array (String)} The current value of <code>choices</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	AlertDialog.synthesizeProperty('choices', Commands.setChoices);
	
	// Event will contain .choice, which is the index of the option chosen.
	/**
	 * @name UI.AlertDialog#setOnChoice
	 * @description Set a function to call on <code>choice</code> events.	 
	 * @param {Function} choiceCallback The new function to call. <br><br>
	 * <b>Note:</b> The <code>choice</code> event is disabled if the value for this parameter is not a function.
	 * @see UI.AlertDialog#event:getOnChoice
 	 * @status iOS, Android, Test
	 * @event
	 */
	/**
	 * @name UI.AlertDialog#getOnChoice
	 * @description Retrieve the function to call on <code>choice</code> events.
	 * @see UI.AlertDialog#event:setOnChoice
	 * @returns {Function} The current function to call.
	 * @event
	 * @type {Function}
 	 * @status iOS, Android, Test
	 */
	 AlertDialog.registerEventType('choice');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ProgressDialog'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ProgressDialog'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ProgressDialog'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var ProgressDialog = exports.ProgressDialog = Element.subclass(
/** @lends UI.ProgressDialog.prototype */
{
	'type':'progressdialog',

    /**
     * @class The <code>ProgressDialog</code> class constructs objects that handle progress updates from the application.
     * @constructs The default constructor. 
     * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
     * @param {String} properties Object properties.
     * @augments UI.Element
     */
    initialize: function($super, properties) {
		if (ProgressDialog._init) ProgressDialog._init();
        return $super(properties);
    },
	/**
	 * Show this dialog.
	 * @function
     * @status iOS, Android, Test
	 */    
    show: Commands.show,
	/**
	 * Hide this dialog.
	 * @function
     * @status iOS, Android, Test
	 */    
    hide: Commands.hide
});

ProgressDialog._init = function() {
	delete ProgressDialog._init;
	if (Element._init) Element._init();
	
	/**
	 * @name UI.ProgressDialog#setTitle
	 * @description Set the value of the <code>title</code> property for a <code>ProgressDialog</code>. This property defines the title string for a progress dialog in the specified view state.
	 * @example var progDialog = new UI.ProgressDialog();
	 * progDialog.setTitle("Downloading game components...");
	 * @param {String} title The new value for <code>title</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.ProgressDialog#getTitle
	 * @function
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.ProgressDialog#getTitle
	 * @description Retrieve the value of the <code>title</code> property for a <code>ProgressDialog</code> in the specified view state. 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>title</code>.
	 * @see UI.ProgressDialog#setTitle
	 * @function
     * @status iOS, Android, Test
	 */
	ProgressDialog.synthesizePropertyWithState('title', Commands.setTitle);
	/**
	 * @name UI.ProgressDialog#setText
	 * @description Set the value of the <code>text</code> property for a <code>ProgressDialog</code> in the specified view state. This property defines a text string for a progress dialog in the specified view state.
	 * @example var progDialog = new UI.ProgressDialog();
	 * progDialog.setText("Please wait...");
	 * @param {String} text The new value for <code>text</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.ProgressDialog#getText
	 * @function
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.ProgressDialog#getText
	 * @description Retrieve the value of the <code>text</code> property for a <code>ProgressDialog</code> in the specified view state.	 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>text</code>.
	 * @see UI.ProgressDialog#setText
	 * @function
     * @status iOS, Android, Test
	 */
	ProgressDialog.synthesizePropertyWithState('text', Commands.setText);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Toast'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Toast'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Toast'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var Toast = exports.Toast = Element.subclass(
/** @lends UI.Toast.prototype */
{	
    'type': 'toast',
    /**
    * @class The <code>Toast</code> class constructs objects that render temporary messages on the device screen.
    * @name UI.Toast
    * @augments UI.View
    */
	initialize: function($super, properties) {
		if (Toast._init) Toast._init();
		$super(properties);
	},
	
	/** 
	 * Show this dialog.
	 * @function
     * @status iOS, Android, Test
	 */
    show: Commands.show
});

Toast._init = function() {
	delete Toast._init;
	if (Element._init) Element._init();

	/**
	 * @name UI.Toast#setText
	 * @description Set the value of the <code>text</code> property for a view state. This property defines a text string to use in the specified view state.
	 * @example var tempMessage = new UI.Toast();
	 * tempMessage.setText("Game Over");
	 * @param {String} text The new value for <code>text</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Toast#getText
	 * @function
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.Toast#getText
	 * @description Retrieve the value of the <code>text</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>text</code>.
	 * @see UI.Toast#setText
	 * @function	 
     * @status iOS, Android, Test
	 */
	Toast.synthesizePropertyWithState('text', Commands.setText);
	/** 
	* @name UI.Toast#setOnDisappear
	* @description Set a function to call when the <code>disappear</code> event occurs. The callback for the event returns 
	* <code>true</code> if the temporary message should disappear. Otherwise, the callback returns <code>false</code>.
	* @param {function} disappearCallback The new callback function.<br><br>
	* <b>Note:</b> The <code>disappear</code> event is disabled if the value of this parameter is not a function.
	* @see UI.Toast#event:getOnDisappear
	* @event
	*/
	/**
	* @name UI.Toast#getOnDisappear
	* @description Retrieve the function to call when the <code>disappear</code> event occurs.
	* @returns {function} The current callback function.
	* @see UI.Toast#event:setOnDisappear
	* @event
	*/
	Toast.registerEventType('disappear');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/AdView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/AdView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/AdView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

/** @private */
var AdView = exports.AdView = AbstractView.subclass(
{
	'type':'adview',

	/**
	 * @class The <code>AdView</code> class constructs objects that handle event callback functions and ad event metadata.
	 * @constructs The default constructor. 
	 * @param $super This parameter is stripped out during execution. Do not supply it.
	 * @param {String} properties
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (AdView._init) AdView._init();
		$super(properties);
		
		this.onappear = this.bind(this._onappear);
		this.ondisappear = this.bind(this._ondisappear);
		this.onclick = this.bind(this._onclick);
	},
	
	/**
	 * An event for signaling when an <code>AdView</code> is on display.
	 * @event
	 */
	onappear: function() {
	 },
	
	/**
	 * An event for signaling when an <code>AdView</code> has been closed.
	 * @event
	 */
	ondisappear: function() { 
	},
	
	/** @protected */
	_onappear: function($super, event) {
		( $super || function(){} )(event);
//		Core.Analytics._getPipe().revenueEvent("ADSHOW",  this.getAdEventMetadata());
        visible = true;
	},
	
	/** @protected */
	_ondisappear: function($super, event) {
		( $super || function(){} )(event);
//		Core.Analytics._getPipe().revenueEvent("ADCLOSE", this.getAdEventMetadata());
        visible = false;
	},
	
	performEventCallback: function($super, event) {
		if (event.eventType == 'click')
		{
//			Core.Analytics._getPipe().revenueEvent("ADCLCK", this.getAdEventMetadata());
			NgLogD("AD WAS CLICKED in AdView wooo!!!!");
			( $super || function(){} )(event);
		}
		if (event.eventType == 'load')
		{
//			Core.Analytics._getPipe().revenueEvent("ADLOAD", this.getAdEventMetadata());
			NgLogD("AD WAS LOADED in AdView wooo!!!!");
			( $super || function(){} )(event);
		}
	},
	/**
	* Pause this <code>AdView</code>.<br><br>
	* <b>Note:</b> If an <code>AdView</code> is already paused, this call does nothing.
	* @see UI.AdView#resumeAds
	* @status Android
	*/
	pauseAds: function() {
		Commands.pauseAds.call(this);
	},
	/**
	* Resume this <code>AdView</code> from a paused state. Setting this will resume the <code>AdView</code> from the current position.
	* @see UI.AdView#resumeAds
	* @status Android
	*/
	resumeAds: function() {
		Commands.resumeAds.call(this);
	},
	/**
	* Set the refresh rate for this <code>AdView</code>. 
	* @param {Number} refreshRate The amount of time each ad is on display (in milliseconds).
	* @status Android
	*/
	setRefreshRate: function(refreshRate) {
		Commands.setAdRefreshRate.call(this, refreshRate);
	},
	/**
	* Set this <code>AdView</code> to automatically play.
	* @status Android
	* @param {Boolean} autoplay Set as <code>true</code> if autoplay is enabled.
	*/
	setAutoplay: function(autoplay) {
		Commands.setAdRefreshRate.call(this, autoplay);
	},
	
	/**
	 * Retrieve event metadata from this <code>AdView</code>. 
	 */
	getAdEventMetadata: function(){
		NgLogD("AD EventMetetData was requested!");
		var AdMeteData = "DefaultAdEventMetaData";
		return AdMeteData;
	}
});

// Event Handlers
AdView._init = function() {
	delete AdView._init;
	if (AbstractView._init) AbstractView._init();

    /**
	 * @name UI.AdView#getActive
	 * @description Retrieve the value of the <code>active</code> property.
	 * @returns {Boolean} Returns <code>true</code> if the <code>AdView</code> object is set to active.
	 * @see UI.AdView#setActive
	 * @status iOS, Android, Flash, Test
	 * @function
	 */
	AdView.synthesizeProperty('active', Commands.setActive);
    
	/**
	 * @name UI.AdView#setOnClick
	 * @description Set a function to call on <code>click</code> events.	 
	 * @param {Function} clickCallback The new <code>click</code> callback function. <br><br>
	 * <b>Note:</b> The <code>click</code> event is disabled if the value for this parameter is not a function.<br>
	 * @see UI.AdView#event:setOnClick
 	 * @status Android, Test
	 * @event
	 */
	/**
	 * @name UI.AdView#getOnClick
	 * @description Retrieve the function to call on <code>click</code> events.<br>
	 * @see UI.AdView#event:getOnClick
	 * @returns {Function} The current <code>click</code> callback function.<br>
 	 * @status Android, Test
	 * @event
	 */
	AdView.registerEventType('click');
	/**
	 * @name UI.AdView#setOnLoad
	 * @description Set a function to call on <code>load</code> events.	 
	 * @param {Function} loadCallback The new <code>load</code> callback function. <br><br>
	 * <b>Note:</b> The <code>load</code> event is disabled if the value for this parameter is not a function.<br>
	 * @see UI.AdView#event:getOnClick
 	 * @status Android, Test
	 * @event
	 */
	/**
	 * @name UI.AdView#getOnLoad
	 * @description Retrieve the function to call on <code>load</code> events.<br>
	 * @see UI.AdView#event:getOnClick
	 * @returns {Function} The current <code>load</code> callback function.<br>
 	 * @status Android, Test
	 * @event
	 */
	AdView.registerEventType('load');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/DocumentView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/DocumentView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/DocumentView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var DocumentView = exports.DocumentView = AbstractView.subclass(
/** @lends UI.DocumentView.prototype */
{
	'type':'documentview',
	/**
	 * @name UI.DocumentView
	 * @class The <code>DocumentView</code> class constructs objects that handle document locations.
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (DocumentView._init) DocumentView._init();
		$super(properties);
	}
});

// Properties
DocumentView._init = function() {
	delete DocumentView._init;
	if (AbstractView._init) AbstractView._init();
	
	/**
	 * @name UI.DocumentView#setDocumentURL
	 * @description Set the document URL for this <code>DocumentView</code>.
	 * @param {String} documentURL The new document URL.
	 * @see UI.DocumentView#getDocumentURL
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.DocumentView#getDocumentURL
	 * @description Retrieve the document URL of this <code>DocumentView</code>.
	 * @returns {String} The current document URL.
	 * @see UI.DocumentView#setDocumentURL
	 * @status iOS, Android, Test
	 * @function
	 */
	DocumentView.synthesizeProperty('documentURL', Commands.setSourceDocument);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/CheckoutView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/CheckoutView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/CheckoutView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var ViewGeometry = require('NGCore/Client/UI/ViewGeometry');
var Commands = require('NGCore/Client/UI/Commands').Commands;

var CheckoutView = exports.CheckoutView = AbstractView.subclass(
/** @lends UI.CheckoutView.prototype */
{
	'type':'checkoutview',
	/**
	 * @name UI.CheckoutView
	 * @class The <code>CheckoutView</code> class constructs objects that handle and manage information associated with <code>POST</code> methods in an application.
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (CheckoutView._init) CheckoutView._init();
		$super(properties);
	}
});

// Properties
CheckoutView._init = function() {
	delete CheckoutView._init;
	if (AbstractView._init) AbstractView._init();
	
	// THESE ARE METHODS NOT PROPERTIES... THIS SHOULD BE FIXED.
	// We define ONLY setters, and no getters (write-only props, no local copies)
	/**
	 * @name UI.CheckoutView#setPostData
	 * @description Set the value returned by the <code>postData()</code> method of this <code>CheckoutView</code>.
	 * @param {String} postData The new value for <code>postData</code>.
	 * @see UI.CheckoutView#getPostData
	 * @status Android
	 * @function
	 */
	/**
	 * @name UI.CheckoutView#getPostData
	 * @description Retrieve the value returned by the <code>postData()</code> method of this <code>CheckoutView</code>.
	 * @returns {String} The current value of <code>postData</code>.
	 * @see UI.CheckoutView#setPostData
	 * @status Android
	 * @function
	 */
	CheckoutView.registerAccessors('postData', null, Commands.setPostData);
	/**
	 * @name UI.CheckoutView#setPostURL
	 * @description Set the value returned by the <code>postURL()</code> method of this <code>CheckoutView</code>.
	 * @param {String} postURL The new value for <code>postURL</code>.
	 * @see UI.CheckoutView#getPostURL
	 * @status Android
	 * @function
	 */
	/**
	 * @name UI.CheckoutView#getPostURL
	 * @description Retrieve the value returned by the <code>postURL()</code> method of this <code>CheckoutView</code>.
	 * @returns {String} The current value of <code>postURL</code>.
	 * @see UI.CheckoutView#setPostURL
	 * @status Android
	 * @function
	 */
	CheckoutView.registerAccessors('postURL', null, Commands.loadPostURL);
	/**
	 * @name UI.CheckoutView#setGetURL
	 * @description Set the value returned by the <code>getURL()</code> method of this <code>CheckoutView</code>.
	 * @param {String} getURL The new value for <code>getURL</code>.
	 * @see UI.CheckoutView#getGetURL
	 * @status Android
	 * @function
	 */
	/**
	 * @name UI.CheckoutView#getGetURL
	 * @description Retrieve the value returned by the <code>getURL()</code> method of this <code>CheckoutView</code>.
	 * @returns {String} The current value for <code>getURL</code>.
	 * @see UI.CheckoutView#setGetURL
	 * @status Android
	 * @function
	 */
	CheckoutView.registerAccessors('getURL', null, Commands.loadGetURL);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Spinner'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Spinner'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Spinner'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var Spinner = exports.Spinner = AbstractView.subclass(
/** @lends UI.Spinner.prototype */
{
	'type':'spinner',
	
	/**
	* @class The <code>Spinner</code> class constructs objects that handle menu spinners in a user interface. 
	* @name UI.Spinner
	* @augments UI.AbstractView
	*/
	initialize: function($super, properties) {
		if (Spinner._init) Spinner._init();
		return $super(properties);
	}
});

Spinner._init = function() {
	delete Spinner._init;
	if (AbstractView._init) AbstractView._init();
	
	Spinner.synthesizeProperty('darkStyle', Commands.setDarkStyle);
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ProgressBar'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ProgressBar'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ProgressBar'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var WindowR = require('NGCore/Client/UI/Window');

var ProgressBar = exports.ProgressBar = AbstractView.subclass(
/** @lends UI.ProgressBar.prototype */
{
	'type':'progressbar',

    /**
     * @class <code>ProgressBar</code> constructs a horizontal bar that gives a finite indication of progress.
     * @constructs The default constructor. 
     * @param $super This parameter is stripped out during execution. Do not supply it.
     * @param {String} properties
     * @augments UI.AbstractView
     */
    initialize: function($super, properties) {
		if (ProgressBar._init) ProgressBar._init();
        return $super(properties);
    },

	useForUpdateProgress: Commands.useForUpdateProgress,
});

ProgressBar._init = function() {
	delete ProgressBar._init;
	if (AbstractView._init) AbstractView._init();

	/**
	 * @name UI.ProgressBar#getProgressGradient
	 * @description Retrieve the <code>progressGradient</code> for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current progressGradient for the specified view state.<br>
	 * @see UI.ProgressBar#setProgressGradient
	 * @status Javascript, Android
	 * @function
	 */
	/**
	 * @name UI.ProgressBar#setProgressGradient
	 * @description Set a progressGradient for a view state.
	 * @see UI.ProgressBar#getProgressGradient
	 * @param {Object} progressGradientURL The new progressGradient.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @status Android
	 * @function 
	 */
	ProgressBar.synthesizePropertyWithState('progressGradient', Commands.setProgressGradient);
	/**
	 * @name UI.SecondaryBar#getSecondaryGradient
	 * @description Retrieve the <code>secondaryGradient</code> for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current secondaryGradient for the specified view state.<br>
	 * @see UI.SecondaryBar#setSecondaryGradient
	 * @status Javascript, Android
	 * @function
	 */
	/**
	 * @name UI.SecondaryBar#setSecondaryGradient
	 * @description Set a secondaryGradient for a view state.
	 * @see UI.SecondaryBar#getSecondaryGradient
	 * @param {Object} secondaryGradientURL The new secondaryGradient.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @status Android
	 * @function 
	 */
	ProgressBar.synthesizePropertyWithState('secondaryGradient', Commands.setSecondaryGradient);
	
	/**
	 * @name UI.ProgressBar#getProgress
	 * @description Retrieve the value of the <code>progress</code> properties.
	 * @returns {Array} The current values of <code>progress</code> and <code>secondaryProgress</code>.<br>
	 * @see UI.ProgressBar#setProgress
	 * @status Javascript, Android
	 * @function
	 */
	/**
	 * @name UI.ProgressBar#setProgress
	 * @description Set the values of the <code>progress</code> properties.
	 * @see UI.ProgressBar#getProgress
	 * @param {Number} progress The new value for <code>progress</code>, as a decimal Number between 0.0 and 1.0.
	 * @param {Number} secondaryProgress The new value for <code>secondaryProgress</code>, as a decimal Number between 0.0 and 1.0.
	 * @status Javascript, Android
	 * @function
	 */
	var setProgressGuarded = function(arg0) {
		var args = (arg0 instanceof Array) ? arg0 : Array.prototype.slice.call(arguments);
		while (args.length < 2) args.push(0);
		Commands.setProgress.apply(this, args);
	}
	ProgressBar.synthesizeCompoundProperty('progress', setProgressGuarded);
	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed,
		'disabled': Commands.State.Disabled,
	};

	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Button." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			ProgressBar.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};

	bindStateProperties('progressGradient');
	bindStateProperties('secondaryGradient');
	bindStateProperties('gradient');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/MapView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/MapView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/MapView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var MapAnnotation = require('NGCore/Client/UI/MapAnnotation').MapAnnotation;

var MapView = exports.MapView = AbstractView.subclass(
/** @lends UI.MapView.prototype */
{
	'type':'mapview',
	/**
	* @class <code>MapView</code>
	* @name UI.MapView
	* @augments UI.View
	*/
	initialize: function($super, properties) {
		this._annotations = [];
		this._region = [];
		return $super(properties);
	},
	
	getCenterCoordinate: function()
	{
		return [this._region[0], this._region[1]];
	},
    
    setCenterCoordinate: function(lat, lon, animated)
    {
        this._region[0] = lat;
        this._region[1] = lon;
        if (!this._region[2])
            this._region[2] = 0.05;
        if (!this._region[3])
            this._region[3] = 0.05;            
        this.setRegion(this._region[0], this._region[1], this._region[2], this._region[3], animated);
    },
	
	getCoordinateSpan: function()
	{
		return [this._region[2], this._region[3]];
	},	
	
	selectAnnotation: function(annotation)
	{
		if (annotation instanceof MapAnnotation) {
			var index = this._annotations.indexOf(annotation);
			if (index != -1) {
				Commands.selectAnnotation.call(this, annotation.__objectRegistryId);
				return;
			}
		}
		Commands.selectAnnotation.call(this, -1);
	},
	
	addAnnotation: function(annotation)
	{
		if (annotation instanceof MapAnnotation) {
			this._annotations.push(annotation);
			
			Commands.addAnnotation.call(this, annotation.__objectRegistryId);
			
		} else throw {message: this.type + ".addAnnotation: " + annotation + " is not a MapAnnotation!"};
		return this;
	},
	
	removeAnnotation: function(annotation)
	{
		if (annotation instanceof MapAnnotation) {
			// Remove this node from parent's child list
			var index = this._annotations.indexOf(annotation);
			if (index != -1) {
				this._annotations.splice(index, 1);
			}
			
			// Remove from the parent at the system level
			Commands.removeAnnotation.call(this, annotation.__objectRegistryId);
		} else throw {message: this.type + ".removeAnnotation: " + annotation + " is not a MapAnnotation!"};
		return annotation;
	},
	
	/**
	 * @private
	 */    
	updateRegionFits: function(lat, lon ,latD , lonD) {
		//console.log(lat + " " + lon + " " + latD + " " + lonD);
		//console.log(this._region[0] + " " + this._region[1] + " " + this._region[2] + " " + this._region[3]);
		this._region[0] = lat;
		this._region[1] = lon;
		this._region[2] = latD;
		this._region[3] = lonD;
	},
	
	/**
	 * @private
	 */    
	performEventCallback: function($super, e) {
		if (e.eventType == 'regionchange') this.updateRegionFits(e.latitude, e.longitude , e.latitudeDelta , e.longitudeDelta);
		$super(e);
	}
});

// Properties
(function() {
	MapView.synthesizeProperty('scrollable', Commands.setScrollable);
	
	MapView.synthesizeProperty('zoomable', Commands.setZoomable);
	
	MapView.synthesizeCompoundProperty('region', Commands.setRegion);
	
	MapView.registerEventType('regionchange');
})();
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/MapAnnotation'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/MapAnnotation'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/MapAnnotation'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var MapAnnotation = exports.MapAnnotation = Element.subclass(
/** @lends UI.MapAnnotation.prototype */
{
	'type':'mapannotation',
	/**
	* @class <code>MapAnnotation</code>
	* @name UI.MapAnnotation
	* @augments Core.Class
	*/
	initialize: function($super, properties) {
		return $super(properties);
	},

	setCalloutLeftView: function(view)
	{
		this._calloutLeftView = view;
		Commands.setCalloutLeftView.call(this, view.__objectRegistryId);
	},

	getCalloutLeftView: function()
	{
		return this._calloutLeftView;
	},

	setCalloutRightView: function(view)
	{
		this._calloutRightView = view;
		Commands.setCalloutRightView.call(this, view.__objectRegistryId);
	},

	getCalloutRightView: function()
	{
		return this._calloutRightView;
	},

	setView: function(view)
	{
		this._view = view;
		Commands.setView.call(this, view.__objectRegistryId);
	},

	getView: function()
	{
		return this._view;
	},

	setImage: function(image)
	{
		console.log("WARNING : MapAnnotation.setImage has been deprecated. Use MapAnnotation.setView instead.");
		var iV = new UI.Image();
		iV.setImage(image);
		iV.setFrame([0, 0, 40, 40]);
		this.setView(iV);
	},

	/**
	 * @private
	 */    
	performEventCallback: function($super, e) {
		$super(e);
	}
});

// Properties
(function() {

	MapAnnotation.synthesizeCompoundProperty('coordinate', Commands.setCoordinate);
	
	MapAnnotation.synthesizeCompoundProperty('centerOffset', Commands.setCenterOffset);
	
	MapAnnotation.synthesizeProperty('calloutTitle', Commands.setCalloutTitle);

	MapAnnotation.synthesizeProperty('calloutSubtitle', Commands.setCalloutSubtitle);
	
	MapAnnotation.synthesizeProperty('calloutEnabled', Commands.setCalloutEnabled);

	MapAnnotation.registerEventType('select');
	MapAnnotation.registerEventType('deselect');
})();
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Analytics'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Analytics'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Analytics'] = exports; var Class = require('NGCore/Client/Core/Class').Class,
NgPipe = require('NGCore/Shared/NgPipe').NgPipe,
NgPipesRemote = require('NGCore/Shared/NgPipesRemote').NgPipesRemote;

var Analytics = Class.singleton(
/** @lends Core.Analytics.prototype */
{
    classname: 'Analytics',

    /**
     * @class The <code>Analytics</code> class serves as the custom messaging channel to the ngCore platform. 
     * The <code>Analytics</code> class provides developers with a way to keep track of game-specific items that require analysis and counting.
     * Use this class when you need your games to send custom elements that require in-game analytics support. 
     * @constructs The default constructor for setting up the NgPipe.
     * @augments Core.Class
     * @param {Boolean} [sendToRemote=true] Set <code>sendToRemote</code> to <code>true</code> to send analytics data to a remote server.
     * @param {String} [analyticsServer=ngmoco analytics server] A custom analytics server.
     * @private
     */
    initialize: function() {
        if (!this._pipe) {
          this._pipe = new NgPipe();
        }
    },

	/** @private */
	updateGLEXT: function()
	{
		try
		{
			var caps = require('NGCore/Client/Core/Capabilities').Capabilities;
			var ext = caps.getOglExtensions();
			if (ext.length > 2)	// > 2 means we got some actual data, not our fake string
			{
				// We need to rip out just one of the four tex compressions we want.
				var list = [];
				var goodies =
				[
					"GL_IMG_texture_compression_pvrtc",
					"GL_AMD_compressed_ATC_texture",
					"GL_OES_compressed_ETC1_RGB8_texture",
					"GL_AMD_compressed_3DC_texture"
				];
				for (var i in goodies)
				{
					var item = goodies[i];
					for (var j in ext)
					{
						if (ext[j] ===  item)
						{
							var rep = {};
							rep[caps.getDeviceName()] = item;
							list.push(rep);
						}
					}
				}

				for (i in list)
				{
					Analytics.reportGameEvent("openglexts", list[i]);
				}
			}
		}
		catch (e)
		{
			NgLogException(e);
		}
	},

    /** @private */
    enable: function() {
        this._pipe.enable();
    },

    /** @private */
    disable: function() {
        this._pipe.disable();
    },

    /** @private */
    setUrl: function(url) {
        this._pipe.setRemoteUrl(url);
    },

    /**
    * Report a navigation event that occurs when users navigate between application pages. 
    * Calling this function will alert the analytics platform that a user has generated a navigation event.
    * This information is used to plot how users move through the game, how long they spend on a page, and what page they navigate to next.
    *
    * @param {String} from The name of the page from which navigation originates. 
    * @param {String} to An analytics name for the destination page.
    * @param {String} btnid The ID of the button that triggered the navigation.
    */
    reportNavigation : function(from, to, btnid) {
        if (!(from && to)) {
            return false;
        }
        this._pipe.uiEvent('NAV', {to: to, fro: from, btnid: btnid} );
        return true;
    },
    /**
    * Report a custom game event. Use this when something in your game happens that you want to know about, 
    * but does not change the user's core stats.<br><br>
    * <b>Note:</b> This function serves as a catch-all. If you need your game to count or analyze something that does not fit into any 
    * other category, use this call.
    * 
    * @param {String} eventId The ID for the custom event.
    * @param {Object} payload A hash of extra information.
    * @param {Object} playerState A hash of important player states.
    */
    reportGameEvent : function(eventId, payload, playerState ) {
        if (!eventId) {
            return false;
        }

        this._pipe.gameEvent(eventId, payload, playerState);

        return true;
    },
    /**
    * Report a change to a playerstate. A playerstate is the object representation of the player's core stats. 
    * For example, if a player purchased an in-game item, you would call this to let the analytics system know what happened and how much gold was spent.
    * Everything in the player state is counted and recorded. Make sure to only pass in things for which you want to see the change 
    * (gold, mojo, grow, level, xp, health, lives, and so on).
    * <b>Note:</b> This is only for game state and should not include information that is unique to a user. For example, the user game tag or the user ID.
    *
    * @param {String} action The product ID of a purchased product. This essentially points out when an action is performed.
    * @param {Object} change A hash of currencies spent and/or gained. For example {mojo: 100, gold:-10}
    * @param {Object} playerState A hash of important player states after the purchase.
    */
    reportPlayerStateChange : function(action, change,  playerState) {
        if (action) {
            this._pipe.playerEvent(action, 'PLSTCHANGE', change, playerState);
            return true;
        } else {
            return false;
        }
    },

    /**
    * Report when a user reaches a new stage of a funnel. Funnel refers to a set of pages or requirements a user is required to engage in before proceeding. 
    * You can use this call to keep track of progress for all users. For example, keeping track of various stages users engage in for game registration.
    * Funnel stages are ordered by numeric ID. The funnel <code>stageName</code> is used for display. You do not need to define funnels ahead of time.
    * Funnel stages start at 0 and increase as the user proceeds further.<br><br>
    * <b>Note:</b> Calling <code>reportFunnelStage()</code> multiple times for a single user generates an incorrect count.
    *
    * @param {String} funnelName The name of the funnel that the user has progressed to.
    * @param {Number} funnelStage The integer value of the stage that the user reached.
    * @param {String} stageName The name of the stage that the user reached.
    * @param {Object} playerState A hash of important player states after a funnel stage.
    * @private
    */
    reportFunnelStage : function(funnelName, funnelStage, stageName, playerState) {
        var payload =  {};

        if (!(funnelName)) {
            return false;
        }
        if (funnelStage !== null && funnelStage !== undefined) {
            payload.stage = funnelStage;
        } else {
            return false;
        }

        if (stageName) {
            payload.stageName = stageName;
        }
        this._pipe.funnelEvent(funnelName, payload, playerState);

        return true;
    },
    /**
     * Report an interaction between two users.
     *
     * @param {String} actionId The action that the user is performing to interact with the other user
     * @param {String} friendGamerTag The other user with whom the current user is interacting.
     * @param {Object} payload A hash of extra information
     */
    reportSocialEvent: function(actionId, friendGamerTag, payload) {
        if (actionId && actionId.length && friendGamerTag && friendGamerTag.length ) {
            this._pipe.socialEvent(actionId, friendGamerTag, payload);
            return true;
        }
        return false;
    },
    /**
    * Report an error to analytics.
    *
    * @param {String} error_msg The error message to log.
    */
    reportError : function(error_msg) {
        if (!error_msg) {
            return false;
        }
        this._pipe.gameOpsEvent("ERR", {err: error_msg } );
        return true;
    },
    /**
     * @private
     */
    addTag: function(tag) {
        if (tag) {
            var evpl = {tag:tag};
            this._pipe.gameEvent('tag', evpl);
            return true;
        }
        return false;
    },
    /** @private */
    _getPipe: function() {
        return this._pipe;
    },
    /**
    * Game Service running inside privileged interpreter may use this method
    * to change the Social Analytic object to be used.  Please see MOBWEST-2300
	* for details
	*
    * @private
    */
	_setNgPipeSocialAnalytics: function(socialAnalyticObj) {
		if (this._pipe) {
			this._pipe._setSocialAnalytics(socialAnalyticObj);
		}
	}
});
exports.Analytics = Analytics;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Color'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Color'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Color'] = exports; exports.Color = require('NGCore/Shared/Color').Color;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Vector'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Vector'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Vector'] = exports; exports.Vector = require('NGCore/Shared/Vector').Vector;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Point'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Point'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Point'] = exports; exports.Point = require('NGCore/Shared/Point').Point;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Size'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Size'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Size'] = exports; exports.Size = require('NGCore/Shared/Size').Size;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Rect'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Rect'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Rect'] = exports; exports.Rect = require('NGCore/Shared/Rect').Rect;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/MessageEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/MessageEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/MessageEmitter'] = exports; exports.MessageEmitter = require('NGCore/Shared/MessageEmitter').MessageEmitter;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/MessageListener'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/MessageListener'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/MessageListener'] = exports; exports.MessageListener = require('NGCore/Shared/MessageListener').MessageListener;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/ObjectRegistry'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/ObjectRegistry'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/ObjectRegistry'] = exports; var Class = require('NGCore/Client/Core/Class').Class;

exports.ObjectRegistry = Class.singleton(
{
	classname: 'ObjectRegistry',
		
	/** @private @class @status */
	initialize: function()
	{
		this._currentId = 0;
		this._guardId = 0;
		this._objects = {};
	},
	
	/** @status */
	register: function(obj)
	{
		if(obj.__objectRegistryId)
			throw new Error('ObjectRegistry.register: object already registered');
			
		var id = "" + ++this._currentId;
		obj.__objectRegistryId = id;
		this._objects[id] = obj;
	},
	
	/** @status */
	unregister: function(obj)
	{
		if(!obj.__objectRegistryId)
			throw new Error('ObjectRegistry.unregister: object not registered');
			
		var id = obj.__objectRegistryId;
		obj.__objectRegistryId = 0;
		delete this._objects[id];
	},
	
	/** @status */
	isObjectRegistered: function(obj)
	{
		if(obj.__objectRegistryId)
			return true;
		else
			return false;
	},
	
	/** @status */
	isIdRegistered: function(id)
	{
		if(this._objects[id])
			return true;
		else
			return false;
	},
	
	/** @status */
	objectToId: function(obj)
	{
		var id = obj.__objectRegistryId;
		
		if(!id)
			throw new Error('ObjectRegistry.objectToId: object not registered');
		
		return id;
	},
	
	/** @status */
	idToObject: function(id)
	{
		return this._objects[id];
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Time'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Time'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Time'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class Time
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Client/Core/Class').Class;
var Proc = require('NGCore/Client/Core/Proc').Proc;

var Time = Class.singleton(
/** @lends Core.Time.prototype */
{
	classname: 'Time',
	mFrameTime: 0,
	mFrameDelta: 0,

	/**
	 * @class the <code>Time</code> class constructs objects that provide access to the system clock and system timings for a device.
	 * @status iOS, Android, Flash
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 */
	initialize: function()
	{
	},

	/**
	 * Return the timestamp for the current time frame (expressed in milliseconds).
	 * @returns {Number} The timestamp for the current time frame.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFrameTime: function()
	{
		return this.mFrameTime;
	},

	/**
	 * Return the delta time in milliseconds since the last time frame.
	 * @returns {Number} The delta time since the last time frame.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFrameDelta: function()
	{
		return this.mFrameDelta;
	},

	/**
	 * Return the real-time clock in milliseconds. 
	 * <b>Note:</b> This differs from the time frame timestamp, which is constant for the entire time frame.
	 * @returns {Number} The real-time clock.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getRealTime: function()
	{
		return (new Date()).getTime();
	},

	$_frameTimeRecv: function( cmd )
	{
		var o = {};
		this._frameTimeRecvGen(cmd, o);

		this.mFrameDelta = this.mFrameTime ? o.time - this.mFrameTime : 1;
		this.mFrameTime = o.time;
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 351
	// Method frameTime = -1
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Time._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				case -1:
					Time._frameTimeRecv( cmd );
					break;
				default:
					NgLogE("Unknown static method id " + cmdId + " in Time._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[351] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	$_frameTimeRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Time.frameTime from command: " + cmd );
			return false;
		}
		
		obj[ "time" ] = Proc.parseInt( cmd[ 0 ] );
		if( obj[ "time" ] === undefined )
		{
			NgLogE("Could not parse time in Time.frameTime from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $_frameTimeRecv: function( cmd ) {}

// {{/Wg Generated Code}}

});

exports.Time = Time;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/toMD5'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/toMD5'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/toMD5'] = exports; exports.toMD5 = require('NGCore/Shared/Lib/md5').toMD5;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/SHA1'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/SHA1'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/SHA1'] = exports; var sha1 = require('NGCore/Shared/Lib/sha1');

exports.SHA1 = {
	b64_hmac_sha1: sha1.b64_hmac_sha1,
	hex_sha1: sha1.hex_sha1,
	b64_sha1: sha1.b64_sha1
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/UpdateEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/UpdateEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/UpdateEmitter'] = exports; var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Proc = require('NGCore/Client/Core/Proc').Proc;
var Time = require('NGCore/Client/Core/Time').Time;

exports.UpdateEmitter = MessageEmitter.singleton(
/** @lends Core.UpdateEmitter.prototype */
{
	classname: 'UpdateEmitter',
		
	/**
	 * @class The <code>UpdateEmitter</code> module constructs a singleton object that emits every frame with the delta in milliseconds since the last frame.<br><br>
	 * <b>Note:</b> <code>{@link Core.UpdateEmitter#setTickRate}</code> is also used to define the framerate of any animation reproduced by a sprite 
	 * (see <code>{@link GL2.Sprite#setAnimation}</code>).
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		
		this.__clubObject = new NgEngineEntity();
		this.__clubObject.mIsUpdatable = true;
		this.__clubObject.onUpdate = this._emitTime.bind(this);
		this.__clubObject.register();
		
		this._createSendGen(this.__objectRegistryId);
	},
	
	_emitTime: function()
	{
		this.emit(Time.getFrameDelta());
	},
	/**
	 * Set the tick rate that this <code>UpdateEmitter</code> object uses to send updates.<br><br>
	 * <b>Example:</b> Calling <code>setTickRate(15)</code>, any <code>MessageListener</code> objects that are listening 
	 * to the <code>UpdateEmitter</code> receive messages 15 times a second.	 
	 * @param {Number} r The new tick rate.
	 * @see GL2.Sprite
	 * @status iOS, Android, Flash
	 */
	setTickRate: function( r ) 
	{
		this._setTickRateSendGen(r);
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 304
	// Method create = -1
	// Method setTickRate = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in UpdateEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in UpdateEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[304] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Proc.appendToCommandString( ":304,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_setTickRateSendGen: function( rate )
	{
		Proc.appendToCommandString( ":304,2," + this.__objectRegistryId + "," + rate  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// setTickRate: function( rate ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Proc'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Proc'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Proc'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class Proc
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Class = require('NGCore/Client/Core/Class').Class;
var Base64 = require('NGCore/Client/Core/Base64').Base64;

////////////////////////////////////////////////////////////////////////////////

exports.Proc = Class.singleton(
{
	classname: 'Proc',
	
	initialize: function()
	{
		this._commandString = "";
	},
	
	appendToCommandString: function( str )
	{
		this._commandString += str;
	},
	
	getCommandString: function()
	{
		return this._commandString;
	},
	
	clearCommandString: function ()
	{
		this._commandString = "";
	},
	
	parseBool: function( v )
	{
		return v == 1 ? true : false;
	},

	parseInt: function( v )
	{
		return parseInt( v, 10 );
	},
	
	parseFloat: function( v )
	{
		return parseFloat( v );
	},
	
	parseString: function( v )
	{
		return Base64.decode( v );
	},
	
	parseJSONString: function( v )
	{
		return JSON.parse( Base64.decode( v ) );
	},

	setPrivileged: function()
	{
		this._privileged = true;
	},

	isPrivileged: function()
	{
		return this._privileged ? true : false;
	},

// {{?Wg Generated Code}}
	_classRecvGen: function( cmd )
	{
		var classId = parseInt( cmd.shift(), 10 );
		
		var handler = PROC_DISPATCH_TABLE[classId];
		if(handler)
		{
			handler(cmd);
		}
		else
		{
			NgLogE( "Unknown class id " + classId + " in _classRecvGen" );
		}
	}
// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/_LocalGameList'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/_LocalGameList'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/_LocalGameList'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class _LocalGameList
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Class = require('NGCore/Client/Core/Class').Class;
var Proc = require('NGCore/Client/Core/Proc').Proc;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var Time = require('NGCore/Client/Core/Time').Time;
var toMD5 = require('NGCore/Client/Core/toMD5').toMD5;
var Util = require('NGCore/Client/Network/Util').Util;
var Base64 = require('NGCore/Client/Core/Base64').Base64;

////////////////////////////////////////////////////////////////////////////////

exports._LocalGameList = Class.singleton (
/** @lends Core._LocalGameList.prototype */
{
	classname: '_LocalGameList',

	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		this.mGameList = [];
		var Storage = require('NGCore/Client/Storage').Storage;
		this.mFile = Storage.FileSystem;
		this.mGameStore = Storage.KeyValueCache.global("Core.GameList");

		this.mLoadingGames = {};
		this.mActiveGameKey = "activeGames";
		this.mRequiredAvailableSpace = 0;
		this.mSpaceAvailable = 0;
		this.mSpaceFreeCallbacks = [];
		this._firstBootGameLaunch = true;

		this._getRepoSpaceSendGen();

		this._setStage(this.ProgressStage.BootFirst);
		this._reloadGameList();
	},
	
	ProgressStage:
	{
		BootFirst: {},
		BootSecond: {},
		GameWithoutSecond: {},
		GameWithSecond: {},
		Regular: {}
	},
	
	_setStage: function(stage)
	{
		this._progressStage = stage;
		switch(stage)
		{
			case this.ProgressStage.BootFirst:
				console.log('setStage BootFirst');
				this._progressMin = 0;
				this._progressRange = 0.25;
				break;
			case this.ProgressStage.BootSecond:
				console.log('setStage BootSecond');
				this._progressMin = 0.25;
				this._progressRange = 0.25;
				break;
			case this.ProgressStage.GameWithoutSecond:
				console.log('setStage GameWithoutSecond');
				this._progressMin = 0.25;
				this._progressRange = 0.75;
				break;
			case this.ProgressStage.GameWithSecond:
				console.log('setStage GameWithSecond');
				this._progressMin = 0.5;
				this._progressRange = 0.5;
				break;
			case this.ProgressStage.Regular:
				console.log('setStage Regular');
				this._progressMin = 0;
				this._progressRange = 1;
				break;
			default:
				console.log('setStage ERROR');
				this._progressMin = 0;
				this._progressRange = 1;
		}
		console.log('min:', this._progressMin, 'range:', this._progressRange);
	},
	
	_nextStage: function()
	{
		switch(this._progressStage)
		{
			case this.ProgressStage.BootFirst:
				this._setStage(this.ProgressStage.GameWithoutSecond);
				break;
			case this.ProgressStage.BootSecond:
				this._setStage(this.ProgressStage.GameWithSecond);
				break;
			case this.ProgressStage.GameWithoutSecond:
				this._setStage(this.ProgressStage.Regular);
				break;
			case this.ProgressStage.GameWithSecond:
				this._setStage(this.ProgressStage.Regular);
				break;
		}
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 303
	// Method create = -1
	// Method updateGame = 2
	// Method updateDone = 3
	// Method getRepoSpace = 4
	// Method repoSpace = 5
	// Method deleteGame = 6
	// Method setUpdateProgress = 7
	// Method pauseUpdate = 8
	// Method resumeUpdate = 9
	// Method cancelUpdate = 10
	// Method updateProgress = 11
	// Method allowBGUpdates = 12
	// Method runGame = 13
	// Method finishGame = 14
	// Method setProgressText = 15
	// Method setSplashVisible = 16
	// Method exceptionForwarded = 17
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._updateGameRecv( cmd );
					break;
				case 5:
					instance._repoSpaceRecv( cmd );
					break;
				case 6:
					instance._deleteGameRecv( cmd );
					break;
				case 8:
					instance._pauseUpdateRecv( cmd );
					break;
				case 9:
					instance._resumeUpdateRecv( cmd );
					break;
				case 10:
					instance._cancelUpdateRecv( cmd );
					break;
				case 12:
					instance._allowBGUpdatesRecv( cmd );
					break;
				case 13:
					instance._runGameRecv( cmd );
					break;
				case 14:
					instance._finishGameRecv( cmd );
					break;
				case 17:
					instance._exceptionForwardedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in _LocalGameList._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in _LocalGameList._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[303] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_updateGameRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.updateGame from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _LocalGameList.updateGame from command: " + cmd );
			return false;
		}
		
		obj[ "id" ] = Proc.parseInt( cmd[ 1 ] );
		if( obj[ "id" ] === undefined )
		{
			NgLogE("Could not parse id in _LocalGameList.updateGame from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_repoSpaceRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.repoSpace from command: " + cmd );
			return false;
		}
		
		obj[ "space" ] = Proc.parseInt( cmd[ 0 ] );
		if( obj[ "space" ] === undefined )
		{
			NgLogE("Could not parse space in _LocalGameList.repoSpace from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_deleteGameRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.deleteGame from command: " + cmd );
			return false;
		}
		
		obj[ "mdFive" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "mdFive" ] === undefined )
		{
			NgLogE("Could not parse mdFive in _LocalGameList.deleteGame from command: " + cmd );
			return false;
		}
		
		obj[ "game" ] = Proc.parseString( cmd[ 1 ] );
		if( obj[ "game" ] === undefined )
		{
			NgLogE("Could not parse game in _LocalGameList.deleteGame from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_pauseUpdateRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.pauseUpdate from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _LocalGameList.pauseUpdate from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_resumeUpdateRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.resumeUpdate from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _LocalGameList.resumeUpdate from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_cancelUpdateRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.cancelUpdate from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _LocalGameList.cancelUpdate from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_allowBGUpdatesRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.allowBGUpdates from command: " + cmd );
			return false;
		}
		
		obj[ "allow" ] = Proc.parseBool( cmd[ 0 ] );
		if( obj[ "allow" ] === undefined )
		{
			NgLogE("Could not parse allow in _LocalGameList.allowBGUpdates from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_runGameRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.runGame from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _LocalGameList.runGame from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_finishGameRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.finishGame from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_exceptionForwardedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.exceptionForwarded from command: " + cmd );
			return false;
		}
		
		obj[ "exceptionString" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "exceptionString" ] === undefined )
		{
			NgLogE("Could not parse exceptionString in _LocalGameList.exceptionForwarded from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Proc.appendToCommandString( ":303,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_updateDoneSendGen: function( id, error )
	{
		Proc.appendToCommandString( ":303,3," + this.__objectRegistryId + "," + id + "," + Base64.encode( error )  );
	},
	
	/** @private */
	_getRepoSpaceSendGen: function(  )
	{
		Proc.appendToCommandString( ":303,4," + this.__objectRegistryId );
	},
	
	/** @private */
	_setUpdateProgressSendGen: function( progress )
	{
		Proc.appendToCommandString( ":303,7," + this.__objectRegistryId + "," + progress  );
	},
	
	/** @private */
	_updateProgressSendGen: function( url, cur, total, error )
	{
		Proc.appendToCommandString( ":303,11," + this.__objectRegistryId + "," + Base64.encode( url ) + "," + cur + "," + total + "," + ( error ? 1 : 0 )  );
	},
	
	/** @private */
	_setProgressTextSendGen: function( text )
	{
		Proc.appendToCommandString( ":303,15," + this.__objectRegistryId + "," + Base64.encode( text )  );
	},
	
	/** @private */
	_setSplashVisibleSendGen: function( visible )
	{
		Proc.appendToCommandString( ":303,16," + this.__objectRegistryId + "," + ( visible ? 1 : 0 )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _updateGameRecv: function( cmd ) {}
	// updateDone: function( id, error ) {}
	
	// getRepoSpace: function(  ) {}
	
	// _repoSpaceRecv: function( cmd ) {}
	// _deleteGameRecv: function( cmd ) {}
	// setUpdateProgress: function( progress ) {}
	
	// _pauseUpdateRecv: function( cmd ) {}
	// _resumeUpdateRecv: function( cmd ) {}
	// _cancelUpdateRecv: function( cmd ) {}
	// updateProgress: function( url, cur, total, error ) {}
	
	// _allowBGUpdatesRecv: function( cmd ) {}
	// _runGameRecv: function( cmd ) {}
	// _finishGameRecv: function( cmd ) {}
	// setProgressText: function( text ) {}
	
	// setSplashVisible: function( visible ) {}
	
	// _exceptionForwardedRecv: function( cmd ) {}

// {{/Wg Generated Code}}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
	_updateGameRecv: function( cmd )
	{
		this._getRepoSpaceSendGen();

		var o = {};
		this._updateGameRecvGen(cmd, o);

		if (o.url in this.mLoadingGames)
		{
			this.mLoadingGames[o.url].id = o.id;
			this.mLoadingGames[o.url].dlman.resume();
		}
		else
		{
			this.updateGame(o.url, o.id,
				(function (url, newFiles, err)
				{
					o.id = this.mLoadingGames[url].id;
					this._updateDoneSendGen(o.id, err);
				}).bind(this, o.url)
			);
		}
	},
	mobageRunGame: function (funk)
	{
		this._gameRunner = funk;
	},
	_runGameRecv: function( cmd )
	{
		var o = {};
		this._runGameRecvGen(cmd, o);
		if (this._gameRunner)
		{
			console.log("_LGL running gameRunner " + o.url);
			this._gameRunner(o.url);
		}
		else
		{
			console.log("_LGL running game " + o.url);
			var _int_LGL = require('NGCore/Client/Core/_int_LGL')._int_LGL;
			_int_LGL.launch(o.url, _int_LGL.ProcID.Game);
		}
	},
	/**
	 * set the function that kills the current game app
	 */
	setFinishGameHandler: function(funk)
	{
		this._finishGameHandler = funk;
	},
	_finishGameRecv: function()
	{
		if (this._finishGameHandler)
		{
			this._finishGameHandler();
		} else {
			console.log("_LocalGameList: finishGameHandler is not set");
		}
	},
	_repoSpaceRecv: function( cmd )
	{
		var obj = {};
		this._repoSpaceRecvGen(cmd, obj);
		this.mSpaceAvailable = obj.space;
		console.log("SD card space available(b): " + this.mSpaceAvailable);

		var length = this.mSpaceFreeCallbacks.length;
		while (length--)
		{
			(this.mSpaceFreeCallbacks.pop())();
		}
	},

	_deleteGameRecv: function( cmd )
	{
		// site to calc md5: http://pajhome.org.uk/crypt/md5/
		var allowedGames =
		[
			"http://10.15.", // Allow partial ones, for testing
			'http://gamehub.mobage.com/app/1.0s/gamehub',
			'url of allowed game'
		];

		var obj = {};
		this._deleteGameRecvGen(cmd, obj);
		var i;
		for(i in allowedGames)
		{
			var match = obj.game.match(allowedGames[i]);
			if(match && !match.index)
			{
				NgLogD("Deleting " + obj.mdFive);
				this.deleteGameFiles(obj.mdFive);

				var doneCB = (function ()
				{
					NgLogD("Finished deleting game from " + this.mActiveGameKey + " for " + obj.mdFive );
				}).bind(this);
				this._deleteGameFromStorage(obj.mdFive,doneCB);

				return;
			}
			else
			{
				// for testing, allow any local server starting with 10.15
			}
		}
		NgLogE("_LocalGameList unauthorized call to deleteGame from "+obj.game+"!");
	},

// _deleteGameFromStorage is for deleting the games info from LGL storage, not the game's storage

	_deleteGameFromStorage: function(mdFive,doneCB)
	{
		var self = this;
		this.mGameStore.getItem(this.mActiveGameKey,
			function(error, value)
			{
				var list = JSON.parse(value);
				
				var good = false;
				var ind;
				var out = [];
				for(ind = 0; ind < list.length; ++ind)
				{
					if(list[ind].name == mdFive)
						good = true;
					else
						out.push(list[ind]);
				}
				
				if( good )
				{
					NgLogD("_LocalGameList found and removed " + mdFive);
					self.mGameStore.setItem(self.mActiveGameKey, JSON.stringify(out), doneCB);
				}
				else
				{
					NgLogD("_LocalGameList failed to find and remove " + mdFive);
					doneCB("Could not remove item: " + error);
				}
				
			}, true
		);
	},

	getGameConfig: function(identifier, isMDFive, callBack)
	{
		if (typeof isMDFive == 'function')
		{
			callBack = isMDFive;
			isMDFive = false;
		}

		var folder;
		if (isMDFive)
		{
			folder = identifier;
		}
		else
		{
			var Util = require('NGCore/Client/Network/Util').Util;
			var norm = Util.NormalizeUrl(identifier);
			folder = toMD5(norm);
		}

		this.mFile.readFile(folder + "/" + Capabilities._getConfigFile(),
			function (err, contents)
			{
				var ret = {};
				if (err || !contents)
				{
					console.log("Could not get config from %s! err: %s", identifier, err);
				}
				else
				{
					ret = JSON.parse(contents);
				}
				callBack(ret);
			}
		);
	},

	getRepoSpace: function()
	{
		return this.mSpaceAvailable;
	},

	getConfig: function(gameOrigin, name, callback, failEarly)
	{// callback = function (config, err)
		// XHR
		var XHR = require('NGCore/Client/Network/XHR').XHR;
		var Util = require('NGCore/Client/Network/Util').Util;
		
		var httpStatus = 0;
		
		Util.OperationWithRetries(function(failCb)
		{
			var req = new XHR();
			req.onreadystatechange = function()
			{
				if(req.readyState == 4)
				{
					httpStatus = req.status;
					if(httpStatus == 200)
					{
						// Succes.
						callback(req.responseText);
					}
					else if(httpStatus == 404)
					{
						// File not on server, so load from the regular location
						console.log("no configuration file found at %s, using root server", gameOrigin + name);
						callback( "{}" );
					}
					else
					{
						//Error! Retry
						failCb();
					}
				}
			};

			req.open('GET', gameOrigin + name + Util.getCacheBustingString(), true);
			req.send();
		}, function()
		{
			callback(null, true, httpStatus);
		}, failEarly);
	},

	// gameOrigin: url to folder holding webgame.ngmanifest
	// doneCB = function(totalBytes, error)
	updateGame: function(gameOrigin, id, doneCB, failEarly, failAllowed)
	{
		// console.log ( "LGL.updateGame url = " + gameOrigin );
		// console.log ( "LGL.updateGame boot game = " + Capabilities.getBootGame() );
		
		var re = new RegExp(".*" + Capabilities.getBootGame());
		var match = gameOrigin.match(re);
		
		if (match) 
			this._firstBootGameLaunch = false;
			
		// console.log ( "_LocalGameList.updateGame updating game." );

		// Normalize URL
		var Util = require('NGCore/Client/Network/Util').Util;
		gameOrigin = Util.NormalizeUrl(gameOrigin);
		var name = toMD5(gameOrigin);
		this.mLoadingGames[gameOrigin] = {id: id};

		console.log(gameOrigin + " toMD5: " + name);

		// Get device-specific manifest directory
		var buildPath = {"Android" : "android", "iPhone OS" : "ios", "flash" : ""};
		// Get Device capabilities platformOs
		var caps = require('NGCore/Client/Core/Capabilities').Capabilities;
		var build = "/" + buildPath[caps.getPlatformOS()];

		this._setProgress(0);

		var curContUrl = "";
		var configFile = toMD5(gameOrigin) + "/" + caps._getConfigFile();
		
		// This is guaranteed to be synchronous, so will always occur before the callback for subsequent operations.
		this.mFile.readFile(configFile,
			function(err, data)
			{
				if (data)
				{
					var obj = JSON.parse(data);
					curContUrl = obj.contentUrl;
				}
			}
		);

		this.getConfig(gameOrigin + build, "/" + caps._getConfigFile(),
		(function(config, error, status)
		{
			if (error)
			{
				doneCB(0, error);
				delete this.mLoadingGames[gameOrigin];
			}
			else
			{
				this._setProgress(0.1);

				// Read config
				var parsedConfig = JSON.parse(config);
				if(!parsedConfig.contentUrl)
				{
					parsedConfig.contentUrl = gameOrigin + build;
				}
				else if (parsedConfig.contentUrl == curContUrl)
				{
					// no need to update.
					this._setProgress( 1.0 );
					this._setStage(this.ProgressStage.Regular);
					this.mFile.writeFile(configFile, JSON.stringify(parsedConfig),
						function(err) {console.log(err); } );
					doneCB(0);
					delete this.mLoadingGames[gameOrigin];
					return;
				}

				this._callDownloadManifest(parsedConfig, gameOrigin, name, failEarly, failAllowed, (function(bytes, error)
				{
					this._setProgress( 1.0 );
					this._nextStage();

					if (! error) {
						var that = this;
						this._reloadGameList({name:name, url:gameOrigin}, function()
						{
							if (doneCB && (typeof doneCB == 'function')) {
								doneCB(bytes, error);
								delete that.mLoadingGames[gameOrigin];
							}
						});
					} else {
						doneCB(bytes, error);
						delete this.mLoadingGames[gameOrigin];
					}
				}).bind(this));
			}
		}).bind(this), failEarly);
	},

	_allowBGUpdatesRecv: function( cmd )
	{
		var o = {};
		this._allowBGUpdatesRecvGen(cmd, o);
		this._pauseOrResumeAll(o.allow);
	},

	_pauseOrResumeAll: function(resume)
	{
		for (i in this.mLoadingGames)
		{
			if (resume)
			{
				console.log("Resuming download of " + i);
				this.resumeUpdate(i);
			}
			else
			{
				console.log("Pausing download of " + i);
				this.pauseUpdate(i);
			}
		}
	},

	pauseUpdate: function(url)
	{
		if (this.mLoadingGames[url])
		{
			if(this.mLoadingGames[url].dlman)
			{
				this.mLoadingGames[url].dlman.pause();
				this.mLoadingGames[url].userPause = true;
			}
		}
	},

	_pauseUpdateRecv: function(cmd)
	{
		var o = {};
		this._pauseUpdateRecvGen(cmd, o);
		this.pauseUpdate(o.url);
	},

	resumeUpdate: function(url)
	{
		if (this.mLoadingGames[url])
		{
			if(this.mLoadingGames[url].dlman)
			{
				this.mLoadingGames[url].dlman.resume();
				this.mLoadingGames[url].userPause = false;
			}
		}
	},

	_resumeUpdateRecv: function(cmd)
	{
		var o = {};
		this._resumeUpdateRecvGen(cmd, o);
		this.resumeUpdate(o.url);
	},

	cancelUpdate: function(url)
	{
		if (this.mLoadingGames[url])
		{
			if (this.mLoadingGames[url].dlman) {
                this.mLoadingGames[url].dlman.abort();
            }
			delete this.mLoadingGames[url];

			//Cancel the keep alive request as well
			var LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;

            this.identification_key = 'manifest_download';
            LifecycleEmitter.cancelEngineKeepAlive(this);
		}
	},

	_cancelUpdateRecv: function(cmd)
	{
		var o = {};
		this._cancelUpdateRecvGen(cmd, o);
		this.cancelUpdate(o.url);
	},

	_setProgress: function (progress) {
		if(progress > 1) progress = 1;
		if(progress < 0) progress = 0;
		progress = progress*this._progressRange + this._progressMin;
		this._setUpdateProgressSendGen(progress);
	},

	listenToProgress: function (listener)
	{
		this._privListener = listener;
	},

	_updateProgress: function(url, prog, total, err)
	{
		//console.log("Updating progress for: %s, %d, %d " + err, url, prog, total);
		if (this._privListener)
			this._privListener(url, prog, total, err);

		if (this.mLoadingGames[url] && this.mLoadingGames[url].id >=0)
			this._updateProgressSendGen(url,prog,total,err);
	},

	// doneCB = function(totalBytes, error)
	_callDownloadManifest: function (config, gameOrigin, name, failEarly, failAllowed, doneCB)
	{
		var contentUrl = config.contentUrl;
		var reportTotalBytes = 0;
		var self = this;
		var Downloader = require('NGCore/Client/Network/DownloadManifest').DownloadManifest;
		
		var manifestName = require('NGCore/Client/Core/_int_LGL')._int_LGL.getManifestName(config);

		// Do download
		(function doDownload()
		{
			var dler = new Downloader();
			dler.mLocalGameList = self;
			var firstProgress = true;
            var LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;
            this.identification_key = 'manifest_download';
            NgLogD("++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++Manifest Download Request Keep Engine Alive");
            LifecycleEmitter.requestEngineKeepAlive(this);
			// Only allow this on iOS
			config.omitJsUpdate = config.omitJsUpdate && (Capabilities.getPlatformOS() == "iPhone OS");
			dler._setConfig(config);
			dler.start(contentUrl, name, {'webgame.ngmanifest':manifestName}, function(bytesDownloaded, bytesTotal)
			{
				if(firstProgress)
				{
					// First progress callback is made when manifest is downloaded.
					firstProgress = false;
					self._setProgress(0.2);
					reportTotalBytes = bytesTotal;
				}
				else
				{
					self._setProgress(0.3 + 0.6 * (bytesDownloaded / bytesTotal));
				}

				// update LGL
				self._updateProgress(gameOrigin, bytesDownloaded, bytesTotal);
			}, function(error, manifest, wasCached)
			{
				if (failAllowed)
				{
					if (doneCB)
					{
						doneCB(reportTotalBytes, error);
					}
				}
				else if(error)
				{
					NgLogE("Error: " + error);
					// update LGL
					self._updateProgress(gameOrigin, 0, 0, error);
					doneCB(0, error);
				}
				else
				{
					if (doneCB)
					{
						doneCB(reportTotalBytes);
					}
				}

                this.identification_key = 'manifest_download';
                LifecycleEmitter.cancelEngineKeepAlive(this);
			}, false, failEarly);
			self.mLoadingGames[gameOrigin].dlman = dler;
		})();
	},

	freeSpace: function(space, cb)
	{
		this.mRequiredAvailableSpace = space;
		this.mSpaceFreeCallbacks.push(
			(function()
			{
				if (this.mRequiredAvailableSpace > this.mSpaceAvailable)
				{
					if (this._privListener)
					{
						this._privListener("", 0, 0, "SD card is full");
					}
					else
					{
						console.log("Warning!! Mobage is not handling SD card full error!");
						// This is Preservation of ancient code which has and will likely never execute
						var checkAgain = function()
						{
							if (this.mRequiredAvailableSpace > this.mSpaceAvailable)
							{
								this.pruneGames(1);
								this.mSpaceFreeCallbacks.push(checkAgain);
							}
							else
							{
								cb();
							}
						};
						// Is a redundant check on space, but looks better/is simpler/won't ever be used anyhow
						checkAgain();
					}
				}
				else
				{
					cb();
				}
			}).bind(this)
		);

		this._getRepoSpaceSendGen();
	},

	pruneGames: function(number)
	{
		var self = this;

		// Function to put oldest games on top of the stack
		var sort = function (l, r)
		{
			return r.lastRun - l.lastRun;
		};

		this.mGameStore.getItem(this.mActiveGameKey,
			function(error, value)
			{
				var list = JSON.parse(value);
				list.sort(sort);
				while (number-- && (list.length - 1))
				{
					var game = list.pop();

					// Do not delete the currently loading game
					if (!(game.name in self.mLoadingGames))
					{
						// delete game
						self.deleteGameFiles(game.name);
					}
					else
					{
						list.push(game);
					}
				}

				// Save the data
				self.mGameStore.setItem(self.mActiveGameKey, JSON.stringify(list));
			}, true
		);
	},

	deleteGame: function (url, callBack)
	{
		var Util = require('NGCore/Client/Network/Util').Util;
		var norm = Util.NormalizeUrl(url);
		var mdFive = toMD5(norm);

		this.deleteGameFiles(mdFive);
		this._deleteGameFromStorage(mdFive, callBack);
	},

	// Delete the KeyValueCache.local of the given game
	deleteGameKeyValue: function(mdFive)
	{
		var kvm = require('NGCore/Client/Storage').KeyValueCache;
		kvm.global(mdFive).clear();
	},

	deleteGameFiles: function(game)
	{
		var self = this;
		self.mFile.deleteFile( game , 
			function(err)
				{
					if(err == "" )
						NgLogI('Deleted');
					else
						NgLogD("Could not delete game");

					self._getRepoSpaceSendGen();
				});
	},

	getGameList: function()
	{
		return this.mGameList;
	},

	clearWatch: function()
	{
		var fs = require('NGCore/Client/Storage/FileSystem').FileSystem;
		fs.deleteFile(".watch");
	},

	/**
	 * @private
	 */
	_reloadGameList: function(newItem, cb)
	{
		this.mGameStore.getItem(this.mActiveGameKey,
			(function(error, value)
			{
				var list;
				if (value)
					list = JSON.parse(value);
				else
					list = [];

				if (newItem)
				{
					var bNew = true;
					for (var i in list)
					{
						if (list[i].name == newItem.name)
						{
							bNew = false;
							newItem.lastRun = list[i].lastRun;
							list[i] = newItem;
							break;
						}
					}

					if (bNew)
					{
						list.push(newItem);
					}
					this.mGameStore.setItem(this.mActiveGameKey, JSON.stringify(list));
				}

				this.mGameList = list;

				if (typeof cb == 'function')
					cb();
			}).bind(this),
			true
		);
	},

	_getRunningGame: function(callBack)
	{
		// Function to put oldest games on top of the stack
		var sort = function (l, r)
		{
			return r.lastRun - l.lastRun;
		};

		this._reloadGameList(false, (function(cb)
		{
			var list = this.mGameList;
			list.sort(sort);
			var current = null;
			var len = list.length;
			for (var i = 0; i < len; ++i)
			{
				if (list[i].lastRun)
				{
					current = list[i];
					break;
				}
			}
			if (current && current.url)
				cb(current.url);
		}).bind(this, callBack));
	},

	/** @private */
	_pausingGame: function()
	{
		// true to resume download when pausing a game
		this._pauseOrResumeAll(true);
	},

	/** @private */
	_resumingGame: function()
	{
		// Check if the current game allows downloading
		this._getRunningGame((function(game)
		{
			this.getGameConfig(game, (function(config)
			{
				if (config.noBackgroundUpdates)
				{
					// false to pause download when resuming a game
					this._pauseOrResumeAll(false);
				}
			}).bind(this));
		}).bind(this));
	},

	setSplashVisible: function( visible )
	{
		this._setSplashVisibleSendGen(visible);
	},

	setProgressText: function( text )
	{
		this._setProgressTextSendGen(text);
	},

	updateAvailable: function(game, doneCB, errorCB)
	{
		var _int_LGL = require('NGCore/Client/Core/_int_LGL')._int_LGL;
		_int_LGL.updateAvailable(game, doneCB, errorCB);
	},

	/*
	 * Set the exception handler. Default is undefined.
	 * @param {Function} the function that handles the exception occurred in the Game proc. signature: function(exceptionString)
	 */
	setExceptionHandler: function(func)
	{
		this._exceptionHandler = func;
	},

	_exceptionForwardedRecv: function( cmd )
	{
		var obj = {};
		this._exceptionForwardedRecvGen(cmd, obj);
		var exception = JSON.parse(obj.exceptionString);
		
		if (this._exceptionHandler)
			this._exceptionHandler(exception);
		else
			NgLogException(exception);
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/NativeAppLaunch'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/NativeAppLaunch'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/NativeAppLaunch'] = exports; // @deprecated
var NativeAppLaunch;

exports.NativeAppLaunch = NativeAppLaunch;; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/NgPipe'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/NgPipe'] || {}; $MODULE_REGISTRY['NGCore/Shared/NgPipe'] = exports; var Class = require('NGCore/Shared/Class').Class;
var NgPipesRemote = require('NGCore/Shared/NgPipesRemote').NgPipesRemote;
var hex_sha1 = require('NGCore/Shared/Lib/sha1').hex_sha1;
var __hasProp = Object.prototype.hasOwnProperty;
var CapabilitiesReq = require('NGCore/Client/Core/Capabilities');

/*
The NgPipes object
*/

NgPipe = Class.subclass({
    classname: "NgPipe",
    initialize: function(options) {
        options = options || {};
		/*
		 * Note that this require statement cannot be put at the top level
		 * because it will cause code to fail to execute.  It's an intricacy
		 * in our require system.
		 */
		this._socAnalytics = require('NGCore/Client/Social').Social.Common.Analytics;
        this._meta = options.meta || {};
        this._queue = null;
        this._isSendQueued = false;
        this._sendDelay = options.sendDelay || 5000;
        this._meta = options.meta || {};
        this._seqStart = options.seqStart || new Date().getTime();
        this._playerState = options.playerState || null;
        this._seqNumber = options.seqNumber || 0;
        this._allowedLargeValue = {
            msg: 1024 * 5,
            err: 1024 * 5,
            sid: 64,
            udid: 64
        };

        this._sendToRemote = true;
        this._globalKey = '__NgPipeStorage';
        var self = this;
        var cb = function(error,value, key) {
            var new_queue = [];
            if (!error) {
                try {
                    new_queue = JSON.parse(value);
                } catch(e) {
                    new_queue = [];
                }
            }

            if (self._queue) {
                new_queue = self._queue.concat(new_queue);
            }

            self._setQueue(new_queue);
            if (self._queue.length > 0 ){
                self._drainQueue();
            }
        };
        this._locListener = null;
        this._location = null;
        Storage.KeyValueCache.global(this._globalKey).getItem(this._globalKey, cb);
        var starting_queue = [].concat(options.queue || []);
        this._queue = starting_queue;
        this._sessionEnded = false;
        this._capAlphaNumStringKeys = ['afam', 'asku', 'srcty', 'evcl', 'evid', 'pltfmsku','carr','srv'];
        this.sessionStartEvent();
        this._tagQa();
        this._hookLifetime();
        this._hookGeo();
        return true;
    },

    close: function() {
        this._drainQueue();
        return true;
    },

    enable: function() {
        this._sendToRemote = true;
    },

    disable: function() {
        this._sendToRemote = false;
    },

    setRemoteUrl: function(url) {
        NgPipesRemote.setUrl(url);
    },

    playerEvent: function(eventId, evcl, change, playerState) {
        var e;
        evcl || (evcl = "PLST");
        e = {
            change: change,
            srcty: 'GC',
            evid: eventId,
            evcl: evcl,
            plst: this._getPlayerStateDiff(playerState || this._playerState)
        };
        this._queueMessage(e);
        this._setCurrentPlayerState(playerState);
        return e;
    },
    gameEvent: function(eventId, payload, playerState) {
        var e;
        e = {
            evid: eventId,
            evpl: payload,
            srcty: 'GC',
            evcl: 'GAME'
        };

        if (playerState) {
          e.plst = this._getPlayerStateDiff(playerState || this._playerState);
        }
        this._queueMessage(e);
        return e;
    },
    gameOpsEvent: function(eventId, payload) {
        var e;
        e = {
            evid: eventId,
            evpl: payload,
            srcty: 'GC',
            evcl: 'GAMEOPS'
        };
        this._queueMessage(e);
        return e;
    },
    revenueEvent: function(eventId, payload) {
        var e;
        e = {
            evcl: 'REV',
            evid: eventId,
            srcty: 'PC',
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },
    uiEvent: function(eventId, payload) {
        var e;
        e = {
            evcl: 'UI',
            srcty: 'GC',
            evid: eventId,
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },
    funnelEvent: function(eventId, payload, playerState) {
        var e;
        e = {
            evcl: 'FUNNEL',
            srcty: 'GC',
            evid: eventId,
            evpl: payload
        };

        if (playerState) {
          e.plst = this._getPlayerStateDiff(playerState || this._playerState);
          this._setCurrentPlayerState(playerState);
        }
        this._queueMessage(e);
        return e;
    },
    plusEvent: function(eventId, payload) {
        var e;
        e = {
            evcl: 'PLUS',
            srcty: 'PC',
            evid: eventId,
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },
    plusUIEvent: function(eventId, payload) {
        var e = {
            evcl: 'PLUSUI',
            srcty: 'PC',
            evid: eventId,
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },
    navigationEvent: function(fromScreen, toScreen, buttonID){
        var payload = {};
        payload.fro = fromScreen;
        payload.to  = toScreen;
        if(buttonID){
            payload.btnid = buttonID;
        }

        return this.plusUIEvent("NAV", payload);
    },
    sessionEndEvent: function() {
        if (!(this._sessionEnded)) {
            var e;
            var Capabilities = CapabilitiesReq.Capabilities;

            e = {
                evid:  'SFN',
                evcl:  'PLUS',
                srcty: 'PC',
                hwty:  Capabilities.getDeviceName(), // cat ro.product.manufacturer, ro.product.brandh, ro.product.model
                hwrev: Capabilities.getPlatformHW(), // cat ro.revision + ro.build.date.utc
                osrev: ""+  Capabilities.getPlatformOS() + " " + Capabilities.getPlatformOSVersion(), // ro.build.fingerprint
                lang: Capabilities.getLanguage()
            };

            e = this._queueMessage(e);
            this._sessionEnded = true;
            return e;
        }
        return null;
    },
    sessionStartEvent: function() {
        var e;
        var Capabilities = CapabilitiesReq.Capabilities;

        e = {
            evid:  'SST',
            evcl:  'PLUS',
            srcty: 'PC',
            hwty:  Capabilities.getDeviceName(), // cat ro.product.manufacturer, ro.product.brandh, ro.product.model
            hwrev: Capabilities.getPlatformHW(), // cat ro.revision + ro.build.date.utc
            osrev: ""+  Capabilities.getPlatformOS() + " " + Capabilities.getPlatformOSVersion(), // ro.build.fingerprint
            lang: Capabilities.getLanguage()
        };



        e = this._queueMessage(e);
        return e;
    },
    socialEvent: function(eventId, friendId,  payload) {
        var e;
        e = {
            evcl: 'SOCL',
            srcty: 'GC',
            frid: friendId,
            evid: eventId,
            evpl: payload
        };
        return this._queueMessage(e);
    },
    initPlayerState: function(inState) {
        this._setCurrentPlayerState(inState);
        return true;
    },

    updatePlayerState: function(newState) {
        this._setCurrentPlayerState(newState);
        return true;
    },

    //params for internal IAP events:

    //promo campaign unique identifier
    //promoid (String)

    //price of virtual good
    //price (Float)

    //currency used. Defaults to USD
    //cur (String)

    //user's moba balance after purchase
    //mobabalance (Integer)

    //unique identifier for purchase
    //orderid (String)

    //a string identifier for an item, e.g. "IceCastle"
    //sku (String)

    //the value of the item in moba
    //mobaprice (Float)

    //the quantity of item being purchased
    //itemamt (Float)

    //a text description of the item.
    //desc (String)

    //a message displayed to the user when the debit or credit occurs
    //dispmsg (String)

    //the name of the item, as displayed to the user
    //dispname (String)

    //the Mobage ID for the product.
    //productid (Integer)

    //dynamic data accepts a custom object with any params not included above
    //dynamicdata (Object)

    reportAdShow : function(adid) {
        return this.revenueEvent('ADSHOW',{'adid':adid});      
    },

    reportAdClick : function(adid) {
        return this.revenueEvent('ADCLCK',{'adid':adid});    
    },

    reportPromoShow : function(promoid) {
        return this.revenueEvent('PROMOSHOW',{'promoid':promoid});    
    },

    reportPromoClick : function(promoid) {
        return this.revenueEvent('PROMOCLCK',{'promoid':promoid});    
    },

    reportPromoRedeem : function(promoid) {
        return this.revenueEvent('PROMOREDM',{'promoid':promoid});    
    },

    //user clicks on money sku
    reportMoneyIAPIntent : function(sku,item_amt,price,product_id,display_name,user_end_moba_balance,description,display_message,cur,dynamicdata) {
        var evpl = {
            sku : sku,
            itemamt : item_amt,
            productid: product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance,
            amt : price,
            cur : cur || 'USD'
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('IAPINTENT', evpl);
    },

    //user cancels a money sku transaction
    reportMoneyIAPCancel : function(sku,item_amt,price,product_id,display_name,user_end_moba_balance,description,display_message,cur,dynamicdata) {
        var evpl = {
            sku : sku,
            itemamt : item_amt,
            productid: product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance,
            amt : price,
            cur : cur || 'USD'
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('IAPCANCEL', evpl);
    },

    //money sku transaction is successful; orderid required
    reportMoneyIAPSuccess : function(sku,item_amt,price,orderid,product_id,display_name,user_end_moba_balance,description,display_message,cur,dynamicdata) {
        var evpl = {
            sku : sku,
            itemamt : item_amt,
            orderid : orderid,
            productid: product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance,
            amt : price,
            cur : cur || 'USD'
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('IAPSUCCESS',evpl);
    },

    //money iap purchase fails after being authorized by user; orderid optional if available, pass in null otherwise
    reportMoneyIAPFail : function(sku,item_amt,price,orderid,product_id,display_name,user_end_moba_balance,description,display_message,cur,dynamicdata) {
        var evpl = {
            sku : sku,
            itemamt : item_amt,
            productid: product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance,
            amt : price,
            cur : cur || 'USD'
            };
        orderid ? evpl.orderid = orderid : "";
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('IAPFAIL', evpl);
    },

    //user opens money IAP store
    reportMoneyIAPShow : function() {
        return this.revenueEvent('IAPSHOW',{});
    },

    //user opens moba IAP store
    reportMobaIAPShow : function() {
        return this.revenueEvent('MOBAIAPSHOW',{});
    },

    //user clicks on a moba sku
    reportMobaIAPIntent : function(sku,moba_price,product_id,display_name,user_end_moba_balance,description,display_message,dynamicdata) {
        var evpl = {
            sku : sku,
            mobaprice : moba_price,
            productid : product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('MOBAIAPINTENT', evpl);
    },

    //user cancels moba sku transaction
    reportMobaIAPCancel : function(sku,moba_price,product_id,display_name,user_end_moba_balance,description,display_message,dynamicdata) {
        var evpl = {
            sku : sku,
            mobaprice : moba_price,
            productid : product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('MOBAIAPCANCEL', evpl);
    },

    //moba sku transaction is successful. orderid required. 
    reportMobaIAPSuccess : function(sku,moba_price,orderid,product_id,display_name,user_end_moba_balance,description,display_message,dynamicdata) {
        var evpl = {
            sku : sku,
            mobaprice : moba_price,
            orderid : orderid,
            productid : product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('MOBAIAPSUCCESS', evpl);
    },

    //moba sku purchase fails after being authorized by user. orderid optional if available, pass in null otherwise
    reportMobaIAPFail : function(sku,moba_price,orderid,product_id,display_name,user_end_moba_balance,description,display_message,dynamicdata) {
        var evpl = {
            sku : sku,
            mobaprice : moba_price,
            productid : product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance
            };
        orderid ? evpl.orderid = orderid : '';
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('MOBAIAPFAIL', evpl);
    },

    /**
    * Report us scraping a facebook user's profile - ext_id is the user's facebook ID.
    *
    */
    reportFacebookScrape : function(ext_id, dynamicdata) {
        var e;
        var evpl={};
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        e = {
            evcl: 'PLUS',
            srcty: 'PC',
            extid: ext_id,
            evid: 'FBSCRAPE',
            evpl: evpl
        };
        this._queueMessage(e);
        return e;
    },

    /**
    * Report us scraping a user's contact list - ext_id is the user's facebook ID.
    *
    */
    reportContactScrape : function(dynamicdata) {
        var e;
        var evpl={};
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        e = {
            evcl: 'PLUS',
            srcty: 'PC',
            evid: 'CONTACTSCRAPE',
            evpl: evpl
        };
        this._queueMessage(e);
        return e;
    },

    /**
    * Report a user posting to another user's wall.
    *
    */
    reportWallPost : function(friendId, payload) {
        var e;
        e = {
            evcl: 'SOCL',
            srcty: 'PC',
            frid: friendId,
            evid: 'WALLPOST',
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },

    /**
    * Report a user downloading a game from a specific section in the store.
    * @param {String} game is the asku for the game being downloaded.
    * @param {String} section is the name of the section that the user downloaded from:
    *   AllGames, FeaturedGames, MyProfile, FriendsLastPlayedGame, FriendsPlayingGame
    * @param {String} slot is the order of the game in the section (if applicable)
    */
    reportDownload : function(game, section, slot) {
        var payload = {};
        payload.game = game;
        payload.section = section;
        payload.slot = slot;
        var e;
        e = {
            evcl: 'PLUS',
            srcty: 'PC',
            evid: 'DOWNLOAD',
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },

    /**
    * add internal tag to a user.
    */
    addTag : function(tagName) {
        var payload = {};
        payload.tag = tagName;
        var e;
        e = {
            evcl: 'PLUS',
            evid: 'TAG', 
            srcty: 'PC',
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },

    getSeqNumber: function() {
        this._seqNumber += 1;
        return this._seqNumber;
    },

    getQueueCount: function() {
        return this._queue.length;
    },

    getSendDelay: function() {
        return this._sendDelay;
    },

    setSendDelay: function(val) {
        return (this._sendDelay = val);
    },

    setMeta: function(key, value) {
        if (!value) {
            value = key;
            return (this._meta = value);
        } else {
            return (this._meta[key] = value);
        }
    },

    getMeta: function(key) {
        if (key) {
            return this._meta[key];
        } else {
            return this._meta;
        }
    },

    _queueMessage: function(msg) {
        if (!msg) {
            return false;
        }

        var self = this;

        //This sets metas that don't change often
        this._setUnsetMetaKeys();

        // The rest of these function set properties that 
        msg = this._mergeMeta(msg);
        msg = this._addSeqDetails(msg);
        msg = this._addGeo(msg);
        msg = this._addEvts(msg);
        msg = this._addGameSku(msg);
        msg = this._addGameRel(msg);
        msg = this._addCarrier(msg);
        msg = this._addService(msg);
        msg = this._addPlatformVersion(msg);
        msg = this._addUserId(msg);
        msg = this._addUserName(msg);
        msg = this._normalizeValues(msg);
        var queue = this._getQueue();
        queue.push(msg);
        this._setQueue(queue);

        if (!this._isSendQueued) {
            setTimeout(function() {
                self._isSendQueued = false;
                return self._drainQueue();
            }, self._sendDelay);
        }
        return msg;
    },
    _tagQa: function() {
        var fs = require('NGCore/Client/Storage/FileSystem').FileSystem;
        var self = this;
        fs.readFile('QA',function(err,data) {
            if (!err) {
                self.addTag("NGMOCOQA");
            }
        });
    },
    _hookGeo: function() {
        var Social = require('NGCore/Client/Social').Social;
        if(Social.US){
            var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
            var Device = require('NGCore/Client/Device').Device, self = this;
            var LocationListener = MessageListener.subclass({
                initialize: function() {
                    Device.LocationEmitter.addListener(this, this.onUpdate, false);
                },
                onUpdate: function(location) {
                    self._location = location;
                    Device.LocationEmitter.removeListener(this);
                    self._locListener = null;
                }
            });
            this._locListener = new LocationListener();
        }
    },
    _hookLifetime: function() {
        var self = this;
        var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
        var Device = require('NGCore/Client/Device').Device;
        var ListenerClass =  MessageListener.subclass({
            initialize: function() {
                Device.LifecycleEmitter.addListener(this, this.onLifecycleUpdate);
            },
            onLifecycleUpdate: function(event) {
                switch (event) {
                case Device.LifecycleEmitter.Event.Suspend:
                case Device.LifecycleEmitter.Event.Terminate:
                    self.sessionEndEvent();
					self._drainQueue();
                    break;
                case Device.LifecycleEmitter.Event.Resume:
                default:
                    self.initialize();
                    break;
                }
            }
        });
        if (!this._listener) {
            this._listener = new ListenerClass();
        }
    },
    /**
    * Game Service running inside privileged interpreter may use this method
    * to change the Social Analytic object to be used.  Please see MOBWEST-2300
	* for details
	*
    * @private
    */
	_setSocialAnalytics: function(obj) {
		this._socAnalytics = obj;
	},
    _setUnsetMetaKeys: function() {
        var Capabilities = CapabilitiesReq.Capabilities, udid;
        if ((!this.getMeta('udid')) && (udid = Capabilities.getUniqueId() )) {
            this.setMeta('udid', udid);
        }

        if (!this.getMeta('sid')) {
            var sid = ''+ hex_sha1(this._seqStart+ (this.getMeta('udid')|| "UNKNOWN"));
            this.setMeta('sid', sid);
        }

        if (!this.getMeta('pltfmsku')) {
            var platRegex = /android/;

            var plat = Capabilities.getPlatformOS();
            if (plat) {
                plat = plat.toLowerCase();
                if (plat.match(platRegex) ) {
                    plat = "android";
                } else if ("flash" === plat ) {
                    plat = "flash";
                } else {
                    plat = "ios";
                }
                this.setMeta( 'pltfmsku', plat);
            }
        }

        if (!this.getMeta('apiver')) {
            this.setMeta('apiver', 5);
        }
        return true;
    },

    _getPlayerStateDiff: function(newState) {
        var delta_sign, delta_value, diff, key, value;
        diff = {};
        if (!this._playerState) {
            this._setCurrentPlayerState(newState);
        }
        for (key in newState) {
            if (!__hasProp.call(newState, key)) continue;
            value = newState[key];
            if (typeof value === 'number') {
                delta_value = (value - this._playerState[key]) || 0;
                if (delta_value < 0) {
                    delta_sign = '-';
                }
                if (delta_value >= 0) {
                    delta_sign = '+';
                }
                diff[key] = "" + delta_sign + "," + Math.abs(delta_value) + "," + (this._playerState[key]);
            } else if (typeof value === 'string') {
                diff[key] = value;
            }
        }
        return diff;
    },

    _setCurrentPlayerState: function(pst) {
        var key, value;
        this._playerState = {};
        for (key in pst) {
            if (!__hasProp.call(pst, key)) continue;
            value = pst[key];
            this._playerState[key] = value;
        }
        return true;
    },

    _addEvts: function(msg) {
      var d = new Date(); 
      msg.evts =  d.getTime();
      return msg;
    },
    _addGeo: function(msg) {
        var loc_point;

        if (this._location && (loc_point = this._location.getPosition())  && !isNaN(loc_point.getX()) && !isNaN(loc_point.getY())) {
            msg.geo = "" + loc_point.getX() + "," + loc_point.getY();
        }
        return msg;
    },
    _addCarrier: function(msg) {
        var Capabilities = CapabilitiesReq.Capabilities;
        var carr = Capabilities.getCarrier();
        if (carr) {
            msg.carr = carr;
        }
        return msg;
    },
    _addService: function(msg) {
        var Analytics = this._socAnalytics;
        msg.srvc = Analytics.getServiceId();
        return msg;
    },
    _addPlatformVersion: function(msg) {
        var Analytics = this._socAnalytics;
        msg.pver = Analytics.getPlatformVersion();
        return msg;

    },
    _addSeqDetails: function(msg) {
        this._seqNum += 1;
        msg.seq = this.getSeqNumber();
        msg.seqdt = new Date().getTime() - this._seqStart;
        return msg;
    },
    _addUserId: function(msg) {
      var Analytics = this._socAnalytics;
      var uid = Analytics.getUserId();
      if (uid) {
        msg.uid = uid;
      }
      return msg;
    },
    _addUserName: function(msg) {
      var Analytics = this._socAnalytics;
      var un = Analytics.getUsername();
      if (un) {
        msg.plus = un;
      }
      return msg;
    },
    _addGameSku: function(msg) {
        var app_key = (Capabilities.getConfigs() || {} )["appId"];
        if ( app_key ) {
            msg.asku = app_key;
        }
        return msg;
    },
    _addGameRel: function(msg) {
        var arel = Capabilities.getAppReleaseVersion();
        if (arel) {
          msg.arel = arel;
        }
        return msg;
    },
    _normalizeValues: function(msg) {
        var key, value;
        for (key in msg) {
            if (!__hasProp.call(msg, key)) continue;
            value = msg[key];
            if (typeof value === 'string') {
                value = this._normalizeString(key, value);
            } else if (typeof value === 'object') {
                value = this._normalizeValues(value);
            }
            msg[key] = value;
        }
        return msg;
    },

    _normalizeString: function(key, value) {
        value = value.substring(0, this._allowedLargeValue[key] || 32);
        if (-1 !== this._capAlphaNumStringKeys.indexOf(key)) {
            value = value.toUpperCase().replace(/[^\w]+/g, "").replace("_", "");
        }
        return value;
    },

    _mergeMeta: function(msg) {
        var _ref, _ref2, key, new_msg, value;
        new_msg = {};
        for (key in msg) {
            if (!__hasProp.call(msg, key)) continue;
            value = msg[key];
            new_msg[key] = value;
        }
        for (key in _ref = this._meta) {
            if (!__hasProp.call(_ref, key)) continue;
            value = _ref[key];
            (_ref2 = new_msg[key]) ? _ref2 : new_msg[key] = value;
        }
        return new_msg;
    },

    _drainQueue: function() {
        var cb, self, toDrain;
        toDrain = this._getQueue();
        this._setQueue([]);
        self = this;

        if (! this._sendToRemote)
            return true;

        cb = function(state, not_sent) {
            if (state === NgPipesRemote.possibleStates.error) {
                self._queueMany(not_sent);
                self._sendDelay = self._sendDelay * 2;
            } else if (state === NgPipesRemote.possibleStates.finished ) {
                self._sendDelay = 5000;
            }
            return true;
        };
        NgPipesRemote.clearQueue(toDrain, cb);
        toDrain = null; // explicit clear to keep memory down
        return true;
    },

    _queueMany: function(msg_arr) {
        var _i, _len, msg, self = this;
        this._setQueue( (this._getQueue() || [] ).concat(msg_arr) );
        if (this._isSendQueued) {
          this._isSendQueued = true;
          setTimeout(function() {
              self._isSendQueued = false;
              return self._drainQueue();
          }, self._sendDelay);
        }

        return true;
    },
    _setQueue: function(new_queue) {
        this._queue = new_queue;
        Storage.KeyValueCache.global(this._globalKey).setItem(this._globalKey, JSON.stringify(this._queue));
        return true;
    },
    _getQueue: function() {
        return this._queue;

    }
});

exports.NgPipe = NgPipe;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/NgPipesRemote'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/NgPipesRemote'] || {}; $MODULE_REGISTRY['NGCore/Shared/NgPipesRemote'] = exports; var Network = require('NGCore/Client/Network').Network;

NgPipesRemote = {
  listeners: [],
  debug: false,

  possibleStates: {
    unknown: {},
    finished: {},
    error: {}
  }
};

NgPipesRemote.addListener = function(listner) {
  this.listeners.push(listner);
  return true;
};

NgPipesRemote.clearQueue = function(queue, callback) {

  if (!queue) {
    return false;
  }

  if (!this.getUrl()) {
    if (callback) {
      callback(NgPipesRemote.possibleStates.finished, []);
    }
    return false;
  }
	var copy_array = queue.slice(0, queue.length);

	var _j, _len2, data;
  while (copy_array && copy_array.length > 0) {
    var to_send = copy_array.slice(0, 10);
    copy_array = copy_array.slice(10);
    data = "";

    for (_j = 0, _len2 = to_send.length; _j < _len2; _j++) {
      data += JSON.stringify(to_send[_j]);
      if (_j+1 < _len2) {
         data += "\r\n";
      } //if len
    } //for

    if (data) {
      NgPipesRemote._makeRequest(data, to_send, callback);
    } //if data
  }//while

};

NgPipesRemote._makeRequest = function(json_data, objs, callback) {
  var request = new Network.XHR(), url = this.getUrl();
  if (this.debug) {
    NgPipesRemote._debugOutput(json_data);
  }

	var LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;
	LifecycleEmitter.requestEngineKeepAlive(objs);
  request.onreadystatechange = function() {
    var status = null;
    try {
      if (this.readyState === 4) {
		LifecycleEmitter.cancelEngineKeepAlive(objs);
        status = NgPipesRemote._handleResponse(request.responseText);
      } else {
        status = NgPipesRemote.possibleStates.unknown;
      }
    } catch (ex) {
      status = NgPipesRemote.possibleStates.error;
      NgLogException(ex);
    }

    if (callback) {
      callback(status, objs);
    }

    NgPipesRemote._notifyListeners(status);
    return true;
  };

  request.open("POST", url, true);

  request.setRequestHeader("X-Ngpipes-Api", "1.0");
  request.setRequestHeader("Content-Type", "application/json+batch");
  request.setRequestHeader("If-None-Match", "0");

  request.send(json_data);

  NgPipesRemote._notifyListeners('started');
  return true;
};
NgPipesRemote.setUrl = function(url) {
    this.url = url;
};
NgPipesRemote.getUrl = function() {
    if (this.url)
        return this.url;
    var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
    var url = null;
    
    if (Capabilities) {
      //Get the url from the configuration.json
      url = (Capabilities.getConfigs() || {} )["analyticsServer"] || null;
      if (url) {
        url = "https://"+url+"/pipes/r.2/bulk_record_stats";
        if (this.debug) {
          NgLogD("Pipes URL => " + url );
        }
      }
    }
    return url;
};


NgPipesRemote._handleResponse = function(respText) {
  var respObj, result;
  result = NgPipesRemote.possibleStates.unknown;
  if (respText && respText.length > 0) {
    try {
    respObj = JSON.parse(respText);
    } catch (e) {
      //Clean up after ourselves.
      respObj = null;
    }
	if (respObj  && (respObj.success !== null && respObj.success !== undefined ) && respObj.success) {
      if (this.debug) {
        NgLogD("[NgPipesRemote] Got Success" );
      }
      result = NgPipesRemote.possibleStates.finished;
    } else {
      result = NgPipesRemote.possibleStates.error;
    }
  } else {
      if (this.debug) {
        NgLogD('[NgPipesRemote] ERROR posting');
      }

    result = NgPipesRemote.possibleStates.error;
  }
  return result;
};

NgPipesRemote._debugOutput = function(str) {
  var _i, _len, _result, msg, msgs;
  msgs = str.split("\r\n");
  for (_i = 0, _len = msgs.length; _i < _len; _i++) {
    msg = msgs[_i];
    NgLogD("[NgPipesRemote] Message sent: " + msg);
  }
  return false;
};

NgPipesRemote._notifyListeners = function(state) {
  var _i, _len, _ref, l;
  for (_i = 0, _len = (_ref = this.listeners).length; _i < _len; _i++) {
    l = _ref[_i];
    l(state);
  }
  return true;
};

exports.NgPipesRemote = NgPipesRemote;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Lib/sha1'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Lib/sha1'] || {}; $MODULE_REGISTRY['NGCore/Shared/Lib/sha1'] = exports; /*
 * @description
 * A JavaScript implementation of the Secure Hash Algorithm, SHA-1, as defined
 * in FIPS PUB 180-1
 * Version 2.1a Copyright Paul Johnston 2000 - 2002.
 * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
 * Distributed under the BSD License
 * See http://pajhome.org.uk/crypt/md5 for details.
 * @namespace
 * @name sha1
 */

/*
 * Configurable variables. You may need to tweak these to be compatible with
 * the server-side, but the defaults work in most cases.
 */
var hexcase = 0;  /* hex output format. 0 - lowercase; 1 - uppercase        */
var b64pad  = ""; /* base-64 pad character. "=" for strict RFC compliance   */
var chrsz   = 8;  /* bits per input character. 8 - ASCII; 16 - Unicode      */

/*
 * Add integers, wrapping at 2^32. This uses 16-bit operations internally
 * to work around bugs in some JS interpreters.
 */
function safe_add(x, y)
{
  var lsw = (x & 0xFFFF) + (y & 0xFFFF);
  var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
  return (msw << 16) | (lsw & 0xFFFF);
}

/*
 * Bitwise rotate a 32-bit number to the left.
 */
function rol(num, cnt)
{
  return (num << cnt) | (num >>> (32 - cnt));
}

/*
 * Perform the appropriate triplet combination function for the current
 * iteration
 */
function sha1_ft(t, b, c, d)
{
  if(t < 20) { return (b & c) | ((~b) & d); }
  if(t < 40) { return b ^ c ^ d; }
  if(t < 60) { return (b & c) | (b & d) | (c & d); }
  return b ^ c ^ d;
}

/*
 * Determine the appropriate additive constant for the current iteration
 */
function sha1_kt(t)
{
  return (t < 20) ?  1518500249 : (t < 40) ?  1859775393 :
         (t < 60) ? -1894007588 : -899497514;
}

/*
 * Calculate the SHA-1 of an array of big-endian words, and a bit length
 */
function core_sha1(x, len)
{
  /* append padding */
  x[len >> 5] |= 0x80 << (24 - len % 32);
  x[((len + 64 >> 9) << 4) + 15] = len;

  var w = Array(80);
  var a =  1732584193;
  var b = -271733879;
  var c = -1732584194;
  var d =  271733878;
  var e = -1009589776;

  for(var i = 0; i < x.length; i += 16)
  {
    var olda = a;
    var oldb = b;
    var oldc = c;
    var oldd = d;
    var olde = e;

    for(var j = 0; j < 80; j++)
    {
      if(j < 16) { w[j] = x[i + j]; }
      else {
		w[j] = rol(w[j-3] ^ w[j-8] ^ w[j-14] ^ w[j-16], 1);
	  }
      var t = safe_add(safe_add(rol(a, 5), sha1_ft(j, b, c, d)),
                       safe_add(safe_add(e, w[j]), sha1_kt(j)));
      e = d;
      d = c;
      c = rol(b, 30);
      b = a;
      a = t;
    }

    a = safe_add(a, olda);
    b = safe_add(b, oldb);
    c = safe_add(c, oldc);
    d = safe_add(d, oldd);
    e = safe_add(e, olde);
  }
  return Array(a, b, c, d, e);

}

/*
 * Convert an 8-bit or 16-bit string to an array of big-endian words
 * In 8-bit function, characters >255 have their hi-byte silently ignored.
 */
function str2binb(str)
{
  var bin = Array();
  var mask = (1 << chrsz) - 1;
  for(var i = 0; i < str.length * chrsz; i += chrsz) {
    bin[i>>5] |= (str.charCodeAt(i / chrsz) & mask) << (32 - chrsz - i%32);
  }
  return bin;
}

/**
 * @description
 * Call the <code>core_hmac_sha1()</code> function to calculate the HMAC-SHA1 of a key and some data.
 * A JavaScript implementation of the Secure Hash Algorithm, SHA-1, as defined
 * in FIPS PUB 180-1
 * Version 2.1a Copyright Paul Johnston 2000 - 2002.
 * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
 * Distributed under the BSD License
 * See <a href="http://pajhome.org.uk/crypt/md5">this</a> or <a href="http://www.itl.nist.gov/fipspubs/fip180-1.htm">NIST</a> for details.
 * @namespace
 * @name core_hmac_sha1
 * @function
 * @param key The key to use with sha1.
 * @param data The data to hash.
 * @return A sha1 hash of the data and key.
 * @example
 * var key = "12345"
 * var data = "The data I would like to hash."
 * core_hmac_sha1(key, data);
 */
function core_hmac_sha1(key, data)
{
  var bkey = str2binb(key);
  if(bkey.length > 16) {
	bkey = core_sha1(bkey, key.length * chrsz);
  }

  var ipad = Array(16), opad = Array(16);
  for(var i = 0; i < 16; i++)
  {
    ipad[i] = bkey[i] ^ 0x36363636;
    opad[i] = bkey[i] ^ 0x5C5C5C5C;
  }

  var hash = core_sha1(ipad.concat(str2binb(data)), 512 + data.length * chrsz);
  return core_sha1(opad.concat(hash), 512 + 160);
}

/*
 * Convert an array of big-endian words to a string
 */
function binb2str(bin)
{
  var str = "";
  var mask = (1 << chrsz) - 1;
  for(var i = 0; i < bin.length * 32; i += chrsz) {
    str += String.fromCharCode((bin[i>>5] >>> (32 - chrsz - i%32)) & mask);
  }
  return str;
}

/*
 * Convert an array of big-endian words to a hex string.
 */
function binb2hex(binarray)
{
  var hex_tab = hexcase ? "0123456789ABCDEF" : "0123456789abcdef";
  var str = "";
  for(var i = 0; i < binarray.length * 4; i++)
  {
    str += hex_tab.charAt((binarray[i>>2] >> ((3 - i%4)*8+4)) & 0xF) +
           hex_tab.charAt((binarray[i>>2] >> ((3 - i%4)*8  )) & 0xF);
  }
  return str;
}

/*
 * Convert an array of big-endian words to a base-64 string
 */
function binb2b64(binarray)
{
  var tab = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
  var str = "";
  for(var i = 0; i < binarray.length * 4; i += 3)
  {
    var triplet = (((binarray[i   >> 2] >> 8 * (3 -  i   %4)) & 0xFF) << 16) |
                  (((binarray[i+1 >> 2] >> 8 * (3 - (i+1)%4)) & 0xFF) << 8 ) |
                   ((binarray[i+2 >> 2] >> 8 * (3 - (i+2)%4)) & 0xFF);
    for(var j = 0; j < 4; j++)
    {
      if(i * 8 + j * 6 > binarray.length * 32){
		str += b64pad;
	  } else {
		str += tab.charAt((triplet >> 6*(3-j)) & 0x3F);
	  }
    }
  }
  return str;
}

/*
 * These are the functions you'll usually want to call
 * They take string arguments and return either hex or base-64 encoded strings
 */
function hex_sha1(s){return binb2hex(core_sha1(str2binb(s),s.length * chrsz));}
function b64_sha1(s){return binb2b64(core_sha1(str2binb(s),s.length * chrsz));}
function str_sha1(s){return binb2str(core_sha1(str2binb(s),s.length * chrsz));}
function str_hmac_sha1(key, data){ return binb2str(core_hmac_sha1(key, data));}
function hex_hmac_sha1(key, data){ return binb2hex(core_hmac_sha1(key, data));}
function b64_hmac_sha1(key, data, padChar){
	if ((typeof padChar != "undefined") && padChar) {
        b64pad = padChar;
	}
	return binb2b64(core_hmac_sha1(key, data));
}

/*
 * Perform a simple self-test to see if the VM is working
 */
function sha1_vm_test()
{
  return hex_sha1("abc") == "a9993e364706816aba3e25717850c26c9cd0d89d";
}

// Exports for node.js
if((typeof exports != "undefined") && exports)
{
	exports.b64_hmac_sha1 = b64_hmac_sha1;
	exports.hex_sha1 = hex_sha1;
	exports.b64_sha1 = b64_sha1;
}
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social'] || {}; $MODULE_REGISTRY['NGCore/Client/Social'] = exports; /**
 * Public API for GameService
 * 
 * Access this file as NGCore/Client/Social.js
 */

// Note the proper require path for our public interface files is: "./Social/US/[filename]"

/** @namespace
 * @name Social
 * @description
 * The <code>Social</code> namespace provides interfaces for the Mobage Social APIs.
 */
exports.Social = {
};

/** @namespace
 * @name Social.Common
 * @description
 * The <code>Social.Common</code> namespace provides interfaces for functionality common to submodules for Japan (JP), the United States (US), 
 * and future submodules. The common features include Auth, People, Appdata, Blacklist, Profanity and Service. Service APIs can be both common
 * or native, and include the Community button, the Balance button, the Friend Picker, the User Finder, and the User Profile.
 */
exports.Social.Common = {
	Appdata: require('NGCore/Client/Social/US/Common/Appdata').Appdata,
	Auth: require('NGCore/Client/Social/US/Common/Auth').Auth,
	Blacklist: require('NGCore/Client/Social/US/Common/Blacklist').Blacklist,
	Config: require('NGCore/Client/Social/US/Common/Config').Config,
	People: require('NGCore/Client/Social/US/Common/People').People,
	Profanity: require('NGCore/Client/Social/US/Common/Profanity').Profanity,
	Request: require('NGCore/Client/Social/US/Common/Request').Request,
	Service: require('NGCore/Client/Social/US/Common/Service').Service,
  Analytics: require('NGCore/Client/Social/US/Common/Analytics').Analytics
};

/** @namespace
 * @name Social.US
 * @description
 * The <code>Social.US</code> namespace provides interfaces for the United States (US) submodule. 
 * The features include User, Game, Leaderboard, Score, Ordered List, and AppData.
 */
exports.Social.US = {
	// Data Models
	DataModel: require('NGCore/Client/Social/US/Models/DataModel').DataModel,
	User: require('NGCore/Client/Social/US/Models/User').User,
	Game: require('NGCore/Client/Social/US/Models/Game').Game,
	Leaderboard: require('NGCore/Client/Social/US/Models/Leaderboard').Leaderboard,
	Score: require('NGCore/Client/Social/US/Models/Score').Score,
	
	AppData: require('NGCore/Client/Social/US/Models/AppData').AppData,
	
	// Data Cache
	Cache: require('NGCore/Client/Social/US/Models/Cache').Cache,

	// Data APIs
	Session: require('NGCore/Client/Social/US/Data/Session').Session,
	Dispatcher: require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher
};

/** @namespace
 * @name Social.US.Service
 * @description
 * Service APIs include the Community button, the Balance button, the Friend Picker, the User Finder, and the User Profile.
 */
exports.Social.US.Service = {
	Friends: require('NGCore/Client/Social/US/Service/Friends').Friends,
	Profile: require('NGCore/Client/Social/US/Service/Profile').Profile,
	ButtonOverlays: require('NGCore/Client/Social/US/Service/ButtonOverlays').ButtonOverlays,
	GameLaunchPayload: require('NGCore/Client/Social/US/Service/GameLaunchPayload').GameLaunchPayload
};

/** @namespace
 * @name Bank
 * @description
 * The <code>Bank</code> namespace provides interfaces for the Mobage Bank APIs.
 */
exports.Bank = require('NGCore/Client/Social/US/Service/Bank').Bank;; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Storage/FileSystem'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Storage/FileSystem'] || {}; $MODULE_REGISTRY['NGCore/Client/Storage/FileSystem'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class FileSystem
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Class = require('NGCore/Client/Core/Class').Class;

////////////////////////////////////////////////////////////////////////////////

exports.FileSystem = Class.singleton(
/** @lends Storage.FileSystem.prototype */
{
	classname: 'FileSystem',
	
	/**
	 * @class The <code>FileSystem</code> class constructs a singleton object that controls file manipulation tasks: reading, writing, deleting, or decompressing a file.
	 * 
	 * @constructs The default constructor.
	 * @augments Core.Class
	 */
	initialize: function()
	{
		/** @private */
		this.readRequests = {};
		/** @private */
		this.writeRequests = {};
		/** @private */
		this.cbIdCounter = 1;
		
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},

	/**
	 * Read a file into memory from local storage.
	 * @example FileSys.readFile(SomeFile, true, function(err, data){...}
	 * @param {String} fname The name of the file to read into memory.
	 * @param {Boolean} [binary=false] Set as <code>true</code> if <code>readFile()</code> shouuld conduct a binary read.
	 * @param {Function} [cb] Specifies a callback function that returns an error if the file read operation fails.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	readFile: function( fname, binary, cb )
	{
		this.readFileIn(this.Store.Local, fname, binary, cb);
	},

	/**
	 * @private
	 *	read a file from a common store on the filesystem
	 *	NOTE: This is not a secure location and games should not rely on this for critical data
	 *	@param {store} The shared location to read from
	 *	@param {fname} The name of the file to be read
	 *	@param {cb} The callback function to be called
	 *	@param {binary} binary mode or not
     *  @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	readFileIn: function( store, fname, binary, cb )
	{
		var cbId = 0;

		if(typeof(binary) == 'function')
		{
			cb = binary;
			binary = false;
		}
		binary = binary || false;

		if ( cb )
		{
			cbId = this.cbIdCounter++;
			this.readRequests[ cbId ] = cb;
		}
		this._readFileSendGen(cbId,store,fname,binary);
	},

	/**
	 * Write a file to local storage.
	 * @example FileSys.writeFile(SomeFile, someData, true, (function(){...});
	 * @param {String} fname The name of the file to write into storage.
	 * @param {Binary, String} data The data to write to the file.
	 * @param {Boolean} [binary=false] Set as <code>true</code> if <code>writeFile()</code> should conduct a binary write.
	 * @param {Function} [cb] Specifies a callback function that returns an error if the file write operation fails.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	writeFile: function( fname, data, binary, cb )
	{
		this.writeFileIn(this.Store.Local, fname, data, binary, cb);
	},

	/**
	 * @private
	 *	write a file to a common store on the filesystem
	 *	NOTE: This is not a secure location and games should not rely on this for critical data
	 *	@param {store} The shared location to write to
	 *	@param {fname} The name of the file to be written
	 *	@param {cb} The callback function to be called after completion
	 *	@param {binary} binary mode or not
     *  @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	writeFileIn: function( store, fname, data, binary, cb )
	{
		var cbId = 0;

		if(typeof(binary) == 'function')
		{
			cb = binary;
			binary = false;
		}
		binary = binary || false;

		if ( cb )
		{
			cbId = this.cbIdCounter++;
			this.writeRequests[ cbId ] = cb;
		}

		this._writeFileSendGen(cbId,store,fname,data,binary);
	},

	/**
	 * Delete a file from local storage.
	 * @example FileSys.deleteFile(SomeFile,function(err, data){});
	 * @param {String} fname The name of the file to delete.
	 * @param {Function} [cb] Specifies a callback function that returns an error if the file delete operation fails.
     * @status iOS, Android, Test, iOSTested, AndroidTested     
	 */
	deleteFile: function ( fname, cb )
	{
		this.deleteFileIn(this.Store.Local, fname, cb);
	},

	/**
	 * @private
	 *	delete a file from a common store on the filesystem
	 *	NOTE: This is not a secure location and games should not rely on this for critical data
	 *	@param {store} The shared location path
	 *	@param {fname} The name of the file to be deleted
	 *	@param {cb} The callback function to be called
     *  @status iOS, Android, Test, iOSTested, AndroidTested     
	 */
	deleteFileIn: function ( store, fname, cb )
	{
		var cbId = 0;

		if ( cb )
		{
			cbId = this.cbIdCounter++;
			this.writeRequests[ cbId ] = cb;
		}
		this._deleteFileSendGen(cbId,store,fname);
	},
	
	/**
	 * Decompress a zipfile.
	 * @example FileSys.readFile(SomeFile, ./some/path/to/destination/, true, function(err, data){...}
	 * @param {String} fname The name of the zipfile to decompress.
	 * @param {String} destination The directory path where the contents of the decompressed file are written.
	 * @param {Boolean} [returnFiles] Set as <code>true</code> if <code>decompressFile()</code> should return a list of files contained in the zipfile specified by the <code>fname</code> parameter.
	 * @param {Function} [cb] Specifies a callback function that returns an error if the file decompress operation fails.
     * @status iOS, Android
	 */
	decompressFile: function( fname, destination, returnFiles, cb )
	{
		this.decompressFileIn(this.Store.Local, fname, destination, returnFiles, cb);
	},
	
	/**
	 * @private
	 *	decompress a file to a shared location on the filesystem
	 *	NOTE: This is not a secure location and games should not rely on this for critical data
	 *	@param {store} The shared location path
	 *	@param {fname} The name of the file to be read
	 *	@param {cb} The callback function to be called
	 *	@param {destination} destination location to unzip files to
	 *	@param {returnFiles} true/false if true it returns a json object with a list of each file, its MD5 hash and its size
     *  @status iOS, Android    
	 */
	decompressFileIn: function( store, fname, destination, returnFiles, cb )
	{
		var cbId = 0;

		if ( cb )
		{
			cbId = this.cbIdCounter++;
			this.writeRequests[ cbId ] = cb;
		}
		this._decompressFileSendGen(cbId,store,fname,destination,returnFiles);
	},
	
	/**
	 * @private
	 */
	_readFileCbRecv: function( cmd ) 
	{
		var msg = {};
		if(!this._readFileCbRecvGen(cmd, msg))
			return;
			
		var cbId = msg[ "callbackId" ];
		var data = msg[ "data" ];
		var err = msg[ "error" ];
		
		if ( !cbId )
		{
			NgLogE ( "FileSystem.onReadFile: No cbId" );
			return;
		}
		
		var cb = this.readRequests[ cbId ];
		
		if ( !cb )
		{
			NgLogE ( "FileSystem.onReadFile: No registered cb found..cbId is :" + cbId );
			return;
		}
		
		delete this.readRequests[ cbId ];
		cb ( err, data );
	},
	
	/**
	 * @private
	 */
	_writeFileCbRecv: function( cmd )
	{
		var msg = {};
		if(!this._writeFileCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg[ "callbackId" ];
		var err = msg[ "error" ];
		
		if ( !cbId )
		{
			//NgLogE ( "FileSystem command : No cbId" );
			return;
		}
		
		var cb = this.writeRequests[ cbId ];
			
		if ( !cb )
		{
			NgLogE ( "FileSystem command : No registered cb found..cbId is :" + cbId );
			return;
		}

		delete this.writeRequests[ cbId ];
		cb ( err );
	},
	
	/**
	 * @private
	 */
	_deleteFileCbRecv: function( cmd )
	{
		var msg = {};
		if(!this._deleteFileCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg[ "callbackId" ];
		var err = msg[ "error" ];
		
		if ( !cbId )
		{
			//NgLogE ( "FileSystem command : No cbId" );
			return;
		}
		
		var cb = this.writeRequests[ cbId ];
		
		if ( !cb )
		{
			NgLogE ( "FileSystem command : No registered cb found..cbId is :" + cbId );
			return;
		}
		
		delete this.writeRequests[ cbId ];
		cb ( err );
	},
	
	/**
	 * @private
	 */
	_decompressFileCbRecv: function( cmd )
	{
		var msg = {};
		if(!this._decompressFileCbRecvGen(cmd, msg))
			return;
			
		var cbId = msg[ "callbackId" ];
		var files = msg[ "files" ];
		var err = msg[ "error" ];
		
		if ( !cbId )
		{
			//NgLogE ( "FileSystem command : No cbId" );
			return;
		}
		
		var cb = this.writeRequests[ cbId ];
		
		if ( !cb )
		{
			NgLogE ( "FileSystem command : No registered cb found..cbId is :" + cbId );
			return;
		}
		
		try
		{
			files = JSON.parse(files);
		}
		catch(e)
		{
			NgLogE ( "FileSystem command : Could not parse response :" + files );
			err = "Could not parse files";
		}
		
		delete this.writeRequests[ cbId ];
		cb ( err, files );
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	Store:
	{ 
		/** /tmp */
		Temp: 0,
		/** local sandbox */
		Local: 1,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 338
	// Method create = -1
	// Method readFile = 2
	// Method writeFile = 3
	// Method deleteFile = 4
	// Method decompressFile = 5
	// Method readFileCb = 6
	// Method writeFileCb = 7
	// Method deleteFileCb = 8
	// Method decompressFileCb = 9
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 6:
					instance._readFileCbRecv( cmd );
					break;
				case 7:
					instance._writeFileCbRecv( cmd );
					break;
				case 8:
					instance._deleteFileCbRecv( cmd );
					break;
				case 9:
					instance._decompressFileCbRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in FileSystem._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in FileSystem._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[338] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_readFileCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.readFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.readFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "data" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "data" ] === undefined )
		{
			NgLogE("Could not parse data in FileSystem.readFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.readFileCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_writeFileCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.writeFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.writeFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.writeFileCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_deleteFileCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.deleteFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.deleteFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.deleteFileCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_decompressFileCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.decompressFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.decompressFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "files" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "files" ] === undefined )
		{
			NgLogE("Could not parse files in FileSystem.decompressFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.decompressFileCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":338,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_readFileSendGen: function( callbackId, storeId, filename, binary )
	{
		Core.Proc.appendToCommandString( ":338,2," + this.__objectRegistryId + "," + callbackId + "," + storeId + "," + Core.Base64.encode( filename ) + "," + ( binary ? 1 : 0 )  );
	},
	
	/** @private */
	_writeFileSendGen: function( callbackId, storeId, filename, data, binary )
	{
		Core.Proc.appendToCommandString( ":338,3," + this.__objectRegistryId + "," + callbackId + "," + storeId + "," + Core.Base64.encode( filename ) + "," + Core.Base64.encode( data ) + "," + ( binary ? 1 : 0 )  );
	},
	
	/** @private */
	_deleteFileSendGen: function( callbackId, storeId, filename )
	{
		Core.Proc.appendToCommandString( ":338,4," + this.__objectRegistryId + "," + callbackId + "," + storeId + "," + Core.Base64.encode( filename )  );
	},
	
	/** @private */
	_decompressFileSendGen: function( callbackId, storeId, filename, destination, returnFiles )
	{
		Core.Proc.appendToCommandString( ":338,5," + this.__objectRegistryId + "," + callbackId + "," + storeId + "," + Core.Base64.encode( filename ) + "," + Core.Base64.encode( destination ) + "," + ( returnFiles ? 1 : 0 )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// readFile: function( callbackId, storeId, filename, binary ) {}
	
	// writeFile: function( callbackId, storeId, filename, data, binary ) {}
	
	// deleteFile: function( callbackId, storeId, filename ) {}
	
	// decompressFile: function( callbackId, storeId, filename, destination, returnFiles ) {}
	
	// _readFileCbRecv: function( cmd ) {}
	// _writeFileCbRecv: function( cmd ) {}
	// _deleteFileCbRecv: function( cmd ) {}
	// _decompressFileCbRecv: function( cmd ) {}

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network'] || {}; $MODULE_REGISTRY['NGCore/Client/Network'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class Network
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////
/**
 * @name Network
 * @namespace
 * <p>Classes and objects contained by the Network module.</p>
 * @description <p>The Network module is a collection of classes that support manipulation of network flow.
 * Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 *<ul>
 *<li><code>{@link Network.DownloadFile}</code>: Construct objects that conduct a file download.</li>
 *<li><code>{@link Network.DownloadManifest}</code>: Construct objects that keep manifests up-to-date.</li>
 *<li><code>{@link Network.XHR}</code>: Construct XmlHttpRequest objects.</li>
 *</ul>
 */
exports.Network = {};

exports.Network.__defineGetter__("XHR", function() {
	delete this.XHR;
	return this.XHR = require('NGCore/Client/Network/XHR').XHR;
});
exports.Network.__defineGetter__("DownloadFile", function() {
	delete this.DownloadFile;
	return this.DownloadFile = require('NGCore/Client/Network/DownloadFile').DownloadFile;
});
exports.Network.__defineGetter__("DownloadManifest", function() {
	delete this.DownloadManifest;
	return this.DownloadManifest = require('NGCore/Client/Network/DownloadManifest').DownloadManifest;
});
exports.Network.__defineGetter__("Util", function() {
	delete this.Util;
	return this.Util = require('NGCore/Client/Network/Util').Util;
});
exports.Network.__defineGetter__("_int_Util", function() {
	delete this._int_Util;
	return this._int_Util = require('NGCore/Client/Network/_int_Util')._int_Util;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/LifecycleEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/LifecycleEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/LifecycleEmitter'] = exports; var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Proc = require('NGCore/Client/Core/Proc').Proc;

exports.LifecycleEmitter = MessageEmitter.singleton(
/** @lends Device.LifecycleEmitter.prototype */
{
	classname: 'LifecycleEmitter',
		
	/**
	 * @class The <code>LifecycleEmitter</code> class constructs a singleton object that emits <code><a href="Device.LifecycleEmitter.html#Event">Event</a></code> 
	 * objects when device lifecycle events occur.
	 * Applications can respond to these events by notifying external sources. For example,
	 * an application can respond to a <code>Terminate</code> event by writing an analytics log.<br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		/** @private */
		this.identificationCache = {};
		this.numEngineRequests = 0;
	},
	
	_lifecycleEventRecv: function( cmd )
	{
		var msg = {};
		if(!this._lifecycleEventRecvGen(cmd, msg))
			return;
			
		this.emit(msg.event);
		//Cascade the original message back out to native for forwarding
		//	to the next interpreter in the chain.
		this._lifecycleEventSendGen(msg.event);
	},

	/** @private */
	$exitProcess: function()
	{
		this._exitProcessSendGen();
	},
	
	/** @private */
	$_bgMe: function()
	{
		this.__bgMeSendGen();
	},

	/** @private */
	$pauseGame: function()
	{
		NgLogD("+++++++++++++++++++++++++++++++++++++++++Pausing Game");
		this._pauseGameSendGen();
		var _lgl = require('NGCore/Client/Core/_LocalGameList')._LocalGameList;
		_lgl._pausingGame();
	},

	/** @private */
	$resumeGame: function()
	{
		NgLogD("+++++++++++++++++++++++++++++++++++++++++Resuming Game");
		this._resumeGameSendGen();
		var _lgl = require('NGCore/Client/Core/_LocalGameList')._LocalGameList;
		_lgl._resumingGame();
	},

	requestEngineKeepAlive: function(obj)
	{
		var key = obj;
		if (obj.identification_key !== undefined)
		{
			key = obj.identification_key;
		}

		{
			//Store identification key and increment request to engine
			this.identificationCache[key] = true;
			++this.numEngineRequests;
			this.incrementEngineAlive();
		}
	},
	
	cancelEngineKeepAlive: function(obj)
	{
		var key = obj;
		if (obj.identification_key !== undefined)
		{
			key = obj.identification_key;
		}

		{
			if (this.identificationCache[key])
			{
				//Store identification key and increment request to engine
				delete this.identificationCache[key];
				--this.numEngineRequests;
				this.decrementEngineAlive();
			}else{
				NgLogD("Identification Key not found");
			}
		}
	},

	incrementEngineAlive: function()
	{
		this._incrementEngineAliveSendGen();
	},
	
	decrementEngineAlive: function()
	{
		this._decrementEngineAliveSendGen();
	},
	
	cancelAllEngineRequests: function()
	{
		this._cancelAllEngineRequestsSendGen();
	},

	_killGameProc: function( )
	{
		this.__killGameProcSendGen();
	},

// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration values for lifecycle events.
	 * @fieldOf Device.LifecycleEmitter.prototype
	 */
	Event:
	{ 
		/** Application is being suspended. */
		Suspend: 0,
		/** Application is being resumed. */
		Resume: 1,
		/** Application is being terminated. */
		Terminate: 2,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 334
	// Method create = -1
	// Method lifecycleEvent = 2
	// Method exitProcess = -3
	// Method pauseGame = -4
	// Method resumeGame = -5
	// Method incrementEngineAlive = 6
	// Method decrementEngineAlive = 7
	// Method cancelAllEngineRequests = 8
	// Method _killGameProc = -9
	// Method _bgMe = -10
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._lifecycleEventRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in LifecycleEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in LifecycleEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[334] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_lifecycleEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in LifecycleEmitter.lifecycleEvent from command: " + cmd );
			return false;
		}
		
		obj[ "event" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "event" ] === undefined )
		{
			NgLogE("Could not parse event in LifecycleEmitter.lifecycleEvent from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":334,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_lifecycleEventSendGen: function( event )
	{
		Core.Proc.appendToCommandString( ":334,2," + this.__objectRegistryId + "," + event  );
	},
	
	/** @private */
	$_exitProcessSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334," + -3  );
	},
	
	/** @private */
	$_pauseGameSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334," + -4  );
	},
	
	/** @private */
	$_resumeGameSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334," + -5  );
	},
	
	/** @private */
	_incrementEngineAliveSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334,6," + this.__objectRegistryId );
	},
	
	/** @private */
	_decrementEngineAliveSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334,7," + this.__objectRegistryId );
	},
	
	/** @private */
	_cancelAllEngineRequestsSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334,8," + this.__objectRegistryId );
	},
	
	/** @private */
	$__killGameProcSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334," + -9  );
	},
	
	/** @private */
	$__bgMeSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334," + -10  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _lifecycleEventRecv: function( cmd ) {}
	// lifecycleEvent: function( event ) {}
	
	// $exitProcess: function(  ) {}
	
	// $pauseGame: function(  ) {}
	
	// $resumeGame: function(  ) {}
	
	// incrementEngineAlive: function(  ) {}
	
	// decrementEngineAlive: function(  ) {}
	
	// cancelAllEngineRequests: function(  ) {}
	
	// $_killGameProc: function(  ) {}
	
	// $_bgMe: function(  ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/XHR'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/XHR'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/XHR'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class XHR
// XMLHttpRequest implementation
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Class = require('NGCore/Client/Core/Class').Class;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Util = require('NGCore/Client/Network/Util').Util;
var Caps = require('NGCore/Client/Core/Capabilities').Capabilities;

////////////////////////////////////////////////////////////////////////////////

var Header = function (item, content)
{
	this.item = item;
	this.content = content;
};
var headerEx = /(.*?): (.*)/;

/**
 * Constants
 */
var State =
{
	UNSENT: 0,
	OPENED: 1,
	HEADERS_RECEIVED: 2,
	LOADING: 3,
	DONE: 4
};

// ///////////// Begin HTTP req'd methods of testing! //////
var methods =
[
	"OPTIONS",
	"GET",
	"HEAD",
	"POST",
	"PUT",
	"DELETE",
	"TRACE",
	"CONNECT"
];

var unsecureMethods = ["CONNECT", "TRACE", "TRACK"];

var checkMethod = function(method)
{
	if(!method) return "GET";

	method = method.toString();

	if (method in unsecureMethods)
	{
		throw "SECURITY_ERROR " + method + " not allowed.";
	}
	if (method.toUpperCase() in methods)
	{
		return method.toUpperCase();
	}
	return method;
};

// ////////////////////////// End! /////////////////////

////////////////////////////////////////////////////////////////////////////////

exports.XHR = Class.subclass(
/** @lends Network.XHR.prototype */
{
	classname: 'XHR',
	
	/**
	 * @class The <code>XHR</code> class constructs <code>XmlHttpRequest</code> objects. Applications can use these objects to
	 * send HTTP or HTTPS requests directly to a web server and load the server response data directly back into a script.
	 * @constructs The default constructor. 
	 * @see <a href="http://www.w3.org/TR/XMLHttpRequest/">Official W3C XmlHttpRequest specification</a>
	 * @augments Core.Class
	 */
	initialize: function()
	{
		this.request;
		this.respHeaders = {};

		this.settings = {};
		this.headers = [];

		// State-associated flags
		this.sendFlag = false;
		this.errorFlag = false;
		
		// Status & response
		this.readyState = State.UNSENT;
		this.responseText = null;
		this.responseXML = null;
		this.status = 0;
		this.statusText = "";
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 340
	// Method create = -1
	// Method destroy = 2
	// Method sendStatus = 3
	// Method sendHeaders = 4
	// Method sendData = 5
	// Method onFinish = 6
	// Method start = 7
	// Method header = 8
	// Method setComposition = 9
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 3:
					instance._sendStatusRecv( cmd );
					break;
				case 4:
					instance._sendHeadersRecv( cmd );
					break;
				case 5:
					instance._sendDataRecv( cmd );
					break;
				case 6:
					instance._onFinishRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in XHR._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in XHR._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[340] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_sendStatusRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in XHR.sendStatus from command: " + cmd );
			return false;
		}
		
		obj[ "statNum" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "statNum" ] === undefined )
		{
			NgLogE("Could not parse statNum in XHR.sendStatus from command: " + cmd );
			return false;
		}
		
		obj[ "statStr" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "statStr" ] === undefined )
		{
			NgLogE("Could not parse statStr in XHR.sendStatus from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_sendHeadersRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in XHR.sendHeaders from command: " + cmd );
			return false;
		}
		
		obj[ "headers" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "headers" ] === undefined )
		{
			NgLogE("Could not parse headers in XHR.sendHeaders from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_sendDataRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in XHR.sendData from command: " + cmd );
			return false;
		}
		
		obj[ "data" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "data" ] === undefined )
		{
			NgLogE("Could not parse data in XHR.sendData from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_onFinishRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in XHR.onFinish from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseBool( cmd[ 0 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in XHR.onFinish from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":340,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":340,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_startSendGen: function( method, url, data, headers )
	{
		Core.Proc.appendToCommandString( ":340,7," + this.__objectRegistryId + "," + Core.Base64.encode( method ) + "," + Core.Base64.encode( url ) + "," + Core.Base64.encode( data ) + "," + headers  );
	},
	
	/** @private */
	_headerSendGen: function( item, content )
	{
		Core.Proc.appendToCommandString( "," + Core.Base64.encode( item ) + "," + Core.Base64.encode( content )  );
	},
	
	/** @private */
	_setCompositionSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":340,9," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// _sendStatusRecv: function( cmd ) {}
	// _sendHeadersRecv: function( cmd ) {}
	// _sendDataRecv: function( cmd ) {}
	// _onFinishRecv: function( cmd ) {}
	// start: function( method, url, data, headers ) {}
	
	// header: function( item, content ) {}
	
	// setComposition: function(  ) {}
	

// {{/Wg Generated Code}}

// API
	/**
	 * Initialize a request for this <code>XHR</code>.
	 *
	 * <b>Note:</b> Calling <code>open()</code> will wipe all request headers. You must set them after making this call.
	 *
	 * @param {String}
	 *            method The request method 
	 * 		(<code>GET</code>, <code>POST</code>, <code>OPTIONS</code>, <code>HEAD</code>,  
	 *		<code>PUT</code>, <code>DELETE</code>, <code>TRACE</code>, <code>CONNECT</code>)
	 * @param {String}
	 *            url The request URL.
	 * @param {Boolean}
	 *            [async=true] Returns <code>true</code> if the request is synchronous. Returns <code>false</code> in all other cases.<br><br> 
	 * 		<b>Note:</b> Currently not implemented.
	 * @param {String}
	 *            [user] Username for basic authentication.<br><br> 
	 *		<b>Note:</b> Currently not implemented.
	 * @param {String}
	 *            [password] Password for basic authentication.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	open: function(method, url, async, user, password)
	{
		url = url.split(' ').join('%20');
		this.settings =
		{
			"method": checkMethod(method),
			"url": Util.buildRelativeUrl(url),
			"async": async,
			"user": user,
			"password": password
		};

		// Check URL and set XHR flag appropriately
// 		var localServer = Caps.getServer();
// 		if (localServer == url.substr(0, localServer.length) && Caps.getPlatformOS() == "Android")
// 		{
// 			this.NXS = true;
// 		}

		if (this.me && this.sendFlag)
		{
			http.abort(this.me);
		}
		this.reset();
		this.setState(State.OPENED);
	},

	/**
	* @ private
	* Send a request initialized by the <code>open()</code> method. 
	* @param {Array} [composition] Array of strings and file names to be composed into the body.<br><br>
	* <b>Note:</b> This parameter is ignored if <code>readyState</code> is set as <code>GET</code> or <code>HEAD</code>.
	* @throws {INVALID_STATE_ERR} If <code>readyState</code> is set as anything other than <code>OPENED</code> or if the <code>send()</code> flag is true.
	* @see Network.XHR#open
	* @status iOS, Android
	*/

	sendComposition: function(comp)
	{
		// ex: [{"str":"string to send"},{"file":"path/to/file.bin"},{"str":"more goods"}]
		this.composing = true;
		this.send(JSON.stringify(comp));
	},

	/**
	* Send a request initialized by the <code>open()</code> method.
	* @param {String} [data] The request entity body.<br><br>
	* <b>Note:</b> This parameter is ignored if <code>readyState</code> is set as <code>GET</code> or <code>HEAD</code>.
	* @throws {INVALID_STATE_ERR} If <code>readyState</code> is set as anything other than <code>OPENED</code> or if the <code>send()</code> flag is true.
	* @see Network.XHR#open
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	send: function(data)
	{
		if (this.readyState != State.OPENED || this.sendFlag)
		{
			throw "INVALID_STATE_ERR: " + (this.sendFlag ? "Already sending" : "in state " + this.readyState);
		}
		this.sendFlag = true;

		if (data && this.settings.method != "GET" && this.settings.method != "HEAD")
		{
			// TODO http://www.w3.org/TR/XMLHttpRequest/#the-send-method step 3
		}

		this.errorFlag = false;

		// Set content length header
		if (this.settings.method == "GET" || this.settings.method == "HEAD")
		{
			data = null;
		}
		else if (data)
		{
			var bFound = false;
			for (var i in this.headers)
			{
				if (this.headers[i].item == "Content-Type")
				{
					bFound = true;
					break;
				}
			}
			if (!bFound)
			{
				this.setRequestHeader("Content-Type", "text/plain;charset=UTF-8");
			}
		}

		this.responseText = "";

		// Send data to the server
		if (!data)
		{
			data = "";
		}

		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

/* Not supporting NXS. Could remove it, but maybe we will support it one day */
		if (this.NXS)
		{
			this.me = http.create(this);
			for (var i in this.headers)
			{
				var h = this.headers[i];
				http.addHeader(this.me, h.item + ": " + h.content);
			}
			http.send(this.me, this.settings.method, this.settings.url, data);
		}
		else
		{
			if (this.composing)
				this._setCompositionSendGen();

			this._startSendGen(this.settings.method, this.settings.url, data, this.headers.length);
			for (var i in this.headers)
			{
				var obj = this.headers[i];
				this._headerSendGen(obj.item, obj.content);
			}
		}
	}, // this.send() 

	/**
	 * Cancel any existing or pending network activity for this <code>XHR</code>. 
	 * This method is invoked using the specification outlined by W3C.
	 * @see <a href="http://www.w3.org/TR/XMLHttpRequest/#the-abort-method">W3C specification outline for <code>abort()</code></a>
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	abort: function()
	{
		this.responseText = null;
		this.errorFlag = true;
		this.headers = [];

		if (this.sendFlag)
		{
			if (this.NXS)
			{
				http.abort(this.me);
			}

			if (this.readyState != State.DONE)
			{
				this.sendFlag = false;
				this.setState(State.DONE);
			}
		}
		this.readyState = State.UNSENT;
	},

	/**
	 * Retrieve a header from the server response.
	 *
	 * @param {String}
	 *            header Name of header to retrieve.
	 * @returns {String} Text of the header or <code>null</code> if text does not exist.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getResponseHeader: function(header)
	{
		if (this.readyState > State.OPENED)
		{
			return this.respHeaders[header.toLowerCase()];
		}
		return null;
	},

	/**
	 * Nonstandard: Retrieve the key-value map of all response headers.
	 *
	 * @return {Object} A key-value map as an object.
     * @status iOS, Android, Test, iOSTested, AndroidTested
     */
	getUnflattenedResponseHeaders: function()
	{
		return this.respHeaders;
	},

	/**
	 * Retrieve all the response headers from a request.
	 * This method is invoked using the specification outlined by W3C.
	 * @return {String} All the response headers from a request.
	 * @see <a href="http://www.w3.org/TR/XMLHttpRequest/#the-getallresponseheaders-method">W3C specification outline for <code>getAllResponseHeaders()</code>.</a>
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getAllResponseHeaders: function()
	{
		if (this.readyState < State.HEADERS_RECEIVED || this.errorFlag)
		{
			return "";
		}

		var result = "";
		for (var i in this.respHeaders)
		{
			result += i + ": " + this.respHeaders[i] + "\r\n";
		}
		return result.substr(0, result.length - 2);
	},

	/**
	 * Set a header for the request.
	 *
	 * @param {String}
	 *            header The name of the header.
	 * @param {String}
	 *            value The value of the header.
	 * @see Network.XHR#getRequestHeader
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	setRequestHeader: function(header, value)
	{
		this.headers.push(new Header(header, value));
	},

	/**
	 * Retrieve a header from the request.
	 *
	 * @param {String} header The name of the header.
	 * @return {String} The value of the header.
	 * @see Network.XHR#setRequestHeader
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getRequestHeader: function(header)
	{
		var ret = null;
		for (var i in this.headers)
		{
			if (this.headers[i].item == header)
			{
				ret = this.headers[i].content;
				break;
			}
		}
		return ret;
	},

// Receivers
    /*
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	onStatus: function ( num, str)
	{
		this.status = num;
		this.statusText = str;
	},

	_sendStatusRecv: function( cmd )
	{
		var obj = {};
		this._sendStatusRecvGen(cmd, obj);
		this.onStatus(obj.statNum, obj.statStr);
	},
    /*
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	onHeaders: function(str)
	{
		var lines = str.split('\n');
		lines.pop();
		for (var i in lines)
		{
			var match = headerEx.exec(lines[i]);
			if (match)
				this.respHeaders[match[1].toLowerCase()] = match[2];
		}
		this.setState(State.HEADERS_RECEIVED);
	},

	_sendHeadersRecv: function( cmd )
	{
		var obj = {};
		this._sendHeadersRecvGen(cmd, obj);
		this.onHeaders(obj.headers);
	},
    /*
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	onData: function(data)
	{
		this.responseText += data;
		this.setState(State.LOADING);
	},

	_sendDataRecv: function( cmd )
	{
		var obj = {};
		this._sendDataRecvGen(cmd, obj);
		this.onData(obj.data);
	},
    /*
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	onFinish: function (err)
	{
		this.sendFlag = false;
		if (err)
		{
			this.responseText = null;
			this.error = "Network Error";
			this.errorFlag = true;
			this.status = 0;
		}
		this.setState(State.DONE);
	},

	_onFinishRecv: function( cmd )
	{
		var obj = {};
		this._onFinishRecvGen(cmd, obj);
		this.onFinish(obj.error);
	},

// Internal methods
	/**
	 * Reset all fields from a request. This call sets <code>readyState</code> to <code>UNSENT</code> 
	 * and the response properties to <code>null</code>.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	reset: function()
	{
		this.headers = [];
		this.readyState = State.UNSENT;
		this.responseText = null;
		this.responseXML = null;
		this.composing = false;
	},
	/**
	 * Change the value of <code>readyState</code> and call <code>onreadystatechange()</code>.
	 *
	 * @param {Number}
	 *            state The new value for <code>readyState</code>
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	setState: function(state)
	{
		this.readyState = state;
		if (state == State.DONE)
		{
			this._destroySendGen();
			ObjectRegistry.unregister(this);
		}
		if (typeof this.onreadystatechange != 'undefined')
		{
			try
			{
				this.onreadystatechange();
			}
			catch (e)
			{
				NgLogException(e);
			}
		}
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/DownloadFile'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/DownloadFile'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/DownloadFile'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class DownloadFile
// Downloads a file to the sandbox
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Class = require('NGCore/Client/Core/Class').Class;

////////////////////////////////////////////////////////////////////////////////

exports.DownloadFile = Class.subclass(
/** @lends Network.DownloadFile.prototype */
{
	classname: 'DownloadFile',
	/**
	* @class The <code>DownloadFile</code> class constructs objects that conduct a file download through an HTTP request.
	* @constructs The default constructor. 
	* @augments Core.Class
	*/
	initialize: function() {},

	/**
	  * Initiate a file download.
	  * @example var url = 'http://url/to/stuff/
	  * new Network.DownloadFile).start(filename, 'GET', url, [], (function(status, md5)
	  * @param {String} filename A local and relative path for storing the downloaded data.
	  * @param {String} method The HTTP method to use.  For example, <code>GET</code> or <code>POST</code>.
	  * @param {String} url The URL of the downloaded file.
	  * @param {Object} [headers] A dictionary that maps header names to header values.
	  * @param {Function} [callback] A callback function for notification
	  * of when the download completes. The signature for the callback is equivalent
	  * to:<br><br>
	  * <pre>function(statusCode,fileSignature)</pre><br>
	  * The <code>fileSignature</code> is currently the
	  * md5 checksum of the file.
	  * @type void
      * @status iOS, Android, Test, iOSTested, AndroidTested
	  */
	start: function(filename, method, url, headers, callback)
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		url = url.split(' ').join('%20');
		// Check headers
		if (!(headers instanceof Array))
		{
			NgLogE('Improper headers sent('+headers+'). Need an array, ex: ["Content-Easter: egg"]');
			headers = [];
		}

		// Send the goods
		this.__sendSendGen( filename, method, url, headers.length );

		// Send headers
		for (var i in headers)
		{
			this.__headerSendGen(headers[i].item, headers[i].content);
		}

		// Save the callback
		this.mCB = callback
	},

	abort: function()
	{
		this._destroySendGen();
		ObjectRegistry.unregister(this);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 341
	// Method create = -1
	// Method destroy = 2
	// Method _send = 3
	// Method _header = 4
	// Method finish = 5
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 5:
					instance._finishRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in DownloadFile._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in DownloadFile._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[341] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_finishRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in DownloadFile.finish from command: " + cmd );
			return false;
		}
		
		obj[ "status" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "status" ] === undefined )
		{
			NgLogE("Could not parse status in DownloadFile.finish from command: " + cmd );
			return false;
		}
		
		obj[ "signature" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "signature" ] === undefined )
		{
			NgLogE("Could not parse signature in DownloadFile.finish from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":341,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":341,2," + this.__objectRegistryId );
	},
	
	/** @private */
	__sendSendGen: function( fileName, method, url, headers )
	{
		Core.Proc.appendToCommandString( ":341,3," + this.__objectRegistryId + "," + Core.Base64.encode( fileName ) + "," + Core.Base64.encode( method ) + "," + Core.Base64.encode( url ) + "," + headers  );
	},
	
	/** @private */
	__headerSendGen: function( item, content )
	{
		Core.Proc.appendToCommandString( "," + Core.Base64.encode( item ) + "," + Core.Base64.encode( content )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// _send: function( fileName, method, url, headers ) {}
	
	// _header: function( item, content ) {}
	
	// _finishRecv: function( cmd ) {}

// {{/Wg Generated Code}}
	
	_finishRecv: function( cmd )
	{
		this._destroySendGen();
		
		var obj = {};
		this._finishRecvGen(cmd, obj);

		if (this.mCB)
			this.mCB(obj.status, obj.signature);

		ObjectRegistry.unregister(this);
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/Util'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/Util'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/Util'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Utilities for Network
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Caps = require('NGCore/Client/Core/Capabilities').Capabilities;
var Time = require('NGCore/Client/Core/Time').Time;
var LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;

////////////////////////////////////////////////////////////////////////////////

var urlPathServerSplit = /^(https?:\/\/)?([^\/]*)(.*[^\/])?.?/i;

var Util = exports.Util =
{
    /*
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	NormalizeUrl: function(url, keepTrailingSlash)
	{
		url = Util.buildRelativeUrl(url);

		// Now split it into parts and make server bits lower case
		var parsed = url.match(urlPathServerSplit);
		if (parsed && parsed[1])
		{
			// absolute path!
			url = parsed[1].toLowerCase() + parsed[2].toLowerCase() + (parsed[3] ? parsed[3] : "");
		}
		else
		{
			// Direct server, no path
			url = url.toLowerCase();
		}
		return url;
	},

	buildRelativeUrl: function(url)
	{
		if (!url.match(/^(https?:\/\/)/))
		{
			// If the path is relative, then we append our server to the beginning of it
			if (url.charAt(0) == '/' || !url.length)
			{
				url = Caps.getServer() + url;
			}
			else
			{
				url = Caps.getServer() + "/" + Caps.getGame() + "/" + url;
			}
		}

		return url;
	},

	RetrySchedule: function(initialRetry, maxDuration)
	{
		var count = Math.floor(Math.log(maxDuration / initialRetry));
		var schedule = [initialRetry];
		for(var i=0; i < count + 1; ++i)
		{
			initialRetry *= 2;
			schedule.push(initialRetry);
		}
		return schedule;
	},
	
	OperationWithRetries: function(operationCb, failureCb, failEarly)
	{
		var abortAttempts;
		var abortTime;
		var abortTimeAttempts;
		
		if(failEarly)
		{
			abortAttempts = 3;
			abortTime = 10000;
			abortTimeAttempts = 1;
		}
		else
		{
			abortAttempts = Infinity;
			abortTime = 30000;
			abortTimeAttempts = 6;
		}
		
		// console.log('retry config abortAttempts:', abortAttempts, 'abortTime', abortTime, 'abortTimeAttempts', abortTimeAttempts);
		
		abortTime = Core.Time.getRealTime() + abortTime;
		var timeout = 250;
		var attemptCount = 1;
		
		var failed = false;
		var armed = true;
		
		var failureParam = function()
		{
			if(failed) return;
			
			if(!armed)
			{
				console.log('OperationWithRetries: failureParam called when not armed');
				return;
			}
			armed = false;
			
			if(attemptCount >= abortAttempts)
			{
				console.log('OperationWithRetries: too many retry attempts');
				var failed = true;
				failureCb();
				return;
			}
			
			if(Core.Time.getRealTime() >= abortTime && attemptCount >= abortTimeAttempts)
			{
				console.log('OperationWithRetries: retries took too long');
				console.log('OperationWithRetries: abortTime:', abortTime, 'realTime:', Core.Time.getRealTime());
				console.log('OperationWithRetries: attemptCount:', attemptCount, 'abortTimeAttempts:', abortTimeAttempts);
				var failed = true;
				failureCb();
				return;
			}
			
			console.log('OperationWithRetries: Failure, will retry in ' + timeout + 'ms');
			setTimeout(function()
			{
				if(failed) return;
				armed = true;
				operationCb(failureParam, abortParam);
			}, timeout);
			
			attemptCount += 1;
			timeout *= 2;
		};
		
		var abortParam = function()
		{
			var failed = true;
			failureCb();
		};
		
		operationCb(failureParam, abortParam);
		
		return abortParam;
	},
	
	showFatalErrorDialog: function(status)
	{
		// Set up info dialog
		var myAlert = new AlertDialog();
		myAlert.setTitle(Core.Localization.getString("Network failure"));
		myAlert.setChoices([Core.Localization.getString("Exit")]);

		myAlert.onchoice =
		function(ret)
		{
			myAlert.hide();
			LifecycleEmitter.exitProcess();
		};
		
		// TODO: Move this list somewhere localizable
		var commonErrors = {
			'302': "File location has changed (302)",
			'400': "Bad request to server (400)",
			'401': "Authorization failed (401)",
			'403': "Server permissions error (403)",
			'404': "Resource not found (404)",
			'408': "Request timed out (408)",
			'500': "Internal server error (500)",
			'501': "Cannot process request (501)",
			'502': "Bad Gateway (502)",
			'503': "Service overloaded / down for maintenance (503)",
			'504': "Timeout at intervening gateway (504)"
		};
		myAlert.setText( Core.Localization.getString( commonErrors[status] || "This application requires a working data connection." ) );
		myAlert.show();
	},

	showSimpleNetworkError: function(status)
	{
		// Set up info dialog
		var myAlert = new AlertDialog();
		myAlert.setTitle(Core.Localization.getString("Network failure"));
		myAlert.setChoices([Core.Localization.getString("OK")]);

		myAlert.onchoice =
		function(ret)
		{
			myAlert.hide();
		};

		// TODO: Move this list somewhere localizable
		var commonErrors = {
			'302': " File location has changed (302)",
			'400': " Bad request to server (400)",
			'401': " Authorization failed (401)",
			'403': " Server permissions error (403)",
			'404': " Resource not found (404)",
			'408': " Request timed out (408)",
			'500': " Internal server error (500)",
			'501': " Cannot process request (501)",
			'502': " Bad Gateway (502)",
			'503': " Service overloaded / down for maintenance (503)",
			'504': " Timeout at intervening gateway (504)"
		};
		var message = "Cannot download game without network connection.";
		if (commonErrors[status])
		{
			message += commonErrors[status];
		}
		myAlert.setText( Core.Localization.getString( message ) );
		myAlert.show();
	},
	
	getCacheBustingString: function()
	{
		return '?t=' + (new Date()).getTime();
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/_int_Util'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/_int_Util'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/_int_Util'] = exports; ///////////////////////////////////////////////////////////////////////////////
// Class _int_Util
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Class = require('NGCore/Client/Core/Class').Class;
////////////////////////////////////////////////////////////////////////////////

exports._int_Util = Class.singleton(
/** @lends Network._int_Util.prototype */
{
	classname: '_int_Util',
	
	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		this._callbackID = 0;
		this._callbacks = [];

		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	ProcID:
	{ 
		/** High privilege proc */
		Persist: -1,
		/** Low priv */
		Game: -2,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 350
	// Method create = -1
	// Method destroy = 2
	// Method sign = 3
	// Method signCallback = 4
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 4:
					instance._signCallbackRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in _int_Util._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in _int_Util._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[350] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_signCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in _int_Util.signCallback from command: " + cmd );
			return false;
		}
		
		obj[ "signature" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "signature" ] === undefined )
		{
			NgLogE("Could not parse signature in _int_Util.signCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in _int_Util.signCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":350,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":350,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_signSendGen: function( baseString, callbackID, environment )
	{
		Core.Proc.appendToCommandString( ":350,3," + this.__objectRegistryId + "," + Core.Base64.encode( baseString ) + "," + callbackID + "," + Core.Base64.encode( environment )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// sign: function( baseString, callbackID, environment ) {}
	
	// _signCallbackRecv: function( cmd ) {}

// {{/Wg Generated Code}}

	sign: function( baseString, environment, callback) {
		this._callbacks[this._callbackID] = callback;
		this._signSendGen(baseString,this._callbackID, environment);
		this._callbackID++;
	},
	_signCallbackRecv: function( cmd ) {
		var msg = {};
		if (! this._signCallbackRecvGen(cmd, msg)) {
			return;
		}
		var func = this._callbacks[parseInt(msg.callbackID)];
		if (func) {
			func(msg.signature);
		}
	}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/MessageEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/MessageEmitter'] || {}; $MODULE_REGISTRY['NGCore/Shared/MessageEmitter'] = exports; var Class = require('NGCore/Shared/Class').Class;
var MessageListener = require('NGCore/Shared/MessageListener').MessageListener;

exports.MessageEmitter = Class.subclass(
/** @lends Core.MessageEmitter.prototype */
{
	classname: 'MessageEmitter',
	
	/**
	 * @status iOS, Android, Flash
	 * @class The <code>MessageEmitter</code> class constructs emitter objects that send messages to registered <code>{@link Core.MessageListener}</code> objects. 
	 * When a defined condition triggers an emitter, all registered listener objects are in turn triggered.
	 * <br><br>
	 * Emitter objects support two communication modes: emit and chain. When emitting, each listener is called in turn.
	 * When chaining, each listener can halt the propagation of a message to 
	 * other listeners by returning <code>true</code> from their callback.
	 * <br><br>
	 * Each listener can include an optional priority ranking. Priority determines the order
	 * in which an emitter calls each listener. 
	 * If two listener objects are registered with the same priority, the emitter calls them in the order they were registered. 
	 * The default priority is <code>0</code>. 
	 * <br><br>
	 * <b>Note:</b> Do not instantiate this class directly. Use classes derived from <code>MessageEmitter</code> for instantiation. This includes:
	 * <div class="ul">
	 * <li>{@link Core.Localization}</li>
	 * <li>{@link Core.UpdateEmitter}</li>
	 * <li>{@link Device.KeyEmitter}</li>
	 * <li>{@link Device.LifecycleEmitter}</li>
	 * <li>{@link Device.LocationEmitter}</li>
	 * <li>{@link Device.MemoryEmitter}</li>
	 * <li>{@link Device.MotionEmitter}</li>
	 * <li>{@link Device.NetworkEmitter}</li>
	 * <li>{@link Device.OrientationEmitter}</li>
	 * <li>{@link Device.ShakeEmitter}</li>
	 * </div>
	 * @constructs The default constructor.
	 * @augments Core.Class
	 */
	initialize: function()
	{
		this._messageListenersCount = 0;
		this._messageListenerRecords = [];
		this._messageDeferredWork = [];
		this._messageShouldDefer = false;
	},
	
	/**
	 * Unregister all <code>MessageListener</code> objects from this <code>MessageEmitter</code>.<br><br>
	 * <b>Note:</b> Do not use the emitter after calling this.
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function($super)
	{
		if(this._messageShouldDefer)
		{
			this._messageDeferredWork.push(this._destroyActual.bind(this, $super));
		}
		else
		{
			this._destroyActual($super);
		}
	},
	
	_destroyActual: function(superDestroy)
	{
		// Unregister all listeners.
		var records = this._messageListenerRecords;
		while(records.length)
		{
			this.removeListener(records[0].l);
		}
		
		if(superDestroy)
			superDestroy();
	},
	
	/**
	 * Retrieve the number of <code>MessageListener</code> objects registered with this <code>MessageEmitter</code>.
	 * @returns {Number} The current number of <code>MessageListener</code> objects.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getListenerCount: function()
	{
		return this._messageListenersCount;
	},
	
	/**
	 * Add a <code>MessageListener</code> to this <code>MessageEmitter</code>. When an application calls <code>emit()</code> 
	 * or <code>chain()</code> 
	 * on this emitter, a callback function passed as a parameter is called on the specified listener.
	 * The parameters for the callback function are identical to parameters for <code>emit()</code> or
	 * <code>chain()</code>.
	 * <br><br>
	 * <b>Note:</b> Each listener can only listen to an emitter one time.<br><br>
	 * The following code examples illustrate different call styles for <code>addListener()</code>.
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onCallback);
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onEvent, 200);
	 *
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to add.
	 * @param {Function} func The callback function.
	 * @param {Number} [priority=0] The priority for this <code>MessageListener</code>.
	 * @throws {MessageEmitter.addListener: listener is already listening} Calling <code>addListener()</code> multiple times on the same emitter
	 * with the same listener.
	 * @throws {MessageEmitter.addListener: listener must be instances of MessageListener} Listener is not an instance of <code>MessageListener</code>.
	 * @see Core.MessageEmitter#removeListener,
	 * @see Core.MessageEmitter#emit,
	 * @see Core.MessageEmitter#chain
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	addListener: function(listener, func, priority)
	{
		if(!listener instanceof MessageListener)
			throw new Error('MessageEmitter.addListener: listener must be instances of MessageListener');
			
		if(!listener._startListeningEmitter(this))
			throw new Error('MessageEmitter.addListener: listener is already listening');
			
		if(!priority)
		{
			priority = 0;
		}
		
		this._messageListenersCount++;	
		if(this._messageShouldDefer)
		{
			this._messageDeferredWork.push(this._addListenerActual.bind(this, listener, func, priority));
		}
		else
		{
			this._addListenerActual(listener, func, priority);
		}
	},
	
	_addListenerActual: function(listener, func, priority)
	{
		//  The priority for default value is <code>0</code>
		if ((typeof priority) == 'undefined') {
			priority = 0;
		}
		// TODO Replace with binary search.
		var records = this._messageListenerRecords;
		var len = records.length;
		for(var i=0; i < len; ++i)
		{
			if(records[i].p <= priority)
				break;
		}
		records.splice(i, 0, {l: listener, f: func, p: priority});
	},
	
	/**
	 * Remove a <code>MessageListener</code> from this <code>MessageEmitter</code>.<br><br> 
	 * The following code examples illustrate different call styles for <code>removeListener</code>.
	 * @example
	 * emitter.removeListener(myListener, myListener.onCallback);
	 * @example
	 * emitter.removeListener(myListener);
	 *
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to remove.
	 * @returns {Boolean} Returns <code>true</code> if the registered listener was removed. Returns <code>false</code> if the registered listener is not found 
	 * or is not registered with this emitter.
	 * @throws {MessageEmitter.removeListener: listener is not listening} Specified listener is not currently registered
	 * with this <code>MessageEmitter</code>.
	 * @see Core.MessageEmitter#addListener
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	removeListener: function(listener)
	{
		if(!listener._stopListeningEmitter(this))
			//throw new Error('MessageEmitter.removeListner: listener is not listening');
			return false;
		
		this._messageListenersCount--;
		if(this._messageShouldDefer)
		{
			// TODO Replace with binary search.
			var records = this._messageListenerRecords;
			var len = records.length;
			for(var i=0; i < len; ++i)
			{
				var record = records[i];
				if(record.l == listener)
				{
					record.f = null;
					break;
				}
			}
			
			this._messageDeferredWork.push(this._removeListenerActual.bind(this, listener));
		}
		else
		{
			this._removeListenerActual(listener);
		}
		
		return true;
	},
	
	_removeListenerActual: function(listener)
	{
		// TODO Replace with binary search.
		var records = this._messageListenerRecords;
		var len = records.length;
		for(var i=0; i < len; ++i)
		{
			var record = records[i];
			if(record.l == listener)
			{
				records.splice(i, 1);
				break;
			}
		}
	},
	
	/**
	 * Send a message to every registered <code>MessageListener</code>. This emitter will trigger all listeners
	 * in descending order based on the listener priority. All listener callback functions are generated
	 * with parameters passed to <code>emit()</code>.
	 * @param {Parameters} parameters Parameters to pass in the generated callback funtion.
	 * @see Core.MessageEmitter#chain
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	emit: function(params)
	{
		var handled = false;
		if(this._messageShouldDefer)
		{
			this._messageDeferredWork.push(this._emitActual.bind(this, arguments, false));
		}
		else
		{
			handled = this._emitActual(arguments, true);
		}
		return handled;
	},
	
	_emitActual: function(params, executeDeferred)
	{
		this._messageShouldDefer = true;
		
		var records = this._messageListenerRecords;
		var len = records.length;
		var handled = false;
		for(var i=0; i < len; ++i)
		{
			var record = records[i];
			if(!record.f) continue;
			
			if(record.f.apply(record.l, params))
				handled = true;
		}

		if(!handled)
		{
			//NgLogD("No listeners handling emitted key");
		}
		
		this._messageShouldDefer = false;
		
		if(this._messageDeferredWork.length && executeDeferred)
		{
			this._executeDeferred();
		}

		return handled;
	},
	
	/**
	 * Send a message to every registered <code>MessageListener</code> through a chain of command. 
	 * This emitter will trigger all listeners in descending order based on the listener priority.
	 * All listener callback functions are generated with parameters passed to <code>chain()</code>.	 
	 * <br><br>
	 * Unlike <code>emit()</code>, <code>chain()</code> allows a <code>MessageListener</code> to halt propagation of a message 
	 * to other listener objects by returning <code>true</code> for the callback function.
	 * This is useful for things like touch event handling. A <code>MessageListener</code> can respond to a touch event
	 * by returning <code>true</code>, masking the touch event from other listener objects.
	 *
	 * @param {Parameters} parameters Parameters to pass in the generated callback funtion.
	 * @returns {Boolean} Returns <code>true</code> if the registered listener responded. Returns <code>false</code> in all other cases.
	 * <br><br>
	 * <b>Note:</b> If the application calls <code>chain()</code> recursively from
	 * within a message handler callback, it will always return <code>undefined</code>
	 * regardless of if a <code>MessageListener</code> responds or not.
	 * @see Core.MessageEmitter#emit
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	chain: function(params)
	{
		if(this._messageShouldDefer)
		{
			this._messageDeferredWork.push(this._chainActual.bind(this, arguments, false));
			return undefined;
		}
		else
		{
			return this._chainActual(arguments, true);
		}
	},
	
	_chainActual: function(params, executeDeferred)
	{
		var result = false;
		this._messageShouldDefer = true;
		
		var records = this._messageListenerRecords;
		var len = records.length;
		for(var i=0; i < len; ++i)
		{
			var record = records[i];
			if(!record.f) continue;
			
			if(record.f.apply(record.l, params))
			{
				result = true;
				break;
			}
		}
		
		this._messageShouldDefer = false;
		
		if(this._messageDeferredWork.length && executeDeferred)
		{
			this._executeDeferred();
		}
		
		return result;
	},
	
	_executeDeferred: function()
	{
		// NOTE: Don't factor out deferred.length. Deferred work can add more deferred work.
		var deferred = this._messageDeferredWork;
		for(var i=0; i < deferred.length; ++i)
		{
			deferred[i]();
		}
		this._messageDeferredWork = [];
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/MessageListener'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/MessageListener'] || {}; $MODULE_REGISTRY['NGCore/Shared/MessageListener'] = exports; var Class = require('NGCore/Shared/Class').Class;

exports.MessageListener = Class.subclass(
/** @lends Core.MessageListener.prototype */
{
	classname: 'MessageListener',
	
	/**
	 * @class The <code>MessageListener</code> class is a base class for constructing objects that listen for notifications from emitters 
	 * (see <code>{@link Core.MessageEmitter}</code>). Objects of this type are registered with emitters.
	 * When <code>{@link Core.MessageEmitter#emit}</code> or <code>{@link Core.MessageEmitter#chain}</code> is called on an emitter
	 * all registered listeners will generate a callback function.
	 * <br><br>
	 * Applications must unregister listener objects when they are no longer required in one of three ways: 
	 * <div class="ul"><font size="3">
	 * <li>Calling <code>{@link Core.MessageEmitter#removeListener}</code> on the <code>MessageEmitter</code>.</li>
	 * <li>Calling <code>{@link Core.MessageEmitter#destroy}</code> on the <code>MessageEmitter</code>.</li>
	 * <li>Calling <code>{@link Core.MessageListener#destroy}</code> on the <code>MessageListener</code></li>
	 * </font></div><br>
	 * <font size="3"><b>Note:</b> Applications should not attempt to register a listener with an emitter more than once. Registering a listener with an emitter
	 * multiple times results in exceptions. </font>
	 * @example
	 * var MyListener = Core.MessageListener.subclass(
	 * {
	 *     myCallback: function(verb, value)
	 *     {
	 *         console.log('MyListener.myCallback(' + verb + ', ' + value + ')');
	 *     },
	 * }
	 * var listener = new MyListener();
	 * emitter.addListener(listener, listener.myCallback);
	 * emitter.emit('fun', 5);
	 * @constructs The default constructor.
	 * @augments Core.Class
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		this._messageEmitters = [];
	},
	
	/**
	 * Unregister this <code>MessageListener</code> from all emitters.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		// Unregister from all emitters.
		var emitters = this._messageEmitters;
		while(emitters.length)
			emitters[0].removeListener(this);
	},
	
	// Called by MessageEmitter when this receiver starts listening.
	_startListeningEmitter: function(emitter)
	{
		var emitters = this._messageEmitters;
		var index = emitters.indexOf(emitter);
		if(index !== -1)
			return false;
		
		emitters.push(emitter);
		return true;
	},
	
	// Called by MessageEmitter when this receiver stops listening.
	_stopListeningEmitter: function(emitter)
	{
		var emitters = this._messageEmitters;
		var index = emitters.indexOf(emitter);
		if(index === -1)
			return false;
		
		emitters.splice(index, 1);
		return true;
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/_int_LGL'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/_int_LGL'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/_int_LGL'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class _int_LGL
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Client/Core/Class').Class;
var Proc = require('NGCore/Client/Core/Proc').Proc;
var Base64 = require('NGCore/Client/Core/Base64').Base64;
var toMD5 = require('NGCore/Client/Core/toMD5').toMD5;

////////////////////////////////////////////////////////////////////////////////
function getCorrectedPlatformOS() {
	var os = Capabilities.getPlatformOS();
	switch (os) {
		case 'Android': return 'android';
		case 'iPhone OS': return 'ios';
	}
	return os;
};

function expandTexName(name)
{
	var list =
	{
		"pvr": "GL_IMG_texture_compression_pvrtc",
		"atc": "GL_AMD_compressed_ATC_texture",
		"etc1": "GL_OES_compressed_ETC1_RGB8_texture",
		"3dc": "GL_AMD_compressed_3DC_texture"
	};

	return list[name] || name;
};

var overridePropertyEvaluators = {
	isMatch: function(condition, value) {
		// Return true if the condition holds for the provided value
		// condition may be prefixed with an operator, so we extract it.
		var symbol;
		switch (condition.charAt(0)) {
		case '>':
			symbol = (condition.charAt(1) == '=') ? '>=' : '>';
			break;
		case '<':
			symbol = (condition.charAt(1) == '=') ? '<=' : '<';
			break;
		}
		// Consume any characters we detected, then set the default operation (equals)
		if (symbol) {
			condition = condition.slice(symbol.length);
		} else symbol = '=';

		if (condition == value) {
			return (symbol == '=' || symbol == '<=' || symbol == '>=');
		} else if (condition < value) {
			return (symbol == '<' || symbol == '<=');
		} else {
			return (symbol == '>' || symbol == '>=');
		}
	},

	isVersionMatch: function(condition, value) {
		// Return true if the condition holds for the provided value
		// condition may be prefixed with an operator, so we extract it.
		var symbol;
		if (condition.length > 0) switch (condition.charAt(0)) {
		case '>':
			symbol = (condition.charAt(1) == '=') ? '>=' : '>';
			break;
		case '<':
			symbol = (condition.charAt(1) == '=') ? '<=' : '<';
			break;
		case '=':
			symbol = (condition.charAt(1) == '=') ? '==' : '=';
			break;
		}
		// Consume any characters we detected, or set the default operation (equals)
		if (symbol) {
			condition = condition.slice(symbol.length);
		} else symbol = '=';

		var condition = condition.split('.');
		var value = value.split('.');

		var l = Math.max(condition.length, value.length);

		for (var i = 0; i < l; i++) {
			var ci = '0.' + (condition[i] || 0);
			var vi = '0.' + (value[i] || 0);
			if (ci == vi) continue;
			if (ci < vi) {
				return (symbol == '<' || symbol == '<=');
			} else {
				return (symbol == '>' || symbol == '>=');
			}
		}
		return true;
	},

	'sdkVersion': function(v) {
		return this.isVersionMatch('' + v, Capabilities.getSDKVersion());
	},

	'binaryVersion': function(v) {
		return this.isVersionMatch('' + v, Capabilities.getBinaryVersion());
	},

	'platformOS': function(v) {
		return v == getCorrectedPlatformOS();
	},

	'platformOSVersion': function(v) {
		return this.isVersionMatch('' + v, Capabilities.getPlatformOSVersion());
	},

	'platformHW': function(v) {
		return v == Capabilities.getPlatformHW();
	},

	'physicalMem': function(v) {
		return this.isMatch(v, Capabilities.getPhysicalMem());
	},

	'physicalCpus': function(v) {
		return this.isMatch(v, Capabilities.getPhysicalCpus());
	},

	'activeCpus': function(v) {
		return this.isMatch(v, Capabilities.getActiveCpus());
	},

	'language': function(v) {
		return v == Capabilities.getLanguage();
	},

	'textureMatch': "none",
	'textureCompression': function(v) {
		var matched = Capabilities.getOglExtensions().indexOf(expandTexName(v)) > -1;
		if (matched) this.textureMatch = v;
		return matched;
	},

	'screenWidth': function(v) {
		return this.isMatch(v, Capabilities.getScreenWidth());
	},

	'screenHeight': function(v) {
		return this.isMatch(v, Capabilities.getScreenHeight());
	},

	'screenResolution': function(v) {
		return v == (Capabilities.getScreenWidth() + 'x' + Capabilities.getScreenHeight());
	},

	'screenUnits': function(v) {
		return this.isMatch(v, Capabilities.getScreenUnits());
	},

	'screenPixelUnits': function(v) {
		return this.isMatch(v, Capabilities.getScreenPixelUnits());
	},

	'maxTextureSize': function(v) {
		return this.isMatch(v, Capabilities.getMaxTextureSize());
	},
	
	'reset': function(v) {
		this.textureMatch = "none";
	}
};

var _int_LGL = Class.singleton(
/** @lends Core._int_LGL.prototype */
{
	classname: '_int_LGL',

	launch: function(url, proc)
	{
		var Util = require('NGCore/Client/Network/Util').Util;
		// Default to game proc. Games should actually not be aware of the third option,
		//	as they cannot use it anyway.
		if (!proc)
			proc = _int_LGL.ProcID.Game;

		url = Util.NormalizeUrl(url);

//		console.log("launching game url " + url);

		var run = (function()
		{
			gNgShutdownPending = true;
			this._launchSendGen(url,proc);
		}).bind(this);

		if (proc == _int_LGL.ProcID.Game)
		{
			this.updateGameUse(url, run);
		}
		else
		{
			run();
		}
	},

	updateAvailable: function(game, doneCB, errorCB)
	{
		// Normalize URL
		var url = game;
		if (! url.match(/^\//) && !url.match(/https?:\/\//))
			url = '/' + url;

		var caps = require('NGCore/Client/Core/Capabilities').Capabilities;

		// If we are testing ourselves, we don't to md5 our url
		var name = "";
		if (caps.getUrl() != game)
		{
			var Util = require('NGCore/Client/Network/Util').Util;
			url = Util.NormalizeUrl(url);
			name = toMD5(url);
		}

		// Get device-specific manifest directory
		var buildPath = {"Android" : "android", "iPhone OS" : "ios", "flash" : ""};
		// Get Device capabilities platformOs
		var build = "/" + buildPath[caps.getPlatformOS()];

		var DownloadManifest = require('NGCore/Client/Network/DownloadManifest').DownloadManifest;
		var dm = new DownloadManifest();

		dm.isUpdated(url + build, name, false, doneCB, errorCB);
	},

// Utility (non-generated) functionality
	updateGameUse: function(game, doneCB)
	{
		var name = toMD5(game);
		var self = this;
		var KeyValueCache = require('NGCore/Client/Storage/KeyValue').KeyValueCache;
		this.mGameStore = KeyValueCache.global("Core.GameList");
		this.mActiveGameKey = "activeGames";

		// Get our list of games
		this.mGameStore.getItem(this.mActiveGameKey,
			function(error, value)
			{
				var list;
				if (value)
					list = JSON.parse(value);
				else
					list = [];

				var item;
				for (var i in list)
				{
					if (list[i].name == name)
					{
						item = list[i];
						break;
					}
				}

				if (!item)
				{
					item = {"name": name};
					list.push(item);
				}

				item.lastRun = (new Date()).getTime();
				item.url = game;

 				self.mGameStore.setItem(self.mActiveGameKey, JSON.stringify(list));

                LocalGameList.updateGameList(list);
 				doneCB();
			}, true
		);
	},
	
	getManifestName: function(config) {
		var manifestName = 'webgame.ngmanifest';

		if (config && config.manifestOverrides) {
			try {
				var overrides = config.manifestOverrides;

				for (var i = 0; i < overrides.length; i++) {
					var override = overrides[i];
					if (override && override.criteria) {
						// Clear any matched values...
						overridePropertyEvaluators.reset();

						var criteria = override.criteria;
						var overrideMatched = true;
						for (var key in criteria) {
							if (!criteria.hasOwnProperty(key)) continue;
							var value = criteria[key];

							var evaluator = overridePropertyEvaluators[key];
							if (typeof evaluator != 'function') {
								console.log("ERROR! Undefined criterion " + key + " in configuration.json");
								overrideMatched = false;
								break;
							}

							var criterionMatched = false;
							if (value instanceof Array) {
								for (vi = 0; vi < value.length; vi++) {
									criterionMatched |= evaluator.call(overridePropertyEvaluators, value[vi]);
									if (criterionMatched) break;
								}
							} else {
								criterionMatched = evaluator(value);
							}

							if (!criterionMatched) {
								overrideMatched = false;
								break;
							}
						}

						// At this point, the override has matched. Figure out its name and return the value.
						if (overrideMatched) {
							console.log("MATCHED Override: " + JSON.stringify(override));

							// Format the override manifest name:
							var format = override.manifest.slice(0);
							for (var fi = 1; fi < format.length; fi++) {
								var key = format[fi];
								switch (key) {
								case 'textureCompression':
									format[fi] = overridePropertyEvaluators.textureMatch;
									break;
								case 'platformOS':
									format[fi] = getCorrectedPlatformOS();
									break;
								default:
									// Look up the named property on Capabilities.
									var cap = Capabilities['get' + key.charAt(0).toUpperCase() + key.slice(1)]();
									format[fi] = cap.replace(' ', '_');
								}
							}

							return require('NGCore/Shared/Lib/sprintf').sprintf(format);
						} else {
							console.log("DID NOT MATCH Override: " + JSON.stringify(override));
						}
					}
				}
			} catch (e) {
				console.log("ERROR! Exception occurred in manifest overrides: " + e);
			}
		}

		return manifestName;
	},

// {{?Wg Generated Code}}
	
	// Enums.
	ProcID:
	{ 
		/** High privilege proc */
		Persist: -1,
		/** Low priv */
		Game: -2,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 342
	// Method launch = -1
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in _int_LGL._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in _int_LGL._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[342] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_launchSendGen: function( url, proc )
	{
		Proc.appendToCommandString( ":342,-1," + Base64.encode( url ) + "," + proc  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $launch: function( url, proc ) {}
	

// {{/Wg Generated Code}}

});

exports._int_LGL = _int_LGL;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Lib/md5'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Lib/md5'] || {}; $MODULE_REGISTRY['NGCore/Shared/Lib/md5'] = exports; /*
 * A JavaScript implementation of the RSA Data Security, Inc. MD5 Message
 * Digest Algorithm, as defined in RFC 1321.
 * Version 2.2 Copyright (C) Paul Johnston 1999 - 2009
 * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
 * Distributed under the BSD License
 * See http://pajhome.org.uk/crypt/md5 for more info.
 */

/*
 * Calculate the MD5 of a raw string
 */
function rstr_md5(s)
{
  return binl2rstr(binl_md5(rstr2binl(s), s.length * 8));
}

/*
 * Convert a raw string to a hex string
 */
function rstr2hex(input)
{
  var hex_tab = "0123456789abcdef";
  var output = "";
  var x;
  for(var i = 0; i < input.length; i++)
  {
    x = input.charCodeAt(i);
    output += hex_tab.charAt((x >>> 4) & 0x0F)
           +  hex_tab.charAt( x        & 0x0F);
  }
  return output;
}

/*
 * Encode a string as utf-8.
 * For efficiency, this assumes the input is valid utf-16.
 */
function str2rstr_utf8(input)
{
  var output = "";
  var i = -1;
  var x, y;

  while(++i < input.length)
  {
    /* Decode utf-16 surrogate pairs */
    x = input.charCodeAt(i);
    y = i + 1 < input.length ? input.charCodeAt(i + 1) : 0;
    if(0xD800 <= x && x <= 0xDBFF && 0xDC00 <= y && y <= 0xDFFF)
    {
      x = 0x10000 + ((x & 0x03FF) << 10) + (y & 0x03FF);
      i++;
    }

    /* Encode output as utf-8 */
    if(x <= 0x7F)
      output += String.fromCharCode(x);
    else if(x <= 0x7FF)
      output += String.fromCharCode(0xC0 | ((x >>> 6 ) & 0x1F),
                                    0x80 | ( x         & 0x3F));
    else if(x <= 0xFFFF)
      output += String.fromCharCode(0xE0 | ((x >>> 12) & 0x0F),
                                    0x80 | ((x >>> 6 ) & 0x3F),
                                    0x80 | ( x         & 0x3F));
    else if(x <= 0x1FFFFF)
      output += String.fromCharCode(0xF0 | ((x >>> 18) & 0x07),
                                    0x80 | ((x >>> 12) & 0x3F),
                                    0x80 | ((x >>> 6 ) & 0x3F),
                                    0x80 | ( x         & 0x3F));
  }
  return output;
}

/*
 * Convert a raw string to an array of little-endian words
 * Characters >255 have their high-byte silently ignored.
 */
function rstr2binl(input)
{
  var output = Array(input.length >> 2);
  for(var i = 0; i < output.length; i++)
    output[i] = 0;
  for(var i = 0; i < input.length * 8; i += 8)
    output[i>>5] |= (input.charCodeAt(i / 8) & 0xFF) << (i%32);
  return output;
}

/*
 * Convert an array of little-endian words to a string
 */
function binl2rstr(input)
{
  var output = "";
  for(var i = 0; i < input.length * 32; i += 8)
    output += String.fromCharCode((input[i>>5] >>> (i % 32)) & 0xFF);
  return output;
}

/*
 * Calculate the MD5 of an array of little-endian words, and a bit length.
 */
function binl_md5(x, len)
{
  /* append padding */
  x[len >> 5] |= 0x80 << ((len) % 32);
  x[(((len + 64) >>> 9) << 4) + 14] = len;

  var a =  1732584193;
  var b = -271733879;
  var c = -1732584194;
  var d =  271733878;

  for(var i = 0; i < x.length; i += 16)
  {
    var olda = a;
    var oldb = b;
    var oldc = c;
    var oldd = d;

    a = md5_ff(a, b, c, d, x[i+ 0], 7 , -680876936);
    d = md5_ff(d, a, b, c, x[i+ 1], 12, -389564586);
    c = md5_ff(c, d, a, b, x[i+ 2], 17,  606105819);
    b = md5_ff(b, c, d, a, x[i+ 3], 22, -1044525330);
    a = md5_ff(a, b, c, d, x[i+ 4], 7 , -176418897);
    d = md5_ff(d, a, b, c, x[i+ 5], 12,  1200080426);
    c = md5_ff(c, d, a, b, x[i+ 6], 17, -1473231341);
    b = md5_ff(b, c, d, a, x[i+ 7], 22, -45705983);
    a = md5_ff(a, b, c, d, x[i+ 8], 7 ,  1770035416);
    d = md5_ff(d, a, b, c, x[i+ 9], 12, -1958414417);
    c = md5_ff(c, d, a, b, x[i+10], 17, -42063);
    b = md5_ff(b, c, d, a, x[i+11], 22, -1990404162);
    a = md5_ff(a, b, c, d, x[i+12], 7 ,  1804603682);
    d = md5_ff(d, a, b, c, x[i+13], 12, -40341101);
    c = md5_ff(c, d, a, b, x[i+14], 17, -1502002290);
    b = md5_ff(b, c, d, a, x[i+15], 22,  1236535329);

    a = md5_gg(a, b, c, d, x[i+ 1], 5 , -165796510);
    d = md5_gg(d, a, b, c, x[i+ 6], 9 , -1069501632);
    c = md5_gg(c, d, a, b, x[i+11], 14,  643717713);
    b = md5_gg(b, c, d, a, x[i+ 0], 20, -373897302);
    a = md5_gg(a, b, c, d, x[i+ 5], 5 , -701558691);
    d = md5_gg(d, a, b, c, x[i+10], 9 ,  38016083);
    c = md5_gg(c, d, a, b, x[i+15], 14, -660478335);
    b = md5_gg(b, c, d, a, x[i+ 4], 20, -405537848);
    a = md5_gg(a, b, c, d, x[i+ 9], 5 ,  568446438);
    d = md5_gg(d, a, b, c, x[i+14], 9 , -1019803690);
    c = md5_gg(c, d, a, b, x[i+ 3], 14, -187363961);
    b = md5_gg(b, c, d, a, x[i+ 8], 20,  1163531501);
    a = md5_gg(a, b, c, d, x[i+13], 5 , -1444681467);
    d = md5_gg(d, a, b, c, x[i+ 2], 9 , -51403784);
    c = md5_gg(c, d, a, b, x[i+ 7], 14,  1735328473);
    b = md5_gg(b, c, d, a, x[i+12], 20, -1926607734);

    a = md5_hh(a, b, c, d, x[i+ 5], 4 , -378558);
    d = md5_hh(d, a, b, c, x[i+ 8], 11, -2022574463);
    c = md5_hh(c, d, a, b, x[i+11], 16,  1839030562);
    b = md5_hh(b, c, d, a, x[i+14], 23, -35309556);
    a = md5_hh(a, b, c, d, x[i+ 1], 4 , -1530992060);
    d = md5_hh(d, a, b, c, x[i+ 4], 11,  1272893353);
    c = md5_hh(c, d, a, b, x[i+ 7], 16, -155497632);
    b = md5_hh(b, c, d, a, x[i+10], 23, -1094730640);
    a = md5_hh(a, b, c, d, x[i+13], 4 ,  681279174);
    d = md5_hh(d, a, b, c, x[i+ 0], 11, -358537222);
    c = md5_hh(c, d, a, b, x[i+ 3], 16, -722521979);
    b = md5_hh(b, c, d, a, x[i+ 6], 23,  76029189);
    a = md5_hh(a, b, c, d, x[i+ 9], 4 , -640364487);
    d = md5_hh(d, a, b, c, x[i+12], 11, -421815835);
    c = md5_hh(c, d, a, b, x[i+15], 16,  530742520);
    b = md5_hh(b, c, d, a, x[i+ 2], 23, -995338651);

    a = md5_ii(a, b, c, d, x[i+ 0], 6 , -198630844);
    d = md5_ii(d, a, b, c, x[i+ 7], 10,  1126891415);
    c = md5_ii(c, d, a, b, x[i+14], 15, -1416354905);
    b = md5_ii(b, c, d, a, x[i+ 5], 21, -57434055);
    a = md5_ii(a, b, c, d, x[i+12], 6 ,  1700485571);
    d = md5_ii(d, a, b, c, x[i+ 3], 10, -1894986606);
    c = md5_ii(c, d, a, b, x[i+10], 15, -1051523);
    b = md5_ii(b, c, d, a, x[i+ 1], 21, -2054922799);
    a = md5_ii(a, b, c, d, x[i+ 8], 6 ,  1873313359);
    d = md5_ii(d, a, b, c, x[i+15], 10, -30611744);
    c = md5_ii(c, d, a, b, x[i+ 6], 15, -1560198380);
    b = md5_ii(b, c, d, a, x[i+13], 21,  1309151649);
    a = md5_ii(a, b, c, d, x[i+ 4], 6 , -145523070);
    d = md5_ii(d, a, b, c, x[i+11], 10, -1120210379);
    c = md5_ii(c, d, a, b, x[i+ 2], 15,  718787259);
    b = md5_ii(b, c, d, a, x[i+ 9], 21, -343485551);

    a = safe_add(a, olda);
    b = safe_add(b, oldb);
    c = safe_add(c, oldc);
    d = safe_add(d, oldd);
  }
  return Array(a, b, c, d);
}

/*
 * These functions implement the four basic operations the algorithm uses.
 */
function md5_cmn(q, a, b, x, s, t)
{
  return safe_add(bit_rol(safe_add(safe_add(a, q), safe_add(x, t)), s),b);
}
function md5_ff(a, b, c, d, x, s, t)
{
  return md5_cmn((b & c) | ((~b) & d), a, b, x, s, t);
}
function md5_gg(a, b, c, d, x, s, t)
{
  return md5_cmn((b & d) | (c & (~d)), a, b, x, s, t);
}
function md5_hh(a, b, c, d, x, s, t)
{
  return md5_cmn(b ^ c ^ d, a, b, x, s, t);
}
function md5_ii(a, b, c, d, x, s, t)
{
  return md5_cmn(c ^ (b | (~d)), a, b, x, s, t);
}

/*
 * Add integers, wrapping at 2^32. This uses 16-bit operations internally
 * to work around bugs in some JS interpreters.
 */
function safe_add(x, y)
{
  var lsw = (x & 0xFFFF) + (y & 0xFFFF);
  var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
  return (msw << 16) | (lsw & 0xFFFF);
}

/*
 * Bitwise rotate a 32-bit number to the left.
 */
function bit_rol(num, cnt)
{
  return (num << cnt) | (num >>> (32 - cnt));
}

var toMD5 = function(s) { return rstr2hex(rstr_md5(str2rstr_utf8(s))); }

/*
 * Perform a simple self-test to see if the VM is working
 */
function md5_vm_test()
{
  return toMD5("abc").toLowerCase() == "900150983cd24fb0d6963f7d28e17f72";
}

exports.toMD5 = toMD5;
exports.testMD5 = md5_vm_test;; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Storage/KeyValue'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Storage/KeyValue'] || {}; $MODULE_REGISTRY['NGCore/Client/Storage/KeyValue'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class KeyValue
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

function KeyValueCache() {
};
exports.KeyValueCache = KeyValueCache;
/** @private */
KeyValueCache.lruMeanCacheSize = 100;
/** @private */
KeyValueCache.instanceMap = {};
//TODO: rename this later
var StorageGlobalScopes = [];

KeyValueCache.optimizeCaches = function() 
{
	for (var storeKey in KeyValueCache.instanceMap) {
		if(KeyValueCache.instanceMap.hasOwnProperty(storeKey)) {
			KeyValueCache.instanceMap[storeKey].optimize();
		}
	}
};

KeyValueCache.lowMemoryWarning = function() 
{
	for (var storeKey in KeyValueCache.instanceMap) {
		if(KeyValueCache.instanceMap.hasOwnProperty(storeKey)) {
			var instance = KeyValueCache.instanceMap[storeKey];
			instance.data = {};

			//Purge entries in callbacks
			var newCallbacks = {};
			newCallbacks.uidGenerator = instance.callbacks.uidGenerator;
			for(var cbId in instance.callbacks)
			{
				if(instance.callbacks.hasOwnProperty(cbId)) {
					if(instance.callbacks[cbId]) {
						newCallbacks = instance.callbacks[cbId];
					}
				}
			}
			instance.callbacks = newCallbacks;
		}
	}
};

KeyValueCache.init = function()
{
	KeyValueCache.local = new Storage.KeyValue();
	KeyValueCache.local.registerForKey("local");
};

/**
 * @static Scopes this <code>KeyValueCache</code> object as global. A globally scoped KeyValueCache object can be used by multiple applications for the same data. 
 * @param {String} globalKey The store key for the <code>KeyValueCache</code> object.
 */
KeyValueCache.global = function(globalKey)
{
	if(StorageGlobalScopes[globalKey])
	{
		return StorageGlobalScopes[globalKey];
	}

	//Miss Global Table Cache.
	var scope = new Storage.KeyValue();
	scope.registerForKey(globalKey);
	StorageGlobalScopes[globalKey] = scope;
	return scope;
};

exports.KeyValue = Core.Class.subclass(
/** @lends Storage.KeyValue.prototype */
{
	classname: "KeyValue",
	/**
	 * @class The <code>KeyValue</code> class constructs objects that allow you to manage application key/value pairs in a datastore.
	 * <div class="ul">
	 * <li>Call <code>KeyValueCache.local()</code> to access the <code>local</code> datastore for your application.</li>
	 * <li>Call <code>KeyValueCache.global(globalKey)</code> to access a globally scoped datastore. Multiple applications can use a globally scoped
	 * datastore for the same data. The <code>globalKey</code> parameter is a string that uniquely identifies the datastore.</li>
	 * </div>
	 *
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		/** @private */
		this.initialized = false;
		/** @private */
		this.origin = null;
		/** @private */
		this.callbacks = {};
		/** @private */
		this.callbacks.uidGenerator = 0;
		/** @private */
		this.local = false;
		/** @private */
		this.lruCacheShrinkCounter = 0;
	
		/** @private */
		this.data = {};
		/** @private */
		this.usage = {};
		
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 */
	destroy: function()
	{
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},
    /*
	 * @private
	 * Call <code>registerForKey()</code> to access a datastore identified by the value of the <code>storeKey</code> parameter.
	 * @param {String} storeKey The unique identifier of the datastore.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	registerForKey: function(storeKey) 
	{
		this.origin = storeKey;
		KeyValueCache.instanceMap[storeKey] = this;

		//Push this instance across the native bridge
		this._registerCommandSendGen(this.origin,KeyValueCache.lruMeanCacheSize);
		
		return this;
	},
	/**
	 * Pass the value associated with the key to the callback function.
	 * @param {String} key The key that is associated with the value to pass to the callback function.
	 * @param {Function} callbackFunc The callback function that uses the value associated with the key.
	 * @param {Boolean} [ignoreCache=false] Set <code>ignoreCache</code> to <code>true</code> to force a read from storage.
	 * @example KeyValue.getItem(SomeKey, function(err){...})
     * @status iOS, Android, Test, iOSTested, AndroidTested     
	 */
	getItem: function(key,callbackFunc,ignoreCache /*defaults to false*/)
	{
		if(!ignoreCache)
		{
			if(this.data[key]) {
				callbackFunc(null,this.data[key],key);
				this.usage[key]++;
				return;
			}
			else
			{
				NgLogD("Value not found in cache for..falling back to native");
			}
		}

		//Generate unused callbackEntry
		var callbackId = this.callbacks.uidGenerator++;

		if(!!!callbackFunc) {
			callbackFunc = function(){};
		}
		this.callbacks[callbackId] = callbackFunc;

		this._getItemSendGen(this.origin,callbackId,key);
	},
	
	/**
	 * Associate a value with a key.
	 * @param {String} key The key to associate with the value.
	 * @param {String} value The value to associate with the key.
	 * @param {Function} [callbackFunc] A callback function with an error parameter. The error parameter is null when the <code>setItem()</code> function completes successfully.
	 * @example KeyValue.setItem(someKey, someValue, function(err){...})
     * @status iOS, Android, Test, iOSTested, AndroidTested          
	 */
	setItem: function(key,value,callbackFunc)
	{
		var value = value;
		this.data[key] = value;

		var callbackId = this.callbacks.uidGenerator++;
		if(!callbackFunc) {
			callbackFunc = function(){};
		}
		this.callbacks[callbackId] = callbackFunc;

		this._setItemSendGen(this.origin,callbackId,key,value);
	},
	
	/**
	 * Remove the value that is associated with a key.
	 * @param {String} key The key that is associated with the value to remove.
	 * @param {Function} [callbackFunc] A callback function with an error parameter. The error parameter is null when the <code>removeItem()</code> function completes successfully.
	 * @example KeyValue.removeItem(someKey, function(err){...})
     * @status iOS, Android, Test, iOSTested, AndroidTested     
	 */
	removeItem: function(key,callbackFunc)
	{
		var callbackId = this.callbacks.uidGenerator++;
		if(!!!callbackFunc) {
			callbackFunc = function(){};
		}
		this.callbacks[callbackId] = callbackFunc;

		this._removeItemSendGen(this.origin,callbackId,key);
	},

	/**
	 *  @private
	 * 	clear all key/value pairs stored within this store
	 *  @param {callbackFunc} The callback function to be called
     *  @status iOS, Android, Test, iOSTested, AndroidTested          
	 */
	clear: function(callbackFunc)
	{
		var callbackId = this.callbacks.uidGenerator++;
		if(!!!callbackFunc) {
			callbackFunc = function(){};
		}
		this.callbacks[callbackId] = callbackFunc;

		this._clearSendGen(this.origin,callbackId);
	},
    /*
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	enforceLRUCacheSize: function()
	{
		NgLogD("Enforcing KeyValue Cache Size");
		var tmp = [];
		for (var k in this.data) {
			if (this.data.hasOwnProperty(k)) {
				tmp.push(k);
			}
		}
		var usage = this.usage;
		tmp.sort(function(a,b) {
			var p1 = usage[a];
			if (!p1) {
				p1 = 0;
			}

			var p2 = usage[b];
			if (!p2) {
				p2 = 0;
			}

			if (p1 == p2) { return 0; }
			return p1 < p2 ? 1 : -1;
		});

		var oldData = this.data;
		this.data = {};
		//Copy over the lruMeanCache(number) most used entries
		var stopPoint = KeyValueCache.lruMeanCacheSize;
		for (var i = 0; i < stopPoint && i < tmp.length; i++)
		{
			if(!oldData[tmp[i]]) {
				//Case cache didn't contain that key at this point in time
				stopPoint++;
			}
			else {
				this.data[tmp[i]] = oldData[tmp[i]];
			}
		}
	},
	
	_getInstanceRecv : function(cmd)
	{
		var msg = {};
		if(!this._getInstanceRecvGen(cmd, msg))
			return;
			
		var storeKey = msg["storeKey"];

		var instance = KeyValueCache.instanceMap[storeKey];
		//NgLogD("Storage.getInstanceForCommand Found instance for key [" + storeKey + "]: " + instance + " (" + command + ")");
		return instance;
	},
	
	_registerCommandCbRecv : function(cmd)
	{		
		var msg = {};
		if(!this._registerCommandCbRecvGen(cmd, msg))
			return;
		
		//NgLogD("Storage registerCallback: "+command+"\n");
		if(msg["error"]){
			console.log("Storage: Error registering for KeyValue location '"+msg["error"]+"'");
			if(!this.initialized) {
				delete StorageGlobalScopes[msg["originalStoreKey"]];
			}
			return;
		}

		if(this.origin == "local") {
			this.local = true;
			StorageGlobalScopes[this.origin] = this;
		}

		this.origin = msg["storeKey"];
		this.initialized = true;
		
		for(var i=0; i < msg.preloadDataCount; ++i)
		{
			var preload = {};
			if(!this._preloadDataRecvGen(cmd, preload))
				return;
			
			this.data[preload.key] = preload.value;
		}
	},
	
	_getItemCommandCbRecv : function(cmd)
	{
		var msg = {};
		if(!this._getItemCommandCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg["callbackId"];
		var error = msg["error"];
		var key = msg["key"];
		var value = msg["value"];
		if (error) {
			value = null;
		}

		this.data[key] = value;
		if(!this.usage[key]) {
			this.usage[key] = 1;
		} else {
			this.usage[key]++;
		}

		cb = this.callbacks[cbId];
		if(typeof cb == "function") {
			cb(error,value,key);
			this.callbacks[cbId] = null;
		}

		if(((this.lruCacheShrinkCounter++) % KeyValueCache.lruMeanCacheSize) === 0) {
			this.enforceLRUCacheSize();
		}
		return this;
	},
	
	_setItemCommandCbRecv : function(cmd)
	{
		var msg = {};
		if(!this._setItemCommandCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg["callbackId"];
		var error = msg["error"];
		var key = msg["key"];

		if(!this.usage[key]) {
			this.usage[key] = 1;
		} else {
			this.usage[key]++;
		}
		
		//NgLogD("Storage.setItemCommand Found instance for key [" + key + "]: " + " (" + cbId + ")");

		cb = this.callbacks[cbId];
		if(typeof cb == "function") {
			//NgLogD("Storage.setItemCommand Found callback");
			cb(error,key);
			this.callbacks[cbId] = null;
		}
		if(((this.lruCacheShrinkCounter++) % KeyValueCache.lruMeanCacheSize) === 0) {
			this.enforceLRUCacheSize();
		}
	},
	
	_removeItemCbRecv : function(cmd)
	{
		var msg = {};
		if(!this._removeItemCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg["callbackId"];
		var error = msg["error"];
		var key = msg["key"];
		delete this.usage[key];
		delete this.data[key];

		cb = this.callbacks[cbId];
		if(typeof cb == "function") {
			cb(error,key);
			this.callbacks[cbId] = null;
		}
	},
	
	_clearCommandCbRecv : function(cmd)
	{
		var msg ={};
		if(!this._clearCommandCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg["callbackId"];
		var error = msg["error"];

		this.data = {};
		this.usage = {};

		cb = this.callbacks[cbId];
		if(typeof cb == "function") {
			cb(error,this.origin);
			this.callbacks[cbId] = null;
		}

	},

	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration for response types.
	 * @namespace
	 */
	Responses:
	{ 
		/** Register Storage */
		Register: 0,
		/** Get Item */
		GetItem: 1,
		/** Set Item */
		SetItem: 2,
		/** Remove Item */
		RemoveItem: 3,
		/** Clear All */
		Clear: 4,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 339
	// Method create = -1
	// Method destroy = 2
	// Method registerCommand = 3
	// Method getItem = 4
	// Method setItem = 5
	// Method removeItem = 6
	// Method clear = 7
	// Method getInstance = 8
	// Method registerCommandCb = 9
	// Method preloadData = 10
	// Method getItemCommandCb = 11
	// Method setItemCommandCb = 12
	// Method removeItemCb = 13
	// Method clearCommandCb = 14
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 8:
					instance._getInstanceRecv( cmd );
					break;
				case 9:
					instance._registerCommandCbRecv( cmd );
					break;
				case 10:
					instance._preloadDataRecv( cmd );
					break;
				case 11:
					instance._getItemCommandCbRecv( cmd );
					break;
				case 12:
					instance._setItemCommandCbRecv( cmd );
					break;
				case 13:
					instance._removeItemCbRecv( cmd );
					break;
				case 14:
					instance._clearCommandCbRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in KeyValue._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in KeyValue._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[339] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_getInstanceRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.getInstance from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.getInstance from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.getInstance from command: " + cmd );
			return false;
		}
		
		obj[ "key" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "key" ] === undefined )
		{
			NgLogE("Could not parse key in KeyValue.getInstance from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_registerCommandCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length < 5 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "originalStoreKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "originalStoreKey" ] === undefined )
		{
			NgLogE("Could not parse originalStoreKey in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "preloadDataCount" ] = Core.Proc.parseInt( cmd[ 4 ] );
		if( obj[ "preloadDataCount" ] === undefined )
		{
			NgLogE("Could not parse preloadDataCount in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		cmd.splice(0, 5);
		return true;
	},
	
	/** @private */
	_preloadDataRecvGen: function( cmd, obj )
	{ 
		if( cmd.length < 2 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.preloadData from command: " + cmd );
			return false;
		}
		
		obj[ "key" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "key" ] === undefined )
		{
			NgLogE("Could not parse key in KeyValue.preloadData from command: " + cmd );
			return false;
		}
		
		obj[ "value" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "value" ] === undefined )
		{
			NgLogE("Could not parse value in KeyValue.preloadData from command: " + cmd );
			return false;
		}
		
		cmd.splice(0, 2);
		return true;
	},
	
	/** @private */
	_getItemCommandCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 6 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "key" ] = Core.Proc.parseString( cmd[ 4 ] );
		if( obj[ "key" ] === undefined )
		{
			NgLogE("Could not parse key in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "value" ] = Core.Proc.parseString( cmd[ 5 ] );
		if( obj[ "value" ] === undefined )
		{
			NgLogE("Could not parse value in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_setItemCommandCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 6 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "key" ] = Core.Proc.parseString( cmd[ 4 ] );
		if( obj[ "key" ] === undefined )
		{
			NgLogE("Could not parse key in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "value" ] = Core.Proc.parseString( cmd[ 5 ] );
		if( obj[ "value" ] === undefined )
		{
			NgLogE("Could not parse value in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_removeItemCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 5 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		obj[ "key" ] = Core.Proc.parseString( cmd[ 4 ] );
		if( obj[ "key" ] === undefined )
		{
			NgLogE("Could not parse key in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_clearCommandCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 4 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.clearCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.clearCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.clearCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in KeyValue.clearCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in KeyValue.clearCommandCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":339,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":339,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_registerCommandSendGen: function( storeKey, lruMeanCacheSize )
	{
		Core.Proc.appendToCommandString( ":339,3," + this.__objectRegistryId + "," + Core.Base64.encode( storeKey ) + "," + lruMeanCacheSize  );
	},
	
	/** @private */
	_getItemSendGen: function( storeKey, callbackId, key )
	{
		Core.Proc.appendToCommandString( ":339,4," + this.__objectRegistryId + "," + Core.Base64.encode( storeKey ) + "," + callbackId + "," + Core.Base64.encode( key )  );
	},
	
	/** @private */
	_setItemSendGen: function( storeKey, callbackId, key, value )
	{
		Core.Proc.appendToCommandString( ":339,5," + this.__objectRegistryId + "," + Core.Base64.encode( storeKey ) + "," + callbackId + "," + Core.Base64.encode( key ) + "," + Core.Base64.encode( value )  );
	},
	
	/** @private */
	_removeItemSendGen: function( storeKey, callbackId, key )
	{
		Core.Proc.appendToCommandString( ":339,6," + this.__objectRegistryId + "," + Core.Base64.encode( storeKey ) + "," + callbackId + "," + Core.Base64.encode( key )  );
	},
	
	/** @private */
	_clearSendGen: function( storeKey, callbackId )
	{
		Core.Proc.appendToCommandString( ":339,7," + this.__objectRegistryId + "," + Core.Base64.encode( storeKey ) + "," + callbackId  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// registerCommand: function( storeKey, lruMeanCacheSize ) {}
	
	// getItem: function( storeKey, callbackId, key ) {}
	
	// setItem: function( storeKey, callbackId, key, value ) {}
	
	// removeItem: function( storeKey, callbackId, key ) {}
	
	// clear: function( storeKey, callbackId ) {}
	
	// _getInstanceRecv: function( cmd ) {}
	// _registerCommandCbRecv: function( cmd ) {}
	// _preloadDataRecv: function( cmd ) {}
	// _getItemCommandCbRecv: function( cmd ) {}
	// _setItemCommandCbRecv: function( cmd ) {}
	// _removeItemCbRecv: function( cmd ) {}
	// _clearCommandCbRecv: function( cmd ) {}

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Lib/sprintf'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Lib/sprintf'] || {}; $MODULE_REGISTRY['NGCore/Shared/Lib/sprintf'] = exports; /**
sprintf() for JavaScript 0.6

Copyright (c) Alexandru Marasteanu <alexaholic [at) gmail (dot] com>
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of sprintf() for JavaScript nor the
      names of its contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL Alexandru Marasteanu BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


Changelog:
2007.04.03 - 0.1:
 - initial release
2007.09.11 - 0.2:
 - feature: added argument swapping
2007.09.17 - 0.3:
 - bug fix: no longer throws exception on empty paramenters (Hans Pufal)
2007.10.21 - 0.4:
 - unit test and patch (David Baird)
2010.05.09 - 0.5:
 - bug fix: 0 is now preceeded with a + sign
 - bug fix: the sign was not at the right position on padded results (Kamal Abdali)
 - switched from GPL to BSD license
2010.05.22 - 0.6:
 - reverted to 0.4 and fixed the bug regarding the sign of the number 0
 Note:
 Thanks to Raphael Pigulla <raph (at] n3rd [dot) org> (http://www.n3rd.org/)
 who warned me about a bug in 0.5, I discovered that the last update was
 a regress. I appologize for that.
**/



exports.sprintf = function() {
	str_repeat = function(i, m) {
		for (var o = []; m > 0; o[--m] = i);
		return o.join('');
	};

	var params = new Array();
	var outputArray = false;
	var paramsConsumed = 1;
	if (typeof(arguments[0]) == 'object' && arguments[0].length) {
		outputArray = true;
		for (var i = 0; i < arguments[0].length; ++i) {
			params[i] = arguments[0][i];
		}
	} else {
		for (var i = 0; i < arguments.length; ++i) {
			params[i] = arguments[i];
		}
	}

	var i = 0, a, f = params[i++], o = [], m, p, c, x, s = '';
	while (f) {
		if (m = /^[^\x25]+/.exec(f)) {
			o.push(m[0]);
		}
		else if (m = /^\x25{2}/.exec(f)) {
			o.push('%');
		}
		else if (m = /^\x25(?:(\d+)\$)?(\+)?(0|'[^$])?(-)?(\d+)?(?:\.(\d+))?([b-fosuxX])/.exec(f)) {
			if (((a = params[m[1] || i++]) == null) || (a == undefined)) {
				throw('Too few arguments.');
			}
			if (/[^s]/.test(m[7]) && (typeof(a) != 'number')) {
				throw('Expecting number but found ' + typeof(a));
			}
			switch (m[7]) {
				case 'b': a = a.toString(2); break;
				case 'c': a = String.fromCharCode(a); break;
				case 'd': a = parseInt(a); break;
				case 'e': a = m[6] ? a.toExponential(m[6]) : a.toExponential(); break;
				case 'f': a = m[6] ? parseFloat(a).toFixed(m[6]) : parseFloat(a); break;
				case 'o': a = a.toString(8); break;
				case 's': a = ((a = String(a)) && m[6] ? a.substring(0, m[6]) : a); break;
				case 'u': a = Math.abs(a); break;
				case 'x': a = a.toString(16); break;
				case 'X': a = a.toString(16).toUpperCase(); break;
			}
			a = (/[def]/.test(m[7]) && m[2] && a >= 0 ? '+'+ a : a);
			c = m[3] ? m[3] == '0' ? '0' : m[3].charAt(1) : ' ';
			x = m[5] - String(a).length - s.length;
			p = m[5] ? str_repeat(c, x) : '';
			o.push(s + (m[4] ? a + p : p + a));
			if (outputArray) ++paramsConsumed;
		}
		else {
			throw('Huh ?!');
		}
		f = f.substring(m[0].length);
	}
	if (outputArray && paramsConsumed > 0) {
		arguments[0].splice(0, paramsConsumed);
	}
	return o.join('');
};

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/LocationEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/LocationEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/LocationEmitter'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class LocationEmitter
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

exports.LocationEmitter = Core.MessageEmitter.singleton(
/** @lends Device.LocationEmitter.prototype */
{
	classname: 'LocationEmitter',

	Accuracy:
	{
		LOW:    0, // less power consumption. equivalent to "3km"  in iOS
		MEDIUM: 1, // equivalent to "100m" in iOS
		HIGH:   2  // most accurate, high power consumption. equivalent to "Best" in iOS
	},

	Elements:
	{
		LATITUDE:  1,
		LONGITUDE: 2,
		ALTITUDE:  4,
		HEADING:   8  // equivalent to "bearing" in Android
	},

	/**
	 * @class The <code>LocationEmitter</code> class constructs a singleton object that emits <a href="Device.LocationEmitter.Location.html">Location</a> objects.<br><br>
     * @constructs The default constructor. 
 	 * @see Device.LocationEmitter.Location
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._lastLocation = undefined;
		this._forceListeners = [];
	},

	/**
	 * @param {LocationEmitter#Accuracy} Accuracy accuracy of updates. The default value is HIGH.
	 * @param {Number} elements OR-ed <code>LocationEmitter.Elements</code>. Example: LATITUDE | LONGITUDE. The default value is LATITUDE | LONGITUDE | ALTITUDE | HEADING (i.e. listens to all elements).
	 * @status
	 */
	setProperties: function(accuracy, elements)
	{
		if (! accuracy) accuracy = this.Accuracy.HIGH;
		if (! elements) elements = this.Elements.LATITUDE | this.Elements.LONGITUDE | this.Elements.ALTITUDE | this.Elements.HEADING;
		this.accuracy = accuracy;
		this.elements = elements;
		this._setPropertiesSendGen(accuracy,elements);
	},

	/**
	 * Add a <code>MessageListener</code> to this emitter. When an application calls <code>emit()</code> 
	 * or <code>chain()</code> 
	 * on this emitter, a callback function passed as a parameter is called on the specified listener.
	 * The parameters for the callback function are identical to parameters for <code>emit()</code> or
	 * <code>chain()</code>.
	 * <br><br>
	 * <b>Note:</b> Each listener can only listen to an emitter one time.<br><br>
	 * The following code examples illustrate different call styles for <code>addListener()</code>.
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onCallback);
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onEvent, 200);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to add.
	 * @param {Function} func The callback function.
	 * @param {Number} [priority=0] The priority for this <code>MessageListener</code>.
	 * @throws {MessageEmitter.addListener: listener is already listening} Calling <code>addListener()</code> multiple times on the same emitter
	 * with the same listener.
	 * @throws {MessageEmitter.addListener: listener must be instances of MessageListener} Listener is not an instance of <code>MessageListener</code>.
	 * @see Device.LocationEmitter#removeListener,
	 * @see Core.MessageEmitter#emit,
	 * @see Core.MessageEmitter#chain
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	addListener: function($super, listener, func, forceStart, priority) {
		if(forceStart == undefined)
		{
			this._startUpdatingSendGen(true);
			this._forceListeners.push(listener);
		}
		else
		{
			this._startUpdatingSendGen(forceStart);
			if(forceStart == true)
				this._forceListeners.push(listener);
		}

		$super(listener, func, priority);
	},
	
	/**
	 * Remove a <code>MessageListener</code> from this emitter.<br><br> 
	 * The following code examples illustrate different call styles for <code>removeListener()</code>.
	 * @example
	 * emitter.removeListener(myListener, myListener.onCallback);
	 * @example
	 * emitter.removeListener(myListener);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to remove.
	 * @returns {Boolean} Returns <code>true</code> if the registered listener was removed. Returns <code>false</code> if the registered listener is not found 
	 * or is not registered with this emitter.
	 * @throws {MessageEmitter.removeListener: listener is not listening} Specified listener is not currently registered
	 * with this emitter.
	 * @see Device.LocationEmitter#addListener
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	removeListener: function($super, listener) {
		$super(listener);

		var index = this._forceListeners.indexOf(listener);
		if(index != -1)
		{
			this._forceListeners.splice(index,1);
			if(this._forceListeners.length == 0)
				this._stopUpdatingSendGen();
		}
	},
    
	/**
	 * Retrieve the last location returned by this <code>LocationEmitter</code>.
	 * @returns {Device.LocationEmitter.Location} The last location returned.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getLastLocation: function()
	{
		if(this._lastLocation == undefined || !this._lastLocation.getPosition()) return undefined;
		
		return this._lastLocation;
	},
	
    _locationUpdatedRecv: function( cmd ) {
		var msg = {};
		if (!this._locationUpdatedRecvGen(cmd, msg))
		    return;
		
		if (((this.elements & this.Elements.LATITUDE) == 0)  &&
			((this.elements & this.Elements.LONGITUDE) == 0) &&
			((this.Elements & this.Elements.ALTITUDE) == 0))
			return;

		this._lastLocation = new this.Location(
			new Core.Point(msg["latitude"], msg["longitude"]),
			msg["altitude"],
			undefined,
			msg["accuracy"],
			msg["timestamp"]);

		this.emit(this._lastLocation);
    },
	
	_headingUpdatedRecv: function( cmd ) 
	{
		var msg = {};
		if (!this._headingUpdatedRecvGen(cmd, msg))
			return;
			
		if ((this.elements & this.Elements.HEADING) == 0)
			return;

		this._lastLocation = new this.Location(
			this._lastLocation ? this._lastLocation.getPosition() : undefined,
			this._lastLocation ? this._lastLocation.getAltitude() : undefined,
			msg['magneticHeading'],
			this._lastLocation ? this._lastLocation.getAccuracy() : undefined,
			msg['timestamp']);
		
		if(msg['magneticHeading']) {
			this.emit(this._lastLocation);
		}
	},
	
	Location: Core.Class.subclass(
	/** @lends Device.LocationEmitter.Location.prototype */
	{
		classname: 'Location',
		
		/**
		 * @class <code>Location</code> constructs objects that encapsulate the location of a device.
		 * <code>Location</code> objects contain spatial components, like position and heading information, and a timestamp that indicates when a location is measured.
		 * 
		 * @constructs The default constructor. 
		 * @param {Core.Point} position The latitude / longitude of the device.
		 * @param {Number} altitude The altitude of the device.
		 * @param {Number} heading The heading of the device.
		 * @param {Number} accuracy The accuracy of the measurement.
		 * @param {Number} timestamp The timestamp when the location was measured.
		 * @augments Core.Class
		 */
		initialize: function(position, altitude, heading, accuracy, timestamp)
		{
			this._position = position;
			this._altitude = altitude;
			this._accuracy = accuracy;
			this._heading = heading;
			this._timestamp = timestamp;
		},
		
		/**
		 * Return the position of this <code>Location</code> as latitude / longitude.
		 * @returns {Core.Point} The current latitude / longitude.
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getPosition: function()
		{
			return this._position;
		},
		
		/**
		 * Return the altitude of this <code>Location</code> in feet (ft).
		 * @returns {Number} The current altitude.
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getAltitude: function()
		{
			return this._altitude;
		},
		
		/**
		 * Return the heading of this <code>Location</code> in degrees east of north.
		 * @returns {Number} The current heading.
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getHeading: function()
		{
			return this._heading;
		},
		
		/**
		 * Return the accuracy of the measurement for this <code>Location</code>.
		 * @returns {Number} The current location accuracy.
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getAccuracy: function()
		{
			return this._accuracy;
		},
		
		/**
		 * Return the timestamp when this measurement was taken.
		 * Expressed in milliseconds since Epoch (Unix time).
		 * @returns {Number} The timestamp of the measurement.
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getTimestamp: function()
		{
			return this._timestamp;
		},
	}),
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 333
	// Method create = -1
	// Method destroy = 2
	// Method startUpdatingLocation = 3
	// Method stopUpdatingLocation = 4
	// Method locationUpdated = 5
	// Method startUpdatingHeading = 6
	// Method stopUpdatingHeading = 7
	// Method headingUpdated = 8
	// Method setProperties = 9
	// Method startUpdating = 10
	// Method stopUpdating = 11
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 5:
					instance._locationUpdatedRecv( cmd );
					break;
				case 8:
					instance._headingUpdatedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in LocationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in LocationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[333] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_locationUpdatedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 5 )
		{
			NgLogE("Could not parse due to wrong argument count in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "timestamp" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "timestamp" ] === undefined )
		{
			NgLogE("Could not parse timestamp in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "latitude" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "latitude" ] === undefined )
		{
			NgLogE("Could not parse latitude in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "longitude" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "longitude" ] === undefined )
		{
			NgLogE("Could not parse longitude in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "altitude" ] = Core.Proc.parseFloat( cmd[ 3 ] );
		if( obj[ "altitude" ] === undefined )
		{
			NgLogE("Could not parse altitude in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "accuracy" ] = Core.Proc.parseFloat( cmd[ 4 ] );
		if( obj[ "accuracy" ] === undefined )
		{
			NgLogE("Could not parse accuracy in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_headingUpdatedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 4 )
		{
			NgLogE("Could not parse due to wrong argument count in LocationEmitter.headingUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "timestamp" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "timestamp" ] === undefined )
		{
			NgLogE("Could not parse timestamp in LocationEmitter.headingUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "magneticHeading" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "magneticHeading" ] === undefined )
		{
			NgLogE("Could not parse magneticHeading in LocationEmitter.headingUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "trueHeading" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "trueHeading" ] === undefined )
		{
			NgLogE("Could not parse trueHeading in LocationEmitter.headingUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "accuracy" ] = Core.Proc.parseFloat( cmd[ 3 ] );
		if( obj[ "accuracy" ] === undefined )
		{
			NgLogE("Could not parse accuracy in LocationEmitter.headingUpdated from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":333,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":333,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_startUpdatingLocationSendGen: function( accuracy, distanceFilter )
	{
		Core.Proc.appendToCommandString( ":333,3," + this.__objectRegistryId + "," + accuracy + "," + distanceFilter  );
	},
	
	/** @private */
	_stopUpdatingLocationSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":333,4," + this.__objectRegistryId );
	},
	
	/** @private */
	_locationUpdatedSendGen: function( timestamp, latitude, longitude, altitude, accuracy )
	{
		Core.Proc.appendToCommandString( ":333,5," + this.__objectRegistryId + "," + timestamp + "," + latitude + "," + longitude + "," + altitude + "," + accuracy  );
	},
	
	/** @private */
	_startUpdatingHeadingSendGen: function( orientation, angularFilter )
	{
		Core.Proc.appendToCommandString( ":333,6," + this.__objectRegistryId + "," + orientation + "," + angularFilter  );
	},
	
	/** @private */
	_stopUpdatingHeadingSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":333,7," + this.__objectRegistryId );
	},
	
	/** @private */
	_headingUpdatedSendGen: function( timestamp, magneticHeading, trueHeading, accuracy )
	{
		Core.Proc.appendToCommandString( ":333,8," + this.__objectRegistryId + "," + timestamp + "," + magneticHeading + "," + trueHeading + "," + accuracy  );
	},
	
	/** @private */
	_setPropertiesSendGen: function( accuracy, elements )
	{
		Core.Proc.appendToCommandString( ":333,9," + this.__objectRegistryId + "," + accuracy + "," + elements  );
	},
	
	/** @private */
	_startUpdatingSendGen: function( force )
	{
		Core.Proc.appendToCommandString( ":333,10," + this.__objectRegistryId + "," + ( force ? 1 : 0 )  );
	},
	
	/** @private */
	_stopUpdatingSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":333,11," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// startUpdatingLocation: function( accuracy, distanceFilter ) {}
	
	// stopUpdatingLocation: function(  ) {}
	
	// _locationUpdatedRecv: function( cmd ) {}
	// locationUpdated: function( timestamp, latitude, longitude, altitude, accuracy ) {}
	
	// startUpdatingHeading: function( orientation, angularFilter ) {}
	
	// stopUpdatingHeading: function(  ) {}
	
	// _headingUpdatedRecv: function( cmd ) {}
	// headingUpdated: function( timestamp, magneticHeading, trueHeading, accuracy ) {}
	
	// setProperties: function( accuracy, elements ) {}
	
	// startUpdating: function( force ) {}
	
	// stopUpdating: function(  ) {}
	

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/MemoryEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/MemoryEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/MemoryEmitter'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.MemoryEmitter = Core.MessageEmitter.singleton(
/** @lends Device.MemoryEmitter.prototype */
{
	classname: 'MemoryEmitter',
		
	/**
	 * @class The <code>MemoryEmitter</code> class constructs a singleton object that emits messages
	 * when a low memory warning is received from the system.
	 * Applications can respond by releasing unused objects, allowing the system to re-allocate free memory.
	 * Failure to respond to low memory warnings may result in application 
	 * termination by the operating system.<br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	_memoryEventRecv: function( cmd ) 
	{
		this.emit();
		
		//Cascade the original message back out to native for forwarding
		this._memoryEventSendGen();
	},
													  
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 331
	// Method create = -1
	// Method memoryEvent = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._memoryEventRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in MemoryEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in MemoryEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[331] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_memoryEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in MemoryEmitter.memoryEvent from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":331,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_memoryEventSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":331,2," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _memoryEventRecv: function( cmd ) {}
	// memoryEvent: function(  ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/MotionEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/MotionEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/MotionEmitter'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.MotionEmitter = Core.MessageEmitter.singleton(
/** @lends Device.MotionEmitter.prototype */
{
	classname: 'MotionEmitter',
	
	/**
	 * @class The <code>MotionEmitter</code> class constructs a singleton object that tracks device movement through 3D space. 
	 * These objects emit <a href="Device.MotionEmitter.Motion.html">Motion</a> objects that retrieve spatial data for a given component from the device.<br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @see Device.MotionEmitter.Motion
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		this._lastAccel = null;
		this._lastGyro  = null;
		this._lastCompass = null;
	},

	Motion: Core.Class.subclass(
	/** @lends Device.MotionEmitter.Motion.prototype */
	{
		classname: 'Motion',
		
		/**
		 * @class A <code>Motion</code> object is what <code>MotionEmitter</code> uses to capture device movement through 3D space.
		 * These objects retrieve data from device components on how a device responds to 
		 * physical movement, as reported by the accelerometer, gyroscope and compass instruments.
		 * @constructs The default constructor. 
		 * @param {Array (Number)} accel The accelerometer data.
		 * @param {Array (Number)} gyro The gyroscope data.
		 * @param {Array (Number)} compass The compass data.
		 * @see Device.MotionEmitter
		 * @augments Core.Class
		 */
		initialize: function(accel, gyro, compass)
		{
			this._accel = accel;
			this._gyro  = gyro;
			this._compass = compass;
		},
		
		/**
		 * Retrieve accelerometer data from the device. If the device contains an accelerometer,
		 * calling <code>getAccelData()</code> returns an array of three floating point values. In all other cases,
		 * calling <code>getAccelData()</code> returns <code>undefined</code>.
		 * <b>Note:</b> Use a <code>{@link Core.Capabilities</code> object 
		 * to programmatically check a device for a accelerometer. 
		 * @returns {Array (Number)} The accelerometer data for the device.
		 * @see Core.Capabilities#getHasAccel
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getAccelData: function()
		{
			return this._accel;
		},
		
		/**
		 * Retrieve gyroscope data from the device. If the device contains a gyroscope,
		 * this call returns an array of three floating point values. In all other cases,
		 * this call returns <code>undefined</code>. <br><br>
		 * <b>Note:</b> Use a <code>{@link Core.Capabilities</code> object 
		 * to programmatically check a device for a gyroscope. 
		 * @returns {Array (Number)} The gyroscope data for the device.
		 * @see Core.Capabilities#getHasGyro
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getGyroData: function()
		{
			return this._gyro;
		},
		
		/**
		 * Retrieve compass data from the device. If the device contains a magnetic compass,
		 * this call returns an array of three floating point values. In all other cases,
		 * this call returns <code>undefined</code>.<br><br>
		 * <b>Note:</b> Use a <code>Capabilities</code> object to programmatically check a device for a compass. 
		 * @returns {Array (Number)} The compass data for the device.
		 * @see Core.Capabilities#getHasCompass
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getCompassData: function()
		{
			return this._compass;
		},
	}),

	/**
	 * Construct a <code>MessageListener</code> object and register it with this <code>MotionEmitter</code> object. If an application calls <code>emit()</code> 
	 * or <code>chain()</code> 
	 * on this emitter, a callback function passed as a parameter is called on the specified listener.
	 * The parameters for the callback function are identical to parameters for <code>emit()</code> or
	 * <code>chain()</code>.<br><br>
	 * <b>Note:</b> Each listener can only listen to an emitter once.
	 * The following code examples illustrate different call styles for <code>addListener()</code>.
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onCallback);
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onEvent, 200);
	 *
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to add.
	 * @param {Function} func The callback function.
	 * @param {Number} [priority=0] The priority for this <code>MessageListener</code>.
	 * @see Core.MessageEmitter#emit,
	 * @see Core.MessageEmitter#chain
	 *
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	addListener: function($super, listener, func, priority)
	{
		if (this.getListenerCount() == 0) {
			// start the Accelerometer if this is the first listener
			this._startMotionSendGen();
		}

		$super(listener, func, priority);
	},

	/**
	 * Remove a <code>MessageListener</code> object from this <code>MotionEmitter</code> object. 
	 * The following code examples illustrate different call styles for <code>removeListener()</code>.
	 * @example
	 * emitter.removeListener(myListener, myListener.onCallback);
	 * @example
	 * emitter.removeListener(myListener);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to remove.	 
	 * @returns {Boolean} Returns <code>true</code> when the registered listener was removed. Returns <code>false</code> in all other cases.
	 * @see Core.MessageEmitter#addListener
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
	removeListener: function($super, listener)
	{
		$super(listener);

		if (this.getListenerCount() == 0) {
			// stop the Accelerometer if this is the last listener
			this._stopMotionSendGen();
		}
	},

	_emitMotion: function()
	{
		var motion = new Device.MotionEmitter.Motion(this._lastAccel, this._lastGyro, this._lastCompass);
		this.emit(motion);
	},

	_accelChangedRecv: function( cmd )
	{
		var msg = {};
		if(!this._accelChangedRecvGen(cmd, msg))
			return;

		this._lastAccel = msg;
		this._emitMotion();
		
		//Cascade the original message back out to native for forwarding
		this._accelChangedSendGen(msg.x, msg.y, msg.z);
	},

	_gyroChangedRecv: function( cmd )
	{
		var msg = {};
		if(!this._gyroChangedRecvGen(cmd, msg))
			return;

		this._lastGyro = msg;
		this._emitMotion();
		
		//Cascade the original message back out to native for forwarding
		this._gyroChangedSendGen(msg.x, msg.y, msg.z);
	},
	
	_magneticChangedRecv: function( cmd ) 
	{
		var msg = {};
		if(!this._magneticChangedRecvGen(cmd, msg))
			return;
		
 		this._lastCompass = msg;
		this._emitMotion();
		
		//Cascade the original message back out to native for forwarding
		this._magneticChangedSendGen(msg.x, msg.y, msg.z);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 330
	// Method create = -1
	// Method accelChanged = 2
	// Method gyroChanged = 3
	// Method magneticChanged = 4
	// Method startMotion = 5
	// Method stopMotion = 6
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._accelChangedRecv( cmd );
					break;
				case 3:
					instance._gyroChangedRecv( cmd );
					break;
				case 4:
					instance._magneticChangedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in MotionEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in MotionEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[330] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_accelChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in MotionEmitter.accelChanged from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in MotionEmitter.accelChanged from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in MotionEmitter.accelChanged from command: " + cmd );
			return false;
		}
		
		obj[ "z" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "z" ] === undefined )
		{
			NgLogE("Could not parse z in MotionEmitter.accelChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_gyroChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in MotionEmitter.gyroChanged from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in MotionEmitter.gyroChanged from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in MotionEmitter.gyroChanged from command: " + cmd );
			return false;
		}
		
		obj[ "z" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "z" ] === undefined )
		{
			NgLogE("Could not parse z in MotionEmitter.gyroChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_magneticChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in MotionEmitter.magneticChanged from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in MotionEmitter.magneticChanged from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in MotionEmitter.magneticChanged from command: " + cmd );
			return false;
		}
		
		obj[ "z" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "z" ] === undefined )
		{
			NgLogE("Could not parse z in MotionEmitter.magneticChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":330,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_accelChangedSendGen: function( x, y, z )
	{
		Core.Proc.appendToCommandString( ":330,2," + this.__objectRegistryId + "," + x + "," + y + "," + z  );
	},
	
	/** @private */
	_gyroChangedSendGen: function( x, y, z )
	{
		Core.Proc.appendToCommandString( ":330,3," + this.__objectRegistryId + "," + x + "," + y + "," + z  );
	},
	
	/** @private */
	_magneticChangedSendGen: function( x, y, z )
	{
		Core.Proc.appendToCommandString( ":330,4," + this.__objectRegistryId + "," + x + "," + y + "," + z  );
	},
	
	/** @private */
	_startMotionSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":330,5," + this.__objectRegistryId );
	},
	
	/** @private */
	_stopMotionSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":330,6," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _accelChangedRecv: function( cmd ) {}
	// accelChanged: function( x, y, z ) {}
	
	// _gyroChangedRecv: function( cmd ) {}
	// gyroChanged: function( x, y, z ) {}
	
	// _magneticChangedRecv: function( cmd ) {}
	// magneticChanged: function( x, y, z ) {}
	
	// startMotion: function(  ) {}
	
	// stopMotion: function(  ) {}
	

// {{/Wg Generated Code}} }}}

});
// vim:set fdm=marker noexpandtab:
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/NetworkEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/NetworkEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/NetworkEmitter'] = exports; var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

exports.NetworkEmitter = Core.MessageEmitter.singleton(
/** @lends Device.NetworkEmitter.prototype */
{
	classname: 'NetworkEmitter',
	
	/**
	 * @class The <code>NetworkEmitter</code> class constructs a singleton object that tracks network connectivity status for a device.
	 * These objects emit a <a href="Device.NetworkEmitter.html#Status">Status</a> object when a change to device network connectivity status occurs.
	 * A change in network status is defined as:
	 * <div class="ul"><font size="3">
	 * <li>The device loses access to a network.</li>
	 * <li>The device gains access to a network.</li>
	 * <li>The device switches between cellular and Wi-Fi network access.</li>
	 * </font></div><br>
	 * <p><b>Note:</b> Applications should never directly allocate a singleton.</p>
	 * @constructs The default constructor. 
	 * @see Device.NetworkEmitter#Status
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		this._lastStatus = null;
	},

	/**
	 * Retrieve the network status of the device.
	 * @returns {Device.NetworkEmitter#Status} The current device network status.
	 * @status iOS, Android, Test
	 */
	getLastStatus: function()
	{
		return this._lastStatus;
	},

	/** 
	 * Enumeration values for device network status.
	 * @fieldOf Device.NetworkEmitter.prototype
	 */
	Status:
	{
		/** 
		* <code>0</code> = No network connectivity. 
		* @fieldOf Device.NetworkEmitter.prototype
		* @constant
		*/
		None: 0,
		
		/** 
		* <code>1</code> = Cellular network connectivity. 
		* @fieldOf Device.NetworkEmitter.prototype
		* @constant
		*/
		Cellular: 1,
		
		/** 
		* <code>2</code> = Wi-Fi network connectivity. 
		* @fieldOf Device.NetworkEmitter.prototype
		* @constant
		*/
		Wifi: 2,
	},

	_statusChangedRecv: function( cmd )
	{
		var msg = {};
		if (!this._statusChangedRecvGen(cmd, msg))
		    return;

		this._lastStatus = msg['status'];
		this.emit(this._lastStatus);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 336
	// Method create = -1
	// Method statusChanged = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._statusChangedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in NetworkEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in NetworkEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[336] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_statusChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in NetworkEmitter.statusChanged from command: " + cmd );
			return false;
		}
		
		obj[ "status" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "status" ] === undefined )
		{
			NgLogE("Could not parse status in NetworkEmitter.statusChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":336,-1," + __objectRegistryId  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _statusChangedRecv: function( cmd ) {}

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/OrientationEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/OrientationEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/OrientationEmitter'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class OrientationEmitter
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

exports.OrientationEmitter = Core.MessageEmitter.singleton(
/** @lends Device.OrientationEmitter.prototype */
{
	classname: 'OrientationEmitter',
		
	/**
	 * @class <code>OrientationEmitter</code> constructs a singleton object that tracks the physical orientation of the device.
	 * These objects emit an <code><a href="Device.OrientationEmitter.html#Orientation">Orientation</a></code> object when a change in device orientation occurs.<br><br>
	 * Rotating the device does not necessarily rotate the 
	 * interface presented to the user. Applications must
	 * explicitly call <code><a href="Device.OrientationEmitter.html#setInterfaceOrientation">setInterfaceOrientation()</a></code> to rotate the interface.
	 * This allows an application to selectively choose a supported device orientation.
	 * For example, an application can observe orientation change events and change the interface orientation only if the application suppoorts it.<br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @constructs The default constructor. 	 
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		this._lastDeviceOrientation    = this.Orientation.Portrait;
		this._lastInterfaceOrientation = this.Orientation.Portrait;
	},
	
	/**
	 * Retrieve the device orientation.
	 * @returns {Device.OrientationEmitter#Orientation} The current device orienation.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getDeviceOrientation: function()
	{
		return this._lastDeviceOrientation;
	},
	
	/**
	 * Retrieve the interface orientation. Initially, this is the same
	 * as the device orientation.
	 * @returns {Device.OrientationEmitter#Orientation} The current interface orientation.
	 * @see Device.OrientationEmitter#setInterfaceOrientation
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getInterfaceOrientation: function()
	{
		return this._lastInterfaceOrientation;
	},
	
	/**
	 * Set the interface orientation.
	 * @example var orientation = new Device.OrientationEmitter(Device.OrientationEmitter.Orientation.Portrait, true);
	 * @param {Device.OrientationEmitter#Orientation} orientation The new device orientation.
	 * @param {Boolean} [animated] Set as <code>true</code> to render the orientation change with an animated effect.
	 * @see Device.OrientationEmitter#getInterfaceOrientation
	 * @status iOS, Test
	 */
	setInterfaceOrientation: function(orientation, animated)
	{
		if (orientation != this._lastInterfaceOrientation)
		{
			NgLogD("setInterfaceOrientation to " + orientation);
			this._setInterfaceOrientationSendGen(orientation,animated);
			this._lastInterfaceOrientation = orientation;
		}
	},
	
	/**
	 * Enumeration for device orientation.
	 * @fieldOf Device.OrientationEmitter.prototype
	 */
	Orientation:
	{ 
		/** 
		* Portrait orientation. 
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		Portrait: 0,
		/** 
		* Portrait orientation, but rotated 180 degrees. 
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		PortraitUpsideDown: 1,
		/** 
		* Landscape orientation with the top of the device to the left. 
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		LandscapeLeft: 2,
		/** 
		* Landscape orientation with the top of the device to the right. 
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		LandscapeRight: 3,
		/** 
		* Oriented with the face of the device up. 
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		FaceUp: 4,
		/** 
		* Oriented with the face of the device down. 
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		FaceDown: 5,
	},

	/**
	 * Enumeration for orientation type.
	 * It can be used to identify which event happens.
	 * @filedOf Device.OrientationEmitter.prototype
	 */
	OrientationType:
	{
		/**
		* Device orientation has changed.
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		Device: 0,
		/**
		* Interface orientation has changed.
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		Interface: 1
	},

	_orientationChangedRecv: function( cmd )
	{
		var msg = {};
		if(!this._orientationChangedRecvGen(cmd, msg))
			return;
 
 		this._lastDeviceOrientation = msg['orientation'];
		this.emit({type: this.OrientationType.Device, orientation:msg['orientation']});
		
		//Cascade the original message back out to native for forwarding
		this._orientationChangedSendGen(msg.orientation);
	},
	
	_interfaceOrientationChangedRecv: function( cmd )
	{
		var msg = {};
		if(!this._interfaceOrientationChangedRecvGen(cmd, msg))
			return;
 
 		this._lastInterfaceOrientation = msg['orientation'];
		this.emit({type: this.OrientationType.Interface, orientation:msg['orientation']});
		
		//Cascade the original message back out to native for forwarding
		this._interfaceOrientationChangedSendGen(msg.orientation);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 335
	// Method create = -1
	// Method orientationChanged = 2
	// Method setInterfaceOrientation = 3
	// Method interfaceOrientationChanged = 4
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._orientationChangedRecv( cmd );
					break;
				case 4:
					instance._interfaceOrientationChangedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in OrientationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in OrientationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[335] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_orientationChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in OrientationEmitter.orientationChanged from command: " + cmd );
			return false;
		}
		
		obj[ "orientation" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "orientation" ] === undefined )
		{
			NgLogE("Could not parse orientation in OrientationEmitter.orientationChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_interfaceOrientationChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in OrientationEmitter.interfaceOrientationChanged from command: " + cmd );
			return false;
		}
		
		obj[ "orientation" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "orientation" ] === undefined )
		{
			NgLogE("Could not parse orientation in OrientationEmitter.interfaceOrientationChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":335,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_orientationChangedSendGen: function( orientation )
	{
		Core.Proc.appendToCommandString( ":335,2," + this.__objectRegistryId + "," + orientation  );
	},
	
	/** @private */
	_setInterfaceOrientationSendGen: function( orientation, animated )
	{
		Core.Proc.appendToCommandString( ":335,3," + this.__objectRegistryId + "," + orientation + "," + ( animated ? 1 : 0 )  );
	},
	
	/** @private */
	_interfaceOrientationChangedSendGen: function( orientation )
	{
		Core.Proc.appendToCommandString( ":335,4," + this.__objectRegistryId + "," + orientation  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _orientationChangedRecv: function( cmd ) {}
	// orientationChanged: function( orientation ) {}
	
	// setInterfaceOrientation: function( orientation, animated ) {}
	
	// _interfaceOrientationChangedRecv: function( cmd ) {}
	// interfaceOrientationChanged: function( orientation ) {}
	

// {{/Wg Generated Code}} }}}

});
// vim:set fdm=marker noexpandtab:
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/ShakeEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/ShakeEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/ShakeEmitter'] = exports; var Core = require('NGCore/Client/Core').Core;
var MotionEmitter = require('NGCore/Client/Device/MotionEmitter').MotionEmitter;

var ProxyListener = Core.MessageListener.subclass(
{
	onUpdate: function() {}
});

exports.ShakeEmitter = Core.MessageEmitter.singleton(
/** @lends Device.ShakeEmitter.prototype */
{
	classname: 'ShakeEmitter',
		
	/**
	 * @class The <code>ShakeEmitter</code> class constructs a singleton object that tracks when users physically shake the device. 
	 * These objects emit messages when the device recognizes a shake gesture.<br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @status iOS, Android
	 */
	
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._proxyListener = new ProxyListener();
		
	},
	
	/**
	 * Add a <code>MessageListener</code> to this emitter. When an application calls <code>emit()</code> 
	 * or <code>chain()</code> 
	 * on this emitter, a callback function passed as a parameter is called on the specified listener.
	 * The parameters for the callback function are identical to parameters for <code>emit()</code> or
	 * <code>chain()</code>.
	 * <br><br>
	 * <b>Note:</b> Each listener can only listen to an emitter one time.<br><br>
	 * The following code examples illustrate different call styles for <code>addListener()</code>.
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onCallback);
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onEvent, 200);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to add.
	 * @param {Function} func The callback function.
	 * @param {Number} [priority=0] The priority for this <code>MessageListener</code>.
	 * @throws {MessageEmitter.addListener: listener is already listening} Calling <code>addListener()</code> multiple times on the same emitter
	 * with the same listener.
	 * @throws {MessageEmitter.addListener: listener must be instances of MessageListener} Listener is not an instance of <code>MessageListener</code>.
	 * @see Device.ShakeEmitter#removeListener,
	 * @see Core.MessageEmitter#emit,
	 * @see Core.MessageEmitter#chain
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	addListener: function($super, listener, func, priority)
	{
		if (this.getListenerCount() == 0) {
			MotionEmitter.addListener(this._proxyListener, function(){});
		}

		$super(listener, func, priority);
	},
	
	/**
	 * Remove a <code>MessageListener</code> from this emitter.<br><br> 
	 * The following code examples illustrate different call styles for <code>removeListener()</code>.
	 * @example
	 * emitter.removeListener(myListener, myListener.onCallback);
	 * @example
	 * emitter.removeListener(myListener);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to remove.
	 * @returns {Boolean} Returns <code>true</code> if the registered listener was removed. Returns <code>false</code> if the registered listener is not found 
	 * or is not registered with this emitter.
	 * @throws {MessageEmitter.removeListener: listener is not listening} Specified listener is not currently registered
	 * with this emitter.
	 * @see Device.ShakeEmitter#addListener
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	removeListener: function($super, listener)
	{
		$super(listener);

		if (this.getListenerCount() == 0) {
			MotionEmitter.removeListener(this._proxyListener);
		}
	},
	
	_shakeRecv: function( cmd )
	{
		this.emit();
		
		//Cascade the original message back out to native for forwarding
		this._shakeSendGen();
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 332
	// Method create = -1
	// Method shake = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._shakeRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in ShakeEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in ShakeEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[332] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_shakeRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in ShakeEmitter.shake from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":332,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_shakeSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":332,2," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _shakeRecv: function( cmd ) {}
	// shake: function(  ) {}
	

// {{/Wg Generated Code}}	

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/KeyEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/KeyEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/KeyEmitter'] = exports; var Core = require('NGCore/Client/Core').Core;
var UI = require('NGCore/Client/UI').UI;

////////////////////////////////////////////////////////////////////////////////

// Private Class Statics
var keyCodeReverseMap = null;

exports.KeyEmitter = Core.MessageEmitter.singleton(
/** @lends Device.KeyEmitter.prototype */
{
	classname: 'KeyEmitter',

	/**
	 * @class The <code>KeyEmitter</code> class constructs a singleton object that emits a <code><a href="Device.KeyEmitter.KeyEvent.html">KeyEvent</a></code> object 
	 * when the user presses or releases a device hardware key.<br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @require Device
	 * @example
	 *
	 * var KeyListener = Core.MessageListener.subclass({
	 *   onUpdate: function(keyEvent) {
	 *     // back to the launcher when the back button is pressed
	 *     if (keyEvent.code === Device.KeyEmitter.Keycode.back) {
	 *        this.destroy();
	 *        LGL.runUpdatedGame('/Samples/Launcher');
	 *        return;
	 *     }
	 *
	 *     var text = '';
	 *     switch (keyEvent.type) {
	 *        case Device.KeyEmitter.EventType.onDown:
	 *           text += 'onDown :'
	 *           break;
	 *        case Device.KeyEmitter.EventType.onUp:
	 *           text += 'onUp :'
	 *           break;
	 *     }
	 *
	 *     text += Device.KeyEmitter.keyCodeToSymbol(keyEvent.code);
	 *     console.log(text);
	 *   }
	 * };
	 *
	 * var keyListener = new KeyListener();
	 * Device.KeyEmitter.addListener(keyListener, keyListener.onUpdate);
	 *
	 * @status Android, Test, AndroidTested
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},

	/**
	 * Convert a keycode into the equivalent human-readable symbol. The keycode to convert is passed in as a parameter.
	 * The following code example illustrates how to convert a keycode into a human-readable symbol.
	 * @param {String} keyCode The keycode to convert.
	 * @static
	 *
	 * @example
	 *   var symbol = Device.KeyEmitter.keyCodeToSymbol(0x1d);
	 *   // symbol => 'a'
	 *
	 * @status
	 */
	keyCodeToSymbol: function(keyCode)
	{
		if (!keyCodeReverseMap) {
			keyCodeReverseMap = {};
			for (var codename in this.Keycode) {
				keyCodeReverseMap[this.Keycode[codename]] = codename;
			}
		}
		return keyCodeReverseMap[keyCode] || '';
	},

	KeyEvent: Core.Class.subclass(
	/** @lends Device.KeyEmitter.KeyEvent.prototype */
	{
		classname: 'KeyEvent',

		/**
		 * @class <code>KeyEvent</code> constructs objects that contain the parcel of a keyboard event. 
		 * The keycode of the key that triggered the event is passed in as a parameter.
		 * @constructs The default constructor. 
		 * @augments Core.Class
		 * @param {Device.KeyEmitter.EventType} type The type of the keyboard event.
		 * @param {Integer} modifiers the bit-and of {@link Device.KeyEmitter#Modifier} combination.
		 * @param {Device.KeyEmitter.Keycode} code The actual keycode.
		 */
		initialize: function(type, modifiers, code)
		{
			this.type      = type;
			this.modifiers = modifiers;
			this.code      = code;
		}
	}),

	_onKeyEventRecv: function( cmd )
	{
		var msg = {};
		if(!this._onKeyEventRecvGen(cmd, msg))
			return;

		var keyEvent = new Device.KeyEmitter.KeyEvent(msg.type, msg.modifiers, msg.code);
		
		if(!this.chain(keyEvent)) {
			//Noone handled this keyEvent. Cascade the original back out to native for forwarding
			//	to the next interpreter in the chain.
			this._onKeyEventSendGen(msg.type, msg.modifiers, msg.code);
		}
	},

// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Event type Enums.
	 * Currently we only have onUp and onDown events.
	 *
	 * @namespace
	 * */
	EventType:
	{ 
		/** the key is hooked up. */
		onUp: 0,
		/** the key is pressed down. */
		onDown: 1,
	},
	
	/** 
	 * Enums for modifiers that are being pressed.
	 * They are passed as bit-and-ed.
	 *
	 * @namespace
	 * @example
	 *
	 * var keyEvent; // emitted from KeyEmitter
	 * if (keyEvent.modifiers & Device.KeyEmitter.Modifier.ALT && 
	 *     keyEvent.modifiers & Device.KeyEmitter.Modifier.SHIFT)
	 *    console.log("ALT+SHIFT");
	 * */
	Modifier:
	{ 
		/** no modifiers */
		NONE: 0,
		/** SYMBOL modifier */
		SYMBOL: 1 << 0,
		/** ALT modifier */
		ALT: 1 << 1,
		/** ALT_LEFT modifier */
		ALT_LEFT: 1 << 2,
		/** ALT_RIGHT modifier */
		ALT_RIGHT: 1 << 3,
		/** SHIFT modifier */
		SHIFT: 1 << 4,
		/** SHIFT_LEFT modifier */
		SHIFT_LEFT: 1 << 5,
		/** SHIFT_RIGHT modifier */
		SHIFT_RIGHT: 1 << 6,
	},
	
	/** 
	 * Keycode Enums.
	 * Define bunch of key codes.
	 * @namespace
	 * */
	Keycode:
	{ 
		/** * */
		a: 0x1d,
		/** * */
		b: 0x1e,
		/** * */
		c: 0x1f,
		/** * */
		d: 0x20,
		/** * */
		e: 0x21,
		/** * */
		f: 0x22,
		/** * */
		g: 0x23,
		/** * */
		h: 0x24,
		/** * */
		i: 0x25,
		/** * */
		j: 0x26,
		/** * */
		k: 0x27,
		/** * */
		l: 0x28,
		/** * */
		m: 0x29,
		/** * */
		n: 0x2a,
		/** * */
		o: 0x2b,
		/** * */
		p: 0x2c,
		/** * */
		q: 0x2d,
		/** * */
		r: 0x2e,
		/** * */
		s: 0x2f,
		/** * */
		t: 0x30,
		/** * */
		u: 0x31,
		/** * */
		v: 0x32,
		/** * */
		w: 0x33,
		/** * */
		x: 0x34,
		/** * */
		y: 0x35,
		/** * */
		z: 0x36,
		/** TBD */
		up: 0x13,
		/** TBD */
		down: 0x14,
		/** TBD */
		left: 0x15,
		/** TBD */
		right: 0x16,
		/** * */
		enter: 0x42,
		/** * */
		backspace: 0x43,
		/** * */
		back: 0x04,
		/** backunhandled: 0x54, Special KeyCode to tell MobageService that the back was unhandled by the game, after the service declined first dibs. Stole MAX_KEYCODE (deprecated constant). */
		backunhandled: 0x54,
		/** * */
		menu: 0x52,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 343
	// Method create = -1
	// Method onKeyEvent = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._onKeyEventRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in KeyEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in KeyEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[343] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onKeyEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyEmitter.onKeyEvent from command: " + cmd );
			return false;
		}
		
		obj[ "type" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "type" ] === undefined )
		{
			NgLogE("Could not parse type in KeyEmitter.onKeyEvent from command: " + cmd );
			return false;
		}
		
		obj[ "modifiers" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "modifiers" ] === undefined )
		{
			NgLogE("Could not parse modifiers in KeyEmitter.onKeyEvent from command: " + cmd );
			return false;
		}
		
		obj[ "code" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "code" ] === undefined )
		{
			NgLogE("Could not parse code in KeyEmitter.onKeyEvent from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":343,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_onKeyEventSendGen: function( type, modifiers, code )
	{
		Core.Proc.appendToCommandString( ":343,2," + this.__objectRegistryId + "," + type + "," + modifiers + "," + code  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _onKeyEventRecv: function( cmd ) {}
	// onKeyEvent: function( type, modifiers, code ) {}
	

// {{/Wg Generated Code}}

});
// vim:set fdm=marker noexpandtab:
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/_PushNotificationEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/_PushNotificationEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/_PushNotificationEmitter'] = exports; var Core = require('NGCore/Client/Core').Core;

/*
	NOTE: 	THIS IS FOR INTERNAL USE ONLY AND WILL BE DEPRECATED IN THE FUTURE.
			DO NOT USE IT IN ANY OF YOUR CODE.
*/

exports.PushNotificationEmitter = Core.MessageEmitter.singleton(
/** @lends Device.PushNotificationEmitter.prototype */
{
	classname: 'PushNotificationEmitter',
		
	/**
	 * @class Emits when native code recieves a push notification
	 * @constructs The default constructor.
	 * @augments Core.MessageEmitter
	 */
	
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	_onPushNotificationRecv: function( cmd )
	{
		var msg = {};
		if (!this._onPushNotificationRecvGen(cmd, msg))
			return;
			
		this._lastMsgPayload = msg.msgPayload;
		
		if(!this.chain(msg.msgPayload))	{
			//Noone handled this keyEvent. Cascade the original back out to native for forwarding
			//	to the next interpreter in the chain.
			this._onPushNotificationSendGen(msg.msgPayload);
		}
		
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 345
	// Method create = -1
	// Method onPushNotification = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._onPushNotificationRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in PushNotificationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in PushNotificationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[345] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onPushNotificationRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in PushNotificationEmitter.onPushNotification from command: " + cmd );
			return false;
		}
		
		obj[ "msgPayload" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "msgPayload" ] === undefined )
		{
			NgLogE("Could not parse msgPayload in PushNotificationEmitter.onPushNotification from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":345,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_onPushNotificationSendGen: function( msgPayload )
	{
		Core.Proc.appendToCommandString( ":345,2," + this.__objectRegistryId + "," + Core.Base64.encode( msgPayload )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _onPushNotificationRecv: function( cmd ) {}
	// onPushNotification: function( msgPayload ) {}
	

// {{/Wg Generated Code}}	

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/_InAppPurchaseEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/_InAppPurchaseEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/_InAppPurchaseEmitter'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class InAppPurchaseEmitter
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

exports.InAppPurchaseEmitter = Core.MessageEmitter.singleton(
/** @lends Device.InAppPurchaseEmitter.prototype */
{
	classname: 'InAppPurchaseEmitter',
	
	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	_onPurchaseEventRecv: function( cmd ) {
		var msg = {};
		if (!this._onPurchaseEventRecvGen(cmd, msg))
			return;
		if(!this.chain(msg.err, msg.data, msg.verificationToken))	{
			//Noone handled this keyEvent. Cascade the original back out to native for forwarding
			//	to the next interpreter in the chain.
			this._onPurchaseEventSendGen(msg.err, msg.data, msg.verificationToken);
		}
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 347
	// Method create = -1
	// Method onPurchaseEvent = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._onPurchaseEventRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in InAppPurchaseEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in InAppPurchaseEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[347] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onPurchaseEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in InAppPurchaseEmitter.onPurchaseEvent from command: " + cmd );
			return false;
		}
		
		obj[ "err" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "err" ] === undefined )
		{
			NgLogE("Could not parse err in InAppPurchaseEmitter.onPurchaseEvent from command: " + cmd );
			return false;
		}
		
		obj[ "data" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "data" ] === undefined )
		{
			NgLogE("Could not parse data in InAppPurchaseEmitter.onPurchaseEvent from command: " + cmd );
			return false;
		}
		
		obj[ "verificationToken" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "verificationToken" ] === undefined )
		{
			NgLogE("Could not parse verificationToken in InAppPurchaseEmitter.onPurchaseEvent from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":347,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_onPurchaseEventSendGen: function( err, data, verificationToken )
	{
		Core.Proc.appendToCommandString( ":347,2," + this.__objectRegistryId + "," + Core.Base64.encode( err ) + "," + Core.Base64.encode( data ) + "," + Core.Base64.encode( verificationToken )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _onPurchaseEventRecv: function( cmd ) {}
	// onPurchaseEvent: function( err, data, verificationToken ) {}
	

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/_InAppPurchase'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/_InAppPurchase'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/_InAppPurchase'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class InAppPurchase
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Client/Core/Class').Class;
var DeviceReq = require('NGCore/Client/Device');
var Localization = require('NGCore/Client/Core/Localization').Localization;

////////////////////////////////////////////////////////////////////////////////

exports.InAppPurchase = Class.singleton(
/** @lends Device.InAppPurchase.prototype */
{
	classname: 'InAppPurchase',
	
	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},

	initService: function(ordercb, donecb) {
		if ((!this._isIOS()) && (!this._isAndroid())) {
			NgLogE("ERROR: Neither Android nor iOS platform, IAP will not work");
			donecb();
			return;
		}
		if (!this._iapInited) {
			var IAPListener = Core.MessageListener.subclass({
				onPurchaseEvent: this._iapCallback.bind(this)
			});
			// Register for Android / iOS IAP callbacks the same way
			this.listener = new IAPListener();
	        DeviceReq.Device.InAppPurchaseEmitter.addListener(
				this.listener, this.listener.onPurchaseEvent);
	    	// listener will be called when purchase state changes
		}
		this._initDonecb = donecb;
		this._initOrdercb = ordercb;
		if (this._isAndroid()) {
			this._iapCallback('morenonces', '', '');
			/*
			 * Gets persisted unfulfilled orders, calls back ordercb for each
			 * unfulfilled order.
			 */
			var self = this;
			Storage.KeyValueCache.local.getItem(this._IAB_ORPHANED,
			function(err, currorders) {
	   			if (currorders && (currorders.length > 0)) {
					var orders = JSON.parse(currorders);
   					// _restoreOrders eventually calls _initService when fully
					// done.
					self._restoreOrders(orders);
				} else {
					self._initService();
				}
			});
		} else {
			// _isIOS - call _initService directly.  It will call back with
			// orphaned order if any.
			this._initService();
		}
	},

	launchPurchaseView: function(productID, quantity, purchasecb, failcb, cancelcb) {
		if (!this._iapInited) {
			NgLogE("ERROR: function initService must be called and its donecb " +
			"called back, before launchPurchaseView may be used.");
			failcb(false, "failed:initservice_not_done");
			return;
		}

		this._currentOrderProductID = productID;

		this._currentOrderCancelcb = cancelcb;
		this._currentOrderFailcb = failcb;
		this._currentOrderPurchasecb = purchasecb;

		// Android IAB currently only supports quantity of 1
		if (quantity !== 1 && this._isAndroid()) {
			failcb(false, "failed:unsupported_quantity");
			return;
		}

		// Place progress dialog underneath the IAB view first
        if(this._isIOS()) {
	        this._currentOrderProgressDialog = (new UI.ProgressDialog()).retain();
	        this._currentOrderProgressDialog.setText(Localization.getString("Processing Order"));
        } else if(!this._isIOS()) {
	        this._currentOrderProgressDialog = (new UI.AlertDialog()).retain();
	        this._currentOrderProgressDialog.setTitle(Localization.getString("Processing Order"));
            // todo: localization???
            this._currentOrderProgressDialog.setText(
                "Your order is being processed. You will receive a confirmation momentarily.");
            this._currentOrderProgressDialog.setChoices(["OK"]);
            this._currentOrderProgressDialog.onchoice = function(event) {
                this._currentOrderProgressDialog.release();
                this._currentOrderProgressDialog = null;
            };
        }

	    this._currentOrderProgressDialog.show();

		if (this._isIOS() || this._isAndroid()) {
	        DeviceReq.Device.InAppPurchase._requestPurchase(productID, quantity);
			// Note that _iapCallback will call the *cb callback function(s)
			return;
		}
	    this._currentOrderProgressDialog.hide();
        this._currentOrderProgressDialog.release();
	    this._currentOrderProgressDialog = undefined;
		NgLogE('launchPurchaseView failed: only Android and iOS platforms are currently supported.');
		failcb(false, "failed:unsupported_platform");
		return;
	},

	pushSingleNonce: function(nonce){
		var noncePool = [];
		noncePool.push(nonce);
		this._fillIABNoncePool(JSON.stringify(noncePool));
	},

	/**
	 * get a product information specified by productId.
	 * @param {String} productId the product ID registered at iTunes connect.
	 * @param {Function} callback called back when it gets a response. The signature for the callback is equivalent to:<br><br>
	 * <pre>function(productData, err)</pre><br>
	 * The <code>productData</code> is an product information like "JPY,115.000000".
	 * When something bad happenes, <code>err</code> is set to the error message. Otherwise, err will be null or undefined.
	 * @status iOS, iOSTested
	 */
	getProductInformation: function(productId, callback) {
		this._getProductInformationCB = callback;
		this._getProductInformationSendGen(productId);
	},

	/*
	 * For Google IAB, these constants come from
	 * Consts.java in IAB sample code
	 *
	 *	public enum PurchaseState {
     *   PURCHASED,   // User was charged for the order. -- 0
     *   CANCELED,    // The charge failed on the server. -- 1
	 *   REFUNDED;    // User received a refund for the order. -- 2
	 */
	_IAB_PURCHASED: 0,
	_IAB_CANCELED: 1,
	_IAB_REFUNDED: 2,
	_IAB_ORPHANED: "com.ngmoco.in_app_purchase.iab_orphaned_orders",

	_capIsAndroid: undefined,
	_capIsIOS: undefined,

	// at most one outstanding order is supported
	_currentOrderCancelcb : undefined,
	_currentOrderFailcb : undefined,
	_currentOrderProductID : undefined,
	_currentOrderProgressDialog : undefined,
	_currentOrderPurchasecb : undefined,

	_initDonecb : undefined,
	_initOrdercb : undefined,
	_iapInited: false,

	_generateIABNonce: function(){
		var timestamp = new Date().getTime();
		var random = Math.floor(Math.random() * 1000);
		var nonce = (timestamp * 1000) + random;
		NgLogD("Generated nonce: " + nonce);
		return nonce;
	},

	_iapCallback: function( err, data, verificationToken ) {
		if (err == 'morenonces') {
			var count = 10;
			var noncePool = [];
			while(noncePool.length < count){
				noncePool.push(this._generateIABNonce());
			}
			this._fillIABNoncePool(JSON.stringify(noncePool));
			return true;
		}
		if ((err == 'initdone') || (err == 'initcheckdone')) {
			if (typeof this._initDonecb == 'function') {
				this._iapInited = true;
				this._initDonecb();
				this._initDonecb = undefined;
				this._initOrdercb = undefined;
			} else {
				NgLogW("WARN: " + err + " callback with empty donecb");
			}
	        // at most one listener gets iap events
	        return true;
		}
		if (err == 'getProductInformationDone') {
			if (data && data.length > 0) {
				var datajsonp = JSON.parse(data);
				this._getProductInformationCB(datajsonp.productId);
			} else {
				this._getProductInformationCB('', "no information on this product");
			}
			this._getProductInformationCB = undefined;
			return true;
		}
		var orderId = undefined;
		var prodId = "";
	    var firstOrder = undefined;
	    var datajson = undefined;
		if (data && data.length > 0) {
		    datajson = JSON.parse(data);
		    if ((typeof datajson.orders == 'undefined') ||
		        (datajson.orders.length <= 0)) {
		        // callback with no orders, try to get prodId
			    if (typeof datajson.productId != 'undefined') {
					prodId = datajson.productId.toUpperCase();
				}
		    } else {
 				if (this._isAndroid() &&
				 	(typeof this._currentOrderProgressDialog == 'undefined')) {
						// this callback comes in 'out of band', when user did
						// not attempt a purchase.  This happens on Android
						// when async callbacks are not confirmed due to
						// connectivity issue.  This callback is persisted for
						// the next 'initService' call to pick up. Only
						// successful orders will be used in callbacks.
						// Failed order and refunds are ignored.
						//
						// Note also that Android IAB could callback with
						// duplicate order numbers.  In other words, the same
						// order number could come back twice in 2 different
						// callbacks.  There is no code on client to detect
						// such duplicate.  It is up to the server to detect
						// orders which have already been fulfilled.
						//
						var successOrders = this._filterSuccessOrders(datajson, verificationToken);
						if (successOrders.length > 0) {
							this._persistOrphanedOrders(successOrders);
						}
						return true;
				} else if (datajson.orders.length === 1) {
					// on iOS, and in common cases on Android, there is at
					// most one order
				    firstOrder = datajson.orders[0];
					prodId = firstOrder.productId.toUpperCase();
					orderId = firstOrder.orderId;
				} else {
					var successOrders2 = this._filterSuccessOrders(datajson, verificationToken);
					// on Android, get the first match.  Then add any orphaned
					// orders to existing list of persisted
					// orders.  These will be processed during next initService
					if (successOrders2.length > 0) {
					    firstOrder = successOrders2.shift();
						prodId = firstOrder.productId.toUpperCase();
						orderId = firstOrder.orderId;
						if (successOrders2.length > 0) {
							this._persistOrphanedOrders(successOrders2);
						}
					}
				}
			}
		}
		if (this._currentOrderProductID != prodId) {
			NgLogW("iapCallback: product id mismatch in callback.  Req: '" +
					this._currentOrderProductID + "' CB:'" + prodId + "'");
		}
		if ((err && (err.length > 0)) || (firstOrder && firstOrder.purchaseState &&
			(firstOrder.purchaseState !== this._IAB_PURCHASED))) {
			if (firstOrder && firstOrder.purchaseState &&
				(firstOrder.purchaseState === this._IAB_REFUNDED)) {
				// refunds are generated 'out of the blue' by merchant and is
				// not part of normal flow.  Hence it is ignored.  Code now
				// continues to wait for actual purchase callback
				NgLogD("iapCallback: ignoring refunded order: " +
						JSON.stringify(firstOrder));
				return true;
			}
			if (typeof this._currentOrderProgressDialog != 'undefined') {
				this._currentOrderProgressDialog.hide();
                this._currentOrderProgressDialog.release();
				this._currentOrderProgressDialog = undefined;
			}

			if (err == 'cancelled') {
				if ((typeof this._currentOrderCancelcb) == 'function') {
					this._currentOrderCancelcb();
					this._currentOrderCancelcb = undefined;
				}
			} else {
				if (err) {
					NgLogD("DEBUG: iapCallback: got error: " + err);
				} else {
					// _IAB_CANCELED
					NgLogD("DEBUG: iapCallback: got canceled purchaseState.");
				}
				if ((typeof this._currentOrderFailcb) == 'function') {
					this._currentOrderFailcb(false, err);
					this._currentOrderFailcb = undefined;
				}
			}

	        // at most one listener gets iap events
	        return true;
	    }
		if (typeof firstOrder == 'undefined') {
			// there was no (non-refunded) order in callback
			return true;
		}
	    var nextcb2 = function(cbIsDone) {
			if (typeof this._currentOrderProgressDialog != 'undefined') {
				this._currentOrderProgressDialog.hide();
		        this._currentOrderProgressDialog.release();
				this._currentOrderProgressDialog = undefined;
			}
		    if (cbIsDone !== false) {
				return;
			}
			// Currently, fail if the first try is not done, no retry
			if ((typeof this._currentOrderFailcb) == 'function') {
				this._currentOrderFailcb(true, "failed:no_more_retry");
				this._currentOrderFailcb = undefined;
			}
	    };
		if ((typeof this._currentOrderPurchasecb) == 'function') {
			var receipt = verificationToken;
			if (this._isAndroid()) {
				// on Android, both the data and signature are required
				// for verification
				var receiptj = {
					data: data,
					signature: verificationToken
				};
				receipt = JSON.stringify(receiptj);
			}
		    this._currentOrderPurchasecb(prodId, orderId, receipt, firstOrder, nextcb2.bind(this));
			this._currentOrderPurchasecb = undefined;
		} else if ((!this._iapInited) && ((typeof this._initOrdercb) ==
		 			'function')) {
			var initcb2 = function(){
				// Do nothing on iOS as Store Observer simply emits
				// asychronously until done.
			};
			// part of initService flow
		    this._initOrdercb(prodId, orderId, verificationToken, firstOrder,
			initcb2);
		}
        // at most one listener gets iap events
        return true;
    },

	_isAndroid: function() {
		if (typeof this._capIsAndroid != 'undefined') {
			return this._capIsAndroid;
		}
		// Find out from capabilities
	    var capabilities = Core.Capabilities;
	    if ((typeof capabilities.getPlatformOS() != "undefined") &&
	        (capabilities.getPlatformOS().toLowerCase() == 'android')) {
	        this._capIsAndroid = true;
	    } else {
	        this._capIsAndroid = false;
		}
		return this._capIsAndroid;
	},

	_isIOS: function() {
		if (typeof this._capIsIOS != 'undefined') {
			return this._capIsIOS;
		}
		// Find out from capabilities
	    var capabilities = Core.Capabilities;
	    if ((typeof capabilities.getPlatformOS() != "undefined") &&
	        (capabilities.getPlatformOS().toLowerCase() == 'iphone os')) {
	        this._capIsIOS = true;
	    } else {
	        this._capIsIOS = false;
		}
		return this._capIsIOS;
	},

	_fillIABNoncePool: function(nonces) {
		this._fillIABNoncePoolSendGen(nonces);
	},
	_filterSuccessOrders: function(datajson, verificationToken) {
		var successOrders = [];
		for (var kdx in datajson.orders) {
			if ((datajson.orders[kdx].purchaseState) &&
				(datajson.orders[kdx].purchaseState ===
					this._IAB_PURCHASED)) {
				var theorder = datajson.orders[kdx];
				theorder.verificationToken = verificationToken;
				successOrders.push(theorder);
			}
		}
		return successOrders;
	},
	_persistOrphanedOrders: function(successOrders) {
		// add orders to existing list of persisted orders
		Storage.KeyValueCache.local.getItem(this._IAB_ORPHANED,
			(function(err, currorders){
				if (currorders && (currorders.length > 0)) {
					var orderlist = JSON.parse(currorders);
					for (var idx in orderlist) {
						successOrders.push(orderlist[idx]);
					}
				}
			    Storage.KeyValueCache.local.setItem(this._IAB_ORPHANED,
					JSON.stringify(successOrders), function(){
					NgLogD("Orphaned orders added to persistent store: " + JSON.stringify(successOrders));
			    });
			}).bind(this));
	},
	_initService: function() {
		this._initServiceSendGen();
	},

	_requestPurchase: function( sku, quantity ) {
		this._requestPurchaseSendGen(sku, quantity);
	},

	/*
	 * Given unfulfilled orders, calls back ordercb for each unfulfilled order.
	 * Resets persisted store using removeItem when done, then call
	 * _initService to continue init process.
	 */
	_restoreOrders: function(orders) {
		var self = this;
		if (orders.length <= 0) {
			// No more unfulfilled orders
			Storage.KeyValueCache.local.removeItem(this._IAB_ORPHANED,
			function() {
				self._initService();
			});
			return;
		}
		var order = orders.pop();
		var cb = function() {
			self._restoreOrders(orders);
		};
		// part of initService flow
		this._initOrdercb(order.productId.toUpperCase(), order.orderId, order.verificationToken, order, cb.bind(this));
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 348
	// Method create = -1
	// Method initService = 2
	// Method requestPurchase = 3
	// Method fillIABNoncePool = 4
	// Method getProductInformation = 5
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in InAppPurchase._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in InAppPurchase._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[348] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":348,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_initServiceSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":348,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_requestPurchaseSendGen: function( sku, quantity )
	{
		Core.Proc.appendToCommandString( ":348,3," + this.__objectRegistryId + "," + Core.Base64.encode( sku ) + "," + quantity  );
	},
	
	/** @private */
	_fillIABNoncePoolSendGen: function( nonces )
	{
		Core.Proc.appendToCommandString( ":348,4," + this.__objectRegistryId + "," + Core.Base64.encode( nonces )  );
	},
	
	/** @private */
	_getProductInformationSendGen: function( productId )
	{
		Core.Proc.appendToCommandString( ":348,5," + this.__objectRegistryId + "," + Core.Base64.encode( productId )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// initService: function(  ) {}
	
	// requestPurchase: function( sku, quantity ) {}
	
	// fillIABNoncePool: function( nonces ) {}
	
	// getProductInformation: function( productId ) {}
	

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/IPCEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/IPCEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/IPCEmitter'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class IPCEmitter
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Core = require('NGCore/Client/Core').Core;
var Class          = require('NGCore/Client/Core/Class').Class;
var Proc           = require('NGCore/Client/Core/Proc').Proc;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Base64         = require('NGCore/Client/Core/Base64').Base64;
var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
var DownloadFile   = require('NGCore/Client/Network/DownloadFile').DownloadFile;
var Util           = require('NGCore/Client/Network/Util').Util;
var FileSystem     = require('NGCore/Client/Storage/FileSystem').FileSystem;

////////////////////////////////////////////////////////////////////////////////

exports.IPCEmitter = MessageEmitter.singleton(
/** @lends Device.IPCEmitter.prototype */
{

	classname: 'IPCEmitter',

	/**
	 * @class The IPCEmitter class constructs a singleton object that handles Inter-Process Communication. 
	 * These objects emit events when a specified application is launched from within another application.
	 * @constructs The default constructor.
	 * @augments Core.MessageEmitter
	 */
	initialize: function()
	{
		console.log('IPCEmitter.initialize');
		this._callbackID = 0;
		this._callbacks = [];
		
		this._shouldEmitIntents = false;

		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},

	/**
	 * Check whether the host OS can launch the provided URL asynchronously.
	 * @example var appToLaunch = 'mobage//auth?packageName=xxx.xxx&className=xxx.xxx';
	 * Device.IPCEmitter.canLaunch(appToLaunch, function(canLaunch) {
	 * 	if (canLaunch) {
	 * 		console.log('launching... ' + canLaunch);
	 * 		Device.IPCEmitter.launch(appToLaunch, function(error) {
	 * 			label.setText('failed in launching the URL:' + appToLaunch);
	 * 		});
	 * 	} else {
	 * 		label.setText('cannot launch the URL:' + appToLaunch);
	 * 	}
	 * });
	 * @param {String} url A URL to test
	 * @param {Function} callback A callback function that passes a Boolean value when a result is returned. 
	 * If the URL is OK to launch, the callback returns <code>true</code>.
	 * @status
	 */
	canLaunch: function(url, callback)
	{
		this._callbacks[this._callbackID] = callback;
		this._canLaunchSendGen(url,this._callbackID);
		this._callbackID++;
	},

	/**
	 * Request that the host OS launch the provided URL.
	 * @example var appToLaunch = 'mobage//auth?packageName=xxx.xxx&className=xxx.xxx'
	 * Device.IPCEmitter.launch(appToLaunch, function(error) {
	 * 	label.setText('failed in  launching the URL:' + appToLaunch);
	 * });
	 * @param {String} url A URL to launch
	 * @param {Function} errCallback A callback function that passes an error object when an error occurs. 
	 * If the URL is successfully launched, no callback. Otherwise, the callback returns an error.
	 */
	launch: function(url, callback)
	{
		 this._callbacks[this._callbackID] = callback;
		 this._launchSendGen(url,this._callbackID);
		 this._callbackID++;
	},

	launchIntent: function( intent, extras )
	{
		this._launchIntentSendGen(intent,extras);
	},
	
	launchService: function( intent, extras, packageName )
	{
		//This function originally did not take a "packageName" parameter, it was part of the extrasObj.
		//The separate parameter is added to make it a bit more clear that it is necessary to pass in a packageName.
		//Not sure it's going to help though, because we're trying to preserve backwards compatibility here.
		if (typeof(packageName) == "string")
		{
			var extrasObj;
			if (typeof(extras) == "string")
			{
				extrasObj = JSON.parse(extras);
			}
			else
			{
				extrasObj = {};
			}
			extrasObj["packageName"] = packageName;
			extras = JSON.stringify(extrasObj);
		}
		this._launchServiceSendGen(intent,extras);
	},

	/**
	 * Launch a Single Sign-on URL.
	 * @example var appToLaunch = 'mobage//auth?packageName=xxx.xxx&className=xxx.xxx';
	 * Device.IPCEmitter.launchForSSO(appToLaunch, function(error) {
	 * 	label.setText('failed in  launching the URL:' + appToLaunch);
	 * });
	 * @param {String} url The URL to launch. The URL must include the following as part of the query string: packageName=xxxx&className=yyyy.
	 * @param {Function} callback The callback function. 
	 * @status
	 */
	launchForSSO: function(url, callback)
	{
		url += '&sso_auth';
		this.launch(url, callback);
	},

	/**
	 * Return an array of signatures for the packageName.
	 * @param {String} packageName packageName is like "com.ngmoco.gamejs"
	 * @param {Function} callback callback function signature: function(signatures) { }
	 * @status Android
	 */
	getAppSignatures: function(packageName, callback)
	{
		this._callbacks[this._callbackID] = callback;
		this._getAppSignaturesSendGen(packageName,this._callbackID);
		this._callbackID++;
	},

	/**
	 * Return the package name that invokes this ngCore app.
	 * @param {Function} callback The current callback function. Below is the callback signature. 
	 * @example function(packageName) { }
	 * @status Android
	 */
	getCallingPackage: function(callback)
	{
		this._callbacks[this._callbackID] = callback;
		this._getCallingPackageSendGen(this._callbackID);
		this._callbackID++;
	},
	
	/**
	 * Return whether the service .
	 * @param {Function} callback The current callback function. Below is the callback signature. 
	 * @example function(packageName) { }
	 * @status Android
	 */
	getIsServiceRunning: function(serviceEnum, callback)
	{
		this._callbacks[this._callbackID] = callback;
		this._getIsServiceRunningSendGen(serviceEnum, this._callbackID);
		this._callbackID++;
	},


	app: function()
	{
		return this._app;
	},

	App: Class.subclass(
	/** @lends Device.IPCEmitter.App.prototype */
	{
		classname: 'App',

		/**
		 * @class Information about the app.
		 */
		initialize: function(sourceAppID, intentURL)
		{
			this._sourceAppID   = sourceAppID;
			this._intentURL     = intentURL;
		},

		/**
		 * information for checking if application has launched or resumed with custom URL scheme.
		 * @type String
		 */
		getID: function()
		{
			return this._sourceAppID;
		},

		/**
		 * Returns the URL used to launch this app, or an empty string if not launched via URL
		 * @type String
		 */
		getURL: function()
		{
			return this._intentURL;
		}
	}),

	Intent: Class.subclass(
	/** @lends Device.IPCEmitter.App.prototype */
	{
		classname: 'Intent',

		/**
		 * @class Information about the app.
		 */
		initialize: function(action, extras)
		{
			this._action   = action;
			this._extras   = extras;
		},

		/**
		 * information for checking if application has launched or resumed with custom URL scheme.
		 * @type String
		 */
		getAction: function()
		{
			return this._action;
		},

		/**
		 * Returns the URL used to launch this app, or an empty string if not launched via URL
		 * @type String
		 */
		getExtras: function()
		{
			return this._extras;
		}
	}),

	/**
	 * Create home screen shortcut icon.
	 * @param {String} name Displayed shortcut name
	 * @param {String} url Invoked url when icon clicked. 
	 * @param {String} icon_path Local file path that stores icon file.
	 * @status Android
	 */
	createShortcut: function( name, url, icon_path )
	{
		this._createShortcutSendGen(name, url, icon_path);
	},

	/**
	 * Create home screen shortcut icon with downloading its image.
	 * @param {String} name Displayed shortcut name.
	 * @param {String} url Invoked url when icon clicked. 
	 * @param {String} icon_url Icon image url.
	 * @param {Function} callback Callback function that passes a Boolean value whether download succeed. Below is the callback signature.
	 * @example function(hasDownloadError) { }
	 * @status Android
	 */
	createShortcutByIconUrl: function( name, url, icon_url, callback )
	{
                NgLogD("createShortcutByIconUrl called", name, url, icon_url);

                var df = new DownloadFile();
                var filename = 'shortcut_icon_image'+(new Date().getTime());
                var self = this;
                NgLogD("Icon download begin");
		Util.OperationWithRetries(function(failCb, abortCb) {
			df.start(filename, 'GET', icon_url, [], function( statusCode, fileSignature ) {
				NgLogD("Icon download finished status="+statusCode);
				if(statusCode == 200) {
					self.createShortcut( name, url, filename );
					FileSystem.deleteFile( filename, function() {
						if(callback)
							callback(false);
					});
				}
				else if(statusCode == 404)
				{
					NgLogE("Unable download icon file: icon_url="+icon_url+", status="+statusCode);
					abortCb();
				}
				else
				{
					NgLogE("Unable download icon file: icon_url="+icon_url+", status="+statusCode);
					failCb();
				}
			});
		},
		function() {
			NgLogE("Unable download icon file");
			if(callback)
				callback(true);
		}, 
		true);
	},

	// ------------------------------------------------------------------
	// private
	//

	/**
	 * invoked from native when the app is resumed back from other app.
	 */
	_onResumedFromOthers: function (url, sourceAppID)
	{
		this._app = new Device.IPCEmitter.App(sourceAppID, url);
		this.emit(this._app);

		//Cascade the original message back out to native for forwarding
		this._onResumeFromOthersSendGen(url, sourceAppID);
	},
	
	// Should only be called by privileged callers
	_setEmitIntents: function ( emit ) {
		this._shouldEmitIntents = Boolean(emit);
	},

	_onIntentReceived: function (action, extras)
	{
		console.log("On IntentReceived: " + action + " / " + JSON.stringify(extras));
		if (this._shouldEmitIntents) {
			this.emit( new exports.IPCEmitter.Intent(action, extras) );
		}
	},

	// private
	_canLaunchCallbackRecv: function( cmd )
	{
		var msg = {};
		if (! this._canLaunchCallbackRecvGen(cmd, msg))
			return;

		var func = this._callbacks[parseInt(msg.callbackID, 10)];
		if (func) {
			func(msg.canLaunch);
		}
	},

	_onResumeFromOthersRecv: function(cmd)
	{
		var msg = {};
		if (! this._onResumeFromOthersRecvGen(cmd, msg))
			return;

		this._onResumedFromOthers(msg.url, msg.sourceAppID);
	},

	_launchFailedRecv: function( cmd )
	{
		var msg = {};
		if (! this._launchFailedRecvGen(cmd, msg))
			return;

		var func = this._callbacks[parseInt(msg.callbackID, 10)];
		if (func) {
			func(msg.canLaunch);
		}
	},

	_getAppSignaturesCallbackRecv: function( cmd )
	{
		var msg = {};
		if (! this._getAppSignaturesCallbackRecvGen(cmd, msg))
			return;

		var func = this._callbacks[parseInt(msg.callbackID, 10)];
		if (func) {
			func(msg.signatures.split(','));
		}
	},

	_getCallingPackageCallbackRecv: function( cmd )
	{
		var msg = {};
		if (! this._getCallingPackageCallbackRecvGen(cmd, msg))
			return;

		var func = this._callbacks[parseInt(msg.callbackID, 10)];
		if (func) {
			func(msg.packageName);
		}
	},
	
	
	_getIsServiceRunningCallbackRecv: function( cmd )
	{
		var msg = {};
		if (! this._getIsServiceRunningCallbackRecvGen(cmd, msg))
			return;

		var func = this._callbacks[parseInt(msg.callbackID, 10)];
		if (func) {
			func(msg.running);
		}
	},
	
	_onIntentReceivedRecv: function( cmd )
	{
		var msg = {};
		if (! this._onIntentReceivedRecvGen(cmd, msg))
			return;
		
		this._onIntentReceived( msg.action, JSON.parse(msg.extras, 10) );
	},

// {{?Wg Generated Code}}
	
	// Enums.
	/** 
			* Enumeration for services whose status may be queried.
			* @namespace
			 */
	Service:
	{ 
		/** * */
		SystemDownloadProvider: 1,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 349
	// Method create = -1
	// Method canLaunch = 2
	// Method launch = 3
	// Method onResumeFromOthers = 4
	// Method launchFailed = 5
	// Method canLaunchCallback = 6
	// Method getAppSignatures = 7
	// Method getAppSignaturesCallback = 8
	// Method getCallingPackage = 9
	// Method getCallingPackageCallback = 10
	// Method launchIntent = 11
	// Method launchService = 12
	// Method onIntentReceived = 13
	// Method getIsServiceRunning = 14
	// Method getIsServiceRunningCallback = 15
	// Method createShortcut = 16
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 4:
					instance._onResumeFromOthersRecv( cmd );
					break;
				case 5:
					instance._launchFailedRecv( cmd );
					break;
				case 6:
					instance._canLaunchCallbackRecv( cmd );
					break;
				case 8:
					instance._getAppSignaturesCallbackRecv( cmd );
					break;
				case 10:
					instance._getCallingPackageCallbackRecv( cmd );
					break;
				case 13:
					instance._onIntentReceivedRecv( cmd );
					break;
				case 15:
					instance._getIsServiceRunningCallbackRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in IPCEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in IPCEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[349] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onResumeFromOthersRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.onResumeFromOthers from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in IPCEmitter.onResumeFromOthers from command: " + cmd );
			return false;
		}
		
		obj[ "sourceAppID" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "sourceAppID" ] === undefined )
		{
			NgLogE("Could not parse sourceAppID in IPCEmitter.onResumeFromOthers from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_launchFailedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.launchFailed from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in IPCEmitter.launchFailed from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in IPCEmitter.launchFailed from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_canLaunchCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.canLaunchCallback from command: " + cmd );
			return false;
		}
		
		obj[ "canLaunch" ] = Core.Proc.parseBool( cmd[ 0 ] );
		if( obj[ "canLaunch" ] === undefined )
		{
			NgLogE("Could not parse canLaunch in IPCEmitter.canLaunchCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in IPCEmitter.canLaunchCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_getAppSignaturesCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.getAppSignaturesCallback from command: " + cmd );
			return false;
		}
		
		obj[ "signatures" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "signatures" ] === undefined )
		{
			NgLogE("Could not parse signatures in IPCEmitter.getAppSignaturesCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in IPCEmitter.getAppSignaturesCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_getCallingPackageCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.getCallingPackageCallback from command: " + cmd );
			return false;
		}
		
		obj[ "packageName" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "packageName" ] === undefined )
		{
			NgLogE("Could not parse packageName in IPCEmitter.getCallingPackageCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in IPCEmitter.getCallingPackageCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_onIntentReceivedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.onIntentReceived from command: " + cmd );
			return false;
		}
		
		obj[ "action" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "action" ] === undefined )
		{
			NgLogE("Could not parse action in IPCEmitter.onIntentReceived from command: " + cmd );
			return false;
		}
		
		obj[ "extras" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "extras" ] === undefined )
		{
			NgLogE("Could not parse extras in IPCEmitter.onIntentReceived from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_getIsServiceRunningCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.getIsServiceRunningCallback from command: " + cmd );
			return false;
		}
		
		obj[ "running" ] = Core.Proc.parseBool( cmd[ 0 ] );
		if( obj[ "running" ] === undefined )
		{
			NgLogE("Could not parse running in IPCEmitter.getIsServiceRunningCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in IPCEmitter.getIsServiceRunningCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":349,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_canLaunchSendGen: function( url, callbackID )
	{
		Core.Proc.appendToCommandString( ":349,2," + this.__objectRegistryId + "," + Core.Base64.encode( url ) + "," + callbackID  );
	},
	
	/** @private */
	_launchSendGen: function( url, callbackID )
	{
		Core.Proc.appendToCommandString( ":349,3," + this.__objectRegistryId + "," + Core.Base64.encode( url ) + "," + callbackID  );
	},
	
	/** @private */
	_onResumeFromOthersSendGen: function( url, sourceAppID )
	{
		Core.Proc.appendToCommandString( ":349,4," + this.__objectRegistryId + "," + Core.Base64.encode( url ) + "," + Core.Base64.encode( sourceAppID )  );
	},
	
	/** @private */
	_getAppSignaturesSendGen: function( packageName, callbackID )
	{
		Core.Proc.appendToCommandString( ":349,7," + this.__objectRegistryId + "," + Core.Base64.encode( packageName ) + "," + callbackID  );
	},
	
	/** @private */
	_getCallingPackageSendGen: function( callbackID )
	{
		Core.Proc.appendToCommandString( ":349,9," + this.__objectRegistryId + "," + callbackID  );
	},
	
	/** @private */
	_launchIntentSendGen: function( intent, extras )
	{
		Core.Proc.appendToCommandString( ":349,11," + this.__objectRegistryId + "," + Core.Base64.encode( intent ) + "," + Core.Base64.encode( extras )  );
	},
	
	/** @private */
	_launchServiceSendGen: function( intent, extras )
	{
		Core.Proc.appendToCommandString( ":349,12," + this.__objectRegistryId + "," + Core.Base64.encode( intent ) + "," + Core.Base64.encode( extras )  );
	},
	
	/** @private */
	_getIsServiceRunningSendGen: function( serviceEnum, callbackID )
	{
		Core.Proc.appendToCommandString( ":349,14," + this.__objectRegistryId + "," + serviceEnum + "," + callbackID  );
	},
	
	/** @private */
	_createShortcutSendGen: function( name, url, icon_path )
	{
		Core.Proc.appendToCommandString( ":349,16," + this.__objectRegistryId + "," + Core.Base64.encode( name ) + "," + Core.Base64.encode( url ) + "," + Core.Base64.encode( icon_path )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// canLaunch: function( url, callbackID ) {}
	
	// launch: function( url, callbackID ) {}
	
	// _onResumeFromOthersRecv: function( cmd ) {}
	// onResumeFromOthers: function( url, sourceAppID ) {}
	
	// _launchFailedRecv: function( cmd ) {}
	// _canLaunchCallbackRecv: function( cmd ) {}
	// getAppSignatures: function( packageName, callbackID ) {}
	
	// _getAppSignaturesCallbackRecv: function( cmd ) {}
	// getCallingPackage: function( callbackID ) {}
	
	// _getCallingPackageCallbackRecv: function( cmd ) {}
	// launchIntent: function( intent, extras ) {}
	
	// launchService: function( intent, extras ) {}
	
	// _onIntentReceivedRecv: function( cmd ) {}
	// getIsServiceRunning: function( serviceEnum, callbackID ) {}
	
	// _getIsServiceRunningCallbackRecv: function( cmd ) {}
	// createShortcut: function( name, url, icon_path ) {}
	

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/LayoutEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/LayoutEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/LayoutEmitter'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class LayoutEmitter
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

exports.LayoutEmitter = Core.MessageEmitter.singleton(
/** @lends Device.LayoutEmitter.prototype */
{
	classname: 'LayoutEmitter',
	
	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	_layoutChangedRecv: function( cmd ) 
	{
		var msg = {};
		if(!this._layoutChangedRecvGen(cmd, msg))
			return;

 		this._width = msg['width'];
 		this._height = msg['height'];
 		//NgLogD("+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++JS received width as :"+ this._width + " and height as :" + this._height); 
		this.emit(msg);
		this._layoutChangedSendGen(msg.width, msg.height);
	},
	
	$getWidth: function()
	{
		return this._width;
	},
	
	$getHeight: function()
	{
		return this._height;
	},
	
	/**
	 * @private
	 */
	setWidthAndHeight: function(width, height) {
		//NgLogD("---------------------------------Setting width and height for LayoutEmitter directly from native ......... width is " + width + " and height is " + height );
		this._width = width;
		this._width = height;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 352
	// Method create = -1
	// Method layoutChanged = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._layoutChangedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in LayoutEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in LayoutEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[352] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_layoutChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in LayoutEmitter.layoutChanged from command: " + cmd );
			return false;
		}
		
		obj[ "width" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "width" ] === undefined )
		{
			NgLogE("Could not parse width in LayoutEmitter.layoutChanged from command: " + cmd );
			return false;
		}
		
		obj[ "height" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "height" ] === undefined )
		{
			NgLogE("Could not parse height in LayoutEmitter.layoutChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":352,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_layoutChangedSendGen: function( width, height )
	{
		Core.Proc.appendToCommandString( ":352,2," + this.__objectRegistryId + "," + width + "," + height  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _layoutChangedRecv: function( cmd ) {}
	// layoutChanged: function( width, height ) {}
	

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Appdata'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Appdata'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Appdata'] = exports; var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

/**
 * @class 
 * @name Social.Common.Appdata
 * @description
 * Mobage provides a common API for application data, which you can use for both Japan and the US. 
 * <code>Appdata</code> is consistent with the Open Social <code>osapi.appdata</code> interface, 
 * and enables the application to store name/value pairs for arbitrary application data.
 * To add or update application data, call <code>updateEntries()</code>. To retrieve entries, call <code>getEntries()</code>. 
 * To delete entries, call <code>deleteEntries()</code>.
 * @see Social.US.AppData for additional Mobage persistence facilities.
 * @see Storage.KeyValue for additional ngCore persistence facilities.
 * @see Storage.FileSystem for additional ngCore persistence facilities.
 */
exports.Appdata = {
		
	/**
	 * Retrieves a hash of one or more key/value pairs.
	 * If the <code>keys</code> parameter is <code>null</code>, <code>undefined</code> or an empty array, <code>getEntries()</code> 
	 * returns all key/value pairs to the callback function.
	 *
	 * @name Social.Common.Appdata.getEntries
	 * @function
	 * @public
	 * 
	 * @param {Array} keys Set as an array of key names. For example, <code>['key1', 'key2']</code>.
	 * @param {Function} callback Retrieves a hash of key/value pairs. If an error occurs, retursn an error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var entries = {"key1": "value1", "key2": "value2"};
     * ...
     * function(error, entries){
     * &nbsp;&nbsp;   if (error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorDesc = error.description;
     * &nbsp;&nbsp;   } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var retrievedEntries = entries;
     * &nbsp;&nbsp;   }
	 * }
	 * </pre>
	 * @see Social.Common.Appdata.updateEntries
	 * @example 
	 * Appdata.getEntries(['key1', 'key2'], callback );
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	getEntries: function(keys, callback) {
		var cmd = {apiURL:"Common.Appdata.getEntries", keys:keys, callbackFunc:callback};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);		
	},
	
	/**
	 * Inserts or updates the submitted key/value pairs. 
	 * <b>Note:</b> Limited to 30 key/value pairs per user, per game. 
	 * Maximum key name limited to 32 bytes. Maximum value limited to 1,024 bytes.
     * To use key/value pairs without the foregoing constraints, use <code>Storage.KeyValue</code>
     * in ngCore.
	 *
	 * @name Social.Common.Appdata.updateEntries
	 * @function
	 * @public
	 * 
	 * @param {Hash} entries Takes a hash of key/value pairs. For example, <code>{"favoriteMovie": "Pulp Fiction", "petName": "Rover"}</code>.
	 * @param {Function} callback Retrieves the updated entries. If an error occurs, returns an error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var entries = {"favoriteMovie": "Pulp Fiction", "petName": "Rover"};
     * ...
     * function(error, entries){
     * &nbsp;&nbsp;   if (error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorDesc = error.description;
     * &nbsp;&nbsp;   } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var updatedEntries = entries;
     * &nbsp;&nbsp;   }
	 * }
	 * </pre>
	 * @see Social.Common.Appdata.getEntries
	 * @example
	 * Appdata.updateEntries(
	 *              {   'favoriteMovie':'Pulp Fiction',    
	 *                  'petName':'Rover' }, 
	 *              callback );
	 * @status iOS, Android, Test, iOSTested, AndroidTested
     * @see Social.US.AppData for additional Mobage persistence facilities.
     * @see Storage.KeyValue for additional ngCore persistence facilities.
     * @see Storage.FileSystem for additional ngCore persistence facilities.
	 */		
	updateEntries: function(entries, callback) {
		if(entries) {
			var cmd = {apiURL:"Common.Appdata.updateEntries", entries:entries, callbackFunc:callback};
			GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
		} else {
			if(typeof callback === 'function') {
				callback({ 
						errorCode: 400,
						description: "Entries to update are a required parameter"
					}, null);
			}
		}
	},
	
	
	/**
	 * Deletes one or more key/value pairs.
	 *
	 * @name Social.Common.Appdata.deleteEntries
	 * @function
	 * @public
	 * 
	 * @param {Array} keys Takes an array of key names. For example, <code>['petName']</code>. 
     * If <code>null</code>, the return object in the callback is not defined.
	 * @param {Function} callback  Retrieves a hash of the deleted entries. If an error occurs, returns an error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var keys = {"petName"};
     * ...
     * function(error, keys){
     * &nbsp;&nbsp;   if (error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorDesc = error.description;
     * &nbsp;&nbsp;   } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var deletedKeys = keys;
     * &nbsp;&nbsp;   }
	 * }
	 * </pre>
	 * @example
	 * Appdata.deleteEntries(['petName'], callback );
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	deleteEntries: function(keys, callback) {
		if(keys && keys.length > 0) {
			var cmd = {apiURL:"Common.Appdata.deleteEntries", keys:keys, callbackFunc:callback};
			GSGlobals.getRouterInstance().sendCommandToGameService(cmd);		
		} else {
			if(typeof callback === 'function') {
				callback({ 
						errorCode: 400,
						description: "Keys to delete are a required parameter"
					}, null);
			}
		}
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Auth'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Auth'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Auth'] = exports; var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

/**
 * @class
 * @name Social.Common.Auth
 * @description
 * Retrieves a verification code.
 * Games call <code>Auth.authorizeToken()</code> if the game server is using the Mobage REST API.
 * For more information, refer to the Mobage RESTful API Conventions section of the developer's guide.
 */
exports.Auth = {
		
		
	/**
	 * Authorizes a temporary credential and returns a verification code.
	 *
	 * 
	 * @name Social.Common.Auth.authorizeToken
	 * @function
	 * @public
	 *
	 * @param {String} token The temporary credential identifier. 
	 * @param {Function} callback The callback function that handles the verification code and errors.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 *  <pre class="code">
     *  var verifier = "jklmnop";
	 *  function(error, verifier){
     *  &nbsp;&nbsp; if (error){
	 *  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 *  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	 *  &nbsp;&nbsp; } else {
     *  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var verificationCode = verifier;    
     *  &nbsp;&nbsp; }
     *  }
	 * </pre>
	 * @example
	 * var token = "abcdefghi";
     * ...
	 * Social.Common.Auth.authorizeToken (token, callback);
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	authorizeToken: function(token, callback) {
		var cmd = {apiURL:"Common.Auth.authorizeToken", token:token, callbackFunc: callback };
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);		
		//callback(error, verifier)
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Blacklist'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Blacklist'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Blacklist'] = exports; var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

/**
 * @class 
 * @name Social.Common.Blacklist
 * @description
 * Provides an interface for checking the user's blacklist.
 */
exports.Blacklist = {

	/**
	 * Retrieves the target user ID from the specified user's blacklist.
	 * This call passes a user ID and a target user ID to determine if the specified target user is blacklisted. 
	 * If the target user ID parameter is <code>null</code>, this call retrieves the entire blacklist. The callback function also receives the total number of 
	 * target user IDs, the starting index, and the number of target IDs returned for paging the results.
	 *
	 * @name Social.Common.Blacklist.checkBlacklist
	 * @function
	 * @public
	 *
	 * @param {String} userId The user ID for the user who owns the blacklist. 
	 * @param {String} targetUserId The target user ID to check in the blacklist. <br/>If <code>null</code>, it checks the entire blacklist.
	 * @param {Hash} opt Takes a hash containing the start index and count for pagination. <br/>E.g., <code>{'start': 1, 'count': 100}</code> 
     * Requires start index and count. The minimum start index is 1. 
     * If <code>null</code>, undefined or an empty array, the start index is 1 and the count is 50.
	 * @param {Function} callback Retrieves an array of user IDs found in the blacklist. Otherwise, it retrieves an empty array.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var listedUsers = ['user1', 'user2'];
     * ...
     * function(error, listedUsers, result)
	 * &nbsp;&nbsp;		{
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			var blackListedUsers = listedUsers;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			var total = result.total;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			var start = result.start;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			var count = result.count;
  	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			var errorCode = error.errorCode;
  	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			var errorDesc = error.description;
  	 * &nbsp;&nbsp;	}
  	 * </pre>
  	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */			
	checkBlacklist: function(userId, targetUserId, opt, callback) {
		var cmd = {apiURL:"Common.Blacklist.checkBlacklist", userId:userId, targetUserId:targetUserId, opt:opt, callbackFunc: function(error, args) {
			callback(error, args.users, args.result);
		}};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);		
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Config'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Config'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Config'] = exports; var Session = require('NGCore/Client/Social/US/Data/Session').Session;

/**
 * @class 
 * @name Social.Common.Config
 * @description
 * Mobage provides a common API to determine if the server is a sandbox server or a production server. 
 */
exports.Config = {

    /**
    * Returns whether the server is a sandbox server or a production server. 
    * Returns "unknown" if it cannot retrieve the current session
    * or if the server mode is not "sandbox" or "production."
    * 
    * @name Social.Common.Config.getServerEnvironment
    * @public
    * @function
    * @returns {String} "sandbox," "production" or "unknown."
    * @see Social.US.Session.serverModes
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */
	getServerEnvironment: function(){
		var session = Session.getCurrentSession();
		if(!session){
			return "unknown";
		}
		
		var serverMode = Session.getCurrentSession().serverMode();
		if(serverMode == Session.serverModes.production){
			return "production";
		}else if(serverMode == Session.serverModes.sandbox){
			return "sandbox";
		}else{
			return "unknown";
		}
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/People'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/People'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/People'] = exports; var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

/**
 * @class 
 * @name Social.Common.People
 * @description
 * The social API for returning user objects with their social graphs. The user object
 * retrieved varies from platform to platform. US platform required fields are <code>id</code>, <code>displayName</code>, <code>hasApp</code> 
 * and <code>thumbnailUrl</code> of the <code>Person</code> data type.
 */
exports.People = {
	
	/**
	 * Retrieves fields for the specified user from the <code>Person</code> data type. The specified user corresponds to the user ID parameter.
	 * Below are the fields returned by this call:
	 * <ul>
	 * <li><code>id</code></li>
	 * <li><code>displayName</code></li>
	 * <li><code>hasApp</code></li>
	 * <li><code>thumbnailUrl</code></li>
	 * </ul>
	 * Use the <code>fields</code> parameter to retrieve non-required fields of the <code>Person</code> data type.
	 *
	 * @name Social.Common.People.getUser
	 * @function 
	 * @public 
	 *
	 * @param {String} userId The user ID of the user to retrieve.
	 * @param {Array} fields An array of non-required fields of the <code>Person</code> data type to include in the response to the callback. 
     * <br/>For example, <code>['nickname','aboutMe']</code>. If <code>null</code>, <code>undefined</code> or an empty array, this call only retrieves the required fields.
	 * @param {Function} callback Retrieves the user specified by the <code>userId</code> parameter. If an error occurs, returns an error code and error description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, user){
     * &nbsp;&nbsp; if (error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     * &nbsp;&nbsp; } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var retrievedUser = user;
     * &nbsp;&nbsp;}
	 * }</pre>
	 * @see Social.Common.People.getCurrentUser
	 * @example
	 * var recordID = 2;
	 *
	 * Social.Common.People.getUser(recordID, 
	 *                              ['id','nickname','aboutMe'], 
	 *                              callback
	 *		});
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */						
	getUser: function(userId, fields, callback) {
		var cmd = {apiURL:"Common.People.getUser", userId:userId, fields:fields, callbackFunc:callback};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	 * Retrieves an array of users.
	 * Takes one or more user IDs and retrieves an array of users with the callback. 
	 * Retrieves up to 100 users, with no guarantee of retrieving the user array 
	 * in the order specified.
	 * Retrieves the <code>id</code>, <code>displayName</code>, <code>hasApp</code> 
	 * and <code>thumbnailUrl</code> fields of the <code>Person</code> data type for each user.
	 * To retrieve non-required fields of the <code>Person</code> data type, specify the non-required fields 
	 * desired in the <code>fields</code> parameter.
	 *	 
	 * @name Social.Common.People.getUsers
	 * @function 
	 * @public
	 * 
	 * @param {Array} userIds An array of user IDs of the users to retrieve. Minimum array size is 1, and maximum is 100.
	 * @param {Array} fields An array of non-required fields of the <code>Person</code> data type to include in the callback. <br/>For example, <code>['nickname','aboutMe']</code>.
     * <br/>If <code>null</code>, <code>undefined</code> or an empty array, it retrieves only the required fields.
	 * @param {Function} callback Retrieves an array of users specified by the <code>userIds</code> parameter and/or an error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, users){
     * &nbsp;&nbsp; if (error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     * &nbsp;&nbsp; } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var retrievedUsers = users;
     * &nbsp;&nbsp;}
	 * }</pre>
	 * @see Social.Common.People.getUser
	 * @example
	 * People.getUsers([1,2,3],null, callback);
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */				
	getUsers: function(userIds, fields, callback) {
		var cmd = {apiURL:"Common.People.getUsers", userIds:userIds, fields:fields, callbackFunc:function(errors, args) {
			callback(errors, args.users, args.results);
		}};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	
	/**
	 * Retrieves fields for the current user from the <code>Person</code> data type. Below are the fields returned by this call:
	 * <ul>
	 * <li><code>id</code></code>
	 * <li><code>displayName</code></li>
	 * <li><code>hasApp</code></li>
	 * <li><code>thumbnailUrl</code></li>
	 * </ul>
	 *
	 * @name Social.Common.People.getCurrentUser
	 * @function
	 * @public
	 *
	 * @param {Array} fields An array of non-required fields of the <code>Person</code> data type to include in the callback. <br/>For example, <code>['nickname','aboutMe']</code>.
     * <br/>If <code>null</code>, <code>undefined</code> or an empty array, this call only retrieves the required fields.
	 * @param {Function} callback Retrieves the current user. If an error occurs, returns an error code and error description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, user){
     * &nbsp;&nbsp; if (error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     * &nbsp;&nbsp; } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var currentUser = user;
     * &nbsp;&nbsp;}
	 * }</pre>
	 * @see Social.Common.People.getUser
	 * @example
	 * People.getCurrentUser(null, callback);
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */				
	getCurrentUser: function(fields, callback) {
		var cmd = {apiURL:"Common.People.getCurrentUser", fields:fields, callbackFunc:callback};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	
	/**
	 * Retrieves fields for friends of a specified user. Below are the fields returned by this call:
	 * <ul>
	 * <li><code>id</code></li>
	 * <li><code>displayName</code></li>
	 * <li><code>hasApp</code></li> 
	 * <li><code>thumbnailUrl</code></li>
	 * </ul>
	 *
	 * @name Social.Common.People.getFriends
	 * @function
	 * @public
	 * 
	 * @param {String} userId The user ID of the user whose friends are retrieved by the callback function. 
	 * @param {Array} [fields] An array of non-required fields of the <code>Person</code> data type to include in the response to the callback. 
     * <br/>For example, <code>['nickname','aboutMe']</code>.
     * <br/> If <code>null</code>, <code>undefined</code> or an empty array, this call only retrieves the required fields.
	 * @param {Hash} [opt] A hash containing the start index and count for pagination. <br/>For example, <code>{'start': 1, 'count': 100}</code> 
	 * @param {Function} callback Retrieves the friends of the given user. If an error occurs, returns an error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, friends){
     * &nbsp;&nbsp; if (error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     * &nbsp;&nbsp; } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var retrievedFriends = friends;
     * &nbsp;&nbsp;}
	 * }</pre>
	 * @see Social.Common.People.getFriendsWithGame
	 * @example
	 * People.getFriends(4, null, {'start': 2}, callback);
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */					
	getFriends: function(userId, fields, opt, callback) {
		var cmd = {apiURL:"Common.People.getFriends", userId:userId, fields:fields, opt:opt, callbackFunc: function(errors, args) {
			callback(errors, args.users, args.results);
		}};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	
	/**
	 * Retrieves a list of the user's friends playing the current game.
	 *
	 * @name Social.Common.People.getFriendsWithGame
	 * @function
	 * @public
	 *
	 * @param {String} userId The user ID of the person whose friends play the current game.
	 * @param {Array} fields An array of non-required fields of the <code>Person</code> data type to include in the response to the callback. 
     * <br/>For example, <code>['nickname','aboutMe']</code>.
     * <br/> If <code>null</code>, <code>undefined</code> or an empty array, this call retrieves only the required fields.
	 * @param {Hash} opt A hash containing the start index and count for pagination. <br/>For example, <code>{'start': 1, 'count': 100}</code> 
	 * @param {Function} callback Retrieves the friends of the specified user. If an error occurs, returns an error code and error description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, friends){
     * &nbsp;&nbsp; if (error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     * &nbsp;&nbsp; } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var retrievedFriends = friends;
     * &nbsp;&nbsp;}
	 * }</pre>
	 * @see Social.Common.People.getFriends
	 * @example 
	 * People.getFriendsWithGame(4, null, null, callback);
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */						
	getFriendsWithGame: function(userId, fields, opt, callback) {
		var cmd = {apiURL:"Common.People.getFriendsWithGame", userId:userId, fields:fields, opt:opt, callbackFunc: function(errors, args) {
			callback(errors, args.users, args.results);
		}};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	}
	
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Profanity'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Profanity'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Profanity'] = exports; var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');	

/**
 * @class 
 * @name Social.Common.Profanity
 * @description
 * Provides an interface to check games for profanity.
 */
exports.Profanity = {
	
	/**
	 * Checks a text string to determine if it contains profanity.
	 * This call only conducts a check and does not attempt to cleanup the string.<br><br>
	 * <b>Note:</b> The server handles locale and language automatically.
	 *
	 * @name Social.Common.Profanity.checkProfanity
	 * @function
	 * @public
	 * 
	 * @param {String} text The string to check for profanity.
	 * @param {Function} callback Retrieves any profane words or phrases in the text parameter. 
     * The result of checking is either <code>true</code> or <code>false</code>. If the result is <code>false</code>, the text string contains profanity. 
     	 * If an error occurs, returns an error code and error description to the callback.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class='code'>function(error, args){
     * &nbsp;&nbsp; if(error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorDesc = error.description;
     * &nbsp;&nbsp;} else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var profanity = args.profanity;
     * &nbsp;&nbsp;}
	 * }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	checkProfanity: function(text, callback) {
		var cmd = {apiURL:"Common.Profanity.checkProfanity", text:text, callbackFunc:function(error, args) {
			callback(error, args.profanity);
		}};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);		
	}	
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Request'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Request'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Request'] = exports; var Class = require('NGCore/Client/Core/Class').Class;


//Don't need to document
exports.Request = Class.subclass({
	execute: function(callback) {
		// [call US function here]	
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Service'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Service'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Service'] = exports; var UI = require('NGCore/Client/UI').UI;

var RouterInited = require('NGCore/Client/Social/_Internal/RouterInit');
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;

var ButtonOverlays = require('NGCore/Client/Social/US/Service/ButtonOverlays').ButtonOverlays;
var Friends = require('NGCore/Client/Social/US/Service/Friends').Friends;
var Profile = require('NGCore/Client/Social/US/Service/Profile').Profile;
var User    = require('NGCore/Client/Social/US/Models/User').User;

/**
 * @class 
 * @name Social.Common.Service
 * @description
 * This interface provides the following social game services: <br/>
 * <div class="ul">
 * <li>Balance Button</li>
 * <li>Community Button</li>
 * <li>Friend Picker</li>
 * <li>User Finder</li>
 * <li>User Profile</li>
 * </div>
 */
exports.Service = {

	
	/**
	* Opens the user finder screen.
	* The user finder provides a way for users to find other users using the following filters:
	* <ul>
	* <li>Suggested Friends</li>
	* <li>Contacts</li> 
	* <li>Requests</li>
	* <li>Search</li>
	* </ul>
	*
	* @name Social.Common.Service.openUserFinder 
	* @function
	* @public
	* @status iOS, Android, Test, iOSTested, AndroidTested
    */		
	openUserFinder: function() {
		Friends.showFindFriends(undefined);
	},

	
	/**
	* Opens the friend picker.
	*
	* @name Social.Common.Service.openFriendPicker 
	* @function
	* @public 
	* 
	* @param {Number} maxFriendsToSelect The maximum number of friends the user may select.
	* @param {Function} callback The callback function called after the view closes. Returns an array of friends.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error, friendUserIds){
	* 	&nbsp;&nbsp;&nbsp;if (error){
	* 	&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  		var errorCode = error.errorCode;
	*   &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  		var errorDesc = error.description;
	* 	&nbsp;&nbsp;&nbsp;} else {
	*   &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  		var pickedFriends = friendUserIds;
	*   &nbsp;&nbsp;&nbsp;  	}
	*   &nbsp;&nbsp;  }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	openFriendPicker: function(maxFriendsToSelect, callback) {
		Friends.showFriendPicker(maxFriendsToSelect, function(err, friends){
			var userIDs = [];
			friends = friends || [];
			for(var idx = 0; idx < friends.length; idx++){
				userIDs.push(friends[idx].recordID);
			}
			callback( userIDs );
		});
	},

	
	/**
	* Opens the specified profile page.
	*
	* @name Social.Common.Service.openUserProfile 
	* @function
	* @public 
	* 
	* @param {String} userId The user ID or gamer name of the profile page to open.
	* @param {Function} callback The callback function if there is an error with the user ID or gamer name.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	openUserProfile: function(userId, callback) {
		if(typeof userId == "string"){
			// if the userId string contains no non-numeral characters:
			//   parse it into a number
			// else null it out, because it's not a valid userId
			if(userId.match(/[^0-9]/) === null){
				userId = parseInt(userId, 10);
			}else{
				userId = null;
			}
		}
		
		if( !userId ){
			callback({errorCode: 400, description: "userid is invalid"});
		}
		else{
			User.getUserWithID(userId, function(err, user){
				if(err){
					if( err==="Sorry, we can't find anyone with that name." ){
						callback({errorCode: 404, description: err});
					} else {
						callback({errorCode: 500, description: err});
					}
				}else if(!user){
					callback({errorCode: 404, description: "User not found"});
				}else{
					Profile.showUserProfile(user, undefined);
				}
			});
	}
	},


	/**
	* Displays the <b>Mobage Community</b> button.
	*	
	* @name Social.Common.Service.showCommunityButton
	* @function
	* @public 
	* 
	* @param {exports.Gravity} gravity Displays the button in the specified corner. 
    * <b>Note:</b> Only supported for the US. Japan uses the top-left corner only.
	* @param {String} theme Displays the theme for the button (for example, "default", "dark", "light"). 
    * <b>Note:</b> Only supported for Japan. You can specify <code>null</code> for the US region.
	* @param {Function} callback The callback function if there is an error related
    * to <code>gravity</code> or <code>theme</code> usage.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @see exports.Gravity
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/           
	showCommunityButton: function(gravity, theme, callback) {
		ButtonOverlays.showCommunityButton(gravity, callback);
	},

	/**
	* Hides the <b>Mobage Community</b> button.
	*
	* @name Social.Common.Service.hideCommunityButton
	* @function
	* @public 
	*	
	* @param {Function} callback The callback function if there is an error hiding the button.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/		
	hideCommunityButton: function(callback) {
		ButtonOverlays.hideCommunityButton(callback);
	},

	
	/**
	* A message emitter object for adding a message emitter when inviting a user.
	*
	* @name Social.Common.Service.invitedUserEmitter
	* @field
	* @public
	* @example 
	* Social.Common.Service. ...
	* ... invitedUserEmitter.addListener(
	*			new Core.MessageListener(), 
	*			function(userId){
	*				NgLogD("New Emitter! " + userId);
	*			}
	*		);
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/
	invitedUserEmitter : new MessageEmitter(),

	
	/**
	 * Shows the balance button where the <code>rect</code> parameter 
	 * determines the size and position of the button.
     * The minimum size of the button is:<br/>
     * <ul>
     * <li>10% of height in Landscape, and the absolute minimum size is 150 x 50.</li>
     * <li>6% of height in Portrait, and the absolute minimum size is 150 x 50.</li>
     	 * </ul>
	 *
	 * @name Social.Common.Service.showBalanceButton
	 * @function
	 * @public
	 *	 
	 * @param {UI.ViewGeometry.Rect} rect Determines the size and position of the balance button.
	 * @param {Function} callback The callback function if there is an error with the <code>rect</code> parameter.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	 * &nbsp;&nbsp;   }
	 * </pre>
	 * @see UI.ViewGeometry.Rect
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	showBalanceButton: function(rect, callback) {		
		ButtonOverlays.showBalanceButton(rect, callback);
	},
	
	/**
	 * Hides the balance button.	
	 * @name Social.Common.Service.hideBalanceButton
	 * @function
	 * @public 
	 * 
	 * @param {Function} callback The callback function called after the view closes.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	 * &nbsp;&nbsp;   }
     * </pre>
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	hideBalanceButton: function(callback) {
		ButtonOverlays.hideBalanceButton(callback);
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Analytics'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Analytics'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Analytics'] = exports; var SessionReq = require('NGCore/Client/Social/US/Data/Session');

/**
 * @private
 * @name Social.Common.Analytics
 * @description Private interface for analytics data
 *
 * TODO: These should be going into the priv interpreter. But need to check with Japan.
 */
exports.Analytics = {
  getUserId: function() {
	var cur_sess =	this._getSession(), cur_u = null;
	if (cur_sess) {
	  cur_u = (cur_sess.user() || {}).recordID;
	}
	return cur_u;
  },
  getUsername: function() {
	var cur_sess =	this._getSession(), cur_u = null;
	if (cur_sess) {
	  cur_u = (cur_sess.user() || {}).gamertag;
	}
	return cur_u;
  },
  getPlatformVersion: function() {
	var cur_sess =	this._getSession(), cur_pver = null;
	if (cur_sess) {
	  cur_pver = cur_sess.platformVersion();
	}
	return cur_pver;
  },
  getServiceId: function() { 
	return "US"; 
  },
  _getSession: function() {
	return SessionReq.Session.getCurrentSession();
  }
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/DataModel'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/DataModel'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/DataModel'] = exports; var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
var SocialR = require('NGCore/Client/Social');
var SessionR        = require('NGCore/Client/Social/US/Data/Session');
var DispatcherR     = require('NGCore/Client/Social/US/Data/Dispatcher');

/**
 * <code>DataModel</code> constructs objects that emit messages when properties of an object change, and provides automatic caching,
 * serialization and deserialization between interpreters. 
 * <br/><br/>
 * <b>Note:</b> Do not instantiate this class directly. Use classes derived from <code>DataModel</code> for instantiation. These include:
 * <div class="ul">
 * <li>{@link Social.US.User}</li>
 * <li>{@link Social.US.AppData}</li>
 * <li>{@link Social.US.Game}</li>
 * <li>{@link Social.US.Score}</li>
 * <li>{@link Social.US.Leaderboard}</li>
 * </div>
 * @class 
 * @name Social.US.DataModel
 */
var DataModel = exports.DataModel = MessageEmitter.subclass({
		
	/**
	 * The default constructor.
	 * @constructs
	 * @private
	 */		
	initialize: function(recordID){
		this.recordID = recordID;

		this._cache();
	},
	beginChanges: function(){
		DispatcherR.Dispatcher.beginBatching();
	},
	endChanges: function(){
		DispatcherR.Dispatcher.endBatching();
	},
	_classname: function(){
		var classname = this.classname;
		return classname;
	},
	_cache: function(){
		if(!this._dataCache){
			var session = SessionR.Session.getCurrentSession();
			if(session){
				var cache = session.dataCache();
				if(cache){
					cache.addObject(this);
					this._dataCache = cache;
				}
			}
		}
		return this._dataCache;
	},
	$_serializedDataModel: function(obj){
		if(obj instanceof(DataModel)){
			obj = {
				classname: obj.classname,
				recordID:  obj.recordID
			};
		}
		return obj;
	},
	$_deserializedDataModel: function(value, cache){
		if(value && value.hasOwnProperty && value.hasOwnProperty("classname") && value.hasOwnProperty("recordID")){
			var theClassname = value.classname;
			var theClass = SocialR.Social.US[theClassname];
			var theRecordID = value.recordID;
			if(theClass && theRecordID){
				var theInstance = cache.getObjectWithRecordID(theClassname, theRecordID);
				if(!theInstance){
					theInstance = new theClass(theRecordID);
				}
				
				theInstance._deserializeFromHash(value.data);
				cache.addObject(theInstance);
    
				value = theInstance;
			}
		}
		return value;
	},
	_serializedHash: function(full){
		var theClass = this.constructor;
		var hash = {classname: theClass.classname, recordID: this.recordID};
		if(full === false){
			return hash; // if it's undefined, assume we want all the data
		}
		
		hash.data = {};
		
		var properties = this.constructor.properties || [];
		for(var idx = 0; idx < properties.length; idx++){
			var propertyName = properties[idx];
			var propertyValue = this[propertyName];

			if(propertyValue instanceof(Array)){
				for(var propertyIndex = 0; propertyIndex < propertyValue.length; propertyIndex++){
					propertyValue[propertyIndex] = DataModel._serializedDataModel(propertyValue[propertyIndex]);
				}
			}else{
				propertyValue = DataModel._serializedDataModel(propertyValue);
			}
			
			hash.data[propertyName] = propertyValue;
		}
		
		return hash;
	},
	_deserializeFromHash: function(data){
		if(!data){
			NgLogD("No public hash data for " + this.classname + " " + this.recordID);
			return;
		}
		
		var cache = this._cache();
		for(var key in data){
			var value = data[key];
			if(value instanceof(Array)){
				for(var propertyIndex = 0; propertyIndex < value.length; propertyIndex++){
					value[propertyIndex] = DataModel._deserializedDataModel(value[propertyIndex], cache);
				}
			}else{
				value = DataModel._deserializedDataModel(value, cache);
			}
			this[key] = value;
		}
	}
});

DataModel._oldSubclass = DataModel.subclass;
DataModel.subclass = function(contents){
	var theClass = DataModel._oldSubclass(contents);
	var properties = contents.properties || [];
	for(var idx = 0; idx < properties.length; idx++){
		var propertyName = properties[idx];
		
		(function(name){
			theClass.prototype.__defineSetter__(name, function(value){
				this["___" + name] = value;
				
				var msg = {};
				msg[""+name] = value;
				
				this.emit(msg);
			});
			theClass.prototype.__defineGetter__(name, function(value){
				return this["___" + name];
			});
		})(propertyName);
	}
	return theClass;
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/User'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/User'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/User'] = exports; var DataModelR  = require('NGCore/Client/Social/US/Models/DataModel');
var Dispatcher  = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;
var OrderedList = require('NGCore/Client/Social/US/Models/OrderedList').OrderedList;
var Social      = require('NGCore/Client/Social').Social;

/**
* <code>User</code> constructs objects that provide a service interface for the current user. 
* <code>User</code> objects enable the current user to retrieve:
* <div class="ul">
* <li>user details</li>
* <li>a list of friends</li>
* <li>games</li>
* </div>
* @class
* @name Social.US.User
* @augments Social.US.DataModel
*/
var User = exports.User = DataModelR.DataModel.subclass({
		
    /**
    * @constructs
    * @ignore
    */
	classname: "User",

	 /**
	 * The user's gamer tag. Read-only.
	 * @name Social.US.User.gamertag
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * The user's avatar ID. Read-only.
	 * @name Social.US.User.avatarId
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The user's motto. Read-only.
	 * @name Social.US.User.motto
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The relation to this user. Read-only.
	 * @name Social.US.User.relation
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * Sparse limits attributes in search results. Read-only.
	 * @name Social.US.User.sparse
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The user's photo ID. Read-only.
	 * @name Social.US.User.photoId
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The user's email address. Read-only.
	 * @name Social.US.User.emailAddress
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * A hash of the user's email address. Read-only.
	 * @name Social.US.User.emailHash
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The user's phone number. Read-only.
	 * @name Social.US.User.phoneNumber
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */


	 /**
	 * The user's password. Read-only.
	 * @name Social.US.User.password
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The user's first name. Read-only.
	 * @name Social.US.User.firstName
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */


	 /**
	 * The user's last name. Read-only.
	 * @name Social.US.User.lastName
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * Whether to hide the user's full name. Read-only.
	 * @name Social.US.User.hideFullName
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * Whether the user is age restricted. Read-only.
	 * @name Social.US.User.ageRestricted
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * Whether the relationship to the user is new. Read-only.
	 * @name Social.US.User.isNewRelationship
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * Whether the user is a mutual friend. Read-only.
	 * @name Social.US.User.isMutualFriend
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * Whether the user shows his/her presence. Read-only.
	 * @name Social.US.User.showsPresence
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * Whether the user only shows friend notifications. Read-only.
	 * @name Social.US.User.setOnlyShowFriendNotifications
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	 

	 /**
	 * The user's capabilities. Read-only.
	 * @name Social.US.User.capabilities
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The user's gamer score. Read-only.
	 * @name Social.US.User.gamerscore
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	 

	 /**
	 * The user's gamer level. Read-only.
	 * @name Social.US.User.gamerLevel
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	 

	 /**
	 * The user's gamer level name. Read-only.
	 * @name Social.US.User.gamerLevelName
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The gamer level score. Read-only.
	 * @name Social.US.User.gamerLevelScore
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The gamer score for the next level. Read-only.
	 * @name Social.US.User.gamerNextLevelScore
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The user's games. Read-only.
	 * @name Social.US.User.games
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	properties: [
		// public
		"gamertag",
		"avatarId",
		"motto",
		"relation",
		"sparse",
		"photoId",
		"emailHash",
		"ageRestricted",
		"isMutualFriend",
		
		// private
		"phoneNumber",
		"password",
		"firstName",
		"lastName",
		"hideFullName",
		"emailAddress",
		"isNewRelationship",
		"showsPresence",
		"onlyShowFriendNotifications",
		"capabilities",
		"gamerscore",
		"gamerLevel",
		"gamerLevelName",
		"gamerLevelScore",
		"gamerNextLevelScore",
		"games"
	],
	
	/**
	 * @constructs The default constructor constructs <code>User</code> objects.
	 * @name Social.US.User.initialize 
	 * @private
	 */
	initialize: function($super, recordID){
		$super(recordID);
		NgLogD("User Public! " + recordID + " " + this.recordID);
	},
	
	
	/**
	* Adds a user to the buddies list and ensures the added user is not on the blocked users list.
	* @name Social.US.User.addBuddy
	* @function
	* @private
	*
	* @param {Social.US.User} buddy The user to add to the buddies list. If not a user, the callback error is "No user."
	* @param {Function} cb The callback function.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error, data){
    * &nbsp;&nbsp;  if (error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var buddyData = data;
    * &nbsp;&nbsp;  }
	* }
	* </pre>	
	*/	
	addBuddy: function(buddy, cb){
		Dispatcher.callMethodOnRemoteObject(this, "addBuddy", [buddy, cb]);
	},
	
	
	/**
	* Removes a user from the buddies list.
	* @name Social.US.User.removeBuddy
	* @function
	* @private
	*
	* @param {User} buddy The user to remove from the buddies list. If not a user, the callback error is "No user."
	* @param {Function} cb The callback function.
	* <br/> 
	* <b>Callback Example:</b>
	* <pre class="code">function(error, data){
    * &nbsp;&nbsp;  if (error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var buddyData = data;
    * &nbsp;&nbsp;  }
	* }
	* </pre>
	*/		
	removeBuddy: function(buddy, cb){
		Dispatcher.callMethodOnRemoteObject(this, "deleteBuddy", [buddy, cb]);
	},
	
	
	/**
	* Retrieves a user object with all of the this user's details.
	*
	* @name Social.US.User.getUserDetails
	* @function
	* @public
	* 
	* @param {Function} cb The callback function.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error, user){
    * &nbsp;&nbsp;  if (error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var userWithDetails = user;
    * &nbsp;&nbsp;  }
	* }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/			
	getUserDetails: function(cb){
		Dispatcher.callMethodOnRemoteObject(this, "getUserDetails", [cb]);		
	},
	
	/**
	* Retrieves an ordered list of the user's friend requests on Mobage.
	* @name Social.US.User.getMobageFriendRequestLists
	* @function
	* @public
	*
	* @return {Social.US.OrderedList} A list of the user's friend requests.
    * @example
    * var myMobageFriendRequests = userA.getMobageFriendRequestsList();
    * @see Social.US.OrderedList for more information on iterating over the Mobage Friend Requests list.
	*/			
	getMobageFriendRequestsList: function(){
		return OrderedList.getObjectPublicInterface(this, "getInvitesList", "_followersListInterface");
	},
	
	/**
	* Returns the user's friends list on Mobage.
	* @name Social.US.User.getMobageFriendsList
	* @function
	* @public	
	*
	* @return {Social.US.OrderedList} The user's friend list on Mobage.
    * @example
    * var myMobageFriendsList = userA.getMobageFriendsList();
    * @see Social.US.OrderedList for more information on iterating over the Mobage friends list.
    * @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	getMobageFriendsList: function(){
		return OrderedList.getObjectPublicInterface(this, "getFriendsList", "_friendsListInterface");
	},
	
	/**
	* Returns the user's blocked user list.
	* @name Social.US.User.getMobageBlockedUserList
	* @function
	* @public	
	*
	* @return {Social.US.OrderedList} The user's blocked user list on Mobage.
	* @see Social.US.OrderedList
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	getMobageBlockedUserList: function(){
		return OrderedList.getObjectPublicInterface(this, "getBlockedUserList", "_enemyListInterface");
	},
	
	/**
	* Returns the user's games list.
	* @name Social.US.User.getOwnedGamesList
	* @function
	* @public	
	*
	* @return {Social.US.OrderedList} The user's Mobage game list.
    * @example
    * var myGamesList = userA.getOwnedGamesList();
    * @see Social.US.OrderedList for more information on iterating over the games list.
    * @status iOS, Android, Test, iOSTested, AndroidTested
	*/			
	getOwnedGamesList: function(){
		return OrderedList.getObjectPublicInterface(this, "getOwnedGamesList", "_ownedGamesListInterface");
	},
	
	/**
	* Returns the list of "featured" users.
	* @name Social.US.User.getFeaturedUsersList
	* @function
	* @public	
	*
	* @return {Social.US.OrderedList} The list of "featured" users.
    * @example
    * var mobageFeaturedUsers = userA.getFeaturedUsersList();
    * @see Social.US.OrderedList for more information on iterating over the Mobage Featured Users list.
    * @status iOS, Android, Test, iOSTested, AndroidTested
	*/	
	getFeaturedUsersList: function(){
		return OrderedList.getObjectPublicInterface(this, "getFeaturedUsersList", "_featuredUsersListInterface");
	},

	/**
	* Invites the user to the current game.
	* @name Social.US.User.inviteToCurrentGame
	* @public
	* @function
	* 
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	inviteToCurrentGame: function(cb){
		var user = this;
		Dispatcher.callMethodOnRemoteObject(this, "inviteToCurrentGame", [function(err){
			if(!err){
				Social.Common.Service.invitedUserEmitter.emit({userId: user.recordID});
				Social.US.Service.Friends.invitedUserEmitter.emit({user: user});
			}
			cb.apply(this, Array.apply(null, arguments));
		}]);		
	},
	
	/**
	 * Send a Push notification to this user through the GameService back end.
	 * @name Social.US.User.sendNotificationToUser
	 * @public
	 * @function
	 *
	 * @param {Alert Text} alertText The displayed message when the push is received.
	 * @param {Badge ID} badgeId Badge displayed on the push.
	 * @param {Sound} sound Sound played when push is received.
	 * @param {Extra Data} extraData Additional payload.
	 *
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	sendNotificationToUser: function(alertText, badgeId, sound, extraData) {
		Dispatcher.callMethodOnRemoteObject(this, "sendNotificationToUser", [alertText, badgeId, sound, extraData]);
	},

    /**
    * Adds a user to the current user's friend list for the current game. Implies a one-directional relationship or "follower" model.
    * Takes an optional group parameter to add the user to a particular group. Current user can only 
    * add the user to one group. If the current user adds the user to a second group in the friend list, 
    * the user is moved from the first group.
    *
    * A group is an arbitrary classification of friends. The <code>group</code> parameter is a string, which 
    * takes the name of the group. You may allow users to manage their own groups, create game-level groups, 
    * or omit groups altogether. A user may only reside in one group of another user's friend list.<br><br>
    * <b>Note:</b> This is part of the Game Graph API. 
    *
    * @example
    * //Retrieve a user and set up a follower relationship.
    * var userA = Social.US.User; 
    * Social.US.User.getUserWithGamertag("chuck", function(error, user){
    *   if(!user) {
    *       var errorCode = error.errorCode;
    *       var errorDesc = error.description;
    *   } else {
    *        userA = user;
    *   }
    * });
    * var userB = Social.US.Session.getCurrentSession().user();
    * userB.addFriend(userA, callback);
    * //...
    * @example
    * //To make the relationship bi-directional, 
    * //you must make the same call for the other user.
    * userA.addFriend(userB, callback);
    *
    * @name Social.US.User.addFriend
    * @public
    * @function
    *
    * @param user The user to add to the current user's friend list. If <code>null</code>, <code>undefined</code> or not a 
    * <code>Social.US.User</code> object, the callback error is "No user."
    * @param {String} [group] An optional parameter for adding the friend into a group within the friend list.
    * @param {Function} cb The callback function.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error, data){
    * &nbsp;&nbsp;  if (error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var appData = data;
    * &nbsp;&nbsp;  }
	* } </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
    */	
	addFriend: function(user, group, cb){
		if(typeof arguments[1] == "function" && !arguments[2]){
			cb = arguments[1];
			group = undefined;
		}
		Dispatcher.callMethodOnRemoteObject(this, "addGameFriend", [user, group, cb]);
	},

    /**
    * Removes a user from the current user's friend list for the current game.<br><br>
    * Does not require a group parameter, friends are only associated to one group in a friend list.
    * @name Social.US.User.removeFriend
    * @public
    * @function
    *
    * @param {Social.US.User} user The user to remove from the current user's friend list. If <code>null</code>, <code>undefined</code> or not a 
    * <code>Social.US.User</code> object, the callback error is "No user."
    * @param {Function} cb The callback function.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error, data){
    * &nbsp;&nbsp;  if (error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var appData = data;
    * &nbsp;&nbsp;  }
	* } </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
    */		
	removeFriend: function(user, cb){
		Dispatcher.callMethodOnRemoteObject(this, "removeGameFriend", [user, cb]);
	},
	
	report: function(reason, cb){
		Dispatcher.callMethodOnRemoteObject(this, "report", [reason, cb]);
	},

    /**
    * Returns the user's friend list for the current game. If you specify the <code>group</code>
    * parameter, this call only returns friends within the group.<br><br>
    * <b>Note:</b> This is part of the Game Graph API.
    * @name Social.US.User.getFriendsList
    * @public
    * @function
    *
    * @param {String} group If specified, returns only friends in the group.
    * @return {Social.US.OrderedList} The user's friend list for the current game.
    * @example
    * var myFriendsList = userA.getFriendsList ("Best Buddies");
    * @see Social.US.OrderedList for more information on iterating over the friends list.
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */	
	getFriendsList: function(group){
		return OrderedList.getObjectPublicInterface(this, "getGameFriendsList", (group ? ("_gameFriendsList-friends-" + group ) : "_gameFriendsList-friends"), "friends", group);
	},


    /**
    * Returns the user's mutual friends.
    * Mutual friends result when two users add each other to their respective friend list.<br><br>
    * <b>Note:</b> This is part of the game graph API.
    * @name Social.US.User.getMutualFriendsList
    * @public
    * @function
    *
    * @param {String} group The group within the friend list. If specified, returns only mutual friends within the group.
    * @return {Social.US.OrderedList} The user's mutual friend list.
    * @example
    * userA.addFriend(userB);
    * userB.addFriend(userA);
    * var myMutualFriends = userA.getMutualFriendsList();
    * //userA appears in userB's mutual friends list, 
    * //because they are in each other's friend lists.
    * @see Social.US.OrderedList for more information on iterating over the mutual friends list.
    * @status iOS, Android, Test, iOSTested, AndroidTested    
    */	
	getMutualFriendsList: function(group){
		return OrderedList.getObjectPublicInterface(this, "getGameFriendsList", (group ? ("_gameFriendsList-mutual-" + group) : "_gameFriendsList-mutual"), "mutual", group);
	},


    /**
    * Returns the user's friend requests list. If the <code>group</code> parameter is specified, returns
    * only friends within the group.
    * @name Social.US.User.getFriendRequestsList
    * @public
    * @function
    *
    * @param {String} group The group within the friend request list.
    * @return {Social.US.OrderedList} The user's friend requests list.
    * @example
    * var myFriendRequestsList = userA.getFriendRequestsList ();
    * @see Social.US.OrderedList for more information on iterating over the friend requests list. 
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */	
	getFriendRequestsList: function(group){
		return OrderedList.getObjectPublicInterface(this, "getGameFriendsList", (group ? ("_gameFriendsList-invitation-" + group) : "_gameFriendsList-invitation"), "invitation", group);
	},

	/**
	* Updates the email address for the current user.
	* @name Social.US.User.setEmailAddress
	* @function
	* @private
	*
	* @param {String} newAddress The email address for the current user.
	* @param {Function} cb The callback function if an error occurs (for example, invalid email address format).
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/	
	setEmailAddress:function(newAddress,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setEmailAddress", [newAddress, cb]);
	},
	
	/**
	* Sets whether the current user will receive notifications from other Mobage users or just from Mobage friends.
	* @name Social.US.User.setOnlyShowFriendNotifications
	* @function
	* @private
	*
	* @param {Boolean} isFriendsOnly Set to <code>true</code> if the current user will only receive notifications from Mobage users who are also Mobage friends. 
    * If set to <code>false</code>, the user receives notifications from all Mobage users. 
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/	
	setOnlyShowFriendNotifications:function(isFriendsOnly,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setOnlyShowFriendNotifications", [isFriendsOnly, cb]);
	},
	
	/**
	* Sets whether the current user will receive game news and updates from Mobage.
	* @name Social.US.User.setOptsIn
	* @function
	* @private
	*
	* @param {Boolean} optIn Set to <code>true</code> if the current user will receive news and updates from Mobage. 
    * If set to <code>false</code>, the user will not receive news or updates from Mobage. 
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/
	setOptsIn:function(optIn,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setOptsIn", [optIn, cb]);
	},

	/**
	* Sets a motto for the current user. In other words, the user's "about me" text string.
	* @name Social.US.User.setMotto
	* @function
	* @private
	*
	* @param {String} motto The motto for the current user.
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/	
	setMotto:function(motto,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setMotto", [motto, cb]);
	},
	
	/**
	* Updates the first name for the current user.
	* @name Social.US.User.setFirstName
	* @function
	* @private
	*
	* @param {String} firstName The first name for the current user.
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/	
	setFirstName:function(firstName,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setFirstName", [firstName, cb]);
	},
	
	/**
	* Updates the last name for the current user.
	* @name Social.US.User.setLastName
	* @function
	* @private
	*
	* @param {String} lastName The last name for the current user.
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/
	setLastName:function(lastName,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setLastName", [lastName, cb]);
	},
	

	/**
	* Sets a password for the current user.
	* @name Social.US.User.setPassword
	* @function
	* @private
	*
	* @param {String} password The password for the current user.
    * @param {String} confirmation The password confirmation for the current user.
	* @param {Function} cb The callback function if an error occurs. For example, password does not meet requirements; password and confirmation do not match, and so on.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/
	setPassword:function(password,confirmation, cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setPassword", [password, confirmation, cb]);
	},

	/**
	* Sets whether the target user is in the logged-in user's blocked user list.
	* @name Social.US.User.setBlocked
	* @function
	* @private
	*
	* @param {Social.US.User} user The user that is the subject of blocking or unblocking.
    * @param {Boolean} blocked Whether the current user blocks the specified user. If <code>true</code>, the specified user is blocked.
    	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/	
	setBlocked:function(blocked, cb){
		Dispatcher.callMethodOnRemoteObject(this, "setBlocked", [blocked, cb]);
	},
	
	/**
	 * Gets the origin of the user's registration.
	 * Mobage records the origin of a user's registration. The "origin" may be the name of an alliance partner.
	 * The origin is typically used as a means of tracking revenue sharing events, such as the promotional activity 
	 * of an alliance partner that attracts new users to Mobage and thereby entitles the alliance partner 
	 * to share in revenue generated by the application.  
	 *
	 * @name Social.US.User.getOriginOfRegistration
	 * @private
	 * @static
	 * @function
	 *
	 * @param {Function} cb The callback function returns the origin of registration, or an error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, originOfRegistration){
	 *     if(!originOfRegistration) {
	 *          var errorCode = error.errorCode;
	 *          var errorDesc = error.description;
	 *     } else {
	 *          var origin = originOfRegistration;
	 *     }
	 * }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getOriginOfRegistration: function(cb) {
		Dispatcher.callMethodOnRemoteObject(this, "getOriginOfRegistration", [cb]);
	}
});

User.GamertagKey = "gamertag";
User.AvatarKey = "badge_id";
User.MottoKey = "motto";
User.RelationKey = "relation";
User.FirstNameKey = "first_name";
User.LastNameKey = "last_name";
User.BirthdateKey = "birth_date";
User.GenderKey = "gender";
User.PrivacyKey = "fullname_privacy";
User.PhotoKey = "photo_url";
User.EmailAddressKey = "email";
User.EmailHashKey = "email_hash";
User.PhoneNumberKey = "phone_number";
User.AgeRangeKey = "age_restricted";
User.SpamKey = "opt_in";

User.PasswordKey = "password";
User.PasswordConfirmKey = "password_confirmation";
User.GamesKey = "games";
User.CapabilitiesKey = "capabilities";
User.NewBuddyKey = "new_buddy";
User.IsMutualFriendKey = "mutual_friends";
User.HidePresenceKey = "hide_presence";
User.OnlyShowFriendNotificationsKey = "friend_only_notification";

User.GamerScoreKey = "gamerscore";
User.LevelNumberKey = "level_position";
User.LevelNameKey = "level_name";
User.CurrentLevelScoreKey = "level_points";
User.NextLevelScoreKey = "level_next_points";

// properties that are not returned in sparse search results
User.NonSparseKeys = [User.PhotoKey, User.EmailAddressKey,
User.EmailHashKey, User.PhoneNumberKey, User.PasswordKey,
User.FirstNameKey, User.LastNameKey, User.PrivacyKey,
User.NewBuddyKey, User.CapabilitiesKey, User.HidePresenceKey,
User.OnlyShowFriendNotificationsKey, User.GamerScoreKey,
User.LevelNumberKey, User.LevelNameKey, User.CurrentLevelScoreKey,
User.NextLevelScoreKey, User.GamesKey];


/**
* Retrieves the user corresponding to the <code>userID</code> parameter.
* @name Social.US.User.getUserWithID
* @public
* @static
* @function
* 
* @param {String} userID The ID for the user.
* @param {Function} cb The callback function if an error occurs.
* <br/> 
* <b>Callback Example:</b><br/>
* <pre class="code">function(error, user){
* &nbsp;&nbsp;  if(!user) {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
* &nbsp;&nbsp;  } else {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var userWithID = user;
* &nbsp;&nbsp;  }
* }
* </pre>
* @status iOS, Android, Test, iOSTested, AndroidTested
*/	
User.getUserWithID = function(userID, cb){
	Dispatcher.callClassMethodOnRemoteObject(User, "getUserWithID", [userID, cb]);
};

/**
* Retrieves the user corresponding to the <code>gamertag</code> parameter.
* @name Social.US.User.getUserWithGamertag
* @public
* @static
* @function
* 
* @param {String} gamertag The user's gamertag.
* @param {Function} cb The callback function if an error occurs.
* <br/> 
* <b>Callback Example:</b><br/>
* <pre class="code">function(error, user){
* &nbsp;&nbsp;  if(!user) {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
* &nbsp;&nbsp;  } else {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var userWithGamertag = user;
* &nbsp;&nbsp;  }
* }
* </pre>
* @status iOS, Android, Test, iOSTested, AndroidTested
*/	
User.getUserWithGamertag = function(gamertag, cb){
	Dispatcher.callClassMethodOnRemoteObject(User, "getUserWithGamertag", [gamertag, cb]);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/Game'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Game'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Game'] = exports; var DataModelR = require('NGCore/Client/Social/US/Models/DataModel');
var OrderedList = require('NGCore/Client/Social/US/Models/OrderedList').OrderedList;
var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;

/**
 * <code>Game</code> objects identify a game and its properties.
 * Game properties include: 
 * <div class="ul">
 * <li><code>name</code></li>
 * <li><code>publisher</code></li>
 * <li><code>category</code></li>
 * <li><code>featured</code></li>
 * <li><code>numberOfLeaderboards</code></li> 
 * <li><code>numberOfAchievements</code></li>
 * <li><code>masterProductID</code></li>
 * <li><code>iconURL</code></li>
 * <li><code>AppStoreURL</code></li>
 * <li><code>feedURL</code></li>
 * <li><code>catalogURL</code></li>
 * </div>
 * <code>Game</code> objects provide static functions to return all games in a catalog or games associated to a user profile.
 * 
 * @class 
 * @name Social.US.Game
 * @augments Social.US.DataModel
 */
var Game = exports.Game = DataModelR.DataModel.subclass({
	classname: "Game",
	
	
	 //Game is a subclass of data model, and the getter/setter methods are generated by defineSetterCallbacks. The following
	 //comments document the generated methods.
	 /**
	 * The game name. Read-only.
	 * @name Social.US.Game.name
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * The publisher name. Read-only.
	 * @name Social.US.Game.publisher
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The game category name. Read-only.
	 * @name Social.US.Game.category
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * Whether the game is featured. Read-only.
	 * @name Social.US.Game.featured
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The number of leaderboards for the game. Read-only.
	 * @name Social.US.Game.numberOfLeaderboards
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * The number of achievements. Read-only.
	 * @name Social.US.Game.numberOfAchievements
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The master product ID. Read-only.
	 * @name Social.US.Game.masterProductID
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * A URL to the icon for a game. Read-only.
	 * @name Social.US.Game.iconURL
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * A URL to the store or marketplace for a game. Read-only.
	 * @name Social.US.Game.appStoreURL
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * A URL to the RSS feed for a game. Read-only.
	 * @name Social.US.Game.feedURL
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * Sets a catalog URL for the catalog of game items. Read-only.
	 * @name Social.US.Game.catalogURL
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	properties: [
		// public
		"name",
		"publisher",
		"category",
		"numberOfLeaderboards",
		"iconURL",
		
		// private
		"numberOfAchievements",
		"featured",
		"masterProductID",
		"appStoreURL",
		"feedURL",
		"catalogURL",
		"description",
		"phone_screenshot_urls",
		"ngcore_url"
	]
});

/**
 * Returns an ordered list interface to the Mobage game catalog.
 * 
 * @name Social.US.Game.getAllGamesList
 * @function
 * @private 
 * @static
 *
 * @returns {Social.US.OrderedList} An ordered list interface to the catalog of games.
 * @see Social.US.OrderedList
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Game.getAllGamesList = function(){
		
	return OrderedList.getClassPublicInterface(Game, "getAllGamesList", "_allGamesInterface");
};

/**
 * Returns the current game. 
 *
 * @name Social.US.Game.getCurrentGame
 * @function
 * @public 
 * @static
 *
 * @param {Function} cb The callback function returns the current game or an error code and description.
 * <br/> 
 * <b>Callback Example:</b><br/>
 * <pre class="code">function(error, game){
 * &nbsp;&nbsp; if(!game){
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
 * &nbsp;&nbsp;} else {
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var currentGame = game;
 * &nbsp;&nbsp;}
 * }
 * </pre>
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Game.getCurrentGame = function(cb){
	Dispatcher.callClassMethodOnRemoteObject(Game, "getCurrentGame", [cb]);
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/Leaderboard'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Leaderboard'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Leaderboard'] = exports; var DataModelR = require('NGCore/Client/Social/US/Models/DataModel');
var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;
var OrderedList = require('NGCore/Client/Social/US/Models/OrderedList').OrderedList;

/**
 * <code>Leaderboard</code> objects enable the current user to get friend scores, top scores, and submit a score.
 * To return a leaderboard, you must set up at least one leaderboard for your game in the Mobabe Sandbox or Production environment.
 * @class 
 * @name Social.US.Leaderboard
 * @augments Social.US.DataModel
 */
var Leaderboard = exports.Leaderboard = DataModelR.DataModel.subclass({

	 
	classname: "Leaderboard",
	properties: [
	"level",
	"title",
	"game",
	"iconURL"
	],

	
	/** 
	 * @constructs Constructs a <code>Leaderboard</code> object identified by the record ID. 
	 * @private
	 *
	 * @param {Type} $super A reference to the DataModel superclass.
	 * @param {String} recordId The record ID of the object.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	initialize: function($super, recordID){
		$super(recordID);
		NgLogD("Leaderboard Public! " + recordID + " " + this.recordID);
	},
	
	
	/**
	* Submits a score to the leaderboard.
	*
	* @name Social.US.Leaderboard.submitScore
	* @function
	* @public
	*
	* @param {Numeric} points The score points. If <code>null</code> or <code>undefined</code>, the callback error is "No score."
	* @param {Function} cb The callback function.
	* <br/> 
    * <b>Callback Example:</b><br/>
    * <pre class='code'>function(error, score){
    * &nbsp;&nbsp;  if(error) {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var setScore = score;
    * }
    * </pre>
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */
	submitScore: function(points, cb){
		Dispatcher.callMethodOnRemoteObject(this, "submitScoreWithPoints", [points, cb]);
	},	
	
	/**
	* Returns an <code>OrderedList</code> with the user's score and the highest scores.
	* 
	* @name Social.US.Leaderboard.getTopScoresList
	* @function
	* @public
	*
	* @return {Social.US.OrderedList} The list of highest scores.
	* @see Social.US.OrderedList
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/		
	getTopScoresList: function(){
		return OrderedList.getObjectPublicInterface(this, "getTopScoresList", "_leaderboardTopScoresInterface");
	},
	
	/**
	* Returns an <code>OrderedList</code> of scores for the user's friends.
	* 
	* @name Social.US.Leaderboard.getFriendsScoresList
	* @function
	* @public
	*
	* @return {Social.US.OrderedList} The list of scores for the user's friends.
	* @see Social.US.OrderedList
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/		
	getFriendsScoresList: function(){
		return OrderedList.getObjectPublicInterface(this, "getFriendsScoresList", "_leaderboardFriendsScoresInterface");
	}

	 /**
	 * The user's level in the game. Read-only.
	 * @name Social.US.Leaderboard.level
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The leaderboard title. Read-only.
	 * @name Social.US.Leaderboard.title
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * The game name. Read-only.
	 * @name Social.US.Leaderboard.game
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * A URL to the leaderboard icon. Read-only.
	 * @name Social.US.Leaderboard.iconURL
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
		 
});

/**
* Returns the leaderboard(s) for the current game.
* To return a leaderboard, you must set up at least one leaderboard for your game in the Mobabe Sandbox or Production environment.
*
* @name Social.US.Leaderboard.getLeaderboards
* @function
* @public
* @static
*
* @param cb Retrieves the leaderboard(s) for the current game. If an error occurs, returns an error code and error description.
* <br/> 
* <b>Callback Example:</b><br/>
* <pre class='code'>function(error, leaderboards){
*     if(error) {
*          var errorCode = error.errorCode;
*          var errorDesc = error.description;
*     } else {
*          var retrievedLeaderboards = leaderboards;
* }
* </pre>
* @status iOS, Android, Test, iOSTested, AndroidTested
*/
Leaderboard.getLeaderboards = function(cb){
	Dispatcher.callClassMethodOnRemoteObject(Leaderboard, "getLeaderboards", [cb]);
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/Score'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Score'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Score'] = exports; var DataModel 	  = require('NGCore/Client/Social/US/Models/DataModel').DataModel;

/**
 * <code>Score</code> constructs objects that reflect a user's score for the current game.
 * @class 
 * @name Social.US.Score
 * @augments Social.US.DataModel
 */
var Score = exports.Score = DataModel.subclass({
	
    classname: "Score",
    	
	 /**
	 * A user's score. Read-only.
	 * @name Social.US.Score.score
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The score as formatted for display. Read-only.
	 * @name Social.US.Score.displayScore
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	
	 /**
	 * The user's rank. Read-only.
	 * @name Social.US.Score.rank
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	
	 /**
	 * The user's level in the current game. Read-only.
	 * @name Social.US.Score.level
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
    
	 /**
	 * A <code>Social.US.User</code> reference to the user associated to the score. Read-only.
	 * @name Social.US.Score.user
	 * @field
	 * @public
     * @see Social.US.User
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */    
	 
    properties: [
	"points",
	"displayScore",
	"rank",
	"level",
	"user"
	]
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/AppData'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/AppData'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/AppData'] = exports; var DataModelReq = require('NGCore/Client/Social/US/Models/DataModel');
var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;

/**
 * <code>AppData</code> constructs objects that get and set a user's properties, 
 * and provides permissions for sharing the user's properties with other users.
 * @class 
 * @name Social.US.AppData
 * @see Social.Common.Appdata for additional Mobage persistence facilities;
 * @see Storage.KeyValue for additional ngCore persistence facilities; and,
 * @see Storage.FileSystem for additional ngCore persistence facilities. 
 */
var AppData = exports.AppData = DataModelReq.DataModel.subclass({
		
	classname: "AppData",
	properties: [
		"data",
		"key",
		"user",
		"permissions"
	],
	
	/**
	 * The application data for the user. Limited to 1024 bytes.
	 * 
	 * @name Social.US.AppData.data
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
	/**
	 * The key describing the application data. Limited to 32 bytes.
	 * 
	 * @name Social.US.AppData.key
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
	/**
	 * The name of the user who owns the data.
	 * 
	 * @name Social.US.AppData.name
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
	/**
	 * The permissions for the application data.<br/><br/>
	 * <code>Private</code>: only the user can read and write the user data.<br/>
	 * <code>FriendsReadOnly</code>: friends can read the user data, but cannot write it.<br/>
	 * <code>PublicReadOnly</code>: all users can read the user data, but cannot write it.     
	 * 
	 * @name Social.US.AppData.permissions
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
	
	
    /**
     * The default constructor.
     * @constructs 
     * @name Social.US.AppData.initialize
     * @private
     *
     * @param recordID A unique ID for the <code>AppData</code> object.
     *
     * @augments Social.US.DataModel
     * @status iOS, Android, Test, iOSTested, AndroidTested
     */	
    initialize: function($super, recordID) {
        $super(recordID);
    }
});

/**
* Takes a user reference and returns key/value pairs of the user for the current game.
* @name Social.US.AppData.getKeysForUser
* @function
* @public
* @static
*
* @param {Social.US.User} user A reference to the user.
* @param {Function} callback The callback function returns key/value pairs for the user and/or and error code and description.
* <br/> 
* <b>Callback Example:</b><br/>
* <pre class="code">var entries = {"key1": "value1", "key2": "value2"};
* ...
* function(error, entries){
* &nbsp;&nbsp;   if (error){
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorCode = error.errorCode;
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorDesc = error.description;
* &nbsp;&nbsp;   } else {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var retrievedEntries = entries;
* &nbsp;&nbsp;   }
* }
* </pre>
* @example
* var user = Social.US.Session.getCurrentSession().user();
* var AppData = Social.US.AppData;
* var retrievedEntries = null;
* AppData.getKeysForUser(user, function(error, entries){
*				retrievedEntries = entries;
*			});
* @status iOS, Android, Test, iOSTested, AndroidTested
*/
AppData.getKeysForUser = function(user, cb){
	Dispatcher.callClassMethodOnRemoteObject(AppData, "getKeysForUser", [user, cb]);
};

/**
* Takes a user, a key (the name of the key for a name/value pair) and returns the key/value pair for the user for the current game.
* @name Social.US.AppData.getDataForUserWithKey
* @function
* @public
* @static
*
* @param {Social.US.User} user A reference to the user.
* @param {String} key The name of the key.
* @param {Function} callback Retrieves the key/value pair for the user and/or an error code and description.
* <br/> 
* <b>Callback Example:</b><br/>
* <pre class="code">function(error, response){
* &nbsp;&nbsp;   if (error){
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorCode = error.errorCode;
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorDesc = error.description;
* &nbsp;&nbsp;   } else {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var fetchedData = response.data;
* &nbsp;&nbsp;   }
* }
* </pre>
* @example
* var user = Social.US.Session.getCurrentSession().user();
* var AData = Social.US.AppData;
* var errorCode = null;
* var errorDesc = null;
* var fetchedData = null;
* AData.getDataForUserWithKey( user, 
*                              key, 
*                              function(error, response){
*                                   errorCode = error.errorCode;
*                                   errorDesc = error.description;
*                                   fetchedData = response.data;
*                              }
*                            );
* @status iOS, Android, Test, iOSTested, AndroidTested
*/
AppData.getDataForUserWithKey = function(user, key, cb){
	Dispatcher.callClassMethodOnRemoteObject(AppData, "getDataForUserWithKey", [user, key, cb]);
};


/**
* Takes data, a user, a key (the name of the key for a name/value pair) and permissions for the data and sets the application data for the user.
* <b>Note:</b> Limited to 30 key/value pairs per user, per game. 
* Maximum key name limited to 32 bytes. Maximum value limited to 1,024 bytes.
* To use key/value pairs without the foregoing constraints, use <code>Storage.KeyValue</code>
* in ngCore.
* @name Social.US.AppData.setDataForUserWithKeyAndPermissions
* @function
* @public
* @static 
*
* @param {String} data The data to set.
* @param {Social.US.User} user A reference to the user.
* @param {String} key The name of the key.
* @param {Social.US.AppData.Permissions} permission The permissions for the data.
* @param {Function} cb The callback function if there is an error with the parameters.
* <br/> 
* <b>Callback Example:</b><br/>
* <pre class="code">function(error){
* &nbsp;&nbsp;  if(!response) {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
* &nbsp;&nbsp;   } else {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var responseValues = response;
* &nbsp;&nbsp;   }
* }
* </pre>
* @example
* var user = Social.US.Session.getCurrentSession().user();
* var data = "some data";
* var key = "some key";
* var errorCode = null;
* var errorDesc = null;
* var result = null; 
*
* var AData = Social.US.AppData;
* 
* AData.setDataForUserWithKeyAndPermissions(data, 
*                                           user, 
*                                           key, 
*                                           AppData.Permissions.Private, 
*                                           function(error, response){
*                                             errorCode = error.errorCode;
*                                             errorDesc = error.description;
*                                             result = response;
*                                           }
*                                         );
* @status iOS, Android, Test, iOSTested, AndroidTested
* @see Social.US.AppData.Permissions for permission settings;
* @see Social.Common.Appdata for additional Mobage persistence facilities;
* @see Storage.KeyValue for additional ngCore persistence facilities; and,
* @see Storage.FileSystem for additional ngCore persistence facilities.
*/
AppData.setDataForUserWithKeyAndPermissions = function(data, user, key, permissions, cb){
	Dispatcher.callClassMethodOnRemoteObject(AppData, "setDataForUserWithKeyAndPermissions", [data, user, key, permissions, cb]);
};



/**
* Defines permissions for viewing user data.<br/><br/>
* <code>Private</code>: only the user can read and write the user data.<br/>
* <code>FriendsReadOnly</code>: friends can read the user data, but cannot write it.<br/>
* <code>PublicReadOnly</code>: all users can read the user data, but cannot write it. 
* @name Social.US.AppData.Permissions
* @field
* @public
* @status iOS, Android, Test, iOSTested, AndroidTested
*/
AppData.Permissions = {
	Private: 0,
	FriendsReadOnly: 1,
	PublicReadOnly: 2
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/Cache'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Cache'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Cache'] = exports; var Class = require('NGCore/Client/Core/Class').Class;
var SocialR = require('NGCore/Client/Social');

/**
 * <code>Cache</code> provides caching for a user's objects residing in the local interpreter.
 * @class 
 * @name Social.US.Cache
 * @private
 */
var Cache = exports.Cache = Class.subclass({


	classname: "Cache",
	inMemoryObjects: {},
	caches: {},
	
	/**
	 * Initializes a cache object upon instantiation. 
	 * @name Social.US.Cache.initialize
	 * @constructs
	 * @private
	 */			
	initialize: function(){
	},

	
	/**
	* Takes a classname and a unique record ID and returns the object or <code>null</code> if it doesn't find the object.
	*
	* @name Social.US.Cache.getObjectWithRecordID
	* @function
	* @private
	*
	* @param {String} classname The name of the class.
	* @param {Number} recordID The object ID.
	*
	* @return Returns the object corresponding to the <code>recordID</code> parameter or <code>null</code> if it doesn't find the object.
	*/
	getObjectWithRecordID: function(classname, recordID){
		var category = this.inMemoryObjects[classname];
		if(category){
			return category[recordID] || null;
		}else{
			return null;
		}
	},
	
	/**
	* Takes an object and adds it to the cache.
	* <code>addObject()</code> takes an object, ensures that it is not already in the cache, and adds it to the cache.
	*
	* @name Social.US.Cache.addObject
	* @function
	* @private
	*	
	* @param {Object} obj The object to add to the cache.
	* @return Returns the record ID of the object added to the cache.
	*/	
	addObject: function(obj){
		var classname = obj._classname();
		var category = this.inMemoryObjects[classname];
		if(!category){
			category = {};
			this.inMemoryObjects[classname] = category;
		}

		var object = category[obj.recordID];
		if(object){
			return object;
		}else{
			category[obj.recordID] = obj;
			return obj;
		}
	},
	
	/**
	* Takes an object reference and removes the object from the cache.
	* 
	* @name Social.US.Cache.removeObject
	* @function
	* @private
	*	
	* @param {Object} obj The object to remove from the cache.
	*/	
	removeObject: function(obj){
		var classname = obj._classname();
		var category = this.inMemoryObjects[classname];
		if(category){
			delete category[obj.recordID]; // ZOMG THE DELETE OPERATOR
		}
	},
	
	/**
	* Takes an object reference and returns whether the object is in the cache.
	* 
	* @name Social.US.Cache.isObjectCached
	* @function
	* @private
	*	
	* @param {Object} obj The object to select in the cache.
	*
	* @return Returns <code>true</true> if the object is in the cache; otherwise, it returns <code>false</code>.
	*/		
	isObjectCached: function(obj){
		var classname = obj._classname();
		var category = this.inMemoryObjects[classname];
		return (category && (category[obj.recordID] == obj));
	},
	
	
	saveCache: function(){
		
	},
	
	
	loadCache: function(){
		
	},
	
	/**
	* Takes a JSON array of objects and loads them into the cache.
	*
	* @name Social.US.Cache.loadCacheFromJSONArray
	* @function
	* @private
	*
	* @param {JSON} jsonArray The JSON object array to load into the cache.
	* @param {function} cb <code>loadCacheFromJSONArray()</code> takes an optional callback function.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
	*/			
	loadCacheFromJSONArray: function(jsonArray, cb){
		var objects = [];
        
		for(var idx = 0; idx < jsonArray.length; idx++){
			var hash = jsonArray[idx];
			if(hash && hash.hasOwnProperty("classname") && hash.hasOwnProperty("recordID")){
				var theClassname = hash.classname;
				var theClass = SocialR.Social.US[theClassname];
				var theRecordID = hash.recordID;
				if(theClass && theRecordID){
					var theInstance = this.getObjectWithRecordID(theClassname, theRecordID);
					if(!theInstance){
						theInstance = new theClass(theRecordID, {});
					}
        
					theInstance._deserializeFromHash(hash);
					this.addObject(theInstance);
				}
			}
		}
        
		cb(null, this);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Data/Session'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Data/Session'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Data/Session'] = exports; var CoreReq = require('NGCore/Client/Core');
//var UserReq = require('../Models/User');
var MessageEmitterReq = require('NGCore/Client/Core/MessageEmitter');
var CacheReq = require('NGCore/Client/Social/US/Models/Cache');
var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;

/**
 * <code>Session</code> manages a user's game sessions.
 * @class 
 * @name Social.US.Session
 */
var Session = exports.Session = MessageEmitterReq.MessageEmitter.subclass({
		
	classname: "Session",
	
	/**
	 * Constructs a session object.
	 * @name Social.US.Session.initialize
	 * @private
	 * @constructs 
	 */	
	initialize: function(gameData){
		if(gameData){
			this._loadSessionData(gameData);
		}
	},
	
	/**
	 * Loads the user's game data into the current session.
	 *
	 * @name Social.US.Session._loadSessionData
	 * @function
	 * @private
	 *
	 * @param {Type} gameData Takes game data and loads it into the current session.
	 */		
	_loadSessionData: function(gameData){
		this._appKey = gameData.appId || this._appKey || null;
		this._appVersion = gameData.appVersion || this._appVersion || null;
		this._platformVersion = gameData.platformVersion || this._platformVersion || "1.0";
		this._serverMode = gameData.serverMode || this._serverMode || null;

		this._user = (gameData.userID ? this.dataCache().getObjectWithRecordID("User", gameData.userID) : null);		
		this.emit({user: this._user});
	},
	
	/**
	 * Returns the cache for the current session. If a session cache does not exist, this call creates a new cache, loads it and returns it.
	 *
	 * @name Social.US.Session.dataCache
	 * @function
	 * @private
	 *
	 * @return {Social.US.Cache} The cache for the current session.
	 */			
	dataCache: function(){
		if(!this._cache){
			this._cache = new CacheReq.Cache();
			this._cache.loadCache(function(err){
				NgLogD("Loaded cache: " + err);
			});
		}
		return this._cache;
	},
	
	
	/**
	 * Returns the user for this session.
	 *
	 * @name Social.US.Session.user
	 * @function
	 * @public
	 *
	 * @return {Social.US.User} The user for the current session.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */					
	user: function(){
		return this._user;
	},
	
	

	// data you probably don't need
	/**
	 * Returns the name of the game for this session.
	 *
	 * @name Social.US.Session.appKey
	 * @function
	 * @public
	 *
	 * @return {String} The application name.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */						
	appKey: function(){
		return this._appKey;
	},
	
	/**
	 * Returns the version of the game for this session.	 
	 *
	 * @name Social.US.Session.appVersion
	 * @function
	 * @public
	 *
	 * @return {String} The application version.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	appVersion: function(){
		return this._appVersion;
	},
	
	/**
	 * Returns the server mode of the game for this session.
	 *
	 * @name Social.US.Session.serverMode
	 * @function
	 * @public
	 *
	 * @return {String} The server mode.
	 * <b>Note:</b> Valid settings for the server mode include:<br/>
	 * <ul>
	 * <li>staging</li>
	 * <li>integration</li>
	 * <li>sandbox</li>
	 * <li>production</li>
	 * <li>unknown</li>
	 * </ul>
	 * @see Social.US.Session.serverModes
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	serverMode: function(){
		return this._serverMode;
	},
	
	/**
	 * Returns the platform version of the game for this session.
	 *
	 * @name Social.US.Session.platformVersion
	 * @function
	 * @public
	 *
	 * @return {String} The platform version.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	platformVersion: function(){
		return this._platformVersion;
	},
	

	/**
	 * Takes a consumer key and retrieves the session tokens for the the consumer key.
	 *
	 * @name Social.US.Session.getSessionTokensForConsumerKey
	 * @function
	 * @public
	 * 
     * @param {String} consumerKey The consumer key.
	 * @param {Function} cb A callback that retrieves the session tokens for the consumer key. If an error occurs, returns an error code 
	 * and error description.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	getSessionTokensForConsumerKey: function(consumerKey, cb){
		Dispatcher.callClassMethodOnRemoteObject("Session", ["getCurrentSession", "getSessionTokensForConsumerKey"], [[], [consumerKey, cb]]);
	}
});


/**
 * The session modes for the server. Session modes include:
 * <ul>
 * <li><code>staging</code></li>
 * <li><code>integration</code></li>
 * <li><code>sandbox</code></li>
 * <li><code>production</code></li>
 * <li><code>unknown</code></li>
 * </ul>
 * @name Social.US.Session.serverModes
 * @field
 * @public
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Session.serverModes = {
	staging: "staging",
	integration: "integration",
	partner: "sandbox",
	sandbox: "sandbox",
	production: "production",
	unknown: "unknown"
};

/**
 * Returns the current session.  
 * @name Social.US.Session.getCurrentSession
 * @function
 * @public 
 * @static
 *
 * @return {Social.US.Session} The current session.
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */	
Session.getCurrentSession = function(){
	return Session._currentSession;
};



Session._emitter = null;

/**
 * Adds a listener to the current session.
 *
 * @name Social.US.Session.addCurrentSessionListener
 * @function
 * @public
 * @static
 *  
 * @param {Core.MessageListener }listener The listener to add to the current session.
 * @param {Function} callback The callback function.
 * @param priority The priority for this <code>MessageListener</code>.
 *
 * @see Core.MessageListener
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Session.addCurrentSessionListener = function(listener, callback, priority){	
	if(!Session._emitter){
		Session._emitter = new MessageEmitterReq.MessageEmitter();
	}
	
	Session._emitter.addListener(listener, callback, priority);
};

/**
 * Removes the listener from the current session.
 *
 * @name Social.US.Session.removeCurrentSessionListener 
 * @function
 * @public 
 * @static
 *
 * @param {Core.MessageListener} listener The listener for the current session.
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Session.removeCurrentSessionListener = function(listener){
	if(Session._emitter){
		Session._emitter.removeListener(listener);
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Data/Dispatcher'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Data/Dispatcher'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Data/Dispatcher'] = exports; var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

var Core = require('NGCore/Client/Core').Core;
var CacheR = require('NGCore/Client/Social/US/Models/Cache');

var SocialR = require('NGCore/Client/Social');
var SessionR = require('NGCore/Client/Social/US/Data/Session');

/**
 * <code>Dispatcher</code> objects know about <code>DataModel</code> objects and can "push" <code>DataModel</code> objects between interpreters.
 * <code>Dispatcher</code> objects can find classes and specific instances of objects, and may invoke their functions.
 * <code>Dispatcher</code> objects also provide a series of convenience functions to facilitate communication between interpreters.
 * @class 
 * @name Social.US.Dispatcher
 * @private
 */
var Dispatcher = exports.Dispatcher = {
				
	classname: "Dispatcher",
	callbackUIDCounter: 0,
	callbacks: {
		"-2": {},
		"-1": {}
	},
	
	/**
	 * Returns the data cache for the current session.
	 * @name Social.US.Dispatcher.cache
	 * @function
	 * @private
	 *
	 * @return {Social.US.Cache} The data cache for the current session.
	 * @see Social.US.Cache
	 */		
	cache: function(){		
		try {		
			return SessionR.Session.getCurrentSession().dataCache();
		}
		catch (err) {
			NgLogD("Mobage/Dispatcher/cache-Warning: cannot get cache. NOTE: This may be expected behavior if early on in initialization. Err=" 
				+ err);

			return null;
		}
	},
	
	
	/**
	 * Gets the current session and loads session data.
	 * If there is no current session, <code>receiveSession()</code> creates a new session.
	 *	 
	 * @name Social.US.Dispatcher.receiveSession
	 * @function
	 * @private
	 *
	 * @param {Type} command Takes a command, which may include the platform version, server mode, application name and application version. 
	 */		
	receiveSession: function(command){		
		var session = SessionR.Session.getCurrentSession();
		if(!session){
			session = new SessionR.Session();
			SessionR.Session._currentSession = session;
		}
		
		var userData = command.data.userData;
		if(userData){
			// the User object will be cached implicitly, then loaded in _loadSessionData
			Dispatcher.receiveObject({data: userData});
		}
		
		session._loadSessionData(command.data);
		
		if(SessionR.Session._emitter){
			SessionR.Session._emitter.emit({session: session});
		}
	},
	
	// DataModel communication
	/**
	 * Finds a particular instance of an object in the local interpreter and calls a method on the object.
	 *	 
	 * @name Social.US.Dispatcher.callMethodOnLocalObject
	 * @function
	 * @private
	 *
	 * @param {Command} command Takes a command object that identifies the class name of the object, 
     * its record ID, the method name to call, and any parameters for the method.
	 * The command object takes an optional callback and <code>callMethodOnLocalObject()</code> returns returns the result 
     * and/or any error code and description to the callback function.
	 */		
	callMethodOnLocalObject: function(command){		
		var recordID = command.recordID;
		var classname = command.classname;
		
		var object = Dispatcher.cache().getObjectWithRecordID(classname, recordID);
		if(object){
			var methodName = command.methodName;

			var error = false;
			var args;
			var retVal;
			if(methodName instanceof Array) {
				var methodOwner = object;
				for(var idx = 0; idx < methodName.length; idx++) {
					if(typeof methodOwner[methodName[idx]] == "function") {
						args = Dispatcher.convertArgumentsArrayFromJSON(command.arguments[idx] || []);
						retVal = methodOwner[methodName[idx]].apply(methodOwner, args);
						methodOwner = retVal;						
					}
					else {
						error = true;
						break;
					}
				}
			}
			else {
				if(typeof object[methodName] == "function") {
					args = Dispatcher.convertArgumentsArrayFromJSON(command.arguments || []);
					retVal = object[methodName].apply(object, args);
				}
				else {
					error = true;
				}
			}
			
			if(error) {
				NgLogD("ERROR: Invalid methods for calling on local object: " + command.recordID + " " + methodName);
			}
			else if(command.callback){
				var callback = Dispatcher.convertFunctionFromJSON({callbackUID: command.callback});
				if(callback){
					callback(retVal);
				}
			}
		}
	},
	
	
	/**
	 * Finds a particular instance of an object in a remote interpreter and calls a method on the remote object.
	 *	 
	 * @name Social.US.Dispatcher.callMethodOnRemoteObject
 	 * @function
 	 * @private
 	 *
	 * @param {Number} object The object reference (i.e., typically the keyword 'this').
	 * @param {String} method The method name to call.
	 * @param {Array} args An array of parameters for the method, including other <code>DataModel</code> objects or functions.
	 * @param {Function} cb Returns the result and/or any error code and description to the callback function.
	 *
	 * <b>Note:</b> If the target method wants a callback as one/more of its arguments, supply it as an element in the argument array, <b>NOT</b> as the fourth parameter.
	 */			
	callMethodOnRemoteObject: function(object, method, args, cb){		
		if(!object || !method){
			NgLogD("Public.Dispatcher.callMethodOnRemoteObject - bailing");
			if(cb){
				cb();
			}
			return;
		}

		args = Dispatcher.convertArgumentsArrayToJSON(args || []);
		
		var cmd = {
			apiURL: "US.Dispatcher.callMethodOnLocalObject",
			recordID: object.recordID,
			classname: object._classname(),
			methodName: method,
			arguments: args,
			callback: Dispatcher.convertFunctionToJSON(cb)
		};
		
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	 * Calls a static method on a class in the local interpreter.
	 *	 
	 * @name Social.US.Dispatcher.callClassMethodOnLocalObject	
	 * @function
	 * @private
	 *
	 * @param {Command} command Takes a command object that identifies the class name of the object, the method name to call, and any parameters for the method.
	 * The command parameter takes an optional callback function and <code>callMethodOnLocalObject()</code> returns returns the result and/or any error code and description to the callback function.
	 */		
	callClassMethodOnLocalObject: function(command){		
		Dispatcher.beginBatching();
		
		var classname = command.classname;
		var methodName = command.methodName;
		if(classname && methodName){
			var theClass = SocialR.Social.US[classname];
			if(!theClass){
				theClass = SocialR.Social.US.Service[classname];
			}
			
			if(theClass){
				var error = false;
				var args;
				var retVal;
				if(methodName instanceof Array) {
					var methodOwner = theClass;
					for(var idx = 0; idx < methodName.length; idx++) {
						if(typeof methodOwner[methodName[idx]] == "function") {
							args = Dispatcher.convertArgumentsArrayFromJSON(command.arguments[idx] || []);
							retVal = methodOwner[methodName[idx]].apply(methodOwner, args);
							methodOwner = retVal;						
						}
						else {
							error = true;
							break;
						}
					}
				}
				else {
					if(typeof theClass[methodName] == "function") {
						args = Dispatcher.convertArgumentsArrayFromJSON(command.arguments || []);
						retVal = theClass[methodName].apply(theClass, args);
					}
					else {
						error = true;
					}
				}
				
				if(error) {
					NgLogD("ERROR: Invalid methods for calling on local Class: " + classname + " " + methodName);
				}
				else if(command.callback){
					var callback = Dispatcher.convertFunctionFromJSON({callbackUID: command.callback});
					if(callback){
						callback(retVal);
					}
				}				
			}
		}
		
		Dispatcher.endBatching();
	},

	/**
	 * Calls a static method on a class in a remote interpreter.
	 *	 
	 * @name Social.US.Dispatcher.callClassMethodOnRemoteObject
	 * @function
	 * @private
	 *
	 * @param {String} theClass The name of the class.
	 * @param {String} method The method name to call.
	 * @param {Array} args An array of parameters for the method.
	 * @param {Function} cb <code>callClassMethodOnRemoteObject()</code> returns returns the result and/or any error code and description to the callback function.
	 * 
	 */			
	callClassMethodOnRemoteObject: function(theClass, methodName, args, cb){		
		if(!theClass || !methodName){
			NgLogD("Public.Dispatcher.callClassMethodOnRemoteObject - bailing");
			if(cb){
				cb();
			}
			return;
		}

		args = Dispatcher.convertArgumentsArrayToJSON(args || []);
		
		var cmd = {
			apiURL: "US.Dispatcher.callClassMethodOnLocalObject",
			classname: (theClass.classname ? theClass.classname : theClass),
			methodName: methodName,
			arguments: args,
			callback: (cb ? Dispatcher.convertFunctionToJSON(cb) : null)
		};
		
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},


	// callback communication

	/**
  	 * Takes a callback and sends it to a remote interpreter.
	 *	 
	 * @name Social.US.Dispatcher.sendCallbackToRemote
	 * @function
	 * @private
	 *
	 * @param {String} callbackUID The user ID of the user receiving the callback.
	 * @param {Array} args An array of parameters for the callback function.
	 */		
	sendCallbackToRemote: function(callbackUID, args){		
		args = Dispatcher.convertArgumentsArrayToJSON(args || []);
		
		var cmd = {
			apiURL: "US.Dispatcher.receiveCallbackFromRemote",
			callbackUID: callbackUID,
			arguments: args,
			zone: GSGlobals.getRouterInstance().zone
		};

		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	/**
	 * Receives a callback from a remote interpreter and provides the arguments to the local callback function.
	 *	 
	 * @name Social.US.Dispatcher.receiveCallbackFromRemote
	 * @function
	 * @private
	 *
	 * @param {Type} command A JSON object containing the user ID of the user receiving the callback and the callback arguments array.
	 */			
	receiveCallbackFromRemote: function(command){
		var callback = Dispatcher.callbacks[GSGlobals.getRouterInstance().zone][command.callbackUID]; //Dispatcher.convertFunctionFromJSON(command);
		if(!callback){
			return;
		}

		var args = Dispatcher.convertArgumentsArrayFromJSON(command.arguments || []);
		
		callback.apply(callback, args);
	},
	

	// convenience functions to facilitate communication of all objects
	
	/**
	 * Parses a JSON array of function parameters and returns an array of function parameters.
	 *	 
	 * @name Social.US.Dispatcher.convertArgumentsArrayFromJSON
	 * @function
	 * @private
	 * 
	 * @param {Array} args An array of function parameters in JSON format.
	 * @return {Array} Returns an array of function parameters.
	 */	
	convertArgumentsArrayFromJSON: function(args){		
		var newArgs = [];
		for(var idx=0; idx < args.length; idx++){
			var arg = args[idx];
			
			if(arg && ((arg.recordID && arg.classname) || arg instanceof Array)){
				newArgs[idx] = Dispatcher.convertModelObjectFromJSON(arg);
			}else if(arg && arg.callbackUID){
				newArgs[idx] = Dispatcher.convertFunctionFromJSON(arg);
			}else{
				newArgs[idx] = arg;
			}
		}
		return newArgs;
	},

	/**
	 * Parses an array of function parameters and returns the array in JSON format.	 
	 * @name Social.US.Dispatcher.convertArgumentsArrayToJSON
	 * @function
	 * @private
	 *
	 * @param {Array} args An array of function parameters.
	 * 
	 * @returns {JSON} An array of function parameters in JSON format.
	 */
	convertArgumentsArrayToJSON: function(args){		
		var newArgs = [];
		for(var idx=0; idx < args.length; idx++){
			var arg = args[idx];
			if(arg && (arg.recordID && arg._classname && typeof arg._classname == "function" && arg._classname())){
				Dispatcher.sendObjectImmediately(arg);

				arg = Dispatcher.convertModelObjectToJSON(arg);
				newArgs[idx] = arg;
			}else if(arg && arg instanceof Array){
				arg = Dispatcher.convertArgumentsArrayToJSON(arg);
				newArgs[idx] = arg;
			}else if(arg && typeof arg == "function"){
				newArgs[idx] = Dispatcher.convertFunctionToJSON(arg);
			}else{
				newArgs[idx] = arg;
			}
		}
		return newArgs;
	},

	// convenience functions to facilitate communication of DataModel objects
	
	/**
	 * Takes a <code>DataModel</code> object and returns the object in JSON format.
	 *	 
	 * @name Social.US.Dispatcher.convertModelObjectToJSON
	 * @function
	 * @private
	 * 
	 * @param {Social.Models.DataModel} object A reference to a <code>DataModel</code> object (i.e., typically a subclass of <code>Models.DataModel</code>).
	 *
	 * @return {JSON} A <code>DataModel</code> object in JSON format.
	 */		
	convertModelObjectToJSON: function(object){		
		if(object && object.recordID && object._classname()){
			object = {
				classname: object._classname(),
				recordID:  object.recordID
			};
		}
		return object;
	},


	/**
	 * Takes a <code>DataModel</code> object in JSON format and returns the object.
	 *	 
	 * @name Social.US.Dispatcher.convertModelObjectFromJSON
 	 * @function
 	 * @private
 	 *
	 * @param {JSON} json A <code>DataModel</code> object in JSON format.
	 * 
	 * @return {Social.US.DataModel} A <code>DataModel</code> object.
	 */		
	convertModelObjectFromJSON: function(json){		
		var object = json;
		if(json.recordID && json.classname){
			var obj = Dispatcher.cache().getObjectWithRecordID(json.classname, json.recordID);
			if(obj){
				object = obj;
				if(json.data){
					object._deserializeFromHash(json.data);
				}
			}
		}else if(json instanceof Array){
			for(var idx=0; idx < json.length; idx++){
				var arg = json[idx];
				json[idx] = Dispatcher.convertModelObjectFromJSON(arg);
			}
		}
		return object;
	},

	// convenience functions to facilitate communication of functions
	
	/**
	 * Takes a function and returns the function in JSON format.
	 *	 
	 * @name Social.US.Dispatcher.convertFunctionToJSON
	 * @function
	 * @private	 
	 * 
	 * @param {function} The function to conver to JSON format.
	 * 
	 * @return {JSON} Returns a function in JSON format.
	 */		
	convertFunctionToJSON: function(fn){		
		if(fn && typeof fn == "function"){
			
			var callbackUID = ++Dispatcher.callbackUIDCounter;
			var zone = GSGlobals.getRouterInstance().zone;
			Dispatcher.callbacks[zone][callbackUID] = fn;

			fn = {
				callbackUID: callbackUID,
				zone: zone
			};
		}
		return fn;
	},


	
	/**
 	 * Takes a function expressed in JSON format and returns the function.
	 * @name Social.US.Dispatcher.convertFunctionFromJSON
	 * @function
	 * @private
	 * 
	 * @param {JSON} A function in JSON format.
	 * 
	 * @return {Function} Returns a function.
	 */	
	convertFunctionFromJSON: function(json){		
		var fn = json;
		var callbackUID = fn.callbackUID;
		var zone = fn.zone;
		
		if(callbackUID){
			var callback = Dispatcher.callbacks[zone][callbackUID];
			if(callback){
				fn = callback;
				delete Dispatcher.callbacks[zone][callbackUID];
			}else{
				fn = Dispatcher.generateCallbackForUID(callbackUID);
			}
		}
		return fn;
	},


	
	/**
	 * Takes a user ID and sends the callback to the remote interpreter.
	 *
	 * @name Social.US.Dispatcher.generateCallbackForUID
	 * @function
	 * @private
	 *	 
	 * @param {Number} The user ID.
	 * @return {Function} Returns a callback to the remote interpreter.
	 */	
	generateCallbackForUID: function(uid){		
		if(uid.callbackUID){
			uid = uid.callbackUID;
		}
		
		return function(){
			Dispatcher.sendCallbackToRemote(uid, arguments);
		};
	},
	
	
	// object sending and batching
	_batchCount: 0,
	_queuedObjects: [],
	
	/**
	 * <code>beginBatching()</code> increments the batch count.
	 * 
	 * @name Social.US.Dispatcher.
	 * @function
	 * @private
	 */	
	beginBatching: function(){		
		++Dispatcher._batchCount;
	},

	/**
	 * Decrements the batch count.
	 * Decrements the batch count and sends any objects remaining in the queue immediately.
	 *
	 * @name Social.US.Dispatcher.endBatching
	 * @function
	 * @private
	 */	
	endBatching: function(){		
		if((--Dispatcher._batchCount) === 0){
			for(var objKey in Dispatcher._queuedObjects){
				var obj = Dispatcher._queuedObjects[objKey];
				Dispatcher._queuedObjects[objKey] = undefined;
				Dispatcher.sendObjectImmediately(obj);
			}
		}
	},

	/**
	 * Takes an object and adds it to a queue, which pushes the object to the remote interpreter.
	 *
	 * @name Social.US.Dispatcher.sendObject
	 * @function
	 * @private
	 */
	sendObject: function(obj){		
		if(Dispatcher._queuedObjects.indexOf(obj) == -1){
			Dispatcher.beginBatching();
			
			var key = "" + obj.classname + "---" + obj.recordID;
			Dispatcher._queuedObjects[key] = obj;
			
			Dispatcher.endBatching();
		}
	},

	/**
	 * Takes an object and pushes it to the remote interpreter immediately (i.e., bypassing the queue).
	 *
	 * @name Social.US.Dispatcher.sendObjectImmediately
	 * @function
	 * @private
	 */
	sendObjectImmediately: function(obj){		
		if(!obj){
			return;
		}
		
		var cmd = {
			apiURL: "US.Dispatcher.receiveObject",
			data:   obj._serializedHash()
		};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	 * Receives a serialized object from the remote interpreter, retrieves the local version of the same object from the cache, and deserializes the received object to the local object.
	 * If there is no local version of the received object, <code>receiveObject()</code> creates a local version and adds it to the cache; then, it deserializes the received object to the newly created local object.
	 *
	 * @name Social.US.Dispatcher.receiveObject
	 * @function
	 * @private
	 */
	receiveObject: function(command){		
		var data = command.data;
		var theRecordID  = data.recordID;
		var theClassname = data.classname;
		var theData      = data.data;
		
		if(theRecordID && theClassname && Dispatcher.cache()){
			var obj = Dispatcher.cache().getObjectWithRecordID(theClassname, theRecordID);
			if(!obj){
				var theClass = SocialR.Social.US[theClassname];
				obj = new theClass(theRecordID);
				
				Dispatcher.cache().addObject(obj);
			}

			// TODO disable emitting somehow
			if(theData){
				obj._deserializeFromHash(theData);
			}
		}
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/Friends'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Friends'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Friends'] = exports; var RouterInited = require('NGCore/Client/Social/_Internal/RouterInit');
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;

var DataModelR = require('NGCore/Client/Social/US/Models/DataModel');
var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;

/**
 * @class 
 * @name Social.US.Service.Friends
 */
var Friends = exports.Friends = DataModelR.DataModel.subclass({
    classname: "Friends"
});

/**
 * Opens the "Find Friends" view.
 *
 * @name Social.US.Service.Friends.showFindFriends
 * @function
 * @public
 * @static
 *
 * @param selectedTab Takes an optional tab reference.
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */		
Friends.showFindFriends = function(selectedTab) {
		NgLogD("Public call showFindFriends");
	
		var cmd = {
			apiURL:"US.Service.Friends.showFindFriends"
		};
		
		if(selectedTab){
			cmd.data.tab = selectedTab;
		}
		
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
};

/**
 * Opens the "Friend Picker" view.
 * 
 * @name Social.US.Service.Friends.openFriendPicker
 * @function
 * @public 
 * @static
 * 
 * @param maxFriendsToPick The maximum number of friends to pick. <code>0</code> for unlimited.
 * @param {Function} callback Retrieves an array of picked users.
 * 
 * <br/> 
 * <b>Callback Example:</b><br/>
 * <pre class="code">function(error, pickedUsers){
 * &nbsp;&nbsp; if(error){
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
 * &nbsp;&nbsp; } else {
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var users = pickedUsers;
 * &nbsp;&nbsp;}
 * }
 * </pre>
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */		
Friends.showFriendPicker = function(maxFriendsToPick, callback) { 
    Dispatcher.callClassMethodOnRemoteObject(Friends, "showFriendPicker", [maxFriendsToPick, callback]);
};

/**
* <code>Social.US.Service.Friends</code> has an invited user message emitter. 
* To add a message listener to the message emitter, see the example below.
*
* @name Social.US.Service.Friends.invitedUserEmitter
* @field
* @public
* @example
* 
* Social.US.Service.Friends.invitedUserEmitter.addListener(
*				new Core.MessageListener(), 
*				function(user){ 
*				// do sth. w/ User object 
*				}
* Social.US.Service.Friends.invitedUserEmitter.emit({user: user});
* @see Core.MessageListener
* @see Core.MessageEmitter
* @status iOS, Android, Test, iOSTested, AndroidTested
*/
Friends.invitedUserEmitter = new MessageEmitter();; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/Profile'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Profile'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Profile'] = exports; var RouterInited = require('NGCore/Client/Social/_Internal/RouterInit');
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

/**
 * @class
 * @name Social.US.Service.Profile
 */

exports.Profile = {
	
	/**
	 * Shows the user profile of the user specified by the <code>userOrGamertag</code> parameter.
	 * 
	 * @name Social.US.Service.Profile.showUserProfile
	 * @function
	 * @public
	 * 
	 * @param userOrGamertag Identifies the user or gamertag corresponding to the user profile.
	 * @param tab Specifies the name of the tab to show when the UI opens. If <code>null</code>, it opens the default tab.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */			
	showUserProfile:function(userOrUserGamertag,tab){		
		var cmd = {
			apiURL:"US.Service.Profile.showUserProfile", 
			data:{
				user:userOrUserGamertag
			}
		};
		if(tab){cmd.tab = tab;}
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/ButtonOverlays'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/ButtonOverlays'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/ButtonOverlays'] = exports; var UI = require('NGCore/Client/UI').UI;

var RouterInited = require('NGCore/Client/Social/_Internal/RouterInit');
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;

var Friends = require('NGCore/Client/Social/US/Service/Friends').Friends;
var Profile = require('NGCore/Client/Social/US/Service/Profile').Profile;
var User    = require('NGCore/Client/Social/US/Models/User').User;

/**
 * @class 
 * @name Social.US.Service.ButtonOverlays
 */
exports.ButtonOverlays = {
	/**
	* Displays the "Mobage Community" button.
	*	
	* @name Social.US.Service.ButtonOverlays.showCommunityButton
	* @function
	* @public 
	* 
	* @param {exports.Gravity} gravity Displays the button in the specified corner.
	* @param {Function} callback The callback function if there is an error related to <code>gravity</code> or <code>theme</code> usage.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @see exports.Gravity
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/   
	showCommunityButton: function(gravity, callback) {
		NgLogD("Public - showCommunityButton");
		
		var cmd = {
			apiURL:"US.Service.ButtonOverlays.showCommunityButton"
		};
		
		cmd["gravity"] = gravity;
		
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		} else {
			cmd["callbackFunc"] = null;
		}
		
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	* Hides the "Mobage Community" button.
	*
	* @name Social.US.Service.ButtonOverlays.hideCommunityButton
	* @function
	* @public 
	*	
	* @param {Function} callback The callback function if there is an error hiding the button.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/	
	hideCommunityButton: function(callback) {
		NgLogD("Public - hideCommunityButton");
		
		var cmd = {
			apiURL:"US.Service.ButtonOverlays.hideCommunityButton"
		};
		
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		} else {
			cmd["callbackFunc"] = null;
		}
		
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	 * Shows the balance button.
	 * Shows the balance button where the <code>rect</code> parameter 
	 * determines the size and position of the button.
	 *
	 * @name Social.US.Service.ButtonOverlays.showBalanceButton
	 * @function
	 * @public
	 *	 
	 * @param {UI.ViewGeometry.Rect} rect Determines the size and position of the balance button.
	 * @param {Function} callback The callback function if there is an error with the <code>rect</code> parameter.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	 * &nbsp;&nbsp;   }
	 * </pre>
	 * @see UI.ViewGeometry.Rect
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	showBalanceButton: function(rect, callback) {
		NgLogD("Public - showBalanceButton");
		
		var cmd = {
			apiURL:"US.Service.ButtonOverlays.showBalanceButton"
		};
		
		if (rect != undefined) {
			cmd["rect"] = rect;
		} else {
			cmd["rect"] = new UI.ViewGeometry.Rect(50, 50, 0, 0);
		}
		
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		} else {
			cmd["callbackFunc"] = null;
		}
	
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	/**
	 * Hides the balance button.	
	 * @name Social.US.Service.ButtonOverlays.hideBalanceButton
	 * @function
	 * @public 
	 * 
	 * @param {Function} callback The callback function called after the view closes.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	 * &nbsp;&nbsp;   }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	hideBalanceButton: function(callback) {
		NgLogD("Public - hideBalanceButton");
		
		var cmd = {
			apiURL:"US.Service.ButtonOverlays.hideBalanceButton"
		};

		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		} else {
			cmd["callbackFunc"] = null;
		}
	
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/GameLaunchPayload'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/GameLaunchPayload'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/GameLaunchPayload'] = exports; var RouterInited = require('NGCore/Client/Social/_Internal/RouterInit');
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;

/**
* Provides an interface for retrieving a game's last payload from the game service. The game
* payload is returned as a string.
* @name Social.US.GameLaunchPayload
*/

var GameLaunchPayload = exports.GameLaunchPayload = {


	/**
	 * @name Social.US.GameLaunchPayload.getLastPayload
	 * @function
	 * @public
	 * 
	 * @param {Function} callback Retrieves the last payload generated by the game client from the game service 
     * as a string (e.g., JSON) and/or any error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, payload){
     *      if(error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     *      } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var pl = payload;     
     *      }
	 * }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
     */
	getLastPayload:function(callback)
	{
        if(callback != undefined && typeof callback == "function")
		{
			var cmd = {
				apiURL:"US.Service.GameLaunchPayload.getLastPayload"
			};

            cmd["callbackFunc"] = callback;

			GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
		}
	},
	
	// private, automatically called when new payload arrives. Do not call.
	onGameLaunchPayload:function(data)
	{
		this.newGamePayloadEmitter.emit(data);
	}
};

GameLaunchPayload.newGamePayloadEmitter = new MessageEmitter();; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/Bank'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Bank'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Bank'] = exports; // Bank Public Interface
var RouterInited 	= require('NGCore/Client/Social/_Internal/RouterInit');
var GSGlobals 		= require('NGCore/Client/Social/_Internal/GSGlobals');
var UI 				= require('NGCore/Client/UI').UI;

/**
* @ignore
* @private
*/
exports.Bank = {
};


/**
 * @class 
 * @name Bank.Debit
 * @description
 * Bank.Debit is an interface for in-game item purchasing. A transaction begins with a call to <code>createTransaction()</code>, which presents
 * a user interface to the user. If the user follows through with a purchase, the <code>transaction.state</code> property changes from 
 * <code>new</code> to <code>authorized</code>. Once <code>createTransaction()</code> executes its callback, the game may call 
 * <code>openTransaction()</code>, which changes the state from <code>authorized</code> to <code>open</code> and puts funds into escrow. 
 * At this point, the game/game server should deliver the purchased items. Once the items have been delivered, the game should call   
 * <code>closeTransaction()</code>. If there is a problem at any point in the transaction lifecycle, call <code>cancelTransaction()</code>,
 * which sets the <code>transactionState</code> property to <code>canceled</code> and restores funds from escrow back to the user.
 */
exports.Bank.Debit = {
	
		
	/**
	 * Creates a transaction. Initially, it sets the <code>transaction.state</code> to <code>new</code>.
     * Mobage presents a dialog that prompts the user to confirm the transaction. 
	 * If the user decides not to proceed with the transaction, the callback error returns as "usercanceled."
	 * In the client-only flow, this call checks inventory and sets the state to <code>authorized</code>.
	 * 
	 * @name Bank.Debit.createTransaction
	 * @function
	 * @public
	 * 
	 * @param {Array} billingItems The billing items for the transaction. <br/><b>Note:</b> The array is limited to one item for this release.
     * <br/><b>Array Example:</b><br/>
     * <pre class="code"> var billingItems = [{
     *     "item": {
     *           "id": "iceCastle",
     *          },
     *     "quantity": 1
     *    },
     *    {
     *     "item": {
     *           "id": "cobbleStoneRoad",
     *          },
     *     "quantity": 3
     *    } 
     * ];
     * </pre>
	 * @param {String} comment A comment about the transaction.
	 * @param {Function} callback Retrieves the transaction details and/or any error code and description.
	 * <br/> 
     * <b>Callback Example:</b><br/>
	 * <pre class="code">var createTxCallback = function (error, transaction){
	 *     if (error === 'usercanceled'){
     *         var userCanceledDlg = new UI.AlertDialog();
     *         userCanceledDlg.setTitle("Cancel Transaction");
     *         userCanceledDlg.setText("User canceled transaction.");
     *         userCanceledDlg.setChoices([('OK')]);
     *         userCanceledDlg.show();
     *     } else if(error){
     *         var errorCode = error.errorCode;
     *         var errorDesc = error.description;
     *         Bank.Debit.cancelTransaction(transaction.id);
     *     } else {
     *         txId = transaction.id;
     *         Bank.Debit.openTransaction(txId, openTxCallback)
     * };
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */				
    createTransaction: function(billingItems, comment, callback) {
		NgLogD("Public call createTransaction");
		
		
	var data = {
	    billingItems: billingItems,
	    comment: comment
	};
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.createTransaction",
			data: data
		};

		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = this._getCallBackFunc(callback);
		}    
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	/**
	 * Places funds into escrow and begins processing the transaction. 
	 * Indicates the game server needs to deliver the purchased item.
	 * The <code>transaction.state</code> transitions from <code>authorized</code> to <code>open</code>.
	 *
	 * @name Bank.Debit.openTransaction
	 * @function
	 * @public
	 * 
	 * @param {String} transactionId The <code>transactionId</code> identifying this transaction.
	 * @param {Function} callback Retrieves the transaction details and/or any error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var openTxCallback = function (error, transaction){
	 *      if (error){
	 *          var errorCode = error.errorCode;
     *          var errorDesc = error.errorDescription;
     *          Bank.Debit.cancelTransaction( transaction.id, 
     *                                        cancelTxCallback );
     *      } else {
     *          var txId = transaction.id;
     *          var txState = transaction.state;
     *          var txComment = transaction.comment;
     *          //You are responsible for delivering items to the client.
     *          MyGameTxClass.deliverItems(transaction.items);
     *          //If you do not close the tx, you do not get paid.
     *          Bank.Debit.closeTransaction( transaction.id, 
     *                                       closeTxCallback );
     *      }	
     * };
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
     */
	openTransaction: function(transactionId, callback) {
		NgLogD("Public call openTransaction");
		
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.openTransaction",
			data:{}
		};
		
		if (transactionId) {
			cmd.data.transactionId = transactionId;
		}
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = this._getCallBackFunc(callback);
		}
        
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	/**
	 * Continues processing a transaction.
	 * Checks the inventory to verify the item is valid, available, and so on. After verification, the <code>transaction.state</code> chranges from <code>new</code> to <code>authorized</code>,
	 * and funds are placed in escrow. The <code>transaction.state</code> transitions from <code>authorized</code> to <code>open</code>, which 
	 * indicates the game server needs to deliver the purchased item. 
	 * 	 
	 *
	 * @name Bank.Debit.continueTransaction
	 * @function
	 * @public
	 * 
	 * @param {String} transactionId The <code>transactionId</code> identifying this transaction.
	 * @param {Function} callback Retrieves the transaction details and/or any error code and description.
	 * <br/>
     * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, transaction){
     *      if(error) {
	 *           var errorCode = error.errorCode;
	 *           var errorDesc = error.description;
     *           Bank.Debit.cancelTransaction( transaction.id, 
     *                                         cancelTxCallback );
     *      } else {
     *           var tx = transaction;
     *           Bank.Debit.openTransaction( transaction.id, 
     *                                       openTxCallback );
     *      }
	 * };
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
    continueTransaction: function(transactionId, callback) {
		NgLogD("Public call continueTransaction");
		
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.continueTransaction",
			data:{}
		};
		
		if (transactionId) {
			cmd.data.transactionId = transactionId;
		}
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		}
        
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	

    /**
     * Cancels the transaction. The transaction was canceled or the purchased item was not delivered and the game
     * needs to return the user's funds. The <code>transaction.state</code> transitions to <code>canceled</code>.
     *
     * @name Bank.Debit.cancelTransaction
     * @function
     * @public 
     * 
     * @param {String} transactionId The <code>transactionId</code> identifying this transaction.
     * @param {Function} callback Retrieves the transaction ID and/or an error code and description.
     * <br/>
     * <b>Callback Example:</b><br/>
	 * <pre class="code">var cancelTxCallback = function (error, transaction){
     *     if (error){
     *        var errorCode = error.errorCode;
     *        var errorDesc = error.errorDescription;
     *        NgLogD('Time to freak out!: ' + errorCode+ ': ' + errorDesc);
     *     } else {
     *        var txId = transaction.id;
     *        var txState = transaction.state;
     *        var txComment = transaction.comment;
     *        if (txState === 'canceled'){
     *          NgLogD('Sniff, sniff... Whaaaaahhhh!!!');
     *        }	
	 *     }	
     * };
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
     */
    cancelTransaction: function(transactionId, callback) {
		NgLogD("Public call cancelTransaction");
		
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.cancelTransaction",
			data:{}
		};
		
		if (transactionId) {
			cmd.data.transactionId = transactionId;
		}
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		}
        
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
    },


	/**
	 * Closes the transaction. The virtual item was delivered.
	 * The <code>transaction.state</code> transitions from <code>open</code> to <code>closed</code>.
	 *
	 * @name Bank.Debit.closeTransaction
	 * @function
	 * @public
	 * 
	 * @param {String} transactionId The <code>transactionId</code> identifying this transaction.
	 * @param {Function} callback Retrieves the transaction details and/or an error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var closeTxCallback = function (error, transaction){
     *     if (error){
     *          var errorCode = error.errorCode;
     *          var errorDesc = error.errorDescription;
     *          NgLogD('Oh my goodness! A transaction error: ' +
     *                  errorCode + ': ' + errorDesc);
     *          Bank.Debit.cancelTransaction( transaction.id, 
     *                                        cancelTxCallback );
	 *     } else {
     *          var txId = transaction.id;
     *          var txState = transaction.state;
     *          var txComment = transaction.comment;
     *          if (txState === 'closed'){
     *              NgLogD('I'm rich! I'm rich!');
     *          }	
     *     }	
     * };
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	closeTransaction: function(transactionId, callback) {
		NgLogD("Public call closeTransaction");
		
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.closeTransaction",
			data:{}
		};
		
		if (transactionId) {
			cmd.data.transactionId = transactionId;
		}
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = this._getCallBackFunc(callback);
		}
        
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	/**
	 * Retrieves the transaction corresponding to the given transaction ID parameter.
	 *
	 * @name Bank.Debit.getTransaction
	 * @function
	 * @public
	 * 
	 * @param {String} transactionId The <code>transactionId</code> identifying this transaction.
	 * @param {Function} callback Retrieves the transaction details and/or an error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, transaction){
     *      if(error) {
	 *            var errorCode = error.errorCode;
	 *            var errorDesc = error.description;
     *      } else {
     *            var tx = transaction;     
     *      }
	 *   }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getTransaction: function(transactionId, callback) {
		NgLogD("Public call getTransaction");
		
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.getTransaction",
			data:{}
		};
		
		if (transactionId) {
			cmd.data.transactionId = transactionId;
		}
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = this._getCallBackFunc(callback);
		}
        
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	 * Retrieves the user's transactions where the state is <code>new</code>, <code>authorized</code> or <code>open</code>.
     * See the Game Service Programming Guide for details.
	 *
	 * @name Bank.Debit.getPendingTransactions
	 * @function
	 * @public
	 * 
	 * @param {Function} callback Retrieves the user's pending transactions and/or an error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, transaction){
     *      if(error) {
	 *         var errorCode = error.errorCode;
	 *         var errorDesc = error.description;
     *      } else {
     *         var tx = transaction;     
     *      }
	 * }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getPendingTransactions: function(callback) {
		NgLogD("Public call getPendingTransactions");

		var cmd = {
			apiURL:"US.Service.Banking.Purchase.getPendingTransactions",
			data:{}
		};

		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = function(err, data) {
				callback(err.error, data.openTransactions);
			};
		}

	    GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	_getCallBackFunc : function(callback) {
			return function(err, data) {
				if(err) {
					callback(err, undefined);
				} else {
					callback(err, data.transaction);					
				}
			};
	}
};

/**
 * @class 
 * @name Bank.Inventory
 * @description
 * Provides an interface to retrieve items from inventory. The Mobage platform
 * server is responsible for managing item inventory in games.
 */
exports.Bank.Inventory = {


	/**
	 * Retrieves the item identified by its product ID from inventory on the Mobage platform server.
	 *
	 * @name Bank.Inventory.getItem
	 * @function
	 * @public
	 * 
	 * @param {Number} itemId The product ID for the item.
     * @param {Function} callback Retrieves the item from inventory on the Mobage platform server and/or an error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var item = {
     *      "id" : "XXXXXXXXX",
     *      "name" : "Tractor",
     *      "price" : 350,
     *      "description" : "Tractor conveys huge amount of equipment.",
     *      "imageUrl" : "http://someurl.com"
     * }
     *function(error, item){
     *      if(error) {
	 *         var errorCode = error.errorCode;
	 *         var errorDesc = error.description;
     *      } else {
     *         var itemData = item;
     *      }
	 * }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */    
    getItem: function(itemId,callback) {
	NgLogD("Public call Inventory getItem");

	var data = {
	    itemId: itemId
	};

	var cmd = {
	    apiURL:"US.Service.Banking.Purchase.getItem",
	    data:data
	};

	if (callback != undefined && typeof callback == "function") {
	    cmd["callbackFunc"] =  function(err, data) {
		if(err) {
		    callback(err, undefined);
		} else {
		    callback(err, data.item);					
		}
	    };
	}

	GSGlobals.getRouterInstance().sendCommandToGameService(cmd);

    }


};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/_Internal/GSGlobals'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/_Internal/GSGlobals'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/_Internal/GSGlobals'] = exports; /**
 * Annoyingly necessary file to break circular dependencies.
 */
var theRouter = null;
exports.setRouterInstance = function(router){
	theRouter = router;
};
exports.getRouterInstance = function(){
	return theRouter;
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/_Internal/RouterInit'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/_Internal/RouterInit'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/_Internal/RouterInit'] = exports; var Router = require('NGCore/Client/Social/_Internal/_Router').Router;
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

//Generate 1 instance of our router now and treat as the global instance!
GSGlobals.setRouterInstance(new Router());; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/_Internal/_Router'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/_Internal/_Router'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/_Internal/_Router'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class Router INTERNAL ROUTING CLASS
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Shared/Class').Class;
var Core = require('NGCore/Client/Core').Core;
var GSCommand = require('NGCore/Client/Social/_Internal/GSCommand');
var Public = require('NGCore/Client/Social').Social;

////////////////////////////////////////////////////////////////////////////////
var RouterVerbose = false;

exports.Router = Class.subclass(
/** @lends GameService.Router.prototype */
{
	classname: 'Router',
	
	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	/** Member var to help shortcircuit uneccessary bounces out to native. */
	zone:-2,
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
			* Zone for this Router Singleton (per-process)
			* @private */
	Zone:
	{ 
		/** Public Zone */
		Public: -2,
		/** GameService Zone */
		GameService: -1,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 346
	// Method create = -1
	// Method sendToOtherProcess = 2
	// Method onCreate = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._sendToOtherProcessRecv( cmd );
					break;
				case 3:
					instance._onCreateRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Router._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Router._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[346] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_sendToOtherProcessRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Router.sendToOtherProcess from command: " + cmd );
			return false;
		}
		
		obj[ "gsCommand" ] = Core.Proc.parseJSONString( cmd[ 0 ] );
		if( obj[ "gsCommand" ] === undefined )
		{
			NgLogE("Could not parse gsCommand in Router.sendToOtherProcess from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_onCreateRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Router.onCreate from command: " + cmd );
			return false;
		}
		
		obj[ "zone" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "zone" ] === undefined )
		{
			NgLogE("Could not parse zone in Router.onCreate from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":346,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_sendToOtherProcessSendGen: function( gsCommand )
	{
		Core.Proc.appendToCommandString( ":346,2," + this.__objectRegistryId + "," + Core.Base64.encode( JSON.stringify( gsCommand ) )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _sendToOtherProcessRecv: function( cmd ) {}
	// sendToOtherProcess: function( gsCommand ) {}
	
	// _onCreateRecv: function( cmd ) {}

// {{/Wg Generated Code}}
	_onCreateRecv:function(cmd) {
		if (!this._onCreateRecvGen(cmd,this)){
			return;
		}
		NgLogD("_Router/_onCreateRecv: "+this.zone);
		//We already stored the zone directly in ourselves (by passing in 'this').
	},
	_sendToOtherProcessRecv: function( cmd )
	{
		var decodedCommand = {};
		if(!this._sendToOtherProcessRecvGen(cmd,decodedCommand)){
			NgLogE("Decode of data for router, failed.");
			return;
		}
		
		var commandObject = decodedCommand["gsCommand"];
		
		//Incoming commands all get executed immediately.
		if(this.zone == this.Zone.Public) {
			if(RouterVerbose) {
				NgLogD("_Router/_sendToOtherProcessRecv - in public");
			}
			
			this.dispatchGameCommand(commandObject);
		}
		else if(this.zone == this.Zone.GameService) {
			if(RouterVerbose) {
				NgLogD("_Router/ _sendToOtherProcessRecv - in privileged");
			}
			
			// Dispatch Immediately, because we are in the right interpreter
			this.dispatchGameServiceCommand(commandObject);
		}
		else {
			NgLogE("Unknown Command Zone for the GameService Router.");
			// Assume public
			this.dispatchGameCommand(commandObject);
		}
	},
 	sendToOtherProcess: function( gsCommand ) 
	{
		var jsonCommand = GSCommand.makeSafe(gsCommand);
		if(!jsonCommand) {
			NgLogD("Couldn't prep GSCommand message for sending!");
			return;
		}
		
		if(RouterVerbose) {
			NgLogD("_Router.js/sendToOtherProcess: " + JSON.stringify(jsonCommand));
		}
		
		this._sendToOtherProcessSendGen(jsonCommand);
	},
	sendCommandToGameService:function(gsCommand) 
	{		
		if(this.zone == this.Zone.Public) {
			if(RouterVerbose) {
				NgLogD("_Router: sendCommandToGameService - in public");
			}
			
			// In the Public Interface, this is an alias for sendToOtherProcess
			this.sendToOtherProcess(gsCommand);
		}
		else if(this.zone == this.Zone.GameService) {
			if(RouterVerbose) {
				NgLogD("_Router: sendCommandToGameService - in privileged");
			}
			
			// Dispatch Immediately, because we are in the right interpreter
			this.dispatchGameServiceCommand(gsCommand);
		}
		else {
			NgLogE("Unknown Command Zone for the GameService Router.");
			// Assume public
			this.sendToOtherProcess(gsCommand);
		}
	},
	sendCommandToGame:function(gsCommand)
	{
		if(this.zone == this.Zone.GameService) {
			// In the GameService Interface, this is an alias for sendToOtherProcess
			this.sendToOtherProcess(gsCommand);
		}
		else if(this.zone == this.Zone.Public) {
			// Dispatch Immediately, because we are in the right interpreter
			this.dispatchGameCommand(gsCommand);
		}
		else {
			NgLogE("Unknown Command Zone for the GameService Router.");
			// Assume Privileged
			this.sendToOtherProcess(gsCommand);
		}
	},
	dispatchGameCommand:function(jsonCommand) 
	{
		var tCommand = GSCommand.makeExecutable(jsonCommand);
		//For the time being we expect this to almost always be callbacks
		if(tCommand && tCommand.hasOwnProperty("callbackFunc")) {	
			if( typeof tCommand["callbackFunc"] == "function" ) {
				var args = null;
				var error = null;
				if(tCommand.hasOwnProperty("error")) {
					error = tCommand["error"];
				}
				if(tCommand.hasOwnProperty("callbackData")) {
					args = tCommand["callbackData"];
				}

				//Time to execute the callback function!
				tCommand["callbackFunc"](error,args);
			}
		}
		else if(tCommand) {
			// Case there was no callbackFunc this is odd!!
			var apiURL = null;
			if(tCommand && tCommand.hasOwnProperty("apiURL") ) {
				apiURL = tCommand["apiURL"];

				var apiPieces = apiURL.split(".");
				var curPackage = Public;

				for ( var i = 0; i < apiPieces.length; i++ )
				{
					if(curPackage.hasOwnProperty(apiPieces[i])) {
						curPackage = curPackage[apiPieces[i]];
					}
					else {
						//Total Fail
						NgLogE("Cannot find namespace " + apiURL + " in GameService");
						curPackage = null;
						break;
					}
				}

				if(curPackage && typeof curPackage == "function" ) {			
					curPackage(tCommand);

					return; //done dispatching!
				}else{
					NgLogE("GameService Public cannot dispatch game command " + JSON.stringify(tCommand));
				}
			}
		}
	},
	dispatchGameServiceCommand:function(jsonCommand) 
	{
		//Don't decode the callbackId into a func when on a different interpreter!
		var apiURL = null;
		if(jsonCommand && jsonCommand.hasOwnProperty("apiURL") ) {
			apiURL = jsonCommand["apiURL"];

			var apiPieces = apiURL.split(".");
			var curPackage = require('NGCore/Client/Social/_Internal/Privileged').Social;

			for ( var i = 0; i < apiPieces.length; i++ )
			{
				if(curPackage.hasOwnProperty(apiPieces[i])) {
					curPackage = curPackage[apiPieces[i]];
				}
				else {
					//Total Fail
					NgLogE("Cannot find namespace " + apiURL + " in GameService");
					curPackage = null;
					break;
				}
			}

			if(curPackage && typeof curPackage == "function" ) {			
				curPackage(jsonCommand);

				return; //done dispatching!
			}
		}
		else {
			NgLogE("Someone called GameService without the proper parameters.\n");
		}
	},
	setVerboseLogging:function(useVerbose)
	{
		RouterVerbose = useVerbose;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/_Internal/GSCommand'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/_Internal/GSCommand'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/_Internal/GSCommand'] = exports; /**
 * GSCommand.js
 * GameService Command Helper
 *
 * @summary Converts hashes for sending across the interpreter bounds, specifically:
 *		- Takes a hash with a callbackFunc
 * 			- Takes callbackFunc and converts to callbackId
 *		- Takes a hash with a callbackId
 *			- Takes the callbackId and looks up a callbackFunc from the local cache
 */
 
var GameServiceCommandCallbackStore = {};
GameServiceCommandCallbackStore.uidGenerator = 0;

/* @private */
var storeCallbackIdForFunc = function(callbackFunc) {
	var uid = GameServiceCommandCallbackStore.uidGenerator++;
	GameServiceCommandCallbackStore[uid] = callbackFunc;
	return uid;
};
/* @private */
var extractFuncForCallbackId = function(callbackId) {
	if(GameServiceCommandCallbackStore.hasOwnProperty(callbackId)){
		var callbackFunc = GameServiceCommandCallbackStore[callbackId];
		delete GameServiceCommandCallbackStore[callbackId];
		return callbackFunc;
	}
	return null;
};

var blindConvert = function(hash) {
	if ( typeof hash == "object" ) {
		// Case we have a hash
		if ( hash.hasOwnProperty("callbackFunc") ) {
			//	with a callback func to convert
			hash["callbackId"] = storeCallbackIdForFunc(hash["callbackFunc"]);
			
			delete hash["callbackFunc"];
		}
		else if (hash.hasOwnProperty("callbackId")) {
			hash["callbackFunc"] = extractFuncForCallbackId(hash["callbackId"]);
			delete hash["callbackId"];
		}
		return hash;
	}
	
	NgLogD("Error: invalid or non-object passed to gsCmdConvert.");
	return null;
};
exports.makeSafe = function(hash) {
	if (hash && typeof hash == "object" && hash.hasOwnProperty("callbackFunc"))
	{
		return blindConvert(hash);
	}
	return hash;
};
exports.makeExecutable = function(hash) {
	if (hash && typeof hash == "object" && hash.hasOwnProperty("callbackId"))
	{
		return blindConvert(hash);
	}
	return hash;
};

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/_Internal/Privileged'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/_Internal/Privileged'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/_Internal/Privileged'] = exports; /**
 * Privileged API for GameService (Public Stub)
 * 
 * Access this file as NGCore/Client/Social.js
 */
exports.Social = {
	// stubbed out for the SDK
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/OrderedList'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/OrderedList'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/OrderedList'] = exports; var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;

/**
 * @class 
 * @name Social.US.OrderedList
 * @description
 * Do not instantiate <code>OrderedList</code> objects directly. This description is for information purposes only. 
 * <code>DataModel</code> subclasses that return <code>OrderedList</code> interfaces include:<br/><br/>
 * <div class="ul">
 * <li>{@link Social.US.User}</li>
 * <li>{@link Social.US.Leaderboard}</li>
 * </div><br/>
 * Some <code>DataModel</code> subclasses can return an <code>OrderedList</code>,
 * which is an interface for iterating over a range of values. You determine the iteration range by
 * selecting one of three common functions: <br/><br/>
 * <div class="ul">
 * <li><code>forAll(iterCb, doneCb):</code> Iterates over all values.</li>
 * <li><code>forRange(start, count, iterCb, doneCb):</code> Iterates from the starting index to the count.</li>
 * <li><code>forItem(index, iterCb, doneCb):</code> Iterates over a particular item given by its index.</li>
 * </div>
 * Each of the functions calls an iteration callback (iterCb) for every available item. 
 * When the function iterates over all items or an error occurs, it calls the done callback (doneCb). You <b>MUST</b> provide both callbacks.
 * <br/><br/>
 * <b>Note:</b> The <code>OrderedList</code> interface invokes an iterator on the server. Do NOT assume it will execute your callback functions immediately.
 *
 * @example
 * //NOTE: You MUST provide both callback functions.
 * userBuddiesList.forAll( 
 *      function(error, details){//per item cb body}, 
 *      function(error, details){//done cb body}
 * );
 *
 * @example
 * //Callback examples
 * var done = false;
 * var err = null;
 *
 * currentUser.getFriendsList().forAll(
 *          function(continueCb, user, index){
 *				if(user == otherUser){
 *					foundBuddy = true;
 *					continueCb(false);
 *				}else{
 *					continueCb(true);
 *				}
 *			}, 
 *          function(error){
 *                  if (!error){
 *                      done = true;
 *                   } else {
 *                      err = error;
 *                   }
 *          }
 * );
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
var OrderedList = {

    /**
    * Returns a public interface for an object.
    * 
    * To expose a privelegee ordered list of a <code>DataModel</code> object in the public interface, 
    * add a function to the object of the corresponding <code>DataModel</code>
    * subclass in the public interface.
    * @example
    * getFollowersList: function(cb){
 	* 	return OrderedList.getObjectPublicInterface(this, "getFollowersList", "_followersListInterface");
	* },
    *
    * @name Social.US.OrderedList.getObjectPublicInterface
    * @function    
    * @private
    *
    * @param {Object} ownerObject The object that will "own" the public interface.
    * @param {Function} getListFn The function that returns a list of values to the <code>OrderedList</code>.
    * @param interfaceName The name of the interface.
    *
    * @return {Social.US.OrderedList} The public interface.
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */
    getObjectPublicInterface: function(ownerObject, getListFn, interfaceName) {
		if(ownerObject[interfaceName]) {
			return ownerObject[interfaceName];
		}
		
		var args = Array.apply(null, arguments);
		if(args && args.length > 3){
			args.splice(0, 3);
		}else{
			args = [];
		}
		
		var newInterface = {
			forAll: function(perItemCb, doneCb) {
				Dispatcher.callMethodOnRemoteObject(ownerObject, [getListFn, "forAll"], [args,[perItemCb, doneCb]]);		
			},
			forRange: function(start, count, perItemCb, doneCb) {
				Dispatcher.callMethodOnRemoteObject(ownerObject, [getListFn, "forRange"], [args,[start, count, perItemCb, doneCb]]);
			},
			forItem: function(index, perItemCb, doneCb) {
				Dispatcher.callMethodOnRemoteObject(ownerObject, [getListFn, "forItem"], [args,[index, perItemCb, doneCb]]);
			}
		};
		
		ownerObject[interfaceName] = newInterface;
		
		return newInterface;
	},

    /**
    * Returns a public interface for a class.
    * To expose a priveleged ordered list of a <code>DataModel</code> subclass in the public interface, 
    * add a function to the subclass of the corresponding <code>DataModel</code>
    * subclass in the public interface.
    * @example
    * getFollowersList: function(cb){
 	* 	return OrderedList.getClassPublicInterface(this, "getFollowersList", "_followersListInterface");
	* },    
    *
    * @name Social.US.OrderedList.getClassPublicInterface
    * @function
    * @private
    *
    * @param {Object} owner The owner of the the public interface.
    * @param {Function} getListFn The function to call on each iteration.
    * @param interfaceName The name of the interface.
    * 
    * @return {Social.US.OrderedList} The public interface.
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */
    getClassPublicInterface: function(owner, getListFn, interfaceName) {
		if(owner[interfaceName]) {
			return owner[interfaceName];
		}
		
		var newInterface = {
			forAll: function(perItemCb, doneCb) {
				Dispatcher.callClassMethodOnRemoteObject(owner, [getListFn, "forAll"], [[],[perItemCb, doneCb]]);
			},
			forRange: function(start, count, perItemCb, doneCb) {
				Dispatcher.callClassMethodOnRemoteObject(owner, [getListFn, "forRange"], [[],[start, count, perItemCb, doneCb]]);
			},
			forItem: function(index, perItemCb, doneCb) {
				Dispatcher.callClassMethodOnRemoteObject(owner, [getListFn, "forItem"], [[],[index, perItemCb, doneCb]]);
			}
		};
		
		owner[interfaceName] = newInterface;
		
		return newInterface;
	}
};

exports.OrderedList = OrderedList;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Color'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Color'] || {}; $MODULE_REGISTRY['NGCore/Shared/Color'] = exports; var Class = require('NGCore/Shared/Class').Class;

exports.Color = Class.subclass(
/** @lends Core.Color.prototype */
{
	classname: 'Color',
	
	/**
	 * @class The <code>Color</code> class constructs objects that control the RGB components of a device. 
	 * RGB is a color model used for rendering objects on-screen and is derived 
	 * from the three primary colors used in the model: red, green, and blue.
	 * Each value ranges from <code>(0-1)</code> and determines the color saturation level.	 
	 * @constructs The default constructor.<br><br>
	 * <b>Example:</b> The following code examples illustrate different call styles for <code>Color</code> objects.<br><br>
	 * A new color with all components set to one (1 = white).
	 * <pre class="code">var style1 = new Core.Color();</pre>
	 *
	 * Copy an existing color.
	 * <pre class="code">var style2 = new Core.Color(style1);</pre>
	 *
	 * Specify all three components.
	 * <pre class="code">var style3 = new Core.Color(1.0, 1.0, 1.0);</pre>
	 *
	 * Specify the color as solid blue.
	 * <pre class="code">var style4 = new Core.Color([0, 0, 1.0]);</pre>
	 *
	 * Specify the color as solid red.
	 * <pre class="code">var style5 = new Core.Color([1.0, 0, 0]);</pre>
	 * 
	 * Specify the color as a dark shade of red.
	 * <pre class="code">var style6 = new Core.Color([.5, 0, 0]);'</pre>
	 * @augments Core.Class
	 * @param {Number} [red=1] The red component.
	 * @param {Number} [green=1] The green component.
	 * @param {Number} [blue=1] The blue component.
	 * @throws {Wrong number of arguments for a Color} Number of parameters passed by this call is invalid.
	 */
	initialize: function(red, green, blue)
	{
		switch(arguments.length)
		{
			case 0:
				// ()
				this._red = 1.0;
				this._green = 1.0;
				this._blue = 1.0;
				break;
			case 1:
				var rhs = arguments[0];
				if(rhs === undefined)
				{
					// (undefined)
					this._red = 1.0;
					this._green = 1.0;
					this._blue = 1.0;
				}
				else if(!rhs.hasOwnProperty('length'))
				{
					// (color)
					this._red = rhs.getRed();
					this._green = rhs.getGreen();
					this._blue = rhs.getBlue();
				}
				else
				{
					switch(rhs.length)
					{
						case 0:
							// ([])
							this._red = 1.0;
							this._green = 1.0;
							this._blue = 1.0;
							break;
						case 1:
							// ([color])
							rhs = rhs[0];
							this._red = rhs.getRed();
							this._green = rhs.getGreen();
							this._blue = rhs.getBlue();
							break;
						case 3:
							// ([red, green, blue])
							this._red = rhs[0];
							this._green = rhs[1];
							this._blue = rhs[2];
							break;
						default:
							throw new Error('Wrong number of arguments for a Color');
					}
				}
				break;
			case 3:
				// (red, gree, blue)
				this._red = arguments[0];
				this._green = arguments[1];
				this._blue = arguments[2];
				break;
			default:
				throw new Error('Wrong number of arguments for a Color');
		}
		return this;
	},
	
	/**
	 * Set the saturation level for all three color components.
	 * @example Core.Color.setAll(0.5, 0.5, 1.0);
	 * @param {Number} [red=1] The red component.
	 * @param {Number} [green=1] The green component.
	 * @param {Number} [blue=1] The blue component.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Color for a full list of supported calling styles.
	 */
	setAll: function(red, green, blue)
	{
		this.constructor.apply(this, arguments);
		return this;
	},
	
	/**
	 * Retrieve the saturation level for the red component of this <code>Color</code>.
	 * @returns {Number} The current saturation level for the red component.
	 */
	getRed: function()
	{
		return this._red;
	},
	
	/**
	 * Retrieve the saturation level for the green component of this <code>Color</code>.
	 * @returns {Number} The current saturation level for the green component.
	 */
	getGreen: function()
	{
		return this._green;
	},
	
	/**
	 * Retrieve the saturation level for the blue component of this <code>Color</code>.
	 * @returns {Number} The current saturation level for the blue component.
	 */
	getBlue: function()
	{
		return this._blue;
	},
	
	/**
	 * Set the saturation level for the red component of this <code>Color</code>.
	 * @example Core.Color.setRed(0.7);
	 * @param {Number} red The new saturation level for the red component.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Color#getRed
	 */
	setRed: function(red)
	{
		this._red = red;
		return this;
	},
	
	/**
	 * Set the saturation level for the green component of this <code>Color</code>.
	 * @example Core.Color.setGreen(0.3);
	 * @param {Number} green The new saturation level for the green component.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Color#getGreen
	 */
	setGreen: function(green)
	{
		this._green = green;
		return this;
	},
	
	/**
	 * Set the saturation level for the blue component of this <code>Color</code>.
	 * @example Core.Color.setBlue(1.0);
	 * @param {Number} blue The new saturation level for the blue component.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Color#getBlue
	 */
	setBlue: function(blue)
	{
		this._blue = blue;
		return this;
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Vector'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Vector'] || {}; $MODULE_REGISTRY['NGCore/Shared/Vector'] = exports; var Class = require('NGCore/Shared/Class').Class;

exports.Vector = Class.subclass(
/** @lends Core.Vector.prototype */
{
	classname: 'Vector',
	
	/**
	 * @class The <code>Vector</code> class constructs objects that define vector point values for the <i>x</i> and <i>y</i> components. 
	 * Supported values range between <code>(0-1)</code>.
	 * @constructs The default constructor. <br><br>
	 * The following code examples illustrate a variety of different calling styles for <code>Vector</code> objects.<br><br>
	 * All components are set to zero.
	 * <pre class="code">var style1 = new Core.Vector();</pre>
	 *
	 * Copy an existing vector.
	 * <pre class="code">var style2 = new Core.Vector(style1);</pre>
	 *
	 * Specify a value for both components.
	 * <pre class="code">var style3 = new Core.Vector(1.0, 1.0);</pre>
	 *
	 * Specify a value for both components.
	 * <pre class="code">var style4 = new Core.Vector([1.0, 1.0]);</pre>
	 * @augments Core.Class
	 * @param {Number} [x=0] The <i>x</i> component.
	 * @param {Number} [y=0] The <i>y</i> component.
	 * @throws {Wrong number of arguments for a Vector} Number of parameters passed by this call is invalid.
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		switch(arguments.length)
		{
			case 0:
				// ()
				this._x = 0;
				this._y = 0;
				break;
			case 1:
				var rhs = arguments[0];
				if(rhs === undefined)
				{
					// (undefined)
					this._x = 0;
					this._y = 0;
				}
				else if(!rhs.hasOwnProperty('length'))
				{
					// (vector)
					this._x = rhs.getX();
					this._y = rhs.getY();
				}
				else
				{
					switch(rhs.length)
					{
						case 0:
							// ([])
							this._x = 0;
							this._y = 0;
							break;
						case 1:
							// ([vector])
							rhs = rhs[0];
							this._x = rhs.getX();
							this._y = rhs.getY();
							break;
						case 2:
							// ([x, y])
							this._x = rhs[0];
							this._y = rhs[1];
							break;
						default:
							throw new Error('Wrong number of arguments for a Vector');
					}
				}
				break;
			case 2:
				// (x, y)
				this._x = arguments[0];
				this._y = arguments[1];
				break;
			default:
				throw new Error('Wrong number of arguments for a Vector');
		}
	},
	
	/**
	 * Set the value of both components for this <code>Vector</code>. 
	 * @param {Number} [x=0] The new <i>x</i> coordinate.
	 * @param {Number} [y=0] The new <i>y</i> coordinate.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Vector for examples of supported calling styles.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAll: function()
	{
		this.constructor.apply(this, arguments);
		return this;
	},
	
	/**
	 * Duplicate this <code>Vector</code>.
	 * @returns {Core.Vector} A new vector with identical coordinates to the duplicated vector.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	clone: function()
	{
		return new this.constructor(this);
	},
	
	/**
	 * Retrieve the value of the <i>x</i> component for this <code>Vector</code>.
	 * @returns {Number} The current <i>x</i> coordinate.
	 * @see Core.Vector#setX
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getX: function()
	{
		return this._x;
	},
	
	/**
	 * Set the value of the <i>x</i> component for this <code>Vector</code>.
	 * @param {Number} <i>x</i> The new <i>x</i> coordinate.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Vector#getX
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setX: function(x)
	{
		this._x = x;
		return this;
	},
	
	/**
	 * Retrieve the value of the <i>y</i> component for this <code>Vector</code>.
	 * @returns {Number} The current <i>y</i> coordinate.
	 * @see Core.Vector#setY
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getY: function()
	{
		return this._y;
	},
	
	/**
	 * Set the value of the <i>y</i> component for this <code>Vector</code>.
	 * @param {Number} <i>y</i> The new <i>y</i> coordinate.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Vector#getY
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setY: function(y)
	{
		this._y = y;
		return this;
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Point'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Point'] || {}; $MODULE_REGISTRY['NGCore/Shared/Point'] = exports; var Class = require('NGCore/Shared/Class').Class;

exports.Point = Class.subclass(
/** @lends Core.Point.prototype */
{
	classname: 'Point',
	
	/**
	 * @class The <code>Point</code> class defines a 2D point coordinate (<i>x</i> and <i>y</i>). 
	 * @status iOS, Android, Flash, Test
	 * @constructs The default constructor. <br><br>
	 * <b>Example:</b>The following code examples illustrate a variety of different calling styles for <code>Point</code> objects.<br><br>
	 * All components are set to zero.
	 * <pre class="code">var style1 = new Core.Point();</pre>
	 *
	 * Copy an existing point.
	 * <pre class="code">var style2 = new Core.Point(style1);</pre>
	 *
	 * Specify a value for both components.
	 * <pre class="code">var style3 = new Core.Point(1.0, 1.0);</pre>
	 *
	 * Specify a value for both components.
	 * <pre class="code">var style4 = new Core.Point([1.0, 1.0]);</pre>
	 * @augments Core.Class
	 * @param {Number} [x=0] The <i>x</i> coordinate.
	 * @param {Number} [y=0] The <i>y</i> coordinate.
	 * @throws {Wrong number of arguments for a Point} Number of parameters passed by this call is invalid.
	 */
	initialize: function(x, y)
	{
		switch(arguments.length)
		{
			case 0:
				// ()
				this._x = 0;
				this._y = 0;
				break;
			case 1:
				var rhs = arguments[0];
				if(rhs === undefined)
				{
					// (undefined)
					this._x = 0;
					this._y = 0;
				}
				else if(!rhs.hasOwnProperty('length'))
				{
					// (point)
					this._x = rhs.getX();
					this._y = rhs.getY();
				}
				else
				{
					switch(rhs.length)
					{
						case 0:
							// ([])
							this._x = 0;
							this._y = 0;
							break;
						case 1:
							// ([point])
							rhs = rhs[0];
							this._x = rhs.getX();
							this._y = rhs.getY();
							break;
						case 2:
							// ([x, y])
							this._x = rhs[0];
							this._y = rhs[1];
							break;
						default:
							throw new Error('Wrong number of arguments for a Point');
					}
				}
				break;
			case 2:
				// (x, y)
				this._x = arguments[0];
				this._y = arguments[1];
				break;
			default:
				throw new Error('Wrong number of arguments for a Point');
		}
	},
	
	/**
	 * Set the value of both the <i>x</i> and <i>y</i> components. 
	 * @param {Number} [<i>x</i>=0] The new <i>x</i> coordinate.
	 * @param {Number} [<i>y</i>=0] The new <i>y</i> coordinate.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Point for examples of supported calling styles.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAll: function(x, y)
	{
		this.constructor.apply(this, arguments);
		return this;
	},
	
	/**
	 * Duplicate this <code>Point</code>.
	 * @returns {Core.Point} A new point with identical <i>x</i> and <i>y</i> coordinates to the cloned point.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	clone: function()
	{
		return new this.constructor(this);
	},
	
	/**
	 * Retrieve the value of the <i>x</i> component of this <code>Point</code>.
	 * @returns {Number} The current <i>x</i> coordinate.
	 * @see Core.Point#setX
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getX: function()
	{
		return this._x;
	},
	
	/**
	 * Set the value of the <i>x</i> component for this <code>Point</code>.
	 * @param {Number} <i>x</i> The new <i>x</i> coordinate.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Point#getX
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setX: function(x)
	{
		this._x = x;
		return this;
	},
	
	/**
	 * Retrieve the value of the <i>y</i> component of this <code>Point</code>.
	 * @returns {Number} The current <i>y</i> coordinate.
	 * @see Core.Point#setY
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getY: function()
	{
		return this._y;
	},
	
	/**
	 * Set the value of the <i>y</i> component for this <code>Point</code>.
	 * @param {Number} <i>y</i> The new <i>y</i> coordinate.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Point#getY
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setY: function(y)
	{
		this._y = y;
		return this;
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Size'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Size'] || {}; $MODULE_REGISTRY['NGCore/Shared/Size'] = exports; var Class = require('NGCore/Shared/Class').Class;

exports.Size = Class.subclass(
/** @lends Core.Size.prototype */
{
	classname: 'Size',
	
	/**
	 * @class The <code>Size</code> class constructs objects that define size values for the <i>height</i> and <i>width</i> components. 
	 * @status iOS, Android, Flash
	 * Supported values range between <code>(0-1)</code>.
	 * @constructs The default constructor. <br><br>
	 * The following code examples illustrate a variety of different calling styles for <code>Size</code> objects.<br><br>
	 * Set both component values to 0.
	 * <pre class="code">var style1 = new Core.Size();</pre>
	 *
	 * Copy an existing size.
	 * <pre class="code">var style2 = new Core.Size(style1);</pre>
	 *
	 * Specify a value for both components.
	 * <pre class="code">var style3 = new Core.Size(1.0, 1.0);</pre>
	 *
	 * Specify a value for both components.
	 * <pre class="code">var style4 = new Core.Size([1.0, 1.0]);</pre>
	 * @augments Core.Class
	 * @param {Number} [width=0] The <i>width</i> component.
	 * @param {Number} [height=0] The <i>height</i> component.
	 */
	initialize: function(width, height)
	{
		switch(arguments.length)
		{
			case 0:
				// ()
				this._width = 0;
				this._height = 0;
				break;
			case 1:
				var rhs = arguments[0];
				if(rhs === undefined)
				{
					// (undefined)
					this._width = 0;
					this._height = 0;
				}
				else if(!rhs.hasOwnProperty('length'))
				{
					// (size)
					this._width = rhs.getWidth();
					this._height = rhs.getHeight();
				}
				else
				{
					switch(rhs.length)
					{
						case 0:
							// ([])
							this._width = 0;
							this._height = 0;
							break;
						case 1:
							// ([size])
							rhs = rhs[0];
							this._width = rhs.getWidth();
							this._height = rhs.getHeight();
							break;
						case 2:
							// ([x, y])
							this._width = rhs[0];
							this._height = rhs[1];
							break;
						default:
							throw new Error('Wrong number of arguments for a Size');
					}
				}
				break;
			case 2:
				// (x, y)
				this._width = arguments[0];
				this._height = arguments[1];
				break;
			default:
				throw new Error('Wrong number of arguments for a Size');
		}
	},
	
	/**
	 * Set the value of all components for this <code>Size</code>. 
	 * @param {Number} [width=0] The new <i>width</i>.
	 * @param {Number} [height=0] The new <i>height</i>.
	 * @throws {Wrong number of arguments for a Size} Number of parameters passed by this call is invalid.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Size for examples of supported calling styles.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAll: function(width, height)
	{
		this.constructor.apply(this, arguments);
		return this;
	},
	
	/**
	 * Duplicate this <code>Size</code>.
	 * @returns {Core.Size} A new size with identical <i>height</i> and <i>width</i> components.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	clone: function()
	{
		return new this.constructor(this);
	},
	
	/**
	 * Retrieve the value of the <i>width</i> component for this <code>Size</code>.
	 * @returns {Number} The current <i>width</i>.
	 * @see Core.Size#setWidth
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getWidth: function()
	{
		return this._width;
	},
	
	/**
	 * Set the value of the <i>width</i> component for this <code>Size</code>.
	 * @param {Number} width The new <i>width</i>.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Size#getWidth
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setWidth: function(width)
	{
		this._width = width;
		return this;
	},
	
	/**
	 * Retrieve the value of the <i>height</i> component for this <code>Size</code>.
	 * @returns {Number} The current <i>height</i>.
	 * @see Core.Size#setHeight
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getHeight: function()
	{
		return this._height;
	},
	
	/**
	 * Set the value of the <i>height</i> component for this <code>Size</code>.
	 * @param {Number} height The new <i>height</i>.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Size#getHeight
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setHeight: function(height)
	{
		this._height = height;
		return this;
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Rect'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Rect'] || {}; $MODULE_REGISTRY['NGCore/Shared/Rect'] = exports; var Class = require('NGCore/Shared/Class').Class;
var Point = require('NGCore/Shared/Point').Point;
var Size = require('NGCore/Shared/Size').Size;

exports.Rect = Class.subclass(
/** @lends Core.Rect.prototype */
{
	classname: 'Rect',
	
	/**
	 * @class The <code>Rect</code> class constructs a rectangle object that is derived from two values: a point of origin  
	 * and a size.	 
	 * @status iOS, Android, Flash
	 * @constructs The default constructor. <br><br>
	 * The following code examples illustrate a variety of different calling styles for <code>Rect</code> objects.<br><br>
	 * All components set to zero.
	 * <pre class="code">var style1 = new Core.Rect();</pre>
	 *
	 * Copy an existing <code>rect</code>.
	 * <pre class="code">var style2 = new Core.Rect(style1);</pre>
	 *
	 * Specify a point and size.
	 * <pre class="code">var style3 = new Core.Rect(new Core.Point(), new Core.Size());</pre>
	 *
	 * Specify four components.
	 * <pre class="code">var style4 = new Core.Rect(0, 0, 100, 100);</pre>
	 * @augments Core.Class
	 * @param {Core.Point} [origin=0] The rectangle point of origin.
	 * @param {Core.Size} [size=0] The rectangle size.
	 * @throws {Wrong number of arguments for a Rect} Number of parameters passed by this call is invalid.
	 */
	initialize: function(origin, size)
	{
		switch(arguments.length)
		{
			case 0:
				// ()
				this._origin = new Point();
				this._size = new Size();
				break;
			case 1:
				var rhs = arguments[0];
				if(rhs === undefined)
				{
					// (undefined)
					this._origin = new Point();
					this._size = new Size();
				}
				else if(!rhs.hasOwnProperty('length'))
				{
					// (rect)
					this._origin = new Point(rhs.getOrigin());
					this._size = new Size(rhs.getSize());
				}
				else
				{
					switch(rhs.length)
					{
						case 0:
							// ([])
							this._origin = new Point();
							this._size = new Size();
							break;
						case 1:
							// ([rect])
							rhs = rhs[0];
							this._origin = new Point(rhs.getOrigin());
							this._size = new Size(rhs.getSize());
							break;
						case 2:
							// ([point, size])
							// ([[x, y], [width, height]])
							this._origin = new Point(rhs[0]);
							this._size = new Size(rhs[1]);
							break;
						case 4:
							// ([x, y, width, height])
							this._origin = new Point(rhs[0], rhs[1]);
							this._size = new Size(rhs[2], rhs[3]);
							break;
						default:
							throw new Error('Wrong number of arguments for a Rect');
					}
				}
				break;
			case 2:
				// (point, size)
				this._origin = new Point(arguments[0]);
				this._size = new Size(arguments[1]);
				break;
			case 4:
				// (x, y, width, height)
				this._origin = new Point(arguments[0], arguments[1]);
				this._size = new Size(arguments[2], arguments[3]);
				break;
			default:
				throw new Error('Wrong number of arguments for a Rect');
		}
	},
	
	/**
	 * Set the value of all components for this <code>rect</code>. 
	 * @param {Core.Point} [origin=0] The new point of origin.
	 * @param {Core.Size} [size=0] The new rectangle size.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Rect for examples of supported calling styles.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAll: function(origin, size)
	{
		this.constructor.apply(this, arguments);
		return this;
	},
	
	/**
	 * Duplicate the point of origin of this <code>rect</code>.
	 * @returns {Core.Point} A new rectangle with an identical origin and size.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	clone: function()
	{
		return new this.constructor(this);
	},
	
	/**
	 * Retrieve the point of origin for this <code>rect</code>.
	 * @returns {Core.Point} The current point of origin.
	 * @see Core.Rect#setOrigin
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getOrigin: function()
	{
		return this._origin;
	},
	
	/**
	 * Set the point of origin for this <code>rect</code>.
	 * @param {Core.Point} origin The new point of origin.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Rect#getOrigin
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setOrigin: function(origin)
	{
		this._origin.setAll(origin);
		return this;
	},
	
	/**
	 * Change the point of origin so that the center of this <code>rect</code> is at the specified location.
	 * @param {Core.Point} origin The new point of origin that results in a rectangle with a center position at the specified location.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Rect#setSizeCentered,
	 * @see Core.Rect#setOrigin
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setOriginCentered: function(origin)
	{
		origin = new Core.Point(origin);
		this._origin.setX(origin.getX() - this._size.getWidth()/2);
		this._origin.setY(origin.getY() - this._size.getHeight()/2);
		return this;
	},
	
	/**
	 * Retrieve the size of this <code>rect</code>.
	 * @returns {Core.Size} The current rectangle size.
	 * @see Core.Rect#setSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSize: function()
	{
		return this._size;
	},
	
	/**
	 * Set the size of this <code>rect</code>.
	 * @param {Core.Size} size The new rectangle size.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Rect#getSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setSize: function(size)
	{
		this._size.setAll(size);
		return this;
	},
	
	/**
	 * Set the size of this <code>rect</code> and preserve the current center position.
	 * @param {Core.Size} size The new rectangle size that retains the current center position.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Rect#setOriginCentered,
	 * @see Core.Rect#setSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setSizeCentered: function(size)
	{
		var oldWidth = this._size.getWidth();
		var oldHeight = this._size.getHeight();
		
		this._size.setAll(size);

		this._origin.setX(this._origin.getX() + oldWidth/2 - this._size.getWidth()/2);
		this._origin.setY(this._origin.getY() + oldHeight/2 - this._size.getHeight()/2);
		return this;
	},
	
	/**
	 * Retrieve the minimum value for <i>x</i>. This is represented by the left coordinate.
	 * @returns {Number} The current minimum value of  the <i>x</i> coordinate.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMinX: function()
	{
		return this._origin.getX();
	},
	
	/**
	 * Retrieve the average of the minimum and maximum <i>x</i> values. This is the middle coordinate.
	 * @returns {Number} The current average of the minimum and maximum <i>x</i> coordinate values. 
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMidX: function()
	{
		return this._origin.getX() +  this._size.getWidth()/2;
	},
	
	/**
	 * Retrieve the maximum value for <i>x</i>. This is the right coordinate.
	 * @returns {Number} The current maximum value of the <i>x</i> coordinate.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMaxX: function()
	{
		return this._origin.getX() + this._size.getWidth();
	},
	
	/**
	 * Retrieve the minimum value for <i>y</i>. This is the top coordinate.
	 * @returns {Number} The current minimum value of the <i>y</i> coordinate.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMinY: function()
	{
		return this._origin.getY();
	},
	
	/**
	 * Retrieve the average of the minimum and maximum <i>y</i> values. This is the middle coordinate.
	 * @returns {Number} The current average of the minimum and maximum <i>y</i> coordinate values.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMidY: function()
	{
		return this._origin.getY() + this._size.getHeight()/2;
	},
	
	/**
	 * Retrieve the maximum value for <i>y</i>. This is the bottom coordinate.
	 * @returns {Number} The current maximum value of the <i>y</i> coordinate.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMaxY: function()
	{
		return this._origin.getY() + this._size.getHeight();
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/AbstractView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/AbstractView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/AbstractView'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var Rect = require('NGCore/Client/UI/ViewGeometry').Rect;

var AbstractView = exports.AbstractView = Element.subclass(
/** @lends UI.AbstractView.prototype */
{
	'type':'<com.ngmoco.view.abstract>',
	/**
	* @class The <code>AbstractView</code> class is a base class for derived classes that handle and manage application views.<br><br>
	* <b>Caution!:</b> This base class is not exported in the UI module. Do not access it or subclass it at runtime. 
	* Derived classes from <code>AbstractView</code> include:
	* <div class="ul">
	 * <li>{@link UI.Button}</li>
	 * <li>{@link UI.CellView}</li>
	 * <li>{@link UI.CheckBox}</li>
	 * <li>{@link UI.CheckoutView}</li>
	 * <li>{@link UI.DocumentView}</li>
	 * <li>{@link UI.EditText}</li>
	 * <li>{@link UI.GLView}</li>
	 * <li>{@link UI.Image}</li>
	 * <li>{@link UI.Label}</li>
	 * <li>{@link UI.Spinner}</li>
	 * <li>{@link UI.View}</li>
	 * <li>{@link UI.WebView}</li>
	 * </div>
	* @constructs The default constructor.
	* @augments UI.Element
	* @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	* @param {String} properties Object properties.
	*/
	initialize: function($super, properties) {
		if (AbstractView._init) AbstractView._init();
		
		this._assignedVisible = true;
		$super(properties);
	},
	
	/** @private */
	destroy: function($super){
		this.removeFromParent();
		$super();
	},
	
	/**
	 * @function 
	 * @description Retrieve the parent node for this view.
	 * @returns Returns the parent if this view is a child of another element. Otherwise, returns undefined.
	 * @see UI.AbstractView#addToParent,
	 * @see UI.AbstractView#removeFromParent
	 */    
	getParent: function(){
		return this._parent;
	},
    
	/**
	 * Add a node at the specified index to the specified parent node.
	 * @example var myParent = new UI.View({
	 * 	...
	 * });
	 * var childNode = new UI.View({
	 *	...
	 * });
	 * ...
	 * childNode.addToParent(myParent); 
	 * @function
	 * @param {Object} parentNode The parent node.
	 * @param {Number} [index] The parent node index location.
	 * @see UI.AbstractView#getParent,
	 * @see UI.AbstractView#removeFromParent
	 */    
	addToParent: function(parentNode, index){
		parentNode.addChild(this, index);
	},
    
	/**
	 * Remove a node from the parent node.
	 * @example childNode.removeFromParent(myParent);
	 * @function 
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see UI.AbstractView#getParent,
	 * @see UI.AbstractView#addToParent
	 */    
	removeFromParent: function(){
		if (this._parent && !this._parent._destroyed) {
			this._parent.removeChild(this);
			this._parent = null;
		}
		return this;
	},
	
	
	/**
	 * Add a new view state.
	 * @function 
	 * @example this.addState(UI.State.Disabled);
	 * @param {UI.State} flags View state flags supported by the new view state.
	 * @see UI.AbstractView#getState,
	 * @see UI.AbstractView#setState,
	 * @see UI.AbstractView#clearState
	 */  
	addState: function(flags) {
		this.setState(this._state | flags);
	},
	
	/**
	 * Clear the view state and set view state flags to the default value.
	 * @function 
	 * @example this.clearState(UI.State.Disabled);
	 * @param {UI.State} flags
	 * @see UI.AbstractView#getState,
	 * @see UI.AbstractView#setState,
	 * @see UI.AbstractView#addState
	 */  
	clearState: function(flags) {
		this.setState(this._state & ~flags);
	},
    
	/**
	 * Retrieve the root node for this object.
	 * @function 
	 * @returns Returns the root node if this is a child node. Otherwise, returns undefined.
	 */
	getRoot: function() {
		return this._parent ? this._parent.getRoot() : undefined;
	},
    

	/** @protected */
	_setVisible: function(makeVisible) {
		var willBeVisible = makeVisible && this._assignedVisible && this._parent && this._parent._visible;
		if (this._visible != willBeVisible) {
			this._visible = willBeVisible;
			var fn = (makeVisible ? this.getOnAppear() : this.getOnDisappear());
			if (typeof fn == 'function') fn.call(this);
		}
	}
});

// Properties
AbstractView._init = function() {
	delete AbstractView._init;
	if (Element._init) Element._init();
	
	var getVisible = function() {
		return this._visible;
	};
	var setVisible = function(makeVisible) {
		this._assignedVisible = makeVisible;
		Commands.setIsVisible.call(this, makeVisible);
		this._setVisible(makeVisible);
	};
	/**
	 * @name UI.AbstractView#setVisible
	 * @description Set the visibility for this object.
	 * @example SomeView = new UI.View();
	 * ...
	 * SomeView.setVisible(true);
	 * @function 
	 * @param {boolean} makeVisible Set as <code>true</code> if this object is visible.
	 * @see UI.AbstractView#getVisible
	 */
	/**
	 * @name UI.AbstractView#getVisible
	 * @description Retrieve the state of visibility for this object.
	 * @function
	 * @returns {boolean} Returns <code>true</code> if this object is visible.
	 * @see UI.AbstractView#setVisible
	 */
	AbstractView.registerAccessors('visible', getVisible, setVisible);
	
	/**
	 * @name UI.AbstractView#setBackgroundColor
	 * @description Set the value for the <code>backgroundColor</code> property. This property defines the color of the background for an object when rendered.
	 * @example SomeView = new UI.View();
	 * ...
	 * SomeView.setBackgroundColor("FF000000");
	 * @param {String} backgroundColor The new background color.
	 * @see UI.AbstractView#getBackgroundColor
	 * @type Color
	 * @function
	 */
	/**
	 * @name UI.AbstractView#getBackgroundColor
	 * @description Retrieve the value of the <code>backgroundColor</code> property.
	 * @returns {String} The current background color.
	 * @see UI.AbstractView#setBackgroundColor
	 * @function
	 */
	AbstractView.synthesizeProperty('backgroundColor', Commands.setBackgroundColor);
	/**
	 * @name UI.AbstractView#setEnabled
	 * @description Set the value for the <code>enabled</code> property. This property defines an object as active or inactive.
	 * @param {Boolean} enabled Set as <code>true</code> if this view state is enabled.
	 * @see UI.AbstractView#getEnabled
	 * @function
	 */
	/**
	 * @name UI.AbstractView#getEnabled
	 * @description Retrieve the value of the <code>enabled</code> property. 
	 * @returns {Boolean} Returns <code>true</code> if this view state is enabled.
	 * @see UI.AbstractView#setEnabled
	 * @function
	 */
	
	AbstractView.synthesizeProperty('enabled', function(enable) {
		this[ (enable ? 'clearState' : 'setState') ](Commands.State.Disabled);
	});
	/**
	 * @name UI.AbstractView#setState
	 * @description Set the value for the <code>state</code> property. This property defines the view state for an object.
	 * @example cellView.setState(UI.State.Normal);
	 * @param {Number} state The new view state.
	 * @see UI.AbstractView#getState
	 * @type State
	 * @function
	 */
	/**
	 * @name UI.AbstractView#getState
	 * @description Retrieve the value of the <code>state</code> property.
	 * @returns {Number} The current view state.
	 * @see UI.AbstractView#setState
	 * @function
	 */
	AbstractView.synthesizeProperty('state', Commands.setState);

	
	/**
	 * @name UI.AbstractView#getFrame
	 * @description Retrieve the value of the <code>frame</code> property.
	 * @param {Number, Array (Number)} frame Individual components or a component array (<i>x</i>,<i>y</i>,<i>w</i>,<i>h</i>).
	 * @see UI.AbstractView#setFrame
	 * @function
	 */
	var getFrame = function() {
		return this._frame;
	};
	/**
	 * @name UI.AbstractView#setFrame
	 * @function 
	 * @description Set the value of the <code>frame</code> property. This property defines the size of <code>frame</code> objects.
	 * @example var back = new UI.Button();
	 * ...
	 * back.setFrame([10, 10, 64, 64]);
	 * @param {Number, Array (Number), Object} arg0 This parameter will pass in values in one of three ways:
	 * <div class="ul">
	 * <li>Four float values (<i>x</i>, <i>y</i>, <i>w</i>, <i>h</i>).</li>
	 * <li>Single array containing the above four values.</li>
	 * <li>A rect specifying the frame (see <code>{@link UI.ViewGeometry.Rect}</code>).</li>
	 * </div>
	 * @see UI.AbstractView#getFrame
	 * @function
	 */
	var setFrame = function(arg0) {
		if( arg0 instanceof Rect ){
			this._frame = arg0.array();
		}
		else if( arg0 instanceof Array ){
			this._frame = arg0;
		}
		else {
			this._frame = Array.prototype.slice.call(arguments);
		}
		Commands.setFrame.apply(this, this._frame);
	};
	AbstractView.registerAccessors('frame', getFrame, setFrame);

	/**
	 * @name UI.AbstractView#setGradient
	 * @description Set the value of the <code>gradient</code> property for a view state. This property defines an image gradient for the object when rendered.
	 * @example label.setGradient({
	 *	corners: '11 11 11 11',
	 *	gradient: ['FFFF8000 0.0', 'FF703300 1.0']
	 * }, UI.State.Selected);
	 * @param {Object} gradient The new gradient. 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.AbstractView#getGradient
	 * @function
	 */
	/**
	 * @name UI.AbstractView#getGradient
	 * @description Retrieve the value of the <code>gradient</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current gradient.
	 * @see UI.AbstractView#setGradient
	 * @function	
	 */
	AbstractView.synthesizePropertyWithState('gradient', Commands.setGradient);	
	/**
	 * @name UI.AbstractView#setBlockTouchEvents
	 * @description Set the value of the <code>blockTouchEvents</code> property.
	 * @param {Object} blockTouchEvents The new value for <code>blockTouchEvents</code>.
	 * @see UI.View#getBlockTouchEvents
	 * @function
	 */
	/**
	 * @name UI.AbstractView#getBlockTouchEvents
	 * @description Retrieve the value of the <code>blockTouchEvents</code> property.
	 * @returns {Object} The current value of <code>blockTouchEvents</code>.
	 * @see UI.View#setBlockTouchEvents
	 * @function
	 */
	AbstractView.synthesizeProperty('touchable', Commands.setTouchable);
	/**
	 * @name UI.AbstractView#setAlpha
	 * @function
	 * @description Set the value of the <code>alpha</code> property. This property defines the level of alpha composting for a specified object when rendered.
	 * @example this._node.setAlpha(1);
	 * @param {Number} decimal Alpha value ranging between <code>(0.0-1.0)</code>.
	 * @see UI.AbstractView#getAlpha
	 * @type Float
	 * @status iOS
	 */
	/**
	 * @name UI.AbstractView#getAlpha
	 * @function
	 * @description Retrieve the value of the <code>alpha</code> property.
	 * @returns {Number} Alpha value ranging between </code>(0.0-1.0)</code>.
	 * @see UI.AbstractView#setAlpha
	 * @type Float
	 * @status
	 */
	AbstractView.synthesizeProperty('alpha', Commands.setAlpha);




	// Event Handlers
	/**
	 * @name UI.AbstractView#setOnAppear
	 * @description Set a function to call when the <code>appear</code> event occurs.
	 * @param {Function} appearCallback The new callback function. <br><br><b>Note:</b> The <code>appear</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example function() { 
	 *	onAppear.appear = true; 
	 * };
	 * @see UI.AbstractView#event:getOnAppear
	 * @event
	 */
	/**
	 * @name UI.AbstractView#getOnAppear
	 * @description Retrieve the function to call when the <code>appear</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.AbstractView#event:setOnAppear
	 * @event
	 */
	AbstractView.registerEventType('appear');
	/**
	 * @name UI.AbstractView#setOnDisappear
	 * @description Set a function to call when the <code>disappear</code> event occurs.
	 * @param {Function} disappearCallback The new callback function. <br><br><b>Note:</b> The <code>disappear</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example function() { 
	 *	onDisappear.disappear = true; 
	 * };
	 * @see UI.AbstractView#event:getOnDisappear
	 * @event
	 */
	/**
	 * @name UI.AbstractView#getOnDisappear
	 * @description Retrieve a function to call when the <code>disappear</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.AbstractView#event:setOnDisappear
	 * @event
	 */
	AbstractView.registerEventType('disappear');
	/**
	 * @name UI.AbstractView#setOnClick
	 * @description Set a function to call when the <code>click</code> event occurs.
	 * @param {Function} clickCallback The new callback function. <br><br><b>Note:</b> The <code>click</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example function() { 
	 *	onClick.clicked = true; 
	 * };
	 * @see UI.AbstractView#event:getOnClick
	 * @event
	 */
	/**
	 * @name UI.AbstractView#getOnClick
	 * @description Retrieve a function to call when the <code>click</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.AbstractView#event:setOnClick
	 * @event
	 */
	AbstractView.registerEventType('click');
	/**
	 * @name UI.AbstractView#setOnSwipe
	 * @description Set a function to call when a <code>swipe</code> event occurs. 
	 * This is when the user swipes a finger across this view, similar to how a user indicatea a "delete row"
	 * request on a table view.  The function gets the <code>UI.Commands.SwipeDirection</code> from 
	 * the first <code>parameter.direction</code>.  
	 * @example
	 * view.setOnSwipe( function(params) { 
	 *	NgLogD("swipe code "+params.direction) 
	 *   } 
	 * );
	 * @param {Function} clickCallback The new callback function. <br><br><b>Note:</b> The <code>swipe</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @see UI.AbstractView#event:getOnSwipe
	 * @event
	 */
	/**
	 * @name UI.AbstractView#getOnSwipe
	 * @description Retrieve a function to call when the <code>swipe</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.AbstractView#event:setOnSwipe
	 * @event
	 */
	AbstractView.registerEventType('swipe');
	/**
	 * @name UI.AbstractView#setOnLongPress
	 * @description Set a function to call when a user taps and holds on a view. 
	 * @param {Function} clickCallback The new callback function. <br><br><b>Note:</b> The event is disabled 
	 * if the value of this parameter is not a function.
	 * @example function() { 
	 *	onLongPress.longpress = true; 
	 * };
	 * @see UI.AbstractView#event:getOnLongPress
	 * @event
	 */
	/**
	 * @name UI.AbstractView#getOnLongPress
	 * @description Retrieve a function to call when a <code>tap and hold</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.AbstractView#event:setOnLongPress
	 * @event
	 */
	AbstractView.registerEventType('longPress');

	/** @private NOT IMPLEMENTED */
	/*
		AbstractView.registerEventType('touchdown');
		AbstractView.registerEventType('touchup');
		AbstractView.registerEventType('touchmove');
		AbstractView.registerEventType('touchcancel');
	*/
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/WindowLayer'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/WindowLayer'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/WindowLayer'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var ViewParent = require('NGCore/Client/UI/ViewParent').ViewParent;
var Commands = require('NGCore/Client/UI/Commands').Commands;

/** @private
 * 	This ENTIRE CLASS is private.
 */
var WindowLayer = exports.WindowLayer = Element.subclass( {
	'type':'windowlayer',
	initialize: function($super, props) {
		if (WindowLayer.init) WindowLayer.init();
		$super(props);
		if (WindowLayer._init) WindowLayer._init();
		ViewParent.initialize.call(this);
		this._visible = true;
	},
	getRoot: function(){
		return this;
	},
	getParent: function(){
		return undefined;
	},
	
	getChildCount: ViewParent.getChildCount,
	getChildren: ViewParent.getChildren,
	addChild: ViewParent.addChild,
	removeChild: ViewParent.removeChild
});

WindowLayer.init = function() {
	delete WindowLayer._init;
	if (Element._init) Element._init();
	
	WindowLayer.synthesizeProperty('level', Commands.setIntValue);
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ViewParent'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ViewParent'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ViewParent'] = exports; var Commands = require('NGCore/Client/UI/Commands').Commands;
var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;

// CAREFUL! THIS IS NOT A CLASS!
exports.ViewParent = {
	initialize : function() {
		this._children = [];
	},

	getChildCount : function() {
		return this._children.length;
	},

	getChildren : function() {
		return this._children.slice();
	},

	addChild : function(childNode,index) {
		if (childNode === this) throw new Error("Cannot add " + childNode + " as a child of itself!");
		if (childNode instanceof AbstractView) {
			if (childNode._parent) childNode.removeFromParent();

			if (index === 0 || index > 0) {
				index = +index;
				this._children.splice(index, 0, childNode);
			} else {
				index = -1;
				this._children.push(childNode);
			}

			// Must populate parent before setting visibility
			childNode._parent = this;
			childNode._setVisible(this._visible);

			Commands.addSubview.call(this, childNode.__objectRegistryId, index);

		} else throw new Error(this.type + ".addChild: " + childNode + " is not a view!");
		return this;
	},

	removeChild : function(childNode) {
		if (childNode instanceof AbstractView) {
			if (childNode._parent == this) {
				childNode._setVisible(false);

				// Remove this node from parent's child list
				var nodeIndex = this._children.indexOf(childNode);
				if (nodeIndex != -1) {
					this._children.splice(nodeIndex, 1);
				}
			}
			// Clear parent value
			childNode._parent = undefined;

			// Remove from the parent at the system level
			Commands.removeFromSuperview.call(childNode);
		} else throw {message: this.type + ".removeChild: " + childNode + " is not a view!"};
		return childNode;
	}

};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio'] = exports; /**
 * <p>Classes and objects contained by the Audio module.</p>
 * @name Audio
 * @namespace 
 * @description <p>The Audio module is a collection of classes that support manipulation of audio effects in an application. 
 * Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 *<ul>
 *<li><code>{@link Audio.ActiveEffect}</code>: Construct objects for controlling the reproduction of <code>Effect</code> objects.</li>
 *<li><code>{@link Audio.Device}</code>: A singleton object that controls device sound effects volume.</li>
 *<li><code>{@link Audio.Effect}</code>: Construct objects that load sound resources into memory.</li>
 *<li><code>{@link Audio.Music}</code>: A singleton object that controls the reproduction of application background music.</li>
 *</ul>
 */
exports.Audio = {};

exports.Audio.__defineGetter__("ActiveEffect", function() {
	delete this.ActiveEffect;
	return this.ActiveEffect = require('NGCore/Client/Audio/ActiveEffect').ActiveEffect;
});
exports.Audio.__defineGetter__("Effect", function() {
	delete this.Effect;
	return this.Effect = require('NGCore/Client/Audio/Effect').Effect;
});
exports.Audio.__defineGetter__("Device", function() {
	delete this.Device;
	return this.Device = require('NGCore/Client/Audio/Device').Device;
});
exports.Audio.__defineGetter__("Music", function() {
	delete this.Music;
	return this.Music = require('NGCore/Client/Audio/Music').Music;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Bank'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Bank'] || {}; $MODULE_REGISTRY['NGCore/Client/Bank'] = exports; 

exports.Bank = require('NGCore/Client/Social/US/Service/Bank').Bank;; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2'] = exports; /**
 * <p>Classes and objects contained by the GL2 module.</p>
 * @name GL2
 * @namespace
 * @description <p>The GL2 module is a collection of classes that support manipulation of visual effects and frameworks in an application.
 * Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 * <ul>
 * <li><code>{@link GL2.Animation}</code>: Control animations in applications.</li>
 * <li><code>{@link GL2.Node}</code>: Control positionable screen elements.</li>
 * <li><code>{@link GL2.Primitive}</code>: Control the drawing of arbitrary vertex-based geometry.</li>
 * <li><code>{@link GL2.Root}</code>: A singleton that acts as a proxy object for the GLView node hierarchy 
 * (<code>Root</code> is the root element of the node hierarchy for GL2View).</li>
 * <li><code>{@link GL2.Sprite}</code>: Control resources for and use of application sprites.</li>
 * <li><code>{@link GL2.Text}</code>: Control resources for and use of application text.</li>
 * <li><code>{@link GL2.Touch}</code>: Control objects that track touch events for a device.</li>
 * <li><code>{@link GL2.TouchTarget}</code>: Control objects that support physical touch events on a device.</li>
 * <li><code>{@link GL2.RenderTarget}</code>: Render GL2 Nodes into a texture, which can then be attached to a GL.Animation</li>
 * </ul>
 * Games must instantiate a {@link UI.GLView} object, set the active state to <code>true</code> and wait for the callback before instantiating any objects in the GL2 class.
 */
exports.GL2 = {};

exports.GL2.__defineGetter__("Animation", function() {
	delete this.Animation;
	return this.Animation = require('NGCore/Client/GL2/Animation').Animation;
});
exports.GL2.__defineGetter__("Node", function() {
	delete this.Node;
	return this.Node = require('NGCore/Client/GL2/Node').Node;
});
exports.GL2.__defineGetter__("Primitive", function() {
	delete this.Primitive;
	return this.Primitive = require('NGCore/Client/GL2/Primitive').Primitive;
});
exports.GL2.__defineGetter__("Touch", function() {
	delete this.Touch;
	return this.Touch = require('NGCore/Client/GL2/Touch').Touch;
});
exports.GL2.__defineGetter__("TouchTarget", function() {
	delete this.TouchTarget;
	return this.TouchTarget = require('NGCore/Client/GL2/TouchTarget').TouchTarget;
});
exports.GL2.__defineGetter__("Root", function() {
	delete this.Root;
	return this.Root = require('NGCore/Client/GL2/Root').Root;
});
exports.GL2.__defineGetter__("Sprite", function() {
	delete this.Sprite;
	return this.Sprite = require('NGCore/Client/GL2/Sprite').Sprite;
});
exports.GL2.__defineGetter__("Text", function() {
	delete this.Text;
	return this.Text = require('NGCore/Client/GL2/Text').Text;
});
exports.GL2.__defineGetter__("RenderTarget", function() {
	delete this.RenderTarget;
	return this.RenderTarget = require('NGCore/Client/GL2/RenderTarget').RenderTarget;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Utils/FPS'] = function(){var exports = $MODULE_REGISTRY['Code/Utils/FPS'] || {}; $MODULE_REGISTRY['Code/Utils/FPS'] = exports; var FPS = exports.FPS = Core.MessageListener.singleton({
    initialize : function()
    {
        this._fcount = 0;
        this._fduration = 0;
        this._fdurationMax = 0;
        this._fdurationMin = Number.MAX_VALUE;
        
        this._finterval = 30 * 5;
        
        // Subscribe to per frame updates.
        Core.UpdateEmitter.addListener(this, this.onUpdate);
        
        // After a timeout, place a button. The timeout is to allow interface orienation to stabalize.
        this.button = new UI.Button({
            normalGradient : {
                'gradient' : [ 'FFF0 0.0', 'FFA0 1.0' ],
                'corners' : '5',
                'outerLine' : 'FF00 5.0'
            },
            highlightedGradient : {
                'gradient' : [ 'FF80 0.0', 'FFC0 1.0' ],
                'corners' : '5',
                'outerLine' : 'FF00 5.0'
            }
        });
        setTimeout(function()
        {
            var w = 120;
            var h = 80;
            this.button.setFrame([ UI.Window._width / 2 - w / 2, UI.Window._height - h, w, h ]);
            UI.Window.document.addChild(this.button);
            this.updateButton();
        }.bind(this), 1000);
    },
    
    updateButton : function()
    {
        if (this.leakCheck)
        {
            this.button.onclick = this.stop.bind(this);
            this.button.setTextColor('FFFF0000');
            this.button.setText('stop leakcheck');
        }
        else
        {
            this.button.onclick = this.start.bind(this);
            this.button.setTextColor('FFFF');
            this.button.setText('start leakcheck');
        }
    },
    
    start : function()
    {
        console.log('/// Starting leakcheck');
        this.leakCheck = true;
        this.startTime = new Date().getTime();
        this.updateButton();
        this.stacks = [];
    },
    
    stop : function()
    {
        this.leakCheck = false;
        this.updateButton();
        
        function formatTime(t)
        {
            return '' + Math.round((t - FPS.startTime) / 100) / 10 + 's';
        }
        
        // output and reset.
        console.log('/// Leaked', this.stacks.length, 'objects in', formatTime(new Date().getTime()));
        for ( var i = 0; i < this.stacks.length; ++i)
        {
            try
            {
                var s = this.stacks[i];
                console.log('/// Leaked', s.type, 'at', formatTime(s.time));
                if (!s.exception || !s.exception.stack)
                    console.log('///   - Stacktrace unavailable');
                
                var stack = s.exception.stack.split('\n    ').slice(2);
                for ( var j = 0; j < stack.length; ++j)
                    console.log('///   -', stack[j]);
            }
            catch (e)
            {
                console.log('///   - Out of memory, stack trace lost');
            }
        }
    },
    
    trackObj : function(obj, type, exception)
    {
        // Check if this has already been registered.
        var s = this.stacks;
        for ( var i = 0; i < s.length; ++i)
        {
            if (s.obj === obj)
                return;
        }
        
        this.stacks.push({
            obj : obj,
            type : type,
            exception : exception,
            time : new Date().getTime()
        });
    },
    
    untrackObj : function(obj)
    {
        var s = this.stacks;
        for ( var i = 0; i < s.length; ++i)
        {
            if (s[i].obj !== obj)
                continue;
            s.splice(i, 1);
            return;
        }
    },
    
    onUpdate : function(frameDelta)
    {
        // add frame data
        this._fduration += frameDelta;
        this._fcount++;
        this._fdurationMax = Math.max(this._fdurationMax, frameDelta);
        this._fdurationMin = Math.min(this._fdurationMin, frameDelta);
        
        // If over our threshold, report and reset.
        if (this._fcount > this._finterval)
        {
            // Calculate average of frame samples.
            var average = this._fduration / this._fcount;
            
            // Output average.
            console.log('///FPS avg: %d, max: %d, min: %d; Instances nodes: %d, sprite: %d, anims: %d, texts: %d', Math.round(1000 / average), Math.round(1000 / this._fdurationMin), Math.round(1000 / this._fdurationMax), GL2.Node.getLiveInstances(), GL2.Sprite.getLiveInstances(), GL2.Animation
                    .getLiveInstances(), GL2.Text.getLiveInstances());
            
            // Reset sample data
            this._fcount = 0;
            this._fduration = 0;
            this._fdurationMax = 0;
            this._fdurationMin = Number.MAX_VALUE;
        }
    }
});

//Node
var nodesLiveInstances = 0;
GL2.Node.getLiveInstances = function()
{
    return nodesLiveInstances;
};

var __GL2Nodeinitialize = GL2.Node.prototype.initialize;
GL2.Node.prototype.initialize = function()
{
    if (FPS.leakCheck)
    {
        try
        {
            throw new Error();
        }
        catch (e)
        {
            FPS.trackObj(this, 'Node', e);
        }
    }
    nodesLiveInstances++;
    __GL2Nodeinitialize.apply(this, arguments);
};

var __GL2Nodedestroy = GL2.Node.prototype.destroy;
GL2.Node.prototype.destroy = function()
{
    if (FPS.leakCheck)
    {
        FPS.untrackObj(this);
    }
    nodesLiveInstances--;
    __GL2Nodedestroy.apply(this, arguments);
};

//Sprites
spritesLiveInstances = 0;
GL2.Sprite.getLiveInstances = function()
{
    return spritesLiveInstances;
};

var __GL2Spriteinitialize = GL2.Sprite.prototype.initialize;
GL2.Sprite.prototype.initialize = function()
{
    if (FPS.leakCheck)
    {
        try
        {
            throw new Error();
        }
        catch (e)
        {
            FPS.trackObj(this, 'Sprite', e);
        }
    }
    spritesLiveInstances++;
    __GL2Spriteinitialize.apply(this, arguments);
};

var __GL2Spritedestroy = GL2.Sprite.prototype.destroy;
GL2.Sprite.prototype.destroy = function()
{
    if (FPS.leakCheck)
    {
        FPS.untrackObj(this);
    }
    spritesLiveInstances--;
    __GL2Spritedestroy.apply(this, arguments);
};

//Texts
textsLiveInstances = 0;
GL2.Text.getLiveInstances = function()
{
    return textsLiveInstances;
};

var __GL2Textinitialize = GL2.Text.prototype.initialize;
GL2.Text.prototype.initialize = function()
{
    if (FPS.leakCheck)
    {
        try
        {
            throw new Error();
        }
        catch (e)
        {
            FPS.trackObj(this, 'Text', e);
        }
    }
    textsLiveInstances++;
    __GL2Textinitialize.apply(this, arguments);
};

var __GL2Textdestroy = GL2.Text.prototype.destroy;
GL2.Text.prototype.destroy = function()
{
    if (FPS.leakCheck)
    {
        FPS.untrackObj(this);
    }
    textsLiveInstances--;
    __GL2Textdestroy.apply(this, arguments);
};

//Animations
animsliveInstances = 0;
GL2.Animation.getLiveInstances = function()
{
    return animsliveInstances;
};

var __GL2Animationinitialize = GL2.Animation.prototype.initialize;
GL2.Animation.prototype.initialize = function()
{
    if (FPS.leakCheck)
    {
        try
        {
            throw new Error();
        }
        catch (e)
        {
            FPS.trackObj(this, 'Animation', e);
        }
    }
    animsliveInstances++;
    __GL2Animationinitialize.apply(this, arguments);
};

var __GL2Animationdestroy = GL2.Animation.prototype.destroy;
GL2.Animation.prototype.destroy = function()
{
    if (FPS.leakCheck)
    {
        FPS.untrackObj(this);
    }
    animsliveInstances--;
    __GL2Animationdestroy.apply(this, arguments);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Utils/BaseClass'] = function(){var exports = $MODULE_REGISTRY['Code/Utils/BaseClass'] || {}; $MODULE_REGISTRY['Code/Utils/BaseClass'] = exports; /**
 * Base Class
 */
exports.BaseClass = Core.Class.subclass({
    classname : 'BaseClass',
    
    initialize : function(width, height)
    {
        this._node = new GL2.Node();
        this._node._AL_owner = this;
        this.__updateListener = new Core.MessageListener();
        Core.UpdateEmitter.addListener(this.__updateListener, this.__onUpdate.bind(this));
        
        if (!width || !height)
        {
            return;
        }
        this._size = [ width, height ];
        this.__size = new Core.Size(TTScene._workingArea.screenWidth, TTScene._workingArea.screenHeight);
        
        //touch target
        this.__touchTarget = new GL2.TouchTarget();
        this.__touchTarget.setAnchor(0.5, 0.5);
        this.__touchTarget.setPosition(this._size[0] / 2, this._size[1] / 2);
        this.__touchTarget.setSize(this._size);
        this.__touchListener = new Core.MessageListener();
        this.__touchTarget.getTouchEmitter().addListener(this.__touchListener, this.__onTouch.bind(this));
        this._node.addChild(this.__touchTarget);
    },
    
    setTouchTargetToScreenSize : function()
    {
        this.__touchTarget.setSize(this.__size);
    },
    
    _replaceRootNode : function(/*GL2.Node*/newNode)
    {
        this._node.destroy();
        this._node = null;
        this._node = newNode;
        this._node.addChild(this.__touchTarget);
    },
    
    getNode : function()
    {
        return this._node;
    },
    
    getSize : function()
    {
        return this.__size;
    },
    
    /**
     * Override to give a different BoundingBox. This implementation uses the
     * this._node if its a Sprite, else use this._node.position and this.__size
     * give in the constructor.
     * 
     * @return the bounding box of this class.
     */
    getBB : function()
    {
        if (this._node.classname == 'Sprite')
        {
            return createBB(this._node);
        }
        else
        {
            return createBBBase(this._node.getPosition(), this.__size);
        }
    },
    
    __onUpdate : function(delta)
    {
        if (this._destroying || this.__destroying)
        {
            return;
        }
        
        if (!this._drawError && this._node.getParent() != null && this._node.getVisible() && this._node.getAlpha() > 0)
        {
            try
            {
                this._draw(delta);
            }
            catch (ex)
            {
                this._drawError = true;
                NgLogException(ex);
            }
        }
    },
    
    /**
     * override this function to do work on every frame
     * 
     * @param delta -
     *            time between frames.
     */
    _draw : function(delta)
    {
    },
    
    __onTouch : function(/*GL2.Touch*/touchEvent)
    {
        switch (touchEvent.getAction())
        {
            case GL2.Touch.Action.Start:
                return this._ccTouchesBegan(touchEvent);
            case GL2.Touch.Action.Move:
                this._ccTouchesMoved(touchEvent);
                break;
            case GL2.Touch.Action.End:
                this._ccTouchesEnded(touchEvent);
                break;
        }
    },
    
    /**
     * Override to react on touch began.
     * @return true if the event is going to be captured by this node, false to
     *         leave others receive this event.
     */
    _ccTouchesBegan : function(/*GL2.Touch*/touchEvent)
    {
        return false;
    },
    
    /**
     * Override to react on touch moved.
     */
    _ccTouchesMoved : function(/*GL2.Touch*/touchEvent)
    {
    },
    
    /**
     * Override to react on touch ended.
     */
    _ccTouchesEnded : function(/*GL2.Touch*/touchEvent)
    {
    },
    
    /**
     * Destroy this instance by removing the listeners and calling destroy on the rootNode.
     */
    destroy : function()
    {
        al_trace(this.classname + ": (Destroy) Destroying");
        
        if (this.__updateListener)
        {
            this.__updateListener.destroy();
            this.__updateListener = null;
        }
        
        if (this.__touchListener)
        {
            this.__touchListener.destroy();
            this.__touchListener = null;
        }
        
        if (this.__touchTarget)
        {
            this.__touchTarget.destroy();
            this.__touchTarget = null;
        }
        
        if (this._node)
    	{
        	this._node._AL_owner = null;
        	this.__destroyNodeAndChildren(this._node);
        	this._node = null;
    	}
        
    },
    
    $__destroyNodeAndChildren : function(/*GL2.Node*/node)
    {
        if (!node)
        {
            return;
        }
        
        while (node._children.length > 0)
        {
            var childNode = node._children[node._children.length - 1];
            if (childNode)
            {
                if (childNode._AL_owner)
                {
                    childNode._AL_owner.destroy();
                }
                else
                {
                    this.__destroyNodeAndChildren(childNode);
                }
            }
        }
        
        node.stopAllActions();
        if (this != node)
        {
            node.destroy();
        }
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Utils/TouchTargetVisualizer'] = function(){var exports = $MODULE_REGISTRY['Code/Utils/TouchTargetVisualizer'] || {}; $MODULE_REGISTRY['Code/Utils/TouchTargetVisualizer'] = exports; var TouchTargetVisualizer = exports.TouchTargetVisualizer = Core.Class.singleton({
	initialize: function() {
		(function() {
			var oldInitialize = GL2.TouchTarget.prototype.initialize;
			GL2.TouchTarget.prototype.initialize = function() {
				oldInitialize.apply(this, arguments);
				this._anchor = new Core.Point(0, 0);
			};
		})();
		
		GL2.TouchTarget.prototype._showVisualization = function() {
			if(this._visualization) return;
			this._visualization = new GL2.Primitive();
			this._visualization.setType(GL2.Primitive.Type.TriangleStrip);
			this._visualization.pushVertex(new GL2.Primitive.Vertex([0, 0]));
			this._visualization.pushVertex(new GL2.Primitive.Vertex([1, 0]));
			this._visualization.pushVertex(new GL2.Primitive.Vertex([0, 1]));
			this._visualization.pushVertex(new GL2.Primitive.Vertex([1, 1]));
			this._visualization.setAlpha(0.5);
			this._visualization.setDepth(Infinity);
			this._visualization.setColor(Math.random(), Math.random(), Math.random());
			this.addChild(this._visualization);
			this._correctVisualization();
		};
		
		GL2.TouchTarget.prototype._hideVisualization = function() {
			if(!this._visualization) return;
			this._visualization.destroy();
			delete this._visualization;
		};
		
		GL2.TouchTarget.prototype._correctVisualization = function() {
			var s = this.getSize();
			var a = this.getAnchor();
			
			this._visualization.setScale(s._width, s._height);
			this._visualization.setPosition(-a._x * s._width, -a._y * s._height);
		};
		
		this.show();
	},
	
	show: function() {
		if(this.showing) return;
		this.showing = true;
		
		TouchTargetVisualizer.oldInitialize = GL2.TouchTarget.prototype.initialize;
		GL2.TouchTarget.prototype.initialize = function() {
			TouchTargetVisualizer.oldInitialize.apply(this, arguments);
			this._showVisualization();
		};
		
		TouchTargetVisualizer.oldDestroy = GL2.TouchTarget.prototype.destroy;
		GL2.TouchTarget.prototype.destroy = function() {
			TouchTargetVisualizer.oldDestroy.apply(this, arguments);
			this._hideVisualization();
		};
		
		TouchTargetVisualizer.oldSetAnchor = GL2.TouchTarget.prototype.setAnchor;
		GL2.TouchTarget.prototype.setAnchor = function() {
			TouchTargetVisualizer.oldSetAnchor.apply(this, arguments);
			this._correctVisualization();
		};
		
		TouchTargetVisualizer.oldSetSize = GL2.TouchTarget.prototype.setSize;
		GL2.TouchTarget.prototype.setSize = function() {
			TouchTargetVisualizer.oldSetSize.apply(this, arguments);
			this._correctVisualization();
		};
		
		var objs = Core.ObjectRegistry._objects;
		for(var i in objs) {
			if(!objs.hasOwnProperty(i)) continue;
			if(!(objs[i] instanceof GL2.TouchTarget)) continue;
			objs[i]._showVisualization();
		}
	},
	
	hide: function() {
		if(!this.showing) return;
		this.showing = false;
		
		GL2.TouchTarget.prototype.initialize = TouchTargetVisualizer.oldInitialize;
		GL2.TouchTarget.prototype.destroy = TouchTargetVisualizer.oldDestroy;
		GL2.TouchTarget.prototype.setAnchor = TouchTargetVisualizer.oldSetAnchor;
		GL2.TouchTarget.prototype.setSize = TouchTargetVisualizer.oldSetSize;
		
		var objs = Core.ObjectRegistry._objects;
		for(var i in objs) {
			if(!objs.hasOwnProperty(i)) continue;
			if(!(objs[i] instanceof GL2.TouchTarget)) continue;
			objs[i]._hideVisualization();
		}
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Utils/RateGameController'] = function(){var exports = $MODULE_REGISTRY['Code/Utils/RateGameController'] || {}; $MODULE_REGISTRY['Code/Utils/RateGameController'] = exports; exports.RateGameController = Core.Class.subclass({
    classname: "RateGameController",
    
    $checkOneTimeRateGame: function () {
        var playerData = TTScene.sharedScene()._playerData;
        var floors = dict_size(playerData._floors);
        
        al_trace("RateGameController.checkOneTimeRateGame: userLevel: " + dict_size(playerData._floors));
        if (!playerData._userWasAskedToRateGame && floors >= RATE_GAME_FLOORS)
        {
            RateGameController.showRateMeDialog();
        }
    },
    
    $showRateMeDialog: function () {
        al_trace("RateGameController.showRateMeDialog");
        
        var playerData = TTScene.sharedScene()._playerData;
        
        al_trace("RateGameController.showRateMeDialog: gameRatedByUser " + playerData._gameRatedByUser);
        al_trace("RateGameController.showRateMeDialog: userWasAskedToRateGame " + playerData._userWasAskedToRateGame);
        
        //don`t ask to rate if the user has already done it or if we have asked more than once
        if (!playerData._gameRatedByUser && playerData._userWasAskedToRateGame < 1)
        {
            var dialog = TTDialog.initWithMessage(Localization.getString(
                "\nPlease give us 5 Stars and tell us what you think."),
                "No thanks, Agreed",
                function(dlg)
                {
                    if (dlg._buttonIndex > 0)
                    {                       
                        RateGameController.redirectUserToRateGame();
                    }
                }, this, null);
            dialog._tag = "rategame";
            
            TTDialogQueue.sharedQueue().addDialog(dialog);
            playerData._userWasAskedToRateGame++;
        }
    },
    
    $redirectUserToRateGame: function () {
        al_trace("RateGameController.redirectUserToRateGame");
        
        var playerData = TTScene.sharedScene()._playerData;
        var marketUrl = "market://details?id=" + Core.Capabilities.getBundleIdentifier();
        Device.IPCEmitter.launch(marketUrl, function(error)
        {
            al_trace("rateGamePrompt: Error launching URL: " + marketUrl + ", error: " + error);
            playerData._gameRatedByUser = false;
            playerData._userWasAskedToRateGame--;
        }.bind(this));
        
        playerData._gameRatedByUser = true;
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Action'] = function(){var exports = $MODULE_REGISTRY['Code/Action'] || {}; $MODULE_REGISTRY['Code/Action'] = exports; exports.Action = {
    ActionManager : require('Code/Action/ActionManager').ActionManager,
    RepeatForever : require('Code/Action/Action').RepeatForever,
    EaseSineInOut : require('Code/Action/EaseAction').EaseSineInOut,
    Sequence : require('Code/Action/IntervalAction').Sequence,
    MoveTo : require('Code/Action/IntervalAction').MoveTo,
    MoveBy : require('Code/Action/IntervalAction').MoveBy,
    ScaleTo : require('Code/Action/IntervalAction').ScaleTo,
    ScaleBy : require('Code/Action/IntervalAction').ScaleBy,
    RotateTo : require('Code/Action/IntervalAction').RotateTo,
    FadeIn : require('Code/Action/IntervalAction').FadeIn,
    FadeOut : require('Code/Action/IntervalAction').FadeOut,
    DelayTime : require('Code/Action/IntervalAction').DelayTime,
    Show : require('Code/Action/InstantAction').Show,
    Hide : require('Code/Action/InstantAction').Hide,
    CallFunc : require('Code/Action/InstantAction').CallFunc
};

/** Node+Action function prototypes */
GL2.Node.prototype.runAction = function(/* Action.Action */action)
{
    Action.ActionManager.addAction(action, this);
};

GL2.Node.prototype.stopAllActions = function()
{
    Action.ActionManager.removeAllActionsFromTarget(this);
};

GL2.Node.prototype.numberOfRunningActions = function()
{
    return Action.ActionManager.numberOfRunningActions(this);
};; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Base/Prototypes'] = function(){var exports = $MODULE_REGISTRY['Code/Base/Prototypes'] || {}; $MODULE_REGISTRY['Code/Base/Prototypes'] = exports; // Trick to force the inclusion of this class
exports.Prototypes = Core.Class.subclass({}); 

var __GL2NodeDestroy = GL2.Node.prototype.destroy;
GL2.Node.prototype.destroy = function()
{    
    if (!this._destroying)
    {
        this._destroying = true;       
        BaseClass.__destroyNodeAndChildren(this);
    }
    else
    {
        __GL2NodeDestroy.apply(this, arguments);
    }
};

var __GL2SpriteDestroy = GL2.Sprite.prototype.destroy;
GL2.Sprite.prototype.destroy = function()
{    
    if (!this._destroying)
    {
        this._destroying = true;        
        BaseClass.__destroyNodeAndChildren(this);
    }
    else
    {
        __GL2SpriteDestroy.apply(this, arguments);
    }
}; 

var __GL2TextDestroy = GL2.Text.prototype.destroy;
GL2.Text.prototype.destroy = function()
{    
    if (!this._destroying)
    {
        this._destroying = true;
        BaseClass.__destroyNodeAndChildren(this);
    }
    else
    {
        __GL2TextDestroy.apply(this, arguments);
    }
};

//formatter
var __nativeNumberToString = Number.prototype.toString;
Number.prototype.toFormattedString = function()
{
    var str = __nativeNumberToString.call(this);
    var arr = [];
    for ( var i = str.length; i > 0; i -= 3)
    {
        arr.push(str.substring(i - 3, i));
    }
    arr.reverse();
    return arr.join(',');
};

/**
* Gets the size of a sprite
* @param s {GL2.Sprite} - Sprite
*/
GL2.Sprite.prototype.AL_getSize = function()
{
    return this._animation._frames[0].getSize();
};

GL2.Sprite.prototype.AL_getScaledSize = function()
{
    var size = this._animation._frames[0].getSize();
    console.log("this: " + this);
    x = new Core.Size(size.getWidth()*this.getScale().getX(), size.getHeight()*this.getScale().getY());
    console.log("xthis: " + this);
    return x;
};

/**
* Gets the anchor point for a sprite
*/
GL2.Sprite.prototype.AL_getAnchor = function()
{
    return this._animation._frames[0].getAnchor();
};

GL2.Node.prototype.AL_removeFromParentAndCleanup = function(cleanup)
{
    if (this._parent && this._parent instanceof GL2.Node)
    {
        var index = this._parent._children.indexOf(this); 
        if (index != -1)
        {
            this._parent.removeChild(this);
        }
    }
    
    if (cleanup)
    {
        this.destroy();
    }
};

GL2.Node.prototype.AL_removeAllChildrenWithCleanup = function(cleanup)
{   
    if (this._children && this._children.length > 0)
    {
        for (var i = this._children.length - 1; i >= 0; i--)
        {
            cleanup && this.stopAllActions(); 
            
            var child = this._children[i];
            if (child && !child.__destroying)
            {
                child.__destroying = true;
                this.removeChild(child);
            }
        }
    }
};

GL2.Node.prototype.AL_destroyAllChildrenWithCleanup = function(cleanup, destroyOwners, delay)
{   
    if (this._children && this._children.length > 0)
    {
        for (var i = this._children.length - 1; i >= 0; i--)
        {            
            al_trace(this.classname + ": (Destroy) Attempting to destroy");            
            var child = this._children[i];
            if (child && !child.__destroying)
            {                
                child.__destroying = true;
                cleanup && child.stopAllActions();
                if (destroyOwners && child._AL_owner)
                {
                    if (delay)
                    {
                        setTimeout(child._AL_owner.destroy.bind(child._AL_owner), 100);
                    }
                    else
                    {
                        child._AL_owner.destroy();
                    }
                }
                else
                {
                    if (delay)
                    {
                        setTimeout(child.destroy.bind(child), 100);
                    }
                    else
                    {
                        child.destroy();
                    }
                }   
            }
        }
    }
};

GL2.Node.prototype.AL_setOpacity = function(opacity)
{
    this.setAlpha(opacity/255);
};

GL2.Node.prototype.AL_getOpacity = function()
{
    return Math.floor(this.getAlpha() * 255);
};

GL2.Node.prototype.AL_setScale = function(scale)
{
    this.setScale(scale, scale);
};

GL2.Node.prototype.AL_setScaleX = function(scale)
{
    this.setScale(scale, this._scale._y);
};

GL2.Node.prototype.AL_setScaleY = function(scale)
{
    this.setScale(this._scale._x, scale);
};

GL2.Node.prototype.AL_getScale = function()
{
    this.getScale().getX();
};

GL2.Node.prototype.AL_setTag = function(tag)
{
    this._AL_tag = tag;
};

GL2.Node.prototype.AL_getTag = function()
{
    return this._AL_tag;
};

GL2.Node.prototype.AL_getChildByTag = function(tag) 
{
    for (var key in this._children)
    {
        var item = this._children[key];
        if (item._AL_tag !== undefined && item._AL_tag == tag)
        {
            return item;
        }
    }
};; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Utils/NSUserDefaults'] = function(){var exports = $MODULE_REGISTRY['Code/Utils/NSUserDefaults'] || {}; $MODULE_REGISTRY['Code/Utils/NSUserDefaults'] = exports; var SyncKeyValue = require('Code/Utils/SyncKeyValue').SyncKeyValue;

exports.NSUserDefaults = SyncKeyValue.singleton({
    classname: 'NSUserDefaults',
    
    initialize : function($super)
    {
        $super("standardUserDefaults",
        [
             "originalUser",
             "originalAlias",
             "badgeNum",
             "bitSortMode",
             "bitBookBadge",
             "bitBookEntries",
             "bitBookBadge",
             "setting-sfxOff",
             "setting-notesOff",
             "resignTime",
             "lastBdayCheck",
             "lastRentCheck",
             "cachedAwards",
             "lifeTimeCoins",
             "awardsYpos"
        ]);
    },
    
    standardUserDefaults : function()
    {
        return this;
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Utils/DataPreloader'] = function(){var exports = $MODULE_REGISTRY['Code/Utils/DataPreloader'] || {}; $MODULE_REGISTRY['Code/Utils/DataPreloader'] = exports; exports.DataPreloader = Core.Class.singleton({
    classname : 'DataPreloader',
    
    preloadData : function(callback)
    {
        var loadedFiles = 0;
        var totalFiles = 7;
        var onFileLoaded = function(i, name, data)
        {
            al_assert(data !== null, "DataPreloader.preloadData: Could not load '" + name + "' file");
            
            switch (Number(i))
            {
                case 0:
                    this._achievements = eval('(' + data + ')');
                    break;
                case 1:
                    this._bb_events = eval('(' + data + ')');
                    break;
                case 2:
                    this._finder = eval('(' + data + ')');
                    break;
                case 3:
                    this._tips = eval('(' + data + ')');
                    break;
                case 4:
                    this._imageSizes = eval('(' + data + ')');
                    break;
                case 5:
                	this._floors = data;
                	break;
                case 6:
                    this._achievementsDescriptions = eval('(' + data + ')');
                    break;
            }
            
            loadedFiles++;
            if (loadedFiles == totalFiles)
            {
                al_trace("DataPreloader.preloadData: Preloading finished...");
                callback();
            }
            else 
            {
                al_trace("DataPreloader.preloadData: " + (totalFiles - loadedFiles) + " files remaining ...");
            }
        }.bind(this);
        
        // Pre-loads files
        var folder = "./Content/";
        
        this.preload(folder + "achievements.plist.json", onFileLoaded.bind(this, 0, "achievements"));
        this.preload(folder + "bb_events.plist.json", onFileLoaded.bind(this, 1, "bb_events"));
        this.preload(folder + "finder.plist.json", onFileLoaded.bind(this, 2, "finder"));
        this.preload(folder + "tips.plist.json", onFileLoaded.bind(this, 3, "tips"));
        this.preload(folder + "imagessize.json", onFileLoaded.bind(this, 4, "imagessize"));
        this.preload(folder + "floors.csv", onFileLoaded.bind(this, 5, "floors"));
        this.preload(folder + "achievementsDescriptions.plist.json", onFileLoaded.bind(this, 6, "achievementsDescriptions"));
    },
    
    preload : function(path, callback)
    {
        Storage.FileSystem.readFile(path, false, function(error, content)
        {
            if (error || !content)
            {
                callback(null);
            }
            else
            {
                callback(content);
            }
        }.bind(this));
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Utils/SpriteFactoryCache'] = function(){var exports = $MODULE_REGISTRY['Code/Utils/SpriteFactoryCache'] || {}; $MODULE_REGISTRY['Code/Utils/SpriteFactoryCache'] = exports; exports.SpriteFactoryCache = Core.Class.singleton({
    classname : 'SpriteFactoryCache',

    initialize : function() {
        this._animationCache = {};
    },
    
    /**
     * @param framePath - the path to the texture to use. Example: ./Content/textures/my_texture.png 
     * @param size - the size of the texture. Example: new Core.Size(128,256) or [128,256]
     * @param anchor - the anchor to use. Example: new Core.Point(0.5,1) or [0.5,1]
     * @param uvs - the uvs mapping to use. Example: new Core.Rect(0,0,1,1) or [0,0,1,1]
     * @param filter - boolean flag to filter the texture, by default false.
     * @returns a GL2.Animation instance, could be a new one or a cached one if already exist.
     */
    getAnimation: function(/*String*/ framePath, /*Core.Size*/ size, /*Core.Point*/ anchor, /*Core.Rect*/ uvs, /*Boolean*/ filter) {
        size = (size instanceof Core.Size) ? size : new Core.Size(size);
        anchor = (anchor instanceof Core.Point) ? anchor : new Core.Point(anchor || [0,0]);
        uvs = (uvs instanceof Core.Rect) ? uvs : new Core.Rect(uvs || [0,0,1,1]);
        
        var animation = this.__animationInCache(framePath, 0, size, anchor, uvs);
        if (!animation) {
            animation = new GL2.Animation();
            animation.setFilteringEnabled(true && filter);
            animation.pushFrame(new GL2.Animation.Frame(framePath, 0, size, anchor, uvs));
            animation._refCounter = 0;
            this.__addToAnimationChache(animation);
        }
        
        animation._refCounter++;
        return animation;
    },
    
    /**
     * 
     * @param framePath - the path to the texture to use. Example: ./Content/textures/my_texture.png 
     * @param size - the size of the texture. Example: new Core.Size(128,256) or [128,256]
     * @param anchor - the anchor to use. Example: new Core.Point(0.5,1) or [0.5,1]
     * @param uvs - the uvs mapping to use. Example: new Core.Rect(0,0,1,1) or [0,0,1,1]
     * @param filter - boolean flag to filter the texture, by default false.
     * @returns a new GL2.Sprite instance with a cached GL2.Animation instance.
     */
    createSpriteWithCachedAnimation : function(/*String*/ framePath, /*Core.Size*/ size, /*Core.Point*/ anchor, /*Core.Rect*/ uvs, /*Boolean*/ filter) {
        var sprite = new GL2.Sprite();
        var animation = this.getAnimation(framePath,size,anchor,uvs,filter);
        sprite.setAnimation(animation);
        return sprite;
    },

    clearAnimationCache : function() {
        var cacheRefCopy = this._animationCache;
        this._animationCache = {};
        var cleared = 0;
        var keeped = 0;
        for ( var key in cacheRefCopy) {
            var animation = cacheRefCopy[key];
            cacheRefCopy[key] = null;
            if (animation._refCounter == 0) {
                animation.destroy();
                cleared++;
            } else {
                this._animationCache[key] = animation;
                keeped++;
            }
        }
        
        al_trace('SpriteFactoryCache.clearAnimationCache: Animation cache cleared: %d, keeped: %d', cleared, keeped);
    },

    __animationInCache : function(image, duration, size, anchor, uvs) {
        var key = this.__createCacheKey(image, duration, size, anchor, uvs);
        return this._animationCache[key];
    },

    __addToAnimationChache : function(/*GL2.Animation*/animation) {
        var key = this.__createCacheKey(animation.getFrame(0).getImage(), animation.getFrame(0).getDuration(), animation.getFrame(0).getSize(), animation.getFrame(0).getAnchor(), animation
                .getFrame(0).getUVs());
        this._animationCache[key] = animation;
        NgLogD("CachingAnimation: " + key);
    },

    __createCacheKey : function(image, duration, size, anchor, uvs) {
        var key = "";
        key += image;
        key += duration;
        key += size._width + "" + size._height;
        key += anchor._x + "" + anchor._y;
        key += uvs.getOrigin()._x + "" + uvs.getOrigin()._y + "" + uvs.getSize()._width + "" + uvs.getSize()._height;

        return key;
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Utils/LabelConfigurer'] = function(){var exports = $MODULE_REGISTRY['Code/Utils/LabelConfigurer'] || {}; $MODULE_REGISTRY['Code/Utils/LabelConfigurer'] = exports; exports.LabelConfigurer = Core.Class.subclass({
    classname : 'LabelConfigurer',
    
    /**
     * Creates a GL2.Text object
     * @param {String} text - the text of the label
     * @param {String} fontName - the font name
     * @param {Number} fontSize - the font size
     * @param {Core.Point} anchor - the anchor, if not given then [0.5,0.5]
     * @returns {GL2.Text}
     */
    $createLabelWithString : function(/*String*/text,/*String*/fontName, /*Number*/fontSize, /*Core.Point*/anchor, /*Boolean*/embedded)
    {
        var result = new GL2.Text();
        result.setText("" + text);
        
        if (!embedded)
        {
            result.setFontFamily(fontName);
        }
        else
        {
            result.setFontFamily("./Content/" + fontName + ".ttf");
            result.setFontLocation(GL2.Text.FontLocation.Manifest);
        }
        
        result.setFontSize(fontSize);
        result.setColor(1, 1, 1);
        result.setAnchor(anchor || [ 0.5, 0.5 ]);
        //Hack for Flash
        if (anchor)
        {
            var p = new Core.Point(anchor);
            // Horizontal anchor
            if (p.getX() == 0)
            {
                result.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
            }
            else if (p.getX() == 0.5)
            {
                result.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
            }
            else if (p.getX() == 1)
            {
                result.setHorizontalAlign(GL2.Text.HorizontalAlign.Right);
            }
            
            // Vertical anchor
            if (p.getY() == 0)
            {
                result.setVerticalAlign(GL2.Text.VerticalAlign.Top);
            }
            else if (p.getY() == 0.5)
            {
                result.setVerticalAlign(GL2.Text.VerticalAlign.Middle);
            }
            else if (p.getY() == 1)
            {
                result.setVerticalAlign(GL2.Text.VerticalAlign.Bottom);
            }
        }
        //End hack
        
        return result;
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Utils/ALLayerColor'] = function(){var exports = $MODULE_REGISTRY['Code/Utils/ALLayerColor'] || {}; $MODULE_REGISTRY['Code/Utils/ALLayerColor'] = exports; exports.ALLayerColor = GL2.Node.subclass({
    classname: 'ALLayerColor',

    destroy: function()
    {
        if (Core.ObjectRegistry.isObjectRegistered(this._sprite))
        {
            this._sprite.destroy();
        }
    },
    
    $layerWithColor : function(color, alpha, width, height, a_anchor)
    {
        var result = new this();     
        if (width === undefined)
        {
            width = UNISAFE_WIDTH;
        }
        
        if (height === undefined)
        {
            height = UNISAFE_HEIGHT;
        }
        
        var anchor = (!a_anchor) ? [ 0.5, 0.5 ] : a_anchor;
        
        result._sprite = TTSpriteFactory.spriteWithFile('1pxwhite.png', anchor, new Core.Vector(width, height));
        result._sprite.setColor(color);
        result._sprite.setAlpha(alpha);
        result.addChild(result._sprite);
        
        return result;
    },

    getSize: function()
    {
        return this._sprite.AL_getSize();
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Utils/AnimationCache'] = function(){var exports = $MODULE_REGISTRY['Code/Utils/AnimationCache'] || {}; $MODULE_REGISTRY['Code/Utils/AnimationCache'] = exports; exports.AnimationCache = Core.Class.singleton({
    classname : 'AnimationCache',

    initialize : function() {
        this._animationCache = {};
    },
    
    /**
     * Creates a new animation
     * @param name {String} Name of the animation
     * @param texturePath {String} Path to the texture
     * @param size {Core.Size} Size in pixels
     * @param anchor {Core.Size} Anchor point
     * @param toggleFilter {Boolean} Activate filtering
     * @param frameParameters {Object} Frame parameters.
     *        Example:
     *        {0: { _duration : 100, _uvs: [0, 0, 0.5, 1] 
     *         1: { _duration : 100, _uvs: [0.5, 0, 1, 1}}
     * @returns
     */
    getAnimation: function(name, texturePath, size, anchor, toggleFilter, frameParameters)
    {        
        var animationKey = texturePath + " " + name;
        
        size = (size instanceof Core.Size) ? size : new Core.Size(size);
        anchor = (anchor instanceof Core.Point) ? anchor : new Core.Point(anchor || [0,0]);
            
        var animation = this._animationCache[animationKey];
        if (!animation)
        {
            animation = new GL2.Animation();
            animation.setFilteringEnabled(true && toggleFilter);
            for (var frameKey in frameParameters)
            {
            	var frame = frameParameters[frameKey];
            	var uvs = (frame._uvs instanceof Core.Rect) ? frame._uvs : new Core.Rect(frame._uvs);
                animation.pushFrame(
                        new GL2.Animation.Frame(
                                "./Content/" + texturePath,
                                frame._duration,
                                size,
                                anchor,
                                uvs));
            }
            
            this._animationCache[animationKey] = animation;
        }
        
        return animation;
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Utils/SoundBoard'] = function(){var exports = $MODULE_REGISTRY['Code/Utils/SoundBoard'] || {}; $MODULE_REGISTRY['Code/Utils/SoundBoard'] = exports; exports.SoundBoard = Core.MessageListener.singleton({
    classname : "SoundBoard",
    
    setEnabled : function(/*Boolean*/e)
    {
        this.sfxEnabled = e;
    },
    
    setMusicEnabled : function(/*Boolean*/e)
    {
        this.musicEnabled = e;
    },
    
    initialize : function()
    {
        this.sfxEnabled = true;
        this.musicEnabled = true;
        this.musicPath = "./Content/";
        this.sfxExtension = ".wav";
        
        if (Core.Capabilities.getPlatformOS() === 'Android')
        {
            al_trace("SoundBoard.initialize: using ogg audio format for sfx z");
            this.sfxExtension = '.ogg';
        }
        else
        {
            al_trace("SoundBoard.initialize: using wav audio format for sfx");
        }
    },
    
    setInRace : function(/*Boolean*/racing)
    {
        al_trace("setInRace: curVal: " + (this.inRace ? "YES" : "NO") + " newVal:" + (racing ? "YES" : "NO"));
        if (racing != this.inRace)
        {
            this.inRace = racing;
            Audio.Music.stop();
            this.playMusic(true);
        }
    },
    
    playMusic : function(/*Boolean*/play, force)
    {        
    	al_trace("<<TT>> DEBUG: Play Music? > " + play);
        if (this.musicEnabled && play)
        {
            if (!Audio.Music.getIsPlaying())
            {
            	al_trace("<<TT>> DEBUG: I AM HERE ... it is a miracle!" );

                var path = this.musicPath + "song4.mp3";
                
                Audio.Music.setPath(path);
                Audio.Music.setVolume(0.75);
                Audio.Music.play();
            }
        }
        else
        {
            Audio.Music.stop();
        }
    },
    
    _loadSfx : function(soundId)
    {
        var sfx = null;
        switch (soundId)
        {
            case VIBRATE:
                return;
                break;
            case SFX_COINS:
                if (!this.coins)
                {
                    this.coins = new Audio.Effect(this.musicPath + "coins" + this.sfxExtension);
                }
                
                sfx = this.coins;
                break;
            
            case SFX_DONEBELL:
                if (!this.doneBell)
                {
                    this.doneBell = new Audio.Effect(this.musicPath + "doneBell" + this.sfxExtension);
                }
                
                sfx = this.doneBell;
                break;
            
            case SFX_ELEVATORBELL:
                if (!this.elevatorBell)
                {
                    this.elevatorBell = new Audio.Effect(this.musicPath + "elevatorBell" + this.sfxExtension);
                }
                
                sfx = this.elevatorBell;
                break;
            
            case SFX_ELEVATORDRONE:
                if (!this.elevatorDrone)
                {
                    this.elevatorDrone = new Audio.Effect(this.musicPath + "elevatorDrone" + this.sfxExtension);
                }
                
                sfx = this.elevatorDrone;
                break;
            
            case SFX_ELEVATORDOORS:
                if (!this.elevatorDoors)
                {
                    this.elevatorDoors = new Audio.Effect(this.musicPath + "elevator_Doors" + this.sfxExtension);
                }
                
                sfx = this.elevatorDoors;
                break;
            
            case SFX_BUX:
                if (!this.bux)
                {
                    this.bux = new Audio.Effect(this.musicPath + "bux" + this.sfxExtension);
                }
                
                sfx = this.bux;
                break;
            
            case SFX_CONSTRUCTION:
                if (!this.construction)
                {
                    this.construction = new Audio.Effect(this.musicPath + "construction" + this.sfxExtension);
                }
                
                sfx = this.construction;
                break;
            
            case SFX_STOCK:
                if (!this.stock)
                {
                    this.stock = new Audio.Effect(this.musicPath + "stock" + this.sfxExtension);
                }
                
                sfx = this.stock;
                break;
            
            case SFX_DOORBELL:
                if (!this.doorBell)
                {
                    this.doorBell = new Audio.Effect(this.musicPath + "doorbell" + this.sfxExtension);
                }
                
                sfx = this.doorBell;
                break;
            
            case SFX_LIGHTSWITCH:
                if (!this.lightSwitch)
                {
                    this.lightSwitch = new Audio.Effect(this.musicPath + "lightSwitch" + this.sfxExtension);
                }
                
                sfx = this.lightSwitch;
                break;
            
            case SFX_FOCUS_CREATIVE:
                if (!this.focusCreative)
                {
                    this.focusCreative = new Audio.Effect(this.musicPath + "floor_creative" + this.sfxExtension);
                }
                
                sfx = this.focusCreative;
                break;
            
            case SFX_FOCUS_FOOD:
                if (!this.focusFood)
                {
                    this.focusFood = new Audio.Effect(this.musicPath + "floor_food" + this.sfxExtension);
                }
                
                sfx = this.focusFood;
                break;
            
            case SFX_FOCUS_RECREATION:
                if (!this.focusRecreation)
                {
                    this.focusRecreation = new Audio.Effect(this.musicPath + "floor_recreation" + this.sfxExtension);
                }
                
                sfx = this.focusRecreation;
                break;
            
            case SFX_FOCUS_RETAIL:
                if (!this.focusRetail)
                {
                    this.focusRetail = new Audio.Effect(this.musicPath + "floor_retail" + this.sfxExtension);
                }
                
                sfx = this.focusRetail;
                break;
            
            case SFX_FOCUS_SERVICE:
                if (!this.focusService)
                {
                    this.focusService = new Audio.Effect(this.musicPath + "floor_service" + this.sfxExtension);
                }
                
                sfx = this.focusService;
                break;
            
            case SFX_DRESSUP:
                if (!this.dressUp)
                {
                    this.dressUp = new Audio.Effect(this.musicPath + "dressup" + this.sfxExtension);
                }
                
                sfx = this.dressUp;
                break;
            
            case SFX_EVICTED:
                if (!this.evicted)
                {
                    this.evicted = new Audio.Effect(this.musicPath + "evicted" + this.sfxExtension);
                }
                
                sfx = this.evicted;
                break;
            
            case SFX_MOVE:
                if (!this.move)
                {
                    this.move = new Audio.Effect(this.musicPath + "floor_move" + this.sfxExtension);
                }
                
                sfx = this.move;
                break;
            
            case SFX_PAINT:
                if (!this.paint)
                {
                    this.paint = new Audio.Effect(this.musicPath + "paint" + this.sfxExtension);
                }
                
                sfx = this.paint;
                break;
        }
        
        return sfx;
    },
    
    playSfx : function(/*Number*/soundId,/*Number*/gain)
    {
        if (!this.sfxEnabled)
        {
            return;
        }
        
        if (typeof(gain) === "undefined")
        {
            gain = 1.0;
        }
                
        al_trace("SoundBoard.playSfx: Playing " + soundId);
        
        var sfx = this._loadSfx(soundId);
        if (sfx)
        {
            al_trace_object(sfx, "sfx");
            var ae = new Audio.ActiveEffect(sfx);
            ae.getPlayCompleteEmitter().addListener(this, this._destroyActiveEffect);
            ae.setVolume(gain);
            ae.play();
            
            if (sfx.__playCount === undefined)
            {
                sfx.__playCount = 0;
            }
            
            sfx.__playCount++;
        }
    },
    
    _destroyActiveEffect : function(activeEffect)
    {
        if (activeEffect)
        {
            activeEffect._effect.__playCount--;
            activeEffect.getPlayCompleteEmitter().removeListener(this);
            activeEffect.destroy();
        }
    },
    
    preloadSfxs : function(sfxs)
    {
        for (var key in sfxs)
        {
            this._loadSfx(sfxs[key]);
        }
    },
    
    releaseSfx : function()
    {
        function destroyEffect(name)
        {
            var effect = this[name];
            if (effect)
            {
                if (effect.__playCount < 1)
                {
                    effect.destroy();
                    this[name] = null;
                }
                else
                {
                    al_trace("Skipping destruction of '" + name + "'. Play count is: " + effect.__playCount);
                }
            }
        }
        
        destroyEffect("coins");
        destroyEffect("doneBell");
        destroyEffect("elevatorBell");
        destroyEffect("elevatorDrone");
        destroyEffect("elevatorDoors");
        destroyEffect("bux");
        destroyEffect("construction");
        destroyEffect("stock");
        destroyEffect("doorBell");
        destroyEffect("lightSwitch");
        destroyEffect("focusCreative");
        destroyEffect("focusFood");
        destroyEffect("focusRecreation");
        destroyEffect("focusRetail");
        destroyEffect("focusService");
        destroyEffect("dressUp");
        destroyEffect("evicted");
        destroyEffect("move");
        destroyEffect("paint");
    },
    
    release : function()
    {
        if (this.musicEnabled)
        {
            Audio.Music.stop();
        }
        
        this.releaseSfx();
        this.destroy();
    },
    
    background: function() {
		this.releaseSfx();
		if (this.enabled) {
			Audio.Music.pause();
		}
	}
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Utils/PaymentController'] = function(){var exports = $MODULE_REGISTRY['Code/Utils/PaymentController'] || {}; $MODULE_REGISTRY['Code/Utils/PaymentController'] = exports; /**
 * Mobage payment controller class. Allows to perform payments using the Mobage
 * banking API. Allows up to 1 concurrent payment.
 */
exports.PaymentController = Core.Class.subclass({
    classname : "PaymentController",
    onClose : null,
    onProcess : null,
    onError : null,
    
    initialize : function(onClose, onProcess, onError)
    {
        this.transactionId = "";
        this.onClose = onClose;
        this.onProcess = onProcess;
        this.onError = onError;
    },
    
    /**
     * Attemps to buy 1 item, given its Stock-keeping Unit code
     * 
     * @param sku
     *            Stock-keeping Unit (item Id)
     * @param comment
     *            Comment used by the transaction log
     */
    createSimpleTransaction : function(sku, comment)
    {
        this.createTransaction([ {
            'item' : {
                'id' : sku
            },
            'quantity' : '1'
        } ], comment);
    },
    
    /**
     * Attemps to buy one or more items in any given quantity.
     * 
     * @param billingItems
     *            Items array (see Bank.Debit.createTransaction for details)
     * @param comment
     *            Comment used by the transaction log
     */
    createTransaction : function(billingItems, comment)
    {
        // Creation response handler
        var onCreateResponse = function(error, transaction)
        {
            if (error || !transaction)
            {
                al_trace("PaymentController.createTransaction.onResponse: Error creating transaction. Error: " + error);
                this.onError(error, transaction);
            }
            else
            {
                // Opening response handler
                var onOpenResponse = function(error, transaction)
                {                  
                    if (error || !transaction)
                    {
                        al_trace("PaymentController.createTransaction.onOpenResponse: Error opening transaction. Error: " + error);
                        Bank.Debit.cancelTransaction(this.transactionId, this.onError);
                    }
                    else
                    {
                        if (this.onProcess)
                        {
                            this.onProcess(transaction);
                        }
                        else
                        {
                            al_trace("PaymentController.createTransaction.onOpenResponse: No processing callback found.");
                        }
                    }
                };

                // Call
                this.transactionId = transaction.id;
                Bank.Debit.openTransaction(this.transactionId, onOpenResponse.bind(this));
            }
        };

        // Call
        Bank.Debit.createTransaction(billingItems, comment, onCreateResponse.bind(this));
    },
    
    /**
     * Attemps to close a transaction
     * 
     * @param transaction
     *            The transaction to close
     */
    closeTransaction : function(transaction)
    {
        // Response handler
        var onResponse = function(error, transaction)
        {            
            if (!error)
            {
                if (transaction)
                {
                    // Transaction successful
                    this.onClose(transaction);
                }
                else
                {
                    this.onError(null, transaction);
                }
            }
            else
            {
                al_trace("PaymentController.closeTransaction.onResponse: Error closing transaction. Error: " + error);
                Bank.Debit.cancelTransaction(this.transactionId, this.onError);
            }
        };
        
        // Call
        if (transaction)
        {
            Bank.Debit.closeTransaction(transaction.id, onResponse.bind(this));
        }
        else
        {
            al_trace("PaymentController.closeTransaction: No transaction transaction.");
        }
    },
    
    /**
     * Cancels existing transactions
     */
    $cancelPendingTransactions : function()
    {
        var onResponse = function(error, transactions)
        {
            var onResponse = function(error, transaction) {};
            for ( var i in transactions)
            {
                Bank.Debit.cancelTransaction(transactions[i], onResponse.bind(this));
            }
        };

        Bank.Debit.getPendingTransactions(onResponse.bind(this));
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Utils/ScoreManager'] = function(){var exports = $MODULE_REGISTRY['Code/Utils/ScoreManager'] || {}; $MODULE_REGISTRY['Code/Utils/ScoreManager'] = exports; exports.ScoreManager = Core.Class.singleton({
    classname : 'ScoreManager',
    
    initialize : function(callback)
    {
        al_trace("ScoreManager.initialize");
        this._leaderboards = null;
    },
    
    destroy : function()
    {
        for ( var i in this._leaderboards)
        {
            this._leaderboards[i].destroy();
        }
        
        this._leaderboards.length = 0;
        this._leaderboards = null;
    },
    
    getLeaderboards : function(onLoad)
    {
        if (this._leaderboards)
        {
            onLoad && onLoad(true);
            return;
        }
        
        Social.US.Leaderboard.getLeaderboards(function(error, result)
        {
            if (error)
            {
                al_trace("ScoreManager.getLeaderboards: error while getting leaderboard. Error: " + JSON.stringify(error));
                onLoad(false);
                return;
            }
            else
            {
                al_trace("ScoreManager.getLeaderboards: got leaderboards: " + result.length);
                this._leaderboards = [];
                for ( var i = 0; i < result.length; i++)
                {
                    var boardName = result[i].title;
                    this._leaderboards[boardName] = result[i];
                }
                
                onLoad && onLoad(true);
                return;
            }
        }.bind(this));
    },

    getFriendScores : function(boardName, onLoad)
    {
        if (!this._leaderboards)
        {
            onLoad && onLoad(null);
            return;
        }
        
        var leaderboard = this._leaderboards[boardName];
        if (!leaderboard)
        {
            al_trace("ScoreManager.getCachedScore: Couldn't get leaderboard");
            onLoad && onLoad(null);
            return;
        }
        
        var topScoreList = leaderboard.getFriendsScoresList();
        
        var result = [];        
        // Social.US.OrderedList iterator
        topScoreList.forAll(
            function(onContinue, item, index)
            {
                // Item callback
                if (item)
                {
                    al_trace("ScoreManager.getFriendScores: item: " + JSON.stringify(item));
                    result.push({
                        'user' : item.user,
                        'score' : item.points
                    });
                    
                    onContinue(true);
                }
                else
                {
                    onContinue(false);
                }
            },
            
            function(error)
            {
                // Finishing callback
                if (!error)
                {
                    al_trace("ScoreManager.getFriendScores: Obtained leaderboard score. Scores: " + JSON.stringify(result));
                    onLoad && onLoad(result);
                }
                else
                {
                    al_trace("ScoreManager.getFriendScores: Error obtaining leaderboard score " + JSON.stringify(error));
                }
            }
        );
    },
    
    submitScore : function(boardName, value)
    {
        if (!this._leaderboards)
        {
            return;
        }
        
        var leaderboard = this._leaderboards[boardName];        
        leaderboard.submitScore(value, function(error, score)
        {
            if (error)
            {
                al_trace("ScoreManager.submitScore: Couldn't submit score " + value + " to leaderboard " + boardName);
            }
            else
            {
                al_trace("ScoreManager.submitScore: Score " + value + " on leaderboard " + boardName + " updated successfully");
            }
        }.bind(this));
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTSpriteFactory'] = function(){var exports = $MODULE_REGISTRY['Code/TTSpriteFactory'] || {}; $MODULE_REGISTRY['Code/TTSpriteFactory'] = exports; var CONTENT_FOLDER = "./Content/";

exports.TTSpriteFactory = Core.Class.subclass({
    $spriteWithFile_withScale : function(filename, /*Core.Vector*/sscale)
    {
        return this.spriteWithFile(filename, [0, 0], sscale);
    },
    
    $spriteWithFile_withAnchor : function(filename, /*Core.Vector*/anchor)
    {
        return this.spriteWithFile(filename, anchor);
    },
    
    $spriteWithSprite_withTexture : function(a_sprite, uvs, a_anchor, a_scale)
    {

        var filename = a_sprite._animation.getFrame(0).getImage();
        return this.spriteWithSprite_withTexture(filename, uvs, a_anchor, a_scale); 
    },
    
    $spriteWithFile_withTexture : function(a_filename, uvs, a_anchor, a_scale, a_size)
    {
        var anchor = (!a_anchor) ? [0, 0] : a_anchor; 

        var imageSize = (!a_size) ? new Core.Size(DataPreloader._imageSizes[a_filename]) : new Core.Size(a_size);
        if(uvs)
    	{
        	var w = uvs[2];
        	var h = uvs[3];
        	
        	imageSize._width *= w;
        	imageSize._height *= h;
    	}
        
        var sprite = new GL2.Sprite();
        sprite.setAnimation(SpriteFactoryCache.getAnimation(CONTENT_FOLDER + a_filename, imageSize, anchor, uvs, false));

        if (a_scale === undefined)
        {
        	sprite.setScale(1,1);

        }
        else
        {
        	sprite.setScale(a_scale);
        }

        return sprite;        
    },
    
    $spriteWithFile : function(a_filename, /*Core.Vector*/a_anchor, /*Core.Vector*/a_scale)
    {
        var anchor = (!a_anchor) ? [0, 0] : a_anchor; 
        
        var imageSize = new Core.Size(DataPreloader._imageSizes[a_filename]);
        var sprite = new GL2.Sprite();
        sprite.setAnimation(SpriteFactoryCache.getAnimation(CONTENT_FOLDER + a_filename, imageSize, anchor, [0, 0, 1, 1], false));
        
        if (a_scale === undefined)
        {
            sprite.setScale(1, 1);

        }
        else
        {
            sprite.setScale(a_scale);
        }
        
        return sprite;
    }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTProductInfo'] = function(){var exports = $MODULE_REGISTRY['Code/TTProductInfo'] || {}; $MODULE_REGISTRY['Code/TTProductInfo'] = exports; exports.TTProductInfo = Core.Class.subclass({
    classname: "TTProductInfo",
    
    initialize : function(pName, pTime)
    {
        this._name = pName;
        this._time = pTime;
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTList'] = function(){var exports = $MODULE_REGISTRY['Code/TTList'] || {}; $MODULE_REGISTRY['Code/TTList'] = exports; exports.TTList = BaseClass.subclass({
    classname : 'TTList',
    
    $MAX_LIST_ITEMS : 64,
    
    initialize : function(width, height, callback)
    {
        this._callback = callback;
        this._velY = this._lastTouchY = this._lastLastTouchY = 0;
        this._elementsNode = new GL2.Node();
        this._node.addChild(this._elementsNode);
        this._children = [];
    },
    
    $initWithTarget : function(callback)
    {
        return new this(UNISAFE_WIDTH, UNISAFE_HEIGHT, callback);
    },
    
    destroy : function()
    {
        this._children.length = 0;
    },
    
    getElementsNode : function()
    {
        return this._elementsNode;
    },
    
    getChildren : function()
    {
        return this._elementsNode._children;
    },
    
    itemAtIndex : function(/*Number*/index)
    {
        if (index < this._children.length)
        {
            return this._children[index];
        }
        else
        {
            return null;
        }
    },
    
    addItem : function(/*GL2.Node*/item)
    {
        if (this._children.length == 0)
        {
            this._topY = 0;// We don't need to know about the space above.//;
            this._viewHeight = this._size[1] - this._node.getPosition().getY() - this._itemSize.getHeight() / 2;
        }
        
        var yPos = this._itemSize.getHeight() * this._children.length;
        item.setPosition(0, yPos);
        this._elementsNode.addChild(item);
        this._children.push(item);
    },
    
    isDragging : function()
    {
        return this._dragging || this._velY != 0;
    },
    
    setItemSize : function(/*Core.Size*/iSize)
    {
        this._itemSize = iSize;
    },
    
    /*non public methods */
    _draw : function(delta)
    {
        if (!this._elementsNode)
        {
            return;
        }
        this._velY += (0 - this._velY) / 6.0;
        if (Math.abs(this._velY) < 2.0)
        {
            this._velY = 0;
        }
        
        this._elementsNode.setPosition(this._elementsNode.getPosition().getX(), this._elementsNode.getPosition().getY() + this._velY);
        var listY = (this._topY - this._elementsNode.getPosition().getY());
        
        // top snap
        if (!this._dragging && (listY < 0 || this._children.length * this._itemSize.getHeight() < this._viewHeight))
        {
            var newY = this._elementsNode.getPosition().getY();
            newY += Math.floor((this._topY - newY) / 3);
            if (newY != 0)
            {
                this._elementsNode.setPosition(this._elementsNode.getPosition().getX(), newY);
            }
        }
        else
        {
            // bottom snap
            var bottomY = Math.floor(((this._children.length + 0.5) * this._itemSize.getHeight() - listY) - this._viewHeight);
            if (!this._dragging && bottomY < 0)
            {
                var newY = this._elementsNode.getPosition().getY();
                var newYDelta = Math.floor((-bottomY) / 3);
                if (newYDelta != 0)
                {
                    newY += newYDelta;
                    this._elementsNode.setPosition(this._elementsNode.getPosition().getX(), newY);
                }
            }
        }
    },
    
    _ccTouchesBegan : function(/*GL2.Touch*/touchEvent)
    {
        this._tapDowned = true;
        
        var tp = this._node.screenToLocal(touchEvent.getPosition());
        this._dragging = true;
        this._velY = 0;
        this._totalDrag = 0;
        this._lastTouchY = this._lastLastTouchY = tp.getY();
        
        return true;
    },
    
    _ccTouchesMoved : function(/*GL2.Touch*/touchEvent)
    {
        if (!this._tapDowned)
        {
            return;
        }
        
        var tp = this._node.screenToLocal(touchEvent.getPosition());
        
        this._lastLastTouchY = this._lastTouchY;
        this._lastTouchY = tp.getY();
        
        var delta = this._lastTouchY - this._lastLastTouchY;
        this._totalDrag += Math.abs(delta);
        this._elementsNode.setPosition(this._elementsNode.getPosition().getX(), this._elementsNode.getPosition().getY() + delta);
    },
    
    _ccTouchesEnded : function(/*GL2.Touch*/touchEvent)
    {
        this._direction = null;
        var tp = this._node.screenToLocal(touchEvent.getPosition());
        
        this._dragging = false;
        this._velY = tp.getY() - this._lastLastTouchY;
        
        // test for tap
        if (this._totalDrag < 5)
        {
            this._velY = 0;
            tp.setX(tp.getX() - this._elementsNode.getPosition().getX());
            tp.setY(tp.getY() - this._elementsNode.getPosition().getY());
            for ( var i = 0; i < this._children.length; i++)
            {
                var child = this._children[i];
                var bb = createBBBase(child.getPosition(), this._itemSize);
                if (CGRectContainsPoint(bb, tp))
                {
                    console.log("item " + i + " tapped");
                    this._callback(i, tp);
                    break;
                }
            }
        }
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTHList'] = function(){var exports = $MODULE_REGISTRY['Code/TTHList'] || {}; $MODULE_REGISTRY['Code/TTHList'] = exports; exports.TTHList = BaseClass.subclass({
    classname : 'TTHList',
    
    $MAX_LIST_ITEMS : 64,
    
    initialize : function(width, height, callback)
    {
        this._callback = callback;
        this._velX = this._lastTouchX = this._lastLastTouchX = 0;
        this._elementsNode = new GL2.Node();
        this._node.addChild(this._elementsNode);
        this._children = [];
    },
    
    $initWithTarget : function(callback)
    {
        return new this(UNISAFE_WIDTH, UNISAFE_HEIGHT, callback);
    },
    
    destroy : function()
    {
        this._children.length = 0;
    },
    
    getElementsNode : function()
    {
        return this._elementsNode;
    },
    
    getChildren : function()
    {
        return this._elementsNode._children;
    },
    
    itemAtIndex : function(/*Number*/index)
    {
        if (index < this._children.length)
        {
            return this._children[index];
        }
        else
        {
            return null;
        }
    },
    
    addItem : function(/*GL2.Node*/item)
    {
        if (this._children.length == 0)
        {
            this._leftX = this._node.getPosition().getX();
            this._viewWidth = UNISAFE_WIDTH;
        }
        
        var xPos = this._itemSize.getWidth() * this._children.length;
        item.setPosition(xPos, 0);
        this._elementsNode.addChild(item);
        this._children.push(item);
    },
    
    isDragging : function()
    {
        return this._dragging || this._velX != 0;
    },
    
    setItemSize : function(/*Core.Size*/iSize)
    {
        this._itemSize = iSize;
    },
    
    /*non public methods */
    _draw : function(delta)
    {
        if (!this._elementsNode)
        {
            return;
        }
        this._velX += (0 - this._velX) / 6.0;
        if (Math.abs(this._velX) < 2.0)
        {
            this._velX = 0;
        }
        
        this._elementsNode.setPosition(this._elementsNode.getPosition().getX() + this._velX, this._elementsNode.getPosition().getY());
        var listX = this._elementsNode.getPosition().getX() - this._leftX;
        
        // left snap
        if (!this._dragging && (listX > 0 || this._children.length * this._itemSize.getWidth() < this._viewWidth))
        {
            var newX = this._elementsNode.getPosition().getX();
            newX += Math.floor((this._leftX - newX) / 3);
            if (newX != 0)
            {
                this._elementsNode.setPosition(newX, this._elementsNode.getPosition().getY());
            }
        }
        else
        {
            // right snap
            var rightX = Math.floor(((this._children.length + 0.5) * this._itemSize.getWidth() + listX) - this._viewWidth);
            if (!this._dragging && rightX < 0)
            {
                var newX = this._elementsNode.getPosition().getX();
                newX -= rightX/3;
                this._elementsNode.setPosition(newX, this._elementsNode.getPosition().getY());
            }
        }
    },
    
    _ccTouchesBegan : function(/*GL2.Touch*/touchEvent)
    {
        this._tapDowned = true;
        
        var tp = this._node.screenToLocal(touchEvent.getPosition());
        this._dragging = true;
        this._velX = 0;
        this._totalDrag = 0;
        this._lastTouchX = this._lastLastTouchX = tp.getX();
        
        return true;
    },
    
    _ccTouchesMoved : function(/*GL2.Touch*/touchEvent)
    {
        if (!this._tapDowned)
        {
            return;
        }
        
        var tp = this._node.screenToLocal(touchEvent.getPosition());
        
        this._lastLastTouchX = this._lastTouchX;
        this._lastTouchX = tp.getX();
        
        var delta = this._lastLastTouchX - this._lastTouchX;
        this._totalDrag += Math.abs(delta);
        this._elementsNode.setPosition(this._elementsNode.getPosition().getX() - delta, this._elementsNode.getPosition().getY());
    },
    
    _ccTouchesEnded : function(/*GL2.Touch*/touchEvent)
    {
        this._direction = null;
        var tp = this._node.screenToLocal(touchEvent.getPosition());
        
        this._dragging = false;
        this._velX = this._lastLastTouchX - tp.getX();
        
        // test for tap
        if (this._totalDrag < 5)
        {
            this._velX = 0;
            tp.setX(tp.getX() - this._elementsNode.getPosition().getX());
            tp.setY(tp.getY() - this._elementsNode.getPosition().getY());
            for ( var i = 0; i < this._children.length; i++)
            {
                var child = this._children[i];
                var bb = createBBBase(child.getPosition(), this._itemSize);
                if (CGRectContainsPoint(bb, tp))
                {
                    al_trace("item " + i + " tapped");
                    this._callback(i, tp);
                    break;
                }
            }
        }
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTFloorTable'] = function(){var exports = $MODULE_REGISTRY['Code/TTFloorTable'] || {}; $MODULE_REGISTRY['Code/TTFloorTable'] = exports; exports.TTFloorTable = Core.Class.subclass({
    $COL_ID : 0,
    $COL_NAME : 1,
    $COL_TYPE : 2,
    $COL_LEVEL : 3,
    $COL_PRODA : 4,
    $COL_PRODB : 5,
    $COL_PRODC : 6,
    
    classname : 'TTFloorTable',
    
    $_floorArr : null,
    
    $sortedByCost : function()
    {
        var unsorted = [].concat(this._floorArr);
        var sorted = unsorted.sort(this.costCompare);
        return sorted;
    },
    
    $loadCSV : function(file)
    {
        //Read csv txt file
        var csv = DataPreloader._floors;
        var rows = csv.split("\n");
        var arr = [];
        
        //Loop through lines, creating TTFloorInfos
        for ( var i = 1; i < rows.length; i++)
        {
            //NSLog(@"%@",[rows objectAtIndex:i]);
            var cols = rows[i].split(",");
            var flrInfo = new TTFloorInfo(cols[TTFloorTable.COL_ID], cols[TTFloorTable.COL_NAME], cols[TTFloorTable.COL_TYPE], cols[TTFloorTable.COL_LEVEL]);
            
            var prodPiecesA = cols[TTFloorTable.COL_PRODA].split(":");
            if (prodPiecesA.length)
            {
                var prodInfoA = new TTProductInfo(prodPiecesA[0], prodPiecesA[1]);
                flrInfo._products[0] = prodInfoA;
            }
            
            var prodPiecesB = cols[TTFloorTable.COL_PRODB].split(":");
            if (prodPiecesB.length)
            {
                var prodInfoB = new TTProductInfo(prodPiecesB[0], prodPiecesB[1]);
                flrInfo._products[1] = prodInfoB;
            }
            
            var prodPiecesC = cols[TTFloorTable.COL_PRODC].split(":");
            if (prodPiecesC.length)
            {
                var prodInfoC = new TTProductInfo(prodPiecesC[0], prodPiecesC[1]);
                flrInfo._products[2] = prodInfoC;
            }
            
            arr.push(flrInfo);
        }
        
        return arr;
    },
    
    $levelForBluprint : function(floorInfo)
    {
        var totalMinutes = parseInt(floorInfo._products[0]._time) + parseInt(floorInfo._products[1]._time)+ parseInt(floorInfo._products[2]._time);
        if (floorInfo._type == FLOOR_TYPE_RESIDENTIAL)
        {
            return floorInfo._level / 100;
        }
        else
        {
            return Math.ceil(totalMinutes / 30.0);
        }
    },
    
    $randomFloorWithType : function(floorType, filter)
    {
        /* DEBUG TO TEST NEW FLOORS
        switch (floorType) {
            case FLOOR_TYPE_FOOD:
                return [TTFloorTable floorWithId:133];
                break;
            case FLOOR_TYPE_RETAIL:
                return [TTFloorTable floorWithId:132];
                break;
            case FLOOR_TYPE_CREATIVE:
                return [TTFloorTable floorWithId:135];
                break;
            case FLOOR_TYPE_SERVICE:
                return [TTFloorTable floorWithId:134];
                break;
            case FLOOR_TYPE_ENTERTAINMENT:
                return [TTFloorTable floorWithId:136];
                break;
            default:
                break;
        }
        // END TEST */

        var numBlueprints = TTFloorTable.floorCount();
        var existMap = [];
        for ( var i = 0; i < numBlueprints; i++)
        {
            existMap[i] = false;
        }
        
        var towerStories = TTScene.sharedScene()._playerData._floors;
        
        for ( var aKey in towerStories)
        {
            var storyInfo = towerStories[aKey];
            if (storyInfo && storyInfo._floorId >= 0 && storyInfo._floorId < numBlueprints)
            {
                var floorInfo = TTFloorTable.floorWithId(storyInfo._floorId);
                if (floorInfo._fid == FLOOR_ID_CONSTRUCTION)
                    existMap[storyInfo.sales()[1]] = true;
                else
                    existMap[storyInfo._floorId] = true;
            }
        }
        
        var possibleFloors = [];
        
        for ( var i = 0; i < numBlueprints; i++)
        {
            var floorInfo = TTFloorTable.floorWithId(i);
            if (floorInfo && floorInfo._fid != FLOOR_ID_EMPTY && floorInfo._fid != FLOOR_ID_CONSTRUCTION && floorInfo._fid != LOBBY_ID)
            {
                var unlocked = dict_size(towerStories) >= TTFloorTable.levelForBluprint(floorInfo);
                if (!filter || (!existMap[floorInfo._fid] && unlocked))
                {
                    if (floorInfo._type == floorType)
                    {
                        possibleFloors.push(floorInfo);
                    }
                }
            }
        }
        
        // return a random one
        if (possibleFloors.length > 0)
        {
            srandom(Core.Time.getRealTime() / 1000);
            return possibleFloors[std_rand() % possibleFloors.length];
        }
        else
        {
            return null;
        }
    },
    
    $floorWithId : function(id)
    {
        if (!this._floorArr)
        {
            this._floorArr = TTFloorTable.loadCSV("floors");
        }
        
        var pattern = null;
        if (id < this._floorArr.length)
        {
            pattern = this._floorArr[id];
        }
        
        return pattern;
    },
    
    $floorCount : function()
    {
        if (!this._floorArr)
        {
            this._floorArr = TTFloorTable.loadCSV("floors");
        }
        
        return this._floorArr.length;
    },
    
    $clearFloorTable : function()
    {
        al_trace("clearFloorTable....");
        this._floorArr = null;
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTFloorInfo'] = function(){var exports = $MODULE_REGISTRY['Code/TTFloorInfo'] || {}; $MODULE_REGISTRY['Code/TTFloorInfo'] = exports; exports.TTFloorInfo = Core.Class.subclass({
    classname: 'TTFloorInfo',
    
    initialize : function(floorId, fName, fType, fLevel)
    {
        this._fid = floorId;
        this._name = fName;
        this._type = fType;
        this._level = fLevel;
        this._products = [];
    },
    
    destroy : function()
    {
    },
    
    $costForBluprint : function(floorInfo)
    {
        var cost = 0;
        if (floorInfo._type == FLOOR_TYPE_RESIDENTIAL)
        {
            cost = floorInfo._level;
        }
        else
        {
            var totalMinutes = floorInfo._products[0]._time + floorInfo._products[1]._time + floorInfo._products[2]._time;
            cost = Math.ceil(totalMinutes * 10);
        }
        
        if (cost > 500)
        {
            cost *= 2;
        }
        
        return cost;
    },
    
    setName : function(newName)
    {
        this._name = newName;
    },
    
    costCompare : function(otherFloor)
    {
        if (otherFloor)
        {
            var costA = TTFloorInfo.costForBluprint(this);
            var costB = TTFloorInfo.costForBluprint(otherFloor);
            if (costA > costB)
            {
                return 1;
            }
            else
            {
                return -1;
            }
        }
        else
        {
            return 0;
        }
    },
    
    products : function()
    {
        return this._products;
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTFloor'] = function(){var exports = $MODULE_REGISTRY['Code/TTFloor'] || {}; $MODULE_REGISTRY['Code/TTFloor'] = exports; exports.TTFloor = BaseClass.subclass({
    classname: 'TTFloor',

    initialize : function()
    {
        this._prodIcons = [];
        this._storyInfo = null;

        //uint floorId, story;
        this._floorGfx = null;
        this._floorMask = null;
        this._shaft = null;
        this._bar = null;
        this._barColor = null;
        this._infoIcon = null;

        this._barLbl = null;
        this._barLblShadow = null;
        this._shaftLbl = null;
        this._infoLbl = null;
        this._infoLblShadow = null;

        //CCLayerColor *door;
        this._extLeft = null;
        this._extRight = null;

        this._floorInfo = null;
        this._storyInfo = null;

        //int problem;
        this._problemLayer = null;
        this._lightsLayer = null;

        this._bitizens = null;
        this._customers = null;
        this._rider = null;//, *customer;

        this._availElevator = null;

        this._hasRent = false;

        this._renters = null;
        this._custBoost = null;
        this._lastCustomerTime = 0;
    },

    destroy : function()
    {
    },

    $initWithStoryInfo : function(/*TTStoryInfo*/ sInfo)
    {
        var result = new this();

        al_trace("Creating floorGfx with id: " + sInfo._floorId);
        result._storyInfo = sInfo;
        result._floorInfo = TTFloorTable.floorWithId(result._storyInfo._floorId);
        result._custBoost = 0;

        // ELEVATOR SHAFT
        result._shaft = TTSpriteFactory.spriteWithFile_withAnchor("shaft.png", new Core.Vector(0,0));
        result._node.addChild(result._shaft);

        result._shaftLbl = LabelConfigurer.createLabelWithString(sprintf("%02d", result._storyInfo._story),"silkscreen", FONT18, [0.5, 0.5], true); 
        result._shaftLbl.setColor(ccc3(255,255,255));
        result._shaftLbl.setAlpha((127+64) / 255);

		var _scale = result._shaftLbl.getScale();
        result._shaftLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);   
        
        result._shaftLbl.setPosition(
                Math.floor(result._shaft.AL_getSize().getWidth()/2 - 2),
                Math.floor(result._shaft.AL_getSize().getHeight()/2 + 20));
        result._shaft.addChild(result._shaftLbl);

        // floorGfx BAR
        result._bar = TTSpriteFactory.spriteWithFile("bar.png", [0,0]);
        result._barColor = TTSpriteFactory.spriteWithFile("bar.png", [0,0]);
        result._barColor.setScale(1,1); // FIXME CONRAD STEIN !
        if (result._floorInfo && result._floorInfo._type == FLOOR_TYPE_RESIDENTIAL) {
            result._barColor.setColor(RES_BAR_COLOR);
        }
        else {
            result._barColor.setColor(STORE_BAR_COLOR);
        }
        result._bar.setPosition(result._shaft.AL_getSize().getWidth()*result._shaft.getScale().getX(),0);
        result._bar.addChild(result._barColor);
        result._node.addChild(result._bar);

        // floorGfx GRAPHIC
        if (result._storyInfo._floorId == LOBBY_ID) 
            result._floorGfx = TTSpriteFactory.spriteWithFile_withAnchor("lobby.png", [0,0]);
        else {
            var imageSize = new Core.Size(DataPreloader._imageSizes["floor" + result._storyInfo._floorId + ".png"]);
            var uvs =[0,0,256/imageSize.getWidth(),96/imageSize.getHeight()];
            result._floorGfx = TTSpriteFactory.spriteWithFile_withTexture("floor" + result._storyInfo._floorId + ".png", uvs, [0,0]);

        }
        
        result._floorGfx.setPosition(result._shaft.AL_getSize().getWidth()*result._shaft.getScale().getX(),
                result._bar.AL_getSize().getHeight()*result._bar.getScale().getY());
        result._floorGfx.setDepth(-100);
        result._node.addChild(result._floorGfx);


        result._lightsLayer = ALLayerColor.layerWithColor(ccc3(0,0,0),0.7,result._floorGfx.AL_getSize().getWidth()*result._floorGfx.getScale().getX(),
                result._floorGfx.AL_getSize().getHeight()*result._floorGfx.getScale().getY(), [0,0]);
//      result._lightsLayer.setScale(result._floorGfx.getScale());
        result._lightsLayer.setPosition(result._floorGfx.getPosition());
        result._lightsLayer.setPosition(result._floorGfx.getPosition());
        result._lightsLayer.setDepth(1001);
        result._node.addChild(result._lightsLayer);
        result._lightsLayer.setVisible(false);

        // PROD ICONS
        if (result._storyInfo._floorId != FLOOR_ID_CONSTRUCTION && result._storyInfo._floorId != FLOOR_ID_EMPTY) {
            for (var i=0; i<5; i++) {
                var picon;

                if (i>0)
                    al_trace(">>> " + result._prodIcons[i-1]);

                if (result._floorInfo && result._floorInfo._type == FLOOR_TYPE_RESIDENTIAL) {
                    picon = TTSpriteFactory.spriteWithFile_withAnchor("tiny_bit_icon.png", [-0.5,-0.5]);
                }
                else
                {
                    picon = result.getProductSprite(i);
                }
                result._prodIcons[i] = picon;
                picon.setAlpha(0);
                // [picon.texture setAliasTexParameters];
                picon.setScale(0.5,0.5);

                result._bar.addChild(picon);
                picon.setPosition(i * (result._floorInfo && result._floorInfo._type == FLOOR_TYPE_RESIDENTIAL ? 8 : 14)+(result._floorInfo && result._floorInfo._type == FLOOR_TYPE_RESIDENTIAL? 0 : 16),1);  
            }
            al_trace(">>> " + result._prodIcons[4]);
        }

        for (var i=0; i<5; i++) 
            al_trace("<<< " + result._prodIcons[i]);

        // BAR LABEL
        if (result._storyInfo._floorId == LOBBY_ID)
            result._barLbl = LabelConfigurer.createLabelWithString("LOBBY","silkscreen",FONT14, [0, 1], true); 
        else
            result._barLbl = LabelConfigurer.createLabelWithString(result._floorInfo._name,"silkscreen",FONT14, [0, 1], true);


        if (result._storyInfo._floorId == LOBBY_ID || result._storyInfo._floorId == FLOOR_ID_EMPTY || result._storyInfo._floorId == FLOOR_ID_CONSTRUCTION)
        {
            result._barLbl.setColor(ccc3(151,151,188));
        }
        else
        {
        	result._barLbl.setColor(TTScene.floorTypeColor(result._floorInfo._type));
        }

        result._barLbl.setPosition(50, 16);
		var _scale = result._barLbl.getScale();
        result._barLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);

		result._barLblShadow = LabelConfigurer.createLabelWithString(result._barLbl.getText(),"silkscreen",FONT14, [0,1], true);
        result._barLblShadow.setColor(ccc3(80,80,80));
        result._barLblShadow.setPosition(result._barLbl.getPosition().getX(), result._barLbl.getPosition().getY() + 2);

		var _scale = result._barLblShadow.getScale();
        result._barLblShadow.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);

        result._bar.addChild(result._barLblShadow);
        result._bar.addChild(result._barLbl);

        // Bitizens
        //bitizens = [[NSMutableArray alloc] initWithCapacity:10];
        result._bitizens = new GL2.Node();
        result._bitizens.setDepth(200);
        result._node.addChild(result._bitizens);

        result._lastCustomerTime = Core.Time.getRealTime()/1000;
        result._customers = new GL2.Node();
        result._customers.setDepth(50);
        result._node.addChild(result._customers);

        if (result._floorInfo && result._floorInfo._fid == FLOOR_ID_CONSTRUCTION)
            result.addContructionWorkers();

        if (sInfo && sInfo._activeProduct >= 0) {
            result.setProductIcon(sInfo._activeProduct);
            //[self update];
        }
        if (result.hasProblem()) {
            result.setProblem(result._storyInfo._problem);
        }
        
        result.repaint(); 
        return result;
    },
    
    repaint : function (repaint) {
    	if(this._storyInfo._color.length!=0 || repaint){
	    	// REPAINT LAYERS
	        fn = this._storyInfo._floorId == LOBBY_ID ? "lobby" : "floor" + this._storyInfo._floorId;
	        var mr = TTSpriteFactory.spriteWithFile(fn+ "_m_r.png", [0,0]);
	        mr.setVisible(false);
	        this._floorGfx.addChild(mr);
	        var mg = TTSpriteFactory.spriteWithFile(fn+ "_m_g.png", [0,0]);
	        mg.setVisible(false);
	        this._floorGfx.addChild(mg);
	        var mb = TTSpriteFactory.spriteWithFile(fn+ "_m_b.png", [0,0]);
	        mb.setVisible(false);
	        this._floorGfx.addChild(mb);
	        
            var largeFlag = this._storyInfo._color.length;
            for ( var i = 0; i < 3; i++)
            {
                var r, g, b;
                if (largeFlag != 0 && !repaint)
                {
                    r = this._storyInfo._color[i][0];
                    g = this._storyInfo._color[i][1];
                    b = this._storyInfo._color[i][2];
                }
                else
                {
                    r = std_rand() % 256;
                    g = std_rand() % 256;
                    b = std_rand() % 256;
                }
                
                this._storyInfo._color[i] = [ r, g, b ];
                this._floorGfx._children[i].setColor(ccc3(r, g, b));
                this._floorGfx._children[i].setVisible(true);
            }
	        //this._storyInfo._color = color;
    	}
    },
    
    zooming : function(/*bool*/ zoomout)
    {
        if(zoomout)
        {
            if(!this._extLeft)
            {

                this._extLeft = TTSpriteFactory.spriteWithFile_withAnchor(TTScene.isDayTime()?"exteriorleft.png":"exteriorleft_night.png",[1,0]);
                this._node.addChild(this._extLeft);
                this._extLeft.setScale(4,4);                
                this._extLeft.setPosition(0,-8); 
            }
            if(!this._extRight)
            {

                this._extRight = TTSpriteFactory.spriteWithFile_withAnchor(
                        TTScene.sharedScene().isDayTime() ? "exteriorright.png":
                            (this._lightsLayer.getVisible() ? "exteriorrightoff_night.png":"exteriorright_night.png"),[0,0]);
                this._node.addChild(this._extRight);
                this._extRight.setDepth(300);
                this._extRight.setScale(4,4);               
                this._extRight.setPosition(UNISAFE_WIDTH,-8); 
            }
        }
        else
        {
            if(this._extLeft)
            {
                this._extLeft.AL_removeFromParentAndCleanup(false);
                this._extLeft = null;
            }
            if(this._extRight)
            {
                this._extRight.AL_removeFromParentAndCleanup(false);
                this._extRight = null;
            }
        }

    },

    addContructionWorkers : function()
    {
        var i;
        for (i=0; i<3; i++) {
            this.addBitizen(BITIZEN_SEED_CONSTRUCTION);
        }
    },

    refreshName : function()
    {
        this._barLbl.setText(this._floorInfo._name);
        
        this._barLblShadow.setText(this._barLbl.getText());
    },

    switchToFloorId : function(/*int*/ fId)
    {
        var newFloorInfo = TTFloorTable.floorWithId(fId);
        if (!newFloorInfo)
            newFloorInfo = TTFloorTable.floorWithId(FLOOR_ID_EMPTY);
        if (newFloorInfo) {
            var oldFloorId = this._storyInfo._floorId;

            this._floorInfo = newFloorInfo;
            this._storyInfo._floorId = fId;

            this._barLbl.setText(newFloorInfo._name);
            this._barLbl.setColor(TTScene.floorTypeColor(newFloorInfo._type));
            this._barLblShadow.setText(newFloorInfo._name);

            if (this._floorInfo._type == FLOOR_TYPE_RESIDENTIAL) {
                 this._barColor.setColor(RES_BAR_COLOR);
            }
            else {
                this._barColor.setColor(STORE_BAR_COLOR);
            }
            
            this._floorGfx.destroy();

            var imageSize = new Core.Size(DataPreloader._imageSizes["floor" + this._floorInfo._fid + ".png"]);
            var uvs =[0,0,256/imageSize.getWidth(),96/imageSize.getHeight()];
            this._floorGfx = TTSpriteFactory.spriteWithFile_withTexture("floor" + this._floorInfo._fid + ".png", uvs, [0,0]);

            this._floorGfx.setPosition(this._shaft.AL_getSize().getWidth()*this._shaft.getScale().getX(),this._bar.AL_getSize().getHeight()*this._bar.getScale().getY());

            this._node.addChild(this._floorGfx);
            
                 
            var newGfx = TTSpriteFactory.spriteWithFile_withTexture(sprintf("floor%s.png",this._floorInfo._fid), uvs, [0,0]);
            
            if (this._floorMask) {
                this._floorMask.destroy(false);

                this._floorMask = null;
            }

            if (oldFloorId == FLOOR_ID_CONSTRUCTION && !TTScene.sharedScene()._playerData._readOnly) {
                var msg = "";
                if (this._floorInfo._type == FLOOR_TYPE_RESIDENTIAL) {
                    msg = "\n\n\n\n\n\n\n\n\n\n\n\nTHE " + this._floorInfo._name + " HAVE OPENED IN YOUR TOWER! YOU CAN NOW MOVE IN MORE BITIZENS!";
                }
                else {
                    msg = "\n\n\n\n\n\n\n\n\n\n\n\nA " + this._floorInfo._name + " HAS BEEN BUILT IN YOUR TOWER! IT SELLS " + this._floorInfo._products[0]._name + ", " + this._floorInfo._products[1]._name + " and " + this._floorInfo._products[2]._name + "";
                }

                var dlg = TTDialog.initWithMessage(msg,"continue", null, null, null);
                newGfx.setScale(0.5,0.5);
                newGfx.setPosition(-60,-100);
                TTDialogQueue.sharedQueue().addDialog(dlg); 
                dlg._node.addChild(newGfx);

            }

            // [lightsLayer setVisible:NO];


            this._storyInfo._sales[0] = 0;
            this._storyInfo._sales[1] = 0;
            this._storyInfo._sales[2] = 0;
            this._storyInfo._stock[0] = 0;
            this._storyInfo._stock[1] = 0;
            this._storyInfo._stock[2] = 0;
            
            var i;

            for (i=0; i<5; i++) {
                al_trace("DEBUG: _prodIcons[i].setAlpha");

                this._prodIcons[i] && this._prodIcons[i].setAlpha(0);
            }

            if (newFloorInfo._type == FLOOR_TYPE_RESIDENTIAL) {
                // record time of day (seconds after midnight) of apartment creation in sales[1]
                var date = new Date(Core.Time.getRealTime()/1000);
                this._storyInfo._sales[1] = date.getHours()*60*60+date.getMinutes()*60+date.getSeconds();
                // start with 3 beds
                //storyInfo._sales[0] = 2;
            }

            // PROD ICONS
            if (this._storyInfo._floorId != FLOOR_ID_CONSTRUCTION && this._storyInfo._floorId != FLOOR_ID_EMPTY) {
                var i;
			for (i=0; i<5; i++) {
                    this._prodIcons[i] && this._prodIcons[i].destroy();

                    var picon;
                    if (this._floorInfo._type == FLOOR_TYPE_RESIDENTIAL) {
                        picon = TTSpriteFactory.spriteWithFile_withAnchor("tiny_bit_icon.png", new Core.Vector(-0.5,-0.5));
                    }
                    else
                        picon = this.getProductSprite(i);
                    this._prodIcons[i] = picon;
                    al_trace("DEBUG: picon.setAlpha");
                    picon.setAlpha(0);
                    // picon.texture.setAliasTexParameter();
                    picon.setScale(0.5, 0.5);

                    this._bar.addChild(picon);
                    picon.setPosition(i * (this._floorInfo && this._floorInfo._type == FLOOR_TYPE_RESIDENTIAL ? 8 : 14)+(this._floorInfo && this._floorInfo._type == FLOOR_TYPE_RESIDENTIAL? 0 : 16),1);  

                }
            }

            TTScene.sharedScene()._towerLayer.calculatePopularities();
        }
    },

    addBitizen : function(/*uint*/ seed)
    {
        var tb = TTBitizen.initWithSeed(seed);
        //[bitizens addObject:tb];
        this._bitizens.addChild(tb._node);

        //ORIGINAL random = std_rand()
        var random = Math.floor(Math.random()* (Math.pow(2, 15) - 1))%128;

        tb._node.setPosition(
                this._floorGfx.getPosition().getX() + HALF_BIT_WIDTH + random % this._floorGfx.AL_getSize().getWidth()*2,
                this._floorGfx.getPosition().getY() + this._floorGfx.AL_getSize().getHeight() - 11);

        //[tb setDestX:floorGfx.position.x+HALF_BIT_WIDTH+rand()%(int)(floorGfx.contentSize.width*floorGfx.scale)];

        tb._destX = (this._floorGfx.getPosition().getX() + HALF_BIT_WIDTH + (random % Math.floor(this._floorGfx.AL_getSize().getWidth() * this._floorGfx.getScale().getX())));
        //tb._destX = this._node.getPosition().getX();
    },

    removeBitizenWithSeed : function(/*uint*/ seed)
    {
        var i = 0;
        for (i=0; i < this._bitizens._children.length; i++) {
            var bit = this._bitizens._children[i]._AL_owner;
            if (bit._seed == seed) { 
                bit._node.AL_removeFromParentAndCleanup(true);
                return true;
            }
        }
        return false;

    },

    containsBitizenWithSeed : function(/*uint*/ seed)
    {
        var i;
        for (i=0; i < this._bitizens._children.length; i++) {
            var bit = this._bitizens._children[i]._AL_owner;
            if (bit._seed == seed) {
                return true;
            }
        }
        return false;
    },

    clearInfoLabel : function()
    {
        if (this._infoLbl) {
            this._infoLbl.AL_removeFromParentAndCleanup(true);
            this._infoLblShadow.AL_removeFromParentAndCleanup(true);
            this._infoLbl = this._infoLblShadow = null;
        }
    },

    setInfoLabel : function(/*string*/string,/*Core.Color*/color)
    {
        if (TTScene.sharedScene()._playerData._readOnly)
        {
            return;
        }

        this.clearInfoLabel();

        // INFO LABEL
        this._infoLbl = LabelConfigurer.createLabelWithString(string.toUpperCase(), "silkscreen", FONT14, [1, 1], true);

		var _scale = this._infoLbl.getScale();
        this._infoLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        this._infoLbl.setColor(color);
        this._infoLbl.setPosition(this._bar.AL_getSize().getWidth() - 2, 16);

        this._infoLblShadow = LabelConfigurer.createLabelWithString(this._infoLbl.getText(), "silkscreen", FONT14, [1, 0], true);

		var _scale = this._infoLblShadow.getScale();
        this._infoLblShadow.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        this._infoLblShadow.setColor(ccc3(67, 67, 104));
        this._infoLblShadow.setPosition(this._infoLbl.getPosition().getX(), this._infoLbl.getPosition().getY() + 1);

        this._bar.addChild(this._infoLblShadow);
        this._bar.addChild(this._infoLbl);
    },

    clearInfoIcon : function()
    {
        if (this._infoIcon) {
            this._infoIcon.AL_removeFromParentAndCleanup(true);
            this._infoIcon = null;
        }
    },

    setInfoIcon : function(/*string*/ filename)
    {
        if (TTScene.sharedScene()._playerData._readOnly)
            return;

        this.clearInfoIcon();
        this._infoIcon = TTSpriteFactory.spriteWithFile_withAnchor(filename, [1,0]);
//      this._infoIcon.setPosition(
//      this._floorGfx.getPosition().getX()+this._floorGfx.AL_getSize().getWidth()*this._floorGfx.getScale().getX()-2,
//      (this._floorGfx.getPosition().getY()+this._floorGfx.AL_getSize().getHeight()*this._floorGfx.getScale().getY()-2));
        this._infoIcon.setPosition(
                this._floorGfx.getPosition().getX()+this._floorGfx.AL_getSize().getWidth()*this._floorGfx.getScale().getX()-2, 2 /* HARDCODED */ + 18);
        this._infoIcon.setDepth(2000);
        this._node.addChild(this._infoIcon);
    },

    getProductSprite : function(/*int*/ prodIndex)
    {

        var filename = this._floorGfx._animation.getFrame(0).getImage().replace("./Content/","");
        var imageSize = new Core.Size(DataPreloader._imageSizes[filename]);
        var w = imageSize.getWidth();
        var h = imageSize.getHeight();

        var uvs = [(prodIndex*32)/w, 96/h, 32/w, 32/h];

        var prodSpr = TTSpriteFactory.spriteWithFile_withTexture(filename, uvs, [1,0], [1,1]);
        prodSpr.setDepth(10000);
        prodSpr.setPosition(-2,0); //FIXME; esta es la posicion del icono que aparece arriba a la derecha de cada piso.


        return prodSpr;
    },

    setProductIcon : function(/*int*/ prodIndex)
    {
        this.setInfoIcon("note_item.png");
        if (!this._infoIcon)
        {
            return;
        }
            
        var x = this.getProductSprite(this._floorInfo && this._floorInfo._type == FLOOR_TYPE_RESIDENTIAL ? (prodIndex+1) : prodIndex);
        this._infoIcon.addChild(x);

        var barBg = ALLayerColor.layerWithColor(ccc3(0,0,0), 255/255, 30 ,2, [0,1]);

        barBg.AL_setTag(TAG_PROGBG);
        barBg.setPosition(-34,x.AL_getSize().getHeight()+2);//FIXME Forced position

        this._infoIcon.addChild(barBg);


        //var progBar = ALLayerColor.layerWithColor(PROG_BAR_COLOR_4B, 255/255, barBg._children[0].AL_getSize().getWidth(),barBg._children[0].AL_getSize().getHeight(), [0,1]);
        var progBar = ALLayerColor.layerWithColor(PROG_BAR_COLOR_4B, 255/255, 30,2, [0,1]);

        progBar.AL_setTag(TAG_PROGBAR);
        progBar.setPosition(-34,x.AL_getSize().getHeight()+2);//FIXME Forced position

        //progBar.setPosition(barBg.getPosition());
        this._infoIcon.addChild(progBar);
    },

    startProduction : function(/*int*/ prodIndex)
    {
        this._storyInfo._activeProduct = prodIndex;
        this._storyInfo._prodStartTime = Core.Time.getRealTime()/1000;

        var tower = TTScene.sharedScene()._towerLayer;/*this._node._parent._parent*/;
        if (tower) {
            tower.clearNoteOfType(NOTE_TYPE_EXCLAIM, this._storyInfo._story);
        }
        this.setProductIcon(prodIndex);
        this.update();
    },

    prodTimeLeftStr : function()
    {
        if (this._storyInfo._activeProduct < 0)
            return "";
        var pInfo = TTFloorTable.floorWithId(this._storyInfo._floorId)._products[this._storyInfo._activeProduct];
        var timeLeft = 0;
        if (this._floorInfo._fid == FLOOR_ID_CONSTRUCTION)
            timeLeft = (this._storyInfo._prodStartTime+pInfo._time*60*((this._storyInfo._sales[2]-1)/2.0))-(Core.Time.getRealTime()/1000);
        else
            timeLeft = (this._storyInfo._prodStartTime+pInfo._time*60)-(Core.Time.getRealTime()/1000);
        return TTScene.timeString(timeLeft);
    },

    addStock : function()
    {
        if (this._storyInfo._activeProduct >= 0) {
            var pInfo = TTFloorTable.floorWithId(this._storyInfo._floorId)._products[this._storyInfo._activeProduct];
            if (pInfo) {

                var grandOpening = this._storyInfo._sales[0] == 0;
                this._storyInfo._sales[0]++;

                var workers = TTScene.sharedScene()._playerData.bitizensWithWorkFloor(this._storyInfo._story);
                var happyCount = 0;
                var w;
                for (w=0; w<workers.length; w++) {
                    var winfo = workers[w];
                    if (winfo._dreamFloor == this._floorInfo._fid)
                        happyCount++;
                }

                var stockAmt = TTScene.quantityForProdTime(pInfo._time);
                if (this._storyInfo._activeProduct < happyCount)
                    stockAmt *= 2;
                this._storyInfo._stock[this._storyInfo._activeProduct] = Math.round(stockAmt);
                this._storyInfo._activeProduct = -1;
                this.clearInfoIcon();
                this.clearInfoLabel();
                this.update();

                SoundBoard.playSfx(SFX_STOCK);

                var tower = TTScene.sharedScene()._towerLayer;/*this._node._parent._parent*/;
                if (tower) {
                    tower.clearNoteOfType(NOTE_TYPE_STOCK, this._storyInfo._story);
                }

                if (this._storyInfo._stock[0] > 0 && this._storyInfo._stock[1] > 0 && this._storyInfo._stock[2] > 0 ) {

                    var buckPrize = (std_random() % 6) == 1;
                    var coinPrize = (this._storyInfo._stock[0]+this._storyInfo._stock[1]+this._storyInfo._stock[2])/20;
                    var prizeStr = buckPrize ? "1 Tower Bux": coinPrize + " coin";

                    if (buckPrize) {
                        // CONGRATS
                        var dlg = TTDialog.initWithMessage(sprintf("\n\n\nYou've earned a\n%s\nbonus for fully stocking this floor!", prizeStr), ",continue", null, null, null);
                        var fullystck = TTSpriteFactory.spriteWithFile("fullystocked.png");
                        fullystck.setPosition(ccp(0,80));
                        dlg._node._children[1].addChild(fullystck);
                        TTDialogQueue.sharedQueue().addDialog(dlg);
                        TTScene.sharedScene()._playerData.addBux(1);
                    }
                    else {
                        TTScene.sharedScene()._playerData.addCoins(coinPrize);
                        TTHud.sharedHud().animateCoinAmt(coinPrize);
                    }

                    TTScene.sharedScene()._playerData.checkStockAchievements();

                    // Chance for BitBook
                    //srandom([NSDate timeIntervalSinceReferenceDate]);
                    if (std_random() % BITBOOK_FLOORSTOCKED_CHANCE == 0) {

                        // Get workers
                        //NSMutableArray *workers = [[TTScene sharedScene].playerData bitizensWithWorkFloor:this._storyInfo.story];
                        var wInfo = null;
                        if (workers && workers.length > 0) {
                            wInfo = workers[std_rand() % workers.length];
                            var entry = TTBitBook.entryFormatForEvent("floor_stocked");
                            TTBitBook.addNewEntry(entry,this._floorInfo._name, wInfo._seed);
                        }
                    }
                }

                if (grandOpening) {
                    // Chance for BitBook
                    //srandom([NSDate timeIntervalSinceReferenceDate]);
                    if (std_rand()%BITBOOK_NEWPRODFLOOR_CHANCE == 0) {

                        // Get rand bitizen
                        var bits = TTScene.sharedScene()._playerData._bitizens;
                        var bInfo;
                        bInfo = (bits.length == 0) ? bits[std_rand()%(bits.length-1)] : null;
                        if (bInfo) {
                            entry = TTBitBookentryFormatForEvent("new_prod_floor");
                            TTBitBook.addNewEntry(entry,this._floorInfo._name,bInfo._seed);
                        }
                    }
                }

                if ( TTScene.sharedScene().tipNumber() >= 20) {
                    var dlg = TTDialog.initWithMessage("\n\n\n\nTUTORIAL Complete!\n\nThanks for learning the basics of Tiny Tower, the sky is the limit from here!", ",continue", null, null, null);
                    TTDialogQueue.sharedQueue().addDialog(dlg);
                    dlg = null;                        

                    var bux = TTScene.sharedScene()._playerData._bux;
                    var coins = TTScene.sharedScene()._playerData._coins;
                    TTScene.sharedScene()._playerData.addBux(-bux + 5);
                    TTScene.sharedScene()._playerData.addCoins(-coins+5000);
                    TTScene.sharedScene()._playerData._paint = 100;
                    TTScene.sharedScene().runTipLayer(null);
                }
            }
        }

    },

    addCustomer2 : function()
    {
        var customers_children_len = this._customers._children.length;
        var customer = this._customers._children[customers_children_len];
        customer.setDestX(this._floorGfx.getPosition().getX()+this._floorGfx.AL_getSize().getWidth()*this._floorGfx.getScale().getX()+32);
        // Remove stock and play player

        this._storyInfo._stock[customer.tag]--;
        TTScene.sharedScene().playerData.addCoins(customer.AL_getTag()+1);
        TTScene.sharedScene().towerLayer.addCPM(customer.AL_getTag()+1);

        this.update();
    },

    addCustomer: function()
    {
        if (this._custBoost > 0) {
            this._custBoost--;
        }

        var prodIndex = std_rand()%3;
        var tries = 1;
        while (this._storyInfo._stock[prodIndex] <= 0) {
            prodIndex = (prodIndex+1)%3;
            tries++;
            if (tries > 3) {
                return;
            }
        }

        // Remove stock and pay player
        this._storyInfo._stock[prodIndex]--;
        TTScene.sharedScene()._playerData.addCoins(prodIndex+1);
        TTScene.sharedScene()._towerLayer.addCPM(prodIndex+1);

        if (this.getNode()._visible && !TTScene.sharedScene()._towerLayer.isScrolling()) {
            var customer = TTBitizen.initWithSeed(std_rand());
            customer._node.setDepth(50);
            this._customers.addChild(customer._node);
            customer._node.AL_setTag(prodIndex);
            var prodIcon = this.getProductSprite(prodIndex);
            // [prodIcon setAnchorPoint:ccp(0.5,0.5)];
            prodIcon.setScale(0.5,0.5);
            prodIcon.setPosition(8,-6);
            customer.setSpeech(prodIcon);
            //[door setPosition:ccp(134,4)];
            customer._node.setPosition(134+16,
            		this._floorGfx.getPosition().getY() + this._floorGfx.AL_getSize().getHeight() - 11);
            customer._destX = this._floorGfx.getPosition().getX()+this._floorGfx.AL_getSize().getWidth()*this._floorGfx.getScale().getX()+32;
        }
    },

    resumeWithTimeElapsed : function(/*TimeInterval*/ time)
    {
        al_trace("TTFloor.resumeWithTimeElapsed");
        
        if (!this._storyInfo || !this._floorInfo
            || this._floorInfo._type == FLOOR_TYPE_RESIDENTIAL
            || this._floorInfo._fid == FLOOR_ID_EMPTY
            || this._floorInfo._fid == FLOOR_ID_CONSTRUCTION)
        {
            al_trace("TTFloor.resumeWithTimeElapsed: Returning early");
            return 0;
        }
        
        this.update();
        var floorType = Number(this._floorInfo._type);
        if (isNaN(floorType))
        {
            al_trace("TTFloor.resumeWithTimeElapsed: Floor type was NaN");
            floorType = 0;
        }
        
        var popularity =  TTScene.sharedScene()._towerLayer.busTypePopularities()[floorType];
        if (isNaN(popularity))
        {
            al_trace("TTFloor.resumeWithTimeElapsed: Popularity was NaN");
            popularity = 0;
        }
        
        var salesPerSecond = (FLOOR_UPDATE_FREQ / CUSTOMER_SPAWN_SECONDS) * popularity;
        var totalSales = time * salesPerSecond;
        var totalStock = this._storyInfo._stock[0] + this._storyInfo._stock[1] + this._storyInfo._stock[2];
        var productsSold = 0;
        var coinsEarned = 0;
        
        // NOTHING TO SELL
        if (totalStock == 0)
        {
        }
        // MORE SALES THAN STOCK
        else if (totalStock <= totalSales)
        {
            productsSold = totalStock;
            coinsEarned = this._storyInfo._stock[0] + this._storyInfo._stock[1] * 2 + this._storyInfo._stock[2] * 3;
            this._storyInfo._stock[0] = 0;
            this._storyInfo._stock[1] = 0;
            this._storyInfo._stock[2] = 0;
        }
        // DISTRIBUTE SALES OVER STOCK
        else // (totalStock > totalSales)
        {
            // FIRST PASS
            var numProds = 0;
            for ( var i = 0; i < 3; i++)
            {
                if (this._storyInfo._stock[i] > 0)
                {
                    numProds++;
                }
            }
            
            var salesPerProd = totalSales / numProds;
            for ( var i = 0; i < 3; i++)
            {
                if (this._storyInfo._stock[i] <= salesPerProd)
                {
                    totalSales -= this._storyInfo._stock[i];
                    productsSold += this._storyInfo._stock[i];
                    coinsEarned += this._storyInfo._stock[i] * (i + 1);
                    this._storyInfo._stock[i] = 0;
                }
                else
                {
                    totalSales -= salesPerProd;
                    productsSold += salesPerProd;
                    coinsEarned += salesPerProd * (i + 1);
                    this._storyInfo._stock[i] -= salesPerProd;
                }
            }
            
            // SECOND PASS
            numProds = 0;
            for ( var i = 0; i < 3; i++)
            {
                if (this._storyInfo._stock[i] > 0)
                {
                    numProds++;
                }
            }
            
            totalStock = this._storyInfo._stock[0] + this._storyInfo._stock[1] + this._storyInfo._stock[2];
            for ( var i = 0; i < 3; i++)
            {
                if (this._storyInfo._stock[i] > 0)
                {
                    var psales = Math.ceil((this._storyInfo._stock[i] / totalStock) * totalSales);
                    if (this._storyInfo._stock[i] < psales)
                    {
                        psales = this._storyInfo._stock[i];
                    }
                    
                    this._storyInfo._stock[i] -= psales;
                    productsSold += psales;
                    coinsEarned += psales * (i + 1);
                }
            }
        }
        this.update();
        
        // BIRTHDAY CHECK
        if (TTScene.sharedScene().shouldCheckBirthdays())
        {
            var doy = TTScene.sharedScene()._dayOfYear;

            al_trace("Checking doy: " + doy);
            for ( var i = 0; i < this._bitizens._children.length; i++)
            {
                var bit = this._bitizens._children[i]._AL_owner;
                var currentYear = (new Date()).getFullYear();
                var jan01 = new Date(currentYear, 0, 1);
                var dayOfYear = Math.ceil((new Date(currentYear, bit._bmonth, bit._bday) - jan01) / 86400000);
                
                al_trace(bit._name + "'s bday: " + dayOfYear + ", day of year: " + doy);

                if (dayOfYear == doy)
                {
                    // WE HAVE A BDAY!
                    TTScene.sharedScene()._playerData.addBux(1);
                    var dlg = TTDialog.initWithMessage(sprintf("\n\n\n\n%s\nhas a birthday today! You've earned 1 Tower Bux!", bit._name), ",continue", null, null, null);
                    var bdbit = TTBitizen.initWithSeed(bit._seed);
                    bdbit._node.setPosition(0, 40);
                    dlg._node._children[1].addChild(bdbit._node);
                    TTDialogQueue.sharedQueue().addDialog(dlg);
                    
                    // BITBOOK
                    var entry = TTBitBook.entryFormatForEvent("birthday");
                    TTBitBook.addNewEntry(entry, bit._seed);
                }
            }
        }
        
        return coinsEarned;//productsSold;
    },

    update : function()
    {
        // chance for 
        // chance for customer
        var now = Core.Time.getRealTime()/1000;
        if (this._storyInfo._floorId != LOBBY_ID && this._floorInfo._type != FLOOR_TYPE_RESIDENTIAL && this._storyInfo._floorId != FLOOR_ID_EMPTY && this._storyInfo._floorId != FLOOR_ID_CONSTRUCTION/* && !customer*/) {
            if (this._storyInfo._stock[0]>0||this._storyInfo._stock[1]>0||this._storyInfo._stock[2]>0) {
                this._lightsLayer.setVisible(false);

                if ((now-this._lastCustomerTime)>=1 && (this._custBoost > 0 || std_rand()*100000/0x7fffffff < (1.0/CUSTOMER_SPAWN_SECONDS)*TTScene.sharedScene()._towerLayer.busTypePopularities()[this._floorInfo._type] ) ) {
                    //NSLog(@"ADDING CUSTOMER");
                    this.addCustomer();
                    this._lastCustomerTime = Core.Time.getRealTime()/1000;
                }
            }
            else if(!this._lightsLayer._visible && !TTScene.sharedScene()._playerData._readOnly) {
                this._lightsLayer.setVisible(true);
                SoundBoard.playSfx(SFX_LIGHTSWITCH);
                al_trace("@ " + (this._storyInfo._activeProduct < 0));
                if (this._storyInfo._activeProduct < 0) {
                    this.setInfoIcon("note_exclaim.png");
                    this.setInfoLabel("CLOSED", INFO_COLOR_PROBLEM);

                    var tower = TTScene.sharedScene()._towerLayer;/*this._node._parent._parent*/;
                    al_trace("tower : " + tower);
                    if (tower) {
                        var tnote = TTNote.initWithType(NOTE_TYPE_EXCLAIM, this._storyInfo._story);
                        tower.addNote(tnote);
                    }

                    // Chance for BitBook
                    if (std_random()%BITBOOK_FLOORCLOSED_CHANCE==0) {
                        // Get workers
                        var workers = TTScene.sharedScene()._playerData.bitizensWithWorkFloor(this._storyInfo._story);
                        var wInfo = null;
                        if (workers && workers.length > 0) {
                            wInfo = workers[std_rand()%workers.length];
                            var entry = TTBitBook.entryFormatForEvent("floor_closed");
                            // TTBitBook.addNewEntry:[NSString stringWithFormat:entry,floorInfo.name] fromBit:wInfo._seed];
                            // FIXME:  the new entry has no format
                            TTBitBook.addNewEntry("" +this._floorInfo._name,wInfo._seed);

                        }
                    }
                }
            }

        }

        if(true) {
            // product icons
            if (this._storyInfo._floorId == FLOOR_ID_CONSTRUCTION || this._storyInfo._floorId == FLOOR_ID_EMPTY) {
                for (var i=0; i<5; i++) {
                    this._prodIcons[i] ? this._prodIcons[i].setVisible(false) : false;
                    // al_trace(sprintf("Setting floor:%d icon:%d to hidden",this._storyInfo._story,i));
                }
            }
            else {
                if (this._floorInfo._type == FLOOR_TYPE_RESIDENTIAL) {
                    var numRenters = TTScene.sharedScene()._playerData.bitizensWithHomeFloor(this._storyInfo._story).length;
                    for (var i=0; i<5; i++) {
                        this._prodIcons[i] ? this._prodIcons[i].setAlpha(32/255) : false;
                        if (this._prodIcons[i] ? this._prodIcons[i].getAlpha()>0 : false)
                            this._prodIcons[i] ? this._prodIcons[i].setAlpha((i<numRenters?255:32)/255) : false;
                    }
                }
                else {
                    for (var i=0; i<3; i++) {
                        this._prodIcons[i] ? this._prodIcons[i].setAlpha( (this._storyInfo._stock[i]<=0?32:255) / 255) : false;
                    }
                }
            }
        }

        // Active product?
        if (this._storyInfo._floorId == FLOOR_ID_CONSTRUCTION || (this._storyInfo._floorId != LOBBY_ID && this._storyInfo._activeProduct >= 0 && this._storyInfo._activeProduct < 3)) {

            //NSLog(@"Floor update product.");

            var pInfo = null;
            if (this._storyInfo._activeProduct >= 0 && this._storyInfo._activeProduct < 3)
                pInfo = TTFloorTable.floorWithId(this._storyInfo._floorId)._products[this._storyInfo._activeProduct];
            // Done?
            var prodTime = Core.Time.getRealTime()/1000 - this._storyInfo._prodStartTime;

            var duration = pInfo ? (pInfo._time*60) : 0;
            if (this._floorInfo._fid == FLOOR_ID_CONSTRUCTION)
                duration = 60*60*((this._storyInfo._sales[2]-1)/2.0); // FIXME, arreglar este truco q hace esperar solo 25 segs.
            if ((this._floorInfo._fid == FLOOR_ID_CONSTRUCTION || this._infoIcon) && prodTime > duration) {
                if (this._floorInfo._fid == FLOOR_ID_CONSTRUCTION) {

                    this.clearInfoIcon();
                    this.clearInfoLabel();
                    this._storyInfo._activeProduct = -1;
                    this.switchToFloorId(this._storyInfo._sales[1]);
                    this._bitizens.AL_removeAllChildrenWithCleanup(true);
                }
                else if (this._floorInfo._type == FLOOR_TYPE_RESIDENTIAL) {
                    this.clearInfoIcon();
                    this.clearInfoLabel();
                    this._storyInfo._activeProduct = -1;
                }
                else if (this._infoIcon && this._infoIcon.AL_getChildByTag(TAG_PROGBAR)) {
                    // Switch to coin icon
                    this.setInfoIcon("note_stock.png");
                    this.setInfoLabel("STOCK!",INFO_COLOR_STOCK);
                    SoundBoard.playSfx(SFX_DONEBELL);

                    var tower = TTScene.sharedScene()._towerLayer/*self._parent._parent*/;
                    if (tower) {
                        var tnote = TTNote.initWithType(NOTE_TYPE_STOCK,this._storyInfo._story);
                        tower.addNote(tnote);
                    }
                }
            }
            else {
                if (this._infoIcon)
                {
                    // Not done, update prog bar
                    var progBar = this._infoIcon.AL_getChildByTag(TAG_PROGBAR);
                    if (progBar) {
                        var duration = pInfo._time*60.0;
                        if (this._floorInfo._fid == FLOOR_ID_CONSTRUCTION)
                            duration = pInfo._time*60.0*((this._storyInfo._sales[2]-1)/2.0);
                        var progress = prodTime/(duration);
                        progress = progress < 0 ? 0 : progress;
                        
                        //(sprintf("Updating with progress: %f scaleX %f",progress,progBar.getScale().getX()));
    
                        progBar.setScale(new Core.Vector(progress,1));
                    }
                    this.setInfoLabel(this.prodTimeLeftStr(), PROG_BAR_COLOR_3B);
                }
            }
        }

        // Remove rider
        if (this._rider && this._rider._node.getPosition().getX() > this._floorGfx.getPosition().getX() + this._floorGfx.AL_getSize().getWidth() * this._floorGfx.getScale().getX() + 0)
        {
            //this._rider._node.AL_removeFromParentAndCleanup(true);
            this._rider.destroy();
            this._rider = null;
        }

        
        // Remove customers
        for ( var c = this._customers._children.length; c >= 0; c--)
        {
            var customer = this._customers._children[c];
            if (customer && customer.getPosition().getX() > this._floorGfx.getPosition().getX() + this._floorGfx.AL_getSize().getWidth() * this._floorGfx.getScale().getX() + 0)
            {
                customer.destroy();
            }
        }
    },

    hasFinishedProduct : function()
    {
        if (this._storyInfo._activeProduct < 0)
        {
            return false;
        }

        var pInfo = TTFloorTable.floorWithId(this._storyInfo._floorId)._products[this._storyInfo._activeProduct];
        var prodTime = Core.Time.getRealTime() / 1000 - this._storyInfo._prodStartTime;
        var duration = pInfo._time * 60;
        if (this._floorInfo._fid == FLOOR_ID_CONSTRUCTION)
        {
            duration = pInfo._time * 60 * ((this._storyInfo._sales[2] - 1) / 2.0);
        }

        return (this._infoIcon && prodTime > duration);
    },

    prodPercentComplete : function()
    {
        if (this._storyInfo._activeProduct < 0)
        {
            return 0;
        }
        else
        {
            var pInfo = TTFloorTable.floorWithId(this._storyInfo._floorId)._products[this._storyInfo._activeProduct];
            var duration = pInfo._time * 60;
            if (this._floorInfo._fid == FLOOR_ID_CONSTRUCTION)
            {
                duration = pInfo._time * 60 * ((this._storyInfo._sales[2] - 1) / 2.0);
            }

            return (Core.Time.getRealTime() / 1000 - this._storyInfo._prodStartTime) / (duration);
        }
    },

    prodHurryCost : function()
    {
        if (this._storyInfo._activeProduct < 0)
        {
            return 0;
        }
        else
        {
            var pInfo = TTFloorTable.floorWithId(this._storyInfo._floorId)._products[this._storyInfo._activeProduct];
            var duration = pInfo._time * 60;
            if (this._floorInfo._fid == FLOOR_ID_CONSTRUCTION)
                duration = pInfo._time * 60 * ((this._storyInfo._sales[2] - 1) / 2.0);
            return Math.ceil(((duration) - (Core.Time.getRealTime()/1000 - this._storyInfo._prodStartTime)) / (BUX_MINUTE_WORTH * 60));
        }
    },

    hurryProduct : function()
    {
        if (this._storyInfo._activeProduct >= 0)
        {
            var pInfo = TTFloorTable.floorWithId(this._storyInfo._floorId)._products[this._storyInfo._activeProduct];
            var duration = pInfo._time * 60;
            if (this._floorInfo._fid == FLOOR_ID_CONSTRUCTION)
            {
                duration = pInfo._time * 60 * ((this._storyInfo._sales[2] - 1) / 2.0);
            }

            this._storyInfo._prodStartTime = Core.Time.getRealTime() / 1000 - duration;
        }
    },

    hasProblem : function()
    {
        return this._storyInfo._problem >= 0;
    },

    setProblem : function(/*int*/ problemType)
    {
        if (this._problemLayer) {
            this._problemLayer.AL_removeFromParentAndCleanup(true);
            this._problemLayer = null;
        }

        this._storyInfo._problem = problemType;
        if (this._storyInfo._problem == PROBLEM_TYPE_FLOOD) {
            this._problemLayer = ALLayerColor.layerWithColor(ccc3(93,138,218), 0.7, this._floorGfx.AL_getSize().getWidth(), /* height */ 10);
        }
        else if (this._storyInfo._problem == PROBLEM_TYPE_POWER) {
            this._problemLayer = ALLayerColor.layerWithColor(ccc3(0,0,0), 0.7, this._floorGfx.AL_getSize().getWidth(), this._floorGfx.AL_getSize().getHeight());
        }

        if (this._problemLayer) {
            this._problemLayer.setScale(this._floorGfx.getScale().getX());
            // this._problemLayer.setAnchorPoint(new Core.Point(0,0));
            this._problemLayer.setPosition(this._floorGfx.getPosition());
            this._problemLayer.setDepth(1000);
            this._node.addChild(this._problemLayer);

            this.setInfoIcon("note_exclaim.png");
            this.setInfoLabel("FIX!", INFO_COLOR_PROBLEM);

            var tower = TTScene.sharedScene()._towerLayer /*self._parent._parent*/;
            if (tower) {
                var tnote = TTNote.initWithType(NOTE_TYPE_EXCLAIM, this._storyInfo._story);
                tower.addNote(tnote);
            }
        }
    },

    fixProblem : function()
    {
        if (this._storyInfo._problem >= 0) {
            this._storyInfo._problem = -1;
            this.clearInfoIcon();
            this.clearInfoLabel();
            this._problemLayer.AL_removeFromParentAndCleanup(true);
        }
    },

    collectCoins : function()
    {
        var numRenters = TTScene.sharedScene()._playerData.bitizensWithHomeFloor(this._storyInfo._story).length;
        if (numRenters > 0) {

            TTScene.sharedScene()._playerData.addCoins(50*numRenters);
            var today = Core.Time.getRealTime()/1000/(60*60*24);
            this._storyInfo._sales[2] = today;
        }
        var tower = TTScene.sharedScene()._towerLayer;/*this._node._parent._parent*/;
        if (tower) {
            tower.clearNoteOfType(NOTE_TYPE_COINS, this._storyInfo._story);
        }
        this._hasRent = false;
        this.clearInfoIcon();
        this.clearInfoLabel();
        this.update();
    },

    elevatorArrived : function(/*TTElevator*/ elevator)
    {
        // Save elevator
        this._availElevator = elevator;
        al_trace("Elevator arrived!");
    },

    addRider2 : function()
    {    
        if (this._rider)
        {
            this._rider._destX = this._floorGfx.getPosition().getX() + this._floorGfx.AL_getSize().getWidth() * this._floorGfx.getScale().getX() + 32;
        }       
    },

    addRider : function(/*TTBitizen*/theRider)
    {
        if (this._rider)
        {
            this._rider.destroy();
            this._rider = null;
        }

        // check if rider is already in the floor
        for ( var i = 0; i < this._bitizens._children.length; i++)
        {
            var bit = this._bitizens._children[i]._AL_owner;
            if (bit._seed == theRider._seed)
            {
                theRider.destroy();
                return;
            }
        }

        this._rider = theRider;
        this._rider._node.setDepth(50);
        this._rider.setSpeech(null);
        this._rider._node.setScale(1,1);

        this._rider._node.setPosition(
                        150,
                        this._floorGfx.getPosition().getY() + this._floorGfx.AL_getSize().getHeight() - 11);

        this._node.addChild(this._rider._node);
        setTimeout(this.addRider2.bind(this), 900);
    },

    updateShaftLbl : function()
    {
        this._shaftLbl.setText(sprintf("%02d", this._storyInfo._story));
    },

    _draw : function()
    {
        // Animate any bitizens
        // console.log("TTFloor._draw[" + this._storyInfo._story +  "] : " + "this._bitizens.length > " + (this._bitizens ? this._bitizens._children.length : "no bitizens!"));
        for ( var i = 0; i < this._bitizens._children.length; i++)
        {
            var bit = this._bitizens._children[i]._AL_owner;
            if (bit && bit._destX < 0 && std_rand() % 100 == 42)
            {
                bit._destX = this._floorGfx.getPosition().getX() + HALF_BIT_WIDTH + (std_rand() % Math.floor(this._floorGfx.AL_getSize().getWidth() * this._floorGfx.getScale().getX()));
            }
        }
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/LoadingScreen'] = function(){var exports = $MODULE_REGISTRY['Code/LoadingScreen'] || {}; $MODULE_REGISTRY['Code/LoadingScreen'] = exports; exports.LoadingScreen = Core.Class.subclass({
    classname: 'LoadingScreen',
    
    initialize : function()
    {
        al_trace("LoadingScreen.initialize");
        
        // Window area
//        var winArea = new UI.ViewGeometry.Rect(0, 0, UI.Window.getOuterWidth(), UI.Window.getOuterHeight());
        var winArea = new UI.ViewGeometry.Rect(0, 0, UI.Window._width, UI.Window._height);
        this._node = new UI.View();
        this._node.setFrame(winArea.array());
        this._node.setBackgroundColor("FF000000");
        
        // Startup image 
        var loadImage = new UI.Image();
        loadImage.setImage('./Content/Default.png'); /*original: Default@2X*/
        loadImage.setImageFit(UI.FitMode.Stretch);
        loadImage.setImageGravity([0.5, 1.0]);
        loadImage.setFrame(winArea.array());
        this._node.addChild(loadImage);
        
        // Spinner
        var spinner = new UI.Spinner();
        spinner.setFrame([ UI.Window.getOuterWidth() / 2 - 32, UI.Window.getOuterHeight() * 0.85, 64, 64 ]);
        this._node.addChild(spinner);
        
        UI.Window.document.addChild(this._node);
    },
    
    destroy : function()
    {
        al_trace("LoadingScreen.destroy");
        var children = this._node.getChildren();
        for ( var i in children)
        {
            children[i].destroy();
        }
        
        this._node.destroy();
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTAppDelegate'] = function(){var exports = $MODULE_REGISTRY['Code/TTAppDelegate'] || {}; $MODULE_REGISTRY['Code/TTAppDelegate'] = exports; exports.TTAppDelegate = Core.Class.singleton({
    classname : 'TTAppDelegate',

    initialize : function() {
        var glView = new UI.GLView();
        glView.onload = function() {
            SoundBoard.instantiate();   
            ScoreManager.instantiate();
            
            Social.Common.Service.showCommunityButton(UI.ViewGeometry.Gravity.TopLeft);
            
            // LOAD SAVE GAME
            TTScene.instantiate();
            TTScene.sharedScene()._playerData.returnFromNeighbor();
                
            // Background music
            var setting = NSUserDefaults.standardUserDefaults().objectForKey("setting-sfxOff");
            if (setting == null) 
            {
                setting = true;
            }
            SoundBoard.setMusicEnabled(setting);
            SoundBoard.playMusic(setting);
            SoundBoard.setEnabled(setting);
        };

//        glView.setAttribute('frame', [0, 0, UI.Window.outerWidth, UI.Window.outerHeight]);
		glView.setAttribute('frame', [0,0,UI.Window._width,UI.Window._height]);
        glView.setAttribute('active', true);

        Device.LifecycleEmitter.addListener(new Core.MessageListener(),this._onLifecycleChange.bind(this));
        Device.KeyEmitter.addListener(new Core.MessageListener(),this._onKeyPressed.bind(this));
    },
    
    _onKeyPressed : function(/*Device.KeyEmitter.Event*/event)
    {        
        if (event.code === Device.KeyEmitter.Keycode.back) /*use back*/
        {
        	 
        	 
        	
            if (!TTScene.sharedScene() || !TTScene.sharedScene()._hud)
            {
                return false;
            }
            
            var sharedQueue = TTDialogQueue.sharedQueue(); 
            if (sharedQueue.hasDialogsOpen())
            {
                sharedQueue.closeDialog();
                return true;
            }
            
            var sharedHud = TTHud.sharedHud();
            if (sharedHud._xbutton.getVisible() && sharedHud._xbutton.getAlpha() > 0)
            {
                sharedHud.onCloseClick();                
                return true;
            }
            
            //This case is when user want to exit of the game with the backButton
            TTScene.sharedScene()._playerData.saveToDisk();
            if (!playerData._readOnly)
            {
       	 		NSUserDefaults.standardUserDefaults().setObject(Core.Time.getRealTime() / 1000, "resignTime");
            }
        }
        return false;
    },

    _onLifecycleChange: function(/*Device.LifecycleEmitter.Event*/ event) 
    {
    	al_trace("----------------------------------------------------------------------- MSS : Event:: "+JSON.stringify(event));
    	
        switch(event) {
        case Device.LifecycleEmitter.Event.Suspend:
            this.applicationWillResignActive();
            break;
        case Device.LifecycleEmitter.Event.Resume:
            this.applicationDidBecomeActive();
            break;
        case Device.LifecycleEmitter.Event.Terminate:
            this.applicationWillTerminate();
            break;
        }
    },

    /**
     * Called when the application is about to terminate.
     */
    applicationWillTerminate: function() {
        al_trace("PFAppDelegate: applicationWillTerminate");
        TTScene.sharedScene()._playerData.saveToDisk();
        
        if (!playerData._readOnly)
        {
            if (TTScene.sharedScene().tipNumber() != -1 && dict_size(playerData._floors) < 4 && !loadingScreen) 
            {
                loadingScreen = new LoadingScreen();
            }
            NSUserDefaults.standardUserDefaults().setObject(Core.Time.getRealTime() / 1000, "resignTime");
        }
        
        
    },

    /**
     * Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions
     * (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
     * Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
     */
    applicationWillResignActive : function()
    {
        al_trace("TTAppDelegate: applicationWillResignActive " + SoundBoard.sfxEnabled); /// TODO TTT-27 ! 
        Device.OrientationEmitter.setInterfaceOrientation(Device.OrientationEmitter.Orientation.Portrait);
        /*TTScene.setPaused(true);*/
        
        if (SoundBoard.sfxEnabled) {
            SoundBoard.setMusicEnabled(false);
            SoundBoard.playMusic(false);
            SoundBoard.background();
            SoundBoard.setEnabled(false);
        }       
        
        var playerData = TTScene.sharedScene()._playerData;
        if (!playerData._readOnly)
        {
            if (TTScene.sharedScene().tipNumber() != -1 && dict_size(playerData._floors) < 4 && !loadingScreen) 
            {
                loadingScreen = new LoadingScreen();
            }
            
            NSUserDefaults.standardUserDefaults().setObject(Core.Time.getRealTime() / 1000, "resignTime");
        }
        
        /*TTScene.setAdVisible(false);*/
        SpriteFactoryCache.clearAnimationCache();
        SoundBoard.releaseSfx();
        TTScene.sharedScene()._playerData.saveToDisk();
    },
    
    /**
     * Restart any tasks that were paused (or not yet started) while the
     * application was inactive.
     */
    applicationDidBecomeActive : function()
    {
        Device.OrientationEmitter.setInterfaceOrientation(Device.OrientationEmitter.Orientation.Portrait);
        al_trace("TTAppDelegate: applicationDidBecomeActive ");
        
        // Background music
        var setting = NSUserDefaults.standardUserDefaults().objectForKey("setting-sfxOff");
        al_trace("TTAppDelegate: applicationDidBecomeActive ");

        if (setting == null) 
        {
        	al_trace("Setting was seted on True, because was not found on NSUserDefaults");
            setting = true;
        }
        	al_trace("<<TT>> DEBUG : Playing MUSIC " + setting);
            SoundBoard.setMusicEnabled(setting);
        	SoundBoard.playMusic(setting);
            SoundBoard.setEnabled(setting);
        
        var playerData = TTScene.sharedScene()._playerData;
        if (!playerData._readOnly)
        {            
            // If the tutorial hasn't been finished
            if (TTScene.sharedScene().tipNumber() != -1 && dict_size(playerData._floors) < 4)
            {
                var dlg = TTDialog.initWithMessage("\n\n\nHello again!\nWould you like to\nrestart the tutorial?", "restart,continue",
                function(dlg)
                {
                    if (dlg._buttonIndex == 0)
                    {
                        playerData.resetGame();
                    }
                }, this, null);
                TTDialogQueue.sharedQueue().addDialog(dlg);
            }
            
            var rt = NSUserDefaults.standardUserDefaults().doubleForKey("resignTime");
            al_trace("------------------------------------------------------------------------- MSS: RT: "+rt);
            if (rt > 0)
            {
                var elapsed = Core.Time.getRealTime() / 1000 - rt;
                if (elapsed > 1)
                {
                    TTScene.sharedScene().resumeWithTimeElapsed(elapsed);
                }
                
                NSUserDefaults.standardUserDefaults().setObject(0, "resignTime");
            }
            
            setTimeout(function()
            {
                al_trace("Hiding loading screen");
                if (loadingScreen)
                {
                    loadingScreen.destroy();
                    loadingScreen = null;
                }
            }.bind(this), 2000);
        }
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTSyncKeyValue'] = function(){var exports = $MODULE_REGISTRY['Code/TTSyncKeyValue'] || {}; $MODULE_REGISTRY['Code/TTSyncKeyValue'] = exports; var SyncKeyValue = require('Code/Utils/SyncKeyValue').SyncKeyValue;

/**
 * TinyTowers Singleton key value
 */
exports.TTSyncKeyValue = SyncKeyValue.singleton({
    classname: 'TTSyncKeyValue',
    
    initialize: function($super){
        $super('DefaultSyncKeyValue',
                ['cs','set']
        );
    }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTGameData'] = function(){var exports = $MODULE_REGISTRY['Code/TTGameData'] || {}; $MODULE_REGISTRY['Code/TTGameData'] = exports; exports.TTGameData = Core.Class.subclass({
    classname: "TTGameData",
    
    initialize : function()
    {
        this._lifeTimeCoins = 0;
        this._coins = 0;
        this._bux = 0;
        this._hearts = 0;
        this._paint = 0;
        this._elevator = 0;
        this._tip = 0;
        this._bitizens = {};
        this._floors = {};
        this._achievements = {};
        this._readOnly = false;
        this._loadingNeigthborInfo = false;
        // Load achievement descriptions
        this._achievementDescriptions = DataPreloader._achievements;
        
        // Rate my game
        this._userWasAskedToRateGame = 0;
        this._gameRatedByUser = false;
        
        // Mobage user
        var session = Social.US.Session.getCurrentSession();
        if (session)
        {
            this._user = session.user();
        }
    },
    
    destroy : function()
    {
        dict_delete(this._bitizens);
        dict_delete(this._floors);
        dict_delete(this._achievementDescriptions);
    },
    
    addCoins : function(amt)
    {
        this._coins = Math.floor(amt + this._coins);
        this._lifeTimeCoins = Math.floor(amt + this._lifeTimeCoins);
        
        TTScene.sharedScene()._hud.refresh();
        SoundBoard.playSfx(SFX_COINS);
    },
    
    addBux : function(amt)
    {
        this._bux = Math.floor(amt + this._bux);
        TTScene.sharedScene()._hud.refresh();
        SoundBoard.playSfx(SFX_BUX);
    },
    
    addHearts : function(amt)
    {
        this._hearts += amt;
        TTHud.sharedHud().refresh();
    },
    
    addBitizenInfo : function(info)
    {
        if (!this._bitizens[info._seed])
        {
            this._bitizens[info._seed] = info;
        }
        
        // Just in case.
        info._seed = Math.floor(info._seed);
        
        if (info._dreamFloor < 0)
        {
            al_trace("Choosing dream floor for bitizen seed: " + info._seed);
            
            // Choose a dream job
            var highestSkill = 0;
            var skilledTypes = [];
            for ( var s = 0; s < 5; s++)
            {
                var sk = TTBitizen.skillIn(s, info._seed);
                al_trace("skill: " + TTScene.floorTypeString(s) + " : " + sk);
                if (sk > highestSkill)
                {
                    highestSkill = sk;
                }
            }
            
            al_trace("highest skill is: " + highestSkill);
            for ( var s = 0; s < 5; s++)
            {
                var sk = TTBitizen.skillIn(s, info._seed);
                if (sk >= highestSkill)
                {
                    al_trace("Adding " + TTScene.floorTypeString(s) + " to high skills");
                    skilledTypes.push(s);
                }
            }
            
            if (skilledTypes.length)
            {
                var randHighSkillType = skilledTypes[std_rand() % skilledTypes.length];
                var dreamFloor = TTFloorTable.randomFloorWithType(randHighSkillType, false);
                info._dreamFloor = dreamFloor._fid;
                al_trace("dream floor: " + dreamFloor._name);
            }
        }
    },
    
    getBitizenInfo : function(seed)
    {
        return this._bitizens[seed];
    },
    
    removeBitizenInfo : function(seed)
    {
        if (this._bitizens[seed])
        {
            delete this._bitizens[seed];
        }
    },
    
    bitizensWithWorkFloor : function(work)
    {
        var retArr = [];
        for ( var aKey in this._bitizens)
        {
            var binfo = this._bitizens[aKey];
            if (binfo._workFloor == work)
            {
                retArr.push(binfo);
                if (retArr.length == 3)
                {
                    return retArr;
                }
            }
            
        }
        return retArr;
    },
    
    bitizensWithHomeFloor : function(home)
    {
        var retArr = [];
        for ( var aKey in this._bitizens)
        {
            
            var binfo = this._bitizens[aKey];
            if (binfo._homeFloor == home)
            {
                retArr.push(binfo);
                if (retArr.length == 5)
                {
                    return retArr;
                }
            }
            
        }
        return retArr;
    },
    
    bitizenCount : function()
    {
        return dict_size(this._bitizens);
    },
    
    addStoryInfo : function(info)
    {
        this._floors[info._story] = info;
    },
    
    getStoryInfo : function(story)
    {
        return this._floors[story];
    },
    
    storiesWithJobs : function()
    {
        // run through bitizens adding up work floors.
        var numFloors = dict_size(this._floors);
        var wstories = [];
        for ( var i = 0; i < numFloors + 1; i++)
        {
            al_trace("storiesWithJobs setup: " + i);
            wstories[i] = 0;
        }
        
        for ( var aKey in this._bitizens)
        {
            var binfo = this._bitizens[aKey];
            if (binfo._workFloor > 0 && binfo._workFloor <= dict_size(this._floors))
            {
                al_trace("Work floor: " + binfo._workFloor);
                wstories[binfo._workFloor]++;
                
                var wstory = this.getStoryInfo(binfo._workFloor);
                var wfloor = TTFloorTable.floorWithId(wstory._floorId);
                var bit = TTBitizen.initWithSeed(binfo._seed);
                al_trace(bit._name + " is worker #" + wstories[binfo._workFloor] + " at " + wfloor._name);
            }
        }
        
        //now go through and grab every non-residential story with a wcount < 3
        var retArr = [];
        for ( var aKey in this._floors)
        {
            var sinfo = this._floors[aKey];
            var fInfo = TTFloorTable.floorWithId(sinfo._floorId);
                        
            if (fInfo && fInfo._type != FLOOR_TYPE_RESIDENTIAL
                    && fInfo._fid != FLOOR_ID_CONSTRUCTION
                    && fInfo._fid != FLOOR_ID_EMPTY)
            {
                // grab worker count
                al_trace("worker count: " + wstories[sinfo._story]);
                if (wstories[sinfo._story] < 3)
                {
                    retArr.push(sinfo);
                }
            }
        }
        
        return retArr;
    },
    
    restoreConfirm : function(dlg)
    {
        if (dlg._buttonIndex == 1)
        {
            var gameStr = dlg._data;
            TTFloorTable.clearFloorTable();
            this.loadFromString(gameStr);
            TTScene.sharedScene().runActiveLayer(TTScene._towerLayer);
            TTScene.sharedScene().runTipLayer(null);
            TTScene.sharedScene().runMenuLayer(null);
            TTHud.sharedHud().refresh();
        }
    },
    
    resetGame : function()
    {
        dict_delete(this._floors);
        dict_delete(this._bitizens);
        dict_delete(this._achievements);
        
        // NOTE: Life time coins is meant to be accumulated in the installation life cycle
        /*this._lifeTimeCoins = 0*/
        this._coins = 0;
        this._bux = 0;
        this._hearts = 0;
        this._paint = 0;
        this._elevator = 0;
        this._tip = 0;
        this._bitizens = {};
        this._floors = {};
        this._achievements = {};
        
        // Rate my game
        // NOTE: The game is meant to be asked once in the installation life cycle
        /*
        this._userWasAskedToRateGame = 0;
        this._gameRatedByUser = false;*/
        
        this.saveToDisk(true);
        this.saveRemotely(true);
        this.returnFromNeighbor();
    },
    
    scheduleNotifications : function()
    {
        // FIXME
        throw new Error("TTGameData.scheduleNotifications: Method not implemented");
        /*
        al_trace("Scheduling notifications...");
        if (!UIApplication.sharedApplication().scheduleLocalNotification || this._readOnly)
        {
            return;
        }
        
        var notesOffSetting = NSUserDefaults.standardUserDefaults().valueForKey("setting-notesOff");
        if (notesOffSetting)
        {
            return;
        }
        
        var count = 0;
        
        // Schedule a notification for any story with an activeProduct
        var now = Core.Time.getRealTime();
        var soonestNote = null;
        for ( var aKey in this._floors)
        {
            var story = this._floors[aKey];
            if (story._activeProduct >= 0 && story._activeProduct < 3)
            {
                var floorInfo = TTFloorTable.floorWithId(story.floorId);
                if (floorInfo)
                {
                    var productInfo = floorInfo.products[story._activeProduct];
                    if (productInfo && story._prodStartTime + productInfo._time * 60 > now)
                    {
                        count++;
                        var localNotif = new UILocalNotification();
                        localNotif.fireDate = story._prodStartTime + productInfo._time * 60;
                        if (floorInfo._fid == FLOOR_ID_CONSTRUCTION)
                            localNotif.fireDate = story.prodStartTime + productInfo._time * 60 * ((story.sales[2] - 1) / 2.0);
                        localNotif._alertAction = "View Tower";
                        if (story._floorId == FLOOR_ID_CONSTRUCTION)
                        {
                            var newFloorId = story.sales[1];
                            var newFloorInfo = TTFloorTable.floorWithId(newFloorId);
                            localNotif._alertBody = "Construction of the " + (newFloorInfo ? newFloorInfo._name : "story") + " on floor " + story._story + " is finished!";
                            localNotif._soundName = "construction.wav";
                        }
                        else if (floorInfo._type == FLOOR_TYPE_RESIDENTIAL)
                        {
                            localNotif.alertBody = "Bedroom contstruction in " + floorInfo._name + " on floor " + story._story + " is finished!";
                            localNotif.soundName = "doorbell.wav";
                        }
                        else
                        {
                            localNotif.alertBody = "The " + floorInfo._name + " on floor " + story._story + " is ready to be re-stocked!";
                            localNotif.soundName = "doneBell.wav";
                        }
                        localNotif.applicationIconBadgeNumber = 0;
                        
                        if (soonestNote == null || localNotif.fireDate < soonestNote.fireDate)
                        {
                            soonestNote = localNotif;
                        }
                    }
                }
            }
        }
        if (soonestNote)
        {
            al_trace(sprintf("Scheduled notification: %s", soonestNote.alertBody));
            UIApplication.sharedApplication().scheduleLocalNotification(soonestNote);
        }*/
    },
    
    reportAchievementIdentifier : function(identifier, percent, cached)
    {
    	al_trace("reportAchievementIdentifier: ");
        if (this._readOnly)
        {
            return;
        }
        al_trace(sprintf("reportAchievementIdentifier: Attempting to report achievement: %s, %f, %s", identifier, percent, cached ? "(from cache)" : ""));
        var earned = this._achievements[identifier];
        //if ([ earned == "2" ] && !cached && percent >= 100)
    	if ([ earned == "1" ] && !cached && percent > 100)
        {
            al_trace("reportAchievementIdentifier: This achievement has already been earned.");
            return;
        }
        
        al_trace("reportAchievementIdentifier: reporting achievement: " + identifier);
    	var achievementPercentComplete = percent > 100.0 ? 100.0 : percent;
        
        // Check if this is being completed for the first time!
    	al_trace(sprintf("reportAchievementIdentifier: achievement.percentComplete: %f,", achievementPercentComplete));
        al_trace(sprintf("reportAchievementIdentifier: percent: "+achievementPercentComplete+"  earned: %s " , earned ));
    	if (achievementPercentComplete >= 100.0 && !earned)
        {
            // First time, pop-up congratulations
            var achName = this._achievementDescriptions[identifier];
            var dlg = TTDialog.initWithMessage(sprintf("\n\n\nCongratulations! You've unlocked the\n%s\nachievement!", achName), ",continue", null, null, null);
            TTDialogQueue.sharedQueue().addDialog(dlg);
           
            this._achievements[identifier] = "1";
        }
        al_trace("reportAchievementIdentifier: next step !");
    },
    
    checkCachedAchievements : function()
    {
        if (!TTScene.sharedScene().gameCenterEnabled || !GKLocalPlayer.localPlayer().isAuthenticated() || this._readOnly)
        {
            return;
        }
        
        var cacheStr = NSUserDefaults.standardUserDefaults().stringForKey("cachedAwards");
        if (cacheStr)
        {
            al_trace("CACHESTR: " + cacheStr);
            NSUserDefaults.standardUserDefaults().setObject(null, "cachedAwards");
            var pieces = cacheStr.split(";");
            for ( var i = 0; i < pieces.length; i++)
            {
                var piece = pieces[i];
                var comps = piece.split(":");
                if (comps.length == 2)
                {
                    var ident = comps[0];
                    var percent = comps[1];
                    this.reportAchievementIdentifier(ident, percent, true);
                }
            }
        }
    },
    
    checkPopAchievements : function()
    {
        if (this._readOnly)
        {
            return;
        }
        
        al_trace("Checking Population Achievements...");
        
        var bitizenCount = dict_size(this._bitizens);
        this.reportAchievementIdentifier("tiny_village", bitizenCount / 15 * 100, false);
        this.reportAchievementIdentifier("tiny_town", bitizenCount / 50 * 100, false);
        this.reportAchievementIdentifier("tiny_city", bitizenCount / 100 * 100, false);
        
        TTHud.sharedHud().refresh();
    },
    
    checkFloorAchievements : function()
    {
        if (this._readOnly)
        {
            return;
        }
        
        al_trace("Checking Floor Achievements...");
        al_trace("checkFloorAchievements: Checking Floor Achievements...");
        var floorCount = dict_size(this._floors);
        this.reportAchievementIdentifier("triskaidekaphobia", floorCount /13 * 100, false);
        this.reportAchievementIdentifier("first_quarter", floorCount / 25 * 100, false);
        this.reportAchievementIdentifier("five_oh", floorCount / 50 * 100, false);
        this.reportAchievementIdentifier("cloud_topper", floorCount / 100 * 100, false);
    },
    
    checkStockAchievements : function()
    {
        if (this._readOnly)
        {
            return;
        }
        
        al_trace("checkStockAchievements: Checking Stock Achievements...");
        var floorCount = TTFloorTable.floorCount();
        al_trace("floorCount: " + floorCount);
        var fstockMap = [];
        for ( var i = 0; i < floorCount; i++)
        {
            fstockMap[i] = false;
        }
        
        for ( var aKey in this._floors)
        {
            var sinfo = this._floors[aKey];
            var fInfo = TTFloorTable.floorWithId(sinfo._floorId);
            
            if (sinfo && fInfo && sinfo._stock[0] > 0 && sinfo._stock[1] > 0 && sinfo._stock[2] > 0)
            {
                al_trace(sprintf("floor %s (id %d) is fully stocked.", fInfo._name, Number(sinfo._floorId)));
                fstockMap[sinfo._floorId] = true;
            }
        }
        
        if (fstockMap[12] && fstockMap[14])
        {
            this.reportAchievementIdentifier("pizza_roll", 100, false);
        }
        if (fstockMap[65] && fstockMap[31])
        {
            this.reportAchievementIdentifier("funny_money", 100, false);
        }
        if (fstockMap[6] && fstockMap[55])
        {
            this.reportAchievementIdentifier("subpar", 100, false);
        }
        if (fstockMap[18] && fstockMap[87])
        {
            this.reportAchievementIdentifier("say_cheese", 100, false);
        }
        if (fstockMap[67] && fstockMap[85])
        {
            this.reportAchievementIdentifier("iglass", 100, false);
        }
        if (fstockMap[63] && fstockMap[19])
        {
            this.reportAchievementIdentifier("dance_fever", 100, false);
        }
        if (fstockMap[68] && fstockMap[76])
        {
            this.reportAchievementIdentifier("bookworm", 100, false);
        }
        if (fstockMap[27] && fstockMap[34])
        {
            this.reportAchievementIdentifier("field_trip", 100, false);
        }
        if (fstockMap[35] && fstockMap[1])
        {
            this.reportAchievementIdentifier("fish_tacos", 100, false);
        }
        if (fstockMap[36] && fstockMap[33])
        {
            this.reportAchievementIdentifier("blockbuster", 100, false);
        }
        if (fstockMap[73] && fstockMap[60])
        {
            this.reportAchievementIdentifier("keep_rollin", 100, false);
        }
        if (fstockMap[7] && fstockMap[97])
        {
            this.reportAchievementIdentifier("somethings_brewing", 100, false);
        }
        if (fstockMap[11] && fstockMap[23])
        {
            this.reportAchievementIdentifier("bar_fight", 100, false);
        }
        if (fstockMap[20] && fstockMap[9])
        {
            this.reportAchievementIdentifier("fortune_cookie", 100, false);
        }
        if (fstockMap[78] && fstockMap[70])
        {
            this.reportAchievementIdentifier("decked_out", 100, false);
        }
        if (fstockMap[88] && fstockMap[79])
        {
            this.reportAchievementIdentifier("fashionista", 100, false);
        }
        if (fstockMap[74] && fstockMap[32])
        {
            this.reportAchievementIdentifier("nerd_alert", 100, false);
        }
        if (fstockMap[38] && fstockMap[71])
        {
            this.reportAchievementIdentifier("stellar_record", 100, false);
        }
        if (fstockMap[26] && fstockMap[25])
        {
            this.reportAchievementIdentifier("dirty_laundry", 100, false);
        }
        if (fstockMap[96] && fstockMap[13])
        {
            this.reportAchievementIdentifier("desserted", 100, false);
        }
        if (fstockMap[4] && fstockMap[30])
        {
            this.reportAchievementIdentifier("cold_medicine", 100, false);
        }
        if (fstockMap[56] && fstockMap[94])
        {
            this.reportAchievementIdentifier("spike_in_sales", 100, false);
        }
        if (fstockMap[22] && fstockMap[77])
        {
            this.reportAchievementIdentifier("fat_quarter", 100, false);
        }
        if (fstockMap[16] && fstockMap[89])
        {
            this.reportAchievementIdentifier("cut_an_album", 100, false);
        }
        if (fstockMap[64] && fstockMap[84])
        {
            this.reportAchievementIdentifier("bet_the_pot", 100, false);
        }
        if (fstockMap[29] && fstockMap[82])
        {
            this.reportAchievementIdentifier("printer_ink", 100, false);
        }
        if (fstockMap[3] && fstockMap[93])
        {
            this.reportAchievementIdentifier("green_screen", 100, false);
        }
        if (fstockMap[95] && fstockMap[81])
        {
            this.reportAchievementIdentifier("joystick_junkie", 100, false);
        }
        if (fstockMap[17] && fstockMap[28])
        {
            this.reportAchievementIdentifier("r_r", 100, false);
        }
        if (fstockMap[90] && fstockMap[0])
        {
            this.reportAchievementIdentifier("oakinawa", 100, false);
        }
        if (fstockMap[2] && fstockMap[91])
        {
            this.reportAchievementIdentifier("tea_square", 100, false);
        }
        if (fstockMap[83] && fstockMap[5])
        {
            this.reportAchievementIdentifier("code_freeze", 100, false);
        }
        if (fstockMap[37] && fstockMap[24])
        {
            this.reportAchievementIdentifier("please_be_seated", 100, false);
        }
        if (fstockMap[21] && fstockMap[86])
        {
            this.reportAchievementIdentifier("an_eye_for_art", 100, false);
        }
        if (fstockMap[8] && fstockMap[61])
        {
            this.reportAchievementIdentifier("burger_bytes", 100, false);
        }
        if (fstockMap[92] && fstockMap[69])
        {
            this.reportAchievementIdentifier("designer_shoes", 100, false);
        }
        if (fstockMap[72] && fstockMap[75])
        {
            this.reportAchievementIdentifier("musical_chairs", 100, false);
        }
        if (fstockMap[62] && fstockMap[57])
        {
            this.reportAchievementIdentifier("nice_shot", 100, false);
        }
        if (fstockMap[10] && fstockMap[15])
        {
            this.reportAchievementIdentifier("rags_to_riches", 100, false);
        }
        if (fstockMap[66] && fstockMap[80])
        {
            this.reportAchievementIdentifier("amusements", 100, false);
        }
    },
    
    returnFromNeighbor : function()
    {
        al_trace("Return from neighbor...");
        
        this.loadGame(function() {
            // Hides loading screen
            setTimeout(function()
            {
                if (loadingScreen)
                {
                    loadingScreen.destroy();
                    loadingScreen = null;
                }
            }.bind(this), 2000);
            
            TTScene.sharedScene().runTipLayer(null);
            TTScene.sharedScene().runMenuLayer(null);
            
            TTHud.sharedHud().setTitle(null);
            TTHud.sharedHud().refresh();
            TTScene.sharedScene().runActiveLayer(new TTowerLayer(UNISAFE_WIDTH,UNISAFE_HEIGHT));
            
            RateGameController.checkOneTimeRateGame();
            
            this._readOnly = false;
            var rt = NSUserDefaults.standardUserDefaults().doubleForKey("resignTime");
            if (rt > 0)
            {
                var elapsed = Core.Time.getRealTime() / 1000 - rt;
                if (elapsed > 1)
                {
                    TTScene.sharedScene().resumeWithTimeElapsed(elapsed);
                }
                NSUserDefaults.standardUserDefaults().setObject(0, "resignTime");
            }
        }.bind(this));
    },
    
    /* Serialization */
    bitStrings : function()
    {
        var retStr = "bitizens{";
        for ( var aKey in this._bitizens)
        {
            var binfo = this._bitizens[aKey];
            retStr += binfo.toString() + ",";
        }
        retStr += "}";
        return retStr;
    },
    
    storyStrings : function()
    {
        var retStr = "stories{";
        for ( var aKey in this._floors)
        {
            var sinfo = this._floors[aKey];
            retStr += sinfo.toString() + ",";
        }
        
        retStr += "}";
        return retStr;
    },
    
    achStr : function()
    {
        var retStr = "";
        for ( var aKey in this._achievements)
        {
            retStr += aKey + ",";
        }
        al_trace("achStr: ++++++++++++++++++++  "+retStr)
        return retStr;
    },
    
    dataString : function()
    {
        return "ltc=" + this._lifeTimeCoins + ";"
            + "coins=" + this._coins + ";" 
            + "bux=" + this._bux + ";"
            + "paint=" + this._paint + ";"
            + "elv=" + this._elevator + ";"
            + "tip=" + this._tip + ";"
            + "ach=" + this.achStr() + ";"
            + "rate_asked=" + this._userWasAskedToRateGame + ";"
            + "rate_rated=" + this._gameRatedByUser + ";"
            + ";|" + this.bitStrings() + "|" + this.storyStrings();
    },    
    
    loadFromString : function(gameStr)
    {        
        al_trace("TTGameData.loadFromString: Loading " + gameStr);
        
        this._lifeTimeCoins = 0;
        this._coins = 0;
        this._bux = 0;
        this._hearts = 0;
        dict_delete(this._bitizens);
        dict_delete(this._floors);
        
        var pipes = gameStr.split("|");
        if (pipes.length > 0)
        {
            //coins & bux
            var pieces = pipes[0].split(";");
            for ( var p = 0; p < pieces.length; p++)
            {
                var piece = pieces[p];
                if (piece.indexOf("ltc=") == 0)
                {
                    this._lifeTimeCoins = Number(piece.split("=")[1]);
                }
                else if (piece.indexOf("coins=") == 0)
                {
                    this._coins = Number(piece.split("=")[1]);
                }
                else if (piece.indexOf("bux=") == 0)
                {
                    this._bux = Number(piece.split("=")[1]);
                }
                else if (piece.indexOf("paint=") == 0)
                {
                    this._paint = Number(piece.split("=")[1]);
                }
                else if (piece.indexOf("elv=") == 0)
                {
                    this._elevator = Number(piece.split("=")[1]);
                }
                else if (piece.indexOf("tip=") == 0)
                {
                    this._tip = Number(piece.split("=")[1]);
                }
                else if (piece.indexOf("ach=") == 0 && this._achievements)
                {
                    var earnedAchs = /*Number(*/piece.split("=")[1]/*)*/;
                    if (earnedAchs)
                    {
                        var achArr = earnedAchs.split(",");
                        for ( var i = 0; achArr && i < achArr.length; i++)
                        {
                            var achId = achArr[i];
                            if(!achId)
                        	{
                            	continue;
                        	}
                            
                            this._achievements[achId] = "1";
                        }
                    }
                }
                else if (piece.indexOf("rate_asked=") == 0)
                {
                    this._userWasAskedToRateGame = Number(piece.split("=")[1]);
                }
                else if (piece.indexOf("rate_rated=") == 0)
                {
                    var value = piece.split("=")[1];
                    this._gameRatedByUser = (value === "true");
                }
            }
        }
        for ( var i = 1; i < pipes.length; i++)
        {
            var pipe = pipes[i];
            if (pipe.indexOf("bitizens{") == 0)
            {
                var bitListStr = pipe.split("{")[1];
                var bitList = bitListStr.split(",");
                for ( var b = 0; b < bitList.length; b++)
                {
                    var bitStr = bitList[b];
                    var bitPieces = bitStr.split(";");
                    var bInfo = new TTBitizenInfo();
                    bInfo._homeFloor = -1;
                    bInfo._workFloor = -1;
                    bInfo._dreamFloor = -1;
                    bInfo._dreamed = false;
                    for ( var bp = 0; bitPieces && bp < bitPieces.length; bp++)
                    {
                        var bitPiece = bitPieces[bp];
                        if (bitPiece.indexOf("h=") == 0)
                        {
                            bInfo._homeFloor = Number(bitPiece.split("=")[1]);
                        }
                        else if (bitPiece.indexOf("w=") == 0)
                        {
                            bInfo._workFloor = Number(bitPiece.split("=")[1]);
                        }
                        else if (bitPiece.indexOf("d") == 0)
                        {
                            bInfo._dreamed = true;
                        }
                        else if (bitPiece.indexOf("s=") == 0)
                        {
                            bInfo._seed = Number(bitPiece.split("=")[1]);
                        }
                        else if (bitPiece.indexOf("j=") == 0)
                        {
                            bInfo._dreamFloor = bitPiece.split("=")[1];
                        }
                        else if (bitPiece.indexOf("vs=") == 0)
                        {
                            bInfo._vseed = Number(bitPiece.split("=")[1]);
                        }
                    }
                                        
                    if (bitPieces && bitPieces.length >= 3)
                    {
                        this.addBitizenInfo(bInfo);
                    }
                }
            }
            if (pipe.indexOf("stories{") == 0)
            {
                var storyListStr = pipe.split("{")[1];
                var storyList = storyListStr.split(",");
                for ( var b = 0; b < storyList.length; b++)
                {
                    var storyStr = storyList[b];
                    var storyPieces = storyStr.split(";");
                    var sInfo = new TTStoryInfo();
                    
                    sInfo._color[0] = [-1,-1,-1];
                    sInfo._color[1] = [-1,-1,-1];
                    sInfo._color[2] = [-1,-1,-1];
                    
                    for ( var sp = 0; storyPieces && sp < storyPieces.length; sp++)
                    {
                        var storyPiece = storyPieces[sp];
                        if (storyPiece.indexOf("s=") == 0)
                        {
                            sInfo._story = Number(storyPiece.split("=")[1]);
                        }
                        else if (storyPiece.indexOf("f=") == 0)
                        {
                            sInfo._floorId = Number(storyPiece.split("=")[1]);
                            if ((sInfo._floorId < 0 || sInfo._floorId >= TTFloorTable.floorCount()) && sInfo._floorId != LOBBY_ID)
                            {
                                al_trace(sprintf("***FLOOR ID: %d isn't one of the %d floors...", sInfo._floorId, TTFloorTable.floorCount()));
                                sInfo._floorId = FLOOR_ID_EMPTY;
                            }
                        }
                        else if (storyPiece.indexOf("a=") == 0)
                        {
                            sInfo._activeProduct = Number(storyPiece.split("=")[1]);
                           
                        }
                        else if (storyPiece.indexOf("pt=") == 0)
                        {
                            sInfo._prodStartTime = Number(storyPiece.split("=")[1]);
                        }
                        else if (storyPiece.indexOf("pr=") == 0)
                        {
                            sInfo._problem = Number(storyPiece.split("=")[1]);
                        }
                        else if (storyPiece.indexOf("sl=") == 0)
                        {
                            var salesStr = storyPiece.split("=")[1];
                            var sales = salesStr.split(":");
                            var fInfo = TTFloorTable.floorWithId(sInfo._floorId);
                            if (sales.length == 3)
                            {
                                for ( var s = 0; s < sales.length; s++)
                                {
                                    sInfo.sales()[s] = Number(sales[s]);
                                    if (fInfo && fInfo._type != FLOOR_TYPE_RESIDENTIAL && sInfo.sales()[s] >= 100)
                                    {
                                        this._hearts++;
                                    }
                                }
                            }
                        }
                        else if (storyPiece.indexOf("st=") == 0)
                        {
                            var stockStr = storyPiece.split("=")[1];
                            var stock = stockStr.split(":");
                            if (stock.length == 3)
                            {
                                for ( var s = 0; s < stock.length; s++)
                                {
                                    sInfo.stock()[s] = Number(stock[s]);
                                    if (sInfo.stock()[s] < 0)
                                    {
                                        sInfo.stock()[s] = 0;
                                    }
                                }
                            }
                        }
                        else if (storyPiece.indexOf("n=") == 0)
                        {
                            var newName = storyPiece.split("=")[1];
                            if (newName && newName.length > 0 &
                                sInfo._floorId != FLOOR_ID_EMPTY &&
                                sInfo._floorId != FLOOR_ID_CONSTRUCTION)
                            {
                                sInfo._name = newName;  // _nname changed to _name
                                var fInfo = TTFloorTable.floorWithId(sInfo._floorId);
                                if (fInfo)
                                {
                                    fInfo.setName(newName);
                                }
                            }
                        }
                        else if (storyPiece.indexOf("mr=") == 0)
                        {
                            var mrStr = storyPiece.split("=")[1];
                            var mr = mrStr.split(":");
                            if (mr.length == 3)
                            {
                                for ( var s = 0; s < mr.length; s++)
                                {
                                    sInfo._color[0][s] = Number(mr[s]);
                                    if (sInfo._color[0][s] < 0)
                                    {
                                        sInfo._color[0][s] = -1;
                                    }
                                }
                            }
                        }
                        else if (storyPiece.indexOf("mg=") == 0)
                        {
                            var mgStr = storyPiece.split("=")[1];
                            var mg = mgStr.split(":");
                            if (mg.length == 3)
                            {
                                for ( var s = 0; s < mg.length; s++)
                                {
                                    sInfo._color[1][s] = Number(mg[s]);
                                    if (sInfo._color[1][s] < 0)
                                    {
                                        sInfo._color[1][s] = -1;
                                    }
                                }
                            }
                        }
                        else if (storyPiece.indexOf("mb=") == 0)
                        {
                            var mbStr = storyPiece.split("=")[1];
                            var mb = mbStr.split(":");
                            if (mb.length == 3)
                            {
                                for ( var s = 0; s < mb.length; s++)
                                {
                                    sInfo._color[2][s] = Number(mg[s]);
                                    if (sInfo._color[2][s] < 0)
                                    {
                                        sInfo._color[2][s] = -1;
                                    }
                                }
                            }
                        }
                    }
                    if (storyPieces && storyPieces.length >= 6)
                    {
                        if (sInfo._story == 1)
                        {
                            sInfo._floorId = LOBBY_ID;
                        }
                                               
                        if(sInfo._color[0][0] == -1 || sInfo._color[0][1] == -1 || sInfo._color[0][2] == -1 
                                || sInfo._color[1][0] == -1 || sInfo._color[1][1] == -1 || sInfo._color[1][2] == -1
                                || sInfo._color[2][0] == -1 || sInfo._color[2][1] == -1 || sInfo._color[2][2] == -1)
                            arr_delete(sInfo._color);
      
                        this.addStoryInfo(sInfo);
                    }
                }
            }
        }
    },
    
    /* Persistence */       
    loadNeighbor : function(player, dlg)
    {
    	
        var onLoadNeighbor = function()
        {
        	al_trace("onLoadNeigthbor() : Storage.FileSystem.readFile() ");
            Storage.FileSystem.readFile("friend.txt", false, function(error, gameStr)
            {
                if (!error)
                {
                    al_trace("onLoadNeigthbor() : _readOnly = false;");
                    // Up the '_loadingNeigthborInfo' flag, trying to avoid an accidental saveData of the neighbor on our game.  TTT-110, (not confirmed)
                    this._loadingNeigthborInfo = true;
                    al_trace("onLoadNeigthbor() : _loadingNeigthborInfo = true");
                    
                	TTFloorTable.clearFloorTable();
                    
                    this.loadFromString(gameStr);
                    TTScene.sharedScene().runTipLayer(null);
                    TTScene.sharedScene().runMenuLayer(null);
                    TTHud.sharedHud().showCloseButton(true);
                    TTHud.sharedHud().showZoomButton(true);
                    TTHud.sharedHud().refresh();
                    
                    al_trace("onLoadNeigthbor() : _readOnly = true;");
                    this._readOnly = true;
                    // Up the '_loadingNeigthborInfo' flag, trying to avoid an accidental saveData of the neighbor on our game.  TTT-110, (not confirmed)   
                    this._loadingNeigthborInfo = false;
                    
                    al_trace("onLoadNeigthbor() : TTScene.sharedScene().runActiveLayer() ");
                    TTScene.sharedScene().runActiveLayer(new TTowerLayer(UNISAFE_WIDTH, UNISAFE_HEIGHT));
                }
                else
            	{
                	al_trace("onLoadNeigthbor() : Error !");
            	}
            }.bind(this));
        }.bind(this);
        
        al_trace("Data I/O:: SM: Loading neighbor tower: " + player.gamertag);
        this.saveToDisk();
        
        this.loadRemotely(player, function(dlg, friendGame)
        {
            if (friendGame)
            {
                al_trace("Data I/O: Game for player: " + player.gamertag + " loaded!");
                Storage.FileSystem.writeFile("friend.txt", friendGame, false, function(err)
                {
                    if (!err)
                    {
                        // save current game
                        NSUserDefaults.standardUserDefaults().setObject(Core.Time.getRealTime()/1000, "resignTime");
                        //FIXME: this.scheduleNotifications(); // Method not implemented yet.
                        dlg.destroy();
                        
                        setTimeout(onLoadNeighbor.bind(this), 1);
                        
                        // TTT-46 fix 2/2.
                        TTScene.sharedScene().runMenuLayer(null);
                    }
                    else
                    {
                        dlg.destroy();
                    }    
                }.bind(this));
            }
            else
            {
                dlg.destroy();
                var dlg = TTDialog.initWithMessage("\n\n\n\nThis neighbor is unavailable.", ",continue", null, null, null);
                TTDialogQueue.sharedQueue().addDialog(dlg);
                TTHud.sharedHud().setTitle(null);
            };
        }.bind(this, dlg));
    },
    
    canSave: function()
    {
        return !this._readOnly && !this._loadingNeigthborInfo && (TTScene.sharedScene().tipNumber() == -1 && dict_size(this._floors) >= 3);
    },
    
    saveRemotely : function(forceSave)
    {
        if (!this.canSave() && forceSave !== true)
        {
            al_trace("Data I/O: Not saving (remotely)");
            return;
        }
        else
        {
            al_trace("Data I/O: Saving conditions met.");
        }
        
        var timestamp = Core.Time.getRealTime()/1000;
        TTScene.sharedScene()._lastUpload = timestamp;
        
        // Save state
        var session = Social.US.Session.getCurrentSession();
        if (session)
        {
            var saveStr = this.dataString();
            al_trace("Data I/O: Saving (remotely) " + saveStr);
            
            var user = session.user();
            // Saves game state
            Social.US.AppData.setDataForUserWithKeyAndPermissions(saveStr, user, "saveGame",
                    Social.US.AppData.Permissions.PublicReadOnly, function(err)
            {
                // Saves life time coins
                Social.US.AppData.setDataForUserWithKeyAndPermissions("" + this._lifeTimeCoins, user, "lifeTimeCoins",
                        Social.US.AppData.Permissions.PublicReadOnly, function(err) {});
            }.bind(this));
        }
        else
        {
            al_trace("Data I/O: Cannot save remotely (no session available).");
        }
        
        // Save scoreboard
        ScoreManager.getLeaderboards(function(results)
        {
            results && ScoreManager.submitScore("Score", dict_size(this._floors));
        }.bind(this));
    },

    saveToDisk : function(forceSave)
    {
    	if(!forceSave)
		{
    		forceSave = false;
		}
    	
    	al_trace("Data I/O:: SAVETODISK: "+this.canSave()+ "  forceSave: "+forceSave);
    	if (!this.canSave() && forceSave !== true)
    	///if (!this.canSave() && forceSave === false)
        {
            al_trace("Data I/O:: Not saving (locally)");
            return;
        }
        else
        {
            al_trace("Data I/O:: Saving conditions met.");
        }
        
        var saveStr = this.dataString();
        al_trace("Data I/O: Saving (locally) " + saveStr);
        Storage.FileSystem.writeFile("game.txt", saveStr, false, function(err)
        {
            NSUserDefaults.standardUserDefaults().setObject("" + this._lifeTimeCoins, "lifeTimeCoins");
        }.bind(this));
    },

    // Loading
    loadGame: function(cb)
    {
        al_trace("Data I/O: ******** LOADING GAME ********");
        
        var recordID = obtainGamerID();
        var originalUser = NSUserDefaults.standardUserDefaults().objectForKey("originalUser");
               
        // Callback (this is executed afterwards)
        var onDataLoaded = function(callback, saveToDisk, result)
        {
            if (!originalUser || originalUser != recordID) {
                NSUserDefaults.standardUserDefaults().setObject(recordID, "originalUser");
                NSUserDefaults.standardUserDefaults().setObject(obtainGamerTag(), "originalAlias");
            }
            
            if (saveToDisk)
            {
             ///   setTimeout(this.saveToDisk.bind(this, true), 2000);
            }
            
            callback();
        }.bind(this);
        
        // Attempts to load the current user game state
        if (!originalUser || originalUser != recordID)
        {
            // Current user doesn't match the last user
            al_trace("Data I/O: loading data remotely for user");
            this.loadRemotely(null, onDataLoaded.bind(this, cb, true));
        }
        else
        {
            // Determines which state is newer: remote or local?
            var session = Social.US.Session.getCurrentSession();
            if (session)
            {
                var user = session.user();
                al_trace("Data I/O: Obtaining remote progress (for comparison)...");
                var localProgress = NSUserDefaults.standardUserDefaults().integerForKey("lifeTimeCoins");
                Social.US.AppData.getDataForUserWithKey(user, "lifeTimeCoins", function(error, response)
                {
                    al_trace_object(response, "Data I/O: response");
                    
                    if (error || !response || !response.data)
                    {
                        al_trace("Data I/O: loading data from disk for user " + originalUser + ". no remote ltc value found");
                        this.loadFromDisk(onDataLoaded.bind(this, cb, false));
                    }
                    else
                    {
                        var remoteProgress = Number(response.data);
                        if (remoteProgress && (remoteProgress > localProgress))
                        {
                            al_trace("Data I/O: loading data remotely for user " + originalUser + ". remote state is newer");
                            this.loadRemotely(null, onDataLoaded.bind(this, cb, true));
                        }
                        else
                        {
                            al_trace("Data I/O: loading data from disk for user " + originalUser + ". disk version is newer");
                            this.loadFromDisk(onDataLoaded.bind(this, cb, false));
                        }
                    }
                }.bind(this));
            }
            else
            {
                al_trace("Data I/O: loading data from disk. no session found");
                this.loadFromDisk(onDataLoaded.bind(this, cb, false));
            }
        }
    },
    
    loadFromDisk : function(callback)
    {
        var retries = 0;
        var finish = false;
        
        function onResponse(error, content)
        {
            if (error || !content || content.length == 0)
            {               
                al_trace("Data I/O: Couldn't read file contents. Error: " + error);
                retries++;
                if (retries == 3)
                {
                    al_trace("Data I/O: Retries exceeded. Attempting to load from backup");
                    finish = true;
                    
                    this.loadRemotely(null, callback);
                }
            }
            else
            {   
                al_trace("Data I/O: Reading file contents...");
                finish = true;
                this.loadFromString(content);               
                callback(content);
            }
            
            if (!finish)
            {
                al_trace("Data I/O: Looping");
                setTimeout(function()
                {
                    Storage.FileSystem.readFile("game.txt", false, onResponse.bind(this));
                }.bind(this), 3000);
            }
        }
        
        Storage.FileSystem.readFile("game.txt", false, onResponse.bind(this));
    },
   
    loadRemotely: function(user, callback)
    {
        var session = Social.US.Session.getCurrentSession();
        if (session)
        {
            if (!user)
            {                
                user = session.user();
            }
            
            // Get keys
            var retries = 0;
            var finish = false;
            
            function onResponse(error, response)
            {
                if (error || !response || !response.data || response.data.length == 0)
                {
                    al_trace("Data I/O: Error while loading key. Error: " + error);
                    retries++;
                    if (retries == 3)
                    {
                        al_trace("Data I/O: Retries exceeded. Loading defaults");
                        finish = true;
                        callback(null);
                    }
                }
                else
                {
                    al_trace("Data I/O: Key loaded");
                    finish = true;
                    this.loadFromString(response.data);
                    callback(response.data);
                }
                
                if (!finish)
                {
                    al_trace("Data I/O: Looping");
                    setTimeout(function()
                    {
                        Social.US.AppData.getDataForUserWithKey(user, "saveGame", onResponse.bind(this));
                    }.bind(this), 3000);
                }
            };
            
            al_trace("Data I/O: Attempting to load key");
            Social.US.AppData.getDataForUserWithKey(user, "saveGame", onResponse.bind(this));
        }
        else
        {
            // No session, cannot load remotely.
            al_trace("Data I/O: No Mobage session available");
            callback(null);
        }
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTScene'] = function(){var exports = $MODULE_REGISTRY['Code/TTScene'] || {}; $MODULE_REGISTRY['Code/TTScene'] = exports; exports.TTScene = BaseClass.singleton({
    classname: "TTScene",
    
    initialize: function() {
        // Resolution and aspect ratio
        this._workingArea = this.getWorkingArea();
        
        this._background = TTSpriteFactory.spriteWithFile("1pxblack.png");
        this._background.setScale(UI.Window._width, UI.Window._height);
        GL2.Root.addChild(this._background);
        
        this._node.setScale([ this._workingArea.scaleX, this._workingArea.scaleY ]);
        this._node.setPosition(this._workingArea.offsetX, this._workingArea.offsetY);
        GL2.Root.addChild(this._node);
        
        srandom(Core.Time.getRealTime());
        this._playerData = new TTGameData();
        
        // ACTIVE LAYER
        this._activeLayer = new GL2.Node();
        this.getNode().addChild(this._activeLayer);
        
        // MENU LAYER
        this._menuLayer = new GL2.Node();
        this.getNode().addChild(this._menuLayer);
        
        // HUD
        this._hud = new TTHud(UNISAFE_WIDTH, UNISAFE_HEIGHT);
        this.getNode().addChild(this._hud.getNode());
                
        // DIALOG
        this._dialogQueue = new TTDialogQueue(UNISAFE_WIDTH, UNISAFE_HEIGHT);
        this.getNode().addChild(TTDialogQueue.sharedQueue()._node);
    },
    
    $shadeLayer : function(/* bool*/ flag, /*bool*/ killEmAll)
    {
    	if(this._towerLayer)
		{
    		this._towerLayer.setShadeLayer(flag,killEmAll);
		}
    },
    
    destroy: function()
    {
    },
    
    $sharedScene: function() 
    {
        return this;
    },
 
    getWorkingArea : function() {
        var result = {
            offsetX : 0,
            offsetY : 0,
            scaleX : UI.Window._width / UNISAFE_WIDTH,
            scaleY : UI.Window._height / UNISAFE_HEIGHT
        };

        result.scaleX = Math.min(result.scaleX, result.scaleY);
        result.scaleY = result.scaleX;
        result.width = result.scaleX * UNISAFE_WIDTH;
        result.height = result.scaleY * UNISAFE_HEIGHT;
        result.offsetX = Math.floor((UI.Window._width - result.width) / 2);
        result.offsetY = Math.floor((UI.Window._height - result.height) / 2);
        
        result.screenWidth = 1 / result.scaleX * UI.Window._width;
        result.screenHeight = 1 / result.scaleY * UI.Window._height;

        return result;
    },
    
    $timeString: function(seconds) {
        
    	seconds = parseInt(seconds);
        if (seconds < 0) {
            return "DONE!";
        }
        
        var minLeft = Math.floor(seconds/60);
        
        if (minLeft > 60*24)
        {
            return sprintf((minLeft/60)%24==0?"%dd":"%dd, %dh",minLeft/(60*24), (minLeft/60)%24);
        }
        else if(minLeft > 60)
        {
            return sprintf(minLeft%60==0?"%dh":"%dh, %dm",minLeft/60,minLeft%60);
        }
        else if (minLeft == 0)
        {
            return "< 1m";
        }
        else
        {
            return sprintf("%dm",minLeft).toUpperCase();
        }
    },
    
    costForProdTime: function(minutes) {
        return this.saleForProdTime(minutes) * 0.9;
    },
    
    costForProdTimeBonus: function(minutes, wBonus) {
        var price = TTScene.costForProdTime(minutes);
        price -= (price*wBonus/100.0);
        return Math.floor(price);
    },
    
    quantityForProdTime: function(minutes) {
        return Math.floor(15*minutes);
    },
    
    saleForProdTime: function(minutes) {
        return Math.floor(10*minutes);
    },
    
    profitForProdTime: function(minutes) {
        return Math.floor(this.saleForProdTime(minutes) - this.costForProdTime(minutes));
    },
    
    _draw: function()
    {
        if (!this._playerData._readOnly)
        {
            var localTime = Core.Time.getRealTime()/1000;
            if (!this._lastUpload)
            {
                this._lastUpload = localTime + BACKUP_RATE_SECONDS;
            }
            
            var difference = Math.abs(localTime - this._lastUpload);
            if (difference > BACKUP_RATE_SECONDS)
            {               
                if (this._playerData.canSave())
                {
                    al_trace("Data I/O: Auto saving (interval)...");
                    this._playerData.saveRemotely();
                    this._playerData.saveToDisk();
                }
                else 
                {
                    al_trace("Data I/O: Couldn't save. Retrying in " + BACKUP_RATE_SECONDS);
                    this._lastUpload = localTime; 
                }
            }
        }
    },
    
    $floorTypeString: function(type) {
        type = parseInt(type);
        var ftype = "";
        switch (type) {
            case FLOOR_TYPE_FOOD:
                ftype = "FOOD";
                break;
            case FLOOR_TYPE_SERVICE:
                ftype = "SERVICE";
                break;
            case FLOOR_TYPE_ENTERTAINMENT:
                ftype = "RECREATION";
                break;
            case FLOOR_TYPE_RETAIL:
                ftype = "RETAIL";
                break;
            case FLOOR_TYPE_CREATIVE:
                ftype = "CREATIVE";
                break;
            case FLOOR_TYPE_RESIDENTIAL:
                ftype = "RESIDENTIAL";
                break;
            default:
                break;
        }
        
        return ftype;
    },    
    
    $floorTypeSound: function(type) {
        var fsound = -1;
        type = parseInt(type);
        switch (type) {
            case FLOOR_TYPE_FOOD:
                fsound = SFX_FOCUS_FOOD;
                break;
            case FLOOR_TYPE_SERVICE:
                fsound = SFX_FOCUS_SERVICE;
                break;
            case FLOOR_TYPE_ENTERTAINMENT:
                fsound = SFX_FOCUS_RECREATION;
                break;
            case FLOOR_TYPE_RETAIL:
                fsound = SFX_FOCUS_RETAIL;
                break;
            case FLOOR_TYPE_CREATIVE:
                fsound = SFX_FOCUS_CREATIVE;
                break;
            case FLOOR_TYPE_RESIDENTIAL:
                fsound = SFX_DOORBELL;
                break;
            default:
                break;
        }
        
        return fsound;  
    },
    
    $floorTypeColor: function(type) {
        var fcolor = new Core.Color(1,1,1);
        
        switch (parseInt(type)) {
            case 0:
                fcolor = new Core.Color(106/255,250/255,66/255);
                break;
            case 1:
                fcolor = new Core.Color(64/255,198/255,249/255);
                break;
            case 2:
                fcolor = new Core.Color(246/255,250/255,165/255);
                break;
            case 3:
                fcolor = new Core.Color(226/255,111/255,255/255);
                break;
            case 4:
                fcolor = new Core.Color(251/255,117/255,66/255);
                break;
            case 5:
                fcolor = new Core.Color(1,1,1);
                break;
            default:
                break;
        }
        return fcolor;
    },
    
    resumeWithTimeElapsed: function(time) {
        al_trace("TTScene.resumeWithTimeElapsed");
        
        if (this._activeLayer._children.length == 0) {
            return;
        }
        
        var activeChild = this._activeLayer._children[0];
        if (activeChild && activeChild._AL_owner && activeChild._AL_owner.resumeWithTimeElapsed) {
            activeChild._AL_owner.resumeWithTimeElapsed(time);
        }
        
        if ((Core.Time.getRealTime()/1000) - this._lastUpload > BACKUP_RATE_SECONDS)
        {
            this._playerData.saveRemotely();
        }
        
        // Check for cached achievements
        this._playerData.checkCachedAchievements();
    },

    runActiveLayer: function(layer) {
        if (this._activeLayer._children.length > 0)
        {
            al_trace("TTScene.runActiveLayer: cleaning up");
            this._activeLayer.AL_destroyAllChildrenWithCleanup(true, true, true);
        }
        
        if (layer) {
            this._towerLayer = layer;
            this._activeLayer.addChild(layer._node);
        }
    },

    runMenuLayer: function(layer) {
        if (this._menuLayer._children.length > 0)
        {
            al_trace("TTScene.runMenuLayer: cleaning up");
            this._menuLayer.AL_destroyAllChildrenWithCleanup(true, true, true);
        }
        
        TTHud.sharedHud().showCloseButton(false);
        if (layer)
        {
        	layer.setTouchTargetToScreenSize();
            this._menuLayer.addChild(layer._node);
            TTHud.sharedHud().showCloseButton(true);
            TTHud.sharedHud().showZoomButton(false);
            SoundBoard.playSfx(SFX_LIGHTSWITCH);
        }
        else
        {
            if (this._towerLayer)
            {
                if (this._playerData._readOnly && !this._towerLayer.isZoomedOut())
                {
                    this._playerData.returnFromNeighbor();
                }
                
                if (!this._towerLayer.isZoomedOut())
                {
                    TTHud.sharedHud().showZoomButton(true);
                }
            }
        }
    },

    runTipLayer: function(layer) {
        if (this._tipLayer) {
            this._tipLayer.destroy();
            this._tipLayer = null;
        }
        if (layer) {
            this._tipLayer = layer;
            this.getNode().addChild(this._tipLayer._node);
        }
    },

    $tipNumber: function() {
        if (this._tipLayer)
        {
            return this._tipLayer._tipNum;
        }
        else
        {
            return -1;
        }
    },

    removeBitizenFromFloors: function(seed) {
        var activeChild = this._activeLayer._children[0];
        if (activeChild && activeChild._AL_owner.removeBitizenWithSeed) {
            activeChild._AL_owner.removeBitizenWithSeed(seed);
        }
    },

    addBitizen: function(seed, story) {
        var activeChild = this._activeLayer._children[0];
        if (activeChild._AL_owner && activeChild._AL_owner.addBitizen) {
            activeChild._AL_owner.addBitizen(seed, story);
        }
    },

    recordTimeOfDay: function() {
        var currentDate = new Date();
        this._isDay = currentDate.getHours() > 5 && currentDate.getHours() < 12+7;
    },
    
    isDayTime: function() {
        return this._isDay;
    },

    recordDayOfYear: function() {
        var currentYear = (new Date()).getFullYear();
        var jan01 = new Date(currentYear, 0, 1);
        this._dayOfYear = Math.ceil((new Date() - jan01) / 86400000);
        
        al_trace("dayOfYear: " + this._dayOfYear);
        
        var lastBdayCheck = NSUserDefaults.standardUserDefaults().integerForKey("lastBdayCheck");
        if (this._dayOfYear > lastBdayCheck)
        {
            this._bDaysChecked = false;
        }
        else
        {
            this._bDaysChecked = true;
        }
        
        NSUserDefaults.standardUserDefaults().setObject(this._dayOfYear, "lastBdayCheck");
    },
    
    shouldCheckBirthdays: function() {
        return !this._bDaysChecked;
    },

    startTransaction: function(productId)
    {
        if (!this._paymentController) { 
            this._proShopOpen = TTDialog.initWithMessage("\n\n\n\n\nCONTACTING SERVER...", ",", null, null, null);
            TTDialogQueue.sharedQueue().addDialog(this._proShopOpen);
            
            this._paymentController = new PaymentController(this.finishTransaction.bind(this), this.processTransaction.bind(this), this.cancelTransaction.bind(this));
            this._paymentController.createSimpleTransaction(productId, "");
        } else {
            // This should never happen
            if (this._proShopOpen) {
                this._proShopOpen.destroy();
                this._proShopOpen = null;
            }
            
            var dlg = TTDialog.initWithMessage("\n\nAn existing purchase is being processed.", ",continue", null, null, null);
            TTDialogQueue.sharedQueue().addDialog(dlg);
        }
    },
    
    processTransaction: function(transaction) {
        al_trace("processtransactioncallback: tx dump - " + JSON.stringify(transaction));
        
        var productId = transaction.item.sku;
        var global = TTScene.sharedScene()._playerData;
        if (productId == "debit:ttbux10") {
            global.addBux(10);
        }
        else if (productId == "debit:ttbux100") {
            global.addBux(100);
        }
        else if (productId == "debit:ttbux1000") {
            global.addBux(1000);
        }
        
        if (this._proShopOpen) {
            this._proShopOpen.destroy();
            this._proShopOpen = null;
        }
        
        if (this._paymentController)
        {
            this._paymentController.closeTransaction(transaction);
        }
        else
        {
            this.cancelTransaction();
        }
    },
    
    cancelTransaction : function(error, data)
    {
        if (error && error.description != "usercanceled")
        {
            al_trace("Server-side bank service returned error: " + JSON.stringify(error));
            
            var tempMessage = new UI.AlertDialog();
            tempMessage.setTitle("Purchase cancelled");
            tempMessage.setText("Oops! We seem to be having issues. Please try again later.");
            tempMessage.setChoices(["OK"]);
            tempMessage.setOnChoice(function()
            { 
                tempMessage.hide();
                // Added for avoid the Server Error and 'eternal lock' of the game on the contacting server dialog. 
                if (this._proShopOpen) {
                    this._proShopOpen.destroy();
                    this._proShopOpen = null;
                    this._paymentController = null;
                }
                // end of fix.
                
            }.bind(this));
            tempMessage.show();
        }
        else
        {
            if (this._proShopOpen)
            {
                this._proShopOpen.destroy();
                this._proShopOpen = null;
                
                var dlg = TTDialog.initWithMessage("\n\n\n\nPurchase cancelled.", ",continue", null, null, null);
                TTDialogQueue.sharedQueue().addDialog(dlg);
            }
            
            this._paymentController = null;
        }
    },
    
    finishTransaction : function()
    {
        this._paymentController = null;
        TTScene.sharedScene()._playerData.saveToDisk();
        var dlg = TTDialog.initWithMessage("\n\n\n\nNimbleBit sincerely thanks you for your purchase!", ",continue", null, null, null);
        TTDialogQueue.sharedQueue().addDialog(dlg);
        this.runMenuLayer(null);
    },
    
    showProShop : function()
    {
        this._proShopOpen = TTDialog.initWithMessage("\n\n\n\n\nCONTACTING SERVER...", ",", null, null, null);
        TTDialogQueue.sharedQueue().addDialog(this._proShopOpen);
        
        var productIds = [ "ttbux10", "ttbux100", "ttbux1000" ];
        var results = new Array(productIds.length);
        var success = true;
        
        var onProductsLoaded = function()
        {
            if (this._proShopOpen)
            {
                this._proShopOpen.destroy();
                this._proShopOpen = null;
            }
            
            this.runMenuLayer(TTBuxLayer.initWithProducts(results));
        };
        
        var onProductsLoadFailed = function()
        {
            if (this._proShopOpen)
            {
                this._proShopOpen.destroy();
                this._proShopOpen = null;
            }
            
            var dlg = TTDialog.initWithMessage("\n\nThe bux store is currently unavailable.", ",continue", null, null, null);
            TTDialogQueue.sharedQueue().addDialog(dlg);
            this.runMenuLayer(null);
        };
        
        var productLoadedCallback = function(i, error, data)
        {
            if (error)
            {
                success = false;
            }
            else
            {
                results[i] = data;
            }
        };
        
        for ( var i = 0; i < productIds.length; i++)
        {
            Bank.Inventory.getItem(productIds[i], productLoadedCallback.bind(this, i));
        }
        
        var timeoutProductLoad = 20000;// ten seconds
        function checkResult(loadedCallback, failedCallback)
        {
            timeoutProductLoad -= 1000;
            if (success == false || timeoutProductLoad <= 0)
            {
                failedCallback();
            }
            else
            {
                for ( var i = 0; i < results.length; i++)
                {                    
                    if (!results[i])
                    {
                        al_trace('bux: retrying');
                        setTimeout(checkResult.bind(this, loadedCallback, failedCallback), 1000);
                        return;
                    }
                }
                
                al_trace('bux: products loaded');
                loadedCallback();
            }
        }
        
        setTimeout(checkResult.bind(this, onProductsLoaded.bind(this), onProductsLoadFailed.bind(this)), 1000);
    }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTHud'] = function(){var exports = $MODULE_REGISTRY['Code/TTHud'] || {}; $MODULE_REGISTRY['Code/TTHud'] = exports; exports.TTHud = BaseClass.subclass({
    classname : 'TTHud',
    initialize : function(width, height)
    {
        //Bottom HUD
        var bottomOffset = (this.__size.getHeight() - height) / 2;
        // FlankOffset
        this.flankOffset = (this.__size.getWidth() - width) / 2;
        
        var narrowSideSize = width<height? width:height; 
        // Bar
        this._bar = TTSpriteFactory.spriteWithFile_withAnchor('menu_bar.png', [ 0, 1 ]);
        this._bar.setPosition(0, height + bottomOffset);
        this._node.addChild(this._bar);
        
        // mbutton
        this._mbutton = TTSpriteFactory.spriteWithFile_withAnchor('menu_button.png', [ 1, 1 ]);
        this._mbutton.setPosition(width, height + bottomOffset);
        this._node.addChild(this._mbutton);
        
        // xbutton
        this._xbutton = TTSpriteFactory.spriteWithFile_withAnchor('menu_close.png', [ 1, 1 ]);
        this._xbutton.setPosition(width, height + bottomOffset + 6);
        this._node.addChild(this._xbutton);
        this._xbutton.setVisible(false);
        
        // TITLE BAR
        this._titleBar = TTSpriteFactory.spriteWithFile('topslice.png');
        var titleBarSize = this._titleBar.AL_getSize();
        this._titleBar.setPosition(0, -bottomOffset);
        this._titleBar.setScale(UNISAFE_WIDTH / (titleBarSize.getWidth()), 1);
        this._node.addChild(this._titleBar);
        
        this._titleLabel = LabelConfigurer.createLabelWithString("TITLE", "silkscreen", FONT14, [ 0.5, 0.5 ], true);
        
		var _scale = this._titleLabel.getScale();
        this._titleLabel.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        //this._titleLabel.setPosition(width / 2, titleBarSize.getHeight()-bottomOffset);
        this._titleLabel.setPosition(width / 2, titleBarSize.getHeight() / 2-bottomOffset);
        this._titleBar.setVisible(false);
        this._titleLabel.setVisible(false);
        this._node.addChild(this._titleLabel);
        
        // popBg
        this._popBg = TTSpriteFactory.spriteWithFile('top_pop.png');
        this._popBg.setPosition(+narrowSideSize*MOBAGE_ICON_SIZE_FACTOR - this.flankOffset, -bottomOffset);
        this._node.addChild(this._popBg);
        
        // zoom button
        this._zbutton = TTSpriteFactory.spriteWithFile('top_zoom.png');
        this._zbutton.setPosition(this._popBg.getPosition().getX() -narrowSideSize*MOBAGE_ICON_SIZE_FACTOR  , this._popBg.getPosition().getY() + /*26*/ + narrowSideSize*MOBAGE_ICON_SIZE_FACTOR /*- this._popBg.AL_getSize().getHeight()*/);
        this._node.addChild(this._zbutton);
        
        // heartBg
        this._heartBg = TTSpriteFactory.spriteWithFile_withAnchor('top_hearts.png', [ 1, 0 ]);
        this._heartBg.setPosition(width, 0-bottomOffset);
        this._node.addChild(this._heartBg);
        
        // Labels
        this._coinLabel = LabelConfigurer.createLabelWithString("100", "silkscreen", FONT17, [ 0, 0.5 ], true);

        
        this._coinLabelPosOrig = [15*2, (-this._bar.AL_getSize().getHeight()/2/2 + 1)*2]; 

        this._coinLabel.setPosition(this._coinLabelPosOrig);
        this._coinLabelPos = this._coinLabel.getPosition();
        
        
        
		var _scale = this._coinLabel.getScale();
        this._coinLabel.setScale(_scale.getX()*FONTSCALE17, _scale.getX()*FONTSCALE17);
        
        this._coinValue = -1;
        this._bar.addChild(this._coinLabel);
        
        this._coinLabelAnim = LabelConfigurer.createLabelWithString("0", "silkscreen", FONT18, [ 0, 1 ], true);
        this._coinLabelAnim.setPosition(15*2, (-this._bar.AL_getSize().getHeight()/2/2 + 1)*2);
        
		var _scale = this._coinLabelAnim.getScale();
        this._coinLabelAnim.setScale(_scale.getX()*FONTSCALE18, _scale.getX()*FONTSCALE18);
        
        this._bar.addChild(this._coinLabelAnim);
        this._coinLabelAnim.setVisible(false);
        
        this._buxLabel = LabelConfigurer.createLabelWithString("0", "silkscreen", FONT18, [ 0, 0.5 ], true);
        this._buxLabel.setPosition((this._bar.AL_getSize().getWidth()/2/2 + 10)*2, (-this._bar.AL_getSize().getHeight()/2/2 + 1)*2);

        
		var _scale = this._buxLabel.getScale();
        this._buxLabel.setScale(_scale.getX()*FONTSCALE18, _scale.getX()*FONTSCALE18);

        this._bar.addChild(this._buxLabel);
        this._buxLabelPos = this._buxLabel.getPosition().clone();
        
        this._popLabel = LabelConfigurer.createLabelWithString("0", "silkscreen", FONT18, [ 0, 0.5 ], true);
        this._popLabel.setPosition(9*2, this._popBg.AL_getSize().getHeight()/2/2*2);

        
		var _scale = this._popLabel.getScale();
        this._popLabel.setScale(_scale.getX()*FONTSCALE18, _scale.getX()*FONTSCALE18);

        this._popBg.addChild(this._popLabel);
        
        this._heartLabel = LabelConfigurer.createLabelWithString("0", "silkscreen", FONT18, [ 0, 0.5 ], true);
        this._heartLabel.setPosition((-this._heartBg.AL_getSize().getWidth()/2 + 10)*2, this._heartBg.AL_getSize().getHeight()/2/2*2);
        
		var _scale = this._heartLabel.getScale();
        this._heartLabel.setScale(_scale.getX()*FONTSCALE18, _scale.getX()*FONTSCALE18);

        this._heartBg.addChild(this._heartLabel);
        
        // Enable input
        this.setTouchTargetToScreenSize();
    },
    
    setTitle : function(/*String*/titleStr)
    {
        if (titleStr)
        {
            this._titleLabel.setText(titleStr);
            this._titleBar.setVisible(true);
        }
        else
        {
            this._titleBar.setVisible(false);
        }
        this._titleLabel.setVisible(this._titleBar.getVisible());
    },
    
    showCloseButton : function(/*Boolean*/vis)
    {
        if (this._xbutton)
        {
            this._xbutton.setVisible(vis);
        }
    },
    
    showZoomButton : function(/*Boolean*/vis)
    {
        if (this._zbutton)
        {
            this._zbutton.setVisible(vis);
        }
    },
    
    setCloseCallback : function(/*SEL*/selector, /*id*/target)
    {
        this._closeTarget = target;
        this._closeSelector = selector;
    },
    
    animateCoinAmt : function(amt)
    {
        if (amt != 0)
        {
            numStr = Math.abs(amt);
            this._coinLabelAnim.setText(numberAddCommas((amt > 0 ? '+' : '-') + numStr));
            if (amt < 0)
            {
                this._coinLabelAnim.setColor(251 / 255, 117 / 255, 66 / 255);
            }
            else
            {
                this._coinLabelAnim.setColor(1, 1, 1);
            }
            this._coinLabelAnim.stopAllActions();
            
            this._coinLabelAnim.setPosition(this._coinLabelPos.getX(), this._coinLabelPos.getY() - 4*2);
            this._coinLabelAnim.setAlpha(1);
            this._coinLabelAnim.setVisible(true);
            this._coinLabelAnim.runAction(Action.Sequence.actions(Action.FadeOut.actionWithDuration(2.0), Action.Hide.action(), null));
            this._coinLabelAnim.runAction(Action.MoveBy.actionWithDuration(2.0, new Core.Point(0, -40*2)));
        }
    },
    
    refresh : function()
    {
        var gd = TTScene.sharedScene()._playerData;
        newCoinStr = gd._coins;
        
        if (newCoinStr != this._coinLabel.getText())
        {
            this._coinLabel.stopAllActions();
            this._coinLabel.setPosition(this._coinLabelPosOrig);
            this._coinLabel.runAction(Action.Sequence.actions(Action.MoveBy.actionWithDuration(0.1, new Core.Point(0, 2)), Action.MoveBy.actionWithDuration(0.1, new Core.Point(0, -2)), null));
            this._coinValue = gd._coins;
        }
        newCoinStr = newCoinStr!=0?newCoinStr:"0"; //FIXME, utilizar sprintf mejor?? 
        this._coinLabel.setText(""+numberAddCommas(newCoinStr));
        newBuxStr = gd._bux;
        if (newBuxStr != this._buxLabel.getText())
        {
            this._buxLabel.stopAllActions();
            this._buxLabel.setPosition(this._buxLabelPos);
            this._buxLabel.runAction(Action.Sequence.actions(Action.MoveBy.actionWithDuration(0.1, new Core.Point(0, 2)), Action.MoveBy.actionWithDuration(0.1, new Core.Point(0, -2)), null));
        }
        
        this._buxLabel.setText("" + numberAddCommas(newBuxStr));
        this._heartLabel.setText("" + dict_size(gd._floors));
        this._popLabel.setText("" + dict_size(gd._bitizens));
    },
    
    _ccTouchesBegan : function(/*GL2.Touch*/touchEvent)
    {
        al_trace('HUD Touch');
        al_trace('menu children ' + TTScene._menuLayer._children.length );
        var tp = this._node.screenToLocal(touchEvent.getPosition());
        if (this._xbutton.getVisible() && CGRectContainsPoint(createBB(this._xbutton), tp))
        {
            this._xbutton.setColor(128 / 255, 128 / 255, 128 / 255);
        }
        else if (CGRectContainsPoint(createBB(this._mbutton), tp) && TTScene.sharedScene()._towerLayer._drivingElevator == false)
        {
            this._mbutton.setAlpha(128 / 255);
        }
        else if (this._zbutton.getVisible() && CGRectContainsPoint(createBB(this._zbutton), tp))
        {
            //this._mbutton.setAlpha(128/255);
        }
        else if (tp.getY() < this._bar.getPosition().getY() - this._bar.AL_getSize().getHeight())
        {
            return false;
        }
        
        return true;
    },
    
    _ccTouchesEnded : function(/*GL2.Touch*/touchEvent)
    {
    	al_trace("touch ended");
        var tp = this._node.screenToLocal(touchEvent.getPosition());
        
        this._mbutton.setAlpha(1);
        this._xbutton.setColor(1, 1, 1);
        
        if (this._xbutton.getVisible() && this._xbutton.getAlpha() > 0 && CGRectContainsPoint(createBB(this._xbutton), tp))
        {
            this.onCloseClick();
        }
        else if (CGRectContainsPoint(createBB(this._mbutton), tp) && TTScene.sharedScene()._towerLayer._drivingElevator == false)
        {
            this._zbutton.setVisible(false);
            TTScene.sharedScene().runMenuLayer(new TTMenu(UNISAFE_WIDTH, UNISAFE_HEIGHT));
        }
        else if (this._zbutton.getVisible() && CGRectContainsPoint(createBB(this._zbutton), tp))
        {
            this._zbutton.setVisible(false);
            this.showCloseButton(true);
            
            TTScene.sharedScene()._towerLayer.zoomOut();
        }
    },
    
    _ccTouchesMoved : function(/*GL2.Touch*/touchEvent)
    {
    	var tp = this._node.screenToLocal(touchEvent.getPosition());

    	if (this._xbutton.getVisible() && CGRectContainsPoint(createBB(this._xbutton), tp))
        {
            this._xbutton.setColor(128 / 255, 128 / 255, 128 / 255);
        }
        else if (CGRectContainsPoint(createBB(this._mbutton), tp))
        {
            this._mbutton.setAlpha(128 / 255);
        }
        else if (this._zbutton.getVisible() && CGRectContainsPoint(createBB(this._zbutton), tp))
        {
            //this._mbutton.setAlpha(128/255);
        }
        else if (tp.getY() < this._bar.getPosition().getY() - this._bar.AL_getSize().getHeight() * 2)
        {
        	this._xbutton.setColor(1,1,1);
        	this._mbutton.setAlpha(1);
            return false;
        }
    },
    
    onCloseClick : function()
    {
        al_trace('Close Touched Ended');
        TTScene.shadeLayer(false, true);
        
        if (TTScene.sharedScene().tipNumber() == 10)
        {
            var dlg = TTDialog.initWithMessage("\n\n\nCannot quit elevator ride during tutorial.", ",continue", null, null, null);
            TTDialogQueue.sharedQueue().addDialog(dlg);
            return;
        }
        
        TTScene.runMenuLayer(null);
        if (this._closeTarget)
        {
            this._closeSelector.call(this._closeTarget);
            this._closeTarget = null;
            this._closeSelector = null;
        }
        
        if (TTScene._towerLayer.isZoomedOut())
        {
            this._zbutton.setVisible(true);
            this.showCloseButton(TTScene._playerData._readOnly);
            TTScene._towerLayer.zoomIn();
            
            if (TTScene.sharedScene().tipNumber() == 3)
            {
                // TIP 4
                var ttl = TTutorialLayer.initWithStep(4, "TAP THE EMPTY FLOOR");
                TTScene.sharedScene().runTipLayer(ttl);
            }
        }
        else
        {
            this.showCloseButton(false);
        }
        
        if (TTScene.sharedScene().tipNumber() == 5)
        {
            // TIP 4
            var ttl = TTutorialLayer.initWithStep(4, "TAP THE EMPTY FLOOR");
            TTScene.sharedScene().runTipLayer(ttl);
            TTScene.sharedScene()._playerData.addCoins(-300);
        }
        if (TTScene.sharedScene().tipNumber() == 7)
        {
            // TIP 6
            var ttl = TTutorialLayer.initWithStep(6, "TAP THE CONSTRUCTION SITE");
            TTScene.sharedScene().runTipLayer(ttl);
        }
        if (TTScene.sharedScene().tipNumber() == 15 || TTScene.sharedScene().tipNumber() == 16 || TTScene.sharedScene().tipNumber() == 17)
        {
            // TIP 14
            var ttl = TTutorialLayer.initWithStep(14, "TAP APARTMENT");
            TTScene.sharedScene().runTipLayer(ttl);
        }
        if (TTScene.sharedScene().tipNumber() == 19)
        {
            // TIP 18
            var ttl = TTutorialLayer.initWithStep(18, "TAP THE RESTAURANT");
            TTScene.sharedScene().runTipLayer(ttl);
        }        
    },
    
    $sharedHud : function()
    {
        return TTScene._hud;
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTDialogQueue'] = function(){var exports = $MODULE_REGISTRY['Code/TTDialogQueue'] || {}; $MODULE_REGISTRY['Code/TTDialogQueue'] = exports; exports.TTDialogQueue = BaseClass.subclass({
    classname : 'TTDialogQueue',
    
    $sharedQueue : function()
    {
        if (!this._sharedQueue)
        {
            this._sharedQueue = TTScene._dialogQueue;
        }
        return this._sharedQueue;
    },
    
    initialize : function()
    {
        this._dialogs = [];
        return this;
    },
    
    destroy : function()
    {
        for ( var i in this._dialogs)
        {
            this._dialogs[i].destroy();
        }
        
        arr_delete(this._dialogs);
        this._dialogs = null;
    },
    
    $addDialog : function(dialog)
    {
        var sharedQueue = this.sharedQueue();
        
        al_trace("Adding dialog... Active dialogs: " + sharedQueue._node._children.length);
        
        // sharedQueue._node._children[0] is a GL2.TouchTarget object
        if (sharedQueue._node._children.length == 1)
        {
            // Display now
            sharedQueue._node.addChild(dialog._node);
            dialog.animateDisplay();
        }
        // If the dialog queue is empty 
        else if (!this._dialogs.length) 
        {
            sharedQueue._dialogs.push(dialog);
        }
        else
        {
            // Save for later.
            var lastIndex = sharedQueue._dialogs.length - 1;
            var lastDialog = sharedQueue._dialogs[lastIndex];
            
            if (lastDialog._tag = "rategame")
            {
                // Rate game case. Adds the new dialog in 
                sharedQueue._dialogs.splice(lastIndex - 1, 0, dialog);
            }
            else
            {
                // Normal case. Adds the new dialog to the end
                sharedQueue._dialogs.push(dialog);
            }
        }
    },
    
    closeDialog : function()
    {
        var sharedQueue = this.sharedQueue();
        if (sharedQueue._node._children.length > 1)
        {
            var firstDialog = sharedQueue._node._children[1];
            TTDialog.dismiss(firstDialog._AL_owner, 0);
        }
    },
    
    hasDialogsOpen : function()
    {
        var sharedQueue = this.sharedQueue();
        return sharedQueue._node._children.length > 1;
    },
    
    popDialog : function()
    {
        if (this._dialogs.length > 0)
        {            
            var lastIndex = this._dialogs.length - 1;
            var newDlg = this._dialogs[lastIndex];
            this._dialogs.splice(lastIndex, 1);
            
            this._node.addChild(newDlg._node);
            newDlg.animateDisplay();
        }
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTZoneLayer'] = function(){var exports = $MODULE_REGISTRY['Code/TTZoneLayer'] || {}; $MODULE_REGISTRY['Code/TTZoneLayer'] = exports; exports.TTZoneLayer = BaseClass.subclass({
    classname : 'TTZoneLayer',
    $NUM_ZONE_BUTTONS : 6,
    
    initialize : function(width, height, emptyFloor)
    {
    	//Bottom offset
    	this.bottomOffset = (this.__size.getHeight() - height) / 2;
    	
        this._newFloor = null;
        this._iconSprites = [];
        this._btnBounds = [];
        
//        var _shade = ALLayerColor.layerWithColor(ccc3(0, 0, 0), (128 + 64) / 255, width, height + this.bottomOffset*2);
//        _shade.setPosition(UNISAFE_WIDTH/2,UNISAFE_HEIGHT/2);
//        this.getNode().addChild(_shade);
        TTScene.shadeLayer(true);
        
        var btnStart = new Core.Point(UNISAFE_WIDTH / 2, 480 - 390);
        var btnSpacingY = 64;
        this._newFloor = emptyFloor;
        
        for ( var i = 0; i < this.NUM_ZONE_BUTTONS; i++)
        {
            var catName = TTScene.floorTypeString(i).toLowerCase();
            var icon = TTSpriteFactory.spriteWithFile("category_" + catName + ".png", [ 0.5, 0.5 ]);
            this._iconSprites[i] = icon;
            
            icon.setPosition(btnStart.getX(), (btnStart.getY() + ((this.NUM_ZONE_BUTTONS - 1) - i) * btnSpacingY));
            this._btnBounds[i] = createBB(icon);
            this.getNode().addChild(icon);
            
            if (TTScene.sharedScene().tipNumber() == 5 && i != FLOOR_TYPE_RESIDENTIAL)
            {
                icon.setVisible(false);
            }
            else if (TTScene.sharedScene().tipNumber() == 12 && i != FLOOR_TYPE_FOOD)
            {
                icon.setVisible(false);
            }
            
            if (i != FLOOR_TYPE_RESIDENTIAL)
            {
                demandLbl = LabelConfigurer.createLabelWithString("" +  Math.round( 100 * TTScene.sharedScene()._towerLayer.busTypePopularities()[i]), "silkscreen", FONT14, [ 0, 1 ], true);
                demandLbl.setPosition(16, 16);

				var _scale = demandLbl.getScale();
		        demandLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
		        
                icon.addChild(demandLbl);
            }
            
            // TITLE BAR
            var titleBg = TTSpriteFactory.spriteWithFile("topslice.png", [ 0, 0 ]);
            titleBg.setScale(UNISAFE_WIDTH / (titleBg.AL_getSize().getWidth() * 1.0), 1);
            titleBg.setPosition(0, -this.bottomOffset);
            this.getNode().addChild(titleBg);
            
            var title = LabelConfigurer.createLabelWithString("FLOOR TYPE", "silkscreen", FONT16, [0.5, 0.5], true);
            title.setPosition(UNISAFE_WIDTH / 2, titleBg.getPosition().getY() + 14);

			var _scale = title.getScale();
	        title.setScale(_scale.getX()*FONTSCALE16, _scale.getX()*FONTSCALE16);
	        
            this.getNode().addChild(title);
        }
        
        this.setTouchTargetToScreenSize();
    },
    
    $initWithNewFloor : function(/*TTFloor*/emptyFloor)
    {
        return new this(UNISAFE_WIDTH, UNISAFE_HEIGHT, emptyFloor);
    },
    
    _ccTouchesBegan : function(/*GL2.Touch*/touchEvent)
    {
        var tp = this._node.screenToLocal(touchEvent.getPosition());
        for ( var i = 0; i < this.NUM_ZONE_BUTTONS; i++)
        {
            if (CGRectContainsPoint(this._btnBounds[i], tp))
            {
                this._iconSprites[i].setColor(127 / 255, 127 / 255, 127 / 255);
            }
        }
        
        return true;
    },
    
    _ccTouchCancelled : function(/*GL2.Touch*/touchEvent)
    {
        for ( var i = 0; i < this.NUM_ZONE_BUTTONS; i++)
        {
            this._iconSprites[i].setColor(255 / 255, 255 / 255, 255 / 255);
        }
    },
    
    _ccTouchesEnded : function(/*GL2.Touch*/touchEvent)
    {
        var tp = this._node.screenToLocal(touchEvent.getPosition());
        
        for ( var i = 0; i < this.NUM_ZONE_BUTTONS; i++)
        {
            this._iconSprites[i].setColor(1, 1, 1);
            if (this._iconSprites[i].getVisible() && CGRectContainsPoint(this._btnBounds[i], tp))
            {
                al_trace("Zone selected: " + TTScene.floorTypeString(i));
                TTScene.shadeLayer(false);
                
                // Grab a random unlocked floorInfo
                var bInfo = TTFloorTable.randomFloorWithType(i, true);
                if (bInfo)
                {
                    // Switch to contruction floor
                    this._newFloor.switchToFloorId(FLOOR_ID_CONSTRUCTION);
                    // Store which floor id we're constructing
                    this._newFloor._storyInfo._sales[1] = bInfo._fid;
                    this._newFloor._storyInfo._sales[2] = dict_size( TTScene.sharedScene()._playerData._floors) ;
                    this._newFloor.startProduction(0);
                    this._newFloor.addContructionWorkers();
                    TTScene.sharedScene().runMenuLayer(null);
                    SoundBoard.playSfx(SFX_CONSTRUCTION);
                    
                    if (TTScene.sharedScene().tipNumber() == 5)
                    {
                        // TIP 6
                        var ttl = TTutorialLayer.initWithStep(6, "TAP THE CONSTRUCTION SITE");
                        TTScene.sharedScene().runTipLayer(ttl);
                    }
                    else if (TTScene.sharedScene().tipNumber() == 12)
                    {
                        // TIP 13
                        var ttl = TTutorialLayer.initWithStep(13, "HURRY CONSTRUCTION");
                        TTScene.sharedScene().runTipLayer(ttl);
                    }
                }
                else
                {
                    var dlg = TTDialog.initWithMessage("\n\n\n\nNo new floors of this type for your level.", ",continue", null, null, null);
                    TTDialogQueue.sharedQueue().addDialog(dlg);
                }
                
                return;
            }
        }
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTowerLayer'] = function(){var exports = $MODULE_REGISTRY['Code/TTowerLayer'] || {}; $MODULE_REGISTRY['Code/TTowerLayer'] = exports; exports.TTowerLayer = BaseClass.subclass({
	classname : 'TTowerLayer',

	initialize : function(width, height)
    {
        al_trace("TTowerLayer.initialize");

        //Bottom offset
        this.bottomOffset = (this.__size.getHeight() - height) / 2;
        // FlankOffset
        this.flankOffset = (this.__size.getWidth() - width) / 2;
        
        // Margins to aspect ratio with width larger than height (ie, iPad)
        // Left margin:
        var leftMarginLayer =  ALLayerColor.layerWithColor([0,0,0], 1, this.flankOffset, UNISAFE_HEIGHT + this.bottomOffset*2, [ 1, 0 ]);
    	leftMarginLayer.setPosition(0,0);
    	leftMarginLayer.setDepth(5000);
    	this.getNode().addChild(leftMarginLayer);
    	// Right Margin.
    	var rightMarginLayer = ALLayerColor.layerWithColor([0,0,0], 1, this.flankOffset + 1, UNISAFE_HEIGHT + this.bottomOffset*2, [ 0, 0 ]);
    	rightMarginLayer.setPosition(UNISAFE_WIDTH,0);
    	rightMarginLayer.setDepth(5000);
    	this.getNode().addChild(rightMarginLayer);
    	
        this.MIN_RIDER_TIP_COINS = 2;
        this.MAX_RIDER_TIP_COINS = 12;
        this.RIDER_TIP_BUX_CHANCE = 15;
        this.AUTOSAVE_TIME_MINUTES = 5;

        this._lastTouchY = 0;
        this._lastLastTouchY = 0;
        this._lastElevatorTouchX = 0;
        this._totalDrag = 0;
        this._velY = 0;
        this._viewHeight = 0;
        this._lastCullY = 0;
        this._zoomedInY = 0;

        this._busPopularities = [];
        this._busCounts = [];

        this._awakeTimestamp = 0;
        this._coinsSinceAwake = 0;

        isPad = true;
        this._isTouchEnabled = true;
        this._velY = this._lastTouchY = this._lastLastTouchY = this._lastElevatorTouchX = 0;
        this._zoomY = LOBBY_BASE_POSITION + 1;
        this._lastFloorUpdate = 0;

        TTScene.sharedScene().recordTimeOfDay();
        this._bgColor = ALLayerColor.layerWithColor(new Core.Color(1, 1, 1), 1, UNISAFE_WIDTH, UNISAFE_HEIGHT + this.bottomOffset*2, [ 0, 0 ]);
        if (TTScene.sharedScene().isDayTime())
        {
            this._bgColor.setColor(56 / 255, 180 / 255, 244 / 255);
        }
        else
        {
            this._bgColor.setColor(26 / 255, 18 / 255, 98 / 255);
        }

        this.getNode().addChild(this._bgColor);
        this._bgColor.setPosition(0, -this.bottomOffset);

        this._floors = [];

        this._botY = -LOBBY_BASE_POSITION + (HUD_BAR_HEIGHT + NOTE_HEIGHT + FLOOR_HEIGHT_PIXELS * 4) + this.bottomOffset;
        this._floorLayer = new GL2.Node();
        this._floorLayer.setPosition(0, this._botY);
        this._floorLayer.setDepth(50);
        this.getNode().addChild(this._floorLayer);

        // CRANE
        this._crane = TTSpriteFactory.spriteWithFile('crane.png', [ 0, 1 ]);
        this._crane.setPosition(0, UNISAFE_HEIGHT);
        this._floorLayer.addChild(this._crane);

        this._craneBuildText = LabelConfigurer.createLabelWithString("BUILD FLOOR", "silkscreen", FONT14, [ 0.5, 1 ], true);
        
        var _scale = this._craneBuildText.getScale();
        this._craneBuildText.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        this._crane.addChild(this._craneBuildText);

        this._craneCoinCost = LabelConfigurer.createLabelWithString("0", "silkscreen", FONT14, [ 0.5, 1 ], true);
        
        var _scale = this._craneCoinCost.getScale();
        this._craneCoinCost.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        this._crane.addChild(this._craneCoinCost);

        this._craneBuxCost = LabelConfigurer.createLabelWithString("0", "silkscreen", FONT12, [ 0.5, 1 ], true);
        
        var _scale = this._craneBuxCost.getScale();
        this._craneBuxCost.setScale(_scale.getX()*FONTSCALE12, _scale.getX()*FONTSCALE12);
        
        this._crane.addChild(this._craneBuxCost);

        this._craneCoin = TTSpriteFactory.spriteWithFile("coin.png", [ 0, 0 ], [ 1, 1 ]);
        this._crane.addChild(this._craneCoin);

        this._craneBux = TTSpriteFactory.spriteWithFile("bux.png", [ 0, 0 ]);
        this._crane.addChild(this._craneBux);

        this.updateCrane();
        var ccCol = ccc3(255, 255, 255);
        var ccCol2 = ccc3(55, 30, 19);
        
        var dirtLayer = ALLayerColor.layerWithColor(ccCol, 1, UNISAFE_WIDTH, -UNISAFE_HEIGHT, [ 0, 1 ]);
        var dirtLayerBg = ALLayerColor.layerWithColor(ccCol2, 1, UNISAFE_WIDTH, -UNISAFE_HEIGHT, [ 0, 1 ]);

        dirtLayer.setPosition(0, UNISAFE_HEIGHT);
        dirtLayer.setDepth(1001);
        this._floorLayer.addChild(dirtLayer);

        var dirt = TTSpriteFactory.spriteWithFile("dirt.png", [ 0, 0 ]);
        dirt.setPosition(0, 0);
        dirt.setDepth(1500);
        dirtLayer.addChild(dirt);
        dirtLayer.addChild(dirtLayerBg);
        
        // LOAD FLOORS FROM PLAYERDATA HERE
        var storyInfos = TTScene.sharedScene()._playerData._floors;
        al_trace("Loading " + dict_size(storyInfos) + " storyInfos in TowerLayer...");
        for (var s = 1; s <= dict_size(storyInfos); s++)
        {
            var sinfo = storyInfos[s];
            if (sinfo)
            {
                this.addFloor(sinfo);
            }
        }

        // FIRST RUN
        al_trace("Floors length: " + this._floors.length);
        if (this._floors.length == 0)
        {
            al_trace("Adding lobby");
            
            var lobbyInfo = new TTStoryInfo();
            lobbyInfo.setFloorId(LOBBY_ID);
            lobbyInfo.setStory(1);
            TTScene.sharedScene()._playerData.addStoryInfo(lobbyInfo);
            this.addFloor(lobbyInfo);

            TTScene.sharedScene()._playerData.addCoins(this.nextFloorCost());
            TTScene.sharedScene()._playerData.addBux(0);

            // TIP 1 
            var ttl = TTutorialLayer.initWithStep(1, "TAP BUILD FLOOR SIGN");
            TTScene.sharedScene().runTipLayer(ttl);
            
        }

        // LOAD BITIZENS FROM PLAYERDATA HERE
        var bitInfos = TTScene.sharedScene()._playerData._bitizens;
        al_trace("Loading " + dict_size(bitInfos) + " bitInfo in TowerLayer...");
        for ( var aKey in bitInfos)
        {
            var binfo = bitInfos[aKey];

            if (binfo)
            {
                var wfloor = null;
                var hfloor = null;
                if (binfo._workFloor > 0 && binfo._workFloor <= this._floors.length)
                {
                    wfloor = this._floors[binfo._workFloor - 1];
                }
                if (binfo._homeFloor > 0 && binfo._homeFloor <= this._floors.length)
                {
                    hfloor = this._floors[binfo._homeFloor - 1];
                }
                if (wfloor && hfloor)
                {
                    if (std_rand() % 3 == 1)
                    {
                        hfloor.addBitizen(binfo._seed);
                    }
                    else
                    {
                        wfloor.addBitizen(binfo._seed);
                    }
                }
                else
                {
                    if (hfloor)
                    {
                        hfloor.addBitizen(binfo._seed);
                    }
                }
            }
        }

        this.updateCrane();
        this.cullFloors();
        this.calculatePopularities();

        // ELEVATOR
        this._elevator = new TTElevator();
        this._elevator._node.setDepth(1000);
        this._elevator._node.setPosition(0, LOBBY_BASE_POSITION - ELEVATOR_HEIGHT);
        this._floorLayer.addChild(this._elevator._node);
        
        // NOTIFICATIONS
        this._noteLayer = new GL2.Node();
        this._noteLayer.setDepth(2000);
        this.getNode().addChild(this._noteLayer);
        this._noteLayer.setVisible(!TTScene.sharedScene()._playerData._readOnly);
        this._drivingElevator = false;

        this._awakeTimestamp = Core.Time.getRealTime()/1000;
        this._coinsSinceAwake = 0;

        // TODO, remove this test method !
        //this.testAddFloors();

    	this._shade = ALLayerColor.layerWithColor(ccc3(0, 0, 0), 0.5, UNISAFE_WIDTH, UNISAFE_HEIGHT + this.bottomOffset*2);
    	this._shade.setPosition( UNISAFE_WIDTH / 2, UNISAFE_HEIGHT / 2 );
	    this.getNode().addChild(this._shade);
	    this._shade.setVisible(false);
	    this._shade.setDepth(1050);
	    this._shade.setScale([2,2]);
	    this.shadeCounter=0;


        // Enable input
        this.setTouchTargetToScreenSize();
    },
    /**
     * Method to add or remove a shade layer when menus or dialog box appears. 
     * 
     * @param flag true for set active the shade layer, false to remove.
     * @param killEmAll true If we want to force to remove the shade layer, usefull when we are removing more than one dialog box at once.
     */
    setShadeLayer : function(/* bool*/ flag, /*bool*/ killEmAll)
    {
    	
    	if(flag)
		{
    		this.shadeCounter++;
    	
		}
    	else
		{
    		this.shadeCounter--;
		
		}

    	if(this.shadeCounter<=0 || killEmAll)
    	{
    		this.shadeCounter=0;
    	}
    	
    	if(this.shadeCounter>0)
		{
    		this._shade.setVisible(true);
		}
    	else if(this.shadeCounter==0)
		{
    		this._shade.setVisible(false);
		}
    	
    },
    
    destroy : function()
    {
        // in case you have something to dealloc, do it in this method
        // in this particular example nothing needs to be released.
        // cocos2d will automatically release all the children (Label)
        //[floors release];
        //[numFormat release];

        /*
        for (var i = 0; i >= this._floors.length -1; i--)
        {
            al_trace("Removing floor: " + i);
            if (this._floors[i])
            {
                this._floors[i].destroy();
            }
        }        
        dict_delete(this._floors);*/
        
        //this._noteLayer.AL_destroyAllChildrenWithCleanup(true, true);
        //this._elevator.destroy();
        
        // this._numFormat.destroy();

        // don't forget to call "super dealloc"
        //[super dealloc];
        //super.destroy();
    },
    
    testAddFloors : function()
    {
        var bInfo = new TTStoryInfo();
        bInfo.setFloorId(44);
        bInfo.setStory(this._floors.length+1);
        TTScene.sharedScene()._playerData.addStoryInfo(bInfo);
        this.addFloor(bInfo);
        
        var aInfo = new TTStoryInfo();
        aInfo.setFloorId(2);
        aInfo.setStory(this._floors.length+1);
        TTScene.sharedScene()._playerData.addStoryInfo(aInfo);
        this.addFloor(aInfo);
        
        var i = new TTBitizenInfo();
        i._seed = 23;
        i._homeFloor = aInfo._story;
        i._workFloor = -1;
        i._dreamFloor = -1;
        i._dreamed = false;
        TTScene.sharedScene()._playerData.addBitizenInfo(i);
        this._floors[2].addBitizen(i._seed);
        
        var cInfo = new TTStoryInfo();
        cInfo.setFloorId(3);
        cInfo.setStory(this._floors.length+1);
        TTScene.sharedScene()._playerData.addStoryInfo(cInfo);
        this.addFloor(cInfo);
        
        
        var dInfo = new TTStoryInfo();
        dInfo.setFloorId(4);
        dInfo.setStory(this._floors.length+1);
        TTScene.sharedScene()._playerData.addStoryInfo(dInfo);
        this.addFloor(dInfo);
        
        var eInfo = new TTStoryInfo();
        eInfo.setFloorId(5);
        eInfo.setStory(this._floors.length+1);
        TTScene.sharedScene()._playerData.addStoryInfo(eInfo);
        this.addFloor(eInfo);
    },
	
	cullFloors : function()
	{
		for ( var i = 0; i < this._floors.length; i++)
		{
			var flr = this._floors[i];
			var yPos = flr.getNode().getParent().getPosition().getY() + flr.getNode().getPosition().getY();
			if (this._floorLayer.getScale().getX() == 1 && (yPos < -2 * FLOOR_HEIGHT_PIXELS || yPos > UNISAFE_HEIGHT + FLOOR_HEIGHT_PIXELS) )
			{
				flr.getNode().setVisible(false);
			}
			else
			{
				flr.getNode().setVisible(true);
			}
		}
		this._lastCullY = this._floorLayer.getPosition().getY();
	},

	nextFloorCost : function()
	{
		var fc = this._floors.length + 1;
		return fc * 1500 * fc / 10.0;
	},

	zoomIn : function()
	{
		if (this._floorLayer.getScale().getX() == 1)
		{
			return;
		}

		for ( var i = 0; i < this._floors.length; i++)
		{
			this._floors[i].zooming(false);
		}

		var zoomscale = 1;
		this._floorLayer.setPosition(0, -HUD_BAR_HEIGHT - 38);
		this._floorLayer.setScale(zoomscale, zoomscale);
		this._botY = -LOBBY_BASE_POSITION + (HUD_BAR_HEIGHT + NOTE_HEIGHT + FLOOR_HEIGHT_PIXELS * 4) + this.bottomOffset;
		this._floorLayer.setPosition(this._floorLayer.getPosition().getX(), this._zoomedInY);

		this.cullFloors();
		this._noteLayer.setVisible(!TTScene.sharedScene()._playerData._readOnly);
		this._bgLayer.destroy(); // [bgLayer removeFromParentAndCleanup:YES];
		this._bgLayer = null;
		this._zoomY = LOBBY_BASE_POSITION + 1;
		this._velY = 0;
	},

	isZoomedOut : function()
	{
		return (this._floorLayer.getScale().getX() != 1);
	},

	zoomOut : function()
	{
		if ((this._floorLayer.getScale().getX() == 1 && this._floorLayer.getScale().getY() == 1) && !this._drivingElevator)
		{
			TTScene.sharedScene().recordTimeOfDay();
			this._zoomedInY = this._floorLayer.getPosition().getY();
			for ( var i = 0; i < this._floors.length; i++)
			{
				
				this._floors[i].zooming(true);
			}

		    var zoomscale = 0.25;
		    this._floorLayer.setScale(zoomscale, zoomscale);
			
			this._botY = UNISAFE_HEIGHT/2 + FLOOR_HEIGHT_PIXELS * 3/4 + 4;
			this._floorLayer.setPosition(UNISAFE_WIDTH * 3 / 8, this._botY);
	
			this.cullFloors();
			this._velY = 0;
			//this._zoomY = Math.abs(this._crane.getPosition().getY()/4 + this.isPad ?UNISAFE_HEIGHT/4:0);
			
			this._noteLayer.setVisible(false);
	
			if (!this._bgLayer)
			{
				this._bgLayer = new GL2.Node();
				this._bgLayer.setPosition(0, +this.bottomOffset-1); //setPosition(UNISAFE_WIDTH/2,UNISAFE_HEIGHT/2);
				skyline = TTSpriteFactory.spriteWithFile(TTScene.sharedScene().isDayTime() ? "city.png" : "city_night.png");
				this.getNode().addChild(this._bgLayer);
				this._bgLayer.addChild(skyline);
	
				for ( var i = 0; i < 3; i++)
				{
					var cloud = new TTCloud();
					this._bgLayer.addChild(cloud._node);
					
					var positionX = Math.floor(Math.random()* (Math.pow(2, 15) - 1)) % UNISAFE_WIDTH;
					var positionY = Math.floor(Math.random()* (Math.pow(2, 15) - 1)) % UNISAFE_HEIGHT;
					
					cloud._node.setPosition(positionX , (UNISAFE_HEIGHT / 2) - positionY);
				}
			}
		}
	},

	calculatePopularities : function()
	{
		var stories = TTScene.sharedScene()._playerData._floors;
		for ( var i = 0; i < NUM_BUS_TYPES + 1; i++)
		{
			this._busCounts[i] = 0;
		}

		var totalBusinesses = 0;
		for ( var aKey in stories)
		{
			var story = stories[aKey];
			var fInfo = TTFloorTable.floorWithId(story._floorId);
			if (fInfo && story && story._floorId != FLOOR_ID_EMPTY && story._floorId != FLOOR_ID_CONSTRUCTION && story._floorId != LOBBY_ID)
			{
				// update count for this floor type
				this._busCounts[fInfo._type]++;
				if (fInfo._type != FLOOR_TYPE_RESIDENTIAL)
				{
					totalBusinesses++;
				}
			}
		}

		var idealCountPerType = totalBusinesses / (NUM_BUS_TYPES * 1.0);
		if (idealCountPerType < 1)
		{
			idealCountPerType = 1.0;
		}
		al_trace("idealCountPerType: " + idealCountPerType);

		for ( var i = 0; i < NUM_BUS_TYPES; i++)
		{
			al_trace("Business count for type " + TTScene.sharedScene().floorTypeString(i) + " : " + this._busCounts[i]);
			var demand = idealCountPerType / (this._busCounts[i] * 1.0);
			if (demand > 1)
			{
				demand = 1.0;
			}
			this._busPopularities[i] = demand;
		}
	},

	busTypePopularities : function()
	{
		return this._busPopularities;
	},

	busTypeCounts : function()
	{
		return this._busCounts;
	},

	updateCrane : function()
	{
		var ccost = this.nextFloorCost();
		this._craneCoinCost.setText(numberAddCommas(ccost));
		var signPos = new Core.Point(178, 120);
		this._craneBuildText.setPosition(signPos.getX(), -signPos.getY() + 6);
		this._craneCoinCost.setPosition(signPos.getX() + this._craneCoin.AL_getSize().getWidth() / 2/2, -signPos.getY() + 12*2);
		this._craneCoin.setPosition(this._craneCoinCost.getPosition().getX() - 50/*this._craneCoinCost.AL_getSize().getWidth()/2*/, this._craneCoinCost.getPosition().getY() - 8*2);

		// ese 25 aparece por lo que esta en comentario, y ese 8 es un 3 en el original.
		this._craneBux.setVisible(false);
		this._craneBuxCost.setVisible(false);
	},

	addFloor : function(/*TTStoryInfo*/newStory)
	{	    
		var newFloor = TTFloor.initWithStoryInfo(newStory);
		newFloor._node.setPosition(0, UNISAFE_HEIGHT - (newStory._story) * FLOOR_HEIGHT_PIXELS);
		this._floors.push(newFloor);
		this._floorLayer.addChild(newFloor._node);

		al_trace("num floors: " + this._floors.length);
		this._viewHeight = UNISAFE_HEIGHT - this._floors.length * FLOOR_HEIGHT_PIXELS;
		al_trace("_viewHeight :" + this._viewHeight);

		this._crane.setPosition(0, this._viewHeight);		
		return newFloor;
	},

	buildNewFloorDialog : function(/*TTDialog*/dialog)
	{
		if (dialog._buttonIndex == 1)
		{
			// Add new floor
			var emptyStory = new TTStoryInfo();
			emptyStory.setFloorId(FLOOR_ID_EMPTY);
			emptyStory.setStory( this._floors.length + 1);
			TTScene.sharedScene()._playerData.addStoryInfo(emptyStory);
			this.addFloor(emptyStory);

			// charge
			TTScene.sharedScene()._playerData.addCoins(-dialog._data);
			this.updateCrane();

			SoundBoard.playSfx(SFX_CONSTRUCTION);

			// CONGRATS
			var dlg = TTDialog.initWithMessage("\n\n\n\nCongratulations on expanding your tower, you've been given a complimentary Tower Buck!", ",Continue", null, null, null);
			var newflr = TTSpriteFactory.spriteWithFile("flooradded.png");
			newflr.setPosition(-80, -110);
			dlg._node.addChild(newflr);		

			TTDialogQueue.sharedQueue().addDialog(dlg);
	 
			TTScene.sharedScene()._playerData.addBux(1);
			TTHud.sharedHud().showZoomButton(false);
			TTHud.sharedHud().showCloseButton(true);
			this.zoomOut();

			if (TTScene.sharedScene().tipNumber() == 2)
			{
				// TIP 3
				var ttl = TTutorialLayer.initWithStep(3, "TAP X TO EXIT ZOOM VIEW");
				TTScene.sharedScene().runTipLayer(ttl);
				 
			}
			else if (TTScene.sharedScene().tipNumber() == 11)
			{
				// TIP 12
				var ttl = TTutorialLayer.initWithStep(12, "PUT FOOD TYPE IN 3RD FLOOR");
				TTScene.sharedScene().runTipLayer(ttl);
			 
			}
			else if (TTScene.sharedScene().tipNumber() > 0)
			{
				var dlg = TTDialog.initWithMessage("\n\n\n\nTUTORIAL Complete!\n\nThanks for learning the basics of Tiny Tower, the sky is the limit from here!", ",Continue", null, null, null);
				TTDialgoQueue.addDialog(dlg);
				
				var bux = TTScene.sharedScene()._playerData._bux;
				var coins = TTScene.sharedScene()._playerData._coins;
				TTScene.sharedScene()._playerData.addBux(-bux + 5);
				TTScene.sharedScene()._playerData.addCoins(-coins + 5000);
				TTScene.sharedScene()._playerData._paint = 100;
				TTScene.sharedScene().runTipLayer(null);
			}
			
			if (this._floors.length == RATE_GAME_FLOORS)
	        {
	            RateGameController.showRateMeDialog();
	        }

			TTScene.sharedScene()._playerData.checkFloorAchievements();  
		}
		else
		{
			if (TTScene.sharedScene().tipNumber() == 2 ) 			
			{
				// TIP 1
				var ttl = TTutorialLayer.initWithStep(1, "TAP BUILD FLOOR SIGN");
				TTScene.sharedScene().runTipLayer(ttl);
			}
		}
	},

	cancelDrivingElevator : function()
	{
		if (this._drivingElevator)
		{
			this._drivingElevator = false;
			this._elevator.cancelRider();
			this._elevatorControls.AL_cleanupAndRemove(true); // o AL_removeFromParentAndCleanup
			this._elevator._targetFloor = this._floors[0];
		}
	},

	cancelFinder : function()
	{
		if (this._finderMode)
		{
			this._finderMode = false;
			this._finderOverlay.destroy();
			TTHud.sharedHud().showZoomButton(true);
			TTHud.sharedHud().showCloseButton(false);
		}
	},

	spawnRider : function()
	{
		if (this._floors.length < 2) 
		{
			return;
		}

		srandom(Math.floor(Core.Time.getRealTime() / 1000));
		var r = 1 + std_rand() % (this._floors.length - 1);
		var isVIP = (std_rand() % 15 == 0 && TTScene.sharedScene().tipNumber() < 1); // Random
		var vSeed = std_rand() % BITIZEN_SPECIAL_SEED_COUNT + 1;
		var tnote = TTNote.initWithType(isVIP ? NOTE_TYPE_VIP : NOTE_TYPE_RIDER, 1);
		this.addNote(tnote);

		this._floors[0].setInfoIcon(isVIP ? "note_vip.png" : "note_ride.png");
		al_trace("rider to floor: " + r);
		SoundBoard.playSfx(SFX_ELEVATORBELL); 

		if (isVIP)
		{
			this._elevator.addNewVIP(vSeed);
		}
		else
		{
			this._elevator.addNewRiderGoingToFloor(this._floors[r]);
		}        
	},

	addNote : function(/*TTNote*/note)
	{
		var curWidth = this._noteLayer._children.length * NOTE_WIDTH; 
		this._noteLayer.addChild(note);
		note.setPosition(0 + curWidth, UNISAFE_HEIGHT - HUD_BAR_HEIGHT + this.bottomOffset);  
	},

	hasNoteOfType : function(/*int*/ntype, /*int*/floor)
	{
		for ( var i = 0; i < this._noteLayer._children.length; i++)
		{
			var note = this._noteLayer._children[i];
			if ( parseInt(note._noteType) == parseInt(ntype) && note._data == floor)
			{
				// found this note!
				return true;
			}
		}

		return false;
	},

	clearNoteOfType : function(/*int*/ntype,/*int*/floor)
	{
		var delIndex = Number.MAX_VALUE;
		for ( var i = 0; i < this._noteLayer._children.length; i++) 
		{
			var note = this._noteLayer._children[i];
			if (note._noteType == ntype && note._data == floor)
			{
				// remove this note!
				delIndex = i;
			}
			else if (i > delIndex)
			{
				// reposition remaining notes
				al_trace("repositioning note: " + i);
				note.setPosition(note.getPosition().getX() - NOTE_WIDTH, note.getPosition().getY());
			}
		}
		if (delIndex < Number.MAX_VALUE /* INT_MAX */)
		{
			this._noteLayer._children[delIndex].destroy();
		}
	},

	riderTip : function(/*TTDialog*/dialog)
	{
		var tipAmt = Number(dialog._data);
		if (tipAmt == 1)
		{
			TTScene.sharedScene()._playerData.addBux(tipAmt);
		}
		else
		{
			TTScene.sharedScene()._playerData.addCoins(tipAmt);
		}
	},

	deliverVipDialog : function(/*TTDialog*/dlg)
	{
		if (dlg._buttonIndex > 0)
		{
			var rFloor = this._floors[this._elevator._node.AL_getTag()];
			if (rFloor)
			{
				// affect the floor
				if (this._elevator._occupant._seed == BITIZEN_SEED_REALESTATE)
				{
					// check for an open bedroom
					var movedIn = false;
					var newBit = TTBitizen.initWithSeed(std_rand());

					if (rFloor._floorInfo._type == FLOOR_TYPE_RESIDENTIAL)

					{
						var numBeds = 5;

						// get occupant count
						var occupants = TTScene.sharedScene()._playerData.bitizensWithHomeFloor(rFloor._storyInfo._story);

						// check for open bed
						if (occupants.length < numBeds)
						{
							// move in bitizen
							movedIn = true;

							// Chance for BitBook
							if (std_rand() % TTBitBook.BITBOOK_NEWROOMATE_CHANCE == 0)
							{

								// Get roomates
								var roomies = TTScene.sharedScene()._playerData.bitizensWithHomeFloor(rFloor._storyInfo._story);
								var wInfo = null;
								if (roomies && dict_size(roomies) > 0)
								{
									wInfo = roomies[std_rand() % dict_size(roomies)];
									var entry = TTBitBook.entryFormatForEvent("new_roommate");
									TTBitBook.addNewEntry(entry, newBit._firstName, wInfo._seed);
								}
							}

							var newInfo = new TTBitizenInfo();
							newInfo._seed = newBit._seed;
							newInfo._homeFloor = rFloor._storyInfo._story;
							newInfo._workFloor = -1;
							newInfo._dreamFloor = -1;
							newInfo._dreamed = false;
							TTScene.sharedScene()._playerData.addBitizenInfo(newInfo);
							rFloor.addBitizen(newInfo._seed);
						}
					}

					if (movedIn)
					{	
						
						TTDialogQueue.sharedQueue().addDialog(TTDialog.initWithMessage("\n\n\n" + newBit._name + "\nhas moved into floor " + rFloor._storyInfo._story + "!", ",Continue", null,  null, null));                       
						//this._elevator._occupant._node.setVisible(false);
						SoundBoard.playSfx(SFX_DOORBELL);

						TTScene.sharedScene()._playerData.checkPopAchievements();

						// Chance for BitBook
						if (std_rand() % BITBOOK_NEWRESIDENT_CHANCE == 0)
						{
							var entry = TTBitBook.entryFormatForEvent("new_bitizen");
							TTBitBook.addNewEntry(entry, newBit._seed);
						}
					}
				}                
				else if (this._elevator._occupant._seed == BITIZEN_SEED_CONSTRUCTION && rFloor._floorInfo._fid == FLOOR_ID_CONSTRUCTION)
				{
					// take 3 hours off construciton
					rFloor._storyInfo._prodStartTime = rFloor._storyInfo._prodStartTime - 3 * 60 * 60;  
				}
				else if (this._elevator._occupant._seed == BITIZEN_SEED_DELIVERYMAN && rFloor._floorInfo._fid != FLOOR_ID_CONSTRUCTION && rFloor._storyInfo._activeProduct > -1)
				{
					// take 3 hours off restocking
					rFloor._storyInfo._prodStartTime = rFloor._storyInfo._prodStartTime - 3 * 60 * 60;  
				}
				else if (this._elevator._occupant._seed == BITIZEN_SEED_BIGSPENDER && rFloor._floorInfo._type != FLOOR_TYPE_RESIDENTIAL && rFloor._floorInfo._fid != FLOOR_ID_CONSTRUCTION && rFloor._floorInfo._fid != FLOOR_ID_EMPTY)
				{
					// randomly quick sell a stocked product
					var prodIndex = std_rand() % 3;
					var tries = 1;
					while (rFloor._storyInfo._stock[prodIndex] <= 0)  
					{
						prodIndex = (prodIndex + 1) % 3;
						tries++;
						if (tries > 3)
						{
							return;
						}
					}

					// Remove stock and pay player
					var amt = rFloor._storyInfo._stock[prodIndex] * (prodIndex + 1);  
					rFloor._storyInfo._stock[prodIndex] = 0;  
					TTScene.sharedScene()._playerData.addCoins(amt);
					TTHud.sharedHud().animateCoinAmt(amt);
				}
				else if (this._elevator._occupant._seed == BITIZEN_SEED_CELEBRITY && rFloor._floorInfo._type != FLOOR_TYPE_RESIDENTIAL && rFloor._floorInfo._fid != FLOOR_ID_CONSTRUCTION && rFloor._floorInfo._fid != FLOOR_ID_EMPTY)
				{
					// take 3 hours off restocking
					rFloor._custBoost = 50;
				}

				this._elevator._riderFloor = rFloor;
				this._elevator.deliverRider();
				this._drivingElevator = false ;
				this._elevatorControls.AL_removeFromParentAndCleanup(true);
				TTHud.sharedHud().showCloseButton(false);
				TTHud.sharedHud().setCloseCallback(null, null);
				this._elevator._targetFloor = this._floors[0];
			}
		}
	},

	startFinderDialog : function(/*TTDialog*/dlg)
	{
		if (dlg._buttonIndex > 0)
		{            
			// Start finder mode
			this._finderMode = true;
			TTHud.sharedHud().showZoomButton(false);
			this._finderOverlay = TTSpriteFactory.spriteWithFile("finder.png", [0,1]);
			this._finderOverlay.setPosition(0, UNISAFE_HEIGHT -93 + this._finderOverlay.AL_getSize().getHeight()/2+16 +this.bottomOffset ); 

			if (this._finderBitInfo)
			{
				var fbit = TTBitizen.initWithSeed(this._finderBitInfo._seed);  
				this._finderOverlay.addChild(fbit._node);
				fbit._node.setPosition(32, -52);  
				 
				var lbl = LabelConfigurer.createLabelWithString("FIND " + fbit._name, "silkscreen",FONT14, [0,0.5], true);  
				lbl.setPosition(8 , -14);  
				
				var _scale = lbl.getScale();
		        lbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
		        
				this._finderOverlay.addChild(lbl);
			}
			else
			{
				this.cancelFinder();
				return;
			}
			this._finderOverlay.setDepth(2001);
			
			this._node.addChild(this._finderOverlay);
			TTHud.sharedHud().setCloseCallback(this.cancelFinder, this);
			TTHud.sharedHud().showCloseButton(true);
		}
	},

	_draw : function(delta)
	{	
	    
		if (this._moveMode)
		{
			this._zoomY = this._movingFloor._node.getPosition().getY() + FLOOR_HEIGHT_PIXELS; 
			
		}
		else if (this._drivingElevator)
		{		    
			if (this._lastElevatorTouchX > 0)
			{
				var push = this._lastElevatorTouchX < UNISAFE_WIDTH / 2 ? -1 : 1;
				this._elevator.push(push);
			}
			
			this._zoomY = this._elevator._node.getPosition().getY() + ELEVATOR_HEIGHT;

			// EASE TO FLOOR			
			var nearFloor = Math.floor((LOBBY_BASE_POSITION - this._elevator._node.getPosition().getY()) / FLOOR_HEIGHT_PIXELS);
			var targetY = LOBBY_BASE_POSITION - (nearFloor * FLOOR_HEIGHT_PIXELS);
					
			if (this._elevator._velY == 0)
			{
				this._elevator._node.setPosition(
				        this._elevator._node.getPosition().getX(),
				        this._elevator._node.getPosition().getY() + (targetY - (this._elevator._node.getPosition().getY() + ELEVATOR_HEIGHT)) / 10.0); 

			}

			this._elevatorSfxCount += this._elevator._velY;
			if (this._elevatorSfxCount > 15)
			{
				this._elevatorSfxCount = 0;
			}
			
			if (this._elevator._node.AL_getTag() != nearFloor 
					&& this._elevator.isOccupantVIP() 
					&& Math.abs(this._elevator._velY) < 0.2 
					&& Math.abs((this._elevator._node.getPosition().getY() + ELEVATOR_HEIGHT) - targetY) < 1)
			{
				// which floor are we stopped at?
				if (nearFloor > 0)
				{
					this._elevator._node.AL_setTag(nearFloor);
					
					// Ask to deliver this vip
					var dlg = TTDialog.initWithMessage("\n\n\n\nDeliver this V.I.P. to floor " + (nearFloor + 1) + "?", "No,Yes", this.deliverVipDialog, this, nearFloor);
					TTDialogQueue.sharedQueue().addDialog(dlg);
				}
			}
			else if (Math.abs(this._elevator._velY) < 0.2
					&& Math.abs(this._elevator._node.getPosition().getY() + ELEVATOR_HEIGHT 
					         - (this._elevator._riderFloor._node.getPosition().getY() + (FLOOR_HEIGHT_PIXELS * 2))) < 1
					&& !this._elevator.isOccupantVIP())
			{
				// APARTMENT?
				var movedIn = false;
				if (this._elevator._riderFloor._floorInfo._type
				    && this._elevator._riderFloor._floorInfo._type == FLOOR_TYPE_RESIDENTIAL)
				{
					var numBeds = 5;

					// get occupant count
					var occupants = TTScene.sharedScene()._playerData.bitizensWithHomeFloor(this._elevator._riderFloor._storyInfo._story);

					// check for open bed
					if (occupants.length < numBeds)
					{
						// move in bitizen
						movedIn = true;

						// Chance for BitBook
						if (std_rand() % TTBitBook.BITBOOK_NEWROOMATE_CHANCE == 0)
						{
							// Get roomates
							var roomies = TTScene.sharedScene()._playerData.bitizensWithHomeFloor(this._elevator._riderFloor._storyInfo._story);
							var wInfo = null;
							if (roomies && roomies.length > 0)
							{
								wInfo = roomies[std_rand() % roomies.length];
								var entry = TTBitBook.entryFormatForEvent("new_roommate");
								var newBit = TTBitizen.initWithSeed(this._elevator._occupant._seed);
								TTBitBook.addNewEntry(entry, newBit._firstName, wInfo._seed);
								newBit = null;
							}
						}

						var newInfo = new TTBitizenInfo();
						newInfo._seed = this._elevator._occupant._seed;
						newInfo._homeFloor = this._elevator._riderFloor._storyInfo._story;
						newInfo._workFloor = -1;
						newInfo._dreamFloor = -1;
						newInfo._dreamed = false;
						TTScene.sharedScene()._playerData.addBitizenInfo(newInfo);
						this._elevator._riderFloor.addBitizen(newInfo._seed);

						//newInfo = null;  
					}
				}

				if (movedIn)
				{			
					
					TTDialogQueue.sharedQueue().addDialog(TTDialog.initWithMessage("\n\n\n" + this._elevator._occupant._name + "\nhas moved into floor " + this._elevator._riderFloor._storyInfo._story + "!", ",Continue", null, null, null));
					this._elevator._occupant._node.setVisible(false);
					SoundBoard.playSfx(SFX_DOORBELL);

					// TIP 11
					if (TTScene.sharedScene().tipNumber() == 10)
					{
						TTScene.sharedScene()._playerData.addCoins(-TTScene.sharedScene()._playerData._coins);
						TTScene.sharedScene()._playerData.addCoins(this.nextFloorCost() + 100);
						var ttl = TTutorialLayer.initWithStep(11, "BUILD 3RD FLOOR");
						TTScene.sharedScene().runTipLayer(ttl);
						//ttl = null;  
					}

					TTScene.sharedScene()._playerData.checkPopAchievements();

					// Chance for BitBook
					if (std_rand() % TTBitBook.BITBOOK_NEWRESIDENT_CHANCE == 0)
					{
						var entry = TTBitBook.entryFormatForEvent("new_bitizen");
						TTBitBook.addNewEntry(entry, this._elevator._occupant._seed);  
					}
				}
				else
				{
					// TIP PLAYER
					var tipAmt = (this._elevator._riderFloor._storyInfo._story) * 2;
					if (std_rand() % this.RIDER_TIP_BUX_CHANCE == 1)
					{
						tipAmt = 1;
						var dlg = TTDialog.initWithMessage("\n\n\n" + this._elevator._occupant._name + "\nhas tipped you " + tipAmt + " " + (tipAmt == 1 ? "TowerBux" : "coins") + "!", ",Continue", this.riderTip, this, tipAmt);
						TTDialogQueue.sharedQueue().addDialog(dlg);
					}
					else
					{

						// Function RiderTip -------
						if (tipAmt == 1)
						{
							TTScene.sharedScene()._playerData.addBux(tipAmt);
						}
						else
						{
							TTScene.sharedScene()._playerData.addCoins(tipAmt);
							TTHud.sharedHud().animateCoinAmt(tipAmt);
						}
						// end func

						// BITIZEN TIPS!
						if (!TTScene.sharedScene()._playerData._readOnly)
						{
							this._riderCount++;
							if (this._riderCount % 4 == 0)
							{
								var nextTip = TTTips.nextTip();
								if (nextTip)
								{
									TTDialogQueue.sharedQueue().addDialog(TTDialog.initWithMessage("TINY TOWER TIP!\n\n" + nextTip, ",Continue", null, null, null));
								}
							}
						}
					}
				}

				this._elevator.deliverRider();
				this._drivingElevator = false;
				this._elevatorControls.AL_removeFromParentAndCleanup(true);
				TTHud.sharedHud().showCloseButton(false);
				TTHud.sharedHud().setCloseCallback(null, null);
				this._elevator._targetFloor = this._floors[0];
			}
		}
		else if (!TTScene.sharedScene()._playerData._readOnly)
		{
			// CHANCE FOR RIDER
			if (TTScene.sharedScene().tipNumber() < 1
			    && !this._elevator._riderFloor
			    && this._elevator._node.getPosition().getY() + ELEVATOR_HEIGHT > (LOBBY_BASE_POSITION - 1)
			    && std_rand() % 500 == 42)
			{
				this.spawnRider();
			}
		}

		// AUTOSAVE
		if (!TTScene.sharedScene()._playerData._readOnly)
		{
			var timeSinceAutoSave = Core.Time.getRealTime()/1000 - this._lastAutoSave;
			if (timeSinceAutoSave > this.AUTOSAVE_TIME_MINUTES * 60)
			{
				this._lastAutoSave = Core.Time.getRealTime()/1000;
				al_trace("Data I/O: AUTO SAVING LOCAL GAME...");
				TTScene.sharedScene()._playerData.saveToDisk();
			}
		}
		
		var lastFloor = this._floors[this._floors.length - 1]; 
		
		if (this._floors.length
		    && this._elevator._node.getPosition().getY() + ELEVATOR_HEIGHT > LOBBY_BASE_POSITION)
		{
		    // Snaps the elevator to the lobby
			this._elevator._node.setPosition(
			    this._elevator._node.getPosition().getX(),
			    LOBBY_BASE_POSITION - ELEVATOR_HEIGHT);
		}
		else if (this._floors.length
		    && (this._elevator._node.getPosition().getY() + ELEVATOR_HEIGHT
		        < lastFloor._node.getPosition().getY() + (FLOOR_HEIGHT_PIXELS * 2)))
		{
		    // Snaps to the top floor
			this._elevator._node.setPosition(
			    this._elevator._node.getPosition().getX(),
			    lastFloor._node.getPosition().getY() + (FLOOR_HEIGHT_PIXELS * 2) - ELEVATOR_HEIGHT);
		}

		// zooming
		if (this._zoomY < LOBBY_BASE_POSITION + 1)
		{				
			this._velY = (this._zoomY + UNISAFE_HEIGHT/2 - (LOBBY_BASE_POSITION - this._floorLayer.getPosition().getY())  ) / 8;
		}
		else
		{
			if(this._velY != 0)
			{
				// easing
				this._velY += (0 - this._velY) / 8.0;
			}
		}
		 
		if (Math.abs(this._velY) < 1 && this._velY != 0)
		{
			this._velY = 0;
			this._floorLayer.setPosition(Math.floor(this._floorLayer.getPosition().getX()), Math.floor(this._floorLayer.getPosition().getY())  );
		}
		
		if(! (this._floorLayer.getScale().getX() < 1)) // vista normal edificio (No hay zoomOut)
		{
			this._floorLayer.setPosition(Math.floor(this._floorLayer.getPosition().getX()), Math.round( this._floorLayer.getPosition().getY() - this._velY ));
		}
		else
		{
			if(dict_size(this._floors) > 4 )
			{
				this._floorLayer.setPosition(Math.floor(this._floorLayer.getPosition().getX()), Math.round(this._floorLayer.getPosition().getY() - this._velY ) );
			}
		}
		
		var listY = this._floorLayer.getPosition().getY();
		
        // bottom snap
        if (!this._dragging && (listY < this._botY || dict_size(this._floors) < 3))
        {
            var newY = this._floorLayer.getPosition().getY();
            newY -= Math.floor((newY - this._botY) / 3);
            this._floorLayer.setPosition(this._floorLayer.getPosition().getX(), newY);
        }
        else
        {            
            // Top Snap
            if (this._floorLayer.getScale().getX() < 1)
            {
                // Zoom out
                this._topY = FLOOR_HEIGHT_PIXELS / 4 * (dict_size(this._floors) - 2) ;
            }
            else
            {
                // Normal zoom
                this._topY = FLOOR_HEIGHT_PIXELS * (dict_size(this._floors) - 2);
            }
            
            if (!this._dragging && listY > this._topY)
            {
                var newY = this._floorLayer.getPosition().getY();
                newY -= Math.floor((newY - this._topY) / 3);
                this._floorLayer.setPosition(this._floorLayer.getPosition().getX(), newY);
            }
        }
        
        if (this._floorLayer.getScale().getX() < 1 && (this._floorLayer.getPosition().getY() < this._botY + this.bottomOffset))
        {
            this._floorLayer.setPosition(this._floorLayer.getPosition().getX(), this._botY + this.bottomOffset);
        }
        
        if (this._bgLayer)
        {
            this._bgLayer.setPosition(this._bgLayer.getPosition().getX(), Math.round(this.bottomOffset + (this._floorLayer.getPosition().getY() - this._botY) / 2 ));
        }
        
        // CULLING
        if (Math.abs(this._floorLayer.getPosition().getY() - this._lastCullY) > FLOOR_HEIGHT_PIXELS)
        {
            this.cullFloors();
        }
        
        // FLOOR UPDATES
        var timeSinceUpdate = Core.Time.getRealTime() / 1000 - this._lastFloorUpdate;
        if (timeSinceUpdate > FLOOR_UPDATE_FREQ)
        {
            
            for ( var i = 1; i < this._floors.length; i++)
            {
                this._floors[i].update();
            }
            
            if (std_rand() % 370 == 17 && !this.hasNoteOfType(NOTE_TYPE_FIND, 0) && TTScene.sharedScene().tipNumber() < 1)
            {
                // Chance for finder
                var tnote = TTNote.initWithType(NOTE_TYPE_FIND, 0);
                this.addNote(tnote);
                //tnote = null ;  
            }
            else if (!TTScene.sharedScene()._playerData._readOnly && std_rand() % 266 == 42)
            {
                // BITBOOK
                var entry = TTBitBook.entryFormatForEvent("random");
                var bits = TTScene.sharedScene()._playerData._bitizens;
                
                var allKeys = [];
                for ( var key in bits)
                {
                    allKeys.push(key);
                }
                
                if (allKeys && allKeys.length > 0)
                {
                    var randomIndex = std_random() % allKeys.length;
                    var bInfo = bits[allKeys[randomIndex]];
                    TTBitBook.addNewEntry(entry, bInfo._seed);
                }
            }
            
            this._lastFloorUpdate = Core.Time.getRealTime() / 1000;
            
        }
	},

	resumeWithTimeElapsed : function(/*Core.Time.getRealTime*/time)
	{
	    al_trace("TTowerLayer.resumeWithTimeElapsed - Time Elapsed :" + time);
	    
	    this._lastAutoSave = Core.Time.getRealTime()/1000;
	    TTScene.sharedScene().recordDayOfYear();    
	    
	    var earned = 0;
	    for (var i = 0; i < dict_size(this._floors); i++) {
	        var floor = this._floors[i];
	        earned += Math.floor(floor.resumeWithTimeElapsed(time));
	        
	        al_trace("TTowerLayer.resumeWithTimeElapsed: Earned (" + i + ") "+ earned);
	    }
	    
	    // PAY PLAYER
	    if (earned > 0) {
	        TTScene.sharedScene()._playerData.addCoins(earned);

	        var dlg = TTDialog.initWithMessage(sprintf("WELCOME BACK!\n\n\nWhile you were away your tower earned\n%s coins!", numberAddCommas(earned)), ",continue", null, null, null);
	        TTDialogQueue.sharedQueue().addDialog(dlg);
	    }
	    
	    // RENT
	    var lastRentCheck = NSUserDefaults.standardUserDefaults().integerForKey("lastRentCheck");
	    if (TTScene.sharedScene()._dayOfYear != lastRentCheck) {
	        // PAY RENT
	        var bitCount = dict_size(TTScene.sharedScene()._playerData._bitizens);
	        var rentAmt = bitCount * 100;
	        TTScene.sharedScene()._playerData.addCoins(rentAmt);
	        if (rentAmt > 0) {
	            var dlg = TTDialog.initWithMessage(sprintf("\n\n\nYou have collected\n%s coins\nin rent from your\n%d bitizens!", numberAddCommas(rentAmt), bitCount), ",continue", null, null, null);
	            TTDialogQueue.sharedQueue().addDialog(dlg);
	        }
	        
	        NSUserDefaults.standardUserDefaults().setObject(TTScene.sharedScene()._dayOfYear, "lastRentCheck");
	    }
	    
	    TTScene.sharedScene().recordTimeOfDay();
	    this._bgColor.setColor(TTScene.sharedScene().isDayTime()? ccc3(56,180,244): ccc3(26,18,98));
	    
	    this._awakeTimestamp = Core.Time.getRealTime()/1000;
	    this._coinsSinceAwake = 0;
	},

	addCPM : function(/*int*/coins)
	{
		this._coinsSinceAwake += coins;
	},

	coinsPerMinute : function()
	{
		var timeElapsed = Core.Time.getRealTime()/1000 - this._awakeTimestamp;
		
		return this._coinsSinceAwake / (timeElapsed / 60.0);
	},

	removeBitizenWithSeed : function(/*uint*/seed)
	{
		for ( var i = 0; i < this._floors.length; i++)
		{
			var f = this._floors[i];
			if (f.removeBitizenWithSeed(seed))
			{
				return;
			}
		}
	},

	addBitizen : function(/*uint*/seed, /*int*/story)
	{
		if (story < 0 || story >= this._floors.length)
		{
			return;
		}

		var f = this._floors[story];
		f.addBitizen(seed);
	},

	shiftFloor : function(/*int*/direction)
	{
		var moveIndex = this._movingFloor._storyInfo._story - 1;
		var swapIndex = moveIndex + direction;
		if (swapIndex < 1 || swapIndex > this._floors.length - 1)
		{
			// Nothing to swap
			return;
		}

		var swapFloor = this._floors[swapIndex];
		if (swapFloor)
		{
			al_trace("swapping floor " + this._movingFloor._floorInfo._name + " with floor" + swapFloor._floorInfo._name);

			var oldMoveStory =  this._movingFloor._storyInfo._story;
			var newMoveStory = swapFloor._storyInfo._story;
			var oldSwapStory = swapFloor._storyInfo._story;
			var newSwapStory = this._movingFloor._storyInfo._story;

			// swap positions in floors array
			var tempObject = this._floors[moveIndex];
			this._floors[moveIndex] = this._floors[swapIndex];
			this._floors[swapIndex] = tempObject;

			// swap floors graphically
			var oldMovePos = this._movingFloor._node.getPosition();
			var oldPosX = oldMovePos.getX();
			var oldPosY = oldMovePos.getY();
			
			this._movingFloor._node.setPosition(swapFloor._node.getPosition().getX(),swapFloor._node.getPosition().getY());
			swapFloor._node.setPosition(oldPosX,oldPosY);

			// swap storyInfo story values
			this._movingFloor._storyInfo._story = newMoveStory; 
			swapFloor._storyInfo._story = newSwapStory;  
			this._movingFloor.updateShaftLbl();
			swapFloor.updateShaftLbl();

			// take out and re-insert story infos in gamedata dictionary
			var floorDict = TTScene.sharedScene()._playerData._floors;
 

			dict_remove(floorDict, oldMoveStory);
			dict_remove(floorDict, oldSwapStory);

			floorDict[newMoveStory] = this._movingFloor._storyInfo;
			floorDict[newSwapStory] = swapFloor._storyInfo;

			// run through bitizens and update work & home stories for affected bitizens
			var bitDict = TTScene.sharedScene()._playerData._bitizens;
			for (aKey in bitDict)
			{
				var binfo = bitDict[aKey];
				if (binfo._workFloor == oldMoveStory)
				{
					binfo._workFloor = newMoveStory; 
				}
				else if (binfo._workFloor == oldSwapStory)
				{
					binfo._workFloor = newSwapStory;  
				}

				if (binfo._homeFloor == oldMoveStory)
				{
					binfo._homeFloor = newMoveStory;
				}
				else if (binfo._homeFloor == oldSwapStory)
				{
					binfo._homeFloor = newSwapStory; // creo q se debe dejar campo() para getter y setCampo(var) para setter.
				}
			}

			// run through notifications and update accordingly
			for ( var i = 0; i < this._noteLayer._children.length; i++)
			{
				var note = this._noteLayer._children[i];
				if (note._data && note._data == oldMoveStory)
				{
					note._data = newMoveStory; 
				}
				else if (note._data && note._data == oldSwapStory)
				{
					note._data = newSwapStory;
				}
			}

			SoundBoard.playSfx(SFX_MOVE);
		}
	},

	_ccTouchesBegan : function(/*GL2.Touch*/touchEvent)
	{
		console.log("TTower Touch");
		this._zoomY = LOBBY_BASE_POSITION + 1;

		var leftMargin = new Core.Rect(-this.flankOffset, 0, this.flankOffset, UNISAFE_HEIGHT + this.bottomOffset*2 );
		var rightMargin = new Core.Rect(UNISAFE_WIDTH, 0, this.flankOffset, UNISAFE_HEIGHT + this.bottomOffset*2 );
		
		
		var tp = this._node.screenToLocal(touchEvent.getPosition());
		
		if(CGRectContainsPoint(leftMargin, tp) || CGRectContainsPoint(rightMargin, tp))
		{
			return true;
		}
		if (this._drivingElevator)
		{
			this._lastElevatorTouchX = tp.getX();
		}
		else if (this._moveMode)
		{
			// BUTTON TOUCH
			this.shiftFloor((tp.getX() < UNISAFE_WIDTH / 2) ? 1 : -1);
		}
		else
		{
			// CHECK NOTE LAYER HIT
			if (this._noteLayer.getVisible() && this._noteLayer._children.length > 0)
			{
				var firstNote = this._noteLayer._children[0];
				var noteBox = new Core.Rect(firstNote.getPosition().getX(), firstNote.getPosition().getY() - NOTE_HEIGHT, 
						this._noteLayer._children.length * NOTE_WIDTH/** self.scale */
						, NOTE_HEIGHT/** self.scale */
				);
				if (CGRectContainsPoint(noteBox, tp))
				{
					this._dragging = false;
					return true;
				}
			}

			this._dragging = true;
			this._velY = 0;
			this._totalDrag = 0;
			this._lastTouchY = tp.getY();
			this._lastLastTouchY = tp.getY();
		}

		return true;
	},

	_ccTouchesEnded : function(/*GL2.Touch*/touchEvent)
	{
	    var tp = this._node.screenToLocal(touchEvent.getPosition());

		this._lastElevatorTouchX = 0;
		if (!this._drivingElevator && !this._moveMode && !this._finderMode &&  !this._dragging && !TTScene.sharedScene()._playerData._readOnly && this._noteLayer.getVisible() && this._noteLayer._children.length > 0)
		{
			var firstNote = this._noteLayer._children[0];
			var noteBox = new Core.Rect(firstNote.getPosition().getX(), firstNote.getPosition().getY() - NOTE_HEIGHT , 
					this._noteLayer._children.length * NOTE_WIDTH  /* * this._node.getScale().getX() */, NOTE_HEIGHT /* * this._node.getScale().getX() */); // FIXME; check scale.
			console.log("" + this._noteLayer._children.length * NOTE_WIDTH * this._node.getScale().getX() + ", " + NOTE_HEIGHT * this._node.getScale().getX());

			if (CGRectContainsPoint(noteBox, tp))
			{
				var noteIndex = Math.floor((tp.getX() - firstNote.getPosition().getX()) / NOTE_WIDTH);
				al_trace("NOTE " + noteIndex + " TAPPED.");

				if (noteIndex < this._noteLayer._children.length)
				{
					var note = this._noteLayer._children[noteIndex];
					if (note._noteType == NOTE_TYPE_FIND)
					{
						this.clearNoteOfType(NOTE_TYPE_FIND, 0);

						// Ask to start finder mode
						var bits = TTScene.sharedScene()._playerData._bitizens;
						//var bitKeys = bits.allKeys();
						var bitsArray = [];
						for (var b in bits) {
						    if (bits.hasOwnProperty(b)) {
						        bitsArray.push(bits[b]);
						    }
						}
						if (bits && bitsArray.length > 0)
						{
							this._finderBitInfo = bitsArray[std_rand() % bitsArray.length];

							var fbit = TTBitizen.initWithSeed(this._finderBitInfo._seed);
							var fMsg = sprintf(TTFinder.randFinderFormat(), fbit._name, fbit._male ? "him" : "her"); 
							var dlg = TTDialog.initWithMessage(sprintf("\n\n\n\n\n\n" + fMsg), "NO,YES", this.startFinderDialog, this, null);
							TTDialogQueue.sharedQueue().addDialog(dlg);
							//(0,-74)
							fbit._node.setPosition(55,-150);
							//fbit._node.setPosition(0, -84);
							dlg._node._children[1+2].addChild(fbit._node);
							TTDialogQueue.sharedQueue().addDialog(dlg);
						}
						else
						{
							return;
						}
					}
					else
					{
						var noteData = note._data;
						if (noteData)
						{
							var noteFloor = noteData;
							this._zoomY = LOBBY_BASE_POSITION - (noteFloor - 1) * FLOOR_HEIGHT_PIXELS;
						}
					}
				}
			}
		}

		if (!this._dragging)
		{
			return;
		}
		
		this._dragging = false;
		this._velY = this._lastLastTouchY - tp.getY();
		
		//FIXME, this._moveMode lo puse a la mala, no se donde esta en el original, pero es para evitar bug.
		// test for tap
		if (this._totalDrag < 5 && !TTScene.sharedScene()._playerData._readOnly && !this._moveMode) 
		{
			this._velY = 0;
			// TAP TOP TO SCROLL
			if (tp.getY() > UNISAFE_HEIGHT - 20)
			{
				//this._zoomY = (this._floors.length) * FLOOR_HEIGHT_PIXELS;
				return;
			}

			tp.setX(tp.getX() - this._floorLayer.getPosition().getX());
			tp.setY(tp.getY() - this._floorLayer.getPosition().getY());
			
			if (this._floorLayer.getScale().getX() != 1)
			{
				return;
			}
			
			// CRANE CHECK
			if (!this._moveMode && !this._finderMode && CGRectContainsPoint(createBB(this._crane), tp)) 
			{
				var fcost = this.nextFloorCost();

				// Check coins
				if (TTScene.sharedScene()._playerData._coins < fcost)
				{
					var dlg = TTDialog.initWithMessage("\n\n\nYou do not have enough coins to build a new floor.", ",Continue", null, this, null);
					TTDialogQueue.sharedQueue().addDialog(dlg);
				}
				else
				{
					// Ask to build new floor
					var dlg = TTDialog.initWithMessage("\n\n\n\nBuild a new floor at a cost of " + numberAddCommas(fcost) + " coins?", "NO,YES", this.buildNewFloorDialog.bind(this), this, fcost);
					TTDialogQueue.sharedQueue().addDialog(dlg);

					// TIP 2
					if (TTScene.sharedScene().tipNumber() == 1 ) 
					{
						var ttl = TTutorialLayer.initWithStep(2, "TAP YES");
						TTScene.sharedScene().runTipLayer(ttl);

					}
				}

				return;
			}

			for ( var i = 0; i < this._floors.length; i++)
			{
				var child = this._floors[i];
				var bb = new Core.Rect(child._node.getPosition().getX(), child._node.getPosition().getY(), UNISAFE_WIDTH, FLOOR_HEIGHT_PIXELS);

				if (CGRectContainsPoint(bb, tp))
				{
					al_trace("Floor " + i + " tapped!");
					var tFloor = this._floors[i];
					if (true)
					{
						if (this._finderMode)
						{
							// Check floor for finder bit
							console.log("*** " + this._finderBitInfo._seed);
							var fBit = TTBitizen.initWithSeed(this._finderBitInfo._seed);
							if (tFloor.containsBitizenWithSeed(this._finderBitInfo._seed))
							{
								var dlg = TTDialog.initWithMessage("\n\n\nThanks for helping to find " + fBit._name + "! Here is a Tower Buck for your trouble.", ",Continue", null,  null, null);
								TTDialogQueue.sharedQueue().addDialog(dlg);

								TTScene.sharedScene()._playerData.addBux(1);
								this.cancelFinder();
							}
							else
							{
								var dlg = TTDialog.initWithMessage("\n\n\n\n" + fBit._name + " Is not on this floor!", ",Continue", null, null, null);
								TTDialogQueue.sharedQueue().addDialog(dlg);
							}
							//fBit.destroy();
						}
						else if (i == 0 && this._elevator.hasOccupant() && this._floors[0]._infoIcon)
						{
							if (this._elevator.isOccupantVIP())
							{
								var msg = "";
								switch (this._elevator._occupant._seed)
								{
								case BITIZEN_SEED_CONSTRUCTION:
									msg = "\n\n\n\n\nA V.I.P. has arrived!\n\n\nThis construction worker will take 3 hours off any construction floor you deliver them to!";
									break;
								case BITIZEN_SEED_DELIVERYMAN:
									msg = "\n\n\n\n\nA V.I.P. has arrived!\n\n\nThis deliveryman will take 3 hours off any restocking floor you deliver them to!";
									break;
								case BITIZEN_SEED_BIGSPENDER:
									msg = "\n\n\n\n\nA V.I.P. has arrived!\n\n\nThis big spender will buyout all of one product of the floor you deliver them to!";
									break;
								case BITIZEN_SEED_CELEBRITY:
									msg = "\n\n\n\n\nA V.I.P. has arrived!\n\n\nThis celebrity will temporarily increase customers of the floor you deliver them to!";
									break;
								case BITIZEN_SEED_REALESTATE:
									msg = "\n\n\n\nvA V.I.P. has arrived!\n\n\nThis real estate agent will move a new bitizen into the residential floor you deliver them to!";
									break;
								default:
									break;
								}
								var dlg = TTDialog.initWithMessage(sprintf(msg), ",Continue", null,  null, null);
								TTDialogQueue.sharedQueue().addDialog(dlg);
							}
							else
							{
								var lbl = LabelConfigurer.createLabelWithString("" + this._elevator._riderFloor._storyInfo._story, "silkscreen", FONT14, [0.5, 0.5], true);
								lbl.setColor(ccc3(0, 0, 0));
								
								var _scale = lbl.getScale();
						        lbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
						        
								this._elevator._occupant.setSpeech(lbl);
							}
							this._elevator._node.AL_setTag(-1);
							this._lastElevatorTouchX = 0;
							this._drivingElevator = true;
							// HACK
							if (this._node._children.indexOf(this._elevatorControls) == -1) 
							{
    							this._elevatorControls = TTSpriteFactory.spriteWithFile("elevator_controls.png");
    							this._elevatorControls.setPosition(Math.round( (UNISAFE_WIDTH / 2)-95 ) , 345);
    							this._elevatorControls.setDepth(2001);
							}
							// END HACK
							this._node.addChild(this._elevatorControls);
							this.clearNoteOfType(this._elevator.isOccupantVIP() ? NOTE_TYPE_VIP : NOTE_TYPE_RIDER, (1));

							this._floors[0].clearInfoIcon();
							this._floors[0].clearInfoLabel();
							
							this._elevator.setMaxVel(4.0 + this._floors.length * 0.15); 
							TTHud.sharedHud().showZoomButton(false);
							// Function end
							if (TTScene.sharedScene().tipNumber() == 9)
							{
								// TIP 10
								var ttl = TTutorialLayer.initWithStep(10, "TAKE RIDER TO 2ND FLOOR");
								TTScene.sharedScene().runTipLayer(ttl);
							}
						}
						else if (i == 0 && !tFloor._infoIcon && TTScene.sharedScene().tipNumber() < 1)
						{
							var fpl = TTFloorPaintLayer.initWithFloor(tFloor);
							TTScene.sharedScene().runMenuLayer(fpl);
						}
						else if (i > 0)
						{
							al_trace("" + tFloor._storyInfo._floorId);
							if (tFloor._storyInfo._floorId == FLOOR_ID_EMPTY)
							{
								if (TTScene.sharedScene().tipNumber() == 4)
								{
									// TIP 5
									var ttl = TTutorialLayer.initWithStep(5, "SELECT A FLOOR TYPE");
									TTScene.sharedScene().runTipLayer(ttl);
									TTScene.sharedScene()._playerData.addCoins(300);
								}

								// NEW FLOOR PICKER
								TTHud.sharedHud().showZoomButton(false);
								var zl = TTZoneLayer.initWithNewFloor(tFloor);
								TTScene.sharedScene().runMenuLayer(zl);
							}
							else if (tFloor.hasFinishedProduct())
							{
								tFloor.addStock();
							}
							else if (tFloor.hasProblem())
							{
								tFloor.fixProblem();
								this.clearNoteOfType(NOTE_TYPE_EXCLAIM, tFloor._storyInfo._story);
							}
							else if (tFloor._hasRent)
							{
								tFloor.collectCoins();
							}
							else
							{
								// FLOOR FOCUS
								var ffl = TTFloorFocusLayer.initWithFloor(tFloor);
								TTScene.sharedScene().runMenuLayer(ffl);
								if (TTScene.sharedScene().tipNumber() == 6)
								{
									// TIP 7
									var ttl = TTutorialLayer.initWithStep(7, "TAP THE HURRY BUTTON");
									TTScene.sharedScene().runTipLayer(ttl);
								}
								else if (TTScene.sharedScene().tipNumber() == 14)
								{
									// TIP 15
									var ttl = TTutorialLayer.initWithStep(15, "TAP BITIZEN (PERSON)");
									TTScene.sharedScene().runTipLayer(ttl);
								}
								else if (TTScene.sharedScene().tipNumber() == 18)
								{
									// TIP 19
									var ttl = TTutorialLayer.initWithStep(19, "RESTOCK FOOD ITEM");
									TTScene.sharedScene().runTipLayer(ttl);
								}
							}
						}
					}
				}
			}
		}
	},

	ccTouchCancelled : function(/*GL2.Touch*/touchEvent)
	{
		this._lastElevatorTouchX = 0;
		if (!this._dragging)
		{
			return;
		}

		var tp = this._node.screenToLocal(touchEvent.getPosition());
		this._dragging = false;
		this._velY = this._lastLastTouchY - tp.getY();
	},

	_ccTouchesMoved : function(/*GL2.Touch*/touchEvent)
	{
		var tp = this._node.screenToLocal(touchEvent.getPosition());
		if (this._drivingElevator)
		{
			this._lastElevatorTouchX = tp.getX();
		}
		
		if (!this._dragging)
		{
			return;
		}

		this._lastLastTouchY = this._lastTouchY;
		this._lastTouchY = tp.getY();
		this._totalDrag += Math.abs(this._lastLastTouchY - this._lastTouchY);
		this._floorLayer.setPosition(this._floorLayer.getPosition().getX(), this._floorLayer.getPosition().getY() - (this._lastLastTouchY - this._lastTouchY));
	},

	isScrolling : function()
	{
		return this._drivingElevator || this._dragging;
	},

	stopMovingFloor : function()
	{
		this._moveMode = false;
		this._movingFloor = null;

		this._moveControls.AL_removeFromParentAndCleanup(true);
		//this.removeChild(this._moveControls);

		TTHud.sharedHud().showCloseButton(false);
		TTHud.sharedHud().showZoomButton(true);
	},

	startMovingFloor : function(/*TTFloor*/mFloor)
	{
		TTScene.sharedScene().runMenuLayer(null);
		this._moveMode = true;
		this._movingFloor = mFloor;
		this._moveControls = TTSpriteFactory.spriteWithFile("elevator_controls.png");
		this._moveControls.setPosition(UNISAFE_WIDTH / 2 -95, 345);
        this._moveControls.setDepth(2001);
		this._node.addChild(this._moveControls);

		TTHud.sharedHud().setCloseCallback(this.stopMovingFloor.bind(this), this);
		TTHud.sharedHud().showCloseButton(true);
		TTHud.sharedHud().showZoomButton(false);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTFloorFocusLayer'] = function(){var exports = $MODULE_REGISTRY['Code/TTFloorFocusLayer'] || {}; $MODULE_REGISTRY['Code/TTFloorFocusLayer'] = exports; var STOCK_LABEL_TAG = 100;
var STOCK_BAR = 150;
var STOCK_BAR_SHADE = 200;

exports.TTFloorFocusLayer = BaseClass.subclass({
    classname : 'TTFloorFocusLayer',
    
    initialize : function(width, height, flr)
    {
        this._prodButtonArr = [];
        this._stockButtonArr = [];
        this._workerButtonArr = [];
        this._prevStock = [];
        /*
        this._focusFloor;
        this._workers;
        this._workerBonus;
        this._collectButton;
        this._hurryButton;
        this._destroyButton;
        this._moveButton;
        this._paintButton;
        this._numFormat;
        this._titleLbl;
        this._tfield;
        this._origStr;
        */
        
        this._progShade = null;
        this._heartShade = null;
        this._ptimeLeftLbl = null;
        this._numBeds = -1;
        this._happyCount = -1;
        
        // Enable input
        this.setTouchTargetToScreenSize();
        
        this._focusFloor = flr;

//        var _shade = ALLayerColor.layerWithColor(ccc3(0, 0, 0), 0.5, UNISAFE_WIDTH, UNISAFE_HEIGHT + TTScene.sharedScene()._towerLayer.bottomOffset*2);
//        _shade.setPosition( UNISAFE_WIDTH / 2, UNISAFE_HEIGHT / 2 );
////        this._node.addChild(_shade);
        TTScene.shadeLayer(true);
        
        var bg = TTSpriteFactory.spriteWithFile('focus_bg.png', [ 0.5, 0.5 ]);
        bg.setPosition(UNISAFE_WIDTH / 2, UNISAFE_HEIGHT / 2 - HUD_BAR_HEIGHT / 2);
        this._node.addChild(bg);
        
        var textBox = ALLayerColor.layerWithColor(ccc3(255, 255, 255), 1, 140, 16, [ 0, 0 ]);

        // FIXME : check the Y coord, seems not match the screen
        textBox.setPosition(UNISAFE_WIDTH / 2 - 70, UNISAFE_HEIGHT - (442 + HUD_BAR_HEIGHT / 2 - 8));
        this._node.addChild(textBox);
        
        this._titleLbl = LabelConfigurer.createLabelWithString(this._focusFloor._floorInfo._name.toUpperCase(), "silkscreen", FONT14, [ 0.5, 0 ], true);
        this._titleLbl.setColor(ccc3(48, 55, 81));

		var _scale = this._titleLbl.getScale();
        this._titleLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        this._titleLbl.setPosition(UNISAFE_WIDTH / 2, UNISAFE_HEIGHT - (442 + HUD_BAR_HEIGHT / 2) + 8);
        this._node.addChild(this._titleLbl);
        
        this._numBeds = -1;
        if (this._focusFloor._floorInfo._type == FLOOR_TYPE_RESIDENTIAL)
        {
            this._numBeds = 5;
            al_trace(sprintf("Num beds: %d", this._numBeds));
        }
        
        if (this._focusFloor._floorInfo._fid != FLOOR_ID_CONSTRUCTION)
        {
            
            if (this._focusFloor._floorInfo._type == FLOOR_TYPE_RESIDENTIAL)
            {
                var bedLbl = LabelConfigurer.createLabelWithString(sprintf("%d BED", this._numBeds), "silkscreen", FONT14, [ 0.5, 0 ], true);

        		var _scale = bedLbl.getScale();
                bedLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
                
                bedLbl.setPosition(UNISAFE_WIDTH / 2, this._titleLbl.getPosition().getY() + 16);
                this._node.addChild(bedLbl);
            }
            else
            { 
                var popLbl = LabelConfigurer.createLabelWithString(sprintf("DEMAND: %d", TTScene.sharedScene()._towerLayer.busTypePopularities()[this._focusFloor._floorInfo._type]*100), "silkscreen", FONT14, [ 0.5, 0 ], true);

        		var _scale = popLbl.getScale();
                popLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);

                popLbl.setPosition(UNISAFE_WIDTH / 2, this._titleLbl.getPosition().getY() + 16);
                this._node.addChild(popLbl);
            }
            
            var typeLbl = LabelConfigurer.createLabelWithString(sprintf("-%s-", TTScene.floorTypeString(this._focusFloor._floorInfo._type)), "silkscreen", FONT14, [ 0.5, 0.5 ], true);
            typeLbl.setColor(TTScene.floorTypeColor(this._focusFloor._floorInfo._type));

    		var _scale = typeLbl.getScale();
            typeLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);

            this._node.addChild(typeLbl);
        }
        
        this._destroyButton = TTSpriteFactory.spriteWithFile("floor_focus_demolish_button.png", [ 0.5, 0.5 ]);
        this._destroyButton.setPosition(bg.getPosition().getX() - 76, bg.getPosition().getY() + 186);
        this._node.addChild(this._destroyButton);
        this._destroyButton.setAlpha(64 / 255);
        
        this._moveButton = TTSpriteFactory.spriteWithFile("floor_focus_move_button.png", [ 0.5, 0.5 ]);
        this._moveButton.setPosition(bg.getPosition().getX(), bg.getPosition().getY() + 186);
        this._node.addChild(this._moveButton);
        this._moveButton.setAlpha(1);
        
        this._paintButton = TTSpriteFactory.spriteWithFile("floor_focus_paint_button.png", [ 0.5, 0.5 ]);
        this._paintButton.setPosition(bg.getPosition().getX() + 76, bg.getPosition().getY() + 186);
        this._node.addChild(this._paintButton);
        if (this._focusFloor._floorInfo._fid == FLOOR_ID_CONSTRUCTION)
    	{
            this._paintButton.setAlpha(64 / 255);
    	}
        //BITIZENS
        this._workerBonus = 0;
        this._happyCount = 0;
        if (this._focusFloor._floorInfo._type == FLOOR_TYPE_RESIDENTIAL)
        {
            this._workers = TTScene.sharedScene()._playerData.bitizensWithHomeFloor(this._focusFloor._storyInfo._story);            
        }
        else
        {
            this._workers = TTScene.sharedScene()._playerData.bitizensWithWorkFloor(this._focusFloor._storyInfo._story);
        }
        
        if (this._focusFloor._floorInfo._fid != FLOOR_ID_CONSTRUCTION)
        {
            for ( var w = 0; (this._numBeds < 0 && w < 3) || (this._numBeds > 0 && w < this._numBeds); w++)
            {
                var imageSize = new Core.Size(DataPreloader._imageSizes["floor_focus_worker_bg.png"]);
                
                var wb;
                if (this._focusFloor._floorInfo._type == FLOOR_TYPE_RESIDENTIAL)
                {
                	wb = TTSpriteFactory.spriteWithFile_withTexture("floor_focus_worker_bg.png",[0, 4/imageSize.getHeight(), 1, (imageSize.getHeight() - 22)/imageSize.getHeight()], [0.5 , 0.5 ]);
                }
                else
                {
                	wb = TTSpriteFactory.spriteWithFile("floor_focus_worker_bg.png", [ 0.5, 0.5 ]);
                }
                this._workerButtonArr[w] = wb;
                this._node.addChild(wb);
                
                if (this._focusFloor._floorInfo._type == FLOOR_TYPE_RESIDENTIAL)
                {
                    wb.setPosition(bg.getPosition().getX() - bg.AL_getSize().getWidth()/4 - 3*2, bg.getPosition().getY() - bg.AL_getSize().getHeight()/4 + w * (wb.AL_getSize().getWidth() - 10) - 8);
                }
                else
                {
                    wb.setPosition(bg.getPosition().getX() - bg.AL_getSize().getWidth()/4 + w * wb.AL_getSize().getWidth() * wb.getScale().getX() - 3*2, bg.getPosition().getY() - bg.AL_getSize().getHeight()/4 + 8);
                }
                
                if (this._numBeds > 0 && this._workers.length < this._numBeds && w >= this._workers.length)
                {
                    // FOR RENT
                    var rentLbl = LabelConfigurer.createLabelWithString(sprintf(" FOR\nRENT \n1"), "silkscreen", FONT12, [ 0.5, 0.5 ], true);

            		var _scale = rentLbl.getScale();
                    rentLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);

                    rentLbl.setColor(ccc3(20, 20, 40));
                    rentLbl.setPosition(0, 0);
                    wb.addChild(rentLbl);
                    var rbux = TTSpriteFactory.spriteWithFile("bux.png", [ 0.5, 0.5 ]);
                    rbux.setPosition(0, 14);
                    wb.addChild(rbux);
                }
                else if (this._workers.length > w)
                {
                    var binfo = this._workers[w];
                    var wbit = TTBitizen.initWithSeed(binfo._seed);
                    
                    wbit._node.setPosition(wb.getPosition().getX() - 2, wb.getPosition().getY());
                    this._node.addChild(wbit.getNode());
                    
                    if (this._focusFloor._floorInfo._type != FLOOR_TYPE_RESIDENTIAL)
                    {
                        
                        var skill = TTBitizen.skillIn(this._focusFloor._floorInfo._type, binfo._seed);
                        this._workerBonus += skill;
                        var skillLbl = LabelConfigurer.createLabelWithString(skill, "silkscreen", FONT14, [0.5, 0.5], true);

                		var _scale = skillLbl.getScale();
                        skillLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
                        
                        skillLbl.setColor(TTScene.floorTypeColor(this._focusFloor._floorInfo._type));
                        skillLbl.setPosition(-2, wb.AL_getSize().getHeight() / 2 - 6);
                        wb.addChild(skillLbl);
                    }
                    else
                    {
                        //wbit._node.setPosition(wbit._node.getPosition().getX(),wbit._node.getPosition().getY()-7);
                        wbit._node.setPosition(wbit._node.getPosition().getX(), wbit._node.getPosition().getY() + 7);
                        //[wb setTextureRect:CGRectMake(0, 0, wb.AL_getSize().getWidth(), wb.AL_getSize().getHeight()-10)];
                        
                        // NAME AND JOB

                        var nameLbl = LabelConfigurer.createLabelWithString(wbit._name, "silkscreen", FONT14, [ 0, 1 ], true);

                		var _scale = nameLbl.getScale();
                        nameLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);

                        // [CCLabelBMFont labelWithString:wbit.name fntFile:"silkscreen"];
                        nameLbl.setPosition(wb.AL_getSize().getWidth()/2, -14);

                        wb.addChild(nameLbl);
                        
                        // Employed at
                        var employLbl = LabelConfigurer.createLabelWithString("EMPLOYED AT", "silkscreen", FONT14, [ 0, 1 ], true);
                        // [CCLabelBMFont labelWithString:"EMPLOYED AT:" fntFile:"silkscreen"];
                        
                		var _scale = employLbl.getScale();
                        employLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
                        
                        employLbl.setColor(ccc3(145, 135, 186));
                        employLbl.setPosition(wb.AL_getSize().getWidth()/2, nameLbl.getPosition().getY() + 18);
                        wb.addChild(employLbl);
                        
                        var workName = "UNEMPLOYED";
                        var workColor = ccc3(255, 255, 255);
                        if (binfo._workFloor > 0)
                        {
                            var sInfo = TTScene.sharedScene()._playerData.getStoryInfo(binfo._workFloor);
                            var fInfo = TTFloorTable.floorWithId(sInfo._floorId);
                            workName = fInfo._name.toUpperCase();
                            workColor = TTScene.floorTypeColor(fInfo._type);
                        }
                        var employ2Lbl = LabelConfigurer.createLabelWithString(workName, "silkscreen", FONT14, [ 0, 1 ], true);
                        
                		var _scale = employ2Lbl.getScale();
                        employ2Lbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
                        
                        employ2Lbl.setColor(workColor);
                        employ2Lbl.setPosition(wb.AL_getSize().getWidth() / 2, employLbl.getPosition().getY() + 14);
                        wb.addChild(employ2Lbl);
                    }
                    
                    // mood
                    var happiness = wbit.happiness();
                    if (happiness == "happy")
                    {
                        this._happyCount++;
                    }
                    
                    var mood = TTSpriteFactory.spriteWithFile(sprintf("mood_%s.png", happiness), [ 0.5, 0.5 ]);
                    al_trace(wb.getPosition().getX() + 16);
                    al_trace(wbit._node.getPosition().getY() + 4);
                    
                    mood.setPosition(wb.getPosition().getX() + 16, wbit._node.getPosition().getY() + 4);
                    mood.setScale(0.5,0.5);
                    this._node.addChild(mood);
                    
                }
                else
                {
                    //[wb.setAlpha(64];
                    var hireLbl = LabelConfigurer.createLabelWithString("HIRE", "silkscreen", FONT14, [0.5, 0.5], true);
                    
            		var _scale =hireLbl.getScale();
                    hireLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);

                    hireLbl.setColor(ccc3(20, 20, 40));
                    hireLbl.setPosition(-1, -2);
                    wb.addChild(hireLbl);
                }
            }
        }
        
        if (this._focusFloor._storyInfo._activeProduct < 0)
        {
            // NO PRODUCT
            this._destroyButton.setAlpha(1);
            
            for ( var p = 0; p < 3; p++)
            {
                var pb = TTSpriteFactory.spriteWithFile("floor_focus_prod_button_stocked.png", [ 0.5, 0.5 ]);
                this._stockButtonArr[p] = pb;
                pb.setVisible(false);
                this._node.addChild(pb);
                pb.setPosition(UNISAFE_WIDTH / 2 + 1, 193 + parseInt((this._focusFloor._floorInfo._type == FLOOR_TYPE_RESIDENTIAL ? 2 : p) * pb.AL_getSize().getHeight()*pb.getScale().getX()) + HUD_BAR_HEIGHT / 2);
                
                if (this._focusFloor._storyInfo._stock[p] > 0)
                {
                    pb.setVisible(true);
                }
                
                var picon = this._focusFloor.getProductSprite(this._focusFloor._floorInfo._type == FLOOR_TYPE_RESIDENTIAL ? p + 1 : p);
                pb.addChild(picon);
                picon.setPosition(-pb.AL_getSize().getWidth() / 2 + picon.AL_getSize().getWidth() + 4, -(pb.AL_getSize().getHeight()/2) + 8 );

                
                var pnameLbl = LabelConfigurer.createLabelWithString(this._focusFloor._floorInfo._products[p]._name.toUpperCase(), "silkscreen", FONT14, [0, 0], true);
                pnameLbl.setColor(ccc3(208, 201, 255));
                pnameLbl.setPosition(-pb.AL_getSize().getWidth() / 2 + picon.AL_getSize().getWidth() + 5*2, -pb.AL_getSize().getHeight()/2 + 10);
              
        		var _scale = pnameLbl.getScale();
                pnameLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
                
                pb.addChild(pnameLbl);
                
                for ( var c = 0; c < p + 1; c++)
                {
                    var ccoin = TTSpriteFactory.spriteWithFile("coin.png", [ 0, 0.5 ]);
                    ccoin.setPosition(pnameLbl.getPosition().getX() + pnameLbl.getSize().getWidth()*2 + 69*2 + 6 * c, pnameLbl.getPosition().getY() +6);

                    pb.addChild(ccoin);
                }
                
                this._prevStock[p] = this._focusFloor._storyInfo._stock[p];

                var pstockLbl = LabelConfigurer.createLabelWithString(sprintf("IN STOCK: %s", Math.floor(this._focusFloor._storyInfo._stock[p])), "silkscreen", FONT14, [0, 0], true);
                
        		var _scale = pstockLbl.getScale();
                pstockLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
                
                pstockLbl.AL_setTag(STOCK_LABEL_TAG);
                pstockLbl.setColor(INFO_COLOR_STOCK);
                pstockLbl.setPosition(pnameLbl.getPosition().getX(), pnameLbl.getPosition().getY() + 16);

                pb.addChild(pstockLbl);
                
                var pbux = TTSpriteFactory.spriteWithFile("bux.png", [ 0, 0 ]);
                pbux.setPosition(-pb.AL_getSize().getWidth() / 2 + 8, 14);

                pb.addChild(pbux);
                
                var quickSellCost = Math.ceil(this._focusFloor._storyInfo._stock[p] * (p + 1) / BUX_STOCK_WORTH);
                var psellLbl = LabelConfigurer.createLabelWithString(sprintf("%d TO QUICK SELL", quickSellCost), "silkscreen", FONT14, [0, 0], true);
                psellLbl.setPosition(pbux.getPosition().getX() + pbux.AL_getSize().getWidth() + 6, pbux.getPosition().getY());
                
        		var _scale = psellLbl.getScale();
                psellLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
                
                pb.addChild(psellLbl);
                
                // STOCK PROG BAR
                if (this._focusFloor._floorInfo._type != FLOOR_TYPE_RESIDENTIAL)
                {
                    var hBarBg = ALLayerColor.layerWithColor(ccc3(107, 100, 152), 1, 160, 6, [ 0, 0.5 ]);
                    pb.addChild(hBarBg);
                    hBarBg.setPosition(pbux.getPosition().getX() + 16, pbux.getPosition().getY() - 6);
                    
                    var hBarInsert = ALLayerColor.layerWithColor(ccc3(55, 52, 87), 1, 156, 2, [ 0, 0 ]);
                    hBarBg.addChild(hBarInsert);
                    hBarInsert.setPosition(2, -2);
                    
                    this._heartShade = ALLayerColor.layerWithColor(ccc3(253, 240, 209), 1, 156, 6, [ 0, 0 ]);
                    // [CCLayerColor layerWithColor:(ccColor4B){253,240,209,255} width:80-2 height:1];
                    hBarBg.AL_setTag(STOCK_BAR);
                    hBarBg.addChild(this._heartShade);
                    this._heartShade.setPosition(1, -1);
                    this._heartShade.AL_setTag(STOCK_BAR_SHADE);
                    var totalStock = TTScene.quantityForProdTime(this._focusFloor._floorInfo._products[p]._time);
                    if (this._happyCount > 0 && p < this._happyCount)
                    {
                        totalStock *= 2;
                    }
                    
                    var heartProg = this._focusFloor._storyInfo._stock[p] / totalStock;
                    if (heartProg > 1)
                    {
                        heartProg = 1;
                    }
                    
                    this._heartShade.setScale(1, 0.5);
                    this._heartShade.setScale(heartProg, this._heartShade.getScale().getY());
                }
            }
            
            for ( var p = 0; p < 3; p++)
            {
                var pb = TTSpriteFactory.spriteWithFile("floor_focus_prod_button.png", [ 0.5, 0.5 ]);
                this._prodButtonArr[p] = pb;
                this._node.addChild(pb);
                pb.setPosition(UNISAFE_WIDTH / 2 + 1, 193 + parseInt((this._focusFloor._floorInfo._type == FLOOR_TYPE_RESIDENTIAL ? 2 : p) * pb.AL_getSize().getHeight() * pb.getScale().getX()) + HUD_BAR_HEIGHT / 2);
                
                if (p >= this._workers.length)
                {
                    pb.setVisible(false);
                }
                if (this._focusFloor._floorInfo._type == FLOOR_TYPE_RESIDENTIAL)
                {
                    pb.setVisible(p == this._numBeds - 1 && p < 2);
                }
                
                var picon = this._focusFloor.getProductSprite(this._focusFloor._floorInfo._type == FLOOR_TYPE_RESIDENTIAL ? p + 1 : p);
                pb.addChild(picon);
                picon.setPosition(-pb.AL_getSize().getWidth() / 2 + picon.AL_getSize().getWidth() + 4, -(pb.AL_getSize().getHeight()/2) + 8);
                
                
                var pnameLbl = LabelConfigurer.createLabelWithString(this._focusFloor._floorInfo._products[p]._name, "silkscreen", FONT14, [0, 0], true);
                
        		var _scale = pnameLbl.getScale();
                pnameLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
                
                pnameLbl.setColor(ccc3(208, 201, 255));
                pnameLbl.setPosition(-pb.AL_getSize().getWidth() / 2 + picon.AL_getSize().getWidth() + 5, -pb.AL_getSize().getHeight() / 2 +10);
                pb.addChild(pnameLbl);
                
                for ( var c = 0; c < p + 1; c++)
                {
                    var ccoin = TTSpriteFactory.spriteWithFile("coin.png", [ 0, 0.5 ]);
                    ccoin.setPosition(pnameLbl.getPosition().getX() + pnameLbl.getSize().getWidth()*2 + 69*2 + 6 * c, pnameLbl.getPosition().getY() + 6);

                    pb.addChild(ccoin);
                }
                
                var pcoin1 = TTSpriteFactory.spriteWithFile("coin.png", [ 0, 0 ]);

                pcoin1.setPosition(pnameLbl.getPosition().getX(), pnameLbl.getPosition().getY() + 16);

                pb.addChild(pcoin1);
                
                var pcostLbl = LabelConfigurer.createLabelWithString(sprintf("%s", TTScene.costForProdTime(this._focusFloor._floorInfo._products[p]._time, this._workerBonus)), "silkscreen", FONT14, [0, 0.5], true);
                
        		var _scale = pcostLbl.getScale();
                pcostLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
                
                pcostLbl.setColor(ccc3(255, 207, 92));
                pcostLbl.setPosition(pcoin1.getPosition().getX() + pcoin1.AL_getSize().getWidth() + 1, pcoin1.getPosition().getY() + pcoin1.AL_getSize().getHeight() / 2);
                pb.addChild(pcostLbl);
                
                if (this._focusFloor._floorInfo._type != FLOOR_TYPE_RESIDENTIAL)
                {
                    var bonusLbl = LabelConfigurer.createLabelWithString(this._workerBonus + "% OFF", "silkscreen", FONT14, [0, 0.5], true);
                    
            		var _scale = bonusLbl.getScale();
                    bonusLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
                    
                    bonusLbl.setColor(ccc3(106, 250, 66));
                    bonusLbl.setPosition(pcostLbl.getPosition().getX() + /*pcostLbl.AL_getSize().getWidth() FIXME !! */18 + 20, pcostLbl.getPosition().getY());
                    pb.addChild(bonusLbl);
                }
                
                var pclock = TTSpriteFactory.spriteWithFile("floor_focus_clock.png", [ 0.5, 0.5 ]);

                pclock.setPosition(-pb.AL_getSize().getWidth() / 2 + picon.AL_getSize().getWidth() / 2, 16);

                
                pb.addChild(pclock);
                
                var ptimeLbl = LabelConfigurer.createLabelWithString(TTScene.timeString(this._focusFloor._floorInfo._products[p]._time * 60).toUpperCase(), "silkscreen", FONT14, [0, 0.5], true);
                
        		var _scale = ptimeLbl.getScale();
                ptimeLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
                // [CCLabelBMFont labelWithString:[[TTScene timeString:this._focusFloor._floorInfo._products[p].time*60] uppercaseString] fntFile:"silkscreen"];
                ptimeLbl.setPosition(pclock.getPosition().getX() + pclock.AL_getSize().getWidth(), pclock.getPosition().getY());
                pb.addChild(ptimeLbl);
                
                if (this._focusFloor._floorInfo._type != FLOOR_TYPE_RESIDENTIAL)
                {
                    var pqtyLbl = LabelConfigurer.createLabelWithString(sprintf("QTY %d", TTScene.quantityForProdTime(this._focusFloor._floorInfo._products[p]._time)), "silkscreen", FONT14, [0, 0.5], true);
                    
            		var _scale = pqtyLbl.getScale();
                    pqtyLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
                    // [CCLabelBMFont labelWithString:[NSString stringWithFormat:"QTY: %",[this._numFormat stringFromNumber:[NSNumber numberWithInt:[TTScene quantityForProdTime:this._focusFloor._floorInfo._products[p].time]]]] fntFile:"silkscreen"];
                    pqtyLbl.setColor(ccc3(208, 201, 255));
                    pqtyLbl.setPosition(ptimeLbl.getPosition().getX() + /*ptimeLbl.AL_getSize().getWidth() FIXME; */+50, ptimeLbl.getPosition().getY());

                    pb.addChild(pqtyLbl);
                    
                    if (this._happyCount > 0 && p < this._happyCount)
                    {
                        var hbonusLbl = LabelConfigurer.createLabelWithString("X2", "silkscreen", FONT14, [0, 0.5], true);
                        
                		var _scale = hbonusLbl.getScale();
                        hbonusLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
                        hbonusLbl.setColor(ccc3(106, 250, 66));
                        hbonusLbl.setPosition(pqtyLbl.getPosition().getX() + 30 + (((pqtyLbl.getText().length / 2) + 0.5) * 13) + 1, pqtyLbl.getPosition().getY() );
                        pb.addChild(hbonusLbl);
                    }
                }
            }
            
        }
        else
        {
            // ACTIVE PRODUCT
            var pb = TTSpriteFactory.spriteWithFile("floor_focus_prod_activebg.png", [ 0.5, 0.5 ]);
            this._node.addChild(pb);
            pb.setPosition(UNISAFE_WIDTH / 2 + 2, this._focusFloor._floorInfo._fid == FLOOR_ID_CONSTRUCTION ? (UNISAFE_HEIGHT - 260 + HUD_BAR_HEIGHT / 2) : (UNISAFE_HEIGHT - 194 + HUD_BAR_HEIGHT / 2));
            
            var p = this._focusFloor._storyInfo._activeProduct;
            
            var picon = this._focusFloor.getProductSprite(this._focusFloor._floorInfo._type == FLOOR_TYPE_RESIDENTIAL ? p + 1 : p);
            pb.addChild(picon);
            //  picon setAnchorPoint(0,0);
            picon.setPosition(-pb.AL_getSize().getWidth() / 2 + picon.AL_getSize().getWidth() + 4, -pb.AL_getSize().getHeight() / 2 + picon.AL_getSize().getHeight() - 20);
            
            var prodName = "";
            if (this._focusFloor._floorInfo._fid == FLOOR_ID_CONSTRUCTION)
            {
                var bpid = this._focusFloor._storyInfo._sales[1];
                prodName = TTScene.floorTypeString(TTFloorTable.floorWithId(bpid)._type);
            }
            else
            {
                prodName = this._focusFloor._floorInfo._products[p]._name.toUpperCase();
            }
            
            var pnameLbl = LabelConfigurer.createLabelWithString(prodName.toUpperCase(), "silkscreen", FONT14, [ 0, 1 ], true);
            // [CCLabelBMFont labelWithString:prodName fntFile:"silkscreen"];
            
    		var _scale = pnameLbl.getScale();
            pnameLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
            
            pnameLbl.setColor(ccc3(208, 201, 255));

            pnameLbl.setPosition(-pb.AL_getSize().getWidth() / 2 + pnameLbl.getSize().getWidth() + 40, -pb.AL_getSize().getHeight() / 2 + 24);

            pb.addChild(pnameLbl);
            
            if (this._focusFloor._floorInfo._fid != FLOOR_ID_CONSTRUCTION)
            {
                for ( var c = 0; c < p + 1; c++)
                {
                    var ccoin = TTSpriteFactory.spriteWithFile("coin.png", [ 0, 1 ]);
                    ccoin.setPosition(pnameLbl.getPosition().getX() + (pnameLbl.getSize().getWidth() + 130) + 8 + 4 * c, pnameLbl.getPosition().getY() );
                    pb.addChild(ccoin);
                }
            }
            
            var psellLbl = LabelConfigurer.createLabelWithString(sprintf("QTY %d", TTScene.quantityForProdTime(this._focusFloor._floorInfo._products[p]._time)), "silkscreen", FONT14, [0, 0], true);
            
    		var _scale = psellLbl.getScale();
            psellLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
            //[CCLabelBMFont labelWithString:[NSString stringWithFormat:"QTY: %",[this._numFormat stringFromNumber:[NSNumber numberWithInt:[TTScene quantityForProdTime:this._focusFloor._floorInfo._products[p].time]]]] fntFile:"silkscreen"];
            psellLbl.setColor(ccc3(208, 201, 255));
            psellLbl.setPosition(pnameLbl.getPosition().getX(), pnameLbl.getPosition().getY() +2);
            pb.addChild(psellLbl);
            
            if (this._happyCount > 0 && p < this._happyCount)	
            {
                var hbonusLbl = LabelConfigurer.createLabelWithString(sprintf("X2"), "silkscreen", FONT14, [ 0, 0 ], true);
                
        		var _scale = hbonusLbl.getScale();
                hbonusLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
                
                hbonusLbl.setColor(ccc3(106, 250, 66));
                hbonusLbl.setPosition(psellLbl.getPosition().getX() + 30  + ((( psellLbl.getText().length /2) + 0.5) *13) +1, psellLbl.getPosition().getY());
                pb.addChild(hbonusLbl);
            }
            
            if (this._focusFloor._floorInfo._fid == FLOOR_ID_CONSTRUCTION || this._focusFloor._floorInfo._type == FLOOR_TYPE_RESIDENTIAL)
            {
                psellLbl.setVisible(false);
            }
            
            // PROG BAR
            var progBg = TTSpriteFactory.spriteWithFile("floor_focus_prog_bg.png", [ 0.5, 0 ], [ 1, 1 ]);
            progBg.setPosition(0, -progBg.AL_getSize().getHeight() / 2 - 18);
            pb.addChild(progBg);
            
            this._progShade = ALLayerColor.layerWithColor(ccc3(0, 0, 0), 1, progBg.AL_getSize().getWidth(), progBg.AL_getSize().getHeight(), [ 1, 0 ]);
            this._progShade.setPosition(progBg.AL_getSize().getWidth() / 2, 0);
            progBg.addChild(this._progShade);
            
            var progOverlay = TTSpriteFactory.spriteWithFile("floor_focus_prog_overlay.png", [ 0.5, 0 ], [ 1, 1 ]);
            progBg.addChild(progOverlay);
            
            this._ptimeLeftLbl = LabelConfigurer.createLabelWithString(TTScene.timeString(this._focusFloor._floorInfo._products[p]._time * 60).toUpperCase(), "silkscreen", FONT14, [ 0.5, 0 ], true);
            
    		var _scale = this._ptimeLeftLbl.getScale();
            this._ptimeLeftLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
            //[CCLabelBMFont labelWithString:[[TTScene timeString:this._focusFloor._floorInfo._products[p].time*60] uppercaseString] fntFile:"silkscreen"];
            this._ptimeLeftLbl.setColor(ccc3(145, 135, 186));
            this._ptimeLeftLbl.setPosition(0, progBg.getPosition().getY() + 26);
            pb.addChild(this._ptimeLeftLbl);
            
            this._collectButton = TTSpriteFactory.spriteWithFile("floor_focus_collect.png", [ 0.5, 0.5 ]);
            this._collectButton.setPosition(pb.getPosition().getX(), pb.getPosition().getY() + 30);
            this._node.addChild(this._collectButton);
            this._collectButton.setVisible(false);
            
            this._hurryButton = TTSpriteFactory.spriteWithFile("floor_focus_hurry.png", [ 0.5, 0.5 ]);
            this._hurryButton.setPosition(this._collectButton.getPosition().getX(), this._collectButton.getPosition().getY() + 10);
            this._node.addChild(this._hurryButton);
            
            var buxCost = this._focusFloor.prodHurryCost();
            var hurryLbl = LabelConfigurer.createLabelWithString("" + buxCost, "silkscreen", FONT14, [ 1, 0 ], true);
            hurryLbl.setPosition(-12, 0);
            
    		var _scale = hurryLbl.getScale();
            hurryLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
            this._hurryButton.addChild(hurryLbl);
            
        }
        
        SoundBoard.playSfx(TTScene.floorTypeSound(this._focusFloor._floorInfo._type));
        
        //FIXME: Text field not supported by ngcore ?!
        //this._tfield = [[UITextField alloc] initWithFrame:
        //CGRectMake(60, 165, 200, 90));
        //[this._tfield setReturnKeyType:UIReturnKeyDone);
        //[this._tfield setAutocorrectionType:UITextAutocorrectionTypeNo);
        //[this._tfield setAutocapitalizationType:UITextAutocapitalizationTypeNone);
        //[this._tfield setClearsOnBeginEditing:true);
        
        //[this._tfield setDelegate:this);
        //[this._tfield setText:"");
        //[this._tfield setCenter:ccp(0,-UNISAFE_HEIGHT));
        //[[[[CCDirector sharedDirector] openGLView] window] addSubview:this._tfield);
    },
    
    destroy : function()
    {
        TTScene.shadeLayer(false);
        al_trace("FloorFocus layer DEALLOC!");
        this._numFormat = null;
        this._workers = null;
        if (this._tfield)
    	{
        	this._tfield.removeFromSuperview();
    	}
        this._tfield = null;
        this._origStr = null;
    },
    
    $initWithFloor : function(flr)
    {
        return new this(UNISAFE_WIDTH, UNISAFE_HEIGHT, flr);       
    },
    
    textFieldShouldReturn : function(textField)
    {
        al_trace("textFieldShouldReturn");
        textField.resignFirstResponder();
        return true;
    },
    
    textFieldDidEndEditing : function(textField)
    {
        al_trace("textFieldDidEndEditing");
        if (textField == this._tfield)
        {
            if (this._tfield.text.length == 0 && this._origStr)
            {
                this._titleLbl.setText(this._origStr);
                this._focusFloor._floorInfo._name = this._origStr;
                this._focusFloor.storyInfo._name = this._origStr;
                this._focusFloor.refreshName();
            }
            
            this._origStr = null;
            this._tfield.endEditing(true);
            // here is where you should do something with the data they entered
        }
    },
    
    textField : function(txtField, range, string)
    {
        if (this._titleLbl.getText().length >= 14 && string.length > 0)
        {
            return false;
        }
        
        if (!string || string.length == 0)
        {
            if (this._titleLbl.getText().length > 0)
            {
                this._titleLbl.setText(this._titleLbl.getText().substr(0, this._titleLbl.getText().length - 1));
            }
            
            this._focusFloor._floorInfo._name = this._titleLbl.getText();
            this._focusFloor._storyInfo._name = this._titleLbl.getText();
            this._focusFloor.refreshName();
            return true;
        }
        var ch = string[0];
        var retVal = (ch >= 65 && ch <= 90)
                    || (ch >= 97 && ch <= 122)
                    || (ch == 129) || (ch == 39)
                    || (ch == 32) || (ch == 46)
                    || (ch >= 48 && ch <= 57);
        if (retVal)
        {
            this._titleLbl.setText(this._titleLbl.getText() + string.toUpperCase());
            this._focusFloor._floorInfo._name = this._titleLbl.getText();
            this._focusFloor._storyInfo._name = this._titleLbl.getText();
            this._focusFloor.refreshName();
        }
        return retVal;
    },
    
    _draw : function()
    {
        if (this._focusFloor._storyInfo._activeProduct >= 0)
        {
            // update prog bar
            var percent = this._focusFloor.prodPercentComplete();
            percent = percent < 0 ? 0 : percent; 
            
            if (percent >= 1)
            {
                if (this._collectButton.getVisible() == false && this._focusFloor._floorInfo._type != FLOOR_TYPE_RESIDENTIAL)
                {
                    this._collectButton.setVisible(true);
                    this._hurryButton.setVisible(false);
                }
                this._ptimeLeftLbl.setText(this._focusFloor.prodTimeLeftStr());
                percent = 1;
            }
            //else {
            this._progShade && this._progShade.setScale([ 1 - percent, this._progShade.getScale().getY() ]);
            this._ptimeLeftLbl && this._ptimeLeftLbl.setText(this._focusFloor.prodTimeLeftStr());
            //}
        }
        else if (this._focusFloor._floorInfo._type != FLOOR_TYPE_RESIDENTIAL && this._prodButtonArr.length>0)
        {
            for ( var i = 0; i < 3; i++)
            {
                if (!this._prodButtonArr[i].getVisible() && this._focusFloor._storyInfo._stock[i] == 0 && i < this._workers.length)
                {
                    this._prodButtonArr[i].setVisible(true);
                }
                else if (this._prodButtonArr[i].getVisible() && this._focusFloor._storyInfo._stock[i] > 0)
                {
                    this._prodButtonArr[i].setVisible(false);
                }
                
                if (this._stockButtonArr[i].getVisible() && this._focusFloor._storyInfo._stock[i] == 0)
                {
                    this._stockButtonArr[i].setVisible(false);
                }
                else if (!this._stockButtonArr[i].getVisible() && this._focusFloor._storyInfo._stock[i] > 0)
                {
                    this._stockButtonArr[i].setVisible(true);
                }
                
                if (this._stockButtonArr[i].getVisible() && this._focusFloor._storyInfo._stock[i] != this._prevStock[i])
                {
                    var slbl = this._stockButtonArr[i].AL_getChildByTag(STOCK_LABEL_TAG);
                    // (CCLabelBMFont*)this._stockButtonArr[i] getChildByTag:STOCK_LABEL_TAG);
                    if (slbl)
                    {
                        slbl.setText(sprintf("IN STOCK: %d", Math.floor(this._focusFloor._storyInfo._stock[i])));
                    }
                    
                    var bar = this._stockButtonArr[i].AL_getChildByTag(STOCK_BAR);
                    var shade = bar.AL_getChildByTag(STOCK_BAR_SHADE);
                    var totalStock = TTScene.quantityForProdTime(this._focusFloor._floorInfo._products[i]._time);
                    if (this._happyCount > 0 && i < this._happyCount)
                    {
                        totalStock *= 2;
                    }
                    
                    var stockProg = this._focusFloor._storyInfo._stock[i] / totalStock;
                    if (stockProg > 1)
                    {
                        stockProg = 1;
                    }
                    
                    shade.setScale([ stockProg, shade.getScale().getY() ]);
                    this._prevStock[i] = this._focusFloor._storyInfo._stock[i];
                }
            }
        }
    },
    
    _ccTouchesBegan : function(touchEvent)
    {
        var tp = this._node.screenToLocal(touchEvent.getPosition());
        if (this._focusFloor._storyInfo._activeProduct < 0)
        {
            for ( var p = 2; p >= 0; p--)
            {
                if (CGRectContainsPoint(createBB(this._prodButtonArr[p]), tp))
                {
                    this._prodButtonArr[p].setAlpha((128 + 64) / 255);
                    this._stockButtonArr[p].setAlpha((128 + 64) / 255);
                }
            }
        }
        else
        {
            if (this._collectButton && this._collectButton.getVisible()
                && CGRectContainsPoint(createBB(this._collectButton), tp))
            {
                this._collectButton.setAlpha(127 / 255);
            }
            else if (this._hurryButton && this._hurryButton.getVisible()
                && CGRectContainsPoint(createBB(this._hurryButton), tp))
            {
                this._hurryButton.setAlpha(127 / 255);
            }
        }
        
        if (this._destroyButton && this._destroyButton.getAlpha() > (64 / 255)
            && CGRectContainsPoint(createBB(this._destroyButton), tp))
        {
            this._destroyButton.setAlpha(127 / 255);
        }
        else if (this._moveButton && this._moveButton.getAlpha() > (64 / 255)
            && CGRectContainsPoint(createBB(this._moveButton), tp))
        {
            this._moveButton.setAlpha(127 / 255);
        }
        else if (this._paintButton && this._paintButton.getAlpha() > (64 / 255)
            && CGRectContainsPoint(createBB(this._paintButton), tp))
        {
            this._paintButton.setAlpha(127 / 255);
        }
        
        // worker buttons
        for ( var w = 0; w < 5; w++)
        {
            if (this._workerButtonArr.length >= w && this._workerButtonArr[w])
            {
                if (this._workerButtonArr[w].getAlpha() > (64 / 255) && CGRectContainsPoint(createBB(this._workerButtonArr[w]), tp))
                {
                    this._workerButtonArr[w].setAlpha(128 / 255);
                }
            }
        }
        
        if (this._focusFloor._floorInfo._fid != FLOOR_ID_EMPTY && this._focusFloor._floorInfo._fid != FLOOR_ID_CONSTRUCTION
        //&& !this._tfield.isEditing 
        //&& CGRectContainsPoint(createBB(this._titleLbl), tp)
        )
        {
            /*
            this._origStr = sprintf("%s", this._titleLbl.getText());
            al_trace(sprintf("setting this._origStr to:%s", this._origStr));
            //this._tfield.becomeFirstResponder();
            this._titleLbl.setText("");*/
        }
        
        return true;
    },
    
    _ccTouchesMoved : function (touchEvent)
    {
    	var tp = this._node.screenToLocal(touchEvent.getPosition());
        if (this._focusFloor._storyInfo._activeProduct < 0)
        {
            for ( var p = 2; p >= 0; p--)
            {
                if (CGRectContainsPoint(createBB(this._prodButtonArr[p]), tp))
                {
                    this._prodButtonArr[p].setAlpha((128 + 64) / 255);
                    this._stockButtonArr[p].setAlpha((128 + 64) / 255);
                }
                else
            	{
                	this._prodButtonArr[p].setAlpha(255 / 255);
                    this._stockButtonArr[p].setAlpha(255/ 255);
            	}
            }
        }
        else if (this._collectButton && this._hurryButton)
        {
            if (this._collectButton.getVisible() && CGRectContainsPoint(createBB(this._collectButton), tp))
            {
                this._collectButton.setAlpha(127 / 255);
                this._hurryButton.setAlpha(255 / 255);
            }
            else if (this._hurryButton.getVisible() && CGRectContainsPoint(createBB(this._hurryButton), tp))
            {
                this._hurryButton.setAlpha(127 / 255);
                this._collectButton.setAlpha(255 / 255);
            }
            else
            {
                this._hurryButton.setAlpha(255 / 255);
                this._collectButton.setAlpha(255 / 255);
            }
        }
        
        if (this._destroyButton && this._moveButton && this._paintButton)
        {
            if (this._destroyButton.getAlpha() > (64 / 255)
                && CGRectContainsPoint(createBB(this._destroyButton), tp))
            {
                this._destroyButton.setAlpha(127 / 255);
            	this._moveButton.setAlpha(255 / 255);
            	this._paintButton.setAlpha(255 / 255);
            }
            else if (this._moveButton.getAlpha() > (64 / 255)
                && CGRectContainsPoint(createBB(this._moveButton), tp))
            {
        		this._moveButton.setAlpha(127 / 255);
                
                if( this._focusFloor._floorInfo._fid != FLOOR_ID_CONSTRUCTION )
            	{
                	this._paintButton.setAlpha(255 / 255);
                	if (this._focusFloor._storyInfo._activeProduct < 0)
            		{
                		this._destroyButton.setAlpha(255 / 255);
            		}
            	}
            }
            else if (this._paintButton.getAlpha() > (64 / 255)
                && CGRectContainsPoint(createBB(this._paintButton), tp))
            {
                this._paintButton.setAlpha(127 / 255);
	        	this._moveButton.setAlpha(255 / 255);
	        	if (this._focusFloor._storyInfo._activeProduct < 0)
        		{
	        		this._destroyButton.setAlpha(255 / 255);
        		}
            	
            }
            else
        	{
            	this._moveButton.setAlpha(255 / 255);
                
                if( this._focusFloor._floorInfo._fid != FLOOR_ID_CONSTRUCTION )
            	{
                	this._paintButton.setAlpha(255 / 255);
                	if (this._focusFloor._storyInfo._activeProduct < 0)
                	{	
                		this._destroyButton.setAlpha(255 / 255);
                	}
            	}
        	}
        }
        
        // worker buttons
        for ( var w = 0; w < 5; w++)
        {
            if (this._workerButtonArr.length >= w && this._workerButtonArr[w])
            {
                if (CGRectContainsPoint(createBB(this._workerButtonArr[w]), tp))
                {
                    this._workerButtonArr[w].setAlpha(128 / 255);
                }
                else
            	{
                	this._workerButtonArr[w].setAlpha(255 / 255);
            	}
            }
        }
    	
    },
    
    _ccTouchesCancelled : function(touchEvent)
    {
        if (this._focusFloor._storyInfo._activeProduct < 0)
        {
            for ( var p = 2; p >= 0; p--)
            {
                this._prodButtonArr[p].setAlpha(1);
                this._stockButtonArr[p].setAlpha(1);
            }
        }
        else
        {
            if (this._collectButton && this._collectButton.getVisible())
            {
                this._collectButton.setAlpha(1);
            }
            else if (this._hurryButton && this._hurryButton.getVisible())
            {
                this._hurryButton.setAlpha(1);
            }
        }
        
        if (this._destroyButton && this._destroyButton.getAlpha() == (128 / 255))
        {
            this._destroyButton.setAlpha(1);
        }
        
        if (this._moveButton && this._moveButton.getAlpha() == (128 / 255))
        {
            this._moveButton.setAlpha(1);
        }
        
        if (this._paintButton && this._paintButton.getAlpha() == (128 / 255))
        {
            this._paintButton.setAlpha(1);
        }
        
        for ( var w = 0; w < 5; w++)
        {
            if (this._workerButtonArr.length >= w && this._workerButtonArr[w])
            {
                if (this._workerButtonArr[w].getAlpha() > (64 / 255))
                {
                    this._workerButtonArr[w].setAlpha(1);
                }
            }
        }
    },
    
    startProductDlg : function(dlg)
    {
        if (dlg._buttonIndex > 0)
        {
            var data = dlg._data;
            
            var cost = data[1];
            TTScene.sharedScene()._playerData.addCoins(-cost);
            
            this._focusFloor.startProduction(data[0]);
            this._focusFloor.update();
            
            if (TTScene.sharedScene().tipNumber() == 19)
            {
                // TIP 20
                TTScene.sharedScene()._playerData.addBux(1);
                var ttl = TTutorialLayer.initWithStep(20, "HURRY THE RESTOCKING");
                TTScene.sharedScene().runTipLayer(ttl);
            }
            
            // RELOAD THIS MENU
            TTScene.sharedScene().runMenuLayer(null);
        }
    },
    
    hurryMoveDlg : function(dlg)
    {
        if (dlg._buttonIndex > 0)
        {
            //NSArray *data = dlg.data;
            var cost = 1;
            TTScene.sharedScene()._playerData.addBux(-cost);
            
            var moveInSeed = std_rand();
            
            // Chance for BitBook
            //srandom([NSDate timeIntervalSinceReferenceDate]);
            if (std_random() % BITBOOK_NEWROOMATE_CHANCE == 0)
            {
                
                // Get roomates
                var roomies = TTScene.sharedScene()._playerData.bitizensWithHomeFloor(this._focusFloor._storyInfo._story);
                var wInfo = null;
                if (roomies && roomies.length > 0)
                {
                    wInfo = roomies[std_rand() % roomies.length];
                    var entry = TTBitBook.entryFormatForEvent("new_roommate");
                    var newBit = TTBitizen.initWithSeed(moveInSeed);
                    TTBitBook.addNewEntry(sprintf(entry, newBit._name), wInfo._seed);
                }
            }
            
            // Put a new bitizen in this apartment
            // srand([NSDate timeIntervalSinceReferenceDate]);
            var newInfo = new TTBitizenInfo();
            newInfo._seed = moveInSeed;
            newInfo._homeFloor = this._focusFloor._storyInfo._story;
            newInfo._workFloor = -1;
            newInfo._dreamFloor = -1;
            newInfo._dreamed = false;
            TTScene.sharedScene()._playerData.addBitizenInfo(newInfo);
            this._focusFloor.addBitizen(newInfo._seed);
            
            //TTScene.sharedScene()._playerData.checkPopAchievements();
            
            // Chance for BitBook
            //srandom([NSDate timeIntervalSinceReferenceDate]);
            if (std_random() % BITBOOK_NEWRESIDENT_CHANCE == 0)
            {
                var entry = TTBitBook.entryFormatForEvent("new_bitizen");
                TTBitBook.addNewEntry(entry, newInfo._seed);
            }
            
            // RELOAD THIS MENU
            var ffl = TTFloorFocusLayer.initWithFloor(this._focusFloor);
            TTScene.sharedScene().runMenuLayer(ffl);
        }
    },
    
    hurryProductDlg : function(dlg)
    {
        if (dlg._buttonIndex > 0)
        {
            var data = dlg._data;
            var cost = data[1];
            TTScene.sharedScene()._playerData.addBux(-cost);
            
            var preHurryFloorId = this._focusFloor._floorInfo._fid;
            
            this._focusFloor.hurryProduct();
            this._focusFloor.update();
            
            if (this._focusFloor._floorInfo._type == FLOOR_TYPE_RESIDENTIAL || preHurryFloorId == FLOOR_ID_CONSTRUCTION)
            {
                // RELOAD THIS MENU
                TTScene.sharedScene().runMenuLayer(null);
            }
            
            if (TTScene.sharedScene().tipNumber() == 8)
            {
                // TIP 9
                var ttl = TTutorialLayer.initWithStep(9, "TAP THE LOBBY");
                TTScene.sharedScene().runTipLayer(ttl);
                TTScene.sharedScene()._towerLayer.spawnRider();
            }
            else if (TTScene.sharedScene().tipNumber() == 13)
            {
                // TIP 14
                var ttl = TTutorialLayer.initWithStep(14, "TAP APARTMENT");
                TTScene.sharedScene().runTipLayer(ttl);
            }
            else if (TTScene.sharedScene().tipNumber() == 20)
            {
                // TIP 21
                var ttl = TTutorialLayer.initWithStep(21, "TAP RESTOCK BUTTON");
                TTScene.sharedScene().runTipLayer(ttl);
            }
        }
        else
        {
            if (TTScene.sharedScene().tipNumber() == 8)
            {
                // TIP 7
                var ttl = TTutorialLayer.initWithStep(7, "TAP THE HURRY BUTTON");
                TTScene.sharedScene().runTipLayer(ttl);
            }
        }
    },
    
    quickSellDlg : function(dlg)
    {
        if (dlg._buttonIndex > 0)
        {
            var data = dlg._data;
            
            var prod = data[0];
            if (prod >= 0 && prod < 3)
            {
                TTScene.sharedScene()._playerData.addCoins(this._focusFloor._storyInfo._stock[prod] * (prod + 1));
                this._focusFloor._storyInfo._stock[prod] = 0;
            }
            else
            {
                return;
            }
            
            var cost = data[1];
            TTScene.sharedScene()._playerData.addBux(-cost);
            
            //[this._focusFloor hurryProduct];
            //[this._focusFloor update];
            
            // RELOAD THIS MENU
            TTScene.sharedScene().runMenuLayer(null);
        }
    },
    
    demolishDlg : function(dlg)
    {
        if (dlg._buttonIndex > 0)
        {
            for ( var i = 0; i < this._workers.length; i++)
            {
                var binfo = this._workers[i];
                binfo._workFloor = 0;
                
                var tl = TTScene.sharedScene()._towerLayer; //this._focusFloor.parent.parent;
                tl.removeBitizenWithSeed(binfo._seed);
                var homeFloor = tl._floors[binfo._homeFloor - 1];
                homeFloor.addBitizen(binfo._seed);
            }
            
            this._focusFloor.switchToFloorId(FLOOR_ID_EMPTY);
            this._focusFloor._lightsLayer.setVisible(false);
            this._focusFloor.update();
            
            
            // RELOAD THIS MENU
            TTScene.sharedScene().runMenuLayer(null);
        }
    },
    
    moveDlg : function(dlg)
    {
        if (dlg._buttonIndex > 0)
        {
            TTScene.sharedScene()._playerData.addBux(-1);
            TTScene.sharedScene()._towerLayer.startMovingFloor(this._focusFloor);
        }
    },
    
    _ccTouchesEnded : function(touchEvent)
    {
        var tp = this._node.screenToLocal(touchEvent.getPosition());
        if (this._focusFloor._storyInfo._activeProduct < 0)
        {
            for ( var p = 2; p >= 0; p--)
            {
                this._prodButtonArr[p].setAlpha(1);
                this._stockButtonArr[p].setAlpha(1);
            }
            
            for ( var p = 2; p >= 0; p--)
            {
                if (this._prodButtonArr[p].getVisible() && CGRectContainsPoint(createBB(this._prodButtonArr[p]), tp))
                {
                    var cost = TTScene.costForProdTime(this._focusFloor._floorInfo._products[p]._time, this._workerBonus);
                    // check cost
                    if (TTScene.sharedScene()._playerData._coins - cost < 0)
                    {
                        var dlg = TTDialog.initWithMessage(sprintf("\n\n\n\nYou do not have enough coins for that."), ",continue", null, null, null);
                        TTDialogQueue.sharedQueue().addDialog(dlg);
                    }
                    else
                    {
                        // from function startProductDlg:
                        TTScene.sharedScene()._playerData.addCoins(-cost);
                        TTHud.sharedHud().animateCoinAmt(-cost);
                        
                        this._focusFloor.startProduction(p);
                        this._focusFloor.update();
                        
                        if (TTScene.sharedScene().tipNumber() == 19)
                        {
                            // TIP 20
                            TTScene.sharedScene()._playerData.addBux(1);
                            var ttl = TTutorialLayer.initWithStep(20, "HURRY THE RESTOCKING");
                            TTScene.sharedScene().runTipLayer(ttl);
                        }
                        
                        // RELOAD THIS MENU
                        TTScene.sharedScene().runMenuLayer(null);
                    }
                }
            }
            
            for ( var p = 2; p >= 0; p--)
            {
                this._stockButtonArr[p].setAlpha(1);
            }
            
            for ( var p = 2; p >= 0; p--)
            {
                if (this._stockButtonArr[p].getVisible() && CGRectContainsPoint(createBB(this._stockButtonArr[p]), tp))
                {
                    var cost = Math.ceil(this._focusFloor._storyInfo._stock[p] * (p + 1) / BUX_STOCK_WORTH);
                    // check cost
                    if (TTScene.sharedScene()._playerData._bux - cost < 0)
                    {
                        var dlg = TTDialog.initWithMessage("\n\n\n\nYou do not have enough bux for that.", ",continue", null, null, null);
                        TTDialogQueue.sharedQueue().addDialog(dlg);
                    }
                    else
                    {
                        //NSString *costStr = [this._numFormat stringFromNumber:[NSNumber numberWithInt:cost]];
                        var dlg = TTDialog.initWithMessage(sprintf("\n\n\nQuick sell remaining stock at a cost of %d bux?", cost), "no,yes", this.quickSellDlg.bind(this), this, [ p, cost, null ]);
                        TTDialogQueue.sharedQueue().addDialog(dlg);
                    }
                }
            }
        }
        else
        {
            if (this._collectButton && this._collectButton.getVisible())
            {
                this._collectButton.setAlpha(1);
                if (CGRectContainsPoint(createBB(this._collectButton), tp))
                {
                    // COLLECT
                    this._focusFloor.addStock();
                    TTScene.sharedScene().runMenuLayer(null);
                }
            }
            else if (this._hurryButton && this._hurryButton.getVisible())
            {
                this._hurryButton.setAlpha(1);
                if (CGRectContainsPoint(createBB(this._hurryButton), tp))
                {
                    // HURRY
                    var cost = this._focusFloor.prodHurryCost();
                    
                    // check cost
                    if (TTScene.sharedScene()._playerData._bux - cost < 0)
                    {
                        var dlg = TTDialog.initWithMessage("\n\n\n\nYou do not have enough tower bux for that.", ",continue", null, null, null);
                        TTDialogQueue.sharedQueue().addDialog(dlg);
                    }
                    else
                    {
                        if (this._focusFloor._floorInfo._fid == FLOOR_ID_CONSTRUCTION)
                        {
                            //callback:@selector(hurryProductDlg:) target:self data:[NSArray arrayWithObjects:[NSNumber numberWithInt:focusFloor.storyInfo.activeProduct],[NSNumber numberWithInt:cost],nil]];
                            //"no,yes", this.hurryProductDlg(/*[this._focusFloor._storyInfo._activeProduct,cost]*/), this,  null);
                            //this.hurryProductDlg,this,[this._focusFloor._storyInfo._activeProduct,cost,null]);
                            var dlg = TTDialog.initWithMessage(sprintf("\n\n\nHurry construction of this floor at a cost of %d bux?", cost), "no,yes", this.hurryProductDlg.bind(this), this, [ this._focusFloor._storyInfo._activeProduct, cost ]);
                            TTDialogQueue.sharedQueue().addDialog(dlg);
                            
                            if (TTScene.sharedScene().tipNumber() == 7)
                            {
                                // TIP 8
                                var ttl = TTutorialLayer.initWithStep(8, "TAP YES");
                                TTScene.sharedScene().runTipLayer(ttl);
                            }
                        }
                        else
                        {
                            var dlg = TTDialog.initWithMessage(sprintf("\n\n\nHurry production of\n%@\nat a cost of %d bux?", this._focusFloor._floorInfo._products[this._focusFloor._storyInfo._activeProduct]._name, cost), "no,yes", this.hurryProductDlg, this, [
                                    this._focusFloor._storyInfo._activeProduct, cost, null ]);
                            TTDialogQueue.sharedQueue().addDialog(dlg);
                        }
                    }
                }
            }
        }
        
        if (this._destroyButton && this._destroyButton.getAlpha() > 64 / 255)
        {
            this._destroyButton.setAlpha(1);
            if (CGRectContainsPoint(createBB(this._destroyButton), tp))
            {
                var numInhab = 0;
                if (this._focusFloor._floorInfo._type == FLOOR_TYPE_RESIDENTIAL)
                {                  
                    numInhab = TTScene.sharedScene()._playerData.bitizensWithHomeFloor(this._focusFloor._storyInfo._story).length;                  
                }
                
                if (numInhab == 0)
                {
                    // DEMOLISH?
                    var dlg = TTDialog.initWithMessage("\n\nAre you sure you want to demolish this floor? All stock for this floor will be lost!", "cancel,demolish", this.demolishDlg, this, null);
                    TTDialogQueue.sharedQueue().addDialog(dlg);
                }
                else
                {
                    var dlg = TTDialog.initWithMessage("\n\n\nYou can't demolish an apartment while bitizens are living there!", ",continue", null, null, null);
                    TTDialogQueue.sharedQueue().addDialog(dlg);
                }
            }
        }
        if (this._moveButton && this._moveButton.getAlpha() > 64 / 255)
        {
            this._moveButton.setAlpha(1);
            if (CGRectContainsPoint(createBB(this._moveButton), tp))
            {
                if (TTScene.sharedScene()._playerData._bux - 1 < 0)
                {
                    var dlg = TTDialog.initWithMessage("\n\n\n\nYou do not have enough tower bux for that.", ",continue", null, null, null);
                    TTDialogQueue.sharedQueue().addDialog(dlg);
                }
                else
                {
                    var dlg = TTDialog.initWithMessage("\n\n\n\nMove this floor at a cost of 1 bux?", "no,yes", this.moveDlg, this, null);
                    TTDialogQueue.sharedQueue().addDialog(dlg);
                }
            }
        }
        
        if (this._paintButton && this._paintButton.getAlpha() > (64 / 255))
        {
            this._paintButton.setAlpha(1);
            if (CGRectContainsPoint(createBB(this._paintButton), tp))
            {
                
                var fpl = TTFloorPaintLayer.initWithFloor(this._focusFloor);
                TTScene.sharedScene().runMenuLayer(fpl);
            }
        }
        
        // worker buttons
        for ( var w = 0; w < 5; w++)
        {
            if (this._workerButtonArr.length >= w && this._workerButtonArr[w])
            {
                if (this._workerButtonArr[w].getAlpha() > (64 / 255) && CGRectContainsPoint(createBB(this._workerButtonArr[w]), tp))
                {
                    if (w >= this._workers.length)
                    {
                        if (this._focusFloor._floorInfo._type == FLOOR_TYPE_RESIDENTIAL)
                        {
                            // check cost
                            if (TTScene.sharedScene()._playerData._bux - 1 < 0)
                            {
                                var dlg = TTDialog.initWithMessage("\n\n\n\nYou do not have enough tower bux for that.", ",continue", null, null, null);
                                TTDialogQueue.sharedQueue().addDialog(dlg);
                            }
                            else
                            {
                                // MOVE IN QUICK
                                var dlg = TTDialog.initWithMessage("\n\n\nMove a bitizen in to this apartment immediately at a cost of 1 bux?", "no,yes", this.hurryMoveDlg, this, null);
                                TTDialogQueue.sharedQueue().addDialog(dlg);
                            }
                        }
                        else
                        {
                            var bll = TTBitizenListLayer.initWithHiringFloor(this._focusFloor);
                            TTScene.sharedScene().runMenuLayer(bll);
                        }
                    }
                    else if (w < this._workers.length)
                    {
                        if (TTScene.sharedScene().tipNumber() == 15)
                        {
                            // TIP 16
                            var ttl = TTutorialLayer.initWithStep(16, "ASSIGN NEW JOB");
                            TTScene.sharedScene().runTipLayer(ttl);
                        }
                        
                        var bfl = TTBitFocusLayer.initWithBitizen(this._workers[w], this._focusFloor);
                        TTScene.sharedScene().runMenuLayer(bfl);
                    }
                }
            }
        }
        
        for ( var w = 0; w < 5; w++)
        {
            if (this._workerButtonArr.length >= w && this._workerButtonArr[w])
            {
                if (this._workerButtonArr[w].getAlpha() > (64 / 255))
                {
                    this._workerButtonArr[w].setAlpha(1);
                }
            }
        }
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTBitizenInfo'] = function(){var exports = $MODULE_REGISTRY['Code/TTBitizenInfo'] || {}; $MODULE_REGISTRY['Code/TTBitizenInfo'] = exports; exports.TTBitizenInfo = Core.Class.subclass({
    classname : 'TTBitizenInfo',
    
    initialize : function()
    {
        this._homeFloor = 0;
        this._workFloor = 0;
        this._dreamFloor = 0;
        this._seed = 0;
        this._vseed = 0;
        this._dreamed = false;
       
        this._randomizer = new RandomGen();
    },
    
    toString : function()
    {
        return "h=" + this._homeFloor
            + ";w=" + this._workFloor
            + ";j=" + this._dreamFloor
            + ";d=" + this._dreamed
            + ";s=" + this._seed
            + ";vs=" + this._vseed + ";";
    },
    
    $happyCompare : function(a, b)
    {
        if (a && b)
        {
            var moodA = 0;
            if (a._workFloor > 0)
            {
                var sInfo = TTScene.sharedScene()._playerData.getStoryInfo(a._workFloor);
                if (a._dreamFloor == sInfo._floorId)
                {
                    moodA = 2;
                }
                else
                {
                    var fInfo = TTFloorTable.floorWithId(sInfo._floorId);
                    var sk = TTBitizen.skillIn(fInfo._type, a._seed);
                    if (sk >= 5)
                    {
                        moodA = 1;
                    }
                }
            }
            
            var moodB = 0;
            if (b._workFloor > 0)
            {
                var sInfo = TTScene.sharedScene()._playerData.getStoryInfo(b._workFloor);
                if (b._dreamFloor == sInfo._floorId)
                {
                    moodB = 2;
                }
                else
                {
                    var fInfo = TTFloorTable.floorWithId(sInfo._floorId);
                    var sk = TTBitizen.skillIn(fInfo._type, b._seed);
                    if (sk >= 5)
                    {
                        moodB = 1;
                    }
                }
            }
            
            if (moodA == moodB)
            {
                return 0;
            }
            
            if (moodA > moodB)
            {
                return 1;
            }
            else
            {
                return -1;
            }
        }
        else
        {
            return;
        }
    },
    
    $jobCompare : function(a, b)
    {
        
        if (a && b)
        {
            var jobTypeA = -1;
            if (a._workFloor > 0)
            {
                var sInfo = TTScene.sharedScene()._playerData.getStoryInfo(a._workFloor);
                var fInfo = TTFloorTable.floorWithId(sInfo._floorId);
                if (sInfo && fInfo)
                {
                    jobTypeA = fInfo._type;
                }
            }
            
            var jobTypeB = -1;
            if (b._workFloor > 0)
            {
                var sInfo = TTScene.sharedScene()._playerData.getStoryInfo(b._workFloor);
                var fInfo = TTFloorTable.floorWithId(sInfo._floorId);
                if (sInfo && fInfo)
                {
                    jobTypeB = fInfo._type;
                }
            }
            
            if (jobTypeA == jobTypeB)
            {
                return 0;
            }
            
            if (jobTypeA > jobTypeB)
            {
                return 1;
            }
            else
            {
                return -1;
            }
        }
        else
        {
            return 0;
        }
    },
    
    $skillCompare : function(a, b, skill)
    {
        if (a && b)
        {
            var jobSkillA = TTBitizen.skillIn(skill, a._seed);
            var jobSkillB = TTBitizen.skillIn(skill, b._seed);
            
            if (jobSkillA == jobSkillB)
            {
                return 0;
            }
            
            if (jobSkillA > jobSkillB)
            {
                return -1;
            }
            else
            {
                return 1;
            }
        }
        else
        {
            return 0;
        }
    },
    
    $skillCompareFood : function(a, b)
    {
        return TTBitizenInfo.skillCompare(a, b, FLOOR_TYPE_FOOD);
    },
    
    $skillCompareService : function(a, b)
    {
        return TTBitizenInfo.skillCompare(a, b, FLOOR_TYPE_SERVICE);
    },
    
    $skillCompareRetail : function(a, b)
    {
        return TTBitizenInfo.skillCompare(a, b, FLOOR_TYPE_RETAIL);
    },
    
    $skillCompareRecreation : function(a, b)
    {
        return TTBitizenInfo.skillCompare(a, b, FLOOR_TYPE_ENTERTAINMENT);
    },
    
    $skillCompareCreative : function(a, b)
    {
        return TTBitizenInfo.skillCompare(a, b, FLOOR_TYPE_CREATIVE);
    },
    
    setSeed: function(seed)
    {
        this._seed = seed;
    },
    reseed: function(seed)
    {
       this._randomizer.useSeed(seed); 
    },
    
    getRandomInt: function()
    {
        return Math.floor(this._randomizer.getRandom() * (Math.pow(2, 15) - 1));
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTBitizen'] = function(){var exports = $MODULE_REGISTRY['Code/TTBitizen'] || {}; $MODULE_REGISTRY['Code/TTBitizen'] = exports; exports.TTBitizen = BaseClass.subclass({
    classname : 'TTBitizen',

    $_maleNames : [ "JAMES", "JOHN", "ROBERT", "MICHAEL", "WILLIAM", "DAVID", "RICHARD", "CHARLES", "JOSEPH", "THOMAS", "CHRISTOPHER", "DANIEL", "PAUL", "MARK", "DONALD", "GEORGE", "KENNETH", "STEVEN", "EDWARD", "BRIAN", "RONALD", "ANTHONY", "KEVIN", "JASON", "MATTHEW", "GARY", "TIMOTHY",
                        "JOSE", "LARRY", "JEFFREY", "FRANK", "SCOTT", "ERIC", "STEPHEN", "ANDREW", "RAYMOND", "GREGORY", "JOSHUA", "JERRY", "DENNIS", "WALTER", "PATRICK", "PETER", "HAROLD", "DOUGLAS", "HENRY", "CARL", "ARTHUR", "RYAN", "ROGER", "JOE", "JUAN", "JACK", "ALBERT", "JONATHAN", "JUSTIN",
                        "TERRY", "GERALD", "KEITH", "SAMUEL", "WILLIE", "RALPH", "LAWRENCE", "NICHOLAS", "ROY", "BENJAMIN", "BRUCE", "BRANDON", "ADAM", "HARRY", "FRED", "WAYNE", "BILLY", "STEVE", "LOUIS", "JEREMY", "AARON", "RANDY", "HOWARD", "EUGENE", "CARLOS", "RUSSELL", "BOBBY", "VICTOR", "MARTIN",
                        "ERNEST", "PHILLIP", "TODD", "JESSE", "CRAIG", "ALAN", "SHAWN", "CLARENCE", "SEAN", "PHILIP", "CHRIS", "JOHNNY", "EARL", "JIMMY", "ANTONIO", "DANNY", "BRYAN", "TONY", "LUIS", "MIKE", "STANLEY", "LEONARD", "NATHAN", "DALE", "MANUEL", "RODNEY", "CURTIS", "NORMAN", "ALLEN", "MARVIN",
                        "VINCENT", "GLENN", "JEFFERY", "TRAVIS", "JEFF", "CHAD", "JACOB", "LEE", "MELVIN", "ALFRED", "KYLE", "FRANCIS", "BRADLEY", "JESUS", "HERBERT", "FREDERICK", "RAY", "JOEL", "EDWIN", "DON", "EDDIE", "RICKY", "TROY", "RANDALL", "BARRY", "ALEXANDER", "BERNARD", "MARIO", "LEROY",
                        "FRANCISCO", "MARCUS", "MICHEAL", "THEODORE", "CLIFFORD", "MIGUEL", "OSCAR", "JAY", "JIM", "TOM", "CALVIN", "ALEX", "JON", "RONNIE", "BILL", "LLOYD", "TOMMY", "LEON", "DEREK", "WARREN", "DARRELL", "JEROME", "FLOYD", "LEO", "ALVIN", "TIM", "WESLEY", "GORDON", "DEAN", "GREG", "JORGE",
                        "DUSTIN", "PEDRO", "DERRICK", "DAN", "LEWIS", "ZACHARY", "COREY", "HERMAN", "MAURICE", "VERNON", "ROBERTO", "CLYDE", "GLEN", "HECTOR", "SHANE", "RICARDO", "SAM", "RICK", "LESTER", "BRENT", "RAMON", "CHARLIE", "TYLER", "GILBERT", "GENE", "MARC", "REGINALD", "RUBEN", "BRETT", "ANGEL",
                        "NATHANIEL", "RAFAEL", "LESLIE", "EDGAR", "MILTON", "RAUL", "BEN", "CHESTER", "CECIL", "DUANE", "FRANKLIN", "ANDRE", "ELMER", "BRAD", "GABRIEL", "RON", "MITCHELL", "ROLAND", "ARNOLD", "HARVEY", "JARED", "ADRIAN", "KARL", "CORY", "CLAUDE", "ERIK", "DARRYL", "JAMIE", "NEIL", "JESSIE",
                        "CHRISTIAN", "JAVIER", "FERNANDO", "CLINTON", "TED", "MATHEW", "TYRONE", "DARREN", "LONNIE", "LANCE", "CODY", "JULIO", "KELLY", "KURT", "ALLAN", "NELSON", "GUY", "CLAYTON", "HUGH", "MAX", "DWAYNE", "DWIGHT", "ARMANDO", "FELIX", "JIMMIE", "EVERETT", "JORDAN", "IAN", "WALLACE", "KEN",
                        "BOB", "JAIME", "CASEY", "ALFREDO", "ALBERTO", "DAVE", "IVAN", "JOHNNIE", "SIDNEY", "BYRON", "JULIAN", "ISAAC", "MORRIS", "CLIFTON", "WILLARD", "DARYL", "ROSS", "VIRGIL", "ANDY", "MARSHALL", "SALVADOR", "PERRY", "KIRK", "SERGIO", "MARION", "TRACY", "SETH", "KENT", "TERRANCE",
                        "RENE", "EDUARDO", "TERRENCE", "ENRIQUE", "FREDDIE", "WADE" ],
	$_femaleNames : [ "MARY", "PATRICIA", "LINDA", "BARBARA", "ELIZABETH", "JENNIFER", "MARIA", "SUSAN", "MARGARET", "DOROTHY", "LISA", "NANCY", "KAREN", "BETTY", "HELEN", "SANDRA", "DONNA", "CAROL", "RUTH", "SHARON", "MICHELLE", "LAURA", "SARAH", "KIMBERLY", "DEBORAH", "JESSICA",
                        "SHIRLEY", "CYNTHIA", "ANGELA", "MELISSA", "BRENDA", "AMY", "ANNA", "REBECCA", "VIRGINIA", "KATHLEEN", "PAMELA", "MARTHA", "DEBRA", "AMANDA", "STEPHANIE", "CAROLYN", "CHRISTINE", "MARIE", "JANET", "CATHERINE", "FRANCES", "ANN", "JOYCE", "DIANE", "ALICE", "JULIE", "HEATHER",
                        "TERESA", "DORIS", "GLORIA", "EVELYN", "JEAN", "CHERYL", "MILDRED", "KATHERINE", "JOAN", "ASHLEY", "JUDITH", "ROSE", "JANICE", "KELLY", "NICOLE", "JUDY", "CHRISTINA", "KATHY", "THERESA", "BEVERLY", "DENISE", "TAMMY", "IRENE", "JANE", "LORI", "RACHEL", "MARILYN", "ANDREA", "KATHRYN",
                        "LOUISE", "SARA", "ANNE", "JACQUELINE", "WANDA", "BONNIE", "JULIA", "RUBY", "LOIS", "TINA", "PHYLLIS", "NORMA", "PAULA", "DIANA", "ANNIE", "LILLIAN", "EMILY", "ROBIN", "PEGGY", "CRYSTAL", "GLADYS", "RITA", "DAWN", "CONNIE", "FLORENCE", "TRACY", "EDNA", "TIFFANY", "CARMEN", "ROSA",
                        "CINDY", "GRACE", "WENDY", "VICTORIA", "EDITH", "KIM", "SHERRY", "SYLVIA", "JOSEPHINE", "THELMA", "SHANNON", "SHEILA", "ETHEL", "ELLEN", "ELAINE", "MARJORIE", "CARRIE", "CHARLOTTE", "MONICA", "ESTHER", "PAULINE", "EMMA", "JUANITA", "ANITA", "RHONDA", "HAZEL", "AMBER", "EVA",
                        "DEBBIE", "APRIL", "LESLIE", "CLARA", "LUCILLE", "JAMIE", "JOANNE", "ELEANOR", "VALERIE", "DANIELLE", "MEGAN", "ALICIA", "SUZANNE", "MICHELE", "GAIL", "BERTHA", "DARLENE", "VERONICA", "JILL", "ERIN", "GERALDINE", "LAUREN", "CATHY", "JOANN", "LORRAINE", "LYNN", "SALLY", "REGINA",
                        "ERICA", "BEATRICE", "DOLORES", "BERNICE", "AUDREY", "YVONNE", "ANNETTE", "JUNE", "SAMANTHA", "MARION", "DANA", "STACY", "ANA", "RENEE", "IDA", "VIVIAN", "ROBERTA", "HOLLY", "BRITTANY", "MELANIE", "LORETTA", "YOLANDA", "JEANETTE", "LAURIE", "KATIE", "KRISTEN", "VANESSA", "ALMA",
                        "SUE", "ELSIE", "BETH", "JEANNE", "VICKI", "CARLA", "TARA", "ROSEMARY", "EILEEN", "TERRI", "GERTRUDE", "LUCY", "TONYA", "ELLA", "STACEY", "WILMA", "GINA", "KRISTIN", "JESSIE", "NATALIE", "AGNES", "VERA", "WILLIE", "CHARLENE", "BESSIE", "DELORES", "MELINDA", "PEARL", "ARLENE",
                        "MAUREEN", "COLLEEN", "ALLISON", "TAMARA", "JOY", "GEORGIA", "CONSTANCE", "LILLIE", "CLAUDIA", "JACKIE", "MARCIA", "TANYA", "NELLIE", "MINNIE", "MARLENE", "HEIDI", "GLENDA", "LYDIA", "VIOLA", "COURTNEY", "MARIAN", "STELLA", "CAROLINE", "DORA", "JO", "VICKIE", "MATTIE", "TERRY",
                        "MAXINE", "IRMA", "MABEL", "MARSHA", "MYRTLE", "LENA", "CHRISTY", "DEANNA", "PATSY", "HILDA", "GWENDOLYN", "JENNIE", "NORA", "MARGIE", "NINA", "CASSANDRA", "LEAH", "PENNY", "KAY", "PRISCILLA", "NAOMI", "CAROLE", "BRANDY", "OLGA", "BILLIE", "DIANNE", "TRACEY", "LEONA", "JENNY",
                        "FELICIA", "SONIA", "MIRIAM", "VELMA", "BECKY", "BOBBIE", "VIOLET", "KRISTINA", "TONI", "MISTY", "MAE", "SHELLY", "DAISY", "RAMONA", "SHERRI", "ERIKA", "KATRINA", "CLAIRE" ],
	$_lastNames : [ "SMITH", "JOHNSON", "WILLIAMS", "JONES", "BROWN", "DAVIS", "MILLER", "WILSON", "MOORE", "TAYLOR", "ANDERSON", "THOMAS", "JACKSON", "WHITE", "HARRIS", "MARTIN", "THOMPSON", "GARCIA", "MARTINEZ", "ROBINSON", "CLARK", "RODRIGUEZ", "LEWIS", "LEE", "WALKER", "HALL", "ALLEN",
                        "YOUNG", "HERNANDEZ", "KING", "WRIGHT", "LOPEZ", "HILL", "SCOTT", "GREEN", "ADAMS", "BAKER", "GONZALEZ", "NELSON", "CARTER", "MITCHELL", "PEREZ", "ROBERTS", "TURNER", "PHILLIPS", "CAMPBELL", "PARKER", "EVANS", "EDWARDS", "COLLINS", "STEWART", "SANCHEZ", "MORRIS", "ROGERS", "REED",
                        "COOK", "MORGAN", "BELL", "MURPHY", "BAILEY", "RIVERA", "COOPER", "RICHARDSON", "COX", "HOWARD", "WARD", "TORRES", "PETERSON", "GRAY", "RAMIREZ", "JAMES", "WATSON", "BROOKS", "KELLY", "SANDERS", "PRICE", "BENNETT", "WOOD", "BARNES", "ROSS", "HENDERSON", "COLEMAN", "JENKINS",
                        "PERRY", "POWELL", "LONG", "PATTERSON", "HUGHES", "FLORES", "WASHINGTON", "BUTLER", "SIMMONS", "FOSTER", "GONZALES", "BRYANT", "ALEXANDER", "RUSSELL", "GRIFFIN", "DIAZ", "HAYES", "MYERS", "FORD", "HAMILTON", "GRAHAM", "SULLIVAN", "WALLACE", "WOODS", "COLE", "WEST", "JORDAN",
                        "OWENS", "REYNOLDS", "FISHER", "ELLIS", "HARRISON", "GIBSON", "MCDONALD", "CRUZ", "MARSHALL", "ORTIZ", "GOMEZ", "MURRAY", "FREEMAN", "WELLS", "WEBB", "SIMPSON", "STEVENS", "TUCKER", "PORTER", "HUNTER", "HICKS", "CRAWFORD", "HENRY", "BOYD", "MASON", "MORALES", "KENNEDY", "WARREN",
                        "DIXON", "RAMOS", "REYES", "BURNS", "GORDON", "SHAW", "HOLMES", "RICE", "ROBERTSON", "HUNT", "BLACK", "DANIELS", "PALMER", "MILLS", "NICHOLS", "GRANT", "KNIGHT", "FERGUSON", "ROSE", "STONE", "HAWKINS", "DUNN", "PERKINS", "HUDSON", "SPENCER", "GARDNER", "STEPHENS", "PAYNE", "PIERCE",
                        "BERRY", "MATTHEWS", "ARNOLD", "WAGNER", "WILLIS", "RAY", "WATKINS", "OLSON", "CARROLL", "DUNCAN", "SNYDER", "HART", "CUNNINGHAM", "BRADLEY", "LANE", "ANDREWS", "RUIZ", "HARPER", "FOX", "RILEY", "ARMSTRONG", "CARPENTER", "WEAVER", "GREENE", "LAWRENCE", "ELLIOTT", "CHAVEZ", "SIMS",
                        "AUSTIN", "PETERS", "KELLEY", "FRANKLIN", "LAWSON", "FIELDS", "GUTIERREZ", "RYAN", "SCHMIDT", "CARR", "VASQUEZ", "CASTILLO", "WHEELER", "CHAPMAN", "OLIVER", "MONTGOMERY", "RICHARDS", "WILLIAMSON", "JOHNSTON", "BANKS", "MEYER", "BISHOP", "MCCOY", "HOWELL", "ALVAREZ", "MORRISON",
                        "HANSEN", "FERNANDEZ", "GARZA", "HARVEY", "LITTLE", "BURTON", "STANLEY", "NGUYEN", "GEORGE", "JACOBS", "REID", "KIM", "FULLER", "LYNCH", "DEAN", "GILBERT", "GARRETT", "ROMERO", "WELCH", "LARSON", "FRAZIER", "BURKE", "HANSON", "DAY", "MENDOZA", "MORENO", "BOWMAN", "MEDINA", "FOWLER",
                        "BREWER", "HOFFMAN", "CARLSON", "SILVA", "PEARSON", "HOLLAND", "DOUGLAS", "FLEMING", "JENSEN", "VARGAS", "BYRD", "DAVIDSON", "HOPKINS", "MAY", "TERRY", "HERRERA", "WADE", "SOTO", "WALTERS", "CURTIS", "NEAL", "CALDWELL", "LOWE", "JENNINGS", "BARNETT", "GRAVES", "JIMENEZ", "HORTON",
                        "SHELTON", "BARRETT", "OBRIEN", "CASTRO", "SUTTON", "GREGORY", "MCKINNEY", "LUCAS", "MILES", "CRAIG", "RODRIQUEZ", "CHAMBERS", "HOLT", "LAMBERT", "FLETCHER", "WATTS", "BATES", "HALE", "RHODES", "PENA", "BECK", "NEWMAN" ],
	$_skinColors : [ ccc3(227, 159, 148), ccc3(239, 178, 150), ccc3(182, 110, 86), ccc3(244, 194, 170), ccc3(246, 209, 175), ccc3(197, 157, 121), ccc3(171, 114, 86), ccc3(126, 84, 64) ],
	$_hairColors : [ ccc3(255, 191, 9), ccc3(46, 37, 35), ccc3(167, 167, 167), ccc3(66, 48, 43), ccc3(103, 57, 37), ccc3(122, 60, 41), ccc3(114, 74, 51), ccc3(180, 118, 75), ccc3(164, 111, 78), ccc3(127, 84, 59), ccc3(31, 37, 50), ccc3(191, 138, 93), ccc3(102, 51, 37), ccc3(67, 43, 30),
                                ccc3(95, 64, 49), ccc3(255, 255, 255), ccc3(93, 59, 64), ccc3(105, 65, 79), ccc3(146, 64, 50), ccc3(111, 56, 49), ccc3(255, 200, 147), ccc3(255, 0, 255), ccc3(60, 255, 0), ccc3(0, 198, 255), ccc3(255, 88, 60), ccc3(102, 78, 74), ccc3(184, 111, 76), ccc3(174, 91, 51),
                                ccc3(134, 25, 18), ccc3(49, 25, 25), ccc3(216, 192, 120), ccc3(227, 204, 136), ccc3(242, 255, 174), ccc3(242, 231, 199), ccc3(168, 72, 48), ccc3(120, 0, 0), ccc3(230, 226, 213), ccc3(72, 0, 0), ccc3(184, 145, 112), ccc3(194, 157, 130), ccc3(229, 198, 141), ccc3(255, 242, 168),
                                ccc3(146, 110, 94), ccc3(158, 77, 10), ccc3(237, 194, 130), ccc3(255, 246, 223), ccc3(220, 160, 0), ccc3(205, 108, 3), ccc3(242, 166, 94) ],
    
    initialize : function()
    {
        this._destX = 0;
        this._name = null;
        this._firstName = null;
        this._lastName = null;
        this._seed = 0;
        this._bmonth = null;
        this._bday = null;
        this._male = null;
        this._info = null;

        this._eyes = null;
        this._hair = null;
        this._head = null;
        this._pants = null;
        this._shirt = null;
        this._shoes = null;
        this._mouth = null;
        this._hacc = null;
        this._tie = null;
        this._glasses = null;
        this._earrings = null;
        this._hat = null;
        this._speech = null;
        
        this._pixelsTraveled = 0;
        this._blinkTimer = 0;
        this._yawnTimer = 0;
        this._height = 10;
        this.shoesFrame1 = new Core.Rect();
        this.shoesFrame2 = new Core.Rect();
        this._lastPos = new Core.Point();
        this._lastVseed = 0;
        this._walkingAnimation = null;
        this._idleAnimation = null;
    },
    
    $initWithSeed : function(bseed)
    {
        var bitizen = new this();
        bitizen._seed = bseed;
        bitizen._info = TTScene._playerData.getBitizenInfo(bitizen._seed);        
        if (bitizen._seed > BITIZEN_SPECIAL_SEED_COUNT)
        {
            srandom(bitizen._seed);
        }
        
        // SEX
        male = (std_rand() % 2 || bitizen._seed == BITIZEN_SEED_BIGSPENDER);  
        bitizen._male = male;
        if (bitizen._seed == BITIZEN_SEED_CELEBRITY)
        {
            bitizen._male = false;
        }
        
        bitizen._firstName = male ? bitizen._maleNames[std_rand() % NUM_MALE_NAMES] : bitizen._femaleNames[std_rand() % NUM_FEMALE_NAMES];
        bitizen._lastName = bitizen._lastNames[std_rand() % NUM_LAST_NAMES];
        
        bitizen._name = bitizen._firstName + " " + bitizen._lastName;
        if (bitizen._name.length >= 15)
        {
            bitizen._name = bitizen._firstName.substr(1, 1) + ". " + bitizen._lastName;
        }
        
        // BIRTHDAY
        bitizen._bmonth = (std_rand() % 12) + 1;
        
        switch (bitizen._bmonth)
        {
            case 1:
            case 3:
            case 5:
            case 7:
            case 8:
            case 10:
            case 12:
                bitizen._bday = (std_rand() % 31) + 1;
                break;
            case 4:
            case 6:
            case 9:
            case 11:
                bitizen._bday = (std_rand() % 30) + 1;
                break;
            case 2:
                bitizen._bday = (std_rand() % 28) + 1;
                break;
        }
        
        // HEAD
        bitizen._head = TTSpriteFactory.spriteWithFile_withAnchor('bitizen-head.png', [ 0.5, 1 ]);
        bitizen._head.setColor(bitizen._skinColors[std_rand() % NUM_SKIN_COLORS]);
        
        // HAIR
        bitizen._hair = TTSpriteFactory.spriteWithFile_withAnchor("bitizen-hair%d.png".replace("%d", (male ? 0 : 1)), [ 0.5, 0 ]);
        bitizen._hair.setColor(bitizen._hairColors[std_rand() % NUM_SKIN_COLORS]);
        
        // VSEED
        if (!bitizen._info || bitizen._info._vseed == 0)
        {
            srandom(bitizen._seed);
            bitizen._lastVseed = bitizen._seed;
            if (bitizen._info)
                bitizen._info._vseed = bitizen._seed;
        }
        else
        {
            srandom(bitizen._info._vseed);
            bitizen._lastVseed = bitizen._info._vseed;
        }
        
        // SHOES
        var imageSize = new Core.Size(DataPreloader._imageSizes['bitizen-shoes.png']);
        
     // Walking animation
        var walkingParameters = {
            0 : {
                _duration : 200,
                _uvs : [ 0, 0, 1, 0.5]
            },
            1 : {
                _duration : 200,
                _uvs : [ 0, 0.5, 1, 0.5 ]
            }
        };
        bitizen._walkingAnimation = AnimationCache.getAnimation("shoes_walking", 'bitizen-shoes.png', imageSize, [ 0.5, 1 ], false, walkingParameters);
        
        // Idle animation
        var idleParameters = {
            0 : {
                _duration : 0,
                _uvs : [  0, 0, 1, 0.5 ]
            },
        };
        bitizen._idleAnimation = AnimationCache.getAnimation("shoes_idle", 'bitizen-shoes.png', imageSize, [ 0.5, 1 ], false, idleParameters);
        
        // Sets animation
        bitizen._shoes = new GL2.Sprite();
        bitizen._shoes.setAnimation(bitizen._idleAnimation);
        bitizen._node.addChild(bitizen._shoes);
        bitizen._shoes.setPosition(0, bitizen._height - 2);
        bitizen._shoes.setColor(bitizen._hairColors[std_rand() % NUM_HAIR_COLORS]);
        
        // PANTS
        bitizen._pants = TTSpriteFactory.spriteWithFile_withAnchor('bitizen-pants.png', [ 0.5, 1 ]);
        bitizen._node.addChild(bitizen._pants);
        bitizen._pants.setPosition(0, bitizen._height - createBB(bitizen._shoes).getSize().getHeight() );
        bitizen._pants.setColor(rand_color());
        
        // SHIRT
        bitizen._shirt = TTSpriteFactory.spriteWithFile_withAnchor('bitizen-shirt.png', [ 0.5, 1 ]);
        bitizen._node.addChild(bitizen._shirt);
        bitizen._shirt.setPosition(
        		new Core.Point(0, 
        				(bitizen._height - (bitizen._pants.getPosition().getY() + createBB(bitizen._pants).getSize().getHeight())) + 2
        				)
        		);
        bitizen._shirt.setColor(rand_color());
        
        if (bitizen._seed == BITIZEN_SEED_CONSTRUCTION)
        {
            bitizen._pants.setColor(ccc3(229, 115, 4));
            bitizen._shirt.setColor(ccc3(255, 129, 5));
            bitizen._shoes.setColor(ccc3(255, 195, 8));
        }
        else if (bitizen._seed == BITIZEN_SEED_DELIVERYMAN)
        {
            bitizen._pants.setColor(ccc3(102, 51, 26));
            bitizen._shirt.setColor(ccc3(102, 51, 26));
            bitizen._shoes.setColor(ccc3(0, 0, 0));
            
        }
        else if (bitizen._seed == BITIZEN_SEED_BIGSPENDER)
        {
            bitizen._pants.setColor(ccc3(78, 136, 10));
            bitizen._shirt.setColor(ccc3(90, 157, 11));
            bitizen._shoes.setColor(ccc3(204, 197, 2));
            
        }
        else if (bitizen._seed == BITIZEN_SEED_CELEBRITY)
        {
            bitizen._pants.setColor(ccc3(255, 255, 255));
            bitizen._shirt.setColor(ccc3(255, 143, 209));
            bitizen._shoes.setColor(ccc3(255, 255, 255));
            
        }
        else if (bitizen._seed == BITIZEN_SEED_REALESTATE)
        {
            bitizen._pants.setColor(ccc3(50, 70, 150));
            bitizen._shirt.setColor(ccc3(30, 60, 130));
            bitizen._shoes.setColor(ccc3(10, 20, 30));
        }
        
        bitizen._node.addChild(bitizen._head);
        bitizen._head.setPosition(
                0,
                bitizen._height - (bitizen._shirt.getPosition().getY() + 4));

        
        // EYES
        bitizen._eyes = TTSpriteFactory.spriteWithFile_withAnchor('bitizen-eyes.png', [ 0.5, 1 ]);
        bitizen._node.addChild(bitizen._eyes);
        bitizen._eyes.setPosition(
                0,
                bitizen._height - (bitizen._head.getPosition().getY() + 24));

        
        // MOUTH
        bitizen._mouth = TTSpriteFactory.spriteWithFile_withAnchor('bitizen-mouth.png', [ 0.5, 1 ]);
        bitizen._node.addChild(bitizen._mouth);
        bitizen._mouth.setPosition(
                bitizen._eyes.getPosition().getX() - 2,
                (bitizen._height + -28) - (bitizen._eyes.getPosition().getY()) - 4);

        
        bitizen._mouth.setVisible(false);
        
        bitizen._node.addChild(bitizen._hair);
        bitizen._hair.setPosition(
                0,
                bitizen._height - (bitizen._head.getPosition().getY() + createBB(bitizen._head).getSize().getHeight()) - 6);

        // UNISEX ACCESSORY?
        // GLASSES?
        if (bitizen._seed == BITIZEN_SEED_BIGSPENDER || bitizen._seed == BITIZEN_SEED_CELEBRITY || std_rand() % 7 == 0)
        {
            bitizen._glasses = TTSpriteFactory.spriteWithFile_withAnchor("bitizen-glasses%d.png".replace("%d", (bitizen._seed == BITIZEN_SEED_BIGSPENDER || bitizen._seed == BITIZEN_SEED_CELEBRITY) ? 2 : std_rand() % NUM_GLASSES), [ 0.5, 1 ]);
            bitizen._node.addChild(bitizen._glasses);
            bitizen._glasses.setPosition(
                    bitizen._head.getPosition().getX(),
                    bitizen._height - (bitizen._hair.getPosition().getY() + 50));

        }
        
        // MALE ACCESSORY?
        if (bitizen._male)
        {
            // TIE
            if (bitizen._seed == BITIZEN_SEED_REALESTATE || bitizen._seed == BITIZEN_SEED_BIGSPENDER || std_rand() % 5 == 0)
            {
            	if(bitizen._seed != BITIZEN_SEED_CONSTRUCTION) {
                bitizen._tie = TTSpriteFactory.spriteWithFile_withAnchor('bitizen-tie.png', [ 0.5, 0 ]);
                bitizen._node.addChild(bitizen._tie);
                bitizen._tie.setPosition(
                        bitizen._head.getPosition().getX(),
                        bitizen._height - (bitizen._head.getPosition().getY()) - 10);
                bitizen._tie.setColor(rand_color());
            	}
            }
            // HAIR
            if (std_rand() % 3 == 0)
            {
                bitizen._hacc = TTSpriteFactory.spriteWithFile_withAnchor('bitizen-hacc%d.png'.replace("%d", std_rand() % NUM_HAIR_ACC), [ 0.5, 0 ]);
                bitizen._node.addChild(bitizen._hacc);
                bitizen._hacc.setPosition(
                        bitizen._eyes.getPosition().getX() - 2,
                        bitizen._height - (bitizen._eyes.getPosition().getY()) - 42);
                bitizen._hacc.setColor(bitizen._hair.getColor());
            }
            // HAT
            if (bitizen._seed != BITIZEN_SEED_BIGSPENDER && (bitizen._seed == BITIZEN_SEED_CONSTRUCTION || bitizen._seed == BITIZEN_SEED_CELEBRITY || std_rand() % 3 == 0))
            {
                if (bitizen._seed != BITIZEN_SEED_CONSTRUCTION && std_rand() % 5 == 0)
                {
                    bitizen._hat = TTSpriteFactory.spriteWithFile_withAnchor('bitizen-bhat%d.png'.replace("%d", std_rand() % NUM_BHATS), [ 0, 1 ]);
                }
                else
                {
                    bitizen._hat = TTSpriteFactory.spriteWithFile_withAnchor('bitizen-mhat%d.png'.replace("%d", std_rand() % NUM_MHATS), [ 0, 1 ]);
                }
                bitizen._node.addChild(bitizen._hat);
                bitizen._hat.setPosition(-18, bitizen._height - 2);

                bitizen._hat.setColor(rand_color());
            }
        }
        // FEMALE ACCESSORY?
        else
        {
            // EARRINGS
            if (bitizen._seed == BITIZEN_SEED_REALESTATE || bitizen._seed == BITIZEN_SEED_CELEBRITY || std_rand() % 5 == 0)
            {
                bitizen._earrings = TTSpriteFactory.spriteWithFile_withAnchor('bitizen-earrings.png', [ 0.5, 0 ]);
                bitizen._node.addChild(bitizen._earrings);
                bitizen._earrings.setPosition(
                        -1 * bitizen._shirt.scale,
                        bitizen._height - (bitizen._shirt.getPosition().getY() + bitizen._shirt.AL_getSize().getHeight() * bitizen._shirt.scale + 4));
                bitizen._earrings.setColor(rand_color());
            }
            // HAT
            if (bitizen._seed == BITIZEN_SEED_CONSTRUCTION || std_rand() % 3 == 0)
            {
                if (bitizen._seed != BITIZEN_SEED_CONSTRUCTION && std_rand() % 5 == 0)
                    bitizen._hat = TTSpriteFactory.spriteWithFile_withAnchor('bitizen-bhat%d.png'.replace("%d", std_rand() % NUM_BHATS), [ 0, 1 ]);
                else
                    bitizen._hat = TTSpriteFactory.spriteWithFile_withAnchor('bitizen-fhat%d.png'.replace("%d", std_rand() % NUM_FHATS), [ 0, 1 ]);
                
                bitizen._node.addChild(bitizen._hat);
                bitizen._hat.setPosition(-18, bitizen._height - 2);

                bitizen._hat.setColor(rand_color());
            }
        }
        
        if (bitizen._hat && bitizen._seed == BITIZEN_SEED_CONSTRUCTION)
        {
            bitizen._hat.setColor(ccc3(255, 255, 0));
        }
        else if (bitizen._hat && bitizen._seed == BITIZEN_SEED_DELIVERYMAN)
        {
            bitizen._hat.setColor(ccc3(102, 51, 26));
        }
        else if (bitizen._tie && bitizen._seed == BITIZEN_SEED_BIGSPENDER)
        {
            bitizen._tie.setColor(ccc3(204, 197, 2));
        }
        else if (bitizen._tie && bitizen._seed == BITIZEN_SEED_REALESTATE)
        {
            bitizen._tie.setColor(ccc3(255, 0, 0));
            
        }
        else if (bitizen._earrings && bitizen._seed == BITIZEN_SEED_REALESTATE)
        {
            bitizen._earrings.setColor(ccc3(255, 0, 0));
        }
        
        bitizen._destX = -1;
        bitizen._lastPos.setX(bitizen._node.getPosition().getX());
        bitizen._lastPos.setY(bitizen._node.getPosition().getY());
        bitizen._pixelsTraveled = 0;
        bitizen._blinkTimer = 0;
        bitizen._yawnTimer = 0;
        
        return bitizen;
    },
    
    destroy : function()
    {
        this._name = null;
        this._firstName = null;
        this._lastName = null;
        this._bmonth = null;
        this._bday = null;
        this._male = null;
        this._info = null;
        this._blinkTimer = 0;
        this._yawnTimer = 0;
        this._height = 10;
        this.shoesFrame1 = null;
        this.shoesFrame2 = null;
        this._lastPos = null;
    },
    
    $skillIn : function(busType, seed)
    {
    	
        srandom((parseInt(busType) + 1) * parseInt(seed));
        return std_rand() % 10;
    },

    setSpeech : function(icon)
    {
        if (this._speech)
        {
            this._speech.destroy(true);
            this._mouth.stopAllActions();
        }
        
        if (icon)
        {
            this._speech = TTSpriteFactory.spriteWithFile_withAnchor('speech.png', [ 0.5, 0.5 ]);
            this._speech.setPosition(-5, this._height-45);
            this._node.addChild(this._speech);
            this._speech.addChild(icon);
          
            //FIXME
            icon.setPosition(icon.getPosition().getX(), icon.getPosition().getY()-4);
           // icon.setPosition(new Core.Point(this._speech.AL_getSize().getWidth/2,this._height-(this._speech.AL_getSize().getHeight()/2+2)));
           
            this._mouth.runAction(
            		Action.RepeatForever.actionWithAction(
            				Action.Sequence.actions(Action.Hide.action(),
            						 Action.DelayTime.actionWithDuration(0.5), 
            						 Action.Show.action(), 
            						 Action.DelayTime.actionWithDuration(0.5),null)));
        }
        else
        {
            this._mouth.setVisible(false);
        }
        
    },
    
    happiness : function()
    {
        var mood = "sad";
        if (this._info._workFloor > 0)
        {
            var sInfo = TTScene.sharedScene()._playerData.getStoryInfo(this._info._workFloor);
            if (this._info._dreamFloor == sInfo._floorId)
            {
                mood = "happy";
            }
            else
            {
                var fInfo = TTFloorTable.floorWithId(sInfo._floorId);
                var sk = TTBitizen.skillIn(fInfo ? fInfo._type : 0, this._info._seed);
                if (sk >= 5)
                {
                    mood = "neutral";
                }
            }
        }
        
        return mood;
    },
    
    _draw : function(delta)
    {
        if (!this._walkingAnimation)
        {
            return;
        }
        
        // DestX
        var walkSpeed = 0;
        if (this._destX > -1)
        {
            if (Math.abs(Math.round(this._node.getPosition().getX()) - this._destX) <= WALK_SPEED )
            {
                this._destX = -1;
            }
            else
            {
                walkSpeed = WALK_SPEED;                
                walkSpeed = walkSpeed * (this._node.getPosition().getX() < this._destX ? 1 : -1); 
                
                this._node.setScale((walkSpeed < 0) ? 1 : -1, 1);
                this._node.setPosition(this._node.getPosition().getX() + walkSpeed, this._node.getPosition().getY());
            }
        }
        
        // walking 
        var pixDist2 = walkSpeed;
        var pixDist = Math.abs(this._node.getPosition().getX() - this._lastPos.getX());
        
        this._pixelsTraveled += pixDist;
        
        if (pixDist > 0)
        {        	
            if (this._shoes._animation != this._walkingAnimation)
            {
                this._shoes.setAnimation(this._walkingAnimation);
            }
        }
        else
        {        
            if (this._shoes._animation != this._idleAnimation)
            {
                this._shoes.setAnimation(this._idleAnimation);
            }
        }
        
        this._lastPos.setX(this._node.getPosition().getX());
        this._lastPos.setY(this._node.getPosition().getY());
        
        // yawning
        if (this._yawnTimer > 0)
        {
            this._yawnTimer--;
            if (this._yawnTimer == 0)
            {
                this._eyes.setAlpha(255 / 255);
                this._mouth.setVisible(false);
            }
        }
        else if (pixDist == 0 && std_rand() % (60 * 30) == 0)
        {
            this._yawnTimer = 30 * 1;
            this._eyes.setAlpha(32 / 255);
            this._mouth.setVisible(true);
        }
        if (this._yawnTimer == 0)
        {
            // blinking
            if (this._blinkTimer > 0)
            {
                this._blinkTimer--;
                if (this._blinkTimer == 0)
                {
                    this._eyes.setAlpha(1);
                }
            }
            else if (std_rand() % (60 * 6) == 0)
            {
                this._blinkTimer = 8;
                this._eyes.setAlpha(32 / 255);
            }
        }
        
        if (this._info && this._lastVseed != this._info._vseed)
        { 
        	al_trace("REDRESS BEGIN");
            //FIXME
            // REDRESS			
            srandom(this._info._vseed);
            this._lastVseed = this._info._vseed;
            
            // SHOES
            this._shoes.setColor(this._hairColors[std_rand() % NUM_HAIR_COLORS]);
            
            // PANTS
            this._pants.setColor(rand_color());
            
            // SHIRT
            this._shirt.setColor(rand_color());
            
            // UNISEX ACCESSORY?
            
            // GLASSES?
            if (this._glasses)
            {
                this._glasses.destroy();
                this._glasses = null;
            }
            
            if (std_rand() % 7 == 0)
            {
            	al_trace("glasses");
                this._glasses = TTSpriteFactory.spriteWithFile_withAnchor("bitizen-glasses%d.png".replace("%d", std_rand() % NUM_GLASSES), [ 0.5, 1 ]);
                this._node.addChild(this._glasses);
                
                /*this._glasses.setPosition(
                		this._head.getPosition().getX(),
                		this._height - (this._hair.getPosition().getY() + 44));
*/
                this._glasses.setPosition(
                		this._head.getPosition().getX(),
                		this._height - (this._hair.getPosition().getY() + 50));
                
            }
            
            if (this._male)
            {
                // TIE
                
                if (this._tie)
                {
                    this._tie.destroy();
                    this._tie = null;
                }
                
                if (std_rand() % 5 == 0)
                {
                	al_trace("TIE");
                    this._tie = TTSpriteFactory.spriteWithFile_withAnchor("bitizen-tie.png", [ 0.5, 0 ]);
                    this._node.addChild(this._tie);
                    
                    
                    this._tie.setPosition(                    		
                    		this._head.getPosition().getX(),
                    		this._height - (this._head.getPosition().getY()+10));
                    this._tie.setColor(rand_color());
                    
                }
                
                // HAIR
                
                if (this._hacc)
                {
                    this._hacc.destroy();
                    this._hacc = null;
                }
                
                if (std_rand() % 3 == 0)
                {
                	al_trace("HAIR");
                    this._hacc = TTSpriteFactory.spriteWithFile_withAnchor("bitizen-hacc%d.png".replace("%d", std_rand() % NUM_HAIR_ACC), [ 0.5, 0 ]);
                    this._node.addChild(this._hacc);
                    this._hacc.setPosition(
                    		this._eyes.getPosition().getX() - 2,
                    		this._height - (this._eyes.getPosition().getY()) - 42);
                    
                    this._hacc.setColor(this._hair.getColor());
                }
                
                
                
                
                
                // HAT
                
                if (this._hat)
                {
                    this._hat.destroy();
                    this._hat = null;
                }
                
                if (this._seed == BITIZEN_SEED_CONSTRUCTION || std_rand() % 3 == 0)
                {
                    if (std_rand() % 5 == 0)
                    {
                        this._hat = TTSpriteFactory.spriteWithFile_withAnchor("bitizen-bhat%d.png".replace("%d", std_rand() % NUM_BHATS), [ 0, 1 ]);
                    }
                    else
                    {
                        this._hat = TTSpriteFactory.spriteWithFile_withAnchor("bitizen-mhat%d.png".replace("%d", std_rand() % NUM_BHATS), [ 0, 1 ]);
                    }
                    al_trace("HAT MEN");
                    this._node.addChild(this._hat);
                    this._hat.setPosition(-18, this._height - 2);
                    this._hat.setColor(rand_color());
                }
                
                // FEMALE ACCESSORY?
            }
            else
            {
                // EARRINGS
                
                if (this._earrings)
                {
                    this._earrings.destroy();
                    this._earrings = null;
                }
                
                if (std_rand() % 5 == 0)
                {
                	al_trace("EARRINGS FEMALE");
                    this._earrings = TTSpriteFactory.spriteWithFile_withAnchor("bitizen-earrings.png", [ 0.5, 1 ]);
                    this._node.addChild(this._earrings);
                    this._earrings.setPosition(
                    		-2,
                    		this._height - (this._shirt.getPosition().getY() + this._shirt.AL_getSize().getHeight() * this._shirt.getScale().getX() + 4));
                }
                
                // HAT
                
                if (this._hat)
                {
                    this._hat.destroy();
                    this._hat = null;
                }
                
                if (this._seed == BITIZEN_SEED_CONSTRUCTION || std_rand() % 3 == 0)
                {
                    if (std_rand() % 5 == 0)
                    {
                        this._hat = TTSpriteFactory.spriteWithFile_withAnchor("bitizen-bhat%d.png".replace("%d", std_rand() % NUM_BHATS), [ 0, 1 ]);
                    }
                    else
                    {
                        this._hat = TTSpriteFactory.spriteWithFile_withAnchor("bitizen-fhat%d.png".replace("%d", std_rand() % NUM_BHATS), [ 0, 1 ]);
                    }
                    al_trace("HAT FEMALE");
                    this._node.addChild(this._hat);
                    this._hat.setPosition(-18, this._height - 2);

                    this._hat.setColor(rand_color());
                }
            }
            al_trace("REDRESS END");
        }
    }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTNewFloorLayer'] = function(){var exports = $MODULE_REGISTRY['Code/TTNewFloorLayer'] || {}; $MODULE_REGISTRY['Code/TTNewFloorLayer'] = exports; exports.TTNewFloorLayer = BaseClass.subclass({
    classname : 'TTNewFloorLayer',
    
    initialize : function(width, height)
    {
        this._emptyFloor = null;
        this._list = null;
        this._itemsLoaded = 0;
        this._itemsToLoad = [];
        this._fcount = 1; // _fcount > 1 for draw. Don't know for what it is used
        
        // focusFloor = flr;
        this._shade = ALLayerColor.layerWithColor(new Core.Color(0,0,0), 128/255);
        this._node.addChild(this._shade);
        
        this._list = TTList.initWithTarget(this, this.listClicked.bind(this));
        this._list.setItemSize(new Core.Size(146 * 2, 88 * 2));
        this._list._node.setPosition(new Core.Point(UNISCREEN_WIDTH / 2, UNISCREEN_HEIGHT / 2 + 100));
        this._node.addChild(this._list._node);
        //arr_delete(this._list);
        
        var numBlueprints = 5;
        this._itemsLoaded = 0;
        var bpbg;
        var i = 0;
        for (i = 0; i < numBlueprints; i++)
        {
            bpbg = TTSpriteFactory.spriteWithFile("blueprint_bg.png");
            this._list.addItem(bpbg);
            
            // random blueprint for now
            var rfid = std_rand() % TTFloorTable.floorCount();
            while (rfid == FLOOR_ID_EMPTY || rfid == FLOOR_ID_CONSTRUCTION)
            {
                rfid = std_rand() % TTFloorTable.floorCount();
            }
            
            bpbg.AL_setTag(rfid);
            this._itemsToLoad.push(bpbg);
        }
        
        this._emptyFloor = floor;
    },
    
    destroy : function()
    {
        arr_delete(this._itemsToLoad);
    },
    
    buildConfirmation : function(dialog)
    {
        if (dialog.buttonIndex == 1)
        {
            var blueprintId = dialog.data.intValue();
            var emptyStory = this._emptyFloor.storyInfo;
            
            // Switch to contruction floor
            this._emptyFloor.switchToFloorId(FLOOR_ID_CONSTRUCTION);
            // Store which floor id we're constructing
            emptyStory.sales()[1] = blueprintId;
            this._emptyFloor.startProduction(0);
            this._emptyFloor.addContructionWorkers();
            TTScene.sharedScene().runMenuLayer(null);
            SoundBoard.playSfx(SFX_CONSTRUCTION);
        }
    },
    
    listClicked : function(index)
    {
        var i = index;
        
        console.log("Catalog tapped index: %d", i);
        
        var blueprintId = this._list[i].AL_getTag();
        var bInfo = TTFloorTable.floorWithId(blueprintId);
        if (bInfo)
        {
            var dlg = new TTDialog();
            dlg.initWithMessage("\n\n\nBuild a\n" + bInfo._name + "\non this floor?", "no,yes", this.buildConfirmation, this, blueprintId);
            TTDialogQueue.sharedQueue().addDialog(dlg);
            
        }
    },
    
    $initWithEmpty : function(floor)
    {
        return new this(UNISAFE_WIDTH, UNISAFE_HEIGHT);
    },
    
    _ccTouchBegan : function(touch, event)
    {
        return false;
    },
    
    _draw : function()
    {
        // check if there are tanks to load, load 3 at a time
        var i;
        for (i = 0; i < 3; i++)
        {
            if (this._fcount > 0 && !this._list.isDragging() && this._itemsToLoad.length > 0)
            {
                console.log("Loading item: " + this._itemsLoaded);
                
                // load an item
                var li = this._list[this._itemsLoaded];
                
                var floorInfo = TTFloorTable.floorWithId(li.AL_getTag());
                if (floorInfo)
                {
                    var fgfx = TTSpriteFactory.spriteWithFile("floor" + floorInfo._fid + ".png");
                    //fgfx.setTextureRect(new Core.Rect(0, 0, 128, 48));
                    fgfx.setPosition(new Core.Point(8, 10));
                    li.addChild(fgfx);
                    
                    // CCLabelBMFont *nameLbl = [CCLabelBMFont labelWithString:[floorInfo.name uppercaseString] fntFile:@"silkscreen9.fnt"];
                    var nameLbl = LabelConfigurer.createLabelWithString(floorInfo, "Arial", 22, new Core.Vector(0, 0));
                    // [nameLbl.texture setAliasTexParameters];
                    nameLbl.setPosition(new Core.Point(6, 77));
                    li.addChild(nameLbl);
                    
                    // CCLabelBMFont *typeLbl = [CCLabelBMFont labelWithString:[TTScene floorTypeString:floorInfo.type] fntFile:@"silkscreen9.fnt"];
                    var typeLbl = LabelConfigurer.createLabelWithString(TTScene.floorTypeString(floorInfo._type), "Arial", 22, new Core.Vector(0, 0));
                    // [typeLbl setColor:[TTScene
                    // floorTypeColor:floorInfo.type]];
                    // [typeLbl.texture setAliasTexParameters];
                    typeLbl.setPosition(new Core.Point(nameLbl.position.x, nameLbl.position.y - 10));
                    li.addChild(typeLbl);
                    
                    if (floorInfo._type != TTHud.FLOOR_TYPE_RESIDENTIAL)
                    {
                        var totalMinutes = floorInfo.products[0].time + floorInfo.products[1].time + floorInfo.products[2].time;
                        // CCLabelBMFont *timeLbl = [CCLabelBMFont labelWithString:[NSString stringWithFormat:@"LVL %d",(int)ceil(totalMinutes/30.0)] fntFile:@"silkscreen9.fnt"];
                        var timeLbl = LabelConfigurer.createLabelWithString("LVL " + Math.ceil(totalMinutes / 30.0), "Arial", 22, new Core.Vector(0, 0));
                        // [timeLbl setColor:[TTScene floorTypeColor:floorInfo.type]];
                        // [timeLbl.texture setAliasTexParameters];
                        timeLbl.setPosition(new Core.Point(138, typeLbl.position.y));
                        li.addChild(timeLbl);
                    }
                }
                
                this._itemsToLoad.removeObjectAtIndex(0);
                this._itemsLoaded++;
            }
        }
        
        this._fcount++;
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTStoryInfo'] = function(){var exports = $MODULE_REGISTRY['Code/TTStoryInfo'] || {}; $MODULE_REGISTRY['Code/TTStoryInfo'] = exports; exports.TTStoryInfo = Core.Class.subclass(
{
    classname : 'TTStoryInfo',
    
    initialize : function()
    {
        // _nname changed to _name     
        this._name = null;
        this._sales = [];
        this._stock = [];
        this._story = -1;
        this._floorId = -1;
        this._activeProduct = -1;
        this._prodStartTime = -1;
        this._problem = -1;
        
        this._color = [];
        
        for ( var i = 0; i < 3; i++)
        {
            this._sales[i] = 0;
            this._stock[i] = 0; // NOTE: missing in the original code
        }
    },
    
    destroy: function()
    {
        arr_delete(this._color);
        arr_delete(this._sales);
        arr_delete(this._stock);
    },
   
    sales : function()
    {
        return this._sales;
    },
    
    stock : function()
    {
        return this._stock;
    },

    setFloorId : function(fid)
    {
        this._floorId = fid;
    },
    setStory : function(story)
    {
        this._story = story;
    },
    
    floorId : function()
    {
        return this._floorId;
    },
    
    $typeCompare : function(a, b)
    {
        if (b)
        {
            var info = TTFloorTable.floorWithId(a._floorId);
            var otherInfo = TTFloorTable.floorWithId(b._floorId);
            
            if (!info || !otherInfo)
            {
                return 0;
            }
            var costA = info._type;
            var costB = otherInfo._type;
            
            if (costA > costB)
            {
                return 1;
            }
            else
            {
                return -1;
            }
        }
        return 0;
    },
    
    toString : function()
    {
        return sprintf("s=%d;f=%d;a=%d;pt=%d;pr=%d;sl=%d:%d:%d;st=%d:%d:%d;n=%s;mr=%s:%s:%s;mg=%s:%s:%s;mb=%s:%s:%s",
            Number(this._story),
            Number(this._floorId),
            Number(this._activeProduct),
            Number(this._prodStartTime),
            Number(this._problem),
            Number(this._sales[0]),
            Number(this._sales[1]),
            Number(this._sales[2]),
            Number(this._stock[0]),
            Number(this._stock[1]),
            Number(this._stock[2]),
            this._name ? this._name:"",
            this._color.length!=0 ? this._color[0][0] : -1,
            this._color.length!=0 ? this._color[0][1] : -1,
            this._color.length!=0 ? this._color[0][2] : -1,
            this._color.length!=0 ? this._color[1][0] : -1,
            this._color.length!=0 ? this._color[1][1] : -1,
            this._color.length!=0 ? this._color[1][2] : -1,
            this._color.length!=0 ? this._color[2][0] : -1,
            this._color.length!=0 ? this._color[2][1] : -1,
            this._color.length!=0 ? this._color[2][2] : -1);
    }
}); ; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTElevator'] = function(){var exports = $MODULE_REGISTRY['Code/TTElevator'] || {}; $MODULE_REGISTRY['Code/TTElevator'] = exports; var TTBitizen = require('Code/TTBitizen').TTBitizen;

exports.TTElevator = BaseClass.subclass({
    classname : 'TTElevator',
    
    initialize : function()
    {        
    	//al_trace("initialize");    	
        this._car = TTSpriteFactory.spriteWithFile("elevator_" + (TTScene.sharedScene()._playerData._elevator) + ".png", [ 0, 1 ]);
        this._car.setPosition(0, -24);

        this._car.setDepth(20);
        this._node.addChild(this._car);
        
        this._targetFloor = null;
        
        this._door = ALLayerColor.layerWithColor(ccc3(0, 0, 0), 1, 30, 60, [ 0.5, 1 ]);
        this._door.setPosition(28,-28);


        this._door.setScale(0, 1);
        this._car.addChild(this._door);
        this._door2 = ALLayerColor.layerWithColor(ccc3(0, 0, 0), 1, 30, 60, [ 0.5, 1 ]);
        this._door2.setPosition(28,-28);

        this._door2.setAlpha(0);
        this._door2.setDepth(100);
        this._car.addChild(this._door2);
        
        this._occupant = null;
        this._velY = 0;
        this._riderFloor = null;
        this._nextRiderSeed = 1;
        this._maxVel = 0;
    },
    
    reload : function()
    {
        var newCar = TTSpriteFactory.spriteWithFile("elevator_" + (TTScene.sharedScene()._playerData._elevator) + ".png", [ 0, 1 ]);
        newCar.setPosition(0, - 12 * this._car.getScale().getY());
        newCar.setDepth(20);
        this._car.setAnimation(newCar.getAnimation());
    },
    
    setMaxVel : function()
    {
        this._maxVel = 4 * (TTScene.sharedScene()._playerData._elevator + 1);
    },
    
    hasOccupant : function()
    {
        return this._occupant;
    },
    
    isOccupantVIP : function()
    {
        return (this._occupant && this._occupant._seed <= BITIZEN_SPECIAL_SEED_COUNT);
    },
    
    addBitizen : function(bitizen)
    {
    	al_trace("addBitizen");
        if (!this._occupant)
        {
        	this._occupant = bitizen;
            //this._occupant._node.AL_removeFromParentAndCleanup(true);
            
            this._occupant._node.setPosition(30, -36);

            this._occupant._node.setDepth(1000);
            this._car.addChild(this._occupant._node);
        	
            this._door2.setAlpha(1);
            this._door2.runAction(
                    Action.Sequence.actions(
                            Action.FadeOut.actionWithDuration(0.5),
                            Action.CallFunc.actionWithTarget(this, this.closeDoors)));
        }
        
    },
    
    newRider : function()
    {
        var newBit = TTBitizen.initWithSeed(this._nextRiderSeed);
        this.addBitizen(newBit);
        this._door2.setAlpha(1);
        this._door2.runAction(
                Action.Sequence.actions(
                        Action.FadeOut.actionWithDuration(0.5),
                        Action.CallFunc.actionWithTarget(this, this.closeDoors)));
        
    },
    
    openDoors : function()
    {
        this._door.runAction(Action.ScaleTo.actionWithDuration(1, 1, 1));
    },
    
    closeDoors : function()
    {
        this._door.runAction(Action.ScaleTo.actionWithDuration(1, 0, 1));
    },
    
    addNewRiderGoingToFloor : function(floor)
    {
        if (!this._occupant)
        {
            this._riderFloor = floor;
            this.openDoors();
            this._nextRiderSeed = std_rand();
            
            this._node.runAction(
                    Action.Sequence.actions(
                            Action.DelayTime.actionWithDuration(2),
                            Action.CallFunc.actionWithTarget(this,this.newRider)));
        }
        
    },
    addNewVIP : function(bitSeed)
    {
        if (!this._occupant)
        {
            this._riderFloor = TTScene.sharedScene()._towerLayer._floors[0];
            this.openDoors();
            this._nextRiderSeed = bitSeed;
            
            this._node.runAction(
                    Action.Sequence.actions(
                            Action.DelayTime.actionWithDuration(2),
                            Action.CallFunc.actionWithTarget(this,this.newRider)));
            
        }
    },
    
    removeBitizen2 : function()
    {
        if (this._occupant)
        {
            this._riderFloor.addRider(this._occupant);
            this._occupant = null;
            this._riderFloor = null;
            this._door2.setAlpha(0);
            this.closeDoors();
        }
    },
    deliverRider : function()
    {
        if (this._occupant)
        {
            this.openDoors();
            SoundBoard.playSfx(SFX_ELEVATORDOORS);			
            this._door2.runAction(
                    Action.Sequence.actions(
                            Action.DelayTime.actionWithDuration(2),
                            Action.FadeIn.actionWithDuration(0.5),
                            Action.CallFunc.actionWithTarget(this,this.removeBitizen2)));
            TTHud.sharedHud().showZoomButton(true);
        }
    },
    cancelRider : function()
    {
        if (this._occupant)
        {
            this._occupant.destroy();
            this._occupant = null;
            this._riderFloor = null;
            this._door.setScale(0, 0);
        }
    },
    
    push : function(direction)
    {
        this._velY = direction * this._maxVel;
    },
    
    _draw : function()
    {
        if (this._velY != 0)
        {
            this._velY *= 0.9;
            if (Math.abs(this._velY) < 0.2)
            {
                this._velY = 0;
            }
            
            this._node.setPosition(this._node.getPosition().getX(), Math.round(this._node.getPosition().getY() + this._velY));
        }
        
        if (this._targetFloor && this._door.getScale().getX() == 0 && !this._occupant)
        {
            var targetPosition = ccp(
                    Math.round(this._targetFloor._node.getPosition().getX()),
                    Math.round(this._targetFloor._node.getPosition().getY() + (FLOOR_HEIGHT_PIXELS * 2) - ELEVATOR_HEIGHT));
            var yVel = (targetPosition.getY() - this._node.getPosition().getY()) / 20;
            
            if (Math.abs(yVel) > this._maxVel)
            {
                yVel = this._maxVel * (yVel > 0 ? 1 : -1);
            }
            else if (Math.abs(yVel) < MIN_VEL)
            {
                yVel = MIN_VEL * (yVel > 0 ? 1 : -1);
            }
            
            this._node.setPosition(Math.round(this._node.getPosition().getX()), Math.round(this._node.getPosition().getY() + yVel));
            if (Math.abs(this._node.getPosition().getY() - this._targetFloor._node.getPosition().getY()) < MIN_VEL && this._velY < 0.2)
            {
                // Clones the position
                this._node.setPosition(targetPosition);
            }
        }
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTDialog'] = function(){var exports = $MODULE_REGISTRY['Code/TTDialog'] || {}; $MODULE_REGISTRY['Code/TTDialog'] = exports; exports.TTDialog = BaseClass.subclass({
    classname : 'TTDialog',
    
    $DLG_INPUT_DELAY : 0.3,
    
    initialize : function(message, buttons, cback, target, ddata)
    {
    	
        this._type = 0;
        this._target = target;
        this._callback = cback;
        this._data = ddata;
        this._leftButton = null;
        this._rightButton = null;
        this._dialogBg = null;
        
        this._firstDrawTime = 0;
        this._lastTouchStartTime;
        
        this._msg = message;
        this._buttonIndex = -1;
        
        var bPieces = buttons.split(",");
        var left = bPieces[0].toUpperCase();
        var right = (bPieces[1]) ? bPieces[1].toUpperCase() : "";
        
        this._node.setPosition(UNISCREEN_CENTER);
        
        this._dCont = new GL2.Node();
        this._dCont.setPosition(UNISCREEN_CENTER);
        this._node.addChild(this._dCont);
        
        this._dialogBg = TTSpriteFactory.spriteWithFile("NB_dialog.png", [ 0.5, 0.5 ]);
        var dialogBgSize = this._dialogBg.AL_getSize();
        this._node.addChild(this._dialogBg);
        
        var dWidth = dialogBgSize.getWidth() * this._dialogBg.getScale().getX();
        var dHeight = dialogBgSize.getHeight() * this._dialogBg.getScale().getY();
        
        // buttons
        var buttonLeft = TTSpriteFactory.spriteWithFile("NB_dialog_button.png", [ 0.5, 0.5 ]);
        buttonLeft.setPosition(right.length ? (this._dialogBg.getPosition().getX() - dWidth / 4 + 14) - 5: this._dialogBg.getPosition().getX(), 85);
        var leftLabel = LabelConfigurer.createLabelWithString(left, "silkscreen", FONT14, [ 0.5, 0.5 ], true);

		var _scale = leftLabel.getScale();
        leftLabel.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        buttonLeft.addChild(leftLabel);
        buttonLeft.setVisible(left.length);
        this._node.addChild(buttonLeft);
        this._leftButton = buttonLeft;
        
        var buttonRight = TTSpriteFactory.spriteWithFile("NB_dialog_button.png", [ 0.5, 0.5 ]);
        buttonRight.setPosition(left.length ? (this._dialogBg.getPosition().getX() + dWidth / 4 - 14) + 10 : this._dialogBg.getPosition().getX(), 85);
        var rightLabel = LabelConfigurer.createLabelWithString(right, "silkscreen", FONT14, [ 0.5, 0.5 ], true);

		var _scale = rightLabel.getScale();
        rightLabel.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        buttonRight.addChild(rightLabel);
        buttonRight.setVisible(right.length);
        this._rightButton = buttonRight;
        this._node.addChild(buttonRight);
        
        // WORD WRAPPED MESSAGE        
        var curLbl = LabelConfigurer.createLabelWithString(message, "silkscreen", FONT14, [ 0.5, 0.5 ], true);

		var _scale = curLbl.getScale();
        curLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        this._node.addChild(curLbl);
        curLbl.setPosition(0, -this._dialogBg.AL_getSize().getHeight()*0 - 60 );
        curLbl.setSize( (dWidth - 50)*1/FONTSCALE14, dHeight*1/FONTSCALE14);
        curLbl.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
        curLbl.setVerticalAlign(GL2.Text.VerticalAlign.Middle);
    },
    
    $initWithMessage : function(message, buttons, cback, target, ddata)
    {
        TTScene.shadeLayer(true);
        return new this(message, buttons, cback, target, ddata);
    },
    
    destroy : function()
    {
        TTScene.shadeLayer(false);
        this._data = null;
        al_trace(sprintf("Dialog with message: %s RELEASED!!!", this._msg));
        this._msg = null;
        
        // Pop next dialog
        TTDialogQueue.sharedQueue().popDialog();
    },
    
    animateDisplay : function()
    {
        this._dCont.setScale(0.01, 0.01);
        this._node.setScale(1, 1);
        this._dCont.setScale(0.01, 0.01);
        this._dCont.runAction(Action.Sequence.actions(
            Action.ScaleTo.actionWithDuration(0.15, 1.1),
            Action.ScaleTo.actionWithDuration(0.05, 1.0),
            null));
    },
    
    _draw : function()
    {
        if (this._firstDrawTime == 0)
        {
            this._firstDrawTime = Core.Time.getRealTime() / 1000;
        }
    },
    
    _ccTouchesBegan : function(/* GL2.Touch */touchEvent)
    {
        this._lastTouchStartTime = Core.Time.getRealTime() / 1000;
        if (this._lastTouchStartTime - this._firstDrawTime < TTDialog.DLG_INPUT_DELAY)
        {
            return true;
        }
        
        var tp = this._node.screenToLocal(touchEvent.getPosition());
        if (this._leftButton.getVisible() && CGRectContainsPoint(createBB(this._leftButton), tp))
        {
            this._leftButton.setAlpha(0.5);
            SoundBoard.playSfx(SFX_LIGHTSWITCH);
        }
        else if (this._rightButton.getVisible() && CGRectContainsPoint(createBB(this._rightButton), tp))
        {
            this._rightButton.setAlpha(0.5);
            SoundBoard.playSfx(SFX_LIGHTSWITCH);
        }
        
        return true;
    },
    
    _ccTouchesMoved : function(/*GL2.Touch*/touchEvent)
    {
    	var tp = this._node.screenToLocal(touchEvent.getPosition());

    	if (this._leftButton.getVisible() && CGRectContainsPoint(createBB(this._leftButton), tp))
        {
            this._leftButton.setAlpha(0.5);
        	this._rightButton.setAlpha(1);
        }
        else if (this._rightButton.getVisible() && CGRectContainsPoint(createBB(this._rightButton), tp))
        {
            this._rightButton.setAlpha(0.5);
            this._leftButton.setAlpha(1);
        }
        else
    	{
        	this._leftButton.setAlpha(1);
        	this._rightButton.setAlpha(1);
        	
    	}
        
    },
    
    _ccTouchesEnded : function(/* GL2.Touch */touchEvent)
    {
        if (this._node.getScale().getX() < 1 || this._lastTouchStartTime - this._firstDrawTime < this.DLG_INPUT_DELAY)
        {
            return;
        }
        var tp = this._node.screenToLocal(touchEvent.getPosition());
        if (this._leftButton.getVisible() && CGRectContainsPoint(createBB(this._leftButton), tp))
        {
            TTDialog.dismiss(this, 0);
        }
        else if (this._rightButton.getVisible() && CGRectContainsPoint(createBB(this._rightButton), tp))
        {
            TTDialog.dismiss(this, 1);
        }
    },
    
    $dismiss : function(dialog, buttonIndex)
    {
        if ( (!dialog._leftButton || !dialog._leftButton.getVisible()) &&
             (!dialog._rightButton || !dialog._rightButton.getVisible()))
        {
            return;
        }
        
        dialog._buttonIndex = buttonIndex;
        if (dialog._callback)
        {
            dialog._callback.call(dialog._target, dialog);
        }
        
        dialog.destroy();
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTMenuLayer'] = function(){var exports = $MODULE_REGISTRY['Code/TTMenuLayer'] || {}; $MODULE_REGISTRY['Code/TTMenuLayer'] = exports; exports.TTMenu = BaseClass.subclass({
    classname : 'TTMenuLayer',
    
    $NUM_MENU_ICONS : 9,
    
    $_icons : [ "menu_bitizen.png", "menu_settings.png", /*"menu_games.png",
                   "menu_gc.png",*/"menu_friends.png", "menu_stats.png", "menu_elevator.png", "menu_getbux.png", "menu_bank.png", "menu_bitbook.png","menu_achievements.png" ],
    $_lbls : [ "BITIZENS", "SETTINGS", /*"GAMES", "GAMECENTER", */"FRIENDS", "STATS", "ELEVATORS", "GET BUX", "BANK", "BITBOOK", "ACHIEVEMENTS" ],
    
    initialize : function(width, height)
    {
        //Bottom offset
        this.bottomOffset = (this.__size.getHeight() - height) / 2;
        
        this._iconSprites = [];
        this._btnBounds = [];
        
        this._background = TTSpriteFactory.spriteWithFile("1pxblack.png");
        this._background.setScale(UNISAFE_WIDTH, UNISAFE_HEIGHT + this.bottomOffset * 2);
        this._background.setPosition(0, -this.bottomOffset);
        this._background.setDepth(-10);
        this._background.setAlpha(0.7);
        this._node.addChild(this._background);
        
        var btnStart = new Core.Point(60, 80);
        var btnSpacingX = 100;
        var btnSpacingY = 100;
        for ( var i = 0; i < this.NUM_MENU_ICONS; i++)
        {
        	var icon = TTSpriteFactory.spriteWithFile_withAnchor(this._icons[i], [ 0.5, 0.5 ]);
            var iconSize = icon.AL_getSize();
            this._iconSprites[i] = icon;
            icon.setPosition(btnStart.getX() + (i % 3) * btnSpacingX, btnStart.getY() + (Math.floor(i / 3)) * btnSpacingY);
            this._btnBounds[i] = new Core.Rect(icon.getPosition().getX() - btnSpacingX / 2, icon.getPosition().getY() - btnSpacingY / 2, btnSpacingX, btnSpacingY);
            this._node.addChild(icon);
            
            var lbl = LabelConfigurer.createLabelWithString(this._lbls[i], "silkscreen", FONT14, [ 0.5, 0.5 ], true);
            
            var _scale = lbl.getScale();
            lbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
            
            lbl.setPosition(icon.getPosition().getX(), icon.getPosition().getY() + 46);
            this._node.addChild(lbl);
            
            if (this._lbls[i] == "BITBOOK"  && TTBitBook.badgeCount() > 0)
            {
                var badge = TTSpriteFactory.spriteWithFile("menu_bitbook_badge.png", [ 0.5, 0.5 ]);
                badge.setPosition(iconSize.getWidth() - 30, -iconSize.getHeight() / 2);
                icon.addChild(badge);
                
                var bCount = LabelConfigurer.createLabelWithString(TTBitBook.badgeCount(), "silkscreen", FONT12, [ 0.5, 0.5 ], true);
                
                var _scale = bCount.getScale();
                bCount.setScale(_scale.getX()*FONTSCALE12, _scale.getX()*FONTSCALE12);
                
                bCount.setPosition(0, 0);
                badge.addChild(bCount);
            }
        }
        
        this.setTouchTargetToScreenSize();
    },
    
    destroy : function()
    {
    },
    
    _ccTouchesBegan : function(/*GL2.Touch*/touchEvent)
    {
        al_trace("Menu touched");
        
        var tp = this._node.screenToLocal(touchEvent.getPosition());
        for ( var i = 0; i < this.NUM_MENU_ICONS; i++)
        {
            if (CGRectContainsPoint(this._btnBounds[i], tp))
            {
                al_trace("Button Touched: " + this._lbls[i]);
                this._iconSprites[i].setColor(127 / 255, 127 / 255, 127 / 255);
            }
        }
        
        return true;
    },
    
    _ccTouchesEnded : function(/*GL2.Touch*/touchEvent)
    {
        var tp = this._node.screenToLocal(touchEvent.getPosition());
        for ( var i = 0; i < this.NUM_MENU_ICONS; i++)
        {
            if (CGRectContainsPoint(this._btnBounds[i], tp))
            {
            	this._iconSprites[i].setColor(ccc3(255,255,255));
            	
                if (this._lbls[i] == "BITIZENS")
                {
                    TTScene.runMenuLayer(TTBitizenListLayer.initWithHiringFloor(null));
                    return;
                }
                else if (this._lbls[i] == "SETTINGS")
                {
                    TTScene.runMenuLayer(TTSettingsLayer.init());
                    return;
                }
                else if (this._lbls[i] == "STATS")
                {
                    TTScene.runMenuLayer(TTStatsLayer.init());
                    return;
                }
                else if (this._lbls[i] == "ELEVATORS")
                {
                    if (TTScene._playerData._elevator == NUM_ELEVATORS - 1)
                    {
                        TTDialogQueue.sharedQueue().addDialog(TTDialog.initWithMessage("\n\n\n\nYou tower has the best elevator!", ",continue", null, null, null));
                    }
                    else
                    {
                        TTScene.runMenuLayer(new TTElevatorShopLayer(UNISAFE_WIDTH, UNISAFE_HEIGHT));
                    }
                    return;
                }
                else if (this._lbls[i] == "BANK")
                {
                    if (TTScene.sharedScene().tipNumber() >= 0)
                    {
                        TTDialogQueue.sharedQueue().addDialog(TTDialog.initWithMessage("\n\n\n\nYou must finish the tutorial first!", ",continue", null, null, null));
                        return;
                    }
                    
                    TTScene.runMenuLayer(TTBankLayer.init());
                    return;
                }
                else if (this._lbls[i] == "BITBOOK")
                {
                    TTScene.runMenuLayer(new TTBitBookListLayer(UNISAFE_WIDTH, UNISAFE_HEIGHT));
                    return;
                }
                else if (this._lbls[i] == "GET BUX")
                {
                    /// Check if the tutorial is active.
                    if (TTScene.sharedScene().tipNumber() >= 0)
                    {
                        TTDialogQueue.sharedQueue().addDialog(TTDialog.initWithMessage("\n\n\n\nYou must finish the tutorial first!", ",continue", null, null, null));
                        return;
                    }
                    

                    if (SIMULATOR) // SIMULATOR
                    {
                        // FIXME: debug mode
                        TTScene._playerData.addBux(100);
                        return;
                    }
                    else
                    {
                        TTScene.showProShop();
                    }
                    
                }
                else if (this._lbls[i] == "FRIENDS")
                {
                    if (TTScene.sharedScene().tipNumber() >= 0)
                    {
                        TTDialogQueue.sharedQueue().addDialog(TTDialog.initWithMessage("\n\n\n\nYou must finish the tutorial first!", ",continue", null, null, null));
                        return;
                    }
                    
                    TTScene.sharedScene().runMenuLayer(TTFriendsListLayer.init());
                }
                else if(this._lbls[i] == "ACHIEVEMENTS")
            	{
                	if (TTScene.sharedScene().tipNumber() >= 0)
                    {
                        TTDialogQueue.sharedQueue().addDialog(TTDialog.initWithMessage("\n\n\n\nYou must finish the tutorial first!", ",continue", null, null, null));
                        return;
                    }
                    
                    TTScene.sharedScene().runMenuLayer(TTAchievementsListLayer.init());
            	}
            }
        }
    },
    
    _ccTouchCancelled : function(/*GL2.Touch*/touchEvent)
    {
        for ( var i = 0; i < this.NUM_MENU_ICONS; i++)
        {
            this._iconSprites[i].setColor(1, 1, 1);
        }
    },
    
    _ccTouchesMoved : function(/*GL2.Touch*/touchEvent)
    {
    	var tp = this._node.screenToLocal(touchEvent.getPosition());

    	for ( var i = 0; i < this.NUM_MENU_ICONS; i++)
        {
            if (CGRectContainsPoint(this._btnBounds[i], tp))
            {
                this._iconSprites[i].setColor(127 / 255, 127 / 255, 127 / 255);
            }
            else
        	{
            	this._iconSprites[i].setColor(255 / 255, 255 / 255, 255 / 255);
        	}
        }
    }
    
    
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTCloud'] = function(){var exports = $MODULE_REGISTRY['Code/TTCloud'] || {}; $MODULE_REGISTRY['Code/TTCloud'] = exports; exports.TTCloud = BaseClass.subclass({
    classname: 'TTCloud',
    
    initialize : function()
    {
        this._cloudSprite = TTSpriteFactory.spriteWithFile("cloud.png");
        this._node.addChild(this._cloudSprite);
    },
    
    _draw : function()
    {
        this._node.setPosition(this._node.getPosition().getX() - 0.25, this._node.getPosition().getY());
        
        if (Math.round(this._node.getPosition().getX()) < 0 - (this._cloudSprite.AL_getSize().getWidth() + 30))
        {
            this._node.setPosition(UNISAFE_WIDTH, this._node.getPosition().getY());
        }
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTNote'] = function(){var exports = $MODULE_REGISTRY['Code/TTNote'] || {}; $MODULE_REGISTRY['Code/TTNote'] = exports; exports.TTNote = GL2.Node.subclass({
    classname : "TTNote",
    
    initialize : function(type, ndata)
    {
        this._noteType = type;
        this._data = ndata;
        
        var icon = null;
        switch (this._noteType)
        {
            case NOTE_TYPE_MAIL:
                icon = TTSpriteFactory.spriteWithFile("note_mail.png", [0,1]);
                break;
            case NOTE_TYPE_EXCLAIM:
                icon = TTSpriteFactory.spriteWithFile("note_exclaim.png", [0,1]);
                break;
            case NOTE_TYPE_COINS:
                icon = TTSpriteFactory.spriteWithFile("note_coin.png", [0,1]);
                break;
            case NOTE_TYPE_RIDER:
                icon = TTSpriteFactory.spriteWithFile("note_ride.png", [0,1]);
                break;
            case NOTE_TYPE_STOCK:
                icon = TTSpriteFactory.spriteWithFile("note_stock.png", [0,1]);
                break;
            case NOTE_TYPE_VIP:
                icon = TTSpriteFactory.spriteWithFile("note_vip.png", [0,1]);
                break;
            case NOTE_TYPE_FIND:
                icon = TTSpriteFactory.spriteWithFile("note_find.png", [0,1]);
                break;
            default:
                break;
        }
        
        if (icon)
        {
            //icon.setAnchor(ccp(0, 0));
            this.addChild(icon);
        }
    },
    
    $initWithType: function(type, ndata)
    {
        return new this(type, ndata);
    },
    
    destroy : function()
    {
        this._data = null;
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTBitBook'] = function(){var exports = $MODULE_REGISTRY['Code/TTBitBook'] || {}; $MODULE_REGISTRY['Code/TTBitBook'] = exports; var NUM_BITBOOK_ENTRIES = 25;

exports.TTBitBook = Core.Class.subclass({
    classname : 'TTBitBook',
    
    $entries : function()
    {
        var currentDefaults = NSUserDefaults.standardUserDefaults();
        var dataRepresentingSavedArray = currentDefaults.objectForKey("bitBookEntries");
        if (dataRepresentingSavedArray)
        {
            var oldSavedArray = JSON.parse(dataRepresentingSavedArray);
            if (oldSavedArray != null)
            {
                return oldSavedArray;
            }
        }
        
        return [];
    },
    
    $resetEntries : function()
    {
        NSUserDefaults.standardUserDefaults().setObject("[]", "bitBookEntries");
    },
    
    $addNewEntry : function(entry, seed)
    {
        if (TTScene.sharedScene()._playerData._readOnly)
        {
            return;
        }
        
        var oldArray = TTBitBook.entries();
        var oldMutArray = [].concat(oldArray);
        
        // new entry
        var newEntryStr = "" + seed + "|" + entry + "|" + Core.Time.getRealTime() / 1000;
        if (oldMutArray.length > NUM_BITBOOK_ENTRIES)
        {
            oldMutArray.splice(0, 1);
        }
        
        oldMutArray.push(newEntryStr);
        var serializedArray = JSON.stringify(oldMutArray);
        NSUserDefaults.standardUserDefaults().setObject(serializedArray, "bitBookEntries");
        al_trace(serializedArray);        
        TTBitBook.setBadgeCount(TTBitBook.badgeCount() + 1);
    },
    
    $entryFormatForEvent : function(eventType)
    {
        if (!this._formats)
        {
            this._formats = DataPreloader._bb_events;
        }
                
        if (this._formats)
        {                        
            // grab array for this event type            
            var array = this._formats[eventType];            
            if (array && array.length > 0)
            {
                // return a random item
                srandom(Core.Time.getRealTime() / 1000);
                return (array[std_rand() % array.length]);
            }
        }
        
        return null;
    },
    
    $setBadgeCount : function(count)
    {
        NSUserDefaults.standardUserDefaults().setObject(count, "bitBookBadge");
    },
    
    $badgeCount : function()
    {
        return NSUserDefaults.standardUserDefaults().integerForKey("bitBookBadge");
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTFinder'] = function(){var exports = $MODULE_REGISTRY['Code/TTFinder'] || {}; $MODULE_REGISTRY['Code/TTFinder'] = exports; exports.TTFinder = Core.Class.subclass({
    classname: 'TTFinder',
    
    $randFinderFormat : function()
    {
        if (!this._formats)
        {
            this._formats = DataPreloader._finder;
        }
        
        if (this._formats)
        {
            // grab array for this event type
            var array = this._formats["finder"];
            if (array && array.length > 0)
            {
                // return a random item
                return (array[std_random() % array.length]);

            }
        }
        
        return null;
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTStatsLayer'] = function(){var exports = $MODULE_REGISTRY['Code/TTStatsLayer'] || {}; $MODULE_REGISTRY['Code/TTStatsLayer'] = exports; exports.TTStatsLayer = BaseClass.subclass({
    classname : "TTStatsLayer",
    initialize : function(width, height)
    {
    	//Bottom offset
    	this.bottomOffset = (this.__size.getHeight() - height) / 2;
    	
        this.__cpmValue = null;

        this._shade = ALLayerColor.layerWithColor(ccc3(0, 0, 0), (128 + 64) / 255, UNISAFE_WIDTH, UNISAFE_HEIGHT + this.bottomOffset*2);
        this._shade.setPosition(UNISAFE_WIDTH/2,UNISAFE_HEIGHT/2);
        this._node.addChild(this._shade);
        //this._shade.setScale([ 2, 2 ]);
        
        var demandLabel = LabelConfigurer.createLabelWithString("BUSINESS DEMAND", "silkscreen", FONT14, [ 0.5, 0 ], true);

		var _scale = demandLabel.getScale();
        demandLabel.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        demandLabel.setPosition(UNISAFE_WIDTH / 2, UNISAFE_HEIGHT - 430);
        this._node.addChild(demandLabel);
        
        var cpmLabel = LabelConfigurer.createLabelWithString("SALES PER MIN", "silkscreen", FONT14, [ 0.5, 0 ], true);

		var _scale = cpmLabel.getScale();
        cpmLabel.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        cpmLabel.setPosition(UNISAFE_WIDTH / 2, UNISAFE_HEIGHT - 290);
        this._node.addChild(cpmLabel);
        
        al_trace("" + TTScene.sharedScene()._towerLayer.coinsPerMinute())
        this._cpmValue = LabelConfigurer.createLabelWithString(sprintf("%.1f", TTScene.sharedScene()._towerLayer.coinsPerMinute()), "silkscreen", FONT18, [ 0.5, 0 ], true);
        this._cpmValue.setPosition(UNISAFE_WIDTH / 2, UNISAFE_HEIGHT - 260);

		var _scale = this._cpmValue.getScale();
        this._cpmValue.setScale(_scale.getX()*0.6, _scale.getX()*0.6);
        
        this._node.addChild(this._cpmValue);
        
        var distLabel = LabelConfigurer.createLabelWithString("FLOOR DISTRIBUTION", "silkscreen", FONT14, [ 0.5, 0 ], true);
        distLabel.setPosition(UNISAFE_WIDTH / 2, UNISAFE_HEIGHT - 220);

		var _scale = distLabel.getScale();
        distLabel.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        this._node.addChild(distLabel);
        
        for ( var i = 0; i < NUM_BUS_TYPES + 1; i++)
        {
            var color3 = TTScene.floorTypeColor(i);
            if (i < NUM_BUS_TYPES)
            {
                var bar = ALLayerColor.layerWithColor(color3, 1, 32, Math.ceil(64 * TTScene.sharedScene()._towerLayer.busTypePopularities()[i]), [0.5,1]);
                bar.setPosition(54 + 60 * i -16, UNISAFE_HEIGHT - 340 + 16);
                this._node.addChild(bar);
                var abbr = "";
                switch (i)
                {
                    case FLOOR_TYPE_FOOD:
                        abbr = "FOOD";
                        break;
                    case FLOOR_TYPE_SERVICE:
                        abbr = "SERV.";
                        break;
                    case FLOOR_TYPE_ENTERTAINMENT:
                        abbr = "REC.";
                        break;
                    case FLOOR_TYPE_RETAIL:
                        abbr = "RET.";
                        break;
                    case FLOOR_TYPE_CREATIVE:
                        abbr = "CREA.";
                        break;
                    default:
                        break;
                }
                
                var busLabel = LabelConfigurer.createLabelWithString(abbr, "silkscreen", FONT14, [ 0.5, 0 ], true);

				var _scale = busLabel.getScale();
		        busLabel.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);

                busLabel.setColor(color3);
				busLabel.setPosition(bar.getPosition().getX(),bar.getPosition().getY());

                this._node.addChild(busLabel);
            }
            var countLabel = LabelConfigurer.createLabelWithString(TTScene.floorTypeString(i), "silkscreen", FONT14, [ 0.5, 0.5 ], true);


			var _scale = countLabel.getScale();
	        countLabel.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);

            countLabel.setColor(color3);
            countLabel.setPosition(126, (distLabel.getPosition().getY() + 30 + 20 * i));
            this._node.addChild(countLabel);
            
            var numLabel = LabelConfigurer.createLabelWithString(TTScene.sharedScene()._towerLayer.busTypeCounts()[i], "silkscreen", FONT14, [ 0.5, 0.5 ], true);

			var _scale = numLabel.getScale();
	        numLabel.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);

            numLabel.setColor(color3);
            numLabel.setPosition(countLabel.getPosition().getX()+120,countLabel.getPosition().getY());
            this._node.addChild(numLabel);
        }
        
        // TITLE BAR
        var titleBg = TTSpriteFactory.spriteWithFile_withAnchor("topslice.png", [0, 0]);
        titleBg.setPosition(0, 0 - this.bottomOffset );
        titleBg.setScale(UNISAFE_WIDTH / (titleBg.AL_getSize().getWidth()), 1);
        this._node.addChild(titleBg);
        
        var title = LabelConfigurer.createLabelWithString("STATS", "silkscreen", FONT14, [0.5, 1], true);
        
		var _scale = title.getScale();
        title.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        title.setPosition(UNISAFE_WIDTH / 2, titleBg.getPosition().getY() + 25);
        this._node.addChild(title);
    },
    
    $init : function()
    {
        return new this(UNISAFE_WIDTH, UNISAFE_HEIGHT);
    },
    
    destroy : function()
    {
        if (TTScene.sharedScene()._menuLayer.getChildren().length == 0)
        {
            TTScene.sharedScene().runMenuLayer(new TTMenu(UNISAFE_WIDTH, UNISAFE_HEIGHT));
        }
    },
    
    _ccTouchesBegan : function(touchEvent)
    {
        /*
        var tp = this._node.screenToLocal(touchEvent.getPosition());*/
        return true;
    },
    
    _ccTouchesEnded : function(touchEvent)
    {
        /*var tp = this._node.screenToLocal(touchEvent.getPosition());*/
    },
    
    _draw : function()
    {
        this._cpmValue.setText(sprintf("%.1f", TTScene.sharedScene()._towerLayer.coinsPerMinute()));
    }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTBankLayer'] = function(){var exports = $MODULE_REGISTRY['Code/TTBankLayer'] || {}; $MODULE_REGISTRY['Code/TTBankLayer'] = exports; var buxAmts = [ 1, 5, 20, 50 ];
var coinAmts = [ 250, 1500, 20000, 100000 ];
var NUM_BANK_BUTTONS = 4;

exports.TTBankLayer = BaseClass.subclass({
    classname : "TTBankLayer",
    
    initialize : function(width, height)
    {
    	//Bottom offset
    	this.bottomOffset = (this.__size.getHeight() - height) / 2;
    	
        this._btnBounds = [];
        this._iconSprites = [];
        this._numFormat = null;
        

        this._shade = ALLayerColor.layerWithColor(ccc3(0, 0, 0), (128 + 64) / 255,UNISAFE_WIDTH,UNISAFE_HEIGHT + this.bottomOffset*2);
        //this._shade.setScale(2,2);
        this._shade.setPosition(UNISAFE_WIDTH/2,UNISAFE_HEIGHT/2);
        this._node.addChild(this._shade);
        
        var btnStart = new Core.Point(UNISAFE_WIDTH / 2, 110);
        var btnSpacingY = 86;
                
        for ( var i = 0; i < NUM_BANK_BUTTONS; i++)
        {
            var icon = TTSpriteFactory.spriteWithFile("bank_button.png", [0.5,0.5]);
            this._iconSprites[i] = icon;
            
            icon.setPosition(btnStart.getX(), btnStart.getY() + (i) * btnSpacingY);
            this._btnBounds[i] = createBB(icon);
            this._node.addChild(icon);
            
            var buxLbl = LabelConfigurer.createLabelWithString(sprintf("%d", buxAmts[i]), "silkscreen", FONT14, [ 0.5, 0.5 ], true);
            buxLbl.setPosition((-42)*2, 2);
            
            var _scale = buxLbl.getScale();
            buxLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
            
            icon.addChild(buxLbl);
            
            // FIXME : Should use NSNumberFormatter for the "perMill" symbol
            var coinLbl = LabelConfigurer.createLabelWithString(numberAddCommas(sprintf("%d", coinAmts[i])), "silkscreen", FONT14, [ 0.5, 0.5 ], true);
            coinLbl.setPosition(29*2 , 0);
            
            var _scale = coinLbl.getScale();
            coinLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
            
            icon.addChild(coinLbl);
        }
        
        // TITLE BAR
        var titleBg = TTSpriteFactory.spriteWithFile_withAnchor("topslice.png", [0, 0]);
        titleBg.setPosition(0, -this.bottomOffset);
        titleBg.setScale(UNISAFE_WIDTH / (titleBg.AL_getSize().getWidth()), 1);
        this._node.addChild(titleBg);
        
        var title = LabelConfigurer.createLabelWithString("BANK", "silkscreen", FONT14, [0.5, 1], true);
        title.setPosition(UNISAFE_WIDTH / 2, titleBg.getPosition().getY() + 25);
        
        var _scale = title.getScale();
        title.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        this._node.addChild(title);
    },
    
    $init : function()
    {
        return new this(UNISAFE_WIDTH, UNISAFE_HEIGHT);
    },
    
    destroy : function()
    {
        if (TTScene.sharedScene()._menuLayer._children.length == 0)
        {
            TTScene.sharedScene().runMenuLayer(new TTMenu(UNISAFE_WIDTH, UNISAFE_HEIGHT));
        }
        
        this._numFormat = null;
    },
    
    _ccTouchesBegan : function(touchEvent)
    {
        //UITouch *touch = [touches anyObject();
        al_trace("TTBankLayer._ccTouchBegan : AH! you touched me!");
        var tp = this._node.screenToLocal(touchEvent.getPosition());
        for ( var i = 0; i < NUM_BANK_BUTTONS; i++)
        {
            if (CGRectContainsPoint(this._btnBounds[i], tp))
            {
                al_trace("you **** touched me, num " + i);
                this._iconSprites[i].setColor(ccc3(127, 127, 127));
            }
        }
        
        return true;
    },
    
    _ccTouchesEnded : function(touchEvent)
    {
        //UITouch *touch = [touches anyObject();
        var tp = this._node.screenToLocal(touchEvent.getPosition());
        for ( var i = 0; i < NUM_BANK_BUTTONS; i++)
        {
            this._iconSprites[i].setColor(ccc3(255, 255, 255));
            if (CGRectContainsPoint(this._btnBounds[i], tp))
            {
                // check if they can afford it
                if (TTScene.sharedScene()._playerData._bux < buxAmts[i])
                {
                    dlg = TTDialog.initWithMessage("\n\n\n\nYou do not have enough bux for that.", ",continue", null, null, null);
                    TTDialogQueue.sharedQueue().addDialog(dlg);
                    dlg = null;
                }
                else
                {
                    // FIXME : uses NSNumFormat, commented before
                    dlg = TTDialog.initWithMessage(sprintf("\n\n\nConvert\n%d bux\ninto\n%s coins?", buxAmts[i], numberAddCommas(coinAmts[i])), "no,yes", this.buyConfirmation, this, i);
                    TTDialogQueue.sharedQueue().addDialog(dlg);
                    dlg = null;
                }
            }
        }
    },
    
    _ccTouchesCancelled : function(touchEvent)
    {
        for ( var i = 0; i < NUM_BANK_BUTTONS; i++)
        {
            this._iconSprites[i].setColor(ccc3(255, 255, 255));
        }
    },
    
    _ccTouchesMoved : function(/*GL2.Touch*/touchEvent)
    {
    	var tp = this._node.screenToLocal(touchEvent.getPosition());
    	for ( var i = 0; i < NUM_BANK_BUTTONS; i++)
        {
            if (CGRectContainsPoint(this._btnBounds[i], tp))
            {
                this._iconSprites[i].setColor(ccc3(127, 127, 127));
            }
            else
        	{
            	this._iconSprites[i].setColor(ccc3(255, 255, 255));
        	}
        }

    },
    
    buyConfirmation : function(dialog)
    {
        if (dialog._buttonIndex == 1)
        {
            var buttonId = dialog._data;
            // take bux
            TTScene.sharedScene()._playerData.addBux(-buxAmts[buttonId]);
            // giev coins
            TTScene.sharedScene()._playerData.addCoins(coinAmts[buttonId]);
            TTHud.sharedHud().animateCoinAmt(coinAmts[buttonId]);
        }
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTBitFocusLayer'] = function(){var exports = $MODULE_REGISTRY['Code/TTBitFocusLayer'] || {}; $MODULE_REGISTRY['Code/TTBitFocusLayer'] = exports; exports.TTBitFocusLayer = BaseClass.subclass({
    classname: 'TTBitFocusLayer',
    
    $initWithBitizen : function(bit, floor)
    {
        return new this(UNISAFE_WIDTH, UNISAFE_HEIGHT, bit, floor);
    },
    
    initialize : function(width, height, bit, floor)
    {
    	//Bottom offset
        this.bottomOffset = (this.__size.getHeight() - height) / 2;
    	
        this._focusBitInfo = TTScene.sharedScene()._playerData.getBitizenInfo(bit._seed);
        this._origFloor = floor;
        
        if (!this._focusBitInfo)
        {
            // BAIL
            TTScene.sharedScene().runMenuLayer(null);
            return;
        }
                
        this._shade = ALLayerColor.layerWithColor(ccc3(0, 0, 0), 128/255, UNISAFE_WIDTH, UNISAFE_HEIGHT + this.bottomOffset*2);
        this._shade.setPosition(UNISAFE_WIDTH/2,UNISAFE_HEIGHT/2);
        this._node.addChild(this._shade);
        
        var bg = TTSpriteFactory.spriteWithFile_withAnchor("focus_bg.png", [0.5, 0]);
        bg.setPosition(UNISAFE_WIDTH / 2, HUD_BAR_HEIGHT / 2);
        this._node.addChild(bg);
        
        this._focusBit = TTBitizen.initWithSeed(bit._seed);
        
        this._titleLbl = LabelConfigurer.createLabelWithString(this._focusBit._name, "silkscreen", FONT14, [0.5, 0.5], true);
        
        var _scale = this._titleLbl.getScale();
        this._titleLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        this._titleLbl.setPosition(UNISAFE_WIDTH / 2, 40);
        this._node.addChild(this._titleLbl);
        
        var popLbl = LabelConfigurer.createLabelWithString("DREAM JOB:", "silkscreen", FONT14, [0.5, 0.5], true);
        
        var _scale = popLbl.getScale();
        popLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        popLbl.setPosition(UNISAFE_WIDTH / 2, this._titleLbl.getPosition().getY() + 16);
        this._node.addChild(popLbl);
        
        var dreamInfo = TTFloorTable.floorWithId(this._focusBitInfo._dreamFloor);
        var typeLbl = LabelConfigurer.createLabelWithString(dreamInfo._name, "silkscreen", FONT14, [0.5, 0.5], true);
        
        var _scale = typeLbl.getScale();
        typeLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        typeLbl.setColor(TTScene.floorTypeColor(dreamInfo._type));
        typeLbl.setPosition(UNISAFE_WIDTH / 2, popLbl.getPosition().getY() + 16);
        this._node.addChild(typeLbl);
        
        var bitWindow = TTSpriteFactory.spriteWithFile_withAnchor("bit_window.png", [0.5, 0.5]);
        bitWindow.setPosition(90, 120);
        this._node.addChild(bitWindow);
        
        this._node.addChild(this._focusBit._node);
        this._focusBit._node.setPosition(90, 130);
        
        var homeLbl = LabelConfigurer.createLabelWithString("HOME:", "silkscreen", FONT14, ccp(1, 0), true);
        
        var _scale = homeLbl.getScale();
        homeLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        homeLbl.setColor(ccc3(145, 135, 186));
        homeLbl.setPosition(bitWindow.getPosition().getX() + 90, bitWindow.getPosition().getY() - 20);
        this._node.addChild(homeLbl);
        
        var home2Lbl = LabelConfigurer.createLabelWithString(sprintf("FLOOR %d", this._focusBitInfo._homeFloor), "silkscreen", FONT14, ccp(0, 0), true);
        home2Lbl.setPosition(homeLbl.getPosition().getX() + 5, homeLbl.getPosition().getY());
        
        var _scale = home2Lbl.getScale();
        home2Lbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        this._node.addChild(home2Lbl);
        
        var ageLbl = LabelConfigurer.createLabelWithString("B-DAY:", "silkscreen", FONT14, ccp(1, 0), true);
        
        var _scale = ageLbl.getScale();
        ageLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        ageLbl.setColor(ccc3(145, 135, 186));
        ageLbl.setPosition(homeLbl.getPosition().getX(), homeLbl.getPosition().getY() + 20);
        this._node.addChild(ageLbl);
        
        var months = [ "JAN", "FEB", "MAR", "APR", "MAY", "JUN", "JUL", "AUG", "SEP", "OCT", "NOV", "DEC" ];
        var age2Lbl = LabelConfigurer.createLabelWithString(sprintf("%s %d", months[this._focusBit._bmonth - 1], this._focusBit._bday), "silkscreen", FONT14, ccp(0, 0), true);
        
        var _scale = age2Lbl.getScale();
        age2Lbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        age2Lbl.setPosition(ageLbl.getPosition().getX() + 5, ageLbl.getPosition().getY());
        this._node.addChild(age2Lbl);
        
        var skills = TTSpriteFactory.spriteWithFile("bit_focus_skills.png");
        skills.setPosition(78, 160);
        this._node.addChild(skills);
        
        for ( var s = 0; s < 5; s++)
        {
            var sk = TTBitizen.skillIn(s, this._focusBit._seed);
            var skillLbl = LabelConfigurer.createLabelWithString(sprintf("%d", sk), "silkscreen", FONT14, [0.5, 1], true);
            
            var _scale = skillLbl.getScale();
            skillLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
            
            skillLbl.setColor(TTScene.floorTypeColor(s));
            skillLbl.setPosition(139, 92 - (4 - s) * 9*2);
            skills.addChild(skillLbl);
        }
        
        // Employed at
        var employLbl = LabelConfigurer.createLabelWithString("EMPLOYED AT:", "silkscreen", FONT14, [0, 0], true);
        
        var _scale = employLbl.getScale();
        employLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        employLbl.setColor(ccc3(145, 135, 186));
        employLbl.setPosition(100, 275);
        this._node.addChild(employLbl);
        
        // mood
        var mood = TTSpriteFactory.spriteWithFile(sprintf("mood_%s.png", this._focusBit.happiness()));
        mood.setPosition(employLbl.getPosition().getX() - 30, employLbl.getPosition().getY() + 5);  
        this._node.addChild(mood);
        
        var workName = "UNEMPLOYED";
        var workColor = ccc3(255, 255, 255);
        if (this._focusBitInfo._workFloor > 0)
        {
            var sInfo = TTScene.sharedScene()._playerData.getStoryInfo(this._focusBitInfo._workFloor);
            var fInfo = TTFloorTable.floorWithId(sInfo._floorId);
            workName = fInfo._name.toUpperCase(); // FIXME
            workColor = TTScene.floorTypeColor(fInfo._type);
        }
        
        var employ2Lbl = LabelConfigurer.createLabelWithString(workName, "silkscreen", FONT14, [0, 0], true);
        
        var _scale = employ2Lbl.getScale();
        employ2Lbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        employ2Lbl.setColor(workColor);
        employ2Lbl.setPosition(employLbl.getPosition().getX(), employLbl.getPosition().getY() + 14);
        this._node.addChild(employ2Lbl);
        
        var button_bg = TTSpriteFactory.spriteWithFile_withAnchor("bit_focus_button_bg.png", [0.5, 1]);
        button_bg.setPosition(UNISAFE_WIDTH/2, UNISAFE_HEIGHT - 65);
        this._node.addChild(button_bg);
        
        this._activityButton = TTSpriteFactory.spriteWithFile_withAnchor("bit_focus_activity_button.png", [0.5, 0.5]);
        this._activityButton.setPosition(86, button_bg.getPosition().getY() - 50);
        this._node.addChild(this._activityButton);
        
        this._jobButton = TTSpriteFactory.spriteWithFile_withAnchor("bit_focus_job_button.png", [0.5, 0.5]);
        this._jobButton.setPosition(this._activityButton.getPosition().getX() + 76, this._activityButton.getPosition().getY());
        this._node.addChild(this._jobButton);
        
        this._evictButton = TTSpriteFactory.spriteWithFile_withAnchor("bit_focus_evict_button.png", [0.5, 0.5]);
        this._evictButton.setPosition(this._jobButton.getPosition().getX() + 76, this._jobButton.getPosition().getY());
        this._node.addChild(this._evictButton);
        
        this.setTouchTargetToScreenSize();
    },
    
    destroy : function()
    {
        al_trace("BitizenFocus DEALLOC!");
        if (TTScene.sharedScene()._menuLayer._children.length == 0)
        {
            if (this._origFloor)
            {
                var ffl = TTFloorFocusLayer.initWithFloor(this._origFloor);
                TTScene.sharedScene().runMenuLayer(ffl);
            }
            else
            {
                var bll = TTBitizenListLayer.initWithHiringFloor(null);
                TTScene.sharedScene().runMenuLayer(bll);
            }
        }
        
        if(this._tfield)
    	{
        	this._tfield.getParent().removeChild(this._tfield);
    	}
        
        if (this._origStr)
        {
            this._origStr = null;
        }
    },
    
    evictDialog : function(dlg)
    {
        if (dlg._buttonIndex > 0)
        {
            //EVICT
            TTScene.sharedScene().removeBitizenFromFloors(this._focusBit._seed);
            TTScene.sharedScene()._playerData.removeBitizenInfo(this._focusBit._seed);
            TTScene.sharedScene().runMenuLayer(null);
            SoundBoard.playSfx(SFX_EVICTED);
        }
    },
    
    jobDialog : function(dlg)
    {
        if (dlg._buttonIndex > 0)
        {
            //NEW JOB
            if (TTScene.sharedScene().tipNumber() == 16)
            {
                // TIP 17
                var ttl = TTutorialLayer.initWithStep(17, "TAP FOOD JOB");
                TTScene.sharedScene().runTipLayer(ttl);
            }
            
            var njl = TTNewJobLayer.initWithBitizen(this._focusBit, this._origFloor);
            TTScene.sharedScene().runMenuLayer(njl);
        }
    },
    
    activityDialog : function(dlg)
    {
        if (dlg._buttonIndex > 0)
        {
        }
    },
    
    _ccTouchesBegan : function(touch)
    {
        var tp = this._node.screenToLocal(touch.getPosition());
        if (this._activityButton.AL_getOpacity() > 64 && CGRectContainsPoint(createBB(this._activityButton), tp))
        {
            this._activityButton.AL_setOpacity(128);
        }
        else if (this._jobButton.AL_getOpacity() > 64 && CGRectContainsPoint(createBB(this._jobButton), tp))
        {
            this._jobButton.AL_setOpacity(128);
        }
        else if (this._evictButton.AL_getOpacity() > 64 && CGRectContainsPoint(createBB(this._evictButton), tp))
        {
            this._evictButton.AL_setOpacity(128);
        }
        
        return true;
    },
    
    _ccTouchesMoved : function(touchEvent)
    {
    	var tp = this._node.screenToLocal(touchEvent.getPosition());
        if (this._activityButton.AL_getOpacity() > 64 && CGRectContainsPoint(createBB(this._activityButton), tp))
        {
            this._activityButton.AL_setOpacity(128);
            this._evictButton.AL_setOpacity(255);
        	this._jobButton.AL_setOpacity(255);
        }
        else if (this._jobButton.AL_getOpacity() > 64 && CGRectContainsPoint(createBB(this._jobButton), tp))
        {
            this._jobButton.AL_setOpacity(128);
            this._evictButton.AL_setOpacity(255);
        	this._activityButton.AL_setOpacity(255);
        }
        else if (this._evictButton.AL_getOpacity() > 64 && CGRectContainsPoint(createBB(this._evictButton), tp))
        {
            this._evictButton.AL_setOpacity(128);
        	this._jobButton.AL_setOpacity(255);
        	this._activityButton.AL_setOpacity(255);
        }
        else
    	{
        	this._evictButton.AL_setOpacity(255);
        	this._jobButton.AL_setOpacity(255);
        	this._activityButton.AL_setOpacity(255);
    	}
    },
    
    _ccTouchesCancelled : function(touch, event)
    {
        
        if (this._activityButton.AL_getOpacity() > 64)
        {
            this._activityButton.AL_setOpacity(255);
        }
        
        if (this._jobButton.AL_getOpacity() > 64)
        {
            this._jobButton.AL_setOpacity(255);
        }
        
        if (this._evictButton.AL_getOpacity() > 64)
        {
            this._evictButton.AL_setOpacity(255);
        }
    },
    
    _ccTouchesEnded : function(touch)
    {
        var tp = this._node.screenToLocal(touch.getPosition());
        if (this._activityButton.AL_getOpacity() > 64)
        {
            this._activityButton.AL_setOpacity(255);
        }
        
        if (this._jobButton.AL_getOpacity() > 64)
        {
            this._jobButton.AL_setOpacity(255);
        }
        
        if (this._evictButton.AL_getOpacity() > 64)
        {
            this._evictButton.AL_setOpacity(255);
        }
        
        if (this._activityButton.AL_getOpacity() > 64 && CGRectContainsPoint(createBB(this._activityButton), tp))
        {
            //DRESS UP
            if (TTScene.sharedScene()._playerData._coins > 0)
            {
                this._focusBitInfo._vseed = std_rand();
                SoundBoard.playSfx(SFX_DRESSUP);
                
                TTScene.sharedScene()._playerData.addCoins(-1);
                TTHud.sharedHud().animateCoinAmt(-1);
            }
        }
        else if (this._jobButton.AL_getOpacity() > 64 && CGRectContainsPoint(createBB(this._jobButton), tp))
        {
            // CHECK IF WORK HAS ACTIVE JOB
            var workStory = TTScene.sharedScene()._playerData.getStoryInfo(this._focusBitInfo._workFloor);
            if (this._focusBitInfo._workFloor > 0 && workStory && workStory._activeProduct > -1)
            {
                var wFloorInfo = TTFloorTable.floorWithId(workStory._floorId);
                var dlg = TTDialog.initWithMessage(sprintf("\n\n\n%s\ncannot be reassigned while restocking the\n%s.", this._focusBit._name, wFloorInfo._name), ",continue", null, null, null);
                TTDialogQueue.sharedQueue().addDialog(dlg);
            }
            else
            {
                var dlg = TTDialog.initWithMessage(sprintf("\n\n\nAssign\n%s\na new job?", this._focusBit._name), "NO,YES", this.jobDialog.bind(this), this, null);
                TTDialogQueue.sharedQueue().addDialog(dlg);
            }
        }
        else if (this._evictButton.AL_getOpacity() > 64 && CGRectContainsPoint(createBB(this._evictButton), tp))
        {
            // CHECK IF WORK HAS ACTIVE JOB
            var workStory = TTScene.sharedScene()._playerData.getStoryInfo(this._focusBitInfo._workFloor);
            if (this._focusBitInfo._workFloor > 0 && workStory && workStory._activeProduct > -1)
            {
                var wFloorInfo = TTFloorTable.floorWithId(workStory._floorId);
                var dlg = TTDialog.initWithMessage(sprintf("\n\n\n%s\ncannot be evicted while restocking the\n%s.", this._focusBit._name, wFloorInfo._name), ",continue", null, null, null);
                TTDialogQueue.sharedQueue().addDialog(dlg);
            }
            else
            {
                var dlg = TTDialog.initWithMessage(sprintf("\n\n\nAre you sure you want to evict\n%s\nfrom your tower?", this._focusBit._name), "NO,YES", this.evictDialog, this, null);
                TTDialogQueue.sharedQueue().addDialog(dlg);
            }
        }
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTBitBookListLayer'] = function(){var exports = $MODULE_REGISTRY['Code/TTBitBookListLayer'] || {}; $MODULE_REGISTRY['Code/TTBitBookListLayer'] = exports; var BIT_ITEM_WIDTH = UNISAFE_WIDTH;
var BIT_ITEM_HEIGHT = 150;

exports.TTBitBookListLayer = BaseClass.subclass({
    classname : 'TTBitBookListLayer',
    
    initialize : function(width, height)
    {
    	//Bottom offset
    	this.bottomOffset = (this.__size.getHeight() - height) / 2;
    	
        this._fcount = 0;
        
        var _shade = ALLayerColor.layerWithColor(ccc3(255, 255, 255), 1,UNISAFE_WIDTH,UNISAFE_HEIGHT + this.bottomOffset*2);
        _shade.setPosition(UNISAFE_WIDTH/2,UNISAFE_HEIGHT/2); 
        this._node.addChild(_shade);
        
        this._list = TTList.initWithTarget(this.listClicked.bind(this));
        this._list.setItemSize(new Core.Size(BIT_ITEM_WIDTH, BIT_ITEM_HEIGHT));
        this._list._node.setPosition(0, 40 - this.bottomOffset);
        this._node.addChild(this._list._node);
        
        var entries = TTBitBook.entries();
        this._itemsLoaded = 0;
        this._itemsToLoad = [];
        
        for ( var i = 0; i < entries.length; i++)
        {
            this._list.addItem(new GL2.Node());
            this._itemsToLoad.push(entries[i]);
        }
        
        // TITLE BAR
        var titleBg = TTSpriteFactory.spriteWithFile_withAnchor("topslice.png", [0, 0]);
        titleBg.setPosition(0, -this.bottomOffset);
        titleBg.setScale(UNISAFE_WIDTH / (titleBg.AL_getSize().getWidth()), 1);
        this._node.addChild(titleBg);
        
        var title = LabelConfigurer.createLabelWithString("BITBOOK", "silkscreen", FONT14, [0.5, 1], true);
        title.setPosition(UNISAFE_WIDTH / 2, titleBg.getPosition().getY() + 25);
        
        var _scale = title.getScale();
        title.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        this._node.addChild(title);
        
        // Clear badge count
        TTBitBook.setBadgeCount(0);
        
        this.setTouchTargetToScreenSize();
    },
    
    destroy : function()
    {
        //[this._itemsToLoad release];
        if (TTScene.sharedScene()._menuLayer._children.length == 0)
        {
            TTScene.sharedScene().runMenuLayer(new TTMenuLayer(UNISAFE_WIDTH, UNISAFE_HEIGHT));
        }
    },
    
    listClicked : function(index)
    {
    },
    
    _ccTouchesBegan : function(touch, event)
    {
        return true;
    },
    
    _draw : function()
    {
        // check if there are tanks to load
        // load 3 at a time
        for ( var i = 0; i < 3; i++)
        {
            if (this._fcount > 0 && !this._list.isDragging() && this._itemsToLoad.length > 0)
            {                
                // load an item
                var li = this._list.itemAtIndex(this._itemsLoaded);
                var bg = ALLayerColor.layerWithColor(ccc3(255, 255, 255), 1, BIT_ITEM_WIDTH, BIT_ITEM_HEIGHT - 20, [0, 0]);
                li.addChild(bg);
                
                var entryStr = this._itemsToLoad[this._itemsToLoad.length - 1];
                var pieces = entryStr.split("|");
                var bseed = Number(pieces[0]);
                var message = pieces[1];
                
                var secsElapsed = 0;
                if (pieces.length > 2)
                {
                    secsElapsed = Core.Time.getRealTime() / 1000 - Number(pieces[2]);
                }
                
                this._itemsToLoad.splice(this._itemsToLoad.length - 1, 1);
                this._itemsLoaded++;
                
                srandom(bseed);
                var bitSquare = ALLayerColor.layerWithColor(rand_color(), 80 / 255, 50, 45, [0, 0]);
                bitSquare.setPosition(5, 5);
                bg.addChild(bitSquare);
                
                var bit = TTBitizen.initWithSeed(bseed);
                bit._node.setPosition(25, 30);
                bitSquare.addChild(bit._node);
                
                var name = LabelConfigurer.createLabelWithString(bit._name, "silkscreen", FONT14, [0, 0], true);
                
                
                var _scale = name.getScale();
                name.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
                
                name.setPosition(60, 5);
                name.setColor(ccc3(89, 81, 140));
                name.setAlpha(100 / 255);
                bg.addChild(name);
                
                // WORD WRAPPED MESSAGE
                var curLbl = LabelConfigurer.createLabelWithString(message, "silkscreen", FONT14, [0, 0], true);
                
                var _scale = curLbl.getScale();
                curLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
                
                curLbl.setPosition(name.getPosition().getX(), name.getPosition().getY() + 20);
                curLbl.setSize((BIT_ITEM_WIDTH - 100)/FONTSCALE14, (BIT_ITEM_HEIGHT - 50)/FONTSCALE14);
                curLbl.setColor(ccc3(0, 0, 0));
                bg.addChild(curLbl);
                
                var time = LabelConfigurer.createLabelWithString(sprintf("%s ago", TTScene.timeString(secsElapsed)), "silkscreen", FONT14, [0, 0], true);
                
                var _scale = time.getScale();
                time.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
                
                time.setPosition(name.getPosition().getX(), BIT_ITEM_HEIGHT - 60);
                time.setColor(ccc3(133, 133, 133));
                bg.addChild(time);
                
                var likeBar = TTSpriteFactory.spriteWithFile("bb_badge.png");
                likeBar.setPosition(name.getPosition().getX(), BIT_ITEM_HEIGHT - 40);
                bg.addChild(likeBar);
                
                // Prevents like number to be NaN
                var numLikes = (bseed + message.length) % 10;
                if (isNaN(numLikes))
                {
                    numLikes = 3;
                }
                
                var likes = LabelConfigurer.createLabelWithString(sprintf("%d BITIZENS LIKE THIS", numLikes), "silkscreen", FONT14, [0, 0], true);
                likes.setPosition(16, 6);

                var _scale = likes.getScale();
                likes.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
                
                likes.setColor(ccc3(89, 81, 140));
                likeBar.addChild(likes);
                
                var bar = ALLayerColor.layerWithColor(ccc3(230, 230, 230), 255, BIT_ITEM_WIDTH, 4, [0, 0]);
                bar.setPosition(0, BIT_ITEM_HEIGHT - 4);
                bg.addChild(bar);
            }
        }
        
        this._fcount++;
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTBitizenListLayer'] = function(){var exports = $MODULE_REGISTRY['Code/TTBitizenListLayer'] || {}; $MODULE_REGISTRY['Code/TTBitizenListLayer'] = exports; exports.TTBitizenListLayer = BaseClass.subclass({
    classname : 'TTBitizenListLayer',
    
    initialize : function(width, height, floor)
    {
    	//Bottom HUD
        this.bottomOffset = (this.__size.getHeight() - height) / 2;
        
        this._fcount = 0;
        this._sortButtons = [];        
        //[[CCTouchDispatcher sharedDispatcher] addTargetedDelegate:this priority:INT_MIN+1 swallowsTouches:true);
        
//        var _shade = ALLayerColor.layerWithColor(ccc3(0, 0, 0), 128/255, width, height + this.bottomOffset, [0, 0]);
//        this._node.addChild(_shade);
        TTScene.shadeLayer(true);
        
        this._hiringFloor = floor;
        
        this._list = TTList.initWithTarget(this.listClicked.bind(this));
        this._list.setItemSize(new Core.Size(160 * 2, 24 * 2));
        this._list._node.setPosition(0, 76 - this.bottomOffset);
        this._node.addChild(this._list._node);
        
        this._bits = TTScene.sharedScene()._playerData._bitizens;
        
        this._sortMode = NSUserDefaults.standardUserDefaults().integerForKey("bitSortMode");
        
        var bitObjs = [];
        for ( var key in this._bits)
        {
            bitObjs.push(this._bits[key]);
        }
                
        var sortedBitArr = null;
        switch (this._sortMode)
        {
            case SORT_MODE_HAPPINESS:
                sortedBitArr = bitObjs.sort(TTBitizenInfo.happyCompare);
                break;
            case SORT_MODE_JOB:
                sortedBitArr = bitObjs.sort(TTBitizenInfo.jobCompare);
                break;
            case SORT_MODE_SKILL_FOOD:
                sortedBitArr = bitObjs.sort(TTBitizenInfo.skillCompareFood);
                break;
            case SORT_MODE_SKILL_SERVICE:
                sortedBitArr = bitObjs.sort(TTBitizenInfo.skillCompareService);
                break;
            case SORT_MODE_SKILL_RECREATION:
                sortedBitArr = bitObjs.sort(TTBitizenInfo.skillCompareRecreation);
                break;
            case SORT_MODE_SKILL_RETAIL:
                sortedBitArr = bitObjs.sort(TTBitizenInfo.skillCompareRetail);
                break;
            case SORT_MODE_SKILL_CREATIVE:
                sortedBitArr = bitObjs.sort(TTBitizenInfo.skillCompareCreative);
                break;
            default:
                break;
        }
        
        if (!sortedBitArr)
        {
            sortedBitArr = bitObjs;
        }
        
        this._itemsLoaded = 0;
        this._itemsToLoad = [];
        
        this._happyCount = 0;
                
        for ( var i = 0; i < sortedBitArr.length; i++)
        {            
            var binfo = sortedBitArr[i];
            var bpbg = TTSpriteFactory.spriteWithFile("picker_item.png");
            this._list.addItem(bpbg);
            
            bpbg.AL_setTag(binfo._seed);
            this._itemsToLoad.push(bpbg);
        }
        
        // this._title BAR
        var titleBg = TTSpriteFactory.spriteWithFile_withAnchor("topslice.png", [ 0, 0 ]);
        titleBg.setPosition(0, 0 - this.bottomOffset);
        titleBg.setScale(UNISAFE_WIDTH / (titleBg.AL_getSize().getWidth() * 1.0), 1);
        this._node.addChild(titleBg);
        
        this._title = LabelConfigurer.createLabelWithString(this._hiringFloor ? "HIRE WORKER" : "DREAM JOBS: 0", "silkscreen", FONT16, [0.5, 1], true);

		var _scale = this._title.getScale();
        this._title.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        this._title.setPosition(UNISAFE_WIDTH / 2, titleBg.getPosition().getY() + 25);
        this._node.addChild(this._title);
        
        // SORT BUTTONS
        for ( var i = 0; i < NUM_SORT_BUTTONS; i++)
        {
            var sButton = TTSpriteFactory.spriteWithFile("sort" + (i + 1) + ".png", [ 0, 0 ]);
            sButton.setPosition(0 + i * 23 * 2, titleBg.getPosition().getY() + titleBg.AL_getSize().getHeight());
            this._node.addChild(sButton);
            if (i != this._sortMode)
            {
                sButton.setColor(ccc3(127, 127, 127));
            }
            this._sortButtons[i] = sButton;
        }
        
        this.setTouchTargetToScreenSize();
    },
    
    $initWithHiringFloor : function(floor)
    {
        return new this(UNISAFE_WIDTH, UNISAFE_HEIGHT, floor);
    },
    
    destroy : function()
    {
        TTScene.shadeLayer(false);
        if (TTScene.sharedScene()._menuLayer._children.length == 0)
        {
            if (this._hiringFloor)
            {
                var ffl = TTFloorFocusLayer.initWithFloor(this._hiringFloor);
                TTScene.sharedScene().runMenuLayer(ffl);
            }
            else
            {
                TTScene.sharedScene().runMenuLayer(new TTMenu(UNISAFE_WIDTH, UNISAFE_HEIGHT));
            }
        }
    },
    
    jobConfirmation : function(dialog)
    {
        if (dialog._buttonIndex == 1)
        {
            var newJobStory = this._hiringFloor._storyInfo._story;
            var curBit = dialog._data;
            var curBitInfo = curBit._info;
            curBitInfo._workFloor = newJobStory;
            var sInfo = TTScene.sharedScene()._playerData._floors[newJobStory];
            var fInfo = null;
            if (sInfo)
            {
            	fInfo = TTFloorTable.floorWithId(sInfo._floorId);
            	SoundBoard.playSfx(TTScene.floorTypeSound(fInfo._type));
            }
            
            TTScene.sharedScene().removeBitizenFromFloors(curBit._seed);
            
            // Dream Job?
            if (sInfo && sInfo._floorId == curBitInfo._dreamFloor && !curBitInfo._dreamed)
            {
                curBitInfo._dreamed = true;
                TTScene.sharedScene()._playerData.addBux(1);
                var dlg = TTDialog.initWithMessage(sprintf("\n\n\n\nYou've placed\n%s\nin their dream job! You've earned a Tower Bux!", curBit._name), ",continue", null, null, null);
                var bdbit = TTBitizen.initWithSeed(curBit._seed);
                bdbit._node.setPosition(0, 40);
                dlg._node._children[1].addChild(bdbit._node);
                TTDialogQueue.sharedQueue().addDialog(dlg);
            }
            
            if (newJobStory > 0)
            {
                TTScene.sharedScene().addBitizen(curBit._seed, newJobStory - 1);
            	al_trace("**** "+"F");
                srandom(Core.Time.getRealTime()/1000);
                if (std_rand() % BITBOOK_NEWJOBHIGH_CHANCE == 0)
                {
                    // High or low match?
                    var skill = TTBitizen.skillIn(fInfo._type, curBitInfo._seed);
                    var hiMatch = skill > 5;
                    
                    var entry = TTBitBook.entryFormatForEvent(hiMatch ? "new_job_high" : "new_job_low");
                    TTBitBook.addNewEntry(sprintf(entry, fInfo._name), curBitInfo._seed);
                }
            }
            else
            {
                TTScene.sharedScene().addBitizen(curBit._seed, curBitInfo._homeFloor - 1);
            }
            
            if (TTScene.sharedScene().tipNumber() > 0)
            {
                // TIP 19
                var ttl = TTutorialLayer.initWithStep(19, "RESTOCK FOOD ITEM");
                TTScene.sharedScene().runTipLayer(ttl);
            }
            TTScene.sharedScene().runMenuLayer(null);
        }
    },
    
    listClicked : function(index)
    {
        var i = index;
        al_trace(sprintf("Catalog tapped index: %d", i));
               
        var li = this._list.itemAtIndex(i);        
        if (!li._children.length)
        {
            return;
        }
        
        var bit = li._children[0]._AL_owner;
        var workStory = null;
        var wFloorInfo = null;
        if (bit._info._workFloor > 0)
        {
            workStory = TTScene.sharedScene()._playerData.getStoryInfo(bit._info._workFloor);
            wFloorInfo = TTFloorTable.floorWithId(workStory._floorId);
        }
        
        if (this._hiringFloor)
        {
            if (workStory && workStory._activeProduct > -1)
            {
                var dlg = TTDialog.initWithMessage(sprintf("\n\n\n%s\ncannot be reassigned while restocking the\n%s.", bit._name, wFloorInfo._name), ",continue", null, null, null);
                TTDialogQueue.sharedQueue().addDialog(dlg);
            }
            else
            {
                var dlg = TTDialog.initWithMessage(sprintf("\n\n\nGive\n%s\na job in the\n%s?", bit._name, this._hiringFloor._floorInfo._name), "no,yes", this.jobConfirmation.bind(this), this, bit);
                TTDialogQueue.sharedQueue().addDialog(dlg);
            }
        }
        else
        {
            var bfl = TTBitFocusLayer.initWithBitizen(bit, null);
            TTScene.sharedScene().runMenuLayer(bfl);
        }
    },
    
    _ccTouchesBegan : function(touch)
    {
        var tp = this._node.screenToLocal(touch.getPosition());
        for ( var i = 0; i < NUM_SORT_BUTTONS; i++)
        {
            var button = this._sortButtons[i];
            if (i != this._sortMode && CGRectContainsPoint(createBB(button), tp))
            {
                NSUserDefaults.standardUserDefaults().setObject(i, "bitSortMode");
                
                var bll = TTBitizenListLayer.initWithHiringFloor(this._hiringFloor);
                TTScene.sharedScene().runMenuLayer(bll);
                
                break;
            }
        }
        
        return true;
    },
    
    _draw : function()
    {
        // check if there are tanks to load
        // load 3 at a time
        for ( var i = 0; i < 5; i++)
        {
            if (this._fcount > 0 && !this._list.isDragging() && this._itemsToLoad.length > 0)
            {
                al_trace("Loading item: " + this._itemsLoaded);
                
                // load an item
                var li = this._list.itemAtIndex(this._itemsLoaded);                
                var binfo = this._bits[li.AL_getTag()];
                if (binfo)
                {                    
                    var bzn = TTBitizen.initWithSeed(binfo._seed);
                    bzn._node.setPosition(9*2, 15*2);
                    li.addChild(bzn._node);
                    
                    var nameLbl = LabelConfigurer.createLabelWithString(bzn._name, "silkscreen", FONT14, [0.5, 0.5], true);

					var _scale = nameLbl.getScale();
			        nameLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
			        
                    nameLbl.setAnchor(ccp(0, 0));
                    nameLbl.setPosition(19*2, (12-7)*2);
                    li.addChild(nameLbl);
                    
                    for ( var s = 0; s < 5; s++)
                    {
                        var sk = TTBitizen.skillIn(s, binfo._seed);
                        var skillLbl = LabelConfigurer.createLabelWithString("" + sk, "silkscreen", FONT14, [0.5, 0.5], true);

						var _scale = skillLbl.getScale();
				        skillLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
				        
                        skillLbl.setColor(TTScene.floorTypeColor(s));
                        skillLbl.setAnchor(ccp(0.5, 0));
                        skillLbl.setPosition(112*2 + s*6*2, nameLbl.getPosition().getY() );
                        li.addChild(skillLbl);
                    }
                    
                    if (binfo._dreamFloor && binfo._dreamFloor != -1)
                    {
                        var dfloorInfo = TTFloorTable.floorWithId(binfo._dreamFloor);
                        var dtypeLbl = LabelConfigurer.createLabelWithString(dfloorInfo._name, "silkscreen", FONT14, [1, 0], true);
                        dtypeLbl.setColor(TTScene.floorTypeColor(dfloorInfo._type));

						var _scale = dtypeLbl.getScale();
				        dtypeLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
				        
                        dtypeLbl.setAlpha(64/255);
                        dtypeLbl.setPosition(280, nameLbl.getPosition().getY() + 14 );
                        li.addChild(dtypeLbl);
                    }
                    
                    if (binfo._workFloor && binfo._workFloor != -1)
                    {
                        var storyInfo = TTScene.sharedScene()._playerData.getStoryInfo(binfo._workFloor);                     
                        var floorInfo = TTFloorTable.floorWithId(storyInfo._floorId);
                        var typeLbl = LabelConfigurer.createLabelWithString((storyInfo && floorInfo) ? floorInfo._name : "UNEMPLOYED", "silkscreen", FONT14, [0, 0], true);

						var _scale = typeLbl.getScale();
				        typeLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
				        
                        typeLbl.setColor(storyInfo && floorInfo ? TTScene.floorTypeColor(floorInfo._type) : ccc3(128, 128, 128));
                        typeLbl.setPosition(nameLbl.getPosition().getX(), nameLbl.getPosition().getY() + 7*2);
                        li.addChild(typeLbl);
                    }
                    else
                	{
                    	var typeLbl = LabelConfigurer.createLabelWithString("UNEMPLOYED", "silkscreen", FONT14, [0, 0], true);

						var _scale = typeLbl.getScale();
				        typeLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
				        
                        typeLbl.setColor(ccc3(128, 128, 128));
                        typeLbl.setPosition(nameLbl.getPosition().getX(), nameLbl.getPosition().getY() + 7*2);
                        li.addChild(typeLbl);
                	}
                    
                    // mood
                    var happiness = bzn.happiness();
                    if (happiness == "happy")
                    {
                        this._happyCount++;
                        //float hp = this._happyCount/(float)this._bits.length*100;
                        this._title.setText("DREAM JOBS: " + this._happyCount);
                    }
                    
                    var mood = TTSpriteFactory.spriteWithFile("mood_" + happiness + ".png");
                    mood.setPosition(146*2, 6*2);
                    li.addChild(mood);
                }
                
                this._itemsToLoad.splice(0, 1);
                this._itemsLoaded++;
            }
        }
        
        this._fcount++;
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTElevatorShopLayer'] = function(){var exports = $MODULE_REGISTRY['Code/TTElevatorShopLayer'] || {}; $MODULE_REGISTRY['Code/TTElevatorShopLayer'] = exports; exports.TTElevatorShopLayer = BaseClass.subclass({
    classname : 'TTElevatorShopLayer',
        
    initialize : function(width, height)
    {
    	//Bottom offset
        this.bottomOffset = (this.__size.getHeight() - height) / 2;
        
        this._buyButton = null;
        this._elevatorGfx = null;
        this._curElevatorLvl = TTScene.sharedScene()._playerData._elevator;
        
        var _shade = ALLayerColor.layerWithColor(ccc3(0, 0, 0), 128 / 255,UNISAFE_WIDTH,UNISAFE_HEIGHT + this.bottomOffset*2);
        _shade.setPosition(UNISAFE_WIDTH/2,UNISAFE_HEIGHT/2);        
        this._node.addChild(_shade);
        //_shade.setScale(2, 2);
        
        var bg = TTSpriteFactory.spriteWithFile("focus_bg.png");
        bg.setPosition((UNISAFE_WIDTH / 2) - 130, (UNISAFE_HEIGHT / 2 + HUD_BAR_HEIGHT / 2) - 240);
        this._node.addChild(bg);
        
        var name = "";
        switch (this._curElevatorLvl + 1)
        {
            case 1:
                name = "NB200 Commercial Lift";
                break;
            case 2:
                name = "Insta-Lift 2000 SE";
                break;
            case 3:
                name = "Ultra-Lift 3000 Extreme";
                break;
            default:
                break;
        }
       
        var titleLbl = LabelConfigurer.createLabelWithString(name, "silkscreen", FONT14, [ 0.5, 0.5 ], true);
        titleLbl.setPosition(UNISAFE_WIDTH / 2, 60);

		var _scale = titleLbl.getScale();
        titleLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        this._node.addChild(titleLbl);
        
        var speedLbl = LabelConfigurer.createLabelWithString(sprintf("SPEED: %d PPM", (this._curElevatorLvl + 2) * 4), "silkscreen", FONT14, [ 0.5, 0.5 ], true);

		var _scale = speedLbl.getScale();
        speedLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        speedLbl.setPosition(UNISAFE_WIDTH / 2, 245);
        this._node.addChild(speedLbl);
        
        var costLbl = LabelConfigurer.createLabelWithString(sprintf("%d", this.costForElevator(this._curElevatorLvl + 1)), "silkscreen", FONT14, [ 0.5, 0.5 ], true);

		var _scale = costLbl.getScale();
        costLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        costLbl.setPosition(UNISAFE_WIDTH / 2 + 4, 285);
        this._node.addChild(costLbl);
        
        var bux = TTSpriteFactory.spriteWithFile_withAnchor('bux.png', [ 1, 0.5 ]);
        bux.setPosition(UNISAFE_WIDTH / 2 - 15, costLbl.getPosition().getY());
        this._node.addChild(bux);
        
        // floor render
        var elevatorGfx = TTSpriteFactory.spriteWithFile(sprintf("elevator_%d.png", this._curElevatorLvl + 1));
        this._node.addChild(elevatorGfx);
        elevatorGfx.setPosition(new Core.Point((UNISAFE_WIDTH / 2) - 25, UNISAFE_HEIGHT / 2 - 150));
        
        this._buyButton = TTSpriteFactory.spriteWithFile("elevator_upgrade.png");
        this._buyButton.setPosition(new Core.Point(bg.getPosition().getX() + 75, bg.getPosition().getY() + 305));
        this._node.addChild(this._buyButton);
        this._buyButton.setAlpha(255 / 255);
        
        this.setTouchTargetToScreenSize();
    },
    
    destroy : function()
    {
        if (TTScene.sharedScene()._menuLayer._children.length == 0)
        {
            TTScene.sharedScene().runMenuLayer(TTMenuLayer._node);
        }
    }, 
    
    $costForElevator : function(level)
    {
    	console.log("25 + 50 * ("+level+" - 1)");
        return 25 + 50 * (level - 1);
    },
    
    _ccTouchesBegan : function(touchEvent)
    {
        var tp = this._node.screenToLocal(touchEvent.getPosition());
        if (this._buyButton && this._buyButton.getAlpha() > (64 / 255) && CGRectContainsPoint(createBB(this._buyButton), tp))
        {
            this._buyButton.setAlpha(127 / 255);
        }
        
        return true;
    },
    
    _ccTouchesCancelled : function(touchEvent)
    {
        if (this._buyButton && this._buyButton.getAlpha() == 128)
        {
            this._buyButton.setAlpha(255 / 255);
        }
    },
    
    buyDlg : function(dlg)
    {
        if (dlg._buttonIndex > 0)
        {
            TTScene.sharedScene()._playerData.addBux(TTElevatorShopLayer.costForElevator(this._curElevatorLvl + 1)*-1);
            TTScene.sharedScene()._playerData._elevator += 1;
            TTScene.sharedScene()._towerLayer._elevator.reload();
            TTScene.sharedScene().runMenuLayer(null);
        }
    },
    
    _ccTouchesEnded : function(touch)
    {
        var tp = this._node.screenToLocal(touch.getPosition());
        if (this._buyButton && this._buyButton.getAlpha() > (64/255))
        {
            this._buyButton.setAlpha(255 / 255);
            if (CGRectContainsPoint(createBB(this._buyButton), tp))
            {
                if (TTScene.sharedScene()._playerData._bux - this.costForElevator(this._curElevatorLvl + 1) < 0)
                {
                    var dlg = TTDialog.initWithMessage("\n\n\n\nYou do not have enough tower bux for that.", ",continue", null, null, null);
                    TTDialogQueue.sharedQueue().addDialog(dlg);
                    dlg = null;
                }
                else
                {
                    // BUY PAINT    				
                    var dlg = TTDialog.initWithMessage(sprintf("\n\n\n\nUpgrade to this elevator for %d bux?", TTElevatorShopLayer.costForElevator(this._curElevatorLvl + 1)), "no,yes", this.buyDlg, this, null);                    
                    TTDialogQueue.sharedQueue().addDialog(dlg);
                    dlg = null;
                }
            }
        }
    },
    
    _ccTouchesMoved : function(/*GL2.Touch*/touchEvent)
    {
    	var tp = this._node.screenToLocal(touchEvent.getPosition());

    	if (this._buyButton && this._buyButton.getAlpha() > (64 / 255) && CGRectContainsPoint(createBB(this._buyButton), tp))
        {
            this._buyButton.setAlpha(127 / 255);
        }
    	else
		{
    		this._buyButton.setAlpha(255 / 255);
		}
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTFloorPaintLayer'] = function(){var exports = $MODULE_REGISTRY['Code/TTFloorPaintLayer'] || {}; $MODULE_REGISTRY['Code/TTFloorPaintLayer'] = exports; exports.TTFloorPaintLayer = BaseClass.subclass({
    classname : 'TTFloorPaintLayer',
    initialize: function(width, height){
        
        this._focusFloor = null;
        this._destroyButton = null;
        this._paintButton = null;
        this._buyPaintButton = null;
        this._floorMask = null;
        this._floorGfx = null;
        this._canLbl = null;
        
        this._numFormat = null;
        
        this.setTouchTargetToScreenSize();
        
    },
    $initWithFloor: function(flr){
        
        var result = new TTFloorPaintLayer(UNISAFE_WIDTH,UNISAFE_HEIGHT);
        
        /*
        numFormat = [[NSNumberFormatter alloc] init];
        [numFormat setNumberStyle:kCFNumberFormatterDecimalStyle];
        [numFormat setPerMillSymbol:@","];
        */
        
        result._focusFloor = flr;
        
        /*
        self.isTouchEnabled = YES;
        [[CCTouchDispatcher sharedDispatcher] addTargetedDelegate:self priority:INT_MIN+1 swallowsTouches:YES];
        */
        
//        var _shade = ALLayerColor.layerWithColor(ccc3(0, 0, 0), 0.5, UNISAFE_WIDTH, UNISAFE_HEIGHT + TTScene.sharedScene()._towerLayer.bottomOffset*2);
//        _shade.setPosition( UNISAFE_WIDTH / 2, UNISAFE_HEIGHT / 2 );
//        result._node.addChild(_shade);
//        //_shade.setScale([2,2]);
//
        TTScene.shadeLayer(true);
        
        var bg = TTSpriteFactory.spriteWithFile('focus_bg.png', [ 0.5, 0.5 ]); 
        bg.setPosition(UNISAFE_WIDTH/2,UNISAFE_HEIGHT/2-HUD_BAR_HEIGHT/2);
        result._node.addChild(bg);
        
        var floorInfo = result._focusFloor._floorInfo;
        var floorName = "";
        if (floorInfo)
        {
            floorName = floorInfo._name;
        }
        
        var titleLbl = LabelConfigurer.createLabelWithString(floorName,"silkscreen",FONT14, [0.5,0],true);
        //titleLbl.setScale(2,2);
        
		var _scale = titleLbl.getScale();
        titleLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        titleLbl.setPosition(new Core.Point(bg.getPosition().getX() ,50));
        result._node.addChild(titleLbl);

        var floorFrame = TTSpriteFactory.spriteWithFile("paint_frame.png");
        result._node.addChild(floorFrame);
        floorFrame.setPosition(new Core.Point(25,80));
        
        
        var fn = result._focusFloor._floorGfx._animation.getFrame(0).getImage().replace("./Content/","");
        var imageSize = new Core.Size(DataPreloader._imageSizes[fn]);
        var uvs =[0,0,256/imageSize.getWidth(),96/imageSize.getHeight()];
        result._floorGfx =  TTSpriteFactory.spriteWithFile_withTexture(fn, uvs);
    
        // RELOAD MASKS
        result._reload_masks();
        
        result._floorGfx.setPosition(new Core.Point(25 + 12,80 + 12));
        result._node.addChild(result._floorGfx);
        
        result._destroyButton = TTSpriteFactory.spriteWithFile("paint_reset.png");
        result._destroyButton.setPosition(bg.getPosition().getX()-80,bg.getPosition().getY()+175);
        result._node.addChild(result._destroyButton);
        result._destroyButton.setAlpha(255/255);
        
        
        result._paintButton = TTSpriteFactory.spriteWithFile("paint_repaint.png");
        result._paintButton.setPosition(bg.getPosition().getX()-60,bg.getPosition().getY()+100);
        result._node.addChild(result._paintButton);
        result._paintButton.setAlpha((TTScene.sharedScene()._playerData._paint)?255/255:64/255);
        
        result._buyPaintButton = TTSpriteFactory.spriteWithFile("paint_buy.png");
        result._buyPaintButton.setPosition(bg.getPosition().getX()-60,bg.getPosition().getY()+40);
        result._node.addChild(result._buyPaintButton);
        result._buyPaintButton.setAlpha(255/255);
        
        var can = TTSpriteFactory.spriteWithFile("paint_can.png",[1.5,0.5]);
        
        can.setPosition(bg.getPosition().getX(),bg.getPosition().getY()-0);
        result._node.addChild(can);
        
        
        result._canLbl = LabelConfigurer.createLabelWithString(sprintf("%@ LEFT", TTScene.sharedScene()._playerData._paint),"silkscreen",FONT14, [0.5,0],true);
        
		var _scale = result._canLbl.getScale();
        result._canLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        //[canLbl setScale:2];
        //[canLbl.texture setAliasTexParameters];
        //[canLbl setAnchorPoint:ccp(0,0.5)];
        result._canLbl.setPosition(can.getPosition().getX()+18,can.getPosition().getY());
        result._node.addChild(result._canLbl);
        
        return result;
        
    },
    _reload_masks : function ()
    {
        var fn = this._focusFloor._floorGfx._animation.getFrame(0).getImage().replace("./Content/","");
       
        if(this._focusFloor._storyInfo._color.length!=0){
        	
	        xfn = fn.replace(".png","");
	        
	        this._floorGfx.AL_removeAllChildrenWithCleanup();
	        // ADD AND PAINT LAYERS AS CURRENT FLOOR
	        var mr = TTSpriteFactory.spriteWithFile(xfn+ "_m_r.png", [0,0]);
	        mr.setVisible(this._focusFloor._floorGfx._children[0].getVisible());
	        mr.setColor(this._focusFloor._floorGfx._children[0].getColor());
	        this._floorGfx.addChild(mr);
	        var mg = TTSpriteFactory.spriteWithFile(xfn+ "_m_g.png", [0,0]);
	        mg.setVisible(this._focusFloor._floorGfx._children[1].getVisible());
	        mg.setColor(this._focusFloor._floorGfx._children[1].getColor());
	        this._floorGfx.addChild(mg);
	        var mb = TTSpriteFactory.spriteWithFile(xfn+ "_m_b.png", [0,0]);
	        mb.setVisible(this._focusFloor._floorGfx._children[2].getVisible());
	        mb.setColor(this._focusFloor._floorGfx._children[2].getColor());
	        this._floorGfx.addChild(mb);
        }
    },
    _draw: function(){
        
    },
    _ccTouchesBegan : function(touchEvent) {
        
        var tp = this._node.screenToLocal(touchEvent.getPosition());
        
        
        
        if (this._destroyButton && this._destroyButton.getAlpha()>64/255 && CGRectContainsPoint(createBB(this._destroyButton), tp)) {
            this._destroyButton.setAlpha(127/255);
        }
        else if (this._paintButton && this._paintButton.getAlpha()>64/255 && CGRectContainsPoint(createBB(this._paintButton), tp)) {
            this._paintButton.setAlpha(127/255);
        }
        else if (this._buyPaintButton && this._buyPaintButton.getAlpha()>64/255 && CGRectContainsPoint(createBB(this._buyPaintButton), tp)) {
            this._buyPaintButton.setAlpha(127/255);
        }

        return true;
        
    },
    
    _ccTouchesMoved : function(touchEvent) {
        
        var tp = this._node.screenToLocal(touchEvent.getPosition());
        
        
        
        if (this._destroyButton && this._destroyButton.getAlpha()>64/255 && CGRectContainsPoint(createBB(this._destroyButton), tp)) {
            this._destroyButton.setAlpha(127/255);
            if(TTScene.sharedScene()._playerData._paint)
    		{
        		this._paintButton.setAlpha(255/255);
    		}
        	else
    		{
        		this._paintButton.setAlpha(64/255);
    		}
        	this._buyPaintButton.setAlpha(255/255);
        }
        else if (this._paintButton && this._paintButton.getAlpha()>64/255 && CGRectContainsPoint(createBB(this._paintButton), tp)) {
            this._paintButton.setAlpha(127/255);
            this._destroyButton.setAlpha(255/255);
        	this._buyPaintButton.setAlpha(255/255);
        }
        else if (this._buyPaintButton && this._buyPaintButton.getAlpha()>64/255 && CGRectContainsPoint(createBB(this._buyPaintButton), tp)) {
            this._buyPaintButton.setAlpha(127/255);
            this._destroyButton.setAlpha(255/255);
            if(TTScene.sharedScene()._playerData._paint)
    		{
        		this._paintButton.setAlpha(255/255);
    		}
        	else
    		{
        		this._paintButton.setAlpha(64/255);
    		}
        }
        else
    	{
        	this._destroyButton.setAlpha(255/255);
        	if(TTScene.sharedScene()._playerData._paint)
    		{
        		this._paintButton.setAlpha(255/255);
    		}
        	else
    		{
        		this._paintButton.setAlpha(64/255);
    		}
        	this._buyPaintButton.setAlpha(255/255);
    	}

        return true;
        
    },
    
    _ccTouchesCancelled: function(touchEvent){
        if (this._destroyButton && this._destroyButton.getAlpha()==128/255) {
            this._destroyButton.setAlpha(255/255);
        }
        if (this._paintButton && this._paintButton.getAlpha()==(128/255)) {
            this._paintButton.setAlpha(255/255);
        }
        if (this._buyPaintButton && this._buyPaintButton.getAlpha()==(128/255)) {
            this._buyPaintButton.setAlpha(255/255);
        }
    },
    buyPaintDlg: function(dlg){
        if (dlg._buttonIndex>0) {
            TTScene.sharedScene()._playerData._paint += 100;
            TTScene.sharedScene()._playerData.addBux(-1);
            this._canLbl.setText(sprintf("%@ LEFT",TTScene.sharedScene()._playerData._paint));
            this._paintButton.setAlpha(255/255);
        }
    },
    _ccTouchesEnded: function(touchEvent){
        var tp = this._node.screenToLocal(touchEvent.getPosition());
        
        if (this._destroyButton && this._destroyButton.getAlpha()>(64/255)) {
            this._destroyButton.setAlpha(255/255);
            if (CGRectContainsPoint(createBB(this._destroyButton), tp)) {
                
            	// PAINT
            	if(this._focusFloor._storyInfo._color.length!=0){
	                this._focusFloor._storyInfo._sales[1] = 0;
	                this._focusFloor._floorGfx.AL_removeAllChildrenWithCleanup();
	                this._floorGfx.AL_removeAllChildrenWithCleanup();
	                arr_delete(this._focusFloor._storyInfo._color);
            	}
            	this._focusFloor.repaint();
            	this._reload_masks();
            	
            }
        }
        
    
    if (this._paintButton && this._paintButton.getAlpha()>64/255) {
        this._paintButton.setAlpha(255/255);
        if (CGRectContainsPoint(createBB(this._paintButton), tp)) {
            // PAINT
            this._focusFloor._storyInfo._sales[1] = std_rand();
            this._focusFloor.repaint(true);
            this._reload_masks();
            
            if (this._floorMask) {
                this._floorMask.removeFromParentAndCleanup(false);
                this._floorMask = null;
            }
            if (this._focusFloor._floorMask) {
//              floorMask = [CCSprite spriteWithTexture:focusFloor.floorMask.texture];
//              [floorMask setTextureRect:focusFloor.floorMask.textureRect];
//              [floorMask setPosition:floorGfx.position];
//              [floorMask setScale:2];
//              [floorMask setTextureRect:floorGfx.textureRect];
//              [self addChild:floorMask];
            }
            
            TTScene.sharedScene()._playerData._paint -= 1;
            this._canLbl.setText(sprintf("%@ LEFT",TTScene.sharedScene()._playerData._paint));
            this._paintButton.setAlpha((TTScene.sharedScene()._playerData._paint)?255/255:64/255);
            
            SoundBoard.playSfx(SFX_PAINT);
        }
    }
    
    
    if (this._buyPaintButton && this._buyPaintButton.getAlpha()>(64/255)) {
    
        this._buyPaintButton.setAlpha(255/255);
        
        if (CGRectContainsPoint(createBB(this._buyPaintButton), tp)) {
            if (TTScene.sharedScene()._playerData._bux - 1 < 0) {
                var dlg = TTDialog.initWithMessage(sprintf("\n\n\n\nYou do not have enough tower bux for that."),",continue", null, null, null);
                TTDialogQueue.sharedQueue().addDialog(dlg); 
            }
            else {
                // BUY PAINT
                var dlg = TTDialog.initWithMessage(sprintf("\n\n\n\nBuy more paint for 1 bux?"),"no,yes", this.buyPaintDlg, this, null);
                TTDialogQueue.sharedQueue().addDialog(dlg); 

            }
        }
        
    
    }

    },
    destroy: function(){
        TTScene.shadeLayer(false);
    }
    
});

    ; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTBuxLayer'] = function(){var exports = $MODULE_REGISTRY['Code/TTBuxLayer'] || {}; $MODULE_REGISTRY['Code/TTBuxLayer'] = exports; var NUM_BUX_BUTTONS = 3;

exports.TTBuxLayer = BaseClass.subclass({
    classname: 'TTBuxLayer',
    
    initialize : function(width, height, products)
    {
        //Bottom offset
        this.bottomOffset = (this.__size.getHeight() - height) / 2;
        
        this._iconSprites = [];
        this._btnBounds = [];
        
        this._shade = ALLayerColor.layerWithColor(ccc3(0, 0, 0), (128 + 64) / 255,UNISAFE_WIDTH,UNISAFE_HEIGHT + this.bottomOffset*2);
        this._shade.setPosition(UNISAFE_WIDTH/2,UNISAFE_HEIGHT/2);
        this._node.addChild(this._shade);
        
        var btnStart = ccp(UNISAFE_WIDTH / 2, 300);
        var btnSpacingY = 100;
        
        this._prods = products;
        
        for ( var i = 0; i < NUM_BUX_BUTTONS && i < products.length; i++)
        {            
            var icon = TTSpriteFactory.spriteWithFile_withAnchor("getbux_" + (i + 1) + ".png", [0.5, 0]);
            this._iconSprites[i] = icon;
            
            var prod = products[i];
            icon.setPosition(btnStart.getX(), btnStart.getY() - (products.length - 1 - i) * btnSpacingY);
            this._btnBounds[i] = createBB(icon);
            this._node.addChild(icon);
            
            var formattedString = prod.price;
            
            var coins = TTSpriteFactory.spriteWithFile_withAnchor("gold_mobacoin.png", [0.5, 0.5]);
            coins.setPosition(16 + 10 * i, 34);
            coins.setScale(0.5, 0.5);
            icon.addChild(coins);
            
            var costLbl = LabelConfigurer.createLabelWithString(formattedString, "silkscreen", FONT18, [0, 0], true);
            costLbl.setPosition(36 + 10 * i, 28);

			var _scale = costLbl.getScale();
	        costLbl.setScale(_scale.getX()*FONTSCALE18, _scale.getX()*FONTSCALE18);
	        

            icon.addChild(costLbl);
        }
                
        // TITLE BAR        
        var titleBg = TTSpriteFactory.spriteWithFile_withAnchor("topslice.png", [ 0, 0 ]);
        titleBg.setPosition(0, -this.bottomOffset);
        titleBg.setScale(UNISAFE_WIDTH / (titleBg.AL_getSize().getWidth() * 1.0), 1);
        this._node.addChild(titleBg);
        
        this._title = LabelConfigurer.createLabelWithString("MORE BUX", "silkscreen", FONT16, [0.5, 1], true);

		var _scale = this._title.getScale();
        this._title.setScale(_scale.getX()*FONTSCALE16, _scale.getX()*FONTSCALE16);
        
        this._title.setPosition(UNISAFE_WIDTH / 2, titleBg.getPosition().getY() + 25);
        this._node.addChild(this._title);
        
        // Show balance button
        var balanceSize = [UI.Window._height * 0.06 * 3 ,
                           UI.Window._height * 0.06];
        var balanceRect = new UI.ViewGeometry.Rect(
                1,
                UI.Window._height - balanceSize[1] - 1,
                balanceSize[0],
                balanceSize[1]);
        // Hide the HUD label coins
        TTScene.sharedScene()._hud._coinLabel.setVisible(false);
        Social.US.Service.ButtonOverlays.showBalanceButton(balanceRect, function(error)
        {
            al_trace("TTBuxLayer: Couldn't show balance button. Error: " + JSON.stringify(error));
        });
    },
    
    $initWithProducts : function(products)
    {
        return new this(UNISAFE_WIDTH, UNISAFE_HEIGHT, products);
    },
    
    destroy : function()
    {
        if (this._prods)
        {
            this._prods.length = 0;
        }
        // Show the HUD label coins
        TTScene.sharedScene()._hud._coinLabel.setVisible(true);
        Social.US.Service.ButtonOverlays.hideBalanceButton(function(error) {});
    },
    
    _ccTouchesBegan : function(touch)
    {
        var tp = this._node.screenToLocal(touch.getPosition());
        for ( var i = 0; i < NUM_BUX_BUTTONS; i++)
        {
            if (CGRectContainsPoint(this._btnBounds[i], tp))
            {
                this._iconSprites[i].setColor(ccc3(127, 127, 127));
            }
        }
        
        return true;
    },
    
    _ccTouchesMoved : function(touch)
    {
        var tp = this._node.screenToLocal(touch.getPosition());
        for ( var i = 0; i < NUM_BUX_BUTTONS; i++)
        {
            if (CGRectContainsPoint(this._btnBounds[i], tp))
            {
                this._iconSprites[i].setColor(ccc3(127, 127, 127));
            }
            else
        	{
            	this._iconSprites[i].setColor(ccc3(255, 255, 255));
        	}
        }
        
        return true;
    },
    
    _ccTouchesCancelled : function(touch)
    {
        for ( var i = 0; i < NUM_BUX_BUTTONS && i < this._prods.length; i++)
        {
            this._iconSprites[i].setColor(ccc3(255, 255, 255));
        }
    },
    
    _ccTouchesEnded : function(touch)
    {
        var tp = this._node.screenToLocal(touch.getPosition());
        for ( var i = 0; i < NUM_BUX_BUTTONS && i < this._prods.length; i++)
        {
            this._iconSprites[i].setColor(ccc3(255, 255, 255));
            if (CGRectContainsPoint(this._btnBounds[i], tp))
            {
                al_trace("ProShop item tapped: " + this._prods[i].id);
                TTScene.sharedScene().startTransaction(this._prods[i].id);
            }
        }
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTSettingsLayer'] = function(){var exports = $MODULE_REGISTRY['Code/TTSettingsLayer'] || {}; $MODULE_REGISTRY['Code/TTSettingsLayer'] = exports; exports.TTSettingsLayer = BaseClass.subclass({
	classname : 'TTSettingsLayer',
	initialize : function (width, height)  
	{
		//Bottom offset
    	this.bottomOffset = (this.__size.getHeight() - height) / 2;
    	
		var shade = ALLayerColor.layerWithColor(ccc3(0,0,0),(128+64)/255, UNISAFE_WIDTH, UNISAFE_HEIGHT + this.bottomOffset*2);
		this._node.addChild(shade);
		shade.setPosition(UNISAFE_WIDTH/2,UNISAFE_HEIGHT/2);
		//shade.setScale(2,2);

		// Sound settings
		var sfxSetting = NSUserDefaults.standardUserDefaults().objectForKey("setting-sfxOff");
		
		if (sfxSetting == null) 
			sfxSetting = true;
		
		al_trace("sfxSetting: [ " + sfxSetting + "]");
		this._sfxCheckbox = [TTSpriteFactory.spriteWithFile_withTexture("checkbox.png", [0,0,0.5,1], [0,1]),
		                     TTSpriteFactory.spriteWithFile_withTexture("checkbox.png", [0.5,0,0.5,1], [0,1])];
		// sfxCheckbox setTextureRect:CGRectMake(sfxSetting?0:sfxCheckbox.contentSize.width/2, 0, sfxCheckbox.contentSize.width/2, sfxCheckbox.contentSize.height)];
		this._sfxCheckbox[0].setPosition(50,UNISAFE_HEIGHT - 320);
		this._sfxCheckbox[1].setPosition(50,UNISAFE_HEIGHT - 320);
		this._node.addChild(this._sfxCheckbox[0]);
		this._node.addChild(this._sfxCheckbox[1]);
		this._sfxCheckbox[0].setVisible(!sfxSetting);
		this._sfxCheckbox[1].setVisible(sfxSetting);
		

		this._sfxLabel = LabelConfigurer.createLabelWithString("SOUNDS","silkscreen", FONT14, [0,1],true);

		var _scale = this._sfxLabel.getScale();
        this._sfxLabel.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
		this._sfxLabel.setPosition(this._sfxCheckbox[0].getPosition().getX()+50,this._sfxCheckbox[0].getPosition().getY() -6 );
		this._node.addChild(this._sfxLabel);

		var noteSetting = NSUserDefaults.standardUserDefaults().objectForKey("setting-notesOff");
		
		var uvs =[noteSetting ? 0 : 0.5, 0, 0.5, 1];
		this._notesCheckbox = [TTSpriteFactory.spriteWithFile_withTexture("checkbox.png", [0,0,0.5,1], [0,1]),
		                     TTSpriteFactory.spriteWithFile_withTexture("checkbox.png", [0.5,0,0.5,1], [0,1])];
//		[notesCheckbox setTextureRect:CGRectMake(notesSetting?0:notesCheckbox.contentSize.width/2, 0, notesCheckbox.contentSize.width/2, notesCheckbox.contentSize.height)];
		this._notesCheckbox[0].setPosition(50,UNISAFE_HEIGHT - 370);
		this._notesCheckbox[1].setPosition(50,UNISAFE_HEIGHT - 370);
		this._node.addChild(this._notesCheckbox[0]);
		this._node.addChild(this._notesCheckbox[1]);
		this._notesCheckbox[0].setVisible(false);
		this._notesCheckbox[1].setVisible(false);

		this._notesLabel = LabelConfigurer.createLabelWithString("NOTIFICATIONS","silkscreen", FONT14, [0,1],true);

		var _scale = this._notesLabel.getScale();
        this._notesLabel.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
		this._notesLabel.setPosition(this._notesCheckbox[0].getPosition().getX()+50,this._notesCheckbox[0].getPosition().getY() - 6);
		this._node.addChild(this._notesLabel);
		this._notesLabel.setVisible(false);

//		if(![[UIApplication sharedApplication] respondsToSelector:@selector(scheduleLocalNotification:)]) {
//		[notesLabel setVisible:NO];
//		[notesCheckbox setVisible:NO];
//		}

		this._resetButton = TTSpriteFactory.spriteWithFile("reset_game.png", [0.5,1]);
		this._resetButton.setPosition(UNISAFE_WIDTH/2,this._notesCheckbox[0].getPosition().getY()+290);
		this._node.addChild(this._resetButton);

        // TITLE BAR
        var titleBg = TTSpriteFactory.spriteWithFile_withAnchor("topslice.png", [0, 0]);
        titleBg.setPosition(0, - this.bottomOffset);
        titleBg.setScale(UNISAFE_WIDTH / (titleBg.AL_getSize().getWidth()), 1);
        this._node.addChild(titleBg);
        
        var title = LabelConfigurer.createLabelWithString("SETTINGS", "silkscreen", FONT14, [0.5, 1], true);

		var _scale = title.getScale();
        title.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        title.setPosition(UNISAFE_WIDTH / 2, titleBg.getPosition().getY() + 25);
        this._node.addChild(title);

//		var originalUser = [[NSUserDefaults standardUserDefaults] stringForKey:@"originalUser"];
		var originalUser = false;
		if (originalUser) {
//			CCLabelBMFont *verLabel = [CCLabelBMFont createLabelWithString:originalUser fntFile:@"silkscreen9.fnt"];
			var verLabel = LabelConfigurer.createLabelWithString(originalUser,"silkscreen", FONT9, [0.5,1],true);
//			[verLabel.texture setAliasTexParameters];
			verLabel.setScale(2,2);
			

			var _scale = verLabel.getScale();
	        verLabel.setScale(_scale.getX()*FONTSCALE9, _scale.getX()*FONTSCALE9);
	        
			verLabel.setColor(ccc3(127,127,127));
			verLabel.setPosition(UNISAFE_WIDTH/2, /* UNISAFE_MARGIN_HEIGHT-HUD_BAR_HEIGHT */ 0 + 20 );
			this._node.addChild(verLabel);
		}
	},
    $init : function()
    {
        return new this(UNISAFE_WIDTH, UNISAFE_HEIGHT);
    },
    destroy : function () 
	{
		if (TTScene.sharedScene()._menuLayer._children.length == 0) {
			TTScene.sharedScene().runMenuLayer(new TTMenuLayer(UNISAFE_WIDTH, UNISAFE_HEIGHT));
		}
	},
	confirmReset : function (dlg) {
		if (dlg._buttonIndex > 0) {
			// Reset game
			TTScene.sharedScene()._playerData.resetGame();
		}
	},
	_ccTouchesBegan : function(touchEvent) {
		//UITouch *touch = [touches anyObject];
		var tp = this._node.screenToLocal(touchEvent.getPosition());

		if(CGRectContainsPoint(createBB(this._resetButton), tp)) {
			this._resetButton.setColor(ccc3(127,127,127));
		}
		return true;
	},
	_ccTouchesCancelled : function(touchEvent) {
		this._resetButton.setColor(ccc3(255,255,255));
	},
	_ccTouchesEnded : function(touchEvent) {

		var tp = this._node.screenToLocal(touchEvent.getPosition());

		if(CGRectContainsPoint(createBB(this._sfxCheckbox[0]), tp) /* || CGRectContainsPoint([sfxLabel boundingBox], tp) */) {
//			[sfxCheckbox setTextureRect:CGRectMake(!setting?0:sfxCheckbox.contentSize.width, 0, sfxCheckbox.contentSize.width, sfxCheckbox.contentSize.height)];
			var setting = NSUserDefaults.standardUserDefaults().objectForKey("setting-sfxOff");
			
			if (setting == null) 
				setting = true;
			
			al_trace("sfxSetting _ccTouchesEnded: [ " + setting + "]");
			
			this._sfxCheckbox[0].setVisible(setting);
			this._sfxCheckbox[1].setVisible(!setting);
			NSUserDefaults.standardUserDefaults().setObject(setting ? false : true , "setting-sfxOff");
			SoundBoard.playSfx(SFX_LIGHTSWITCH);
			
			SoundBoard.setMusicEnabled(!setting);
			
			SoundBoard.playMusic(!setting);
			SoundBoard.setEnabled(!setting);
			
		}
		else if((CGRectContainsPoint(createBB(this._notesCheckbox[0]), tp) 
		    /* || CGRectContainsPoint([notesLabel boundingBox], tp) */ )) {
			var setting = NSUserDefaults.standardUserDefaults().objectForKey("setting-notesOff");
			this._notesCheckbox[0].setVisible(setting);
			this._notesCheckbox[1].setVisible(!setting);
			NSUserDefaults.standardUserDefaults().setObject(setting ? null: "OFF", "setting-notesOff");
			//[notesCheckbox setTextureRect:CGRectMake(!setting?0:notesCheckbox.contentSize.width, 0, notesCheckbox.contentSize.width, notesCheckbox.contentSize.height)];
			SoundBoard.playSfx(SFX_LIGHTSWITCH);

			if (setting) {
				// NOTES ON
				al_trace("Schedule all notes...");
			}
			else {
				al_trace("Cancel all notes...");
			}

		}
		else if(CGRectContainsPoint(createBB(this._resetButton), tp)) {
			var dlg = TTDialog.initWithMessage(sprintf("\n\n\n\ndelete your tiny tower game and start over?\n\nwarning\nyou will lose all bux, coins, and floors!"),
					"no,yes",this.confirmReset,this,null);
			TTDialogQueue.sharedQueue().addDialog(dlg);
		}
		this._resetButton.setColor(ccc3(255,255,255));
	},
	
	_ccTouchesMoved : function(/*GL2.Touch*/touchEvent)
    {
    	var tp = this._node.screenToLocal(touchEvent.getPosition());

    	if(CGRectContainsPoint(createBB(this._resetButton), tp)) 
    	{
			this._resetButton.setColor(ccc3(127,127,127));
		}
    	else
		{
    		this._resetButton.setColor(ccc3(255,255,255));
		}
    }

});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTNewJobLayer'] = function(){var exports = $MODULE_REGISTRY['Code/TTNewJobLayer'] || {}; $MODULE_REGISTRY['Code/TTNewJobLayer'] = exports; exports.TTNewJobLayer = BaseClass.subclass({
    classname: 'TTNewJobLayer',
    
    initialize : function(width, height, bit, floor)
    {        
        //Bottom offset
        this.bottomOffset = (this.__size.getHeight() - height) / 2;
        
        this._fcount = 0;
        
        this._curBitName = bit._name;
        this._curBit = bit;
        this._curBitInfo = TTScene.sharedScene()._playerData._bitizens[this._curBit._seed];
        this._curFloor = floor;
        
        this._shade = ALLayerColor.layerWithColor(ccc3(0, 0, 0), 128 / 255, width, height, [0, 0]);
        this._node.addChild(this._shade);
        
        this._list = TTList.initWithTarget(this.listClicked.bind(this));
        this._list.setItemSize(new Core.Size(320, 48));
        this._list._node.setPosition(0, 32 - this.bottomOffset);
        this._node.addChild(this._list._node);
        /*
        if (TTScene.sharedScene().tipNumber() > 0)
        {
            this._list._node.setPosition(this._list._node.getPosition.getX(), this._list._node.getPosition().getY() + 24);
        }*/
        
        this._hiringStories = TTScene.sharedScene()._playerData.storiesWithJobs();
        
        // Sort hiring stories
        var sortedVals = this._hiringStories.sort(TTStoryInfo.typeCompare);
        
        this._itemsLoaded = 0;
        this._itemsToLoad = [];
        
        al_trace("Hiring Stories: " + this._hiringStories.length);
        for ( var i = -1; i < 0 || i < sortedVals.length; i++)
        {            
            var sInfo = null;
            if (i >= 0)
            {
                sInfo = sortedVals[i];
            }
            
            var bpbg = TTSpriteFactory.spriteWithFile("picker_item.png");
            this._list.addItem(bpbg);
            
            bpbg.AL_setTag(sInfo ? sInfo._story : -1);
            this._itemsToLoad.push(bpbg);
        }
        
        // TITLE BAR
        var titleBg = TTSpriteFactory.spriteWithFile_withAnchor("topslice.png", [ 0, 0 ]);
        titleBg.setPosition(0, 0 - this.bottomOffset);
        titleBg.setScale(UNISAFE_WIDTH / (titleBg.AL_getSize().getWidth() * 1.0), 1);
        this._node.addChild(titleBg);
        
        this._title = LabelConfigurer.createLabelWithString("NEW JOB", "silkscreen", FONT16, [ 0.5, 1 ], true);
        
        var _scale = this._title.getScale();
        this._title.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        this._title.setPosition(UNISAFE_WIDTH / 2, titleBg.getPosition().getY() + 25);
        this._node.addChild(this._title);
        
        TTHud.sharedHud().showZoomButton(false);
        this.setTouchTargetToScreenSize();
    },
    
    $initWithBitizen : function(bit, floor)
    {
        return new this(UNISAFE_WIDTH, UNISAFE_HEIGHT, bit, floor);
    },
    
    jobConfirmation : function(dialog)
    {
        if (dialog._buttonIndex == 1)
        {
            var newJobStory = dialog._data;
            this._curBitInfo._workFloor = newJobStory;
            var sInfo = TTScene.sharedScene()._playerData._floors[newJobStory];
            if (sInfo)
        	{
	            var fInfo = TTFloorTable.floorWithId(sInfo._floorId);
	            SoundBoard.playSfx(TTScene.floorTypeSound(fInfo._type));
        	}
            TTScene.sharedScene().removeBitizenFromFloors(this._curBit._seed);
            
            // Dream Job?
            if (sInfo && sInfo._floorId == this._curBitInfo._dreamFloor && !this._curBitInfo._dreamed)
            {
                this._curBitInfo._dreamed = true;
                TTScene.sharedScene()._playerData.addBux(1);
                var dlg = TTDialog.initWithMessage(sprintf("\n\n\n\nYou've placed\n%s\nin their dream job! You've earned a Tower Bux!", this._curBitName), ",continue", null, null, null);
                var bdbit = TTBitizen.initWithSeed(this._curBit._seed);
                bdbit._node.setPosition(0, 40);
                dlg._node._children[1].addChild(bdbit._node);
                TTDialogQueue.sharedQueue().addDialog(dlg);
            }
            
            if (newJobStory > 0)
            {
                TTScene.sharedScene().addBitizen(this._curBit._seed, newJobStory - 1);
                    
                //srandom([NSDate timeIntervalSinceReferenceDate]);
                if (std_rand() % BITBOOK_NEWJOBHIGH_CHANCE == 0)
                {
                    
                    // High or low match?
                    var skill = TTBitizen.skillIn(fInfo._type, this._curBitInfo._seed);
                    var hiMatch = skill > 5;
                    
                    var entry = TTBitBook.entryFormatForEvent(hiMatch ? "new_job_high" : "new_job_low");
                    TTBitBook.addNewEntry(sprintf(entry, fInfo._name), this._curBitInfo._seed);
                }
            }
            else
            {
                TTScene.sharedScene().addBitizen(this._curBit._seed, this._curBitInfo._homeFloor - 1);
            }
            
            if (TTScene.sharedScene().tipNumber() == 17)
            {
                // TIP 18
                var ttl = TTutorialLayer.initWithStep(18, "TAP THE RESTAURANT");
                TTScene.sharedScene().runTipLayer(ttl);
            }
            
            TTScene.sharedScene().runMenuLayer(null);
        }
    },
    
    listClicked : function(index)
    {
        var i = index;
        al_trace("Catalog tapped index: " + i);
        
        var story = this._list.itemAtIndex(i).AL_getTag();
        al_trace("new job on story: " + story);
        
        var sInfo = TTScene.sharedScene()._playerData._floors[story];
        var fInfo = null;
        if(sInfo)
    	{
        	fInfo = TTFloorTable.floorWithId(sInfo._floorId);
    	}
        
        if (sInfo && fInfo)
        {
            var dlg = TTDialog.initWithMessage(sprintf("\n\n\nGive\n%s\na job in the\n%s?", this._curBitName, fInfo._name), "no,yes", this.jobConfirmation.bind(this), this, story);
            TTDialogQueue.sharedQueue().addDialog(dlg);
        }
        else
        {
            var dlg = TTDialog.initWithMessage(sprintf("\n\n\n\nMake\n%s\nunemployed?", this._curBitName), "no,yes", this.jobConfirmation.bind(this), this, -1);
            TTDialogQueue.sharedQueue().addDialog(dlg);
        }
    },
    
    _ccTouchesBegan : function(touch)
    {
        return false;
    },
    
    _draw : function()
    {
        // check if there are tanks to load
        // load 3 at a time
        for ( var i = 0; i < 3; i++)
        {
            if (this._fcount > 0 && !this._list.isDragging() && this._itemsToLoad.length > 0)
            {
                al_trace("Loading item: " + this._itemsLoaded);
                
                // load an item
                var li = this._list.itemAtIndex(this._itemsLoaded);
                
                var storyInfo = TTScene.sharedScene()._playerData._floors[li.AL_getTag()];
                if (storyInfo)
                {
                    var floorInfo = TTFloorTable.floorWithId(storyInfo._floorId);
                    if (floorInfo)
                    {
                        var nameLbl = LabelConfigurer.createLabelWithString(floorInfo._name.toUpperCase(), "silkscreen", FONT14, [0, 0], true);
                        
                        var _scale = nameLbl.getScale();
                        nameLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
                        
                        nameLbl.setAnchor(ccp(0, 0));
                        nameLbl.setPosition(38, 10);
                        li.addChild(nameLbl);
                        
                        var typeLbl = LabelConfigurer.createLabelWithString(TTScene.floorTypeString(floorInfo._type), "silkscreen", FONT14, [0, 0], true);
                        
                        var _scale = typeLbl.getScale();
                        typeLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
                        
                        typeLbl.setColor(TTScene.floorTypeColor(floorInfo._type));
                        typeLbl.setAnchor(ccp(0, 0));
                        typeLbl.setPosition(nameLbl.getPosition().getX(), nameLbl.getPosition().getY() + 14);
                        li.addChild(typeLbl);
                    }
                }
                else
                {
                    var nameLbl = LabelConfigurer.createLabelWithString("NO JOB", "silkscreen", FONT14, [0, 0], true);
                    
                    var _scale = nameLbl.getScale();
                    nameLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
                    
                    nameLbl.setAnchor(ccp(0, 0));
                    nameLbl.setPosition(38, 10);
                    li.addChild(nameLbl);
                }
                
                this._itemsToLoad.splice(0, 1);
                this._itemsLoaded++;
            }
        }
        
        this._fcount++;
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTutorialLayer'] = function(){var exports = $MODULE_REGISTRY['Code/TTutorialLayer'] || {}; $MODULE_REGISTRY['Code/TTutorialLayer'] = exports; 	exports.TTutorialLayer = BaseClass.subclass({
    classname : 'TTutorialLayer',
    initialize : function(width, height, number, tip)
    {
        // Bottom offset
        this.bottomOffset = (this.__size.getHeight() - height) / 2;
        
        // Flank offset
        this.flankOffset = (this.__size.getWidth() - width) / 2;
        
        this._tipNum = number;
        
        this._tipBox = TTSpriteFactory.spriteWithFile("tutorial2.png", [0, 0]);
        this._tipBox.setPosition(0, -height/2 +20- this.bottomOffset);
        this._node.addChild(this._tipBox);
        
    	var numLabel = LabelConfigurer.createLabelWithString(sprintf("STEP %d of 21", number), "silkscreen", FONT14, [ 0.5, 0.5 ], true);
    	numLabel.setPosition(this._tipBox.AL_getSize().getWidth() / 2, 50);
    	
		var _scale = numLabel.getScale();
        numLabel.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        this._tipBox.addChild(numLabel);
        
        var tipLabel = LabelConfigurer.createLabelWithString(tip, "silkscreen", FONT14, [ 0.5, 0.5 ], true);
        tipLabel.setPosition(this._tipBox.AL_getSize().getWidth() / 2, 80);

		var _scale = tipLabel.getScale();
        tipLabel.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        this._tipBox.addChild(tipLabel);
        
        this._tipBox.runAction(Action.MoveBy.actionWithDuration(0.5, ccp(0,2*this._tipBox.AL_getSize().getHeight())));
    },
    
    $initWithStep : function(number, tip)
    {
        return new this(UNISAFE_WIDTH, UNISAFE_HEIGHT, number, tip);
    },
    
    _ccTouchesBegan : function(touch)
    {
        var tp = this._node.screenToLocal(touch.getPosition());
        return CGRectContainsPoint(createBB(this._tipBox), tp);
    },
    
    _ccTouchesEnded : function(touch)
    {
        var tp = this._node.screenToLocal(touch.getPosition());
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTFriendsListLayer'] = function(){var exports = $MODULE_REGISTRY['Code/TTFriendsListLayer'] || {}; $MODULE_REGISTRY['Code/TTFriendsListLayer'] = exports; var ITEM_WIDTH = 110;

exports.TTFriendsListLayer = BaseClass.subclass({
    classname : 'TTFriendsListLayer',
    
    $init : function()
    {
        return new this(UNISAFE_WIDTH, UNISAFE_HEIGHT);
    },
    
    initialize : function(width, height)
    {
    	//Bottom offset
    	this.bottomOffset = (this.__size.getHeight() - height) / 2;
        // FlankOffset
        this.flankOffset = (this.__size.getWidth() - width) / 2;
        
        // Margins to aspect ratio with width larger than height (ie, iPad)
        // Left margin:
        var leftMarginLayer =  ALLayerColor.layerWithColor([0,0,0], 1, this.flankOffset, UNISAFE_HEIGHT + this.bottomOffset*2, [ 1, 0 ]);
    	leftMarginLayer.setPosition(0,0);
    	leftMarginLayer.setDepth(5000);
    	this.getNode().addChild(leftMarginLayer);
    	// Right Margin.
    	var rightMarginLayer = ALLayerColor.layerWithColor([0,0,0], 1, this.flankOffset + 1, UNISAFE_HEIGHT + this.bottomOffset*2, [ 0, 0 ]);
    	rightMarginLayer.setPosition(UNISAFE_WIDTH,0);
    	rightMarginLayer.setDepth(5000);
    	this.getNode().addChild(rightMarginLayer);

    	var _shade = ALLayerColor.layerWithColor(ccc3(0, 168, 236), 255/255, UNISAFE_WIDTH, UNISAFE_HEIGHT + this.bottomOffset*2, [ 0, 0 ]);
        _shade.setPosition(0,-this.bottomOffset);
        this._node.addChild(_shade);
     
        this._fcount = 0;
        this._itemsLoaded = 0;
        this._itemsToLoad = [];
        
        // BG
        var bg = TTSpriteFactory.spriteWithFile("friends_bg.png");
        bg.setPosition(0, +this.bottomOffset);
        this._node.addChild(bg);
        
        // LIST
        this._list = TTHList.initWithTarget(this.listClicked.bind(this));
        this._list.setItemSize(new Core.Size(ITEM_WIDTH, UNISAFE_HEIGHT));
        this._list._node.setPosition(UNISAFE_WIDTH/2, 0);
        this._list._node.setPosition(0, +this.bottomOffset);
        this._node.addChild(this._list._node);
        
        // TITLE BAR
        var titleBg = TTSpriteFactory.spriteWithFile_withAnchor("topslice.png", [ 0, 0 ]);
        titleBg.setPosition(0, 0 - this.bottomOffset);
        titleBg.setScale(UNISAFE_WIDTH / (titleBg.AL_getSize().getWidth() * 1.0), 1);
        this._node.addChild(titleBg);
        
        this._title = LabelConfigurer.createLabelWithString("FRIENDS", "silkscreen", FONT16, [ 0.5, 1 ], true);
        
		var _scale = this._title.getScale();
        this._title.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
        
        this._title.setPosition(UNISAFE_WIDTH / 2, titleBg.getPosition().getY() + 25);
        this._node.addChild(this._title);
        
        this.loadLeaderboard();
        
        this.setTouchTargetToScreenSize();
    },
        
    loadLeaderboard : function()
    {
        this._loadDlg = TTDialog.initWithMessage("\n\n\n\n\nLoading friends...", ",", null, null, null);
        TTDialogQueue.sharedQueue().addDialog(this._loadDlg);
        
        ScoreManager.getLeaderboards(function(results)
        {
            if (!results)
            {
                this._loadDlg && this._loadDlg.destroy();
                
                // Shows error dialog
                var dlg = TTDialog.initWithMessage("\n\n\n\nError retrieving Mobage friends.", ",continue", null, null, null);
                TTDialogQueue.sharedQueue().addDialog(dlg);
                
                return;
            }
            
            ScoreManager.getFriendScores("Score", function(scores)
            {
                this._loadDlg && this._loadDlg.destroy();
                
                if (scores)
                {
                    var session = Social.US.Session.getCurrentSession();
                    if (session)
                    {
                        var user = session.user();
                        scores.push({ 
                            'user' : user,
                            'score' : dict_size(TTScene.sharedScene()._playerData._floors)
                        });
                    }
                    
                    this._results = scores; 
                    for (var i = 0; i < this._results.length; i++)
                    {
                        // TOWER BASE
                        var bpbg = new GL2.Node();
                        this._list.addItem(bpbg);
                        this._itemsToLoad.push(bpbg);
                    }
                }
                else
                {   
                    // Shows error dialog
                    var dlg = TTDialog.initWithMessage("\n\n\n\nError retrieving Mobage friends.", ",continue", null, null, null);
                    TTDialogQueue.sharedQueue().addDialog(dlg);
                }
            }.bind(this));
        }.bind(this));
    },
    
    listClicked : function(index)
    {
        var i = index;
        al_trace("Friend list tapped index: " + i);
        
        var tappedPlayer = this._results[i];
        var origAlias = NSUserDefaults.standardUserDefaults().stringForKey("originalAlias");
        if (tappedPlayer.user.gamertag == origAlias)
        {
            return;
        }
        
        this._loadDlg = TTDialog.initWithMessage("\n\n\n\n\nLoading tower...", ",", null, null, null);
        TTDialogQueue.sharedQueue().addDialog(this._loadDlg);
        
        TTHud.sharedHud().setTitle(tappedPlayer.user.gamertag);
        
        al_trace("listClicked() : TTScene.sharedScene()._playerData.loadNeighbor() ");
        TTScene.sharedScene()._playerData.loadNeighbor(tappedPlayer.user, this._loadDlg);
        
        
         // TTT-46 fix 1/2., comment the line above, and put on TTGameData. loadRemotely, line 1024 
         //TTScene.sharedScene().runMenuLayer(null);

    },
    
    _ccTouchesBegan : function(touch, event)
    {
        return true;
    },
    
    _draw : function()
    {
        // check if there are tanks to load
        // load 3 at a time
        for ( var i = 0; i < 3; i++)
        {
            if (this._fcount > 0 && !this._list.isDragging() && this._itemsToLoad.length > 0)
            {
                al_trace("Loading item: " + this._itemsLoaded);
                
                // load an item
                var li = this._list.itemAtIndex(this._itemsLoaded);
                var result = this._results[this._itemsLoaded % this._results.length];
                
                var basePosition = UNISAFE_HEIGHT - 42;
                
                var player = result.user;
                var score = result.score;
                if (player)
                {
                	var nameParser = player.gamertag.length > 10 ? player.gamertag.substr(0,10)+"..." : player.gamertag;
                	                	
                    var nameLbl = LabelConfigurer.createLabelWithString(nameParser, "silkscreen", FONT14, [0.5, 1], true);
                    
            		var _scale = nameLbl.getScale();
                    nameLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
                    
                    nameLbl.setPosition(ITEM_WIDTH / 2, basePosition -10);
                    li.addChild(nameLbl);
                    
                    var flrLbl = LabelConfigurer.createLabelWithString("" + score, "silkscreen", FONT14, [0, 1], true);
                    
            		var _scale = flrLbl.getScale();
                    flrLbl.setScale(_scale.getX()*FONTSCALE14, _scale.getX()*FONTSCALE14);
                    
                    flrLbl.setPosition(ITEM_WIDTH / 2, basePosition + 4);
                    li.addChild(flrLbl);
                    
                    if (obtainGamerTag() == player.gamertag)
                    {
                        nameLbl.setColor(ccc3(255, 207, 92));
                        flrLbl.setColor(ccc3(255, 207, 92));
                    }
                    
                    var icon = TTSpriteFactory.spriteWithFile_withAnchor("friends_flooricon.png", [ 1, 1 ]);
                    icon.setPosition(flrLbl.getPosition().getX() - 2, flrLbl.getPosition().getY() + 1);
                    li.addChild(icon);
                    
                    var imageSize = DataPreloader._imageSizes["friends_floor.png"];
                    var towerBody = TTSpriteFactory.spriteWithFile_withTexture("friends_floor.png", [0, 0, 1, score], [0.5, 1], [1, 1], [imageSize[0], imageSize[1]]);
                    towerBody.getAnimation().setWrapMode(GL2.Animation.WrapMode.WrapUV);
                    towerBody.setPosition(ITEM_WIDTH / 2, basePosition - 29);
                    li.addChild(towerBody);
                    
                    var craneTop = TTSpriteFactory.spriteWithFile_withAnchor("friends_topper.png", [ 0.5, 1 ]);
                    craneTop.setPosition(towerBody.getPosition().getX(), towerBody.getPosition().getY() - score * 4);
                    li.addChild(craneTop);
                }
                
                this._itemsToLoad.splice(0, 1);
                this._itemsLoaded++;
            }
        }
        
        this._fcount++;
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/TTAchievementsListLayer'] = function(){var exports = $MODULE_REGISTRY['Code/TTAchievementsListLayer'] || {}; $MODULE_REGISTRY['Code/TTAchievementsListLayer'] = exports; var ACH_ITEM_WIDTH = UNISAFE_WIDTH;
var ACH_ITEM_HEIGHT = 60;

exports.TTAchievementsListLayer = BaseClass.subclass({
    classname : 'TTAchievementsListLayer',
    
    initialize: function(width,height) {
		this._list = null;
		this._itemsToLoad = [];
		this._itemsLoaded = 0;
		this._fcount = 0;
		this._titleLabel = null;
		
		this._earned = 0;
		
		this.getNode().setTouchable(true);
		
		//Bottom offset
    	this.bottomOffset =   (this.__size.getHeight() - height) / 2;
		var topScreenOffset = (height - this.__size.getHeight()) / 2;
		
		//Shade
		var shade = ALLayerColor.layerWithColor(ccc3(0,0,0),0.5, UNISAFE_WIDTH, UNISAFE_HEIGHT + this.bottomOffset*2);
		this._node.addChild(shade);
		shade.setPosition(UNISAFE_WIDTH/2,UNISAFE_HEIGHT/2);
		
		
		this._list = new TTList(width,height,this.listClicked.bind(this));
		this._list.setItemSize(new Core.Size(ACH_ITEM_WIDTH, ACH_ITEM_HEIGHT));
		this._list.getNode().setPosition(0,32 + topScreenOffset / 2);///////////////// margen arriba
		this.getNode().addChild(this._list.getNode());
		
		var achievements = DataPreloader._achievementsDescriptions; // DataPreloader._achievements;
		var numAwards = achievements.length;
		this._itemsLoaded = 0;
		
		for (var a in achievements) 
		{
			this._itemsToLoad.push(a);
			var nod = new GL2.Node();
			
			var li = TTSpriteFactory.spriteWithFile("achievement_bg11.png");
			nod.addChild(li);
			
			
			nod.setColor(180/255,180/255,180/255);
			
			this._list.addItem(nod);
		}
		
	
		var titleBg = TTSpriteFactory.spriteWithFile_withAnchor("topslice.png", [0, 0]);
		titleBg.setPosition(0, - this.bottomOffset);
        titleBg.setScale(UNISAFE_WIDTH / (titleBg.AL_getSize().getWidth()), 1);
        this.getNode().addChild(titleBg);
		
        this._titleLabel = LabelConfigurer.createLabelWithString("ACHIEVEMENTS", "silkscreen", FONT14, [0.5, 1], true);
		var _scale = this._titleLabel.getScale();
		this._titleLabel.setScale(_scale.getX()*FONTSCALE14*0.9, _scale.getX()*FONTSCALE14*0.9);
		this._titleLabel.setPosition(UNISAFE_WIDTH / 2 + UNISAFE_WIDTH/20, titleBg.getPosition().getY() + 25);
        this._node.addChild(this._titleLabel);
        
		// check if we have a saved position
		var yPos = NSUserDefaults.standardUserDefaults().objectForKey('awardsYpos');
		if (yPos) {
			this._list.getElementsNode().setPosition(this._list.getElementsNode().getPosition().getX(),yPos);
		}
				
	},
	
	listClicked: function(/*Number*/ index) {
		console.log("Catalog tapped index: ",index);
	},
	
	$init : function()
    {
        return new this(UNISAFE_WIDTH, UNISAFE_HEIGHT);
    },
    
	_draw: function() {
		// check if there are tanks to load
		// load 3 at a time
		for (var i=0; i < 3; i++)
			if (this._fcount > 0 && !this._list.isDragging() && this._itemsToLoad.length > 0) {
				
				//console.log("Loading item: " + this._itemsLoaded);

				// load an item
				var li = this._list.itemAtIndex(this._itemsLoaded);
				var awardInfo = this._itemsToLoad[0];
				if ( TTScene.sharedScene()._playerData._achievements[awardInfo]=='1') 
				{
					// place star
					var star = TTSpriteFactory.spriteWithFile_withAnchor("achievement_bg11_star.png");
					
					li.addChild(star);
					li.setColor(1,1,1);
					this._earned++;
				}
				else 
				{
					// XP reward
///					var xpStr = awardInfo.xp().toString();
///					var coinlbl = LabelConfigurer.createLabelWithString(xpStr+" xp","ArialRoundedMTBold",24,[0.5,1]);
///					coinlbl.setPosition(86,li.getAnimation().getFrame(0).getSize().getHeight()-38);
///					li.addChild(coinlbl);
				}
				
				
				for (var i in DataPreloader._achievementsDescriptions[awardInfo] )
				{
					//al_trace(">>>>>>>>>::> "+DataPreloader._achievementsDescriptions[awardInfo][i] + " i:"+i+".");
					var achName = DataPreloader._achievementsDescriptions[awardInfo]['Name'];
					var achDescription = DataPreloader._achievementsDescriptions[awardInfo]['Description'];
					break;
				}
				
		        
				// Achievement name
				var titleLbl = LabelConfigurer.createLabelWithString((this._itemsLoaded+1) +": " + achName/*DataPreloader._achievements[awardInfo]*/, "silkscreen", FONT14, [0, 0.5], true);
				titleLbl.setColor(255/255,255/255,255/255);
				titleLbl.setScale(0.4,0.4);
				titleLbl.setPosition(ACH_ITEM_WIDTH/4+0*10,ACH_ITEM_HEIGHT/4+3);
				li.addChild(titleLbl);
				
				// Achievement description
				var descriptionLbl = LabelConfigurer.createLabelWithString(achDescription, "silkscreen", FONT9, [0, 0.5], true);
				descriptionLbl.setSize(ACH_ITEM_WIDTH*1/0.4*0.6,ACH_ITEM_HEIGHT*1/0.4*0.6);
				descriptionLbl.setColor(1,1,1);
				descriptionLbl.setScale(0.4,0.4);
				descriptionLbl.setPosition(titleLbl._position._x,titleLbl._position._y+22);
				li.addChild(descriptionLbl);
				
				
				this._itemsToLoad.shift();
				this._itemsLoaded++;
				
				if (this._itemsToLoad.length == 0) {
					this._titleLabel.setText("Achievements ("+this._earned+"/"+this._itemsLoaded+")");
				}
			}
		
		this._fcount++;
	},
	
	_ccTouchesBegan : function(touchEvent) {
		return true;
	},
	
	destroy: function() {
		// save our place
		NSUserDefaults.standardUserDefaults().setObject(this._list.getElementsNode().getPosition().getY(),'awardsYpos');
		
		this._itemsToLoad.length = 0;
		this._itemsToLoad = null;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ALDebug'] = function(){var exports = $MODULE_REGISTRY['Code/ALDebug'] || {}; $MODULE_REGISTRY['Code/ALDebug'] = exports; 
/* 

The idea is to copy/paste this lines into console for debug propouses.
For example, if you want to set the elevator position, you have to :

	> // moves elevator 10px right, 20px down
	> x = elevator.getPosition().getX()
	> y = elevator.getPosition().getY()
	> elevator.setPosition(x + 10, y + 20) 
	



*/

exports.ALDebug = Core.Class.subclass({
    classname : "ALDebug",
    initialize : function () {

    	this._scene = TTScene.sharedScene();
    	this._dialogQueue = this._scene._dialogQueue;
    	this._towerLayer = this._scene._towerLayer; /* TTowerLayer : BaseClass */
    	this._noteLayer = this._towerLayer._noteLayer; /* TTowerLayer : BaseClass */
    	this._notes = this._noteLayer._children;
    	this._elevator = this._towerLayer._elevator; /* TTElevator : BaseClass */
    	this._floors = this._towerLayer._floors; /* ([] of) TTFloor : BaseClass */
    	this._playerData = this._scene._playerData; /* TTGameData : Core.Class */
    	this._pd_bits = this._playerData._bitizens; /* ({} of ) TTBitizenInfo : Core.Class  */
    },
	get_current_dialog : function () {return this._dialogQueue._node._children[1] ? this._dialogQueue._node._children[1]._AL_owner : null;},
	get_floor_bits : function(floor) {return this._floors[floor._storyInfo._story -1]._bitizens;},
	get_last_added_node : function (node) { var node_len = node._children.length;return node._children[node_len -1];},
	get_last_note : function() {var notes_len = this._notes.length;return this._notes[notes_len-1];},
	find_nodes_by_classname : function(classname, xnode) { 
		var n = xnode ? xnode : GL2.Root;
		var l = [];
		for (var i=0;i < (n._children.length);i++) {
			if (n._children[i]._AL_owner ? n._children[i]._AL_owner.classname == classname : n._children[i].classname == classname)
				l.push(n._children[i]);
			l = l.concat(this.find_nodes_by_classname(classname, n._children[i]));
			}
		return l;
	},
	get_abs_scale : function (xnode, xsc) {
		var sc = xsc ? xsc : new Core.Vector(1,1);
		if (xnode.classname != "Root") {
			sc = new Core.Vector(sc.getX()*xnode.getScale().getX(),sc.getY()*xnode.getScale().getY());
			var r = this.get_abs_scale(xnode._parent, sc);
			return r;
		}	
		
		return sc;
	},
	get_abs_position : function (xnode, xpos) {
		var pos = xpos ? xpos : new Core.Point(0,0);
		if (xnode.classname != "Root") {
			pos = new Core.Point(pos.getX()+xnode.getPosition().getX(), pos.getY()+xnode.getPosition().getY());
			var r = this.get_abs_position(xnode._parent, pos);
			return r;
		}	
		return pos;
	},
	set_abs_position : function (xnode, xpos) {
		var pos = xpos;
		var parent_abs_pos = this.get_abs_position(xnode._parent);
		xnode.setPosition(pos.getX() - parent_abs_pos.getX(), pos.getY() - parent_abs_pos.getY());
	},
	draw_anchor_as_square : function(xnode, xcolor, xscale) {
			   var color = xcolor ? xcolor : new Core.Color(1,0,0);
			   var scale = xscale ? xscale : new Core.Vector(5,5);
			   var sq = ALLayerColor.layerWithColor(color, 1, 1, 1, [ 0.5,0.5 ]);
			   sq.setDepth(Infinity);
			   var pxs = this.get_abs_scale(xnode).getX();
			   var pys = this.get_abs_scale(xnode).getY();
			   sq.setScale(scale.getX()/pxs, scale.getY()/pys);
			   sq._ALDebug = true;
//               var xylbl = LabelConfigurer.createLabelWithString("" + pxs + "," + pxs, "silkscreen", 7, [ 0.5, 0.5 ], true);
//               sq.addChild(xylbl);
	           xnode.addChild(sq);
	},
	
	hide_all : function(xnode)
	{
		var node = xnode ? xnode : GL2.Root;
		for (var i=0;i < node._children.length;i++) {
			this.hide_all(node._children[i]);
		}
		node.classname != "Root" ? node.setVisible(false) : false;
	},
	
	// FIXME: does not work ....  :(
	show_only : function(xnode, xnotfirsttime) { 
		var node = xnode;
		if (!xnotfirsttime) this.hide_all();
		if (node.classname != "Root") {
			this.show_only(node._parent, true);
			node.setVisible(true);
		}
	},
	show_nodes_anchor : function(xnode, xcolor, xscale) { 
		var n = xnode;
		for (var i=0;i < n._children.length;i++) {
			this.show_nodes_anchor(n._children[i]);
			}
		if (xcolor)
			this.draw_anchor_as_square(n, xcolor);	
		else if (xcolor && xscale)
			this.draw_anchor_as_square(n, xcolor, xscale);	
		else
			this.draw_anchor_as_square(n);	
	},
	
	hide_nodes_anchor : function(xnode) { 
		var n = xnode;
		for (var i=0;i < n._children.length;i++) {
			this.hide_nodes_anchor(n._children[i]);
			}
		if (n._ALDebug)
			n.AL_removeFromParentAndCleanup(true);
	},
	get_sprite_image : function (xsprite) {
		return xsprite._animation.getFrame(0).getImage();
	} 
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio/ActiveEffect'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio/ActiveEffect'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio/ActiveEffect'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.ActiveEffect = Core.Class.subclass(
/** @lends Audio.ActiveEffect.prototype */
{
	/**
	 * @class The <code>ActiveEffect</code> class constructs objects that control 
	 * the reproduction of an audio effect. Audio effects in Mobage applications are captured as <code>{@link Audio.Effect}</code> objects. 
	 * <code>{@link Audio.Effect}</code> objects handle and load data for an audio effect into memory. 
	 * This seperation allows applications to manage effect data independently of effect reproduction.
	 * <br><br>
	 * <b>Note:</b> You can only specify <code>{@link Audio.Effect}</code> objects to reproduce at instantiation.
	 * 
	 * @example
	 *
	 *   var effect = new Audio.Effect('some_effect.wav');
	 *   var activeEffect = new Audio.ActiveEffect(effect);
	 *   activeEffect.play();
	 * @constructs The default constructor. 	 
	 * @augments Core.Class
	 * @param {Audio.Effect} effect The <code>{@link Audio.Effect}</code> that this <code>ActiveEffect</code> object plays.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function(effect)
	{
		this._volume  = 1.0;
		this._loops   = false;
		this._playing = false;
		this._paused  = false;

		this._playCompleteEmitter = new Core.MessageEmitter();

		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._setEffect(effect);
	},
	
	/**
	 * Destroy this instance and releases resources on the backend.
	 * <b>Note:</b> This call does not automatically destroy the associated <code>{@link Audio.Effect}</code>.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		this.stop();
		this._effect = null;
		this._playCompleteEmitter.destroy();
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},
	
	/**
	 * Return the volume level for the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * @returns {Number} The current volume level.
	 * @see Audio.ActiveEffect#setVolume
	 * @status iOS, Android, Test
	 */
	getVolume: function()
	{
		return this._volume;
	},
	
	/**
	 * Set the volume level for the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * Calling this changes the volume even if an application is in the middle of reproducing an <code>{@link Audio.Effect}</code> object.
	 * The new volume level applies to any subsequent reproductions of the <code>{@link Audio.Effect}</code> object.
	 * @example Audio.ActiveEffect.setVolume(0.5);
	 * @param {Number} [volume=1] The new volume level. Supported values range between <code>(0-1)</code>. 
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Audio.ActiveEffect#getVolume
	 * @status iOS, Android
	 */
	setVolume: function(volume)
	{
		if (volume < 0.0) volume = 0.0;
		if (volume > 1.0) volume = 1.0;

		this._volume = volume;
		this._setVolumeSendGen(volume);
		return this;
	},
	
	/**
	 * Return the loop status for the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * @returns {Boolean} Returns <code>true</code> if looping is enabled.
	 * @see Audio.ActiveEffect#setLoops
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getLoops: function()
	{
		return this._loops;
	},
	
	/**
	 * Set the loop state for the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * A looped effect wraps seamlessly from begining to end.
	 * @example Audio.ActiveEffect.setLoops(true);
	 * @param {Boolean} loops Set as <code>true</code> to enable looping.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Audio.ActiveEffect#getLoops
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	setLoops: function(loops)
	{
		this._loops = loops;
		this._setLoopsSendGen(loops);
		return this;
	},
	
	/**
	 * Return the <code>Play Complete</code> emitter for the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * The <code>Play Complete</code> emitter notifies applications when reproduction of an <code>{@link Audio.Effect}</code> is complete.<br><br>
	 * <b>Notes:</b>
	 * <ul>
	 *   <li>Any <code>{@link Audio.Effect}</code> object that does not loop uses the <code>Play Complete</code> emitter. </li>
	 * </ul>
	 * @returns {Core.MessageEmitter} The current state of the <code>Play Complete</code> emitter.
	 * @status iOS
	 */
	getPlayCompleteEmitter: function()
	{
		return this._playCompleteEmitter;
	},
	
	/**
	 * Return the play status of the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * @returns {Boolean} Returns <code>true</code> if this <code>ActiveEffect</code> is reproducing an <code>{@link Audio.Effect}</code>.
	 * @see Audio.ActiveEffect#play
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getIsPlaying: function()
	{
		return this._playing;
	},
	
	/**
	 * Return the pause status of the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * @returns {Boolean} Returns <code>true</code> if this <code>(@link Audio.Effect}</code> is in a paused state.
	 * @see Audio.ActiveEffect#pause
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getIsPaused: function()
	{
		return this._paused;
	},
	
	/**
	 * Begin reproducing an <code>{@link Audio.Effect}</code>.
	 * <ul>
	 * <li>If this <code>{@link Audio.Effect}</code> is new or in a stopped state,
	 * reproduction starts at the beginning.</li>
	 * <li>If this <code>{@link Audio.Effect}</code> is in a paused state, reproduction resumes from the previous position.</li>
	 * <li>If this <code>{@link Audio.Effect}</code> is playing, this call does nothing.</li>
	 * </ul>
	 * @see Audio.ActiveEffect#getIsPlaying
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	play: function()
	{
		this._playing = true;
		this._paused  = false;
		this._playSendGen( );
	},
	
	/**
	 * Pause reproduction of an <code>{@link Audio.Effect}</code>.
	 * <ul>
	 * <li>If this <code>ActiveEffect</code> is in the process of reproducing an <code>{@link Audio.Effect}</code>, this call pauses reproduction.</li>
	 * <li>If the <code>{@link Audio.Effect}</code> is in a stopped or paused state, this call does nothing.</li>
	 * </ul>
	 * <b>Note:</b> Calling this does not trigger the <code>Play Complete</code> emitter.
	 * @see Audio.ActiveEffect#getIsPaused
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	pause: function()
	{
		this._playing = false;
		this._paused  = true;
		this._pauseSendGen( );
	},
	
	/**
	 * Stop reprodution of an <code>{@link Audio.Effect}</code> object.
	 * <ul>
	 * <li>If this <code>ActiveEffect</code> is currently reproducing an <code>{@link Audio.Effect}</code> or the <code>{@link Audio.Effect}</code> is in a paused state, this call stops reproduction.</li>
	 * <li>If the <code>{@link Audio.Effect}</code> is in a stopped state, this call does nothing.</li>
	 * </ul>
	 * <b>Note:</b> Calling <code>stop()</code> does not trigger the <code>Play Complete</code> emitter.
	 * @status iOS, Android, Test, iOSTested, AndroidTested	 
	 */
	stop: function()
	{
		this._playing = false;
		this._paused  = false;
		this._stopSendGen( );
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 328
	// Method create = -1
	// Method destroy = 2
	// Method setVolume = 3
	// Method setLoops = 4
	// Method play = 5
	// Method pause = 6
	// Method stop = 7
	// Method setEffect = 8
	// Method playComplete = 9
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 9:
					instance._playCompleteRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in ActiveEffect._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in ActiveEffect._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[328] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_playCompleteRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in ActiveEffect.playComplete from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":328,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":328,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setVolumeSendGen: function( volume )
	{
		Core.Proc.appendToCommandString( ":328,3," + this.__objectRegistryId + "," + volume  );
	},
	
	/** @private */
	_setLoopsSendGen: function( loops )
	{
		Core.Proc.appendToCommandString( ":328,4," + this.__objectRegistryId + "," + ( loops ? 1 : 0 )  );
	},
	
	/** @private */
	_playSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":328,5," + this.__objectRegistryId );
	},
	
	/** @private */
	_pauseSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":328,6," + this.__objectRegistryId );
	},
	
	/** @private */
	_stopSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":328,7," + this.__objectRegistryId );
	},
	
	/** @private */
	_setEffectSendGen: function( effectId )
	{
		Core.Proc.appendToCommandString( ":328,8," + this.__objectRegistryId + "," + effectId  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setVolume: function( volume ) {}
	
	// setLoops: function( loops ) {}
	
	// play: function(  ) {}
	
	// pause: function(  ) {}
	
	// stop: function(  ) {}
	
	// setEffect: function( effectId ) {}
	
	// _playCompleteRecv: function( cmd ) {}

// {{/Wg Generated Code}}

	_setEffect: function(effect)
	{
		this._effect  = effect;
		this._setEffectSendGen(this._effect.__objectRegistryId);
		return this;
	},

	_playCompleteRecv: function( cmd )
	{
		var msg = {};
		if(!this._playCompleteRecvGen(cmd, msg))
			return;

		this._playing = false;
		this._paused  = false;

		this._playCompleteEmitter.emit(this);
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio/Effect'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio/Effect'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio/Effect'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Effect = Core.Class.subclass(
/** @lends Audio.Effect.prototype */
{
	/**
	 * @class The <code>Effect</code> class constructs objects for handling audio resources that comprise an audio effect.
	 * Instantiating these objects allocates resources on the backend.
	 * After creating an <code>Effect</code> object, applications can control reproduction through an <code>{@link Audio.ActiveEffect}</code> object.<br><br>
	 * @example
	 * var effect = new Audio.Effect('Content/explosion.wav');
	 * @constructs The default constructor.<br><br>
	 * The following code is an example of constructing a new <code>Effect</code> object.
	 * @augments Core.Class
	 * @param {String} path A directory path that points to the audio file to load.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function(path)
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._setPath(path);
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},
	
	/**
	 * Set a directory path to the audio file resource for this <code>Effect</code> object.
	 * @param {String} path The new directory path.
	 * @returns Calls to <code>setPath()</code> return <code>this</code> to support method invocation chaining.
	 */
	_setPath: function(path)
	{
		this._path = path;
		this._setPathSendGen(path);
		return this;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 326
	// Method create = -1
	// Method destroy = 2
	// Method setPath = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Effect._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Effect._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[326] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":326,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":326,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setPathSendGen: function( path )
	{
		Core.Proc.appendToCommandString( ":326,3," + this.__objectRegistryId + "," + Core.Base64.encode( path )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setPath: function( path ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio/Device'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio/Device'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio/Device'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Device = Core.Class.singleton(
/** @lends Audio.Device.prototype */
{
	classname: 'Device',

	/**
	 * @class The <code>Device</code> class constructs a singleton object that contains audio device properties.
	 * Applications can use <codeDevice</code> objects to control global audio effects volume 
	 * and reproduce detached audio effects.
	 * <br><br>
	 * <b>Note:</b> An application should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 */
	 
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._volume = undefined; // default value

		var KeyValueCache = require('NGCore/Client/Storage/KeyValue').KeyValueCache;
		var initialValues = KeyValueCache.global("Audio.Device.InitialValues");

		var self = this;
		initialValues.getItem("effectsVolume", function(error, value) {
			self._volume = parseFloat(value);
		});
	},
	
	/**
	 * Return the global sound effects volume for this <code>Device</code> object.
	 * @returns {Number} The current global sound effects volume.
	 * @see Audio.Device#setEffectsVolume	 
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getEffectsVolume: function()
	{
		return this._volume;
	},
	
	/**
	 * Set the global sound effects volume for this <code>Device</code> object.
	 * Volume for each active effect multiplies
	 * by this value to produce a new volume level. 
	 * For example, if the global sound effects volume is set to 0.5, each active effect will play at half the volume set on the effect.
	 * @param {Number} [effectsVolume=1] The new volume for global sound effects. 
	 * Supported values range between <code>(0-1)</code>. 
	 * @example Audio.Device.setEffectsVolume(0.5);
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Audio.Device#getEffectsVolume
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	setEffectsVolume: function(effectsVolume)
	{
		if (effectsVolume < 0.0) effectsVolume = 0.0;
		if (effectsVolume > 1.0) effectsVolume = 1.0;

		this._volume = effectsVolume;
		this._setEffectsVolumeSendGen(effectsVolume);
		return this;
	},
	
	/**
	 * Play an audio effect in a way that is completely detached from upstream or downstream processing.
	 * Using this call is a simple, high-level way to reproduce an audio effect.<br><br>
	 * The specified audio effect is only reproduced once.
	 * There is no control over the effect volume or effect playback.
	 * Resource allocation automatically occurs on the backend when playback begins. Resources are automatically released when playback ends.	 
	 * The following code is an example of a <code>playDetached()</code> call.
	 * @example
	 * Audio.Device.playDetached('Content/explosion.wav');
	 * @param {String} path A relative directory path to the audio file.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	playDetached: function(path)
	{
		this._playDetachedSendGen( path );
		return this;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 327
	// Method create = -1
	// Method setEffectsVolume = 2
	// Method playDetached = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Device._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Device._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[327] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":327,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_setEffectsVolumeSendGen: function( effectsVolume )
	{
		Core.Proc.appendToCommandString( ":327,2," + this.__objectRegistryId + "," + effectsVolume  );
	},
	
	/** @private */
	_playDetachedSendGen: function( path )
	{
		Core.Proc.appendToCommandString( ":327,3," + this.__objectRegistryId + "," + Core.Base64.encode( path )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// setEffectsVolume: function( effectsVolume ) {}
	
	// playDetached: function( path ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio/Music'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio/Music'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio/Music'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Music = Core.Class.singleton(
/** @lends Audio.Music.prototype */
{
	classname: 'Music',

	/**
	 * @class The <code>Music</code> class constructs a singleton object that provides control over reproduction
	 * of application background music.
	 * This object is constructed independently of <code>Device</code> objects because many devices
	 * already provide hardware-accelerated streaming and decode
	 * for a single background music track. Some
	 * devices gracefully mute a background music track
	 * if the user is playing a music track from their own library.
	 * <br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @example 
	 * var background = new Audio.Music('Content/music.mp3');
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._path    = null;
		this._playing = false;
		this._paused  = false;
		this._volume  = 1.0;
	},
	
	/**
	 * Return the directory path to the background music file used as a resource for this <code>Music</code> object.
	 * @returns {String} The directory path to a music file.
	 * @see Audio.Music#setPath
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getPath: function()
	{
		return this._path;
	},
	
	/**
	 * Set the directory path for the background music file that this <code>Music</code> object loads.<br><br>
	 * <b>Note:</b> If the application is reproducing music when this is called, reproduction will stop.
	 * The application must call <code>play()</code> again to start reproduction of the new resource.<br><br>
	 * The code in the following example sets a directory path to a music resource and plays that resource.
	 * @example
	 * Audio.Music.setPath('Content/music.mp3');
	 * Audio.Music.play();
	 *
	 * @param {string} path The new directory path to a music file.
	 * @see Audio.Music#getPath,
	 * @see Audio.Music#play
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	setPath: function(path)
	{
		this._path = path;
		this._setPathSendGen(path);
	},
	
	/**
	 * Return the volume level used for reproduction of this <code>Music</code> object.
	 * @returns {Number} The current volume level.
	 * @see Audio.Music#setVolume
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getVolume: function()
	{
		return this._volume;
	},
	
	/**
	 * Set the volume level used for reproduction of this <code>Music</code> object.
	 * This call instantly modifies the background music volume level.
	 * Any subsequent reproductions of background music will play at the specified volume.
	 * @example Audio.Music.setVolume(0.5);
	 * @param {Number} [volume=1] The new volume. Supported values range between <code>(0-1)</code>.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Audio.Music#getVolume
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	setVolume: function(volume)
	{
		if (volume < 0.0) volume = 0.0;
		if (volume > 1.0) volume = 1.0;

		this._volume = volume;
		this._setVolumeSendGen(volume);
		return this;
	},
	
	/**
	 * Return the playback state of this <code>Music</code> object. 
	 * @returns {Boolean} Returns <code>true</code> if an application is reproducing background music.
	 * @see Audio.Music#play
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getIsPlaying: function()
	{
		return this._playing;
	},
	
	/**
	 * Return the pause state of this <code>Music</code> object.
	 * @returns {Boolean} Returns <code>true</code> if an application is reproducing background music.
	 * @see Audio.Music#pause
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getIsPaused: function()
	{
		return this._paused;
	},
	
	/**
	 * Begin reproduction of this <code>Music</code> object.
	 * <ul>	
	 * <li>If this <code>Music</code> object is a new background music track, or the application has stopped the current background music track, 
	 * this call begins reproduction from the beginning.</li>
	 * <li>If the background music track is in a paused state, this call resumes reproduction from the previous position.</li>
	 * <li>If the background music track is currently playing, this call does nothing.</li>
	 * </ul>
	 * @see Audio.Music#getIsPlaying,
	 * @see Audio.Music#pause,
	 * @see Audio.Music#stop
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	play: function()
	{
		this._playing = true;
		this._paused  = false;
		this._playSendGen( );
	},
	
	/**
	 * Pause reproduction of this <code>Music</code> object.
	 * <ul>
	 * <li>If an application is currently reproducing a background music track, this call pauses reproduction.</li>
	 * <li>If the background music track is in a paused or stopped state, this call does nothing.</li>
	 * </ul>
	 * @see Audio.Music#getIsPaused
	 * @see Audio.Music#play,
	 * @see Audio.Music#stop
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	pause: function()
	{
		this._playing = false;
		this._paused  = true;
		this._pauseSendGen( );
	},
	
	/**
	 * Stop reproduction of this <code>Music</code> object.
	 * <ul>
	 * <li>If the background music track is playing or in a paused state, this call stops playback.</li>
	 * <li>If the background music track is in a stopped state, this call does nothing.</li>
	 * </ul>
	 * @see Audio.Music#play,
	 * @see Audio.Music#pause
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	stop: function()
	{
		this._playing = false;
		this._paused  = false;
		this._stopSendGen( );
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 329
	// Method create = -1
	// Method destroy = 2
	// Method setPath = 3
	// Method setVolume = 4
	// Method play = 5
	// Method pause = 6
	// Method stop = 7
	// Method playComplete = 8
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 8:
					instance._playCompleteRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Music._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Music._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[329] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_playCompleteRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in Music.playComplete from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":329,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":329,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setPathSendGen: function( path )
	{
		Core.Proc.appendToCommandString( ":329,3," + this.__objectRegistryId + "," + Core.Base64.encode( path )  );
	},
	
	/** @private */
	_setVolumeSendGen: function( volume )
	{
		Core.Proc.appendToCommandString( ":329,4," + this.__objectRegistryId + "," + volume  );
	},
	
	/** @private */
	_playSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":329,5," + this.__objectRegistryId );
	},
	
	/** @private */
	_pauseSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":329,6," + this.__objectRegistryId );
	},
	
	/** @private */
	_stopSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":329,7," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setPath: function( path ) {}
	
	// setVolume: function( volume ) {}
	
	// play: function(  ) {}
	
	// pause: function(  ) {}
	
	// stop: function(  ) {}
	
	// _playCompleteRecv: function( cmd ) {}

// {{/Wg Generated Code}}

	_playCompleteRecv: function( cmd )
	{
		var msg = {};
		if(!this._playCompleteRecvGen(cmd, msg))
			return;

		this._playing = false;
		this._paused  = false;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Animation'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Animation'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Animation'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Animation = Core.Class.subclass(
/** @lends GL2.Animation.prototype */
{
	classname: 'Animation',
    
	/**
	 * @class The <code>Animation</code> class constructs objects that define application animations. Animations aggregate and control 
	 * the instantiation of <code>Frame</code> objects for manipulation of <code>{@link GL2.Sprite}</code> and
	 * <code>{@link GL2.Primitive}</code> objects. Each <code>Frame</code> object defines a duration and an image display area. 
	 * <code>Frame</code> objects also include a pre-transform 
	 * offset that define the rotation and scale of sprite images. 
	 * @constructs The default constructor.
	 * @augments Core.Class
	 */
    initialize: function()
    {
		Core.ObjectRegistry.register(this);
		
        this._wrapMode = this.WrapMode.WrapNone;
        this._blendEnabled = true;
        this._blendMode = this.BlendMode.Alpha;
        this._filteringEnabled = true;
		this._loopingEnabled = true;
		this._totalDuration = 0;
		this._frames = [];
		
		this._createSendGen(this.__objectRegistryId);
    },

	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},
	
	/**
	 * Retrieve the specified texture wrap mode for this <code>Animation</code>.
	 * @returns {GL2.Animation#WrapMode} The current texture wrap mode.
	 * @see GL2.Animation#setWrapMode
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getWrapMode: function()
	{
		return this._wrapMode;
	},
	
	/**
	 * Retrieve the alpha blending state for this <code>Animation</code>.
	 * @returns {Boolean} Returns <code>true</code> if alpha blending is enabled. Returns <code>false</code> in all other cases.
	 * @see GL2.Animation#setBlendEnabled
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getBlendEnabled: function()
	{
		return this._blendEnabled;
	},
	
	/**
	 * Retrieve the filtering state for this <code>Animation</code>. 
	 * @returns {Boolean} Returns <code>true</code> if filtering is enabled. Returns <code>false</code> in all other cases.
	 * @see GL2.Animation#setFilteringEnabled
	 */
	getFilteringEnabled: function()
	{
		return this._filteringEnabled;
	},
	
	/**
	 * Retrieve the looping state of this <code>Animation</code>.
	 * @returns {Boolean} Returns <code>true</code> if looping is enabled. Returns <code>false</code> in all other cases.
	 * @see GL2.Animation#setLoopingEnabled
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLoopingEnabled: function()
	{
		return this._loopingEnabled;
	},
	
	/**
	 * Retrieve the total duration of this <code>Animation</code> in milliseconds.
	 * @returns {Number} The current duration. 
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTotalDuration: function()
	{
		return this._totalDuration;
	},
	
	/**
	 * Retrieve the total number of frames in this <code>Animation</code>.
	 * @returns {Number} The current number of frames. 
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFrameCount: function()
	{
		return this._frames.length;
	},
	
	/**
	 * Retrieve a frame at the specified index for this <code>Animation</code>.
	 * @param {Number} index The specified index.
	 * @returns {GL2.Animation.Frame} The current frame at the specified index.
	 * @see GL2.Animation#setFrame
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFrame: function(index)
	{
		return this._frames[index];
	},
    
    /**
	 * Apply a wrap mode to frame textures for this <code>Animation</code>.
	 * @param {GL2.Animation#WrapMode} [wrapMode=0] The new texture wrap mode.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Animation#getWrapMode
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */						
    setWrapMode: function(wrapMode)
	{
		this._wrapMode = wrapMode;
		
		this._setWrapModeSendGen(wrapMode);
		
		return this;
	},
    
    /**
	 * Set the alpha blending state for this <code>Animation</code>. 
	 * <br><br>
	 * <b>Note:</b> You can improve performance for animations with completely opaque frames by disabling alpha blending.
	 * @param {Boolean} [blendEnabled=true] Set as <code>true</code> to enable alpha blending.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Animation#getBlendEnabled
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setBlendEnabled: function(blendEnabled)
	{
		this._blendEnabled = blendEnabled;
		
		this._setBlendEnabledSendGen(blendEnabled);
		
		return this;
	},
	
	/**
	 * Set the alpha blend mode.
	 * @see GL2.Animation#setBlendEnabled
	 * @status Android,AndroidTested
	 */
	setBlendMode: function(blendMode)
	{
		this._blendMode = blendMode;
		
		this._setBlendModeSendGen(blendMode);
		
		return this;
	},
	
	getBlendMode: function()
	{
		return this._blendMode;
	},
	
    /**
	 * Set the filtering state for this <code>Animation</code>.
	 * <br><br>
	 * @param {Boolean} [filteringEnabled=false] Set as <code>true</code> to enable filtering. 
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Animation#getFilteringEnabled
	 */
    setFilteringEnabled: function(filteringEnabled)
	{
		this._filteringEnabled = filteringEnabled;
		
		this._setFilteringEnabledSendGen(filteringEnabled);
		
		return this;
	},
    
    /**
	 * Set the looping state for this <code>Animation</code>.
	 * @param {Boolean} [loopingEnabled=false] Set as <code>true</code> to enable animation looping.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Animation#getLoopingEnabled
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setLoopingEnabled: function(loopingEnabled)
	{
		this._loopingEnabled = loopingEnabled;
		
		this._setLoopingEnabledSendGen(loopingEnabled);
		
		return this;
	},
    
    /**
	 * Add a frame to the end of this <code>Animation</code>.<br><br>
	 * <pre class="code"><font size="2">var animation = new GL2.Animation();
	 * animation.pushFrame(new GL2.Animation.Frame('Content/tank.png', 50, [64, 64], [0.5, 0.5], [0/5, 0, 1/5, 1]));</font></pre>
	 * Calling <code>pushFrame()</code> is equivalent to calling <code>spliceFrames()</code> in the following way: 
	 * <pre class="code"><font size="2">animation.spliceFrames(animation.getFrameCount(), 0, frame);</font></pre>
	 * @param {GL2.Animation.Frame} frame The frame to add.
	 * @see GL2.Animation#spliceFrames
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    pushFrame: function(frame)
	{
		return this.spliceFrames(this._frames.length, 0, frame);
	},
    
    /**
	 * Replace the frame at index <i>i</i>.<br><br>
	 * Calling <code>setFrame()</code> is equivalent to calling <code>spliceFrames()</code> in the following way: 
	 * @example animation.spliceFrames(i, 1, frame)
	 * @param {Number} i Index of the frame to replace.
	 * @param {GL2.Animation.Frame} frame The frame to insert.
	 * @see GL2.Animation#getFrame,
	 * @see GL2.Animation#spliceFrames
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setFrame: function(i, frame)
	{
		return this.spliceFrames(i, 1, frame);
	},
    
    /**
	 * Remove a specific number of frames from this <code>Animation</code> and replace them with specified frames.
	 * <br><br>
	 * <b>Note:</b> This method accepts multiple parameters. The third parameter and beyond define all
	 * <code>Frames</code> to use for replacement.<br><br>
	 * The following example passes in three frames to a <code>spliceFrames()</code> call.
	 * @example animation.spliceFrames(0, 0, frame1, frame2, frame3).
	 * @param {Number} start The index of the first frame to remove.
	 * @param {Number} len The total number of frames to remove.
	 * @param {GL2.Animation.Frame} frames The frames to insert. 
	 * <br><br>
	 * <b>Note:</b> This parameter accepts multiple values.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    spliceFrames: function(start, len, frames)
	{
		var i;
		var frameCount = arguments.length-2;
		var frame;

		// Determine if we should use the v2 version of the messsage, which supports renderTargets.
		// This is so that new javaScript that doesn't use renderTargets will still work with an old binary.
		var useV2 = false;
		for (i = 0; i < frameCount; ++i) {
			frame = arguments[i+2];
			if (frame.getImage().classname === 'RenderTarget')
				useV2 = true;
		}

		// Decrement from total duration.
		for (var i=start; i < start + len; ++i) {
			this._totalDuration -= this._frames[i].getDuration();
		}
		
		this._frames.splice.apply(this._frames, arguments);

		if (useV2) {
			this._spliceFrames2SendGen(start, len, frameCount);
		} else {
			this._spliceFramesSendGen(start, len, frameCount);
		}
		
		for (i = 0; i < frameCount; ++i)
		{
			frame = arguments[i+2];
			var duration = frame.getDuration();
			var size = frame.getSize();
			var anchor = frame.getAnchor();
			var uvs = frame.getUVs();
			var uvOrigin = uvs.getOrigin();
			var uvSize = uvs.getSize();
			var image = frame.getImage();

			// if image is a renderTarget
			var renderTargetID = 0;
			if (image.classname === 'RenderTarget') {
				renderTargetID = image.__objectRegistryId;
				image = '';
			}

			if (useV2) {
				this._frame2SendGen(image,
									renderTargetID,
									duration,
									size.getWidth(),
									size.getHeight(),
									anchor.getX(),
									anchor.getY(),
									uvOrigin.getX(),
									uvOrigin.getY(),
									uvSize.getWidth(),
									uvSize.getHeight());
			} else {
				this._frameSendGen(image,
								   duration,
								   size.getWidth(),
								   size.getHeight(),
								   anchor.getX(),
								   anchor.getY(),
								   uvOrigin.getX(),
								   uvOrigin.getY(),
								   uvSize.getWidth(),
								   uvSize.getHeight());
			}
			this._totalDuration += duration;
		}
		
		return this;
	},
	
	$Frame: Core.Class.subclass(
	/** @lends GL2.Animation.Frame.prototype */
	{
		classname: 'Frame',
		
		/**
		 * @class <code>Frame</code> objects define a path to an image and any properties that support the image as
		 * a single frame in an animation.
		 * @constructs The default constructor. 
		 * @param {String|GL2.RenderTarget} image The directory path to an image, or an instance of GL2.RenderTarget.
		 * @param {Number} duration The time duration of the frame in milliseconds.
		 * @param {Core.Size} size The size of the frame in pixels.
		 * @param {Core.Point} anchor The offset within the frame used for scaling and rotation.
		 * @param {Core.Rect} uvs The image region to use for the frame. The default value is <code>[0,0,1,1]</code> (the entire image) 
		 * with a start coordinate of <code>(0,0)</code> and a size of <code>(1,1)</code>.<br><br> 
		 * <b>Example:</b> To select the lower left region of an image with nine distinct frames (three horizontally, three vertically), 
		 * you would specify <code>[0, 0.66, 0.33, 0.33]</code>. The start coordinate is <code>(0, 0.66)</code>, 
		 * which is the left edge of the image and 2/3rds down. 
		 * The size is <code>(0.33, 0.33)</code> which is a third of the image in each <i>x</i> and <i>y</i> direction.
		 * @see GL2.Animation
		 * @default [0,0,1,1] (the entire image)
		 * @augments Core.Class
		 */
		initialize: function(image, duration, size, anchor, uvs)
		{
			this._image     = image;
			this._duration  = duration || 0;
			this._size   = new Core.Size(size);
			
			if(anchor)
				this._anchor = new Core.Point(anchor);
			else
				this._anchor = new Core.Point(0.5, 0.5);
			
			if(uvs)
				this._uvs = new Core.Rect(uvs);
			else
				this._uvs = new Core.Rect(0, 0, 1, 1);
		},

		/**
		 * Retrieve the image directory path or the renderTarget referenced by this <code>Frame</code>.
		 * @returns {String|GL2.RenderTarget} The current directory path to the image, or a GL2.RenderTarget instance.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getImage:    function()
		{
			return this._image;
		},
		
		/**
		 * Retrieve time duration in milliseconds for this <code>Frame</code>.
		 * @returns {Number} The current time duration for the frame.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getDuration:  function()
		{
			return this._duration;
		},

		/**
		 * Retrieve the pixel size of this <code>Frame</code>.
		 * @returns {Core.Size} The current frame size in pixels.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getSize:    function()
		{
			return this._size;
		},

		/**
		 * Retrieve the offset used for scaling and rotation from within this <code>Frame</code>.
		 * @returns {Core.Point} The current frame offset.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getAnchor:  function()
		{
			return this._anchor;
		},

		/**
		 * Retrieve the texture rectangle for this <code>Frame</code> in UV coordinates.
		 * @returns {Core.Rect} The current UV bounds of the frame within the texture.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getUVs:    function()
		{
			return this._uvs;
		},
	}),
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration for UV wrapping modes.
	 * @namespace
	 */
	WrapMode:
	{ 
		/** Clamp in both U and V. */
		WrapNone: 0,
		/** Wrap in U, clamp in V. */
		WrapU: 1,
		/** Wrap in V, clamp in U. */
		WrapV: 2,
		/** Wrap in both U and V. */
		WrapUV: 3,
	},
	
	/** 
	 * Enumeration for Blend modes.
	 * @namespace
	 */
	BlendMode:
	{ 
		/** blend func: (src alpha, 1 - src alpha). */
		Alpha: 1,
		/** blend func: (src alpha, 1). */
		Add: 2,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 306
	// Method create = -1
	// Method destroy = 2
	// Method setWrapMode = 3
	// Method setBlendEnabled = 4
	// Method setLoopingEnabled = 5
	// Method spliceFrames = 6
	// Method frame = 7
	// Method setFilteringEnabled = 8
	// Method spliceFrames2 = 9
	// Method frame2 = 10
	// Method setBlendMode = 11
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Animation._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Animation._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[306] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":306,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":306,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setWrapModeSendGen: function( wrapMode )
	{
		Core.Proc.appendToCommandString( ":306,3," + this.__objectRegistryId + "," + wrapMode  );
	},
	
	/** @private */
	_setBlendEnabledSendGen: function( blendEnabled )
	{
		Core.Proc.appendToCommandString( ":306,4," + this.__objectRegistryId + "," + ( blendEnabled ? 1 : 0 )  );
	},
	
	/** @private */
	_setLoopingEnabledSendGen: function( loopingEnabled )
	{
		Core.Proc.appendToCommandString( ":306,5," + this.__objectRegistryId + "," + ( loopingEnabled ? 1 : 0 )  );
	},
	
	/** @private */
	_spliceFramesSendGen: function( start, len, frameCount )
	{
		Core.Proc.appendToCommandString( ":306,6," + this.__objectRegistryId + "," + start + "," + len + "," + frameCount  );
	},
	
	/** @private */
	_frameSendGen: function( image, duration, width, height, anchorX, anchorY, startU, startV, sizeU, sizeV )
	{
		Core.Proc.appendToCommandString( "," + Core.Base64.encode( image ) + "," + duration + "," + width + "," + height + "," + anchorX + "," + anchorY + "," + startU + "," + startV + "," + sizeU + "," + sizeV  );
	},
	
	/** @private */
	_setFilteringEnabledSendGen: function( filteringEnabled )
	{
		Core.Proc.appendToCommandString( ":306,8," + this.__objectRegistryId + "," + ( filteringEnabled ? 1 : 0 )  );
	},
	
	/** @private */
	_spliceFrames2SendGen: function( start, len, frameCount )
	{
		Core.Proc.appendToCommandString( ":306,9," + this.__objectRegistryId + "," + start + "," + len + "," + frameCount  );
	},
	
	/** @private */
	_frame2SendGen: function( image, renderTargetID, duration, width, height, anchorX, anchorY, startU, startV, sizeU, sizeV )
	{
		Core.Proc.appendToCommandString( "," + Core.Base64.encode( image ) + "," + renderTargetID + "," + duration + "," + width + "," + height + "," + anchorX + "," + anchorY + "," + startU + "," + startV + "," + sizeU + "," + sizeV  );
	},
	
	/** @private */
	_setBlendModeSendGen: function( blendMode )
	{
		Core.Proc.appendToCommandString( ":306,11," + this.__objectRegistryId + "," + blendMode  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setWrapMode: function( wrapMode ) {}
	
	// setBlendEnabled: function( blendEnabled ) {}
	
	// setLoopingEnabled: function( loopingEnabled ) {}
	
	// spliceFrames: function( start, len, frameCount ) {}
	
	// frame: function( image, duration, width, height, anchorX, anchorY, startU, startV, sizeU, sizeV ) {}
	
	// setFilteringEnabled: function( filteringEnabled ) {}
	
	// spliceFrames2: function( start, len, frameCount ) {}
	
	// frame2: function( image, renderTargetID, duration, width, height, anchorX, anchorY, startU, startV, sizeU, sizeV ) {}
	
	// setBlendMode: function( blendMode ) {}
	

// {{/Wg Generated Code}}
});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Node'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Node'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Node'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Node = Core.Class.subclass(
/** @lends GL2.Node.prototype */
{
	classname: 'Node',
	
	/**
	 * @class The <code>Node</code> class constructs base class objects that contain positionable elements in the GL2 module. 
	 * Applications can use <code>Node</code> objects for grouping and organizing the scene graph. 
	 * <p>
	 * Inside the <code>{@link UI.GLView}</code> class, positionable elements are organized into a node hierarchy. This data
	 * structure is analgous to a scene graph or a node tree. Child nodes inherit data for
	 * transform, visibility, and depth from the parent on a conditional basis. Most drawable attributes for nodes, such as size and color, are specified in 
	 * derived classes. 
	 *</p><p>
	 * All derived GL2 classes from <code>Node</code> are native-backed proxies including <code>Node</code>.
	 * When a <code>Node</code> is instantiated on the Javascript side, a C++ object
	 * is instantiated and managed for the user on the native backend. This condition means the application
	 * must explicity destroy any <code>Node</code> that is no longer used.
	 *</p><p>
	 * A <code>Node</code> can exist independent of the scene, but it will only receive draw or touch updates
	 * when it is attached to the root tree.
	 *</p>
	 *<div class="ul">
	 * <li>Add a node as a child to the root of the scene with <code>{@link GL2.Root#addChild}</code>.</li> 
	 * <li>Add a node as a child to another node with <code>{@link GL2.Node#addChild}</code>.</li>
	 * <li>Remove a node from the root of the scene with <code>{@link GL2.Root#removeChild}.</code></li>
	 * <li>Remove a child node from a parent node with <code>{@link GL2.Node#removeChild}</code>.</li> 
	 *</div><br>
	 * <p>
	 * Call <code><a href="GL2.Node.html#destroy">destroy()</a></code> to automatically remove a node from the parent node.
	 * As previously noted, nodes are supported by a native object on the backend. Maintaining a 
	 * node reference outside of the scene instead of calling <code>destroy()</code> and recreating a new node is a recommended best practice.
	 *</p><p>
	 * Absolute positioning of a single node is determined by the following properties in the defined order:
	 *</p>
	 *<div class="ol">
	 * <li>Scale (two-component [x,y] multiple)</li>
	 * <li>Rotation (degrees about z-axis)</li>
	 * <li>Position (two-component translation)</li>
	 *</div><br>
	 * <p>
	 * Each of these properties is applied to the node relative to the parent node. The final transform
	 * for any given node is the concatenation of each transform in the node graph ancestry. The
	 * root ancestor is fixed to the view and composes the scene so that <code>(0,0)</code> is in the upper
	 * left corner. The first anchored
	 * offset to rotate and scale around is not specified because nodes do not inherently contain a size <code>(see {@link GL2.Animation.Frame#getAnchor}</code>). 
	 *</p><p>
	 * The <code>Depth</code> property of a <code>Node</code> object determines that <code>Node</code> sort order when traversing the scene graph.
	 * Depth is roughly equivalent to z-order or index. Each node is sorted among siblings by
	 * <code>Depth</code>, starting with the lowest depth node and sorting in ascending order.
	 *</p><p>
	 * By default, <code>Nodes</code> are grouped 
	 * with their siblings (not interleaved with cousins) and sorted relative to their parent 
	 * as if the parent depth value was <code>0</code>. However, you can modify this behavior for specific use cases 
	 * with <code><a href="GL2.Node.html#setChildrenDepthGrouped">setChildrenDepthGrouped()</a></code>. 
	 *</p><p>
	 * The node depth (order) in the scene graph will dictate the drawing order and determines what the final frame will look like.
	 * When drawing, <code>GL2.Node</code> utilizes the painter's algorithm.
	 * This means lower depth nodes are obscured by higher depth nodes.
	 * Touch priority occurs in reverse order to drawing order. Touches travel through the scene from higher depth to lower depth nodes 
	 * (front of scene earlier to back of scene later).
	 *</p><p>
	 * As a base class, a <code>Node</code> is not drawable but does maintain <code>Color</code> and <code>Alpha</code>
	 * attributes (see <code><a href="GL2.Node.html#getColor">getColor()</a></code> and <code><a href="GL2.Node.html#getAlpha">getAlpha()</a></code>). 
	 * Child nodes that contain drawable derived classes from 
	 * <code>Node</code> inherit these attributes.
	 * As a result, setting the <code>Color</code> for a parent node affects the color of every child node through multiplication
	 * of color components.</p>
	 * <p>Classes derived from Node include:</p>
	 * <div class="ul">
	 * <li>{@link GL2.Primitive}</li>
	 * <li>{@link GL2.Sprite}</li>
	 * <li>{@link GL2.Text}</li>
	 * </div>
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 */
    initialize: function()
    {
		Core.ObjectRegistry.register(this);
        this._parent = null;
        this._position = new Core.Point();
        this._scale = new Core.Vector(1, 1);
        this._color = new Core.Color(1, 1, 1);
        this._alpha = 1;
        this._rotation = 0;
        this._depth = 0;
        this._visible = true;
        this._touchable = true;
		
        this._childrenDepthGrouped = true;
        this._children = [];
		
		this._createSendGen(this.__objectRegistryId);
    },

	/**
	 * The default destructor. Calling <code>destroy()</code> removes the node from the parent, which releases the
	 * native object on the backend. 
	 * <br><br>
	 * <b>Note:</b> Applications must call this explicitly for nodes that are no longer
	 * used.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		children = this._children;
		while(children.length)
		{
			this.removeChild(children[0]);
		}
			
		if(this._parent)
		{
			this._parent.removeChild(this);
		}
		
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},

	/**
	 * Retrieve the position of this <code>Node</code>.
	 * @returns {Core.Vector} The current node position relative to the parent.
	 * @see GL2.Node#setPosition
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getPosition: function()
	{
		return this._position;
	},
	
	/**
	 * Retrieve the <i>width</i> and <i>height</i> scale multiple of this <code>Node</code>. 
	 * The default scale <code>[1,1]</code> will not modify the resulting transform.
	 * @returns {Core.Vector} The current scale multiple (<i>width</i> and <i>height</i>).
	 * @see GL2.Node#setScale
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getScale: function()
	{
		return this._scale;
	},

	/**
	 * Retrieve the <code>Color</code> component of this <code>Node</code>. Values for <code>Color</code> are based on the RGB color model. 
	 * When drawing, the values for <code>Color</code> are multiplied by the value of each drawable pixel. Child nodes will multiply
	 * the values for <code>Color</code> by the parent composite color before drawing. 
	 * @returns {Core.Color} The current value of all three color components (red, green, blue).
	 *<br><br>
	 * <b>Note:</b> The default RGB triplet <code>[1,1,1]</code> does not produce a color change.
	 * @see Core.Color, 
	 * @see GL2.Node#setColor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getColor: function()
	{
		return this._color;
	},

	/**
	 * Retrieve the <cod>alpha</code> components of this <code>Node</code>.
	 * @returns {Number} The new alpha blending state across the open interval ranging between <code>(0-1)</code>. 
	 * (0 = completely transparent, 1 = completely opaque). Expressed as a float.
	 * @see GL2.Node#setAlpha
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAlpha: function()
	{
		return this._alpha;
	},

	/**
	 * Retrieve the <code>rotation</code> component for this <code>Node</code>.
	 * The default value is 0 degrees about the z-axis.
	 * @returns {Number} The current degree of rotation. Expressed as a float.
	 * @see GL2.Node#setRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getRotation: function()
	{
		return this._rotation;
	},

	/**
	 * Retrieve the <code>depth</code> component for this <code>Node</code>.
	 * The default value is <code>0</code>.
	 * Applications will sort nodes with identical depth values by the last 
	 * time the node was attached to the root node graph.
	 * @returns {Number} The current node depth level (z-order). Expressed as a float.
	 * @see GL2.Root and 
	 * @see GL2.Node#setDepth
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getDepth: function()
	{
		return this._depth;
	},

	/**
	 * Retrieve the <code>visible</code> component for this <code>Node</code>.
	 * This component defines visibility of the node.
	 * The default value is <code>true</code>.<br><br>
	 * <b>Note:</b> A node can inherit the value of this component from parent nodes in the scene graph.
	 * @returns {Boolean} Returns <code>true</code> if the node is visible. Returns <code>false</code> in all other cases.
	 * @see GL2.Node#setVisible
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getVisible: function()
	{
		return this._visible;
	},

	/**
	 * Retrieve the <code>touchable</code> component for this <code>Node</code>.
	 * This component defines touch-support for a node.
	 * The default value is <code>true</code>.<br><br>
	 * <b>Note:</b> A node can inherit "not touchable" from parent nodes in the scene graph.
	 * @returns {Boolean} Returns <code>true</code> if a node is touchable. Returns <code>false</code> in all other cases.
	 * @see GL2.Node#setTouchable
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTouchable: function()
	{
		return this._touchable;
	},
	

	/**
	 * Retrieve <code>childrenDepthGrouped</code> component of this <code>Node</code>.
	 * The default value is <code>true</code>.
	 * When <code>childrenDepthGrouped</code> is <code>false</code>, child nodes sort amongst (interleave 
	 * with) the children of the nearest depthgrouped ancestor.
	 * @returns {Boolean} Returns as <code>true</code> if sorting with ancestor siblings. Returns as <code>false</code> if sorting only with siblings in the graph.
	 * @see GL2.Node#setChildrenDepthGrouped
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getChildrenDepthGrouped: function()
	{
		return this._childrenDepthGrouped;
	},
	
	/**
	 * Retrieve the parent node for this <code>Node</code>.
	 * @returns {GL2.Node} The current parent node.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getParent: function()
	{
		return this._parent;
	},

	/**
	 * Retrieve a copy of the child array for this <code>Node</code>.
	 * @returns {Array GL2.Node} The current list of child nodes.
	 * @status 
	 */
	getChildren: function()
	{
		return this._children.slice();
	},
	
    /**
	 * Set the <code>translation</code> component of the transform for this <code>Node</code>.
	 * You can define the parameter value as a vector or two floats.<br><br>
	 * <b>Note:</b> An application can use this property to translate a group of nodes by
	 * translating the parent. Child nodes inherit this property from the parent node.<br/><br/>
	 * The following code examples illustrate different call styles for <code>setPosition()</code>.<br><br>
	 * 
	 * @example
	 * node.setPosition(new Core.Vector(50, 100));
	 *
	 * @example
	 * node.setPosition(50, 100);
	 * 
	 * @param {Core.Vector} position The new node position relative to the parent.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getPosition,
	 * @see Core.Vector
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setPosition: function(position)
	{
		var p = this._position;
		p.setAll.apply(p, arguments);
		this._setPositionSendGen(p.getX(),p.getY());
		return this;
	},
	
    /**
	 * Set the <i>x</i> and <i>y</i> scale of the transform for this <code>Node</code>.<br><br>
	 * <b>Note:</b> This property affects the coordinate system of child nodes and scales drawing for
	 * derived classes like <code>Sprite</code>, <code>Text</code>, and <code>Primitive</code>.
	 * <br><br>
	 * The following code examples illustrate different call styles for <code>setScale()</code>.<br><br>
	 * 
	 * @example
	 * node.setScale(new Core.Vector(2, 0.5));
	 *
	 * @example
	 * node.setScale(2, 0.5);
	 * 
	 * @param {Core.Vector} scale The new scale multiple (<i>width</i> and <i>height</i>). You can define the parameter value as a vector or two floats.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getScale, 
	 * @see GL2.Primitive, 
	 * @see GL2.Sprite, 
	 * @see GL2.Text
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setScale: function(scale)
	{
		var s = this._scale;
		s.setAll.apply(s, arguments);
		this._setScaleSendGen(s.getX(),s.getY());
		return this;
	},
	/**
	 * Set the color for the specified entity. Call this method either by reference to a single vector object  
	 * or by defining three float parameters.
	 * Every color pixel value for the entity is multiplied by the value of the parameter before drawing.
	 * <br><br>
	 * <b>Example:</b> If you specify an entity to draw an orange pixel <code>(1.0, 0.5, 0)</code>,
	 * but the entity color is purple <code>(0.5, 0, 1.0)</code>, the resulting pixel color is
	 * <code>(0.5, 0, 0)</code>, which is dark red. The application conducts this efficiently for each pixel in the
	 * entity.<br><br>
	 * The following code examples illustrate different call styles for <code>setColor()</code>.<br><br>
	 * 
	 * @example
	 * node.setColor(new Core.Color(1.0, 0.5, 0));
	 *
	 * @example
	 * node.setColor(1.0, 0.5, 0);
	 * 
	 * @param {Core.Color} color Pixel color value to muliply by the entity color value.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Color, 
	 * @see GL2.Node#getColor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setColor: function(color)
	{
		var c = this._color;
		c.setAll.apply(c, arguments);
		this._setColorSendGen(c.getRed(),c.getGreen(),c.getBlue());
		return this;
	},
    /**
	 * Set the alpha blending state for the entity.
	 * Each pixel of the entity blends with the underlying surface. This occurs in proportion to the alpha blending state of the entity.
	 * The application must set the parameter value within the open interval <code>[0, 1]</code>.
	 * <br><br>
	 * <b>Example:</b> Drawing a red entity with an alpha of <code>0.5</code> over a white background results in a light pink entity. 
	 * Drawing an orange pixel <code>(1.0, 0.5, 0)</code> with an alpha of <code>0.66</code> over
	 * a light blue surface <code>(0.0, 1.0, 1.0)</code>, results in a light brown pixel:
	 * @example (1.0, 0.5, 0) * 0.66 + (0.0, 1.0, 1.0) * 0.34 = (0.6, 0.67, 0.34)
	 * @param {Number} alpha The new alpha blending state for the entity ranging between <code>(0-1)</code> 
	 * (0 = completely transparent, 1 = completely opaque). Expressed as a float.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getAlpha
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setAlpha: function(alpha)
	{
		this._alpha = alpha;
		this._setAlphaSendGen(alpha);
		return this;
	},
	
    /**
	 * Set the transform rotation (in degrees) for this <code>Node</code>.<br><br> 	 
	 * <b>Note:</b> This property affects the coordinate system of child nodes and rotates drawing for
	 * derived classes like <code>Sprite</code>, <code>Text</code>, and <code>Primitive</code>.
	 * <br><br>
	 * The following code examples illustrate different call styles for <code>setRotation()</code>.<br><br>
	 * 
	 * Rotate entity 90 degrees.
	 * <pre class="code">node.setRotation(90);</pre> 
	 * Restore entity to original orientation.
	 * <pre class="code">node.setRotation(0);</pre>
	 * Convert radians to degrees.
	 * <pre class="code">var radians = 0.785;
	 * var degrees = radians * Math.PI / 180;</pre>
	 * Convert degrees to radians.
	 * <pre class="code">var degrees = 90;
	 * var radians = degrees * 180 / Math.PI;</pre>
	 *
	 * @param {Number} rotation The new rotation of the entity relative to the parent (in degrees). Expressed as a float.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getRotation, 
	 * @see GL2.Primitive, 
	 * @see GL2.Sprite, 
	 * @see GL2.Text
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setRotation: function(rotation)
	{
		this._rotation = rotation;
		this._setRotationSendGen(rotation);
		return this;
	},
	
    /**
	 * Set the <code>depth</code> component for this <code>Node</code>.
	 * This property affects how a node is sorted when the scene is traversed. Different depth-levels affect
	 * both drawing order (back to front, low to high) and touch priority (front to back,
	 * high to low).<br><br>
	 * <b>Note:</b> Use <code>{@link GL2.Node#setChildrenDepthGrouped}</code> to set how a node will sort with siblings.
	 * @example node.setDepth(20);
	 * @param {Number} depth The new depth for the entity (z-order). Expressed as a float.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getChildrenDepthGrouped, 
	 * @see GL2.Node#setChildrenDepthGrouped
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setDepth: function(depth)
	{
		if(this._depth != depth)
		{
			this._depth = depth;
			this._setDepthSendGen(depth);
		}
		return this;
	},
	
    /**
	 * Set the <code>visible</code> component for this <code>Node</code>.
	 * This component defines visibility of the node.
	 * The default value is <code>true</code>.<br><br>
	 * <b>Note:</b> A node can inherit the value of this component from parent nodes in the scene graph.
	 * @example node.setVisible(true);
	 * @param {Boolean} [visible=true] Set as <code>true</code> if a node is visible.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getVisible
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setVisible: function(visible)
	{
		if(this._visible != visible)
		{
			this._visible = visible;
			this._setVisibleSendGen(visible);
		}
		return this;
	},
	
    /**
	 * Set this <code>Node</code> to support touches.
	 * The <code>touchable</code> property is Boolean and defines a node as supporting touch input.
	 * A node can inherit the value of <code>touchable</code> from parent nodes in the scene graph.<br><br> 
	 * <b>Caution!</b> Instantiating touchable <code>GL2.Node</code> objects will impact performance 
	 * much more than instantiating <code>GL2.Node</code> objects that do not support touch input. If
	 * a node does not need to support touch input, set <code>touchable</code> to <code>false</code>.
	 * @example node.setTouchable(false);
	 * @param {boolean} [touchable=true] Set as <code>true</code> if this node supports touch input.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getTouchahble
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setTouchable: function(touchable)
	{
		this._touchable = touchable;
		this._setTouchableSendGen(touchable);
		return this;
	},
    
	/**
	 * Set whether to sort child nodes adjacent to this <code>Node</code>.
	 * When <code>childrenDepthGrouped</code> is <code>false</code>, the child nodes interleave 
	 * with the children of the nearest similarly grouped ancestor. Applications can use this to sort a distant node
	 * on an independent branch of the graph in close proximity.<br/><br/>
	 * <b>Example:</b> You have multiple group nodes containing a character sprite and a 
	 * shadow sprite. By setting all the shadow sprites to a <code>depth</code> of <code>1</code>, all character sprites to
	 * a <code>depth</code> of <code>2</code>, and setting <code>childrenDepthGrouped</code> to <code>false</code> for each group node, all character sprites will 
	 * sort above shadows when drawn.<br><br>
     * Look at the following structure of nodes.
     * If <code>childrenDepthGrouped</code> is <code>true</code> for the group, the primitive will
     * draw above both the sprite and the text. However, if <code>false</code>,
     * the primitive will draw after the sprite but before the text.
     * <pre class="code">
     * Root
     * +-- Group (depth = 0)
     * |   +-- Sprite (depth = 10)
     * |   +-- Text (depth = -10)
     * |
     * +-- Primitive (depth = 5)
     * </pre>
	 * @param {Boolean} childrenDepthGrouped Set as <code>true</code> to sort with ancestor siblings. Set as <code>false</code> to sort only with siblings in the graph.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getChildrenDepthGrouped
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setChildrenDepthGrouped: function(childrenDepthGrouped)
	{
		if(this._childrenDepthGrouped != childrenDepthGrouped)
		{
			this._childrenDepthGrouped = childrenDepthGrouped;
			this._setChildrenDepthGroupedSendGen(childrenDepthGrouped);
		}
		return this;
	},
	
	/**
	 * Add a node as a child to this <code>Node</code>.
	 * @example node.addChild(this.mySprite);
	 * @param {GL2.Node} child The child node to add.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#removeChild
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	addChild: function(child)
	{
		// Add to children list.
		this._children.push(child);
		
		// Tell child.
		child._didAddToParent(this);
		
		this._addChildSendGen(Core.ObjectRegistry.objectToId(child));
		
		return this;
	},
	
	/**
	 * Remove a specified child node and its subtree from this <code>Node</code>.
	 * @example node.removeChild(this.mySprite);
	 * @param {String} child The child node to remove from the current entity.
	 * @throws {removeChild called for a node that is not a child} Specified node is not a child node.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#addChild
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	removeChild: function(child)
	{
		// Tell child.
		child._willRemoveFromParent();
		
		// Remove from children list.
		var index = this._children.indexOf(child);
		if(index == -1)
			throw new Error('removeChild called for a node that is not a child');
		this._children.splice(index, 1);
		
		this._removeChildSendGen(Core.ObjectRegistry.objectToId(child));
		
		return this;
	},
	
	/**
	 * Convert the relative location of a scene to the local coordinate space for this <code>Node</code>.
	 * @example var p = Game.getRoot().screenToLocal(touch.getPosition());
	 * @param {Core.Vector} location The relative location for a scene.
	 * @see GL2.Node#localToScreen
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	screenToLocal: function(location)
	{
		var parent = this._parent;
		if(!parent)
			return undefined;
			
		location = parent.screenToLocal(location);
		if(!location)
			return undefined;
		
		var x = location.getX();
		var y = location.getY();
		
		// Undo translation.
		var p = this._position;
		x -= p.getX();
		y -= p.getY();
		
		// Undo rotation.
		var r = this._rotation * Math.PI / 180;
		var cosr = Math.cos(r);
		var sinr = Math.sin(r);
		var tx = cosr*x + sinr*y;
		var ty = -sinr*x + cosr*y;
		x = tx;
		y = ty;
		
		// Undo scale.
		var s = this._scale;
		x /= s.getX();
		y /= s.getY();
		
		return new Core.Point(x, y);
	},
	
	/**
	 * Convert a location within the local coordinate space for this <code>Node</code> to a location within the screen coordinate
	 * space.
	 * @param {Core.Vector} location A location in the local transform for this <code>Node</code>.
	 * @see GL2.Node#screenToLocal
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	localToScreen: function(location)
	{
		var x = location.getX();
		var y = location.getY();
		
		// Undo scale.
		var s = this._scale;
		x *= s.getX();
		y *= s.getY();
		
		// Undo rotation.
		var r = -this._rotation * Math.PI / 180;
		var cosr = Math.cos(r);
		var sinr = Math.sin(r);
		var tx = cosr*x + sinr*y;
		var ty = -sinr*x + cosr*y;
		x = tx;
		y = ty;
		
		// Undo translation.
		var p = this._position;
		x += p.getX();
		y += p.getY();
		
		var parent = this._parent;
		if(!parent)
			return undefined;
		
		location = parent.localToScreen(new Core.Point(x, y));
		if(!location)
			return undefined;
		return location;
	},
	
	_didAddToParent: function(parent)
	{
		if(this._parent)
			this._parent.removeChild(this);
		
		this._parent = parent;
	},
	
	_willRemoveFromParent: function()
	{
		this._parent = null;
	},
	
	_synchronizeNodeRecv: function( cmd )
	{
		var msg = {};
		if(!this._synchronizeNodeRecvGen(cmd, msg))
			return;
		this._position.setAll(msg.x, msg.y);
		this._rotation = msg.rotation;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 307
	// Method create = -1
	// Method destroy = 2
	// Method setPosition = 3
	// Method setScale = 4
	// Method setColor = 5
	// Method setAlpha = 6
	// Method setRotation = 7
	// Method setDepth = 8
	// Method setVisible = 9
	// Method setTouchable = 10
	// Method setChildrenDepthGrouped = 11
	// Method addChild = 12
	// Method removeChild = 13
	// Method synchronizeNode = 14
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 14:
					instance._synchronizeNodeRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Node._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Node._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[307] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_synchronizeNodeRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in Node.synchronizeNode from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in Node.synchronizeNode from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in Node.synchronizeNode from command: " + cmd );
			return false;
		}
		
		obj[ "rotation" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "rotation" ] === undefined )
		{
			NgLogE("Could not parse rotation in Node.synchronizeNode from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":307,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":307,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setPositionSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":307,3," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setScaleSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":307,4," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setColorSendGen: function( red, green, blue )
	{
		Core.Proc.appendToCommandString( ":307,5," + this.__objectRegistryId + "," + red + "," + green + "," + blue  );
	},
	
	/** @private */
	_setAlphaSendGen: function( alpha )
	{
		Core.Proc.appendToCommandString( ":307,6," + this.__objectRegistryId + "," + alpha  );
	},
	
	/** @private */
	_setRotationSendGen: function( rotation )
	{
		Core.Proc.appendToCommandString( ":307,7," + this.__objectRegistryId + "," + rotation  );
	},
	
	/** @private */
	_setDepthSendGen: function( depth )
	{
		Core.Proc.appendToCommandString( ":307,8," + this.__objectRegistryId + "," + depth  );
	},
	
	/** @private */
	_setVisibleSendGen: function( visible )
	{
		Core.Proc.appendToCommandString( ":307,9," + this.__objectRegistryId + "," + ( visible ? 1 : 0 )  );
	},
	
	/** @private */
	_setTouchableSendGen: function( touchable )
	{
		Core.Proc.appendToCommandString( ":307,10," + this.__objectRegistryId + "," + ( touchable ? 1 : 0 )  );
	},
	
	/** @private */
	_setChildrenDepthGroupedSendGen: function( childrenDepthGrouped )
	{
		Core.Proc.appendToCommandString( ":307,11," + this.__objectRegistryId + "," + ( childrenDepthGrouped ? 1 : 0 )  );
	},
	
	/** @private */
	_addChildSendGen: function( child )
	{
		Core.Proc.appendToCommandString( ":307,12," + this.__objectRegistryId + "," + child  );
	},
	
	/** @private */
	_removeChildSendGen: function( child )
	{
		Core.Proc.appendToCommandString( ":307,13," + this.__objectRegistryId + "," + child  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setPosition: function( x, y ) {}
	
	// setScale: function( x, y ) {}
	
	// setColor: function( red, green, blue ) {}
	
	// setAlpha: function( alpha ) {}
	
	// setRotation: function( rotation ) {}
	
	// setDepth: function( depth ) {}
	
	// setVisible: function( visible ) {}
	
	// setTouchable: function( touchable ) {}
	
	// setChildrenDepthGrouped: function( childrenDepthGrouped ) {}
	
	// addChild: function( child ) {}
	
	// removeChild: function( child ) {}
	
	// _synchronizeNodeRecv: function( cmd ) {}

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Primitive'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Primitive'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Primitive'] = exports; var Node = require('NGCore/Client/GL2/Node').Node;
var Animation = require('NGCore/Client/GL2/Animation').Animation;
var Core = require('NGCore/Client/Core').Core;

exports.Primitive = Node.subclass(
/** @lends GL2.Primitive.prototype */
{
	classname: 'Primitive',
    
	/**
	 * @class The <code>Primitive</code> class constructs objects that draw arbitrary vertex-based geometry.
	 * These objects provide a means of drawing raw 2D <a href="GL2.Primitive.Vertex.html">vertex</a> data as polygons to a <code>{@link UI.View}</code>. Data is
	 * provided by users as a vertex list. 
	 * @constructs The default constructor. 
	 * @augments GL2.Node
	 */
    initialize: function()
    {
        this._animation = null;
		this._ownsAnimation = false;
		
		this._animationCompleteEmitter = new Core.MessageEmitter();
        this._type = this.Type.Triangles;
        this._vertexes = [];
    },

	/**
	 * The default destructor.
	 * This call cleans up any attached <code>Animation</code> and <code>AnimationCompleteEmitter</code>.
	 * @see GL2.Animation
	 * @status iOS, Android, Flash
	 */
	destroy: function()
	{
		this._tryDestroyAnimation();
		this._animationCompleteEmitter.destroy();
	},
	
	/**
	 * Retrieve the number of listed vertices in the geometry of this <code>Primitive</code>.
	 * @returns {Number} The current number of vertices.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getVertexCount: function()
	{
		return this._vertexes.length;
	},
	
	/**
	 * Retrieve a single vertex from the vertex list of this <code>Primitive</code>.
	 * @param {Number} index The vertex list offset to retrieve.
	 * @returns {GL2.Primitive.Vertex} The current vertex at the specified index in the vertex list.
	 * @see GL2.Primitive#setVertex
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getVertex: function(index)
	{
		return this._vertexes[index];
	},
	
	/**
	 * Retrieve the GL draw mode for this <code>Primitive</code>.
	 * @returns {GL2.Primitive#Type} The current draw mode.
	 * @see GL2.Primitive#setType
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getType: function()
	{
		return this._type;
	},
	
	/**
	 * Retrieve the current <code>Texture Animation</code> object of this <code>Primitive</code>.
	 * @returns {GL2.Animation} The current animation.
	 * @see GL2.Primitive#setAnimation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAnimation: function()
	{
		if(this._ownsAnimation) return null;
		
		return this._animation;
	},
	
	/**
	 * Retrieve the complete message emitter for the current animation.
	 * @returns {Core.MessageEmitter} The emitter for the current texture animation.
	 * @see GL2.Animation,  
	 * @see Core.MessageEmitter
	 * @status iOS, Android, Flash
	 */
	getAnimationCompleteEmitter: function()
	{
		return this._animationCompleteEmitter;
	},
    
	/**
	 * Begin playing the specified animation.
	 * Any animation that is not set to loop will trigger the animation complete callback when done.
	 * @example primitive.setAnimation(myAnimation, 30);
	 * @param {GL2.Animation} animation The current animation.
	 * @param {Number} [startTime=0] The starting point of the animation. Expressed as a float.<br><br>
	 * <b>Example:</b> If <code>setAnimation()</code> is called with a <code>startTime</code> equal to half the total duration of the animation, 
	 * playback begins half way through the animation.
	 * @see GL2.Primitive#getAnimation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setAnimation: function(animation, startTime)
	{
		this._tryDestroyAnimation();
		this._animation = animation;
		
		this._setAnimationSendGen( Core.ObjectRegistry.objectToId(animation), startTime || 0 );
	},
    
    /**
	 * Set a static image as the current animation for this <code>Primitive</code>.
	 * This method instantiates a single frame animation of infinite duration using the
	 * specified image. If the primitive is playing another animation at the time of this call, 
	 * the new animation will take priority over the primitive.
	 * The previous animation will stop and the complete emitter will not respond. 
	 * This is because the animation did not technically complete a full playback cycle. <br><br>
	 * You can define optional parameters for the size, anchor, and UV coordinates of the specified image. 
	 * @example primitive.setImage('./Content/blank.png', [480, 320], [0, 0]);
	 * @param {String} image The directory path to an image referenced by a frame.
	 * @param {Core.Size} [size] The size of the image to display in pixels.
	 * @param {Core.Point} [anchor] The anchor coordinates that indicate the image center in the animation.
	 * @param {Core.Rect} [uvs] The UV coordinates used to specify the subset of an image.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Animation, 
	 * @see GL2.Animation.Frame
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setImage: function(image, size, anchor, uvs)
	{
		this._tryDestroyAnimation();
		
		// Create a single frame animation.
		var args = Array.prototype.slice.call(arguments, 0);
		args.splice(1, 0, 0); // Insert a duration of zero into our arguments.
		var frame = new Animation.Frame();
		frame.constructor.apply(frame, args);
		var animation = new Animation();
		animation.pushFrame(frame);
		
		this._animation = animation;
		this._ownsAnimation = true;
		
		this._setAnimationSendGen(Core.ObjectRegistry.objectToId(animation),0);
		
		return this;
	},
    
    /**
	 * Set the type of geometry on display for this <code>Primitive</code>.
	 * @example primitive.setType(GL2.Primitive.Type.TriangleFan);
	 * @param {GL2.Primitive#Type} type The new GL draw mode.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setType: function(type)
	{
		this._type = type;
		
		this._setTypeSendGen(type);
		
		return this;
	},
    
    /**
     * Add a vertex to the end of the vertex list for this <code>Primitive</code>.<br>
     * <pre class="code"><font size="2">primitive.pushVertex(new Core.Point(w*2/10, h*5/6));</font></pre><br>
     * Calling <code>pushVertex()</code> is equivalent to calling <code>spliceVertexes()</code> in the following way:
     * <pre class="code"><font size="2">primitive.spliceVertexes(primitive.getVertexCount(), 0, vertex);</font></pre>
     * @param {GL2.Primitive.Vertex} vertex The vertex to add.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    pushVertex: function(vertex)
	{
		return this.spliceVertexes(this._vertexes.length, 0, vertex);
	},
    
    /**
	 * Set the vertex at index <i>i</i> for this <code>Primitive</code>.
	 * Calling <code>setVertex()</code> is equivalent to calling <code>spliceVertexes()</code> in the following way:
	 * @example primitive.spliceVertexes(i, 1, vertex)
	 * @param {Number} <i>i</i> The index in the vertex list to set.
	 * @param {GL2.Primitive.Vertex} vertex The new vertex.
	 * @see GL2.Primitive#getVertex
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setVertex: function(i, vertex)
	{
		return this.spliceVertexes(i, 1, vertex);
	},
    
    /**
	 * Replace <code>len</code> vertices, starting at position <code>start</code>, with specified vertices.<br><br>
	 * The following are examples of different call styles for <code>spliceVertexes</code>.<br><br>
	 * Splice a simple textureless quad into the vertex list.
	 * <pre class="code"><font size="2">var c = new Core.Color([1,1,1]);
	 * var w = 100;
	 * var h = 100;
	 * var v = new Array();
	 * v.push(new GL2.Primitive.Vertex([0,0],[0,0],c));
	 * v.push(new GL2.Primitive.Vertex([w,0],[0,0],c));
	 * v.push(new GL2.Primitive.Vertex([w,h],[0,0],c));
	 * v.push(new GL2.Primitive.Vertex([0,h],[0,0],c));</font></pre>
	 * Insert four vertices at position 0 in the vertex list.
	 * <pre class="code"><font size="2">myPrimitive.spliceVertexes.apply(myPrimitive, ([0,0]).concat(v));
	 * myPrimitive.setType(GL2.Primitive.Type.TriangleFan);</font></pre>
	 * @param {Number} start The index from which to remove vertices in the vertex list.
	 * @param {Number} len The number of vertices to replace.
	 * @param {GL2.Primitive.Vertex} vertexes A list of vertices to insert at the start location.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    spliceVertexes: function(start, len, vertexes)
	{
		this._vertexes.splice.apply(this._vertexes, arguments);
		
		var vertexCount = arguments.length-2;
		this._spliceVertexesSendGen(start,len,vertexCount);
		
		for(var i=0; i < vertexCount; ++i)
		{
			var vertex = arguments[i+2];
			var position = vertex.getPosition();
			var uv = vertex.getUV();
			var color = vertex.getColor();
			this._vertexSendGen(
				position.getX(),
				position.getY(),
				uv.getX(),
				uv.getY(),
				color.getRed(),
				color.getGreen(),
				color.getBlue()
			);
		}
		
		return this;
	},

	$Vertex: Core.Class.subclass(
	/** @lends GL2.Primitive.Vertex.prototype */
	{
		classname: 'Vertex',
		
		/**
		 * @class <code>Vertex</code> objects specify location, texture coordinates, and color data
		 * for GL primitive geometry.
		 * @constructs The default constructor. 
		 * @param {Core.Vector|float[2]} position A location.
		 * @param {Core.Vector|float[2]} uv A texture coordinate.
		 * @param {Core.Color|float[3]} color An RGB color triplet.
		 * @see GL2.Primitive
		 * @augments Core.Class
		 */
		initialize: function(position, uv, color)
		{
			this._position = new Core.Point(position);
			this._uv = new Core.Point(uv);
			this._color = new Core.Color(color);
		},
		
		/**
		 * Retrieve the location of this <code>Vertex</code>.
		 * @returns {Core.Vector} The current <i>x</i>,<i>y</i> coordinates for the vertex.
    	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getPosition: function()
		{
			return this._position;
		},
		
		/**
		 * Retrieve the texture coordinates of this <code>Vertex</code>.
		 * @returns {Core.Vector} The current <i>x</i>,<i>y</i> coordinates for the texture.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getUV: function()
		{
			return this._uv;
		},
		
		/**
		 * Retrieve the color of this <code>Vertex</code>.
		 * @returns {Core.Color} The current vertex color as a RGB triplet.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getColor: function()
		{
			return this._color;
		},
	}),
	
	_tryDestroyAnimation: function()
	{
		if(this._ownsAnimation)
		{
			// Set our animation to NULL to unlink ourselves from the animation on the backend
			// or else trying to destory the animation will fail because we are still using it.
			this._setAnimationSendGen(0,0);
		
			this._animation.destroy();
			this._animation = null;
			this._ownsAnimation = false;
		}
		this._animation = null;
		this._image = null;
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration for primitive types.
	 * @namespace
	 */
	Type:
	{ 
		/** Every three vertices define a unique triangle. */
		Triangles: 0,
		/** Every vertex defines a triangle with the 2 preceding vertices. */
		TriangleStrip: 1,
		/** Every vertex defines a triangle with the first vertex and the previous vertex. */
		TriangleFan: 2,
		/** Every vertex pair defines a line segment. */
		LineList: 3,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 308
	// Method create = -1
	// Method spliceVertexes = 2
	// Method vertex = 3
	// Method setType = 4
	// Method setAnimation = 5
	// Method animationComplete = 6
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 6:
					instance._animationCompleteRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Primitive._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Primitive._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[308] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_animationCompleteRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in Primitive.animationComplete from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":308,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_spliceVertexesSendGen: function( start, len, vertexCount )
	{
		Core.Proc.appendToCommandString( ":308,2," + this.__objectRegistryId + "," + start + "," + len + "," + vertexCount  );
	},
	
	/** @private */
	_vertexSendGen: function( x, y, u, v, red, green, blue )
	{
		Core.Proc.appendToCommandString( "," + x + "," + y + "," + u + "," + v + "," + red + "," + green + "," + blue  );
	},
	
	/** @private */
	_setTypeSendGen: function( type )
	{
		Core.Proc.appendToCommandString( ":308,4," + this.__objectRegistryId + "," + type  );
	},
	
	/** @private */
	_setAnimationSendGen: function( animation, startTime )
	{
		Core.Proc.appendToCommandString( ":308,5," + this.__objectRegistryId + "," + animation + "," + startTime  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// spliceVertexes: function( start, len, vertexCount ) {}
	
	// vertex: function( x, y, u, v, red, green, blue ) {}
	
	// setType: function( type ) {}
	
	// setAnimation: function( animation, startTime ) {}
	
	// _animationCompleteRecv: function( cmd ) {}

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Touch'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Touch'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Touch'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Touch = Core.Class.subclass(
/** @lends GL2.Touch.prototype */
{
	classname: 'Touch',
	
	/**
	 * @class The <code>Touch</code> class constructs objects that identify and track the life cycle of unique touch events in the system.
	 * @constructs These objects are constructed by the system.
	 * @augments Core.Class
	 */
	initialize: function()
	{
		this._id = 0;
		this._action = {};
		this._position = new Core.Point();
		this._targetIds = null;
	},
	
	/**
	 * Retrieve a list of every <code>TouchTarget</code> object in which this <code>Touch</code> object resides and is marked as touchable.
	 * @returns {GL2.TouchTarget} A prioritized list of every <code>TouchTarget</code> for this <code>Touch</code>.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTouchTargets: function()
	{
		var ids = this._targetIds;
		var result = [];
		for(var i in ids)
		{
			var t = Core.ObjectRegistry.idToObject(i);
			if(t) result.push(t);
		}
		return result;
	},
	
	/**
	 * Retrieve whether or not this <code>Touch</code> object resides in the specified <code>TouchTarget</code>.
	 * @param {GL2.TouchTarget} touchTarget The <code>TouchTarget</code> to test against.
	 * @returns {Boolean} Returns <code>true</code> when this <code>Touch</code> resides in the <code>TouchTarget</code>.
	 * @status iOS, Android, Flash
	 */
	getIsInside: function(touchTarget)
	{
		// Check if the object's id is in the touchtargets map
		return ( Core.ObjectRegistry.objectToId(touchTarget) in this._targetIds);
	},
	
	/**
	 * Retrieve the location of this <code>Touch</code> object in the global coordinate space.
	 * @returns {Core.Vector} The global coordinates of the <code>Touch</code> location.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getPosition: function()
	{
		return this._position;
	},
	
	/**
	 * Retrieve the ID of this <code>Touch</code> object.
	 * <b>Note:</b> When using this ID as a key, append it to a string so that you can use
	 * it to key an associative array. Otherwise, you will end up with a very large array.
	 * @returns {Number} The current <code>Touch</code> ID.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getId: function()
	{
		return this._id;
	},
	
	/**
	 * Retrieve the phase of this <code>touch</code> event.
	 * Use this method from your listener callback.
	 * The following is an example of a <code>touch</code> event handler for a button.
	 * @example
	 * onTouch: function(touch)
	 * {
	 * 	//getAction() informs us of the type of event being handled.
	 * 	//  In order to get Action.Move and Action.End, we need to return true from Action.Start.
	 * 	switch(touch.getAction())
	 * 	{
	 * 		case touch.Action.Start:
	 * 			//Change the color of our Rectangle
	 * 			this.button.setColor(Defaults.onColor);
	 * 			
	 * 			//Return true here if you want to capture this event for its lifetime.
	 * 			//  returning false will let other, lower priority handlers capture the
	 * 			//  event. In that case we would not want to react to the Action.Start since
	 * 			//  we would not get subsequent Action.End or Action.Move.
	 * 			return true;
	 * 			
	 * 		case touch.Action.End:
	 * 			//Reset the color of our Rectangle
	 * 			this.button.setColor(Defaults.offColor);
	 * 			
	 * 			//We do not need to return anything in Action.End or Action.Move.
	 * 			break;
	 * 		case touch.Action.Move:
	 * 			//The touch object allows us to retrieve metadata about the event.
	 * 			//  If the touch has left our bounds, getIsInside() will return false.
	 * 			if(!touch.getIsInside(this._target))
	 * 			{
	 * 				//If the active touch is outside, reset our Rectangle color.
	 * 				this.button.setColor(Defaults.offColor);
	 * 			}
	 * 			else
	 * 			{
	 * 				//If the active touch is inside, set our Rectangle color to on.
	 * 				this.button.setColor(Defaults.onColor);
	 * 			}
	 * 			break;
	 * 	}
	 * }
	 * @returns {GL2.Touch#Action} The current <code>touch</code> event phase.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAction: function()
	{
		return this._action;
	},
	
	_setId: function(id)
	{
		this._id = id;
	},
	
	_setAction: function(action)
	{
		this._action = action;
	},
	
	_setPosition: function(position)
	{
		this._position.setAll(arguments);
	},
	
	_setTargetIds: function(targetIds)
	{
		// We transfer the array of numeric target IDs into a
		// map so we can support getIsInside call which uses 'in'.
		this._targetIds = {};
		for(var i in targetIds)
			this._targetIds[targetIds[i]] = null;
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration for touch action.
	 * @namespace
	 */
	Action:
	{ 
		/** Finger began touching screen. */
		Start: 0,
		/** Finger stopped touching screen. */
		End: 1,
		/** Finger moved where it is touching the screen. */
		Move: 2,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 312
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Touch._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Touch._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[312] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	// This class is expected to implement the following methods outside of
	// the generated block:

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/TouchTarget'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/TouchTarget'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/TouchTarget'] = exports; var Node = require('NGCore/Client/GL2/Node').Node;
var Sprite = require('NGCore/Client/GL2/Sprite').Sprite;
var Core = require('NGCore/Client/Core').Core;

exports.TouchTarget = Node.subclass(
/** @lends GL2.TouchTarget.prototype */
{
	classname: 'TouchTarget',
    
	/**
	 * @class <code>TouchTarget</code> class constructs objects that provide applications access to touch events.
	 *<br><br>
	 * A <code>TouchTarget</code> is a node with added size and offset attributes that define a
	 * rectangular area as active. Any <a href"GL2.Touch.html">touch</a> that falls within the active area is broadcast
	 * to the <code>TouchTarget</code> where a <code>MessageListener</code> can respond 
	 * to the event. Attach a listener by calling <code><a href="GL2.TouchTarget.html#getTouchEmitter">getTouchEmitter()</a></code>
	 * to retrieve the emitter.
	 *<br><br>
	 * A <code>TouchTarget</code> is created with a <code>0</code> size and a center offset anchor point <code>(0.5,0.5)</code>.
	 * Set these two properties to define a usable area that supports touch events. Generally,
	 * you set these two values as identical to the values for <code><a href="GL2.Sprite.html">sprite</a></code>, <code><a href="GL2.Text.html">text</a></code>, 
	 * or <code><a href="GL2.Primitive.html">primitive</a></code> and add
	 * the <code>TouchTarget</code> as a child of that visible node with a position of <code>0</code>. The <code>TouchTarget</code> 
	 * inherits the transform for the visible node. 
	 * <br><br>
	 * <b>Note:</b> A <code>TouchTarget</code> is not part of the drawing scene traversal and activates regardless of node
	 * visibility or parent visibility. 
	 * Disable touch support for a node by calling <code><a href="GL2.Node.html#setTouchable">setTouchable()</a></code>.
	 * @constructs The default constructor.
	 * @augments GL2.Node
	 */
    initialize: function()
    {
		this._size = new Core.Size();
		this._anchor = new Core.Point(0, 0);
		this._touchEmitter = new Core.MessageEmitter();
    },
    
	/**
	 * Destroy this instance and release resources on the backend that are associated with this <code>TouchTarget</code> object.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
	},
	
	/**
	 * Return the point size of the <code>TouchTarget</code> area.
	 * @returns {Core.Size} The current size of the <code>TouchTarget</code> area.
	 * @see GL2.TouchTarget#setSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSize: function()
	{
		return this._size;
	},
	
	/**
	 * Return the offset values used for scaling and rotating the <code>TouchTarget</code> area.
	 * @returns {Core.Point} The current offset of the target area.
	 * @see GL2.TouchTarget#setAnchor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAnchor: function()
	{
		return this._anchor;
	},
	
	/**
	 * Return the touch emitter for this <code>TouchTarget</code>.
	 * The emitter fires when a captured <code>touch</code> event changes phases. For the initial touch down
	 * phase, this emitter fires when the <code>touch</code> event occurs within the defined touch area. After returning <code>true</code> from
	 * the initial <code>touch</code> event, the emitter fires regardless of where the <code>touch</code> event occurs.<br><br>	 
	 * The following example creates a new <code>TouchTarget</code> in the upper left corner of the scene. 
	 * The listener instance handles the <code>touch</code> events in the <code>onTouch()</code> function.
	 * @example
	 * var target = new GL2.TouchTarget();
	 * target.setAnchor([50,50]);
	 * target.setSize([100,100]);
	 * target.setPosition([50,50]);
	 * 
	 * target.getTouchEmitter().addListener(this, this.onTouch);
	 * 
	 * GL2.Root.addChild(target);
	 * @return {Core.MessageEmitter} The touch emitter for this touch area.
	 * @see GL2.Touch#getAction
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTouchEmitter: function()
	{
		return this._touchEmitter;
	},
	
    /**
	 * Set the size of this <code>TouchTarget</code> (<i>width</i> and <i>height</i>).
	 * @example this.t = new GL2.TouchTarget();
	 * this.t.setSize(Core.Capabilities.getScreenHeight(), Core.Capabilities.getScreenHeight());
	 * @param {Core.Size} size The new size of the <code>TouchTarget</code> area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setSize: function(size)
	{
		var s = this._size;
		s.setAll.apply(s, arguments);

		this._setSizeSendGen(s.getWidth(),s.getHeight());
		
		return this;
	},
	
    /**
	 * Set the anchor point used to rotate and scale the <code>TouchTarget</code> area.
	 * @example this.t = new GL2.TouchTarget();
	 * this.t.setAnchor(0, 0);
	 * @param {Core.Point} anchor The new anchor point for the <code>TouchTarget</code> area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAnchor: function(anchor)
	{
		var a = this._anchor;
		a.setAll.apply(a, arguments);
		
		this._setAnchorSendGen(a.getX(),a.getY());
		
		return this;
	},
	
	/**
	 * Translate a global scene location to the local coordinate space.
	 * Use this method when determining <code>touchMoved</code> offsets.
	 * @example var p = Game.getRoot().screenToLocal(touch.getPosition());
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.Vector} location The location to transform.
	 * @status iOS, Android, Flash
	 */
	screenToLocal: function($super, location)
	{
		location = $super(location);
		if(!location)
			return undefined;
		
		var a = this._anchor;
		var s = this._size;
			
		location.setX(location.getX() + a.getX() * s.getWidth());
		location.setY(location.getY() + a.getY() * s.getHeight());
		return location;
	},
	
	/**
	 * Translate a location in the local coordinate space to the global scene coordinate space.
	 * Use this method for translating between local coordinate spaces.
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.Vector} location The location to transform.
	 * @status iOS, Android, Flash
	 */
	localToScreen: function($super, location)
	{
		var a = this._anchor;
		var s = this._size;
			
		location.setX(location.getX() - a.getX() * s.getWidth());
		location.setY(location.getY() - a.getY() * s.getHeight());
		
		location = $super(location);
		if(!location)
			return undefined;
		return location;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 313
	// Method create = -1
	// Method setSize = 2
	// Method setAnchor = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in TouchTarget._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in TouchTarget._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[313] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":313,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_setSizeSendGen: function( width, height )
	{
		Core.Proc.appendToCommandString( ":313,2," + this.__objectRegistryId + "," + width + "," + height  );
	},
	
	/** @private */
	_setAnchorSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":313,3," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// setSize: function( width, height ) {}
	
	// setAnchor: function( x, y ) {}
	

// {{/Wg Generated Code}}
});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Root'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Root'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Root'] = exports; var Core = require('NGCore/Client/Core').Core;
var Touch = require('NGCore/Client/GL2/Touch').Touch;

exports.Root = Core.Class.singleton(
/** @lends GL2.Root.prototype */
{
	classname: 'Root',
	
	/**
	 * @class The <code>Root</code> class constructs a singleton object that serves as the proxy object for the {@link UI.GLView} node hierarchy.
	 * <code>Root</code> is the root element of the node hierarchy (also known as a scene graph) for <code>GLView</code>.
	 * The <code>Root</code> transform is composed at the upper left corner of the view with a descending <i>y</i> axis.<br><br>
	 * Adding a node to the <code>Root</code> ensures applications include it when determining drawing and touch events.
	 * @constructs The default constructor.
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		
		this._children = [];
		
		this._createSendGen(this.__objectRegistryId);
		
		this._touchTracking = {};
	},
	
	/**
	 * Add a node and the node subtree to the root of the scene graph.
	 * @example var spr = new GL2.Sprite();
	 * ...
	 * GL2.Root.addChild(spr);
	 * @param {GL2.Node} child The node to add.
	 * @see GL2.Root#removeChild
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	addChild: function(child)
	{
		this._children.push(child);
		child._didAddToParent(this);
		
		this._addChildSendGen(Core.ObjectRegistry.objectToId(child));
	},
	
	/**
	 * Remove the child node and the node subtree from the root of the scene graph.<br><br>
	 * <b>Note:</b> This method will not destroy the node. You can keep or destroy a reference to a node 
	 * if you have no further use for it.
	 * @example GL2.Root.removeChild(spr);
	 * @throws {removeChild called for a node that is not a child} Specified node is not a child node.
	 * @param {GL2.Node} child The node to remove.
	 * @see GL2.Root#addChild
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	removeChild: function(child)
	{
		child._willRemoveFromParent();
		
		var index = this._children.indexOf(child);
		if(index == -1)
			throw new Error('removeChild called for a node that is not a child');
		this._children.splice(index, 1);
		
		this._removeChildSendGen(Core.ObjectRegistry.objectToId(child));
	},
	
	/** 
	 * Translate screen coordinates into node coordinates.
	 * @example var p = Game.getRoot().screenToLocal(touch.getPosition());
	 * @param {Core.Vector} location The screen coordinates to translate.
	 * @returns The location as node coordinates.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	screenToLocal: function(location)
	{
		return location;
	},
	
	/** 
	 * Translate node coordinates into screen coordinates.
	 * @param {Core.Vector} location The node coordinates to translate.
	 * @returns The location as screen coordinates.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	localToScreen: function(location)
	{
		return location;
	},
	
	_onTouchEventRecv: function( cmd )
	{
		var msg = {};
		if(!this._onTouchEventRecvGen(cmd, msg))
			return;
		
		// Build touch object.
		var touchId = msg.touchId;
		var touchAction = msg.touchAction;
		var touch = new Touch();
		touch._setId(touchId);
		touch._setAction(touchAction);
		touch._setPosition(msg.x, msg.y);
		
		// Extract all touch targets.
		var ids = [];
		for(var i=0; i < msg.touchTargetCount; ++i)
		{
			var t = {};
			if(!this._touchTargetRecvGen(cmd, t))
				return;
			// Add an array entry for every touch event that we have gotten from native.
			ids.push(t.nodeId);
		}
		
		touch._setTargetIds(ids);
		
		switch(touchAction)
		{
			case Touch.Action.Start:
				// Dispatch to all touch targets until one handles it.
				for(var key in ids)
				{
					var id=ids[key];
					var o = Core.ObjectRegistry.idToObject(id);
					if(o && o.getTouchEmitter().chain(touch))
					{
						this._touchTracking[touchId] = id;
						break;
					}
				}
				break;
			case Touch.Action.End:
				// Dispatch to tracking object.
				var track = this._touchTracking[touchId];
				if(track)
				{
					var o = Core.ObjectRegistry.idToObject(track);
                    if (o)
                        o.getTouchEmitter().chain(touch);
					delete this._touchTracking[touch.getId()];
				}
				break;
			case Touch.Action.Move:
				// Dispatch to tracking object.
				var track = this._touchTracking[touchId];
				if(track)
				{
					var o = Core.ObjectRegistry.idToObject(track);
                    if (o)
                        o.getTouchEmitter().chain(touch);
				}
				break;
		}
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 309
	// Method create = -1
	// Method addChild = 2
	// Method removeChild = 3
	// Method onTouchEvent = 4
	// Method touchTarget = 5
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 4:
					instance._onTouchEventRecv( cmd );
					break;
				case 5:
					instance._touchTargetRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Root._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Root._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[309] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onTouchEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length < 5 )
		{
			NgLogE("Could not parse due to wrong argument count in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		obj[ "touchId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "touchId" ] === undefined )
		{
			NgLogE("Could not parse touchId in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		obj[ "touchAction" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "touchAction" ] === undefined )
		{
			NgLogE("Could not parse touchAction in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 3 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		obj[ "touchTargetCount" ] = Core.Proc.parseInt( cmd[ 4 ] );
		if( obj[ "touchTargetCount" ] === undefined )
		{
			NgLogE("Could not parse touchTargetCount in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		cmd.splice(0, 5);
		return true;
	},
	
	/** @private */
	_touchTargetRecvGen: function( cmd, obj )
	{ 
		if( cmd.length < 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Root.touchTarget from command: " + cmd );
			return false;
		}
		
		obj[ "nodeId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "nodeId" ] === undefined )
		{
			NgLogE("Could not parse nodeId in Root.touchTarget from command: " + cmd );
			return false;
		}
		
		cmd.splice(0, 1);
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":309,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_addChildSendGen: function( child )
	{
		Core.Proc.appendToCommandString( ":309,2," + this.__objectRegistryId + "," + child  );
	},
	
	/** @private */
	_removeChildSendGen: function( child )
	{
		Core.Proc.appendToCommandString( ":309,3," + this.__objectRegistryId + "," + child  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// addChild: function( child ) {}
	
	// removeChild: function( child ) {}
	
	// _onTouchEventRecv: function( cmd ) {}
	// _touchTargetRecv: function( cmd ) {}

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Sprite'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Sprite'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Sprite'] = exports; var Node = require('NGCore/Client/GL2/Node').Node;
var Animation = require('NGCore/Client/GL2/Animation').Animation;
var Core = require('NGCore/Client/Core').Core;

exports.Sprite = Node.subclass(
/** @lends GL2.Sprite.prototype */
{
	classname: 'Sprite',
	
	/**	 
	 * @class The <code>Sprite</code> class constructs objects that are used to display either a single image file 
	 * (see <code><a href="GL2.Sprite.html#setImage">setImage()</a></code>) or an animation.<br><br>
	 * Sprites apply their composite node transform and color to the final 
	 * rendered output of each <code><a href="GL2.Animation.Frame.html">frame</a></code> they display. Frames manage the
	 * pre-transform offset within the image. The pre-transform offset is used by frames for rotation and scale of the image. Combining these
	 * two features, an application can accurately place an image within the view.<br><br>
	 * Animations that reach the end of the last animation frame will trigger the
	 * <code>AnimationCompleteEmitter</code> (see <code><a href="GL2.Sprite.html#getAnimationCompleteEmitter">getAnimationCompleteEmitter()</a></code>). 
	 * All other cases, such as setting a new
	 * animation, does not trigger the emitter.<br><br>
	 * <b>Note:</b> The tick rate for any animation instantiated through <code>Sprite</code> is set through <code>{@link Core.UpdateEmitter#setTickRate}</code>.
	 * @constructs The default constructor.
	 * @augments GL2.Node
	 */
    initialize: function()
    {
		this._clubObject = null;
        this._animation = null;
		this._ownsAnimation = false;
		
		this._animationCompleteEmitter = new Core.MessageEmitter();
    },

	/**
	 * The default destructor.
	 * This call cleans up any attached <code>Animation</code> and <code>AnimationCompleteEmitter</code> objects.
	 * @see GL2.Animation,
	 * @see GL2.Sprite#getAnimationCompleteEmitter
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		this._tryDestroyAnimation();
		this._animationCompleteEmitter.destroy();
	},
	
	/**
	 * Retrieve the current <code>Sprite</code> animation.
	 * If the sprite is rendering a single image animation through <code>setImage()</code>,
	 * this method will return <code>undefined</code>.
	 * @returns {GL2.Animation} The current animation. Returns <code>null</code> if the application is not currently playing an animation.
	 * @see GL2.Sprite#setAnimation,
	 * @see GL2.Sprite#setImage
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAnimation: function()
	{
		if(this._ownsAnimation) return null;
		
		return this._animation;
	},
    
    /**
	 * Retrieve the animation complete emitter for this <code>Sprite</code>.
	 *
	 * This emitter is triggered when one of the following conditions occurs:<br><br>
	 *<ul>
	 * <li>The sprite reaches the end of an animation for which the last frame has a duration of <code>0</code>.</li>
	 * <li>A <code>setAnimation()</code> or a <code>setImage()</code> call resets the animation complete emitter.</li>
	 *</ul>
	 * Any code that requires notification when an animation completes should register as a 
	 * listener to this emitter. The emitter callback will pass this sprite as the only parameter.<br><br>
	 * <b>Note:</b> Looping animations and starting new animations do not trigger this emitter.
	 * @returns {Core.MessageEmitter} The emitter that triggers the completion callback.
	 * @see GL2.Sprite#setAnimation,
	 * @see GL2.Sprite#setImage	 
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAnimationCompleteEmitter: function()
	{
		return this._animationCompleteEmitter;
	},
    
    /**
	 * Begin playing the specified animation with this <code>Sprite</code>.
	 * If the sprite is playing another animation at the time of this call, the new animation will take priority over the sprite.
	 * The previous animation will stop and the complete emitter will not respond. This is because the animation did not technically complete a full playback cycle. 
	 * <br><br>
	 * <b>Note:</b> You can release the resources for any animation set with <code>setAnimation()</code> from the native backend if no other frame
	 * contains it.
	 * @example var animation = Animation.getNamed('background');
	 * ...
	 * var sprite = new GL2.Sprite();
	 * sprite.setAnimation(animation);
	 * @param {GL2.Animation} animation The animation to play.
	 * @param {Number} [startTime=0] The time offset where playback should start relative to the actual start of the animation. Expressed in milliseconds.<br><br>
	 * <b>Example:</b> If <code>setAnimation()</code> is called with a <code>startTime</code> equal to half the total duration of the animation, 
	 * playback begins half way through the animation.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setAnimation: function(animation, startTime)
	{
		this._tryDestroyAnimation();
		this._animation = animation;
		
		this._setAnimationSendGen(Core.ObjectRegistry.objectToId(animation), startTime || 0);
		
		return this;
	},
    
    /**
	 * Set a static image as the current animation for this <code>Sprite</code>.
	 * Internally, this method instantiates a single frame animation of infinite duration using the
	 * specified image. If the sprite is playing another animation at the time of this call, the new animation will take priority over the sprite.
	 * The previous animation will stop and the complete emitter will not respond. This is because the animation did not technically complete a full playback cycle. 
	 * <br><br>
	 * <b>Note:</b> You can release the resources for any image set with <code>setImage()</code> from the native backend if no other frame
	 * contains it.
	 * @example var myImage = new GL2.Sprite();
	 * myImage.setImage('./Content/animation.png', size);
	 * @param {String} image The directory path to an image resource.
	 * @param {Core.Size} [size] The size of the image to display (in pixels).
	 * @param {Core.Point} [anchor] The anchor coordinates that indicate the image center in the animation.
	 * @param {Core.Rect} [uvs] The UV coordinates used to specify the subset of an image.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setImage: function(image, size, anchor, uvs)
	{
		this._tryDestroyAnimation();
		
		// Create a single frame animation.
		var args = Array.prototype.slice.call(arguments, 0);
		args.splice(1, 0, 0); // Insert a duration of zero into our arguments.
		var frame = new Animation.Frame();
		frame.constructor.apply(frame, args);
		var animation = new Animation();
		animation.pushFrame(frame);
		
		this._animation = animation;
		this._ownsAnimation = true;
		
		this._setAnimationSendGen(Core.ObjectRegistry.objectToId(animation),0);
		
		return this;
	},
	
	_tryDestroyAnimation: function()
	{
		if(this._ownsAnimation)
		{
			// Set our animation to NULL to unlink ourselves from the animation on the backend
			// or else trying to destory the animation will fail because we are still using it.
			this._setAnimationSendGen(0,0);
		
			this._animation.destroy();
			this._animation = null;
			this._ownsAnimation = false;
		}
		this._animation = null;
	},
	
	_animationCompleteRecv: function(cmd)
	{
		var msg = {};
		if(!this._animationCompleteRecvGen(cmd, msg))
			return;
		
		this._animationCompleteEmitter.emit(this);
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 310
	// Method create = -1
	// Method setAnimation = 2
	// Method animationComplete = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 3:
					instance._animationCompleteRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Sprite._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Sprite._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[310] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_animationCompleteRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in Sprite.animationComplete from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":310,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_setAnimationSendGen: function( animation, startTime )
	{
		Core.Proc.appendToCommandString( ":310,2," + this.__objectRegistryId + "," + animation + "," + startTime  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// setAnimation: function( animation, startTime ) {}
	
	// _animationCompleteRecv: function( cmd ) {}

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Text'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Text'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Text'] = exports; var Node = require('NGCore/Client/GL2/Node').Node;
var Core = require('NGCore/Client/Core').Core;

exports.Text = Node.subclass(
/** @lends GL2.Text.prototype */
{
	classname: 'Text',
    
	/**
	 * @class The <code>Text</code> class constructs objects that provide font specifications to the GL2 module. 
	 * <code>Text</code> objects define positionable areas for rendering text strings as application labels.
	 * @constructs The default constructor. 
	 * @augments GL2.Node
	 * @param {String} [text] The text string to render in the constructor.
	 */
    initialize: function(text)
    {
		this._size = new Core.Size();
		this._anchor = new Core.Point(0.5, 0.5);
        this._horizontalAlign = this.HorizontalAlign.Center;
        this._verticalAlign = this.VerticalAlign.Middle;
        this._text = '';
		if (text)
			 this.setText(text);
							 
        this._fontFamily = '';
        this._fontSize = 18;
		this._overflowMode = this.OverflowMode.Multiline;
		this._fontLocation = this.FontLocation.Default;
    },
    
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
	},
	
	/**
	 * Retrieve the size of the text area from this <code>Text</code> node.
	 * The text area size is defined through two components: <i>width</i> and <i>height</i>.
	 * A value of <code>0</code> for either component means the text area will expand to the size of the string.
	 * @returns {Core.Vector} The current size of the text area (expressed as points).
	 * @see GL2.Text#setSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSize: function()
	{
		return this._size;
	},
	
	/**
	 * Retrieve the placement offset for translating before applying the transform of this <code>Text</code> node.
	 * This value is specified as a multiple of the text area size with <code>(0,0)</code> as the top-left corner.
	 * @returns {Core.Vector} The current placement offset.
	 * @see GL2.Text#setAnchor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAnchor: function()
	{
		return this._anchor;
	},
	
	/**
	 * Retrieve the horizontal alignment of the text area from this <code>Text</code> node.
	 * @returns {GL2.Text#HorizontalAlign} The current horizontal alignment of the text area.
	 * @see GL2.Text#setHorizontalAlign
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getHorizontalAlign: function()
	{
		return this._horizontalAlign;
	},
	
	/**
	 * Retrieve the vertical alignment of the text area from this <code>Text</code> node.
	 * @returns {GL2.Text#VerticalAlign} The curren vertical alignment of the text area.
	 * @see GL2.Text#setVerticalAlign
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getVerticalAlign: function()
	{
		return this._verticalAlign;
	},
	
	/**
	 * Retrieve the text string this <code>Text</code> node will render.
	 * @returns {String} The current text string to render in the text area.
	 * @see GL2.Text#setText
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getText: function()
	{
		return this._text;
	},
	
	/**
	 * Retrieve the font family for the text area from this <code>Text</code> node.
	 * The GL2 module uses Arial as the text area font family when this value is undefined.<br><br>
	 * <b>Note:</b> <code>Text</code> nodes default to Arial as the font family when an application cannot load the specified font.
	 * @returns The current font family defined for the text area.
	 * @see GL2.Text#setFontFamily
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getFontFamily: function()
	{
		return this._fontFamily;
	},
	
	/**
	 * Retrieve the font size for the text area from this <code>Text</code> node.
	 * @returns {Number} The current font size defined for the text area.
	 * @see GL2.Text#setFontSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFontSize: function()
	{
		return this._fontSize;
	},
	
	/**
	 * Retrieve the overflow style of the text area from this <code>Text</code> node. 
	 * @returns {GL2.Text#OverflowMode} The current overflow style defined for the text area.
	 * @see GL2.Text#setOverflowMode,
	 * @see GL2.Text#OverflowMode
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getOverflowMode: function()
	{
		return this._overflowMode;
	},
	
    /**
	 * Set the size in pixels of the text area for this <code>Text</code> node.
	 * The text area size is defined through two components: <i>width</i> and <i>height</i>. 
	 * @example var w = Core.Capabilities.getScreenWidth();
	 * var h = Core.Capabilities.getScreenHeight();
	 * ...
	 * var label = new GL2.Text();
	 * label.setSize(w, h);
	 * @param {Core.Vector} size A new vector specifying the text area size in pixels.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Text#getSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setSize: function(size)
	{
		var s = this._size;
		s.setAll.apply(s, arguments);

		this._setSizeSendGen(s.getWidth(),s.getHeight());
		
		return this;
	},
	
    /**
	 * Set the text area offset as a multiple of the area size (<i>width</i> and <i>height</i>).
	 * An <code>Anchor</code> defines a location the text area will rotate and scale around; <code>Anchors</code> are applied
	 * to the drawing prior to the composite transform for the node. When the text size of the text area is <code>0</code> in either
	 * dimension, the offset is measured from the rendered size of the string in that dimension.<br><br>
	 * <b>Example:</b> If you want to display a text area as centered, you can set the <code>horizontalAlign</code> to
	 * <code>centered</code> and set the <code>anchor</code> to <code>[0.5,h]</code> with <i>h</i> representing a vertical offset.
	 * @example text.setAnchor(0.5,h);
	 * @param {Core.Vector} location A new vector specifying the offset location.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node,
	 * @see GL2.Text#getAnchor,
	 * @see GL2.Text#setHorizontalAlign
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAnchor: function(location)
	{
		var a = this._anchor;
		a.setAll.apply(a, arguments);
		
		this._setAnchorSendGen(a.getX(),a.getY());
		
		return this;
	},
	
    /**
	 * Set the horizontal alignment of the text area for this <code>Text</code> node.
	 * @example var t = new GL2.Text(this._label);
	 * ...
	 * t.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
	 * @param {GL2.Text#HorizontalAlign} horizontalAlign The new horizontal alignment for the text area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setHorizontalAlign: function(horizontalAlign)
	{
		this._horizontalAlign = horizontalAlign;
		
		this._setHorizontalAlignSendGen(horizontalAlign);
		
		return this;
	},
    
    /**
	 * Set the vertical alignment of the text area for this <code>Text</code> node.
	 * @example var t = new GL2.Text(this._label);
	 * ...
	 * t.setVerticalAlign(GL2.Text.VerticalAlign.Middle);
	 * @param {GL2.Text#VerticalAlign} verticalAlign The new vertical alignment for the text area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Text#getVerticalAlign
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setVerticalAlign: function(verticalAlign)
	{
		this._verticalAlign = verticalAlign;
		
		this._setVerticalAlignSendGen(verticalAlign);
		
		return this;
	},
    
    /**
	 * Set the text string to render in the text area of this <code>Text</code> node.
	 * @example var label = new GL2.Text();
	 * ...
	 * label.setText('This is a label');
	 * @param {String} text The new text string to render in the text area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Text#getText
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setText: function(text)
	{
		this._text = text;
		
		this._setTextSendGen(text);
		
		return this;
	},
    
    /**
	 * Set the font family to use for rendering text strings in the text area of this <code>Text</code> node.<br><br>
	 * Using this call to set application specific fonts (os-independent) requires you to add the font file name with extension (.ttf) to the manifest.json.
	 * The font family file must reside in the <code>Content</code> directory. The font family file name is passed in this call. The font face is applied to each object of type 
	 * <code>GL2.Text</code> that will override the system font.
	 * @example var font = new GL2.Text();
	 * ...
	 * font.setFontFamily("Content/Cacophony.ttf");
	 * @param {String} [fontFamily=Arial] The new font family to render in the text area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Text#getFontFamily
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setFontFamily: function(fontFamily)
	{
		this._fontFamily = fontFamily;
		
		this._setFontFamilySendGen(fontFamily);
		
		return this;
	},
    
    /**
	 * Set the text area font size for this <code>Text</code> node.
	 * @example var fontSize = 24;
	 *
	 * var font = new GL2.Text();
	 * ...
	 * font.setFontSize(fontSize);
	 * @param {Number} [fontSize=18pt] The new font size for text strings (expressed in points).
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Text#getFontSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setFontSize: function(fontSize)
	{
		this._fontSize = fontSize;
		
		this._setFontSizeSendGen(fontSize);
		
		return this;
	},
	
	/**
	 * Set the overflow style of the text area for this <code>Text</code> node. 
	 * This method defines how a <code>Text</code> node will fit a rendered string inside 
	 * the text area when the string is too long.
	 * @example var font = new GL2.Text();
	 * ...
	 * font.setOverflowMode(GL2.Text.OverflowMode.ReduceFontSize);
	 * @param {GL2.Text#OverflowMode} overflowMode The overflow rendering style for long text strings.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Text#getOverflowMode,
	 * @see GL2.Text#OverflowMode
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setOverflowMode: function(overflowMode)
	{
		this._overflowMode = overflowMode;
		
		this._setOverflowModeSendGen(overflowMode);
		
		return this;
	},
	
	/**
	 * Set the directory path to the location of a font used by this <code>Text</code> node.
	 * @example var font = new GL2.Text();
	 * ...
	 * font.setFontLocation(GL2.Text.FontLocation.System);
	 * @param {String} fontLocation The new directory path to a font used in the text area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setFontLocation: function(fontLocation)
	{
		this._fontLocation = fontLocation;
		
		this._setFontLocationSendGen(fontLocation);
		
		return this;
	},
	
	/**
	 * Translate a global scene location to the local coordinate space of this <code>Text</code> node.
	 * Use this method when determining <code>touchMoved</code> offsets.
	 * @example var p = Game.getRoot().screenToLocal(touch.getPosition());
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.Vector} location The location to transform.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	screenToLocal: function($super, location)
	{
		location = $super(location);
		if(!location)
			return undefined;
		
		var a = this._anchor;
		var s = this._size;
			
		location.setX(location.getX() + a.getX() * s.getWidth());
		location.setY(location.getY() + a.getY() * s.getHeight());
		return location;
	},
	
	/**
	 * Translate a location in the local coordinate space to the global scene coordinate space of this <code>Text</code> node.
	 * Use this method for translating between local coordinate spaces.
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.Vector} location The location to transform.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	localToScreen: function($super, location)
	{
		var a = this._anchor;
		var s = this._size;
			
		location.setX(location.getX() - a.getX() * s.getWidth());
		location.setY(location.getY() - a.getY() * s.getHeight());
		
		location = $super(location);
		if(!location)
			return undefined;
		return location;
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration for horizontal alignment modes.
	 * @namespace
	 */
	HorizontalAlign:
	{ 
		/** Align text to the left. */
		Left: 0,
		/** Align text in the center. */
		Center: 1,
		/** Align text to the right. */
		Right: 2,
	},
	
	/** 
	 * Enumeration for vertical alignment modes.
	 * @namespace
	 */
	VerticalAlign:
	{ 
		/** Align text to the top. */
		Top: 0,
		/** Align text in the middle. */
		Middle: 1,
		/** Align text to the bottom. */
		Bottom: 2,
	},
	
	/** 
	 * Enumeration for the behavior when there is too much text to fit on one line.
	 * @namespace
	 */
	OverflowMode:
	{ 
		/** Reduce the font size until the text fits. */
		ReduceFontSize: 0,
		/** Break the text across multiple lines. */
		Multiline: 1,
	},
	
	/** 
	 * Enumeration for location of fonts.
	 * @namespace
	 */
	FontLocation:
	{ 
		/** Use Default fonts. */
		Default: 0,
		/** Use System fonts. */
		System: 1,
		/** Use bundled fonts that ship with engine and available to all apps. */
		Bundled: 2,
		/** Use custom fonts that are loaded with app manifest. */
		Manifest: 3,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 311
	// Method create = -1
	// Method destroy = 2
	// Method setSize = 3
	// Method setAnchor = 4
	// Method setHorizontalAlign = 5
	// Method setVerticalAlign = 6
	// Method setText = 7
	// Method setFontFamily = 8
	// Method setFontSize = 9
	// Method setOverflowMode = 10
	// Method setFontLocation = 11
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Text._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Text._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[311] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":311,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":311,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setSizeSendGen: function( width, height )
	{
		Core.Proc.appendToCommandString( ":311,3," + this.__objectRegistryId + "," + width + "," + height  );
	},
	
	/** @private */
	_setAnchorSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":311,4," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setHorizontalAlignSendGen: function( align )
	{
		Core.Proc.appendToCommandString( ":311,5," + this.__objectRegistryId + "," + align  );
	},
	
	/** @private */
	_setVerticalAlignSendGen: function( align )
	{
		Core.Proc.appendToCommandString( ":311,6," + this.__objectRegistryId + "," + align  );
	},
	
	/** @private */
	_setTextSendGen: function( text )
	{
		Core.Proc.appendToCommandString( ":311,7," + this.__objectRegistryId + "," + Core.Base64.encode( text )  );
	},
	
	/** @private */
	_setFontFamilySendGen: function( fontFamily )
	{
		Core.Proc.appendToCommandString( ":311,8," + this.__objectRegistryId + "," + Core.Base64.encode( fontFamily )  );
	},
	
	/** @private */
	_setFontSizeSendGen: function( fontSize )
	{
		Core.Proc.appendToCommandString( ":311,9," + this.__objectRegistryId + "," + fontSize  );
	},
	
	/** @private */
	_setOverflowModeSendGen: function( overflowMode )
	{
		Core.Proc.appendToCommandString( ":311,10," + this.__objectRegistryId + "," + overflowMode  );
	},
	
	/** @private */
	_setFontLocationSendGen: function( fontLocation )
	{
		Core.Proc.appendToCommandString( ":311,11," + this.__objectRegistryId + "," + fontLocation  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setSize: function( width, height ) {}
	
	// setAnchor: function( x, y ) {}
	
	// setHorizontalAlign: function( align ) {}
	
	// setVerticalAlign: function( align ) {}
	
	// setText: function( text ) {}
	
	// setFontFamily: function( fontFamily ) {}
	
	// setFontSize: function( fontSize ) {}
	
	// setOverflowMode: function( overflowMode ) {}
	
	// setFontLocation: function( fontLocation ) {}
	

// {{/Wg Generated Code}}
});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/RenderTarget'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/RenderTarget'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/RenderTarget'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.RenderTarget = Core.Class.subclass(
	/** @lends GL2.RenderTarget.prototype */
{
	classname: 'RenderTarget',

	/**
	 * @class The GL2.RenderTarget object is used to render a set of GL2.Nodes into a texture target.
	 * this target can then be attached to GL2.Animation.Frames and rendered attached to a GL2.Sprite or GL2.Primitive node.
	 *
	 * @constructs Constructs a new GL2.RenderTarget object.
	 * @param {Number} width Width of texture, must be power of two.
	 * @param {Number} height Height of texture, must be power of two.
	 * @param {bool} [isOpaque] When false (the default) the texture will include an alpha channel, when true the texture will be opaque.
	 */
	initialize: function (width, height, isOpaque, sizePolicy) {
		Core.ObjectRegistry.register(this);
		this._children = [];
		this._width = width;
		this._height = height;
		this._isOpaque = isOpaque ? true : false;
		this._createSendGen(this.__objectRegistryId, width, height, this._isOpaque);
		this._callbackIndexCounter = 1;
		this._callbacks = [];
	},

	/**
	 * Destroys the texture target.
	 */
	destroy: function () {
		var children = this._children;
		while (children.length) {
			this.removeChild(children[0]);
		}
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},

	/**
	 * Adds a GL2.Node object to the RenderTarget.  Visual changes will take effect on the next update.
	 * @param {GL2.Node} child Node to be added.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 */
	addChild: function (child) {
		this._children.push(child);
		child._didAddToParent(this);
		this._addChildSendGen(Core.ObjectRegistry.objectToId(child));
		return this;
	},

	/**
	 * Removes a GL2.Node object from the RenderTarget. Visual changes will take effect on the next update.
	 * @param {GL2.Node} child Node to be removed.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 */
	removeChild: function (child) {
		child._willRemoveFromParent();
		var index = this._children.indexOf(child);
		if (index === -1)
			throw new Error('removeChild called for a node that is not a child');
		this._children.splice(index, 1);
		this._removeChildSendGen(Core.ObjectRegistry.objectToId(child));
		return this;
	},

	/**
	 * Render all the currently attached GL2.Nodes into the texture target.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 */
	update: function () {
		this._updateSendGen();
		return this;
	},

	/**
	 * Automatically render all currently attached GL2.Nodes every frame.
	 * This has the same effect as calling the update method on every frame.
	 * @param {bool} [autoUpdateEnable] Defaults to true, which causes the texture to be updated frame.  Set to false to stop auto updates.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 */
	setAutoUpdate: function (autoUpdateEnable) {
		var enable = (autoUpdateEnable || (autoUpdateEnable === undefined)) ? true : false;
		this._setAutoUpdateSendGen(enable);
		return this;
	},

	/**
	 * Clear texture background before rendering.  By default the background is not cleared.
	 * @param {bool} [clearEnabled] Defaults to true, causing the texture to be cleared before nodes are drawn.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 */
	setClearEnable : function (clearEnable) {
		var enable = (clearEnable || (clearEnable === undefined)) ? true : false;
		this._setClearEnableSendGen(enable);
		return this;
	},

	/**
	 * Set background color of texture.  Can be called with a single Core.color argument or 3 Number arguments.
	 * The default clear color is white.  If the RenderTarget has an alpha component it can be set via the setClearColorAlpha() method.
	 * @param {Number|Core.color} colorOrRed Opaque background color, or the red component if 3 or 4 parameters are given.
	 * @param {Number} [green] Green component of clear color (0, 1).
	 * @param {Number} [blue] Blue component of clear color (0, 1).
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 */
	setClearColor : function () {
		var r, g, b, color;
		if (arguments.length === 1)
		{
			color = arguments[0];
			r = color.getRed();
			g = color.getGreen();
			b = color.getBlue();
		}
		else
		{
			r = arguments[0];
			g = arguments[1];
			b = arguments[2];
		}
		this._setClearColorSendGen(r, g, b);
		return this;
	},

	/**
	 * Set alpha component of background color of texture.
	 * The default clear alpha is 1, opaque.
	 * @param {Number} alpha background color opacity.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 */
	setClearColorAlpha : function (alpha) {
		this._setClearColorAlphaSendGen(alpha);
		return this;
	},

	/**
	 * Save image to the filesystem.
	 * @param {String} filename name of bitmap.
	 * @param {Core.Rect} [rect] Image clip rectangle.  If not specfied the entire RenderTexture will be saved.
	 * @param {Function} [callback] A closure to be executed after image has been saved.  The resulting filename is passed as an argument.
	 */
	save : function (filename, rect, callback) {
		var id = 0;
		if (callback) {
			id = this._callbackIndexCounter++;
			this._callbacks[id] = callback;
		}
		var x = rect ? rect.getOrigin().getX() : -1;
		var y = rect ? rect.getOrigin().getY() : -1;
		var w = rect ? rect.getSize().getWidth() : -1;
		var h = rect ? rect.getSize().getHeight() : -1;
		this._saveSendGen(id, filename, x, y, w, h);
	},

	/**
	 * @private
	 */
	_invokeCallbackRecv: function (cmd)	{
		var msg = {};
		if (!this._invokeCallbackRecvGen(cmd, msg)) {
			return;
		}

		var id = msg.callbackId;
		var err = msg.error;
		if (!id) {
			NgLogE("invokeCallbackRecv command : bad id = " + id);
			return;
		}
		var cb = this._callbacks[id];
		if (!cb) {
			NgLogE("invokeCallbackRecv command : No registered callback found, id = " + id);
			return;
		}
		delete this._callbacks[id];
		cb(err);
	},

	/**
	 * Enable or disable backing store for RenderTarget. Disabled by default
	 * The backing store is used to guarantee that texture will be restored after the application is suspended and restored.
	 * If backing store is not enabled, then the texture is not guaranteed to render correctly after the application is restored.
	 * @param {Bool} [backingStoreEnable] If omitted backing store will be enabled.
	 */
	setBackingStoreEnable: function (backingStoreEnable) {
		var enable = (backingStoreEnable || (backingStoreEnable === undefined)) ? true : false;
		this._setBackingStoreEnableSendGen(enable);
		return this;
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 353
	// Method create = -1
	// Method destroy = 2
	// Method addChild = 3
	// Method removeChild = 4
	// Method update = 5
	// Method setAutoUpdate = 6
	// Method setClearEnable = 7
	// Method setClearColor = 8
	// Method setClearColorAlpha = 9
	// Method save = 10
	// Method invokeCallback = 11
	// Method setBackingStoreEnable = 12
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 11:
					instance._invokeCallbackRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in RenderTarget._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in RenderTarget._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[353] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_invokeCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in RenderTarget.invokeCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in RenderTarget.invokeCallback from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in RenderTarget.invokeCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( objectRegistryId, width, height, isOpaque )
	{
		Core.Proc.appendToCommandString( ":353,-1," + objectRegistryId + "," + width + "," + height + "," + ( isOpaque ? 1 : 0 )  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":353,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_addChildSendGen: function( child )
	{
		Core.Proc.appendToCommandString( ":353,3," + this.__objectRegistryId + "," + child  );
	},
	
	/** @private */
	_removeChildSendGen: function( child )
	{
		Core.Proc.appendToCommandString( ":353,4," + this.__objectRegistryId + "," + child  );
	},
	
	/** @private */
	_updateSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":353,5," + this.__objectRegistryId );
	},
	
	/** @private */
	_setAutoUpdateSendGen: function( autoUpdateEnable )
	{
		Core.Proc.appendToCommandString( ":353,6," + this.__objectRegistryId + "," + ( autoUpdateEnable ? 1 : 0 )  );
	},
	
	/** @private */
	_setClearEnableSendGen: function( clearEnable )
	{
		Core.Proc.appendToCommandString( ":353,7," + this.__objectRegistryId + "," + ( clearEnable ? 1 : 0 )  );
	},
	
	/** @private */
	_setClearColorSendGen: function( r, g, b )
	{
		Core.Proc.appendToCommandString( ":353,8," + this.__objectRegistryId + "," + r + "," + g + "," + b  );
	},
	
	/** @private */
	_setClearColorAlphaSendGen: function( a )
	{
		Core.Proc.appendToCommandString( ":353,9," + this.__objectRegistryId + "," + a  );
	},
	
	/** @private */
	_saveSendGen: function( callbackId, filename, originX, originY, width, height )
	{
		Core.Proc.appendToCommandString( ":353,10," + this.__objectRegistryId + "," + callbackId + "," + Core.Base64.encode( filename ) + "," + originX + "," + originY + "," + width + "," + height  );
	},
	
	/** @private */
	_setBackingStoreEnableSendGen: function( backingStoreEnable )
	{
		Core.Proc.appendToCommandString( ":353,12," + this.__objectRegistryId + "," + ( backingStoreEnable ? 1 : 0 )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( objectRegistryId, width, height, isOpaque ) {}
	
	// destroy: function(  ) {}
	
	// addChild: function( child ) {}
	
	// removeChild: function( child ) {}
	
	// update: function(  ) {}
	
	// setAutoUpdate: function( autoUpdateEnable ) {}
	
	// setClearEnable: function( clearEnable ) {}
	
	// setClearColor: function( r, g, b ) {}
	
	// setClearColorAlpha: function( a ) {}
	
	// save: function( callbackId, filename, originX, originY, width, height ) {}
	
	// _invokeCallbackRecv: function( cmd ) {}
	// setBackingStoreEnable: function( backingStoreEnable ) {}
	

// {{/Wg Generated Code}}

});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Action/ActionManager'] = function(){var exports = $MODULE_REGISTRY['Code/Action/ActionManager'] || {}; $MODULE_REGISTRY['Code/Action/ActionManager'] = exports; var ActionManager = Core.Class.singleton({
    classname : "ActionManager",
    
    initialize : function()
    {
        this._targetsActions = [];
        this._targetsIndex = [];
        
        Core.UpdateEmitter.addListener(new Core.MessageListener(), function(dt)
        {
            this._step(dt / 1000);
        }.bind(this));
    },
    
    numberOfRunningActions : function(/*GL2.Node */target)
    {
        var result = 0;
        var index = this._targetsIndex.indexOf(target);
        if (index != -1)
        {
            var actions = this._targetsActions[index];
            if (actions)
            {
                for ( var i in actions)
                {
                    if (actions[i])
                    {
                        result++;
                    }
                }
            }
        }
        
        return result;
    },
    
    addAction : function(/*Action.Action*/action,/*GL2.Node*/target, /*Boolean*/paused)
    {
        action.startWithTarget(target);
        
        var index = this._targetsIndex.indexOf(target);
        if (index == -1)
        {
            this._targetsIndex.push(target);
            this._targetsActions.push([ action ]);
        }
        else
        {
            this._targetsActions[index].push(action);
        }
    },
    
    removeAllActionsFromTarget : function(/*GL2.Node*/target)
    {
        var index = this._targetsIndex.indexOf(target);
        if (index != -1)
        {
            // delete the element data from both arrays
            this._targetsIndex.splice(index, 1);
            var actions = this._targetsActions.splice(index, 1)[0];
            //destroy the actions
            for ( var i in actions)
            {
                //al_trace("removeAllActionsFromTarget.destroyingAction: " + actions[i]);
                this._destroyAction(actions[i]);
                actions[i] = null;
            }
        }
    },
    
    _step : function(/*Number*/dt)
    {
        for ( var i in this._targetsActions)
        {
            var actions = this._targetsActions[i];
            if (actions)
            {
                for ( var j in actions)
                {
                    var action = actions[j];
                    try
                    {
                        if (action)
                        {
                            if (!action.isDone())
                            {
                                action.step(dt);
                            }
                            else
                            {
                                //al_trace("Destroying finished action: " + action);
                                this._destroyAction(action);
                                actions[j] = null;
                            }
                        }
                    }
                    catch (e)
                    {
                        al_trace("Exception while calling action.step. Exception: " + e.message);
                        this._destroyAction(action);
                        actions[j] = null;
                    }
                    
                }
            }
            
        }
    },
    
    _destroyAction : function(action)
    {
        try
        {
            action && action.destroy();
        }
        catch (e)
        {
            al_trace('Exception while destroying action. Ignored Exception: ' + e);
            throw e;
        }
    }
});

exports.ActionManager = ActionManager;; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Action/Action'] = function(){var exports = $MODULE_REGISTRY['Code/Action/Action'] || {}; $MODULE_REGISTRY['Code/Action/Action'] = exports; var kCCActionTagInvalid = -1;

/**
 * Base class for Action objects.
 */
var Action = Core.Class.subclass({
    classname : 'Action',
    
    initialize : function()
    {
        
        /**
         * The original target, since target can be nil. Is the target that were
         * used to run the action. Unless you are doing something complex, like
         * ActionManager, you should NOT call this method.
         */
        this.originalTarget = null;
        
        /**
         * The "target". The action will modify the target properties. The
         * target will be set with the 'startWithTarget' method. When the 'stop'
         * method is called, target will be set to nil. The target is
         * 'assigned', it is not 'retained'.
         */
        this.target = null;
        
        /** The action tag. An identifier of the action */
        this.tag = 0;
        
    },
    
    /** static builder */
    $action : function()
    {
        return new this();
    },
    
    initialize : function()
    {
        this.originalTarget = this.target = null;
        this.tag = kCCActionTagInvalid;
        return this;
    },
    
    //! return YES if the action has finished
    isDone : function()
    {
        return true;
    },
    
    //! called before the action start. It will also set the target.
    startWithTarget : function(/*GL2.Node*/aTarget)
    {
        this.originalTarget = this.target = aTarget;
    },
    
    //! called after the action has finished. It will set the 'target' to null.
    //! IMPORTANT: You should never call "action.stop()" manually. Instead, use: "target.stopAction(action);"
    stop : function()
    {
        this.target = null;
    },
    
    //! called every frame with it's delta time. DON'T override unless you know what you are doing. dt in seconds
    step : function(/*Number*/dt)
    {
    },
    
    //! called once per frame. time a value between 0 and 1
    //! For example: 
    //! * 0 means that the action just started
    //! * 0.5 means that the action is in the middle
    //! * 1 means that the action is over
    update : function(/*Number*/time)
    {
    },
    
    destroy : function()
    {
    }
});

exports.Action = Action;

/**
 * Base class actions that do have a finite time duration. Possible actions: -
 * An action with a duration of 0 seconds - An action with a duration of 35.5
 * seconds Infinite time actions are valid
 */
var FiniteTimeAction = Action.subclass({
    classname : 'FiniteTimeAction',
    
    initialize : function()
    {
        
        //! duration in seconds of the action
        this.duration = 0;
    },
    
    /** returns a reversed action */
    reverse : function()
    {
        return null;
    }
});

exports.FiniteTimeAction = FiniteTimeAction;

/**
 * Repeats an action for ever. To repeat the an action for a limited number of
 * times use the Repeat action.
 * 
 * @warning This action can't be Sequenceable because it is not an
 *          IntervalAction
 */
var RepeatForever = Action.subclass({
    classname : 'RepeatForever',
    
    initialize : function()
    {
        // the action to repeate
        this.other = null;
    },
    
    /** creates the action */
    $actionWithAction : function(/*IntervalAction*/action)
    {
        return new RepeatForever().initWithAction(action);
    },
    
    /** initializes the action */
    initWithAction : function(/*IntervalAction*/action)
    {
        this.other = action;
        return this;
    },
    
    startWithTarget : function($super,/*GL2.Node*/aTarget)
    {
        $super(aTarget);
        this.other.startWithTarget(aTarget);
    },
    
    step : function(/*Number*/dt)
    {
        this._ddt = this._ddt ? this._ddt + dt : dt;
        //adjust oneOverFPS to slow down the amount of fps for debuging purpose.
        var oneOverFPS = 0;//Example: 1/2 to get 2 fps. Zero to allow the system FPS.
        if (this._ddt > oneOverFPS)
        {
            this.other.step(this._ddt);
            this._ddt = 0;
            
            if (this.other.isDone())
            {
                var diff = this._ddt + this.other.duration - this.other.elapsed;
                this.other.startWithTarget(this.target);
                
                // to prevent jerk. issue #390
                this.other.step(diff);
            }
        }
    },
    
    isDone : function()
    {
        return false;
    },
    
    reverse : function()
    {
        return RepeatForever.actionWithAction(this.other.reverse());
    },
    
    destroy : function()
    {
        this.other.destroy();
    }
});

exports.RepeatForever = RepeatForever;
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Action/EaseAction'] = function(){var exports = $MODULE_REGISTRY['Code/Action/EaseAction'] || {}; $MODULE_REGISTRY['Code/Action/EaseAction'] = exports; var Core = require('NGCore/Client/Core').Core;

var IntervalAction = require('Code/Action/IntervalAction').IntervalAction;

var EaseAction = IntervalAction.subclass({
    classname : 'EaseAction',
    
    other : null,
    
    /** creates the action */
    $actionWithAction : function(/*IntervalAction*/action)
    {
        return new this().initWithAction(action);
    },
    
    /** initializes the action */
    initWithAction : function(/*IntervalAction*/action)
    {
        this.initWithDuration(action.duration);
        this.other = action;
        return this;
    },
    
    startWithTarget : function($super,/*GL2.Node*/aTarget)
    {
        $super(aTarget);
        this.other.startWithTarget(aTarget);
    },
    
    stop : function($super)
    {
        this.other.stop();
        $super();
    },
    
    update : function(/*Number*/t)
    {
        this.other.update(t);
    },
    
    reverse : function()
    {
        return this.actionWithAction(this.other.reverse());
    },
    
    destroy : function()
    {
        this.other.destroy();
    }
});

exports.EaseAction = EaseAction;

var EaseSineInOut = EaseAction.subclass({
    classname : 'EaseSineInOut',
    
    update : function(/*Number*/t)
    {
        this.other.update(-0.5 * (Math.cos(Math.PI * t) - 1));
    }
});

exports.EaseSineInOut = EaseSineInOut;; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Action/IntervalAction'] = function(){var exports = $MODULE_REGISTRY['Code/Action/IntervalAction'] || {}; $MODULE_REGISTRY['Code/Action/IntervalAction'] = exports; var Core = require('NGCore/Client/Core').Core;

var FiniteTimeAction = require('Code/Action/Action').FiniteTimeAction;

var FLT_EPSILON = 1e-15;
var ccpSub = function(/*Core.Point*/a, /*Core.Point*/b)
{
    return new Core.Point(a.getX() - b.getX(), a.getY() - b.getY());
};

var IntervalAction = FiniteTimeAction.subclass({
    classname : 'IntervalAction',
    
    initialize : function()
    {
        /** how many seconds had elapsed since the actions started to run. */
        this.elapsed = null;
        this.firstTick = false;
    },
    
    /** creates the action */
    $actionWithDuration : function(/*Number*/duration)
    {
        return new this().initWithDuration(duration);
    },
    
    /** initializes the action */
    initWithDuration : function(/*Number*/duration)
    {
        this.duration = duration;
        
        // prevent division by 0
        // This comparison could be in step:, but it might decrease the performance
        // by 3% in heavy based action games.
        if (this.duration == 0)
            this.duration = FLT_EPSILON;
        this.elapsed = 0;
        this.firstTick = true;
        return this;
    },
    
    /** returns true if the action has finished */
    isDone : function()
    {
        return (this.elapsed >= this.duration);
    },
    
    step : function(/*Number*/dt)
    {
        if (this.firstTick)
        {
            this.firstTick = false;
            this.elapsed = 0;
        }
        else
            this.elapsed += dt;
        
        this.update(Math.min(1, this.elapsed / this.duration));
    },
    
    startWithTarget : function($super,/*Node*/aTarget)
    {
        $super(aTarget);
        this.elapsed = 0.0;
        this.firstTick = true;
    },
    
    /** returns a reversed action */
    reverse : function()
    {
        throw new Error('ReverseActionNotImplemented');
    }

});

exports.IntervalAction = IntervalAction;

/**
 * Runs actions sequentially, one after another
 */
var Sequence = IntervalAction.subclass({
    classname : 'Sequence',
    
    initialize : function()
    {
        this.actions = [];
        this.split = null;
        this.last = 0;
    },
    
    /** helper constructor to create an array of sequenceable actions */
    $actions : function()
    {
        var now;
        var prev = arguments[0];
        
        for ( var i = 1; i < arguments.length; i++)
        {
            now = arguments[i];
            if (now)
                prev = this.actionOne(prev, now);
            else
                break;
        }
        return prev;
    },
    
    /** creates the action */
    $actionOne : function(/*FiniteTimeAction*/actionOne,/*FiniteTimeAction*/actionTwo)
    {
        return new Sequence().initOne(actionOne, actionTwo);
    },
    
    /** initializes the action */
    initOne : function(/*FiniteTimeAction*/actionOne,/*FiniteTimeAction*/actionTwo)
    {
        
        var d = actionOne.duration + actionTwo.duration;
        this.initWithDuration(d);
        
        this.actions[0] = actionOne;
        this.actions[1] = actionTwo;
        
        return this;
    },
    
    startWithTarget : function($super,/*Node*/aTarget)
    {
        $super(aTarget);
        this.split = this.actions[0].duration / this.duration;
        this.last = -1;
    },
    
    stop : function($super)
    {
        this.actions[0].stop();
        this.actions[1].stop();
        $super();
    },
    
    update : function(/*Number*/t)
    {
        var found = 0;
        var new_t = 0.0;
        
        if (t >= this.split)
        {
            found = 1;
            if (this.split == 1)
                new_t = 1;
            else
                new_t = (t - this.split) / (1 - this.split);
        }
        else
        {
            found = 0;
            if (this.split != 0)
                new_t = t / this.split;
            else
                new_t = 1;
        }
        
        if (this.last == -1 && found == 1)
        {
            this.actions[0].startWithTarget(this.target);
            this.actions[0].update(1.0);
            this.actions[0].stop();
        }
        
        if (this.last != found)
        {
            if (this.last != -1)
            {
                this.actions[this.last].update(1.0);
                this.actions[this.last].stop();
            }
            this.actions[found].startWithTarget(this.target);
        }
        this.actions[found].update(new_t);
        this.last = found;
    },
    
    reverse : function()
    {
        return this.actionOne(this.actions[1].reverse(), this.actions[0].reverse());
    },
    
    destroy : function()
    {
        this.actions[0].destroy();
        this.actions[1].destroy();
    }

});

exports.Sequence = Sequence;

var DelayTime = IntervalAction.subclass({
    classname : 'DelayTime',
    
    update : function(t)
    {
        return;
    },
    
    reverse : function()
    {
        return this.actionWithDuration(this.duration);
    }
});

exports.DelayTime = DelayTime;

/**
 * Moves a GL2.Node object to the position x,y. x and y are absolute coordinates
 * by modifying it's position attribute.
 */
var MoveTo = IntervalAction.subclass({
    classname : 'MoveTo',
    
    initialize : function()
    {
        this.endPosition = null;
        this.startPosition = null;
        this.delta = null;
    },
    
    /** creates the action */
    $actionWithDuration : function(/*Number*/duration,/*Core.Point*/position)
    {
        return new this().initWithDuration(duration, position);
    },
    
    /** initializes the action */
    initWithDuration : function($super,/*Number*/duration,/*Core.Point*/position)
    {
        $super(duration);
        this.endPosition = position;
        return this;
    },
    
    startWithTarget : function($super,/*Node*/aTarget)
    {
        $super(aTarget);
        this.startPosition = this.target.getPosition().clone();
        this.delta = ccpSub(this.endPosition, this.startPosition);
    },
    
    update : function(/*Number*/t)
    {
        //al_trace(this.classname + ".update("+t+")");
        var newPosition = new Core.Point((this.startPosition.getX() + this.delta.getX() * t), (this.startPosition.getY() + this.delta.getY() * t));
        this.target.setPosition(newPosition);
    }

});

exports.MoveTo = MoveTo;

/**
 * Moves a GL2.Node object x,y pixels by modifying it's position attribute. x
 * and y are relative to the position of the object. Duration is is seconds.
 */
var MoveBy = MoveTo.subclass({
    classname : 'MoveBy',
    
    /** creates the action */
    $actionWithDuration : function(/*Number*/duration,/*Core.Point*/deltaPosition)
    {
        return new MoveBy().initWithDuration(duration, deltaPosition);
    },
    
    /** initializes the action */
    initWithDuration : function($super,/*Number*/duration,/*Core.Point*/deltaPosition)
    {
        $super(duration, deltaPosition);
        this.delta = deltaPosition;
        return this;
    },
    
    startWithTarget : function($super,/*Node*/aTarget)
    {
        var dTmp = this.delta;
        $super(aTarget);
        this.delta = dTmp;
    },
    
    reverse : function()
    {
        return this.actionWithDuration(this.duration, new Core.Point(-this.delta.getX(), -this.delta.getY()));
    }

});

exports.MoveBy = MoveBy;

var ScaleTo = IntervalAction.subclass({
    classname : 'ScaleTo',
    
    initialize : function()
    {
        this.scaleX = 0;
        this.scaleY = 0;
        this.startScaleX = 0;
        this.startScaleY = 0;
        this.endScaleX = 0;
        this.endScaleY = 0;
        this.deltaX = 0;
        this.deltaY = 0;
    },
    
    /**
     * Creates the action
     */
    $actionWithDuration : function(/*Number*/t,/*Number*/a,/*Number*/b)
    {
        return new this().initWithDuration(t, a, b);
    },
    
    /**
     * Creates the action
     */
    initWithDuration : function($super,/*Number*/t,/*Number*/a,/*Number*/b)
    {
        // As JavaScript doesn't support method overloading, we have to check if the arguments are defined. 
        $super(t);
        if (typeof (b) == 'undefined')
        {
            /** initializes the action with the same scale factor for X and Y */
            this.endScaleX = a;
            this.endScaleY = a;
        }
        else
        {
            /** creates the action with and X factor and a Y factor */
            this.endScaleX = a;
            this.endScaleY = b;
        }
        
        return this;
    },
    
    startWithTarget : function($super,/*GL2.Node*/aTarget)
    {
        $super(aTarget);
        this.startScaleX = this.target.getScale().getX();
        this.startScaleY = this.target.getScale().getY();
        this.deltaX = this.endScaleX - this.startScaleX;
        this.deltaY = this.endScaleY - this.startScaleY;
    },
    
    update : function(/*Number*/t)
    {
        this.target.setScale((this.startScaleX + this.deltaX * t), (this.startScaleY + this.deltaY * t));
    }
});

exports.ScaleTo = ScaleTo;

/**
 * Scales a GL2.Node object a zoom factor by modifying it's scale attribute.
 */
var ScaleBy = ScaleTo.subclass({
    classname : 'ScaleBy',
    
    startWithTarget : function($super,/*GL2.Node*/aTarget)
    {
        $super(aTarget);
        this.deltaX = this.startScaleX * this.endScaleX - this.startScaleX;
        this.deltaY = this.startScaleY * this.endScaleY - this.startScaleY;
    },
    
    reverse : function()
    {
        return this.actionWithDuration(this.duration, 1 / this.endScaleX, 1 / this.endScaleY);
    }
});

exports.ScaleBy = ScaleBy;

/**
 * Rotates a Node object to a certain angle by modifying it's rotation
 * attribute. The direction will be decided by the shortest angle.
 */
var RotateTo = IntervalAction.subclass({
    classname : 'RotateTo',
    
    initialize : function()
    {
        this.dstAngle = 0;
        this.startAngle = 0;
        this.diffAngle = 0;
    },
    
    /** creates the action */
    $actionWithDuration : function(/*Number*/duration, /*Number*/angle)
    {
        return new this().initWithDuration(duration, angle);
    },
    
    /** initializes the action */
    initWithDuration : function($super,/*Number*/duration, /*Number*/angle)
    {
        $super(duration);
        this.dstAngle = angle;
        return this;
    },
    
    startWithTarget : function($super,/*GL2.Node*/aTarget)
    {
        $super(aTarget);
        
        this.startAngle = this.target.getRotation();
        if (this.startAngle > 0)
            this.startAngle = this.startAngle % 360;
        else
            this.startAngle = this.startAngle % -360;
        
        this.diffAngle = this.dstAngle - this.startAngle;
        if (this.diffAngle > 180)
            this.diffAngle -= 360;
        if (this.diffAngle < -180)
            this.diffAngle += 360;
    },
    
    update : function(/*Number*/t)
    {
        this.target.setRotation(this.startAngle + this.diffAngle * t);
    }
});

exports.RotateTo = RotateTo;

/**
 * Fades Out an object that implements the RGBAProtocol protocol. It modifies
 * the opacity from 1 to 0. The "reverse" of this action is FadeIn.
 */
var FadeOut = IntervalAction.subclass({
    classname : 'FadeOut',
    
    update : function(/*Number*/t)
    {
        this.target.setAlpha(1 - t);
    },
    
    reverse : function()
    {
        return FadeIn.actionWithDuration(this.duration);
    }

});

exports.FadeOut = FadeOut;

/**
 * Fades In an object that implements the RGBAProtocol protocol. It modifies the
 * opacity from 0 to 1. The "reverse" of this action is FadeOut.
 */
var FadeIn = IntervalAction.subclass({
    classname : 'FadeIn',
    
    update : function(/*Number*/t)
    {
        this.target.setAlpha(t);
    },
    
    reverse : function()
    {
        return FadeOut.actionWithDuration(this.duration);
    }

});

exports.FadeIn = FadeIn;
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Action/InstantAction'] = function(){var exports = $MODULE_REGISTRY['Code/Action/InstantAction'] || {}; $MODULE_REGISTRY['Code/Action/InstantAction'] = exports; var Core = require('NGCore/Client/Core').Core;

var FiniteTimeAction = require('Code/Action/Action').FiniteTimeAction;

var InstantAction = FiniteTimeAction.subclass({
    classname : 'InstantAction',
    
    initialize : function()
    {
        /** how many seconds had elapsed since the actions started to run. */
        this.duration = 0;
    },
    
    /** returns true if the action has finished */
    isDone : function()
    {
        return true;
    },
    
    step : function(/*Number*/dt)
    {
        this.update(1);
    },
    
    /** returns a reversed action */
    reverse : function()
    {
        this;
    }

});

exports.InstantAction = InstantAction;

/**
 * Hide the node
 */
var Hide = InstantAction.subclass({
    classname : 'Hide',
    
    startWithTarget : function($super,/*GL2.Node*/aTarget)
    {
        $super(aTarget);
        this.target.setVisible(false);
    },
    
    reverse : function()
    {
        return Show.action();
    }

});

exports.Hide = Hide;

/**
 * Show the node
 */
var Show = InstantAction.subclass({
    classname : 'Show',
    
    startWithTarget : function($super,/*GL2.Node*/aTarget)
    {
        $super(aTarget);
        this.target.setVisible(true);
    },
    
    reverse : function()
    {
        return Hide.action();
    }

});

exports.Show = Show;

var CallFunc = InstantAction.subclass({
    classname : 'CallFunc',
    
    $actionWithTarget : function(t, s)
    {
        return new this().initWithTarget(t, s);
    },
    
    initWithTarget : function(t, s)
    {
        this.targetCallback = t;
        this.selector = s;
        
        return this;
    },
    
    startWithTarget : function($super, /* GL2.Node */aTarget)
    {
        $super(aTarget);
        this.execute();
    },
    
    execute : function()
    {
        this.selector.call(this.targetCallback);
    }
});

exports.CallFunc = CallFunc;; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Utils/SyncKeyValue'] = function(){var exports = $MODULE_REGISTRY['Code/Utils/SyncKeyValue'] || {}; $MODULE_REGISTRY['Code/Utils/SyncKeyValue'] = exports; var SyncKeyValue = Core.Class.subclass({
    classname : "SyncKeyValue",
    
    initialize : function(/*String*/storeKey,/*Array*/knownKeys)
    {
        this._store = Storage.KeyValueCache.global("TinyTowers." + storeKey);
        this._knownKeys = knownKeys;
        this._cachedData = [];
    },
    
    preloadKnownKeys : function(cb)
    {
        this.__readyArr = [];
        
        var myCb = function(j, error, data, key)
        {
            this.__readyArr[j] = true;
            if (data)
            {
                this._cachedData[this._knownKeys[j]] = JSON.parse(data);
            }
            else
            {
                if (error.indexOf('Could not find key') == 0 || error.indexOf('No Results') != -1)
                {
                    al_trace('SyncKeyValue.preloadKnownKeys: Key "' + key + '" not found.');
                }
                else
                {
                    al_trace('SyncKeyValue.preloadKnownKeys: Key "' + key + '" could not be read from disk. Error: ' + error);
                }
            }
        };
        
        for ( var i in this._knownKeys)
        {
            this.__readyArr[i] = false;
            this._store.getItem(this._knownKeys[i], myCb.bind(this, Number(i)));
        }
        
        function checkReady()
        {
            var ready = true;
            for ( var i in this._knownKeys)
            {
                ready = ready && this.__readyArr[i];
            }
            
            if (ready)
            {
                cb.call();
            }
            else
            {
                setTimeout(checkReady.bind(this), 100);
            }
        }
        
        setTimeout(checkReady.bind(this), 100);
    },
    
    objectForKey : function(/*String*/key)
    {
        if (this._checkKey(key))
        {
            return this._cachedData[key];
        }
    },
    
    integerForKey : function(/*String*/key)
    {
        if (this._checkKey(key))
        {
            return Number(this._cachedData[key]);
        }
    },
    
    setObject : function(/*String*/value, /*String*/key)
    {
        if (this._checkKey(key))
        {
            this._cachedData[key] = value;
            this._store.setItem(key, JSON.stringify(value), function(_error, _key)
            {
                al_trace('Data Persisted for key: '+key);
            }.bind(this));
        }
    },
    
    stringForKey : function(key)
    {
        return this.objectForKey(key);
    },
    
    doubleForKey : function(key)
    {
        var result = Number(this.objectForKey(key));
        if (isNaN(result))
        {
            result = 0;
        }
        
        return result;
    },
    
    removeObjectForKey : function(/*String*/key)
    {
        if (this._checkKey(key))
        {
            this._cachedData[key] = null;
            this._store.removeItem(key, function(_error, _key)
            {
                //al_trace('Data Removed for key: '+key);
            }.bind(this));
        }
    },
    
    _checkKey : function(/*String*/key)
    {
        if (this._knownKeys.indexOf(key) != -1)
        {
            return true;
        }
        else
        {
            throw new Error("SyncKeyValueKey._checkKey: Unknown key '" + key + "'. declare it in _knownKeys array.");
        }
    }
});

exports.SyncKeyValue = SyncKeyValue;
; return exports;};
(function()
{
	if(!Function.prototype.hasOwnProperty('bind'))
	{
		var slice = Array.prototype.slice;
		Function.prototype.bind = function(context)
		{
			var func = this;
			if(arguments.length > 1)
			{
				var args = slice.call(arguments, 1);
				return function()
				{
					if(arguments.length)
					{
						var finalArgs = args.concat(slice.call(arguments));
						return func.apply(context, finalArgs);
					}
					else
					{
						return func.apply(context, args);
					}
				}
			}
			else
			{
				return function()
				{
					if(arguments.length)
						return func.apply(context, arguments);
					else
						return func.call(context);
				}
			}
		}
	}
})();

(function()
{
	if(!Array.prototype.hasOwnProperty('indexOf'))
	{
		Array.prototype.indexOf = function(obj)
		{
			var len = this.length;
			for(var i=0; i < this.length; ++i)
			{
				if(obj === this[i])
					return i;
			}
			return -1;
		}
	}
})();

(function()
{
	if (typeof(console) == 'undefined') { 
		console = { log: function(str) {} };
	}
})();

function userGameInit()
{
	console.log("ngCore calling main()");
	main();
}
//////////////////////////////////////////////////////////////////////////////
/** 
 *  @date:      2010-11-0?
 *  @file:      NgWebEngine.js
 *  Website:    http://www.ngmoco.com/
 *  Copyright:  2010, by ngmoco:)
 *              Unauthorized redistribution of source code is 
 *              strictly prohibited. Violators will be prosecuted.
 * 
 *  @brief:
 */
//////////////////////////////////////////////////////////////////////////////
var NGSetTimeoutRunTimers = require('NGCore/Client/UI/NGJSEnvironmentSupport').NGSetTimeoutRunTimers;
var SystemBinding = require('NGCore/Client/UI/SystemBinding').SystemBinding;
var UI = require('NGCore/Client/UI').UI;
var AlertDialog = UI.AlertDialog;
var ProgressDialog = UI.ProgressDialog;
var Downloader = require('NGCore/Client/Network/DownloadManifest').Downloader;
var LocalGameList = require('NGCore/Client/Core/LocalGameList').LocalGameList;
var Device = require('NGCore/Client/Device').Device;
var Core = require('NGCore/Client/Core').Core;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var Localization = require('NGCore/Client/Core/Localization').Localization;

// Global until oauth does not depend on storage.
Storage = require('NGCore/Client/Storage').Storage;

//////////////////////////////////////////////////////////////////////////////////////////////////
// App switching.

var NgProcID =
{
    PersistProc: -1,
    GameProc: -2
};

//////////////////////////////////////////////////////////////////////////////////////////////////

/**
  * @private
  */

var gNgShutdownPending = false;


/////////////////////////////////////////////////////////////////////////////////////////////////
// Global data.
//////////////////////////////////////////////////////////////////////////////////////////////////

var gNgEngineEntities;
var gNgAddedEngineEntities;
var gNgRemovedEngineEntities;

var gNgUpdateEngineEntities;
var gNgTouchEngineEntities;
var gNgKeyPressEngineEntities;

//////////////////////////////////////////////////////////////////////////////////////////////////
// This function is called once by the html container to initialize the game.
//////////////////////////////////////////////////////////////////////////////////////////////////

/**
  * @private
  */

function NgEngineInitPrivate()
{
	NgLogInit();

	NgApplication.getInstance().restart();

	gNgEngineEntities = new Array();
	gNgAddedEngineEntities = new Array();
	gNgRemovedEngineEntities = new Array();

	gNgUpdateEngineEntities = new Array();
	gNgTouchEngineEntities = new Array();
    gNgKeyPressEngineEntities = new Array();

	Core.Analytics.instantiate();
}

//////////////////////////////////////////////////////////////////////////////////////////////////

/**
  * @private
  */

function NgEngineProcessEntityAddRemove()
{
	for(var i in gNgAddedEngineEntities)
	{
		var e = gNgAddedEngineEntities[i];
		if(e.mIsTouchable) NgInsertSortedTouch(e);
		if(e.mIsKeyable)	NgInsertSortedKeyPress(e);
		if(e.mIsUpdatable) gNgUpdateEngineEntities[e.mId] = e;
	}
	gNgAddedEngineEntities = [];

	for(var i in gNgRemovedEngineEntities)
	{
		var e = gNgRemovedEngineEntities[i];

		if(e.mIsTouchable)	gNgTouchEngineEntities.splice(NgFindIndex(gNgTouchEngineEntities,e),1);
		if(e.mIsKeyable) gNgKeyPressEngineEntities.splice(NgFindIndex(gNgKeyPressEngineEntities,e),1);
		if(e.mIsUpdatable) delete gNgUpdateEngineEntities[e.mId];
	}
	gNgRemovedEngineEntities = [];
}

/**
  * @private
  */

function NgHandleException(ex)
{
	if (Core.Proc.isPrivileged()) {
		NgLogException( ex );
	}
	else {
		var exStr = JSON.stringify(ex);
		NgLogException( ex );
		Core.LocalGameList._forwardException(exStr);
	}
}

function NgEngineInit(inputs)
{
	NgLogD("NgEngineInit beg");
	try
	{
		NgEngineInitPrivate();

		time.setCtr('frame',1000,NgLogD);

		//NgLogD("Initializing Storage");
		//Storage.init();
		//NgLogD("Storage initialized");
		NgLogD("KeyValue Storage initializing...");
		Storage.KeyValueCache.init();
		NgLogD("KeyValue Storage initialized...");
	
		Core.Time.instantiate();
	
		NgLogD("Instantiate the Localization context (singleton), depends on Capabilities");
		Localization.instantiate();

	}
	catch( ex )
	{
		NgHandleException(ex);
	}
	NgLogD("NgEngineInit end");	
	
	return NgEngineUpdate(inputs);
}

function NgPreInit(inputs)
{
	NgLogD("Localization NgPreInit beg");
	return update(inputs);
}

/**
  * @private
  */

function NgGameInit(inputs)
{
	NgLogD("NgGameInit beg");
	try
	{
		NGWindow = UI.Window;

		userGameInit();
	}
	catch( ex )
	{
		NgHandleException(ex);
	}
	NgLogD("NgGameInit end");

	return update(inputs);
}

/**
  * @private
  */

// TEMPORARY: Until native code is updated to call NgEngineUpdate.
function update ( inputs )
{
	return NgEngineUpdate ( inputs );
}

//Frame loop calls this every time, get the object out of require once ahead of time.
var NGSetTimeoutRunTimers = require('NGCore/Client/UI/NGJSEnvironmentSupport').NGSetTimeoutRunTimers;

var setTimeoutOrig = setTimeout;
setTimeout  = function(fn, time)
{
	return setTimeoutOrig(function() 
	{
		try
		{
			fn();
		}
		catch( ex )
		{
			NgHandleException(ex);
		}
	}, time);
	
}


var setIntervalOrig = setInterval;
setInterval  = function(fn, time)
{
	return setIntervalOrig(function() 
	{
		try
		{
			fn();
		}
		catch( ex )
		{
			NgHandleException(ex);
		}
	}, time);
	
}



/**
  *	Main entry point for native to invoke JS.
  * @private
  */
var NgEngineUpdate = (function()
{
	var Core = require('NGCore/Client/Core').Core;
	
return function ( inputs )
{
	// time causes a racehorse-sized leak in v8. Only use this for single profiling runs. DO NOT CHECK IN.
//	time.stop('frame');
//	time.start('frame');
	
	try {
		NGSetTimeoutRunTimers();

		if(inputs.length)
		{
			NgEngineProcessEntityAddRemove();
			var commands = inputs.split(':');
			for(var i=0; i<commands.length; ++i)
			{
				command = commands[i];

				// Make sure this isn't an empty input.
				if(0 == command.length) {
					continue;
				}

				switch(parseInt(command))
				{
					case NgEntityTypes.App:
						NgApplication.getInstance().handleCommand(command);
						break;
					case NgEntityTypes.NgFileSys:
						NgApplication.getInstance().getFileSys().handleCommand(command);
                        break;
					case NgEntityTypes.Storage:
						NgLogD("Command for storage is " + command);
						Storage.getInstanceForCommand(command).handleCommand(command);
						break;
					case NgEntityTypes.NgUI:
						NGWindow.handleCommand(command);
						break;
					case NgEntityTypes.NgSystemBinding:
						SystemBinding.handleCommand(command);
						break;
					case 3117:
						console.log('got leet response');
						if(typeof(_WifiDiagCallback) != 'undefined')
							_WifiDiagCallback(command);
						break;
					default:
						Core.Proc._classRecvGen( command.split( ',' ) );
						break;
				}
			}
		}

		if( gNgShutdownPending )
		{
			gNgShutdownPending = false;
		}
		else	// Don't do updates if we're resetting.
		{
			NgEngineProcessEntityAddRemove();
			for(var i in gNgUpdateEngineEntities)
			{
				var entity = gNgUpdateEngineEntities[i];
				if(!entity.mRegistered) continue;
				entity.onUpdate();
			}
		}
	}
	catch(ex)
	{
		NgHandleException(ex);
	}
		
	var tmp = Core.Proc.getCommandString() + gNgCommandString;
	gNgCommandString = tmp;
	Core.Proc.clearCommandString();

	return NgFlushCommandsToString();
}
})();


//////////////////////////////////////////////////////////////////////////////////////////////////
////	NgApplication class
//////////////////////////////////////////////////////////////////////////////////////////////////

var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var Logger = require('NGCore/Client/Core/Logger').Logger;

/** @private */

var NgApplicationCommands = {
	Caps : 0,
	Debug : 1,
	FrameTime : 2,
	FrameRate : 3,
	Start : 4,
	DeviceOrientation: 10,
	SetOrientation: 11,
	BackPress: 12,
	OnBackPressed: 13,
	LaunchExternalNativeApp: 15,
	ExitSystemProcess: 16
};

/**
  * Enumeration values for orientation change events received by
  * {@link NgApplicationObserver}.
  */

var NgApplicationOrientation = {
	Portrait : 0,
	PortraitUpsideDown : 1,
	LandscapeLeft : 2,
	LandscapeRight : 3,
	FaceUp : 4,
	FaceDown : 5
};

/**
  * The NgApplication constructor is invoked during application bootstrap and
  * should not be created by the ngGame application.  Access to the application
  * object should be through the singleton accessor {@link NgApplication#getInstance}.
  * @constructor
  *
  * @class
  * The NgApplication class represents global state and services that are available to
  * ngGame applications.  This includes file system operations,
  * download services, etc.  The application class also manages a time source
  * that is synchronized between the native engine and the ngGame application. <br>
  * The application object is a singleton and should only be accessed through the
  * {@link NgApplication#getInstance} method.
  */

function NgApplication()
{
	/** @private */
	this.mFileSys = Storage.FileSystem;
	/** @private */
	this.mFrameTime = 0.0;
	/** @private */
	this.mObservers = [];
}

// Singleton instance.
/** @private */
NgApplication.sInstance = null;

/**
  * Acquire the singleton instance of the application class.
  * @type NgApplication
  * @return The global application object.
  */

NgApplication.getInstance = function()
{
	if( NgApplication.sInstance == null )
		NgApplication.sInstance = new NgApplication();

	return NgApplication.sInstance;
};

// APITODO: Switch these methods to be defined out-of-line, not by an object literal.

NgApplication.prototype =
{
	mFileSys : null,
	mObservers : [],
	mFrameTime : 0.0,
	
	/** @private */
	restart : function()
	{
	},
	
	/** @private */
	handleCommand : function(command)
	{
		//		NgLogD( "NgApplication command = " + command );

		var commandId = NgPeekCommandId( command );

		switch( commandId )
		{
			case NgApplicationCommands.FrameTime:
				this.parseFrameTime( command );
				break;
			case NgApplicationCommands.Start:
				this.onApplicationStart();
				break;
			case NgApplicationCommands.OnBackPressed:
				this.onApplicationBackPressed();
				break;
			default:
				NgLogE( "NgApplication command unknown: " + command);
				break;
		}
	},
	
	/**
	  * Acquire the file system object.
	  * @type NgFileSys
	  * @return The file system instance.
	  */
	getFileSys : function()
	{
		return this.mFileSys;
	},

	/** @private */
	ngLog : function( level, dbgStr )
	{
		NgPushCommand4( NgEntityTypes.App, NgApplicationCommands.Debug, Core.Base64.encode( dbgStr ), level );
	},
	
	/** @private */
	parseFrameTime : function( command )
	{
		var fields = NgParseCommand2(command,parseInt,parseFloat);
		var frameTime = fields[1];

		if(this.mFrameDelta == undefined)
			this.mFrameDelta = 0;
		else
			this.mFrameDelta = frameTime - this.mFrameTime;

		this.mFrameTime = frameTime;
	},
	
	/**
	  * Get the application time for the current frame.
	  * @type number
	  * @return The time in milliseconds.
	  */
	getFrameTime : function()
	{
		return this.mFrameTime;
	},
	
	/**
	  * Get the application time delta between the current frame and the last frame.
	  * @type number
	  * @return The time delta in milliseconds.
	  */
	getFrameDelta : function()
	{
		return this.mFrameDelta;
	},

	/**
	  * Set the desired application frame rate. <br>
	  * Note: The frame rate specification is not currently fully functional on all 
	  * platforms.
	  * @param {number} frameRate The desired frame rate in hz.
	  * @type void
	  */
	setFrameRate : function(frameRate)
	{
		NgPushCommand3( NgEntityTypes.App, NgApplicationCommands.FrameRate, frameRate);
	},

	/**
	  * Set the current device orientation for the application. <br>
	  * Note: Setting the orientation is not currently fully functional on all
	  * platforms.
	  * @param {NgApplicationOrientation} orientation The desired orientation.
	  * @type void
	  */
	setOrientation : function(orientation)
	{
		NgPushCommand3( NgEntityTypes.App, NgApplicationCommands.SetOrientation, orientation);
	},

	/**
	  * Register an application observer to receive application callbacks.
	  * @param {NgApplicationObserver} obs The observer to register.
	  * @type void
	  */
	registerObserver : function(obs)
	{
		obs.index = this.mObservers.push(obs);
	},

	unregisterObserver : function(obs)
	{
		if (obs.index)
			delete this.mObservers[obs.index - 1];
	},

	/** @private */
	onApplicationStart : function()
	{
		NgUI.onLoad();
		for (i in this.mObservers)
		{
			// TODO is this even possible?
			this.mObservers[i].onApplicationStart();
		}
	},
	
	/** @private */
	onApplicationReceivedCustomMessage : function( message )
	{
		for (i in this.mObservers)
		{
			this.mObservers[i].onApplicationReceivedCustomMessage( message );
		}
	},
	
	/** @private */
	onApplicationBackPressed : function()
	{
			var observerResult = false;
			for (i in this.mObservers)
			{
				 if (this.mObservers[i].onApplicationBackPressed())
				 {
					observerResult = true;
					break;
				 }
			}
			if (!observerResult)
			{
				// back button was not fully handled. Ask the native application to handle it.
				NgPushCommand2(NgEntityTypes.App, NgApplicationCommands.BackPress);
			}
	},
	
	/** @private */
	exitSystemProcess : function ()
	{
		NgLogD ( "pushing exit command" );
		//This makes java exit the app through android lifecycle
		NgPushCommand2(NgEntityTypes.App, NgApplicationCommands.BackPress);
		NgLogD ( "pushed exit command" );
	}
};

// Observer base class for application events.

/**
  * Initialize a new application observer.
  * @constructor
  *
  * @class
  * The NgApplicationObserver class is used as the base class for any user-defined
  * class that receives application-level callbacks.  This currently includes
  * notifications on all application lifecycle events and device orientation
  * changes. <br>
  * Register the application observer by calling {@link NgApplication#registerObserver}.
  */

function NgApplicationObserver() {}

NgApplicationObserver.prototype =
{
	index: 0,
	/**
	  * Callback for application lifecycle start event.
	  * @type void
	  */
	onApplicationStart:function() {},

	/** @private */
	onApplicationReceivedCustomMessage:function( message ) {},

	/**
	  * Callback for device orientation change events.
	  * @param {NgApplicationOrientation} orientation Orientation enumeration value.
	  * @type void
	  */
	onApplicationDeviceOrientation:function( orientation ) {},

	/*
	 * Listener for when the user pushes the HW back button. Currently Android only.
	 *
	 * @return boolean true if back was handled entirely (eat the event), 
	 * false if it was not
	 *
	 */
	onApplicationBackPressed:function()
	{
		return false;
	}
};

//////////////////////////////////////////////////////////////////////////////////////////////////
// class Entity
// Base class for other entity types.
//////////////////////////////////////////////////////////////////////////////////////////////////

// ObjectTypes
// Defined in
//		JS:  NgEntityTypes in NgWebEngine.js and
//		C++: EntityCommandIds in GameView.h
// 1 = App
// 2 = NgTouchEvent
// 3 = NgKeyPressEvent
// 4 = Accel
// 5 = NgTextInputBox2D
// 6 = Animation (completion events)
// 7 = Sound (completion events)
// 8 = EngineEntity
// 9 = DrawableEntity2D
// 10 = NgCanvas2D
// 11 = NgCamera2D
// 12 = NgSprite2D
// 13 = NgText2D
// 14 = NgWebView2D
// 15 = NgAudioManager
// 16 = NgGroup2D
// 100 = LoadApp

// App Commands
// in:
// capabilities = 0, command dictionary format
// frameTime = 2, double
// out:
// NgLogD = 1, string

// NgTouchEvent Commands
// non-native
//	action: 1 = add, 2 = remove, 3 = modify
//	id: touch instance ID
//	x: x position
//	y: y position
// native
//	action: 4 = add, 5 = remove, 6 = modify
//	id: touch instance ID
//	x: x pos
//	y: y pos
//  eid: entity instance ID
//	lx: local x pos
//  ly: local y pos

// NgKeyPressEvent Commands
// action: 1 = down, 2 = up
// id: instance ID
// value: key value

// InputText Box Commands

// Animation
// in:
// only one kind of event, so first value is id of sprite to callback.

// Sound
// in:
//

// Accel Commands
// out:
// SetEventRate = 0, rate (hz)
// in:
// x, y, z position (floats)

// EngineEntity commands

// DrawableEntity2D commands:
// SetNativeTouchType=1,id,value (None=1, Enable = 2, EnableBounds = 3)

// NgCanvas2D Commands
// NewNgCanvas2D=1, id
// DeleteNgCanvas2D=2, id
// Update=3, id, args... not used currently
// SetRoot=4, id, grp id
// ClearRoot=5, id
// EnableNativePicking=6, id, bool

// NgCamera2D Commands
// NewNgCamera2D=1,		id, canvasId, porperties
// DeleteNgCamera2D=2,	id
// UpdateNgCamera2D=3,	id, properties
//	Properties: vx, vy, vz, vh, vw, cx, cy, ch, cw

// NgSprite2D Commands
// NewNgSprite2D=1,		id, canvasId, texture, properties
// DeleteNgSprite2D=2,	id
// UpdateNgSprite2D=3,	id, properties
//   Properties: x, y, z, w, h, r, a

// NgText2D Operations
// NewNgText2D=1		id, canvasId, properties
// DeleteNgText2D=2	id
// UpdateNgText2D=3	id, properties
//  Properties: x, y, z, w, h, justify, text

// NgGroup2D Operations
// New = 1			id, canvasId, [properties/todo]
// Delete = 2		id
// Update = 3		id, [properties/todo]
// Child = 4		id, subcmd, [child id]
//						subcmd 0 = add, 1 = rem, 2 = remAll (no child id)
// Rot = 5			id, anglef
// Pos = 6			id, xf, yf, zf
// Alpha = 7		id, alphaf
// Scale = 8		id, xf, yf

// APITODO: Clean up these identifiers.
// APITODO: Sound is probably not used any more.
// APITODO: Animation is probably not used any more.

var NgEntityTypes = {
	App : 1,
	NgTouchEvent : 2,
	NgKeyPressEvent : 3,
	Accel : 4,
	NgTextInputBox2D : 5,
	Animation : 6,
	Sound : 7,
	NgEngineEntity : 8,
	NgDrawableEntity2D : 9,
	NgCanvas2D : 10,
	NgCamera2D : 11,
	NgSprite2D : 12,
	NgText2D : 13,
	NgWebView2D : 14,
	NgGroup2D : 16,
	NgPhysics2D: 17,
	NgPrimitive2D: 18,
	NgFileSys: 19,
	Gyro : 22,
	NgUI : 23,
	Storage: 24,
	NgSystemBinding: 25,
	NgCustomMessage : 50,
	LoadApp : 100
};

var NgEngineEntityCommandIDs = {
	SetNativeTouchType : 1
};

/**
 * Initializes instance to default values. <br>
 * mId member defaults to 0 but can be set by application before calling {@link NgEngineEntity#register}.
 * @constructor
 *
 * @class
 * NgEngineEntity is the base class for all game entities, such as NgSprite2D and NgText2D. <br>
 * This class introduces key callback functions for touch, key press and per-frame update
 * notification. <br>
 * Additionally, the class introduces a register/unregister mechanism
 * for controlling the existence of the entity in the native game engine.
 *
 */

function NgEngineEntity()
{
	/** The entity id.  Used by the native engine for identification.  @type number */
	this.mId = 0;
	/** The touch priority.  Touches are routed first to the highest priority entities.  @type number */
	this.mTouchPriority = 0;
	/** The key press priority.  Key presses are routed first to the highest priority entities.  @type number */
	this.mKeyPressPriority = 0;
	/** @private */
	this.mIsTouchable = false;
	/** @private */
	this.mIsKeyable = false;
	/** @private */
	this.mIsUpdatable = false;
	/** @private */
	this.mNativeTouchType = NgEngineEntity.NativeTouchType.Enable;
	/** @private */
	this.mRegistered = false;
}

// Static methods and data.

/**
  * NgEngineEntity touch policy enumeration. <br>
  * Used with {@link NgEngineEntity#setNativeTouchType} and {@link NgCanvas2D#enableNativePicking}. <br>
  * Values: <br>
  * None : Disables native touches for this entity (and its children). <br>
  * Enable : Enables this entity to receive touches (or visits child entities) <br>
  * EnableBounds : Enables this entity to receive touches on its axis-aligned bounding box.  If
  * a touch is received on a group, it will report the touch and _not_ visit the group's children.
  */

NgEngineEntity.NativeTouchType = {
	None : 0,
	Enable : 1,
	EnableBounds : 2
};

/**
  * @private
  */

NgEngineEntity.engineCurrentId = 1;

/**
  * Allocate a unique ID for an entity.
  * @return ID value.
  * @type number
  * @private
  */

NgEngineEntity.newEngineId = function ()
{
	return NgEngineEntity.engineCurrentId++;
}

/**
  * Reclaim an entity ID.
  * @private
  */

NgEngineEntity.deleteEngineId = function ()
{
	// Nothing.
}

// Instance methods.

// Basic entity callbacks.

/** @private */

NgEngineEntity.prototype.newEntity = function() {}

/** @private */

NgEngineEntity.prototype.deleteEntity = function() {}

/**
  *	Callback for standard touch events. <br>
  * Standard touch events correspond to all touches
  * within the game view.  For each touch on the game view, all registered touchable
  * entities will receive the event.  Application logic must perform filtering to determine
  * if a particular entity corresponds to the touch event. <br>
  * Refer to {@link NgEngineEntity#toggleTouchable} for control of an entity's touchable state.
  * @param {NgTouchEvent} touch The touch event.
  * @return The application can return true to indicate that it has consumed this event or false
  * to allow other entities to continue processing this event.
  * @type bool
  */

NgEngineEntity.prototype.onTouch = function(touch)
{
	return false;
}

/**
  * Callback for native touch events. <br>
  * Native touch events are pre-filtered by the game engine
  * to correspond to a specific touchable entity.  For each touch on the game view, the game
  * engine will determine which game entities are selected by the touch event.  Only the 
  * selected entities will receive the onNativeTouch event callback. <br>
  * Native touch capability is not affected by touchable state of the entity determined by
  * {@link NgEngineEntity#toggleTouchable}.  Refer to {@link NgEngineEntity#setNativeTouchType} 
  * for management of an entity's native touch policy.
  * @param {NgNativeTouchEvent} touch The touch event.
  * @return The application can return true to indicate that it has consumed this event or false
  * to allow other entities to continue processing this event.
  * @type bool
  */

NgEngineEntity.prototype.onNativeTouch = function(touch)
{

}

/**
  * Callback for keyboard events. <br>These events correspond to physical or software keyboard events. <br>
  * Enable/disable key press events for an entity with {@link NgEngineEntity#toggleKeyable}.
  * @param {NgKeyPressEvent} keyPress The key press event.
  * @return The application can return true to indicate that it has consumed this event or false
  * to allow other entities to continue processing this event.
  * @type bool
  */

NgEngineEntity.prototype.onKeyPress = function(keyPress)
{
	return false;
}

/**
  *	Callback for update events. <br>Per-frame entity logic should be implemented in this callback. <br>
  * Enable/disable update events for an entity with {@link NgEngineEntity#toggleUpdatable}.
  * The return value of this method is ignored.
  * @type void
  */

NgEngineEntity.prototype.onUpdate = function()
{
}

/**
  *	Register this entity instance with the native game engine. <br>
  * The initialization sequence of engine entities has specific constraints: <br>
  * After construction and before calling
  * the register method, class methods that affect the native engine state cannot be called.  
  * During this period, changes to entity state by changing instance variables will be
  * sent to the native engine on the call to register. <br>
  * After register is called, 
  * changes to instance variables will be ignored.  During this phase, the only
  * way to affect native engine state is through methods that push commands to
  * the native side.
  * @type void
  */

NgEngineEntity.prototype.register = function()
{
	this.mParents = new Array();

	if( this.mId >= 0 )
	{
		this.mId = NgEngineEntity.newEngineId();
	}

	this.mRegistered = true;
	gNgEngineEntities[this.mId] = this;
	gNgAddedEngineEntities[this.mId] = this;
	this.newEntity();
}

/**
  * Unregister this entity from the native game engine.
  * @type void
  */

NgEngineEntity.prototype.unregister = function()
{
	var parents = this.mParents.concat(new Array());

	for (var i in parents)
	{
		NgLogD ( "Removing child " + this.mId + " from parent Group " + parents[i].mId + " because the Entity was unregistered");
		parents[i].removeChild( this );
	}

	this.mRegistered = false;
	delete gNgEngineEntities[this.mId];
	// CAUTION : DO NOT SPLICE gNgEngineEntities EVER.
	//gNgEngineEntities.splice(this.mId,1);

	gNgRemovedEngineEntities[this.mId] = this;
	this.deleteEntity();

	if(this.mId >= 0)
		NgEngineEntity.deleteEngineId(this.mId);
}

/**
  * Enable/disable key press callbacks for this entity. <br>This method flips the enable state
  * for key press events. <br>
  * In order to receive key press callbacks, an entity
  * must override the onKeyPress event and enable keyable state by calling this 
  * method. <br>
  * The default state is false.
  * @type void
  */

NgEngineEntity.prototype.toggleKeyable = function()
{
	if(this.mIsKeyable)
		gNgKeyPressEngineEntities.splice(NgFindIndex(gNgKeyPressEngineEntities,this),1);
	else
		NgInsertSortedKeyPress(this);

	this.mIsKeyable = !this.mIsKeyable;
}

/**
  * Enable/disable update callbacks for this entity. <br>
  * This method flips the enable state
  * for update events. <br>
  * In order to receive update callbacks, an entity
  * must override the onUpdate event and enable updatable state by calling this 
  * method. <br>
  * The default state is false.
  * @type void
  */

NgEngineEntity.prototype.toggleUpdatable = function()
{
	if(this.mIsUpdatable)
	{
		delete gNgUpdateEngineEntities[this.mId];
	}
	else
	{
		gNgUpdateEngineEntities[this.mId] = this;
	}
	this.mIsUpdatable = !this.mIsUpdatable;
}

/**
  * Enable/disable touch callbacks for this entity. <br>
  * This method flips the enable state for touch events. <br>
  * In order to receive touch callbacks, an entity
  * must override the onTouch event and enable touchable state by calling this 
  * method. <br>
  * The default state is false.
  * @type void
  */

NgEngineEntity.prototype.toggleTouchable = function()
{
	if(this.mIsTouchable)
		gNgTouchEngineEntities.splice(NgFindIndex(gNgTouchEngineEntities,this),1);
	else
		NgInsertSortedTouch(this);

	this.mIsTouchable = !this.mIsTouchable;
}

/**
  * Set native touch traversal policy. <br>
  * This method controls how the native game engine
  * traverses the game scene graph. <br>
  * The policies are described in further detail with {@link NgEngineEntity#NativeTouchType}. <br>
  * The default state is "Enable".
  * @param {NativeTouchType} type The policy enum for native touch processing.
  * @type void
  */

NgEngineEntity.prototype.setNativeTouchType = function( type )
{
	this.mNativeTouchType = type;
	NgPushCommand4(NgEntityTypes.NgDrawableEntity2D, NgEngineEntityCommandIDs.SetNativeTouchType, this.mId, this.mNativeTouchType );
}
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
var Core = require('NGCore/Client/Core').Core;

// These methods handle all composition for commands being sent back to the
// native engine.

/**
  * @private
  */

var gNgCommandStrings = [];

/**
  * @private
  */

var gNgCommandString = '';

// 0 deferred string composition via user loop
// 1 deferred string composition via internal loop
// 2 on-the-fly string composition.

// TODO: Benchmark all variation on all platforms.  Choose appropriate one(s)
// and prune code for others.

// UPDATE: ALL variations on contructing a string performed IDENTICALLY in
// the iPhone's UIWebView.  Unbelievable.

/**
  * @private
  */

var gNgCommandMode = 2;

/**
  * @private
  */

function NgQueueCommandText(command)
{
	switch(gNgCommandMode)
	{
		case 0:
		case 1:
			gNgCommandStrings.push( command );
			break;
		case 2:
			gNgCommandString += command;
			break;
	}
}

/**
  * @private
  */

function NgFlushCommandsToString()
{
	var outputString = '';
	
	switch(gNgCommandMode)
	{	
		case 0:
			for( var num = 0, end = gNgCommandStrings.length; num < end; ++num )
			{
				outputString += gNgCommandStrings[ num ];
			}
			break;
			
		case 1:
			outputString = String.prototype.concat.apply(gNgCommandStrings);
			break;
	}
	
	switch(gNgCommandMode)
	{
		case 0:
		case 1:
			gNgCommandStrings = [];
			break;
		case 2:
			outputString = gNgCommandString;
			gNgCommandString = '';
			break;
	}
	
	return outputString;	
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

function NgParseString(txt)
{
	return txt;
}

/**
  * @private
  */

function NgParseBase64(txt)
{
	if( txt )
		return Core.Base64.decode(txt);
	else
		return "";
}

/**
  * @private
  */

function NgParseBool(txt)
{
	return parseInt(txt) ? true : false;
}

function NgParseInt(txt)
{
	return parseInt(txt, 10);
}

function NgKVArrayToCmd(kvArray)
{
	var out = "";
	var count = 0
	for (var s in kvArray)
	{
		var value = kvArray[s];
		
		out += "," + s + "," + Core.Base64.encode(value);
		++count;
	}
	return count + out;
}
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

/**
 * Submit a command with 1 argument to the native engine.
 * @private
 */
function NgPushCommand1(arg1)
{
	gNgCommandString += ":" + arg1;
}

/**
 * Submit a command with 2 arguments to the native engine.
 * @private
 */
function NgPushCommand2(arg1, arg2)
{
	gNgCommandString += ":" + arg1 + "," + arg2;
}

/**
 * Submit a command with 3 arguments to the native engine.
 * @private
 */
function NgPushCommand3(arg1, arg2, arg3)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3;
}

/**
 * Submit a command with 4 arguments to the native engine.
 * @private
 */
function NgPushCommand4(arg1, arg2, arg3, arg4)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4;
}

/**
 * Submit a command with 5 arguments to the native engine.
 * @private
 */
function NgPushCommand5(arg1, arg2, arg3, arg4, arg5)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4 + "," + arg5;
}

/**
 * Submit a command with 6 arguments to the native engine.
 * @private
 */
function NgPushCommand6(arg1, arg2, arg3, arg4, arg5, arg6)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4 + "," + arg5 + "," + arg6;
}

/**
 * Submit a command with 7 arguments to the native engine.
 * @private
 */
function NgPushCommand7(arg1, arg2, arg3, arg4, arg5, arg6, arg7)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4 + "," + arg5 + "," + arg6 + "," + arg7;
}

/**
 * Submit a command with 8 arguments to the native engine.
 * @private
 */
function NgPushCommand8(arg1, arg2, arg3, arg4, arg5, arg6, arg7,arg8)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4 + "," + arg5 + "," + arg6 + "," + arg7 + "," + arg8;
}

/**
 * Submit a command with 8 arguments to the native engine.
 * @private
 */
function NgPushCommand9(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4 + "," + arg5 + "," + arg6 + "," + arg7 + "," + arg8 + "," + arg9;
}

/**
 * Submit a command with n arguments to the native engine.
 * @private
 */
function NgPushCommandN()
{
	var argv = arguments;
	var argc = argv.length;
	
	var tmp = ":";
	
	if( argc > 0 )
	{
		tmp += argv[ 0 ];
		
		for( var num = 1; num < argc; ++num )
		{
			tmp += "," + argv[ num ];
		}
	}
	
	gNgCommandString += tmp;
}

/**
 * Peek at the command ID in a command string.  This helps avoid 
 * splitting the string twice in a number of cases.
 * @return Command id or null if parsing failed.
 * @private
 */

function NgPeekCommandId(str)
{
	var vals = str.split ( ",", 2 );
	if( vals.length == 2 )
		return parseInt ( vals[ 1 ] );
	else
		return null;
}

/**
 * Peek at the class and command ID in a command string.  This helps avoid 
 * splitting the string twice in a number of cases.
 * @return Two-element array of ids or null if parsing failed.
 * @private
 */

function NgPeekClassAndCommandId(str)
{
	var vals = str.split ( ",", 2 );
	if( vals.length == 2 )
	{
		vals[ 0 ] = parseInt ( vals[ 0 ] );
		vals[ 1 ] = parseInt ( vals[ 1 ] );
		return vals;
	}
	else
		return null;
}


/**
 * Parse an incoming command string to individual strings.
 * @return an array of fields in serialization order.
 * @private
 */
function NgParseCommandToStrings(src)
{
	return src.split(",");
}

/**
  * @private
  */

function NgParseCommand1(src, func1)
{
	var ret = [];
	
	var fields = src.split(",");
	
	ret[ 0 ] = func1( fields[ 1 ] );
	
	return ret;
}

/**
  * @private
  */

function NgParseCommand2(src, func1, func2)
{
	var ret = [];
	
	var fields = src.split(",");
	
	ret[ 0 ] = func1( fields[ 1 ] );
	ret[ 1 ] = func2( fields[ 2 ] );
	
	return ret;
}

/**
  * @private
  */

function NgParseCommand3(src, func1, func2, func3)
{
	var ret = [];
	
	var fields = src.split(",");
	
	ret[ 0 ] = func1( fields[ 1 ] );
	ret[ 1 ] = func2( fields[ 2 ] );
	ret[ 2 ] = func3( fields[ 3 ] );
	
	return ret;
}

/**
  * @private
  */

function NgParseCommand4(src, func1, func2, func3, func4)
{
	var ret = [];
	
	var fields = src.split(",");
	
	ret[ 0 ] = func1( fields[ 1 ] );
	ret[ 1 ] = func2( fields[ 2 ] );
	ret[ 2 ] = func3( fields[ 3 ] );
	ret[ 3 ] = func4( fields[ 4 ] );
	
	return ret;
}

/**
  * @private
  */

function NgParseCommand5(src, func1, func2, func3, func4, func5)
{
	var ret = [];
	
	var fields = src.split(",");
	
	ret[ 0 ] = func1( fields[ 1 ] );
	ret[ 1 ] = func2( fields[ 2 ] );
	ret[ 2 ] = func3( fields[ 3 ] );
	ret[ 3 ] = func4( fields[ 4 ] );
	ret[ 4 ] = func5( fields[ 5 ] );
	
	return ret;
}


/**
 * Parse an incoming command string to typed values based on passed-in functions.
 * ex: NgParseCommandN("1:1,1.0,ACFHENA==",parseInt, parseFloat, NgParseString);
 * NOTE: The first item is assumed to be the command type, and will be
 * discarded in the output.  I.e., the output starts with the second src element.
 * @return an array of parsed fields in serialization order.
 * @private
 */

function NgParseCommandN(src)
{
	var ret = [];
	
	var argv = arguments;
	var argc = argv.length;
	
	var fields = src.split(",");
	for( var num = 1; num < argc; ++num )
	{
		ret[ num - 1 ] = argv[ num ]( fields[ num ] );
	}
	
	return ret;
}

/**
 * Parse an incoming typed dictionary.  The format of the dictionary is:
 * type,field name,value,type,field name,value[...]
 * Parsed values will be asigned to the field name in the dst array/object.
 * NOTE: Strings passed in this format must not have embedded commas (use
 * base64 encoding if arbitrary strings are being used.
 * @arg src The source command string.
 * @arg srcStart The field index to start parsing dictionary entries from.
 * @arg dst The destination object/array for parsed values.
 * @arg initialFields Optionally store the fields before srcStart in the passed-in array.
 * @return true if all fields were successfully parsed.
 * @private
 */

function NgParseCommandDictionary(src,srcStart,dst,initialFields)
{
	var ret = true;
	var fields = src.split(",");
	var end = fields.length;
	
	if(initialFields)
	{
		for( var num = 0; num < srcStart; ++num )
		{
			initialFields[ num ] = fields[ num ];
		}
	}
	
	for( var num = srcStart; num < end; )
	{
		var type = fields[ num++ ];
		var name = fields[ num++ ];
		var val = fields[ num++ ];
		var good = true;
		
		switch(type)
		{
			case 'i':	// int
				val = parseInt( val );
				break;
			case 'f':	// float
				val = parseFloat( val );
				break;
			case 's':	// string
				break;
			case 'S':	// base64 string
				val = Core.Base64.decode(val);
				break;
			case 'b':	// bool
				val = parseInt(val) ? true : false;
				break;
			default:
				//				NgLogD("NgParseCommandDictionary unknown type for " + type + " " + name + " " + val);
				ret = false;
				good = false;
				break;
		}
		
		if( good )
		{
			dst[ name ] = val;
			
			// TEMP PRW
			NgLogD( "dict: " + name + " : " + dst[ name ] );
		}
		else
		{
			NgLogD("dict: could not process " + type );
		}
	}
	
	return ret;
}
/**
  * @private
  */

var gNgTrace=null;

//////////////////////////////////////////////////////////////////////////////////////////////////
// Logging functions.
//////////////////////////////////////////////////////////////////////////////////////////////////

/**
  * @private
  */
var NgDebugModes = {
	BrowserTrace : {},
	NgCommand : {},
	NgCommandDocLoc : {}
};

/**
  * @private
  */
var NgLogLevel = {
	Verbose : 5,
	Debug : 4,
	Info : 3,
	Warning : 2,
	Error : 1
};

/**
  * @private
  */
var NgLogStr = [ '', 'e', 'w', 'i', 'd', 'v'];


/**
  * @private
  */

// TEMP... this is not how we want to do this long-term.
function NgSetDebugDefaultDestination()
{
	if (typeof navigator == 'undefined')
	{
		return NgDebugModes.NgCommand;
	}

	var agent=navigator.userAgent.toLowerCase();
	if( ! ( (agent.indexOf('iphone') >=0) || (agent.indexOf('ipad') >= 0) ) )
	{
		return NgDebugModes.BrowserTrace;
	}
	else
	{
		return NgDebugModes.NgCommand;
	}
}

/**
  * @private
  */

var gNgDebugMode = NgSetDebugDefaultDestination();

/**
  * @private
  */

function NgLogInit()
{
	if( gNgDebugMode == NgDebugModes.BrowserTrace )
	{
		gNgTrace = document.getElementById("trace");
	}

	// Other modes don't need initialization.
}

function NgLogSetLevel(level)
{
	switch( level )
	{
		case NgLogLevel.Debug:
		{
			NgLogV = NgNoLog;
			NgLogD = NgDoDebugLog;
			NgLogI = NgDoInfoLog;
			NgLogW = NgDoWarningLog;
			NgLogE = NgDoErrorLog;
		}
			break;

		case NgLogLevel.Info:
		{
			NgLogV = NgNoLog;
			NgLogD = NgNoLog;
			NgLogI = NgDoInfoLog;
			NgLogW = NgDoWarningLog;
			NgLogE = NgDoErrorLog;
		}
			break;

		case NgLogLevel.Warning:
		{
			NgLogV = NgNoLog;
			NgLogD = NgNoLog;
			NgLogI = NgNoLog;
			NgLogW = NgDoWarningLog;
			NgLogE = NgDoErrorLog;
		}
			break;

		case NgLogLevel.Error:
		{
			NgLogV = NgNoLog;
			NgLogD = NgNoLog;
			NgLogI = NgNoLog;
			NgLogW = NgNoLog;
			NgLogE = NgDoErrorLog;
		}
			break;

		default:
		case NgLogLevel.Verbose:
		{
			NgLogV = NgDoVerboseLog;
			NgLogD = NgDoDebugLog;
			NgLogI = NgDoInfoLog;
			NgLogW = NgDoWarningLog;
			NgLogE = NgDoErrorLog;
		}
			break;
	}
}

NgDoVerboseLog = function ( msg ) {
	NgLog(NgLogLevel.Verbose, msg);
}

NgDoDebugLog = function ( msg ) {
	NgLog(NgLogLevel.Debug, msg);
}

NgDoInfoLog = function ( msg ) {
	NgLog(NgLogLevel.Info, msg);
}

NgDoWarningLog = function ( msg ) {
	NgLog(NgLogLevel.Warning, msg);
}

NgDoErrorLog = function ( msg ) {
	NgLog(NgLogLevel.Error, msg);
}

NgNoLog = function() {};
NgLogSetLevel(NgLogLevel.Verbose);

var useConsole = ((typeof console != 'undefined') && (typeof console.log == 'function'));

function NgLog( level, msg )
{
	console.log(NgLogStr[level] + ": " + msg);
}

function NgLogException( ex )
{
    var str = "\nEXCEPTION:\n";

    for( var prop in ex )
    {
		str += "property: "+ prop+ " value: ["+ ex[prop]+ "]\n";
    }

    str += "toString(): " + " value: [" + ex.toString() + "]\n\n";

	NgLogD( str );
}
/*
 @author: Remy Sharp / http://remysharp.com
 @date: 2007-04-20
 @name: time
 @methods:
 start - start named timer
 stop - stop named timer
 event - hook predefined event
 func - hook existing function, or hook anonymous function (note refrence is passed back)
 report - output timings
 */
if ((typeof window == 'undefined') || (typeof window.time == 'undefined'))
{
	(function() {
		time = {
			// start + stop taken from firebuglite.js -
			// http://getfirebug.com/firebuglite
			start : function(name) {
				if (!name) {
					error('start: If starting a timer manually a name must be set');
				} else {
					timeMap[name] = (new Date()).getTime();
					if (name in NgRecordMap) {
					} else {
						NgRecordMap[name] = new NgRecord(name);
					}
				}
			},

			stop : function(name) {
				if (name in timeMap) {
					var stop = (new Date()).getTime();
					// var l = new Report(name, timeMap[name], stop);
					var l = NgRecordMap[name].addRecord(stop - timeMap[name]);
					log.push(l);
					if (NgRecordMap[name].records % NgRecordMap[name].ctr == 0) {
						NgRecordMap[name].lineReportMethod.call(this, l);
						NgRecordMap[name].records = 0;
						NgRecordMap[name].avg = 0;
						NgRecordMap[name].min = 55555;
						NgRecordMap[name].max = 0;
					}
					delete timeMap[name];
				} else {
					error('stop:' + name + ' not found');
				}
			},

			event : function(name, elm, type) {
				if (typeof name != 'string') {
					// name has not been passed in
					type = elm;
					elm = name;
					name = '';
				}

				if (!elm.length) {
					elm = [ elm ];
				}

				if (type.indexOf('on') == -1) {
					type = 'on' + type;
				}

				var i = elm.length;
				var timerN = null;
				var c = null;
				while (i--) {
					timerN = name;
					if (!timerN) {
						timerN = elm[i].id || elm[i].getAttribute('class')
								|| elm[i].getAttribute('className')
								|| elm[i].tagName;
					}

					mapEvent(elm[i], type, timerN);
				}
			},

			func : function(name, fn) {
				if (typeof name == 'function') {
					fn = name;
				}

				// get function name as this browser may not support fn.name (IE
				// + Safari + Opera)
				if (!fn.name && typeof fn == 'function') {
					var m = fn.toString().match(/function\s*(.*)\s*\(/);
					if (m[1]) {
						fn.name = m[1];
					}
				}

				if (typeof fn == 'function' && !fn.name) {
					// function is anonymous -
					// time function using var func = time.fn(function() { ...do
					// stuff });
					if (typeof name != 'string') {
						anonFuncId++;
						name = 'anonymous' + anonFuncId;
					}

					return function() {
						time.start(name);
						var ret = fn.apply(window, arguments);
						time.stop(name);
						return ret;
					};
				} else {
					var fnName = fn.name || fn;
					if (typeof name != 'string') {
						name = fnName;
					}

					eval('var fnCopy = ' + fnName);
					if (typeof fnCopy == 'function') {
						var wrap = function() {
							time.start(name);
							var ret = fnCopy.apply(this, arguments);
							time.stop(name);
							return ret;
						};
						wrap.hooked = true;
						eval(fnName + ' = wrap;');
						return eval(fnName);
					} else {
						// error hooking
						error('func: Could not hook function (name: ' + name + ')');
					}
				}
			},

			report : function(name) {
				if (typeof name == 'undefined') {
					reportMethod.call(this, log);
				} else {
					var i = log.length;
					var l = [];
					while (i--) {
						if (name == log[i].name) {
							l.push(log[i]);
						}
					}
					reportMethod.call(this, l);
				}
			},

			setReportMethod : function(fn) {
				if (fn.hooked) {
					error('setReportMethod: Cannot use hooked method ' + fn.name);
				} else {
					reportMethod = fn;
				}
			},

			setCtr : function(name, ctr, fn) {
				if (name in NgRecordMap) {
				} else
					NgRecordMap[name] = new NgRecord(name, ctr, fn);
			},

			setLineReportMethod : function(fn) {
				if (fn.hooked) {
					error('setLineReportMethod: Cannot use hooked method ' + fn.name);
				} else {
					lineReportMethod = fn;
					lineReport = true;
				}
			},

			errors : false
		};

		var timeMap = {};
		var NgRecordMap = {};
		var log = [];
		var reportMethod = defaultReport;
		var lineReport = false;
		var lineReportMethod = defaultLineReport;
		var anonFuncId = 0;

		var Report = function(n, s, e) {
			this.name = n;
			this.start = s;
			this.stop = e;
			this.delta = e - s;
			// useful if I could grab the call - but can't see how due to anon
			// functions (though I can see them in the start method)
		};

		Report.prototype.toString = function() {
			return this.name + ": " + this.delta + "ms";
		};

		function defaultReport(l) {
			alert(l.join("\n"));
		}

		function defaultLineReport(l) {
			alert(l);
		}

		function error(e) {
			if (time.errors)
				alert(e);
		}

		var NgRecord = function(name, ctr, fn) {
			this.name = name;
			this.records = 0;
			this.avg = 0;
			this.min = 555555;
			this.max = 0;
			this.ctr = ctr;
			if (fn.hooked) {
				error('setLineReportMethod: Cannot use hooked method. Will use default method' + fn.name);
				this.lineReportMethod = defaultLineReport;
			} else {
				this.lineReportMethod = fn;
			}

		}

		NgRecord.prototype.addRecord = function(delta) {
			this.avg = (this.avg * this.records + delta) / (this.records + 1);
			if (this.min > delta)
				this.min = delta;
			if (this.max < delta)
				this.max = delta;
			this.records++;
			frq = 1000 / this.avg;
			return this.name + '->  max:' + this.max + '  min:' + this.min
					+ '  avg:' + this.avg.toFixed(2) + '  freq:'
					+ frq.toFixed(2) + '\n';
		}

		// required to create a brand new instance of our copied function
		function mapEvent(e, t, n) {
			var c = e[t];
			if (typeof c == 'function') {
				e[t] = function() {
					time.start(n + ':' + t);
					var ret = c.apply(this, arguments);
					time.stop(n + ':' + t);
					return ret;
				};
			} else {
				error('event: Function must be set on element.' + t
						+ ' before hooking (name: ' + n + ')');
			}
		}
	})();
}

// From NBUniversalLayer.h
var UNISAFE_WIDTH = 320;
var UNISAFE_HEIGHT = 480;
var UNISCREEN_CENTER = new Core.Point(UNISAFE_WIDTH / 2, UNISAFE_HEIGHT / 2);

// FIXME: Next two constants should be defined in TTScene
var BUX_MINUTE_WORTH = 60;
var BUX_STOCK_WORTH = 600.0;

var DLG_INPUT_DELAY = 0.3;
var NUM_HAIR_PIECES = 2;
var NUM_HAIR_ACC = 3;
var NUM_GLASSES = 3;
var NUM_FHATS = 2;
var NUM_MHATS = 1;
var NUM_BHATS = 17;
var NUM_HAIR_COLORS = 49;
var NUM_SKIN_COLORS = 8;
var NUM_MALE_NAMES = 300;
var NUM_FEMALE_NAMES = 300;
var NUM_LAST_NAMES = 300;
var WALK_SPEED = 1;
var NUM_ELEVATORS = 4;
var NUM_MUSIC_TRACKS = 3;

var VIBRATE = 0;
var SFX_COINS = 1;
var SFX_DONEBELL = 2;
var SFX_ELEVATORBELL = 3;
var SFX_ELEVATORDRONE = 4;
var SFX_ELEVATORDOORS = 5;
var SFX_BUX = 6;
var SFX_CONSTRUCTION = 7;
var SFX_STOCK = 8;
var SFX_DOORBELL = 9;
var SFX_LIGHTSWITCH = 10;
var SFX_FOCUS_CREATIVE = 11;
var SFX_FOCUS_FOOD = 12;
var SFX_FOCUS_RECREATION = 13;
var SFX_FOCUS_RETAIL = 14;
var SFX_FOCUS_SERVICE = 15;
var SFX_DRESSUP = 16;
var SFX_EVICTED = 17;
var SFX_MOVE = 18;
var SFX_PAINT = 19;

var HUD_BAR_HEIGHT = 32;

//Constants of the TTFloor.h file
var LOBBY_ID = 65535;

var PROBLEM_TYPE_FLOOD = 0;
var PROBLEM_TYPE_POWER = 1;

var FLOOR_DOOR_X = 43;
var FLOOR_UPDATE_FREQ = 1.0;

var FLOOR_ID_EMPTY = 58;
var FLOOR_ID_CONSTRUCTION = 59;
var FLOOR_TYPE_FOOD = 0;
var FLOOR_TYPE_SERVICE = 1;
var FLOOR_TYPE_ENTERTAINMENT = 2;
var FLOOR_TYPE_RETAIL = 3;
var FLOOR_TYPE_CREATIVE = 4;
var FLOOR_TYPE_RESIDENTIAL = 5;
var NUM_BUS_TYPES = 5;

var INFO_COLOR_COINS = ccc3(255, 207, 92);
var INFO_COLOR_PROBLEM = ccc3(251, 153, 0);
var INFO_COLOR_STOCK = ccc3(253, 240, 209);

//Constants of the TTFloor.m file
var PROG_BAR_COLOR_4B = ccc3(144, 221, 87);//ccc3(144/255,221/255,87/255,255/255),
var PROG_BAR_COLOR_3B = ccc3(144, 221, 87);

var RES_BAR_COLOR = ccc3(112, 173, 115);
var STORE_BAR_COLOR = ccc3(112, 112, 173);

var TAG_PROGBG = 1000;
var TAG_PROGBAR = 1001;

var HALF_BIT_WIDTH = 32;

var CUSTOMER_SPAWN_SECONDS = 6;
var CUSTOMER_WALK_TIME_SECONDS = 6;

//Constants of the TTElevator 
var MAX_VEL = 8;
var MIN_VEL = 0.5;

var DOOR_WIDTH = 15;
var DOOR_HEIGHT = 30;

var NOTE_WIDTH = 19 * 2;
var NOTE_HEIGHT = 19 * 2;
var NOTE_TYPE_MAIL = 0;
var NOTE_TYPE_EXCLAIM = 1;
var NOTE_TYPE_COINS = 2;
var NOTE_TYPE_RIDER = 3;
var NOTE_TYPE_STOCK = 4;
var NOTE_TYPE_VIP = 5;
var NOTE_TYPE_FIND = 6;

var NUM_SORT_BUTTONS = 7;

var BITBOOK_NEWRESIDENT_CHANCE = 2;
var BITBOOK_FLOORCLOSED_CHANCE = 4;
var BITBOOK_FLOORSTOCKED_CHANCE = 2;
var BITBOOK_NEWJOBHIGH_CHANCE = 2;
var BITBOOK_NEWJOBLOW_CHANCE = 2;
var BITBOOK_NEWPRODFLOOR_CHANCE = 1;
var BITBOOK_NEWROOMATE_CHANCE = 2;

var BITIZEN_SEED_CONSTRUCTION = 1;
var BITIZEN_SEED_DELIVERYMAN = 2;
var BITIZEN_SEED_BIGSPENDER = 3;
var BITIZEN_SEED_CELEBRITY = 4;
var BITIZEN_SEED_REALESTATE = 5;
var BITIZEN_SPECIAL_SEED_COUNT = 5;

var SORT_MODE_HAPPINESS = 0;
var SORT_MODE_JOB = 1;
var SORT_MODE_SKILL_FOOD = 2;
var SORT_MODE_SKILL_SERVICE = 3;
var SORT_MODE_SKILL_RECREATION = 4;
var SORT_MODE_SKILL_RETAIL = 5;
var SORT_MODE_SKILL_CREATIVE = 6;

var ELEVATOR_HEIGHT = 66;
var FLOOR_HEIGHT_PIXELS = (48 + 8) * 2;
var LOBBY_BASE_POSITION = UNISAFE_HEIGHT + FLOOR_HEIGHT_PIXELS;

var BACKUP_RATE_SECONDS = 20/*60*60*4*/;

var MOBAGE_ICON_SIZE_FACTOR = 11.875/100;

const FONT18  = 42;
const FONTSCALE18 = 0.4;
const FONT17  = 40;
const FONTSCALE17 = 0.4;
const FONT16  = 38;
const FONTSCALE16 = 0.4;
const FONT14  = 36;
const FONTSCALE14 = 0.4;
const FONT12  = 34;
const FONTSCALE12 = 0.4;
const FONT9  = 32;
const FONTSCALE9 = 0.4;

var SIMULATOR = false;
var RATE_GAME_FLOORS = 5;
/* Quixe -- a Glulx VM interpreter written in Javascript
 * Designed by Andrew Plotkin <erkyrath@eblong.com>
 * <http://eblong.com/zarf/glulx/quixe/>
 *
 * This Javascript library is copyright 2010-2011 by Andrew Plotkin. You may
 * copy and distribute it freely, by any means and under any conditions,
 * as long as the code and documentation is not changed. You may also
 * incorporate this code into your own program and distribute that, or
 * modify this code and use and distribute the modified version, as long
 * as you retain a notice in your program or documentation which mentions
 * my name and the URL shown above.
 */

var RandomGen = Core.Class.subclass({
    classname : 'RandomGen',
    
    initialize : function()
    {
        this.table = undefined;
        this.index1 = undefined;
        this.index2 = undefined;
        this.size = 55;
    },
    
    useSeed : function(seed)
    {
        var i, ii, k, val, loop;
        
        if (this.table === undefined)
        {
            this.table = new Array();
        }
        else
        {
            this.table.length = 0;
        }
        
        this.table[54] = seed;
        this.index1 = 0;
        this.index2 = 31;
        
        k = 1;
        
        for (i = 0; i < this.size; i++)
        {
            ii = (21 * i) % this.size;
            this.table[ii] = k;
            k = (seed - k) >>> 0;
            seed = this.table[ii];
        }
        
        for (loop = 0; loop < 4; loop++)
        {
            for (i = 0; i < this.size; i++)
            {
                val = this.table[i] - this.table[(1 + i + 30) % this.size];
                this.table[i] = val >>> 0;
            }
        }
    },
    
    getRandom : function()
    {
        this.index1 = (this.index1 + 1) % this.size;
        this.index2 = (this.index2 + 1) % this.size;
        this.table[this.index1] = (this.table[this.index1] - this.table[this.index2]) >>> 0;
        return this.table[this.index1] / 0x100000000;
    }
});

//Random
var _randomizer = new RandomGen();

/**
 * Adds a random seed to the randomizer
 * @param {Number} x
 */
function srandom(/*Number*/x)
{
    _randomizer.useSeed(x);
};

/**
 * Returns a pseudo-random number matching the behavior of the C standard library
 * @returns {Number} A pseudo-random number
 */
function std_rand()
{
    return Math.floor(_randomizer.getRandom() * (Math.pow(2, 15) - 1));
};

/**
 * Returns a pseudo-random number matching the behavior of the C standard library
 * @returns {Number} A pseudo-random number
 */
function std_random()
{
    return Math.floor(_randomizer.getRandom() * (Math.pow(2, 31) - 1)); 
};

/**
 * Returns a random color
 * @returns {Core.Color} Randomly generated color
 */
function rand_color()
{
    return new Core.Color(_randomizer.getRandom(), _randomizer.getRandom(), _randomizer.getRandom());
}

function ccp(x, y)
{
    return new Core.Point(x, y);
}

function ccc3(red, green, blue)
{
    if (red === undefined || green === undefined || blue === undefined)
    {
        throw new Error("ccc3: Invalid input");
    }
    
    return new Core.Color(red/255, green/255, blue/255);
}

///////////////////////////////////////////////////////////
// Arrays
///////////////////////////////////////////////////////////
/**
 * Deletes an array
 * @param {Array} a - Array to delete
 */
function arr_delete(/*Array*/a)
{
    a.length = 0;
}

///////////////////////////////////////////////////////////
// Dictionaries
///////////////////////////////////////////////////////////
/**
 * Returns the size of a dictionary
 * @param {Object} d - Dictionary
 * @return {Number} Size of dictionary/associative array 
 */
function dict_size(/*Object*/d)
{
    // FIXME: This function is inefficient, use with care.
    var l = 0;
    for (var k in d)
    {
        l++;
    }
    
    return l;
}

/**
 * Deletes a dictionary
 * @param {Object} d - Dictionary
 */
function dict_delete(/*Object*/d)
{
    for (var k in d)
    {
        delete d[k];
    }
    
    d = null;
}

/**
 * Removes a key from a dictionary
 * @param {Object} d - Dictionary
 * @param {String} k - Key
 */
function dict_remove(/*Object*/d, /*String*/k)
{
    delete d[k];
}

///////////////////////////////////////////////////////////
// Object tracing
///////////////////////////////////////////////////////////
var AL_TRACE_ENABLED = true;

function al_alert(message, title)
{
    if (!title)
    {
        title = "Debug alert"
    }
    
    var dialog = new UI.AlertDialog();
    dialog.setTitle(title);
    dialog.setText(message);
    dialog.setChoices(["OK"]);
    dialog.setOnChoice(function()
    { 
        dialog.hide();
    }.bind(this));
    dialog.show();
}

/**
 * Creates a trace message
 * @param {String} message - Message
 */
function al_trace(/*String*/message)
{
    if (AL_TRACE_ENABLED)
    {
        console.log(message);
    }
}

/**
 * Traces the JSON representation of a JavaScript object
 * @param {Object} o - Object to represent
 * @param {String} message - Message
 */
function al_trace_object(/*Object*/o, /*String*/message)
{
    if (AL_TRACE_ENABLED)
    {
        al_trace(message + ". Object: " + JSON.stringify(o));
    }
}

/**
 * Returns the current stack trace 
 * @return {String} The current execution stack trace in a string object
 */
function al_get_stack()
{
    try
    {
        throw new Error(); 
    }
    catch (e)
    {
        if (e.stack)
        {
            return e.stack;
        }
        else
        {
            // iOS does not adds stack information to exceptions
            return "<Stack not available>";
        }
    }
}

var AL_ASSERT_THROW_ERRORS = false;

/** 
 * @param condition {Boolean} Assert condition
 * @param message {String} Message string
 */
function al_assert(condition, message) {
    if (!condition) {
        if (AL_ASSERT_THROW_ERRORS)
        {
            al_trace(message + ". Stack: " + al_get_stack());
        }
        else
        {
            throw new Error(message);
        }
    }
}

///////////////////////////////////////////////////////////
// Point/rectangle helpers
///////////////////////////////////////////////////////////
/**
 * @param {Core.Rect} rect - the rectangle to check with
 * @param {Core.Point} point - the point check
 * @return true if the point is inside the rectangle including the borders, false otherwise.
 */
function CGRectContainsPoint(/*Core.Rect*/rect,/*Core.Point*/point)
{
    return point.getX() >= rect.getMinX() && point.getX() <= rect.getMaxX() && point.getY() >= rect.getMinY() && point.getY() <= rect.getMaxY();
}

/**
 * @param {Core.Point} point1 - the first point to check
 * @param {Core.Point} point2 - the second point to check
 * @return true if the point are the same
 */
function CGPointEqualToPoint(/*Core.Point*/point1,/*Core.Point*/point2)
{
    return point1.getX() == point2.getX() && point1.getY() == point2.getY();
}
/**
 * Creates the bounding box of a Sprite using the first frame.
 * 
 * @param {GL2.Sprite} sprite -the sprite from where build the BoundingBox.
 * @return {Core.Rect} the rectangle of the bounding box.
 */
function createBB(/*GL2.Sprite*/sprite)
{
    var frame = sprite.getAnimation().getFrame(0);
    return createBBBase(sprite.getPosition(), frame.getSize(), frame.getAnchor(), sprite.getScale());
}

/**
 * Creates a bounding box.
 * 
 * @param {Core.Point} point - the base point.
 * @param {Core.Size} size - the size.
 * @param {Core.Point} anchor - the anchor.
 * @param {Core.Point} scale - the scale.
 * @return {Core.Rect} the rectangle of the bounding box.
 */
function createBBBase(/*Core.Point*/point, /*Core.Size*/size, /*Core.Point*/anchor,/*Core.Point*/scale)
{
    var _anchor = anchor || new Core.Point();
    var _scale = scale || new Core.Point(1, 1);
    
    var _size = new Core.Size(size.getWidth() * _scale.getX(), size.getHeight() * _scale.getY());
    var _point = new Core.Point(point.getX() - _size.getWidth() * _anchor.getX(), point.getY() - _size.getHeight() * _anchor.getY());
    
    if (_size.getWidth() < 0)
    {
        _point.setX(_point.getX() + _size.getWidth());
        _size.setWidth(-_size.getWidth());
    }
    if (_size.getHeight() < 0)
    {
        _point.setY(_point.getY() + _size.getHeight());
        _size.setHeight(-_size.getHeight());
    }
    return new Core.Rect(_point, _size);
}

/**
sprintf() for JavaScript 0.7-beta1
http://www.diveintojavascript.com/projects/javascript-sprintf

Copyright (c) Alexandru Marasteanu <alexaholic [at) gmail (dot] com>
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of sprintf() for JavaScript nor the
      names of its contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL Alexandru Marasteanu BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


Changelog:
2010.09.06 - 0.7-beta1
  - features: vsprintf, support for named placeholders
  - enhancements: format cache, reduced global namespace pollution

2010.05.22 - 0.6:
 - reverted to 0.4 and fixed the bug regarding the sign of the number 0
 Note:
 Thanks to Raphael Pigulla <raph (at] n3rd [dot) org> (http://www.n3rd.org/)
 who warned me about a bug in 0.5, I discovered that the last update was
 a regress. I appologize for that.

2010.05.09 - 0.5:
 - bug fix: 0 is now preceeded with a + sign
 - bug fix: the sign was not at the right position on padded results (Kamal Abdali)
 - switched from GPL to BSD license

2007.10.21 - 0.4:
 - unit test and patch (David Baird)

2007.09.17 - 0.3:
 - bug fix: no longer throws exception on empty paramenters (Hans Pufal)

2007.09.11 - 0.2:
 - feature: added argument swapping

2007.04.03 - 0.1:
 - initial release
**/

var sprintf = (function() {
    function get_type(variable) {
        return Object.prototype.toString.call(variable).slice(8, -1).toLowerCase();
    }
    function str_repeat(input, multiplier) {
        for (var output = []; multiplier > 0; output[--multiplier] = input) {/* do nothing */}
        return output.join('');
    }

    var str_format = function() {
        if (!str_format.cache.hasOwnProperty(arguments[0])) {
            str_format.cache[arguments[0]] = str_format.parse(arguments[0]);
        }
        return str_format.format.call(null, str_format.cache[arguments[0]], arguments);
    };

    str_format.format = function(parse_tree, argv) {
        var cursor = 1, tree_length = parse_tree.length, node_type = '', arg, output = [], i, k, match, pad, pad_character, pad_length;
        for (i = 0; i < tree_length; i++) {
            node_type = get_type(parse_tree[i]);
            if (node_type === 'string') {
                output.push(parse_tree[i]);
            }
            else if (node_type === 'array') {
                match = parse_tree[i]; // convenience purposes only
                if (match[2]) { // keyword argument
                    arg = argv[cursor];
                    for (k = 0; k < match[2].length; k++) {
                        if (!arg.hasOwnProperty(match[2][k])) {
                            throw new Error(sprintf('[sprintf] property "%s" does not exist', match[2][k]));
                        }
                        arg = arg[match[2][k]];
                    }
                }
                else if (match[1]) { // positional argument (explicit)
                    arg = argv[match[1]];
                }
                else { // positional argument (implicit)
                    arg = argv[cursor++];
                }

                if (/[^s]/.test(match[8]) && (get_type(arg) != 'number')) {
                    throw new Error(sprintf('[sprintf] expecting number but found %s', get_type(arg)));
                }
                switch (match[8]) {
                    case 'b': arg = arg.toString(2); break;
                    case 'c': arg = String.fromCharCode(arg); break;
                    case 'd': arg = parseInt(arg, 10); break;
                    case 'e': arg = match[7] ? arg.toExponential(match[7]) : arg.toExponential(); break;
                    case 'f': arg = match[7] ? parseFloat(arg).toFixed(match[7]) : parseFloat(arg); break;
                    case 'o': arg = arg.toString(8); break;
                    case 's': arg = ((arg = String(arg)) && match[7] ? arg.substring(0, match[7]) : arg); break;
                    case 'u': arg = Math.abs(arg); break;
                    case 'x': arg = arg.toString(16); break;
                    case 'X': arg = arg.toString(16).toUpperCase(); break;
                }
                arg = (/[def]/.test(match[8]) && match[3] && arg >= 0 ? '+'+ arg : arg);
                pad_character = match[4] ? match[4] == '0' ? '0' : match[4].charAt(1) : ' ';
                pad_length = match[6] - String(arg).length;
                pad = match[6] ? str_repeat(pad_character, pad_length) : '';
                output.push(match[5] ? arg + pad : pad + arg);
            }
        }
        return output.join('');
    };

    str_format.cache = {};

    str_format.parse = function(fmt) {
        
        // FIXME: monkey patch, replace %@ by %s
        var _fmt = fmt;
        _fmt = _fmt.replace(/%(\d?\$?)@/g, "%$1s");
        _fmt = _fmt.replace(/%(\d?\$?)i/g, "%$1d");
        
        var match = [], parse_tree = [], arg_names = 0;
        while (_fmt) {
            if ((match = /^[^\x25]+/.exec(_fmt)) !== null) {
                parse_tree.push(match[0]);
            }
            else if ((match = /^\x25{2}/.exec(_fmt)) !== null) {
                parse_tree.push('%');
            }
            else if ((match = /^\x25(?:([1-9]\d*)\$|\(([^\)]+)\))?(\+)?(0|'[^$])?(-)?(\d+)?(?:\.(\d+))?([b-fosuxX])/.exec(_fmt)) !== null) {
                if (match[2]) {
                    arg_names |= 1;
                    var field_list = [], replacement_field = match[2], field_match = [];
                    if ((field_match = /^([a-z_][a-z_\d]*)/i.exec(replacement_field)) !== null) {
                        field_list.push(field_match[1]);
                        while ((replacement_field = replacement_field.substring(field_match[0].length)) !== '') {
                            if ((field_match = /^\.([a-z_][a-z_\d]*)/i.exec(replacement_field)) !== null) {
                                field_list.push(field_match[1]);
                            }
                            else if ((field_match = /^\[(\d+)\]/.exec(replacement_field)) !== null) {
                                field_list.push(field_match[1]);
                            }
                            else {
                                throw new Error('[sprintf] huh?');
                            }
                        }
                    }
                    else {
                        throw new Error('[sprintf] huh?');
                    }
                    match[2] = field_list;
                }
                else {
                    arg_names |= 2;
                }
                if (arg_names === 3) {
                    throw new Error('[sprintf] mixing positional and named placeholders is not (yet) supported');
                }
                parse_tree.push(match);
            }
            else {
                throw new Error('[sprintf] huh?');
            }
            _fmt = _fmt.substring(match[0].length);
        }
        return parse_tree;
    };

    return str_format;
})();

var vsprintf = function(fmt, argv) {
    argv.unshift(fmt);
    return sprintf.apply(null, argv);
};


function numberAddCommas(nStr) 
{
    nStr = nStr+"";
    x = nStr.split('.');
    x1 = x[0];
    x2 = x.length > 1 ? '' : '';
    var rgx = /(\d+)(\d{3})/;
    while (rgx.test(x1)) {
        x1 = x1.replace(rgx, '$1' + ',' + '$2');
    }
    return x1 + x2;
};


/**
 * Project includes
 */
    // ngCore
    var Audio = require('NGCore/Client/Audio').Audio;
    var Bank = require('NGCore/Client/Bank').Bank;
    var Core = require('NGCore/Client/Core').Core;
    var Device = require('NGCore/Client/Device').Device;
    var GL2 = require('NGCore/Client/GL2').GL2;
    var Social = require('NGCore/Client/Social').Social;
    var Storage = require('NGCore/Client/Storage').Storage;
    var UI = require('NGCore/Client/UI').UI;
   
    // Utility classes
    var FPS = require('Code/Utils/FPS').FPS;
    var BaseClass = require('Code/Utils/BaseClass').BaseClass;
    var TouchTargetVisualizer = require('Code/Utils/TouchTargetVisualizer').TouchTargetVisualizer;
    var RateGameController = require('Code/Utils/RateGameController').RateGameController;
    
    // Library
    var Action = require('Code/Action').Action;
    var Prototypes = require('Code/Base/Prototypes').Prototypes;
    var NSUserDefaults = require('Code/Utils/NSUserDefaults').NSUserDefaults;
    var DataPreloader = require('Code/Utils/DataPreloader').DataPreloader;
    var SpriteFactoryCache = require('Code/Utils/SpriteFactoryCache').SpriteFactoryCache;
    var LabelConfigurer = require('Code/Utils/LabelConfigurer').LabelConfigurer;
    var ALLayerColor = require('Code/Utils/ALLayerColor').ALLayerColor;
    var AnimationCache = require('Code/Utils/AnimationCache').AnimationCache;
    var SoundBoard = require('Code/Utils/SoundBoard').SoundBoard;
    var PaymentController = require('Code/Utils/PaymentController').PaymentController;
    var ScoreManager = require('Code/Utils/ScoreManager').ScoreManager;
    
    // Game specific
    var TTSpriteFactory = require('Code/TTSpriteFactory').TTSpriteFactory;
    var TTProductInfo = require('Code/TTProductInfo').TTProductInfo;
    var TTList = require('Code/TTList').TTList;
    var TTHList = require('Code/TTHList').TTHList;
    var TTFloorTable = require('Code/TTFloorTable').TTFloorTable;
    var TTFloorInfo = require('Code/TTFloorInfo').TTFloorInfo;
    var TTFloor = require('Code/TTFloor').TTFloor;
    var LoadingScreen = require('Code/LoadingScreen').LoadingScreen;
    var TTAppDelegate = require('Code/TTAppDelegate').TTAppDelegate;
    var TTSyncKeyValue = require('Code/TTSyncKeyValue').TTSyncKeyValue;
    var TTGameData = require('Code/TTGameData').TTGameData;
    var TTScene = require('Code/TTScene').TTScene;
    var TTHud = require('Code/TTHud').TTHud;
    var TTDialogQueue = require('Code/TTDialogQueue').TTDialogQueue;
    var TTZoneLayer = require('Code/TTZoneLayer').TTZoneLayer;
    var TTowerLayer = require('Code/TTowerLayer').TTowerLayer;
    var TTFloorFocusLayer = require('Code/TTFloorFocusLayer').TTFloorFocusLayer;
    var TTBitizenInfo = require('Code/TTBitizenInfo').TTBitizenInfo;
    var TTBitizen = require('Code/TTBitizen').TTBitizen;
    var TTNewFloorLayer = require('Code/TTNewFloorLayer').TTNewFloorLayer;
    var TTStoryInfo = require('Code/TTStoryInfo').TTStoryInfo;
    var TTFloor = require('Code/TTFloor').TTFloor;
    var TTElevator = require('Code/TTElevator').TTElevator;
    var TTDialog = require('Code/TTDialog').TTDialog;
    var TTMenu = require('Code/TTMenuLayer').TTMenu;
    var TTCloud = require('Code/TTCloud').TTCloud; 
    var TTNote = require('Code/TTNote').TTNote;
    var TTBitBook = require('Code/TTBitBook').TTBitBook;
    var TTFinder = require('Code/TTFinder').TTFinder;
    
    // Menu Layers
    var TTStatsLayer = require('Code/TTStatsLayer').TTStatsLayer;
    var TTBankLayer = require('Code/TTBankLayer').TTBankLayer;
    var TTBitFocusLayer = require('Code/TTBitFocusLayer').TTBitFocusLayer;
    var TTBitBookListLayer = require('Code/TTBitBookListLayer').TTBitBookListLayer;
    var TTBitizenListLayer = require('Code/TTBitizenListLayer').TTBitizenListLayer;
    var TTElevatorShopLayer = require('Code/TTElevatorShopLayer').TTElevatorShopLayer;
    var TTFloorPaintLayer = require('Code/TTFloorPaintLayer').TTFloorPaintLayer;
    var TTBuxLayer = require('Code/TTBuxLayer').TTBuxLayer;
    var TTSettingsLayer = require('Code/TTSettingsLayer').TTSettingsLayer;
    var TTNewJobLayer = require('Code/TTNewJobLayer').TTNewJobLayer;
    var TTutorialLayer = require('Code/TTutorialLayer').TTutorialLayer;
    var TTFriendsListLayer = require('Code/TTFriendsListLayer').TTFriendsListLayer;
    var TTAchievementsListLayer = require('Code/TTAchievementsListLayer').TTAchievementsListLayer;
    
    var ALDebug = require('Code/ALDebug').ALDebug;
    
/**
 * Global variables
 */
    var loadingScreen = null;
    
function obtainGamerTag()
{
    var session = Social.US.Session.getCurrentSession(); 
    if (session)
    {
        // Android, iOS
        return Social.US.Session.getCurrentSession().user().gamertag;
    }
    else
    {
        // Flash
        return "DefaultUser";
    }
}

function obtainGamerID()
{
    var session = Social.US.Session.getCurrentSession(); 
    if (session)
    {
        // Android, iOS
        return Social.US.Session.getCurrentSession().user().recordID;
    }
    else
    {
        // Flash
        return "123";
    }
}


var gameLoaded = false;

function continueLoad()
{
    // Displays loading screen
    loadingScreen = new LoadingScreen();
    // Attempts to preload data
    DataPreloader.instantiate();
    DataPreloader.preloadData(function() { 
        // Attempts to load configuration keys
        NSUserDefaults.standardUserDefaults().preloadKnownKeys(function()
        {            
            TTSyncKeyValue.preloadKnownKeys(function() {
                TTAppDelegate.instantiate();
            });
        });
    });
    gameLoaded = true;
}

var LayoutListener = Core.MessageListener.subclass({
    initialize : function()
    {
        console.log("LayoutListener.initialize(TT)");
        Device.LayoutEmitter.addListener(this, this.onUpdate, -1);
    },
    
    onUpdate : function(layout) {
        console.log("LayoutListener.onUpdate(PF): %s, %d, �UI.Window._height: %d, �UI.Window._width: %d", JSON.stringify(layout), Device.OrientationEmitter.getInterfaceOrientation(), UI.Window._height, UI.Window._width);

        //Workaround for GalaxyTab7.7, Android 3.2
        UI.Window._height = layout.height;
        UI.Window._width = layout.width;
        //End workaround.
        
        //requires to ask for width > height to avoid false call on Android where the orientation is LandscafpeLeft but the width is till the same as in portrait
        if (!gameLoaded && UI.Window._height > UI.Window._width) {
            continueLoad();
        }
    }
});

/**
 * Application entry point
 */
function main()
{       
	UI.Window.instantiate();
	
    // Sets ups FPS counter and the update emitter tick rate
    //FPS.instantiate();
	// Android devices doesnt set right the desired frame rate (if because that we put 36 instead of 30) 
    Core.UpdateEmitter.setTickRate(1 / 36);
    
    //very important to be the first line of code
    if (Device.OrientationEmitter.getInterfaceOrientation() != Device.OrientationEmitter.Orientation.Portrait || Core.Capabilities.getPlatformOS() == "Android") {
        al_trace("TinyTower.main: setting interface orientation to Portrait");
        new LayoutListener();
        Device.OrientationEmitter.setInterfaceOrientation(Device.OrientationEmitter.Orientation.Portrait);
    } else {
        al_trace("TinyTower.main: interface already on Portrait orientation");
        continueLoad();
    }
}
